import*as i18n from"../../core/i18n/i18n.js";import*as Buttons from"../../ui/components/buttons/buttons.js";import*as SDK from"../../core/sdk/sdk.js";import*as LitHtml from"../../ui/lit-html/lit-html.js";import*as ReportView from"../../ui/components/report_view/report_view.js";import*as UI from"../../ui/legacy/legacy.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import{NotRestoredReasonDescription}from"./BackForwardCacheStrings.js";import backForwardCacheViewStyles from"./backForwardCacheView.css.js";const UIStrings={mainFrame:"Main Frame",backForwardCacheTitle:"Back/forward cache",unavailable:"unavailable",url:"URL",bfcacheStatus:"Back/forward cache Status",unknown:"unknown",normalNavigation:"Normal navigation (Not restored from back/forward cache)",restoredFromBFCache:"Restored from back/forward cache",pageSupportNeeded:"Actionable",pageSupportNeededExplanation:"These reasons are actionable i.e. they can be cleaned up to make the page eligible for back/forward cache.",circumstantial:"Not Actionable",circumstantialExplanation:"These reasons are not actionable i.e. caching was prevented by something outside of the direct control of the page.",supportPending:"Pending Support",runTest:"Run Test",supportPendingExplanation:"Chrome support for these reasons is pending i.e. they will not prevent the page from being eligible for back/forward cache in a future version of Chrome."},str_=i18n.i18n.registerUIStrings("panels/application/BackForwardCacheView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class BackForwardCacheView extends UI.ThrottledWidget.ThrottledWidget{constructor(){super(!0,1e3),this.getMainResourceTreeModel()?.addEventListener(SDK.ResourceTreeModel.Events.MainFrameNavigated,this.onBackForwardCacheUpdate,this),this.getMainResourceTreeModel()?.addEventListener(SDK.ResourceTreeModel.Events.BackForwardCacheDetailsUpdated,this.onBackForwardCacheUpdate,this),this.update()}wasShown(){super.wasShown(),this.registerCSSFiles([backForwardCacheViewStyles])}onBackForwardCacheUpdate(){this.update()}async doUpdate(){const e={reportTitle:i18nString(UIStrings.backForwardCacheTitle)},t=LitHtml.html`
      <${ReportView.ReportView.Report.litTagName} .data=${e}>
      ${this.renderMainFrameInformation(this.getMainFrame())}
      </${ReportView.ReportView.Report.litTagName}>
    `;LitHtml.render(t,this.contentElement,{host:this})}getMainResourceTreeModel(){return SDK.TargetManager.TargetManager.instance().mainTarget()?.model(SDK.ResourceTreeModel.ResourceTreeModel)||null}getMainFrame(){return this.getMainResourceTreeModel()?.mainFrame||null}async goBackOneHistoryEntry(){SDK.TargetManager.TargetManager.instance().removeModelListener(SDK.ResourceTreeModel.ResourceTreeModel,SDK.ResourceTreeModel.Events.FrameNavigated,this.goBackOneHistoryEntry,this);const e=SDK.TargetManager.TargetManager.instance().mainTarget();if(!e)return;const t=e.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!t)return;const r=await t.navigationHistory();r&&t.navigateToHistoryEntry(r.entries[r.currentIndex-1])}async navigateAwayAndBack(){const e=SDK.TargetManager.TargetManager.instance().mainTarget();if(!e)return;const t=e.model(SDK.ResourceTreeModel.ResourceTreeModel);t&&(SDK.TargetManager.TargetManager.instance().addModelListener(SDK.ResourceTreeModel.ResourceTreeModel,SDK.ResourceTreeModel.Events.FrameNavigated,this.goBackOneHistoryEntry,this),t.navigate("chrome://terms"))}renderMainFrameInformation(e){return e?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${Buttons.Button.Button.litTagName}
            .variant=${"primary"}
            @click=${this.navigateAwayAndBack}>
            ${i18nString(UIStrings.runTest)}
      </${Buttons.Button.Button.litTagName}>
      </${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.url)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>${e.url}</${ReportView.ReportView.ReportValue.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.bfcacheStatus)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>${this.renderBackForwardCacheStatus(e.backForwardCacheDetails.restoredFromCache)}</${ReportView.ReportView.ReportValue.litTagName}>
       ${this.maybeRenderExplanations(e.backForwardCacheDetails.explanations)}
    `:LitHtml.html`<${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.mainFrame)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
      ${i18nString(UIStrings.unavailable)}
      </${ReportView.ReportView.ReportValue.litTagName}>`}renderBackForwardCacheStatus(e){switch(e){case!0:return i18nString(UIStrings.restoredFromBFCache);case!1:return i18nString(UIStrings.normalNavigation)}return i18nString(UIStrings.unknown)}maybeRenderExplanations(e){if(0===e.length)return LitHtml.nothing;const t=e.filter((e=>"PageSupportNeeded"===e.type)),r=e.filter((e=>"SupportPending"===e.type)),a=e.filter((e=>"Circumstantial"===e.type));return LitHtml.html`
      ${this.renderExplanations(i18nString(UIStrings.pageSupportNeeded),i18nString(UIStrings.pageSupportNeededExplanation),t)}
      ${this.renderExplanations(i18nString(UIStrings.supportPending),i18nString(UIStrings.supportPendingExplanation),r)}
      ${this.renderExplanations(i18nString(UIStrings.circumstantial),i18nString(UIStrings.circumstantialExplanation),a)}
    `}renderExplanations(e,t,r){return LitHtml.html`
      ${r.length>0?LitHtml.html`
        <${ReportView.ReportView.ReportKey.litTagName}>
          ${e}
          <${IconButton.Icon.Icon.litTagName} class="inline-icon" .data=${{iconName:"help_outline",color:"var(--color-text-secondary)",width:"16px",height:"16px"}} title=${t}></${IconButton.Icon.Icon.litTagName}>
        </${ReportView.ReportView.ReportKey.litTagName}>
        <${ReportView.ReportView.ReportValue.litTagName}>
          <ul class='not-restored-reason-list'>${r.map((e=>this.renderReason(e)))}</ul>
        </${ReportView.ReportView.ReportValue.litTagName}>
      `:LitHtml.nothing}
    `}renderReason(e){return LitHtml.html`
      <li>
      <${IconButton.Icon.Icon.litTagName} class="inline-icon" .data=${{iconName:"circled_exclamation_icon",color:"orange",width:"16px",height:"16px"}}></${IconButton.Icon.Icon.litTagName}>
        ${e.reason} : ${e.reason in NotRestoredReasonDescription?LitHtml.html`${NotRestoredReasonDescription[e.reason].name()}`:LitHtml.nothing} </li>
    `}}