import{StackTrace}from"./StackTrace.js";import{PermissionsPolicySection,renderIconLink}from"./PermissionsPolicySection.js";import*as Bindings from"../../../models/bindings/bindings.js";import*as Common from"../../../core/common/common.js";import*as i18n from"../../../core/i18n/i18n.js";import*as NetworkForward from"../../../panels/network/forward/forward.js";import*as Root from"../../../core/root/root.js";import*as SDK from"../../../core/sdk/sdk.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import*as ExpandableList from"../../../ui/components/expandable_list/expandable_list.js";import*as ReportView from"../../../ui/components/report_view/report_view.js";import*as IconButton from"../../../ui/components/icon_button/icon_button.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as UI from"../../../ui/legacy/legacy.js";import*as Workspace from"../../../models/workspace/workspace.js";import*as Components from"../../../ui/legacy/components/utils/utils.js";import{OriginTrialTreeView}from"./OriginTrialTreeView.js";import*as Coordinator from"../../../ui/components/render_coordinator/render_coordinator.js";import frameDetailsReportViewStyles from"./frameDetailsReportView.css.js";const UIStrings={additionalInformation:"Additional Information",thisAdditionalDebugging:"This additional (debugging) information is shown because the 'Protocol Monitor' experiment is enabled.",frameId:"Frame ID",document:"Document",clickToRevealInSourcesPanel:"Click to reveal in Sources panel",clickToRevealInNetworkPanel:"Click to reveal in Network panel",unreachableUrl:"Unreachable URL",clickToRevealInNetworkPanelMight:"Click to reveal in Network panel (might require page reload)",ownerElement:"Owner Element",clickToRevealInElementsPanel:"Click to reveal in Elements panel",adStatus:"Ad Status",rootDescription:"This frame has been identified as the root frame of an ad",root:"root",childDescription:"This frame has been identified as a child frame of an ad",child:"child",securityIsolation:"Security & Isolation",secureContext:"Secure Context",yes:"Yes",no:"No",crossoriginIsolated:"`Cross-Origin` Isolated",localhostIsAlwaysASecureContext:"`Localhost` is always a secure context",aFrameAncestorIsAnInsecure:"A frame ancestor is an insecure context",theFramesSchemeIsInsecure:"The frame's scheme is insecure",reportingTo:"reporting to",apiAvailability:"API availability",availabilityOfCertainApisDepends:"Availability of certain APIs depends on the document being `cross-origin` isolated.",availableTransferable:"available, transferable",availableNotTransferable:"available, not transferable",unavailable:"unavailable",sharedarraybufferConstructorIs:"`SharedArrayBuffer` constructor is available and `SABs` can be transferred via `postMessage`",sharedarraybufferConstructorIsAvailable:"`SharedArrayBuffer` constructor is available but `SABs` cannot be transferred via `postMessage`",willRequireCrossoriginIsolated:"⚠️ will require `cross-origin` isolated context in the future",requiresCrossoriginIsolated:"requires `cross-origin` isolated context",transferRequiresCrossoriginIsolatedPermission:"`SharedArrayBuffer` transfer requires enabling the permission policy:",available:"available",thePerformanceAPI:"The `performance.measureUserAgentSpecificMemory()` API is available",thePerformancemeasureuseragentspecificmemory:"The `performance.measureUserAgentSpecificMemory()` API is not available",measureMemory:"Measure Memory",learnMore:"Learn more",creationStackTrace:"Frame Creation `Stack Trace`",creationStackTraceExplanation:"This frame was created programmatically. The `stack trace` shows where this happened.",parentIsAdExplanation:"This frame is considered an ad frame because its parent frame is an ad frame.",matchedBlockingRuleExplanation:"This frame is considered an ad frame because its current (or previous) main document is an ad resource.",createdByAdScriptExplanation:"There was an ad script in the `(async) stack` when this frame was created. Examining the creation `stack trace` of this frame might provide more insight."},str_=i18n.i18n.registerUIStrings("panels/application/components/FrameDetailsView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FrameDetailsView extends UI.ThrottledWidget.ThrottledWidget{reportView=new FrameDetailsReportView;frame;constructor(e){super(),this.frame=e,this.contentElement.classList.add("overflow-auto"),this.contentElement.appendChild(this.reportView),this.update()}async doUpdate(){this.reportView.data={frame:this.frame}}}const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();export class FrameDetailsReportView extends HTMLElement{static litTagName=LitHtml.literal`devtools-resources-frame-details-view`;shadow=this.attachShadow({mode:"open"});frame;protocolMonitorExperimentEnabled=!1;permissionsPolicies=null;permissionsPolicySectionData={policies:[],showDetails:!1};originTrialTreeView=new OriginTrialTreeView;connectedCallback(){this.protocolMonitorExperimentEnabled=Root.Runtime.experiments.isEnabled("protocolMonitor"),this.shadow.adoptedStyleSheets=[frameDetailsReportViewStyles]}set data(e){this.frame=e.frame,!this.permissionsPolicies&&this.frame&&(this.permissionsPolicies=this.frame.getPermissionsPolicyState()),this.render()}async render(){await coordinator.write("FrameDetailsView render",(()=>{this.frame&&LitHtml.render(LitHtml.html`
        <${ReportView.ReportView.Report.litTagName} .data=${{reportTitle:this.frame.displayName()}}>
          ${this.renderDocumentSection()}
          ${this.renderIsolationSection()}
          ${this.renderApiAvailabilitySection()}
          ${this.renderOriginTrial()}
          ${LitHtml.Directives.until(this.permissionsPolicies?.then((e=>(this.permissionsPolicySectionData.policies=e||[],LitHtml.html`
              <${PermissionsPolicySection.litTagName}
                .data=${this.permissionsPolicySectionData}
              >
              </${PermissionsPolicySection.litTagName}>
            `))),LitHtml.nothing)}
          ${this.protocolMonitorExperimentEnabled?this.renderAdditionalInfoSection():LitHtml.nothing}
        </${ReportView.ReportView.Report.litTagName}>
      `,this.shadow,{host:this})}))}renderOriginTrial(){if(!this.frame)return LitHtml.nothing;this.originTrialTreeView.classList.add("span-cols");const e=this.frame,t=()=>{e.getOriginTrials().then((e=>{this.originTrialTreeView.data={trials:e}}))};return t(),LitHtml.html`
    <${ReportView.ReportView.ReportSectionHeader.litTagName}>
      ${i18n.i18n.lockedString("Origin Trials")}
      <${IconButton.IconButton.IconButton.litTagName} class="inline-button" .data="${{clickHandler:t,groups:[{iconName:"refresh_12x12_icon",text:"Refresh"}]}}">
      </${IconButton.IconButton.IconButton.litTagName}>
    </${ReportView.ReportView.ReportSectionHeader.litTagName}>
    ${this.originTrialTreeView}
    <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `}renderDocumentSection(){return this.frame?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>${i18nString(UIStrings.document)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18n.i18n.lockedString("URL")}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        <div class="inline-items">
          ${this.maybeRenderSourcesLinkForURL()}
          ${this.maybeRenderNetworkLinkForURL()}
          <div class="text-ellipsis" title=${this.frame.url}>${this.frame.url}</div>
        </div>
      </${ReportView.ReportView.ReportValue.litTagName}>
      ${this.maybeRenderUnreachableURL()}
      ${this.maybeRenderOrigin()}
      ${LitHtml.Directives.until(this.renderOwnerElement(),LitHtml.nothing)}
      ${this.maybeRenderCreationStacktrace()}
      ${this.maybeRenderAdStatus()}
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `:LitHtml.nothing}maybeRenderSourcesLinkForURL(){if(!this.frame||this.frame.unreachableUrl())return LitHtml.nothing;const e=this.uiSourceCodeForFrame(this.frame);return renderIconLink("sources_panel_icon",i18nString(UIStrings.clickToRevealInSourcesPanel),(()=>Common.Revealer.reveal(e)))}maybeRenderNetworkLinkForURL(){if(this.frame){const e=this.frame.resourceForURL(this.frame.url);if(e&&e.request){const t=e.request;return renderIconLink("network_panel_icon",i18nString(UIStrings.clickToRevealInNetworkPanel),(()=>{const e=NetworkForward.UIRequestLocation.UIRequestLocation.tab(t,NetworkForward.UIRequestLocation.UIRequestTabs.Headers);return Common.Revealer.reveal(e)}))}}return LitHtml.nothing}uiSourceCodeForFrame(e){for(const t of Workspace.Workspace.WorkspaceImpl.instance().projects()){const i=Bindings.NetworkProject.NetworkProject.getTargetForProject(t);if(i&&i===e.resourceTreeModel().target()){const i=t.uiSourceCodeForURL(e.url);if(i)return i}}return null}maybeRenderUnreachableURL(){return this.frame&&this.frame.unreachableUrl()?LitHtml.html`
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.unreachableUrl)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        <div class="inline-items">
          ${this.renderNetworkLinkForUnreachableURL()}
          <div class="text-ellipsis" title=${this.frame.unreachableUrl()}>${this.frame.unreachableUrl()}</div>
        </div>
      </${ReportView.ReportView.ReportValue.litTagName}>
    `:LitHtml.nothing}renderNetworkLinkForUnreachableURL(){if(this.frame){const e=Common.ParsedURL.ParsedURL.fromString(this.frame.unreachableUrl());if(e)return renderIconLink("network_panel_icon",i18nString(UIStrings.clickToRevealInNetworkPanelMight),(()=>{Common.Revealer.reveal(NetworkForward.UIFilter.UIRequestFilter.filters([{filterType:NetworkForward.UIFilter.FilterType.Domain,filterValue:e.domain()},{filterType:null,filterValue:e.path}]))}))}return LitHtml.nothing}maybeRenderOrigin(){return this.frame&&this.frame.securityOrigin&&"://"!==this.frame.securityOrigin?LitHtml.html`
        <${ReportView.ReportView.ReportKey.litTagName}>${i18n.i18n.lockedString("Origin")}</${ReportView.ReportView.ReportKey.litTagName}>
        <${ReportView.ReportView.ReportValue.litTagName}>
          <div class="text-ellipsis" title=${this.frame.securityOrigin}>${this.frame.securityOrigin}</div>
        </${ReportView.ReportView.ReportValue.litTagName}>
      `:LitHtml.nothing}async renderOwnerElement(){if(this.frame){const e=await this.frame.getOwnerDOMNodeOrDocument();if(e)return LitHtml.html`
            <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.ownerElement)}</${ReportView.ReportView.ReportKey.litTagName}>
          <${ReportView.ReportView.ReportValue.litTagName} class="without-min-width">
              <button class="link" role="link" tabindex=0 title=${i18nString(UIStrings.clickToRevealInElementsPanel)}
              @mouseenter=${()=>this.frame?.highlight()}
              @mouseleave=${()=>SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()}
              @click=${()=>Common.Revealer.reveal(e)}
            >
              <${IconButton.Icon.Icon.litTagName} class="button-icon-with-text" .data=${{iconName:"elements_panel_icon",color:"var(--color-primary)",width:"16px",height:"16px"}}></${IconButton.Icon.Icon.litTagName}>
              &lt;${e.nodeName().toLocaleLowerCase()}&gt;
            </button>
          </${ReportView.ReportView.ReportValue.litTagName}>
        `}return LitHtml.nothing}maybeRenderCreationStacktrace(){const e=this.frame?.getCreationStackTraceData();return e&&e.creationStackTrace?LitHtml.html`
        <${ReportView.ReportView.ReportKey.litTagName} title=${i18nString(UIStrings.creationStackTraceExplanation)}>${i18nString(UIStrings.creationStackTrace)}</${ReportView.ReportView.ReportKey.litTagName}>
        <${ReportView.ReportView.ReportValue.litTagName}>
          <${StackTrace.litTagName} .data=${{frame:this.frame,buildStackTraceRows:Components.JSPresentationUtils.buildStackTraceRows}}>
          </${StackTrace.litTagName}>
        </${ReportView.ReportView.ReportValue.litTagName}>
      `:LitHtml.nothing}getAdFrameTypeStrings(e){switch(e){case"child":return{value:i18nString(UIStrings.child),description:i18nString(UIStrings.childDescription)};case"root":return{value:i18nString(UIStrings.root),description:i18nString(UIStrings.rootDescription)}}}getAdFrameExplanationString(e){switch(e){case"CreatedByAdScript":return i18nString(UIStrings.createdByAdScriptExplanation);case"MatchedBlockingRule":return i18nString(UIStrings.matchedBlockingRuleExplanation);case"ParentIsAd":return i18nString(UIStrings.parentIsAdExplanation)}}maybeRenderAdStatus(){if(!this.frame)return LitHtml.nothing;const e=this.frame.adFrameType();if("none"===e)return LitHtml.nothing;const t=this.getAdFrameTypeStrings(e),i=[LitHtml.html`<div title="${t.description}">${t.value}</div>`];for(const e of this.frame.adFrameStatus()?.explanations||[])i.push(LitHtml.html`<div>${this.getAdFrameExplanationString(e)}</div>`);return LitHtml.html`
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.adStatus)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
         <${ExpandableList.ExpandableList.ExpandableList.litTagName} .data=${{rows:i}}></${ExpandableList.ExpandableList.ExpandableList.litTagName}></${ReportView.ReportView.ReportValue.litTagName}>
      `}renderIsolationSection(){return this.frame?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>${i18nString(UIStrings.securityIsolation)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.secureContext)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        ${this.frame.isSecureContext()?i18nString(UIStrings.yes):i18nString(UIStrings.no)}\xA0${this.maybeRenderSecureContextExplanation()}
      </${ReportView.ReportView.ReportValue.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.crossoriginIsolated)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        ${this.frame.isCrossOriginIsolated()?i18nString(UIStrings.yes):i18nString(UIStrings.no)}
      </${ReportView.ReportView.ReportValue.litTagName}>
      ${LitHtml.Directives.until(this.maybeRenderCoopCoepStatus(),LitHtml.nothing)}
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `:LitHtml.nothing}maybeRenderSecureContextExplanation(){const e=this.getSecureContextExplanation();return e?LitHtml.html`<span class="inline-comment">${e}</span>`:LitHtml.nothing}getSecureContextExplanation(){switch(this.frame?.getSecureContextType()){case"Secure":return null;case"SecureLocalhost":return i18nString(UIStrings.localhostIsAlwaysASecureContext);case"InsecureAncestor":return i18nString(UIStrings.aFrameAncestorIsAnInsecure);case"InsecureScheme":return i18nString(UIStrings.theFramesSchemeIsInsecure)}return null}async maybeRenderCoopCoepStatus(){if(this.frame){const e=this.frame.resourceTreeModel().target().model(SDK.NetworkManager.NetworkManager),t=e&&await e.getSecurityIsolationStatus(this.frame.id);if(t)return LitHtml.html`
          ${this.maybeRenderCrossOriginStatus(t.coep,i18n.i18n.lockedString("Cross-Origin Embedder Policy (COEP)"),"None")}
          ${this.maybeRenderCrossOriginStatus(t.coop,i18n.i18n.lockedString("Cross-Origin Opener Policy (COOP)"),"UnsafeNone")}
        `}return LitHtml.nothing}maybeRenderCrossOriginStatus(e,t,i){if(!e)return LitHtml.nothing;const r=e.value!==i,a=!r&&e.reportOnlyValue!==i,o=r?e.reportingEndpoint:e.reportOnlyReportingEndpoint;return LitHtml.html`
      <${ReportView.ReportView.ReportKey.litTagName}>${t}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        ${r?e.value:e.reportOnlyValue}
        ${a?LitHtml.html`<span class="inline-comment">report-only</span>`:LitHtml.nothing}
        ${o?LitHtml.html`<span class="inline-name">${i18nString(UIStrings.reportingTo)}</span>${o}`:LitHtml.nothing}
      </${ReportView.ReportView.ReportValue.litTagName}>
    `}renderApiAvailabilitySection(){return this.frame?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>${i18nString(UIStrings.apiAvailability)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <div class="span-cols">
        ${i18nString(UIStrings.availabilityOfCertainApisDepends)}
        <x-link href="https://web.dev/why-coop-coep/" class="link">${i18nString(UIStrings.learnMore)}</x-link>
      </div>
      ${this.renderSharedArrayBufferAvailability()}
      ${this.renderMeasureMemoryAvailability()}
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `:LitHtml.nothing}renderSharedArrayBufferAvailability(){if(this.frame){const e=this.frame.getGatedAPIFeatures();if(e){const t=e.includes("SharedArrayBuffers"),i=t&&e.includes("SharedArrayBuffersTransferAllowed"),r=i18nString(i?UIStrings.availableTransferable:t?UIStrings.availableNotTransferable:UIStrings.unavailable),a=i?i18nString(UIStrings.sharedarraybufferConstructorIs):t?i18nString(UIStrings.sharedarraybufferConstructorIsAvailable):"";function o(e){switch(e.getCrossOriginIsolatedContextType()){case"Isolated":return LitHtml.nothing;case"NotIsolated":return t?LitHtml.html`<span class="inline-comment">${i18nString(UIStrings.willRequireCrossoriginIsolated)}</span>`:LitHtml.html`<span class="inline-comment">${i18nString(UIStrings.requiresCrossoriginIsolated)}</span>`;case"NotIsolatedFeatureDisabled":if(!i)return LitHtml.html`<span class="inline-comment">${i18nString(UIStrings.transferRequiresCrossoriginIsolatedPermission)} <code>cross-origin-isolated</code></span>`}return LitHtml.nothing}return LitHtml.html`
          <${ReportView.ReportView.ReportKey.litTagName}>SharedArrayBuffers</${ReportView.ReportView.ReportKey.litTagName}>
          <${ReportView.ReportView.ReportValue.litTagName} title=${a}>
            ${r}\xA0${o(this.frame)}
          </${ReportView.ReportView.ReportValue.litTagName}>
        `}}return LitHtml.nothing}renderMeasureMemoryAvailability(){if(this.frame){const e=this.frame.isCrossOriginIsolated(),t=i18nString(e?UIStrings.available:UIStrings.unavailable),i=i18nString(e?UIStrings.thePerformanceAPI:UIStrings.thePerformancemeasureuseragentspecificmemory);return LitHtml.html`
        <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.measureMemory)}</${ReportView.ReportView.ReportKey.litTagName}>
        <${ReportView.ReportView.ReportValue.litTagName}>
          <span title=${i}>${t}</span>\xA0<x-link class="link" href="https://web.dev/monitor-total-page-memory-usage/">${i18nString(UIStrings.learnMore)}</x-link>
        </${ReportView.ReportView.ReportValue.litTagName}>
      `}return LitHtml.nothing}renderAdditionalInfoSection(){return this.frame?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}
        title=${i18nString(UIStrings.thisAdditionalDebugging)}
      >${i18nString(UIStrings.additionalInformation)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.frameId)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        <div class="text-ellipsis" title=${this.frame.id}>${this.frame.id}</div>
      </${ReportView.ReportView.ReportValue.litTagName}>
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `:LitHtml.nothing}}ComponentHelpers.CustomElements.defineComponent("devtools-resources-frame-details-view",FrameDetailsReportView);