import*as i18n from"../../../core/i18n/i18n.js";import*as Adorners from"../../../ui/components/adorners/adorners.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as TreeOutline from"../../../ui/components/tree_outline/tree_outline.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import badgeStyles from"./badge.css.js";import originTrialTokenRowsStyles from"./originTrialTokenRows.css.js";import originTrialTreeViewStyles from"./originTrialTreeView.css.js";const UIStrings={origin:"Origin",trialName:"Trial Name",expiryTime:"Expiry Time",usageRestriction:"Usage Restriction",isThirdParty:"Third Party",matchSubDomains:"Subdomain Matching",rawTokenText:"Raw Token",status:"Token Status",token:"Token",tokens:"{PH1} tokens"},str_=i18n.i18n.registerUIStrings("panels/application/components/OriginTrialTreeView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class Badge extends HTMLElement{static litTagName=LitHtml.literal`devtools-resources-origin-trial-tree-view-badge`;shadow=this.attachShadow({mode:"open"});adorner=new Adorners.Adorner.Adorner;set data(e){this.render(e)}connectedCallback(){this.shadow.adoptedStyleSheets=[badgeStyles]}render(e){const t=document.createElement("span");t.textContent=e.badgeContent,this.adorner.data={name:"badge",content:t},this.adorner.classList.add(`badge-${e.style}`),LitHtml.render(LitHtml.html`
      ${this.adorner}
    `,this.shadow,{host:this})}}function constructOriginTrialTree(e){return{treeNodeData:e,id:"OriginTrialTreeNode#"+e.trialName,children:async()=>e.tokensWithStatus.length>1?e.tokensWithStatus.map(constructTokenNode):constructTokenDetailsNodes(e.tokensWithStatus[0]),renderer:e=>{const t=e.treeNodeData,i=LitHtml.html`
        <${Badge.litTagName} .data=${{badgeContent:i18nString(UIStrings.tokens,{PH1:t.tokensWithStatus.length}),style:"secondary"}}></${Badge.litTagName}>
      `;return LitHtml.html`
        ${t.trialName}
        <${Badge.litTagName} .data=${{badgeContent:t.status,style:"Enabled"===t.status?"success":"error"}}></${Badge.litTagName}>
        ${t.tokensWithStatus.length>1?i:LitHtml.nothing}
      `}}}function constructTokenNode(e){return{treeNodeData:e.status,id:"TokenNode#"+e.rawTokenText,children:async()=>constructTokenDetailsNodes(e),renderer:(e,t)=>{const i=e.treeNodeData,n=LitHtml.html`
        <${Badge.litTagName} .data=${{badgeContent:i,style:"Success"===i?"success":"error"}}></${Badge.litTagName}>
      `;return LitHtml.html`${i18nString(UIStrings.token)} ${t.isExpanded?LitHtml.nothing:n}`}}}function renderTokenDetails(e){return LitHtml.html`
    <${OriginTrialTokenRows.litTagName} .data=${{node:e}}>
    </${OriginTrialTokenRows.litTagName}>
    `}function constructTokenDetailsNodes(e){return[{treeNodeData:e,id:"TokenDetailsNode#"+e.rawTokenText,renderer:renderTokenDetails},constructRawTokenTextNode(e.rawTokenText)]}function constructRawTokenTextNode(e){return{treeNodeData:i18nString(UIStrings.rawTokenText),id:"TokenRawTextContainerNode#"+e,children:async()=>[{treeNodeData:e,id:"TokenRawTextNode#"+e,renderer:e=>{const t=e.treeNodeData;return LitHtml.html`
        <div style="overflow-wrap: break-word;">
          ${t}
        </div>
        `}}]}}function defaultRenderer(e){return LitHtml.html`${String(e.treeNodeData)}`}ComponentHelpers.CustomElements.defineComponent("devtools-resources-origin-trial-tree-view-badge",Badge);export class OriginTrialTokenRows extends HTMLElement{static litTagName=LitHtml.literal`devtools-resources-origin-trial-token-rows`;shadow=this.attachShadow({mode:"open"});tokenWithStatus=null;parsedTokenDetails=[];dateFormatter=new Intl.DateTimeFormat(i18n.DevToolsLocale.DevToolsLocale.instance().locale,{dateStyle:"long",timeStyle:"long"});set data(e){this.tokenWithStatus=e.node.treeNodeData,this.setTokenFields()}connectedCallback(){this.shadow.adoptedStyleSheets=[originTrialTokenRowsStyles],this.render()}renderTokenField=(e,t)=>LitHtml.html`
        <div class="${LitHtml.Directives.ifDefined(t?"error-text":void 0)}">
          ${e}
        </div>`;setTokenFields(){this.tokenWithStatus?.parsedToken&&(this.parsedTokenDetails=[{name:i18nString(UIStrings.origin),value:this.renderTokenField(this.tokenWithStatus.parsedToken.origin,"WrongOrigin"===this.tokenWithStatus.status)},{name:i18nString(UIStrings.expiryTime),value:this.renderTokenField(this.dateFormatter.format(1e3*this.tokenWithStatus.parsedToken.expiryTime),"Expired"===this.tokenWithStatus.status)},{name:i18nString(UIStrings.usageRestriction),value:this.renderTokenField(this.tokenWithStatus.parsedToken.usageRestriction)},{name:i18nString(UIStrings.isThirdParty),value:this.renderTokenField(this.tokenWithStatus.parsedToken.isThirdParty.toString())},{name:i18nString(UIStrings.matchSubDomains),value:this.renderTokenField(this.tokenWithStatus.parsedToken.matchSubDomains.toString())}],"UnknownTrial"===this.tokenWithStatus.status&&(this.parsedTokenDetails=[{name:i18nString(UIStrings.trialName),value:this.renderTokenField(this.tokenWithStatus.parsedToken.trialName)},...this.parsedTokenDetails]))}render(){if(!this.tokenWithStatus)return;const e=[{name:i18nString(UIStrings.status),value:LitHtml.html`
          <${Badge.litTagName} .data=${{badgeContent:this.tokenWithStatus.status,style:"Success"===this.tokenWithStatus.status?"success":"error"}}></${Badge.litTagName}>`},...this.parsedTokenDetails].map((e=>LitHtml.html`
          <div class="key">${e.name}</div>
          <div class="value">${e.value}</div>
          `));LitHtml.render(LitHtml.html`
      <div class="content">
        ${e}
      </div>
    `,this.shadow,{host:this})}}ComponentHelpers.CustomElements.defineComponent("devtools-resources-origin-trial-token-rows",OriginTrialTokenRows);export class OriginTrialTreeView extends HTMLElement{static litTagName=LitHtml.literal`devtools-resources-origin-trial-tree-view`;shadow=this.attachShadow({mode:"open"});set data(e){this.render(e.trials)}connectedCallback(){this.shadow.adoptedStyleSheets=[originTrialTreeViewStyles]}render(e){e.length&&LitHtml.render(LitHtml.html`
      <${TreeOutline.TreeOutline.TreeOutline.litTagName} .data="${{tree:e.map(constructOriginTrialTree),defaultRenderer:defaultRenderer}}">
      </${TreeOutline.TreeOutline.TreeOutline.litTagName}>
    `,this.shadow,{host:this})}}ComponentHelpers.CustomElements.defineComponent("devtools-resources-origin-trial-tree-view",OriginTrialTreeView);