import*as i18n from"../../../core/i18n/i18n.js";import*as DataGrid from"../../../ui/components/data_grid/data_grid.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as IconButton from"../../../ui/components/icon_button/icon_button.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import trustTokensViewStyles from"./trustTokensView.css.js";import trustTokensViewDeleteButtonStyles from"./trustTokensViewDeleteButton.css.js";const UIStrings={issuer:"Issuer",storedTokenCount:"Stored token count",allStoredTrustTokensAvailableIn:"All stored Trust Tokens available in this browser instance.",noTrustTokensStored:"No Trust Tokens are currently stored.",deleteTrustTokens:"Delete all stored Trust Tokens issued by {PH1}."},str_=i18n.i18n.registerUIStrings("panels/application/components/TrustTokensView.ts",UIStrings);export const i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class TrustTokensDeleteButton extends HTMLElement{static litTagName=LitHtml.literal`devtools-trust-tokens-delete-button`;shadow=this.attachShadow({mode:"open"});issuer=null;deleteClickHandler=()=>{};connectedCallback(){this.shadow.adoptedStyleSheets=[trustTokensViewDeleteButtonStyles]}set data(t){this.issuer=t.issuer,this.deleteClickHandler=t.deleteClickHandler,this.render()}render(){this.issuer&&LitHtml.render(LitHtml.html`
      <!-- Wrap the button in a container, otherwise we can't center it inside the column. -->
      <span class="button-container">
        <button class="delete-button"
          title=${i18nString(UIStrings.deleteTrustTokens,{PH1:this.issuer})}
          @click=${()=>this.deleteClickHandler(this.issuer)}>
          <${IconButton.Icon.Icon.litTagName} .data=${{iconName:"trash_bin_icon",color:"var(--color-text-secondary)",width:"9px",height:"14px"}}>
          </${IconButton.Icon.Icon.litTagName}>
        </button>
      </span>`,this.shadow,{host:this})}}export class TrustTokensView extends HTMLElement{static litTagName=LitHtml.literal`devtools-trust-tokens-storage-view`;shadow=this.attachShadow({mode:"open"});tokens=[];deleteClickHandler=()=>{};connectedCallback(){this.shadow.adoptedStyleSheets=[trustTokensViewStyles],this.render()}set data(t){this.tokens=t.tokens,this.deleteClickHandler=t.deleteClickHandler,this.render()}render(){LitHtml.render(LitHtml.html`
      <div>
        <span class="heading">Trust Tokens</span>
        <${IconButton.Icon.Icon.litTagName} class="info-icon" title=${i18nString(UIStrings.allStoredTrustTokensAvailableIn)}
          .data=${{iconName:"ic_info_black_18dp",color:"var(--color-link)",width:"14px"}}>
        </${IconButton.Icon.Icon.litTagName}>
        ${this.renderGridOrNoDataMessage()}
      </div>
    `,this.shadow,{host:this})}renderGridOrNoDataMessage(){if(0===this.tokens.length)return LitHtml.html`<div class="no-tt-message">${i18nString(UIStrings.noTrustTokensStored)}</div>`;const t={columns:[{id:"issuer",title:i18nString(UIStrings.issuer),widthWeighting:10,hideable:!1,visible:!0,sortable:!0},{id:"count",title:i18nString(UIStrings.storedTokenCount),widthWeighting:5,hideable:!1,visible:!0,sortable:!0},{id:"delete-button",title:"",widthWeighting:1,hideable:!1,visible:!0,sortable:!1}],rows:this.buildRowsFromTokens(),initialSort:{columnId:"issuer",direction:"ASC"}};return LitHtml.html`
      <${DataGrid.DataGridController.DataGridController.litTagName} .data=${t}></${DataGrid.DataGridController.DataGridController.litTagName}>
    `}buildRowsFromTokens(){return this.tokens.filter((t=>t.count>0)).map((t=>({cells:[{columnId:"delete-button",value:removeTrailingSlash(t.issuerOrigin),renderer:this.deleteButtonRendererForDataGridCell.bind(this)},{columnId:"issuer",value:removeTrailingSlash(t.issuerOrigin)},{columnId:"count",value:t.count}]})))}deleteButtonRendererForDataGridCell(t){return LitHtml.html`<${TrustTokensDeleteButton.litTagName}
     .data=${{issuer:t,deleteClickHandler:this.deleteClickHandler}}
    ></${TrustTokensDeleteButton.litTagName}>`}}function removeTrailingSlash(t){return t.replace(/\/$/,"")}ComponentHelpers.CustomElements.defineComponent("devtools-trust-tokens-delete-button",TrustTokensDeleteButton),ComponentHelpers.CustomElements.defineComponent("devtools-trust-tokens-storage-view",TrustTokensView);