import*as i18n from"../../../core/i18n/i18n.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as Coordinator from"../../../ui/components/render_coordinator/render_coordinator.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import elementsBreadcrumbsStyles from"./elementsBreadcrumbs.css.js";import{crumbsToRender}from"./ElementsBreadcrumbsUtils.js";import{NodeText}from"./NodeText.js";const UIStrings={breadcrumbs:"DOM tree breadcrumbs"},str_=i18n.i18n.registerUIStrings("panels/elements/components/ElementsBreadcrumbs.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class NodeSelectedEvent extends Event{static eventName="breadcrumbsnodeselected";legacyDomNode;constructor(e){super(NodeSelectedEvent.eventName,{}),this.legacyDomNode=e.legacyDomNode}}const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();export class ElementsBreadcrumbs extends HTMLElement{static litTagName=LitHtml.literal`devtools-elements-breadcrumbs`;shadow=this.attachShadow({mode:"open"});resizeObserver=new ResizeObserver((()=>this.checkForOverflowOnResize()));crumbsData=[];selectedDOMNode=null;overflowing=!1;userScrollPosition="start";isObservingResize=!1;userHasManuallyScrolled=!1;connectedCallback(){this.shadow.adoptedStyleSheets=[elementsBreadcrumbsStyles]}set data(e){this.selectedDOMNode=e.selectedNode,this.crumbsData=e.crumbs,this.userHasManuallyScrolled=!1,this.update()}disconnectedCallback(){this.isObservingResize=!1,this.resizeObserver.disconnect()}onCrumbClick(e){return t=>{t.preventDefault(),this.dispatchEvent(new NodeSelectedEvent(e))}}async checkForOverflowOnResize(){const e=this.shadow.querySelector(".crumbs"),t=this.shadow.querySelector(".crumbs-scroll-container");if(!e||!t)return;const r=await coordinator.read((()=>e.clientWidth)),s=await coordinator.read((()=>t.clientWidth));s>=r&&!1===this.overflowing?(this.overflowing=!0,this.userScrollPosition="start",this.render()):s<r&&!0===this.overflowing&&(this.overflowing=!1,this.userScrollPosition="start",this.render())}async update(){await this.render(),this.engageResizeObserver(),this.ensureSelectedNodeIsVisible()}onCrumbMouseMove(e){return()=>e.highlightNode()}onCrumbMouseLeave(e){return()=>e.clearHighlight()}onCrumbFocus(e){return()=>e.highlightNode()}onCrumbBlur(e){return()=>e.clearHighlight()}engageResizeObserver(){if(!this.resizeObserver||!0===this.isObservingResize)return;const e=this.shadow.querySelector(".crumbs");e&&(this.resizeObserver.observe(e),this.isObservingResize=!0)}async checkForOverflow(){const e=this.shadow.querySelector(".crumbs-scroll-container"),t=this.shadow.querySelector(".crumbs-window");if(!e||!t)return;const r=await coordinator.read((()=>t.clientWidth));await coordinator.read((()=>e.clientWidth))<r-20?this.overflowing&&(this.overflowing=!1,this.render()):this.overflowing||(this.overflowing=!0,this.render())}onCrumbsWindowScroll(e){if(!e.target)return;const t=e.target;this.updateScrollState(t)}updateScrollState(e){const t=e.scrollWidth-e.clientWidth,r=e.scrollLeft;this.userScrollPosition=r<10?"start":r>=t-10?"end":"middle",this.render()}onOverflowClick(e){return()=>{this.userHasManuallyScrolled=!0;const t=this.shadow.querySelector(".crumbs-window");if(!t)return;const r=t.clientWidth/2,s="left"===e?Math.max(Math.floor(t.scrollLeft-r),0):t.scrollLeft+r;t.scrollTo({behavior:"smooth",left:s})}}renderOverflowButton(e,t){const r=LitHtml.Directives.classMap({overflow:!0,[e]:!0,hidden:!1===this.overflowing});return LitHtml.html`
      <button
        class=${r}
        @click=${this.onOverflowClick(e)}
        ?disabled=${t}
        aria-label="Scroll ${e}"
      >&hellip;</button>
      `}async render(){const e=crumbsToRender(this.crumbsData,this.selectedDOMNode);await coordinator.write("Breadcrumbs render",(()=>{LitHtml.render(LitHtml.html`
        <nav class="crumbs" aria-label="${i18nString(UIStrings.breadcrumbs)}">
          ${this.renderOverflowButton("left","start"===this.userScrollPosition)}

          <div class="crumbs-window" @scroll=${this.onCrumbsWindowScroll}>
            <ul class="crumbs-scroll-container">
              ${e.map((e=>{const t={crumb:!0,selected:e.selected};return LitHtml.html`
                  <li class=${LitHtml.Directives.classMap(t)}
                    data-node-id=${e.node.id}
                    data-crumb="true"
                  >
                    <a href="#"
                      draggable=false
                      class="crumb-link"
                      @click=${this.onCrumbClick(e.node)}
                      @mousemove=${this.onCrumbMouseMove(e.node)}
                      @mouseleave=${this.onCrumbMouseLeave(e.node)}
                      @focus=${this.onCrumbFocus(e.node)}
                      @blur=${this.onCrumbBlur(e.node)}
                    ><${NodeText.litTagName} data-node-title=${e.title.main} .data=${{nodeTitle:e.title.main,nodeId:e.title.extras.id,nodeClasses:e.title.extras.classes}}></${NodeText.litTagName}></a>
                  </li>`}))}
            </ul>
          </div>
          ${this.renderOverflowButton("right","end"===this.userScrollPosition)}
        </nav>
      `,this.shadow,{host:this})})),this.checkForOverflow()}async ensureSelectedNodeIsVisible(){if(!this.selectedDOMNode||!this.shadow||!this.overflowing||this.userHasManuallyScrolled)return;const e=this.selectedDOMNode.id,t=this.shadow.querySelector(`.crumb[data-node-id="${e}"]`);t&&await coordinator.scroll((()=>{t.scrollIntoView({behavior:"smooth"})}))}}ComponentHelpers.CustomElements.defineComponent("devtools-elements-breadcrumbs",ElementsBreadcrumbs);