import*as Common from"../../../core/common/common.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as UI from"../../../ui/legacy/legacy.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import{NodeText}from"./NodeText.js";import layoutPaneStyles from"../layoutPane.css.js";import inspectorCommonStyles from"../../../ui/legacy/inspectorCommon.css.js";import*as i18n from"../../../core/i18n/i18n.js";const UIStrings={chooseElementOverlayColor:"Choose the overlay color for this element",showElementInTheElementsPanel:"Show element in the Elements panel",grid:"Grid",overlayDisplaySettings:"Overlay display settings",gridOverlays:"Grid overlays",noGridLayoutsFoundOnThisPage:"No grid layouts found on this page",flexbox:"Flexbox",flexboxOverlays:"Flexbox overlays",noFlexboxLayoutsFoundOnThisPage:"No flexbox layouts found on this page",colorPickerOpened:"Color picker opened."},str_=i18n.i18n.registerUIStrings("panels/elements/components/LayoutPane.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),{render:render,html:html}=LitHtml;export class SettingChangedEvent extends Event{static eventName="settingchanged";data;constructor(e,t){super(SettingChangedEvent.eventName,{}),this.data={setting:e,value:t}}}function isEnumSetting(e){return e.type===Common.Settings.SettingType.ENUM}function isBooleanSetting(e){return e.type===Common.Settings.SettingType.BOOLEAN}export class LayoutPane extends HTMLElement{static litTagName=LitHtml.literal`devtools-layout-pane`;shadow=this.attachShadow({mode:"open"});settings=[];gridElements=[];flexContainerElements=[];constructor(){super(),this.shadow.adoptedStyleSheets=[layoutPaneStyles,inspectorCommonStyles]}set data(e){this.settings=e.settings,this.gridElements=e.gridElements,this.flexContainerElements=e.flexContainerElements,this.render()}onSummaryKeyDown(e){if(!e.target)return;const t=e.target.parentElement;if(!t)throw new Error("<details> element is not found for a <summary> element");switch(e.key){case"ArrowLeft":t.open=!1;break;case"ArrowRight":t.open=!0}}render(){render(html`
      <details open>
        <summary class="header" @keydown=${this.onSummaryKeyDown}>
          ${i18nString(UIStrings.grid)}
        </summary>
        <div class="content-section">
          <h3 class="content-section-title">${i18nString(UIStrings.overlayDisplaySettings)}</h3>
          <div class="select-settings">
            ${this.getEnumSettings().map((e=>this.renderEnumSetting(e)))}
          </div>
          <div class="checkbox-settings">
            ${this.getBooleanSettings().map((e=>this.renderBooleanSetting(e)))}
          </div>
        </div>
        ${this.gridElements?html`<div class="content-section">
            <h3 class="content-section-title">
              ${this.gridElements.length?i18nString(UIStrings.gridOverlays):i18nString(UIStrings.noGridLayoutsFoundOnThisPage)}
            </h3>
            ${this.gridElements.length?html`<div class="elements">
                ${this.gridElements.map((e=>this.renderElement(e)))}
              </div>`:""}
          </div>`:""}
      </details>
      ${void 0!==this.flexContainerElements?html`
        <details open>
          <summary class="header" @keydown=${this.onSummaryKeyDown}>
            ${i18nString(UIStrings.flexbox)}
          </summary>
          ${this.flexContainerElements?html`<div class="content-section">
              <h3 class="content-section-title">
                ${this.flexContainerElements.length?i18nString(UIStrings.flexboxOverlays):i18nString(UIStrings.noFlexboxLayoutsFoundOnThisPage)}
              </h3>
              ${this.flexContainerElements.length?html`<div class="elements">
                  ${this.flexContainerElements.map((e=>this.renderElement(e)))}
                </div>`:""}
            </div>`:""}
        </details>
        `:""}
    `,this.shadow,{host:this})}getEnumSettings(){return this.settings.filter(isEnumSetting)}getBooleanSettings(){return this.settings.filter(isBooleanSetting)}onBooleanSettingChange(e,t){t.preventDefault(),this.dispatchEvent(new SettingChangedEvent(e.name,t.target.checked))}onEnumSettingChange(e,t){t.preventDefault(),this.dispatchEvent(new SettingChangedEvent(e.name,t.target.value))}onElementToggle(e,t){t.preventDefault(),e.toggle(t.target.checked)}onElementClick(e,t){t.preventDefault(),e.reveal()}onColorChange(e,t){t.preventDefault(),e.setColor(t.target.value),this.render()}onElementMouseEnter(e,t){t.preventDefault(),e.highlight()}onElementMouseLeave(e,t){t.preventDefault(),e.hideHighlight()}renderElement(e){const t=this.onElementToggle.bind(this,e),n=this.onElementClick.bind(this,e),s=this.onColorChange.bind(this,e),i=this.onElementMouseEnter.bind(this,e),l=this.onElementMouseLeave.bind(this,e);return html`<div class="element">
      <label data-element="true" class="checkbox-label">
        <input data-input="true" type="checkbox" .checked=${e.enabled} @change=${t} />
        <span class="node-text-container" data-label="true" @mouseenter=${i} @mouseleave=${l}>
          <${NodeText.litTagName} .data=${{nodeId:e.domId,nodeTitle:e.name,nodeClasses:e.domClasses}}></${NodeText.litTagName}>
        </span>
      </label>
      <label @keyup=${e=>{if("Enter"!==e.key&&" "!==e.key)return;e.target.querySelector("input").click(),UI.ARIAUtils.alert(i18nString(UIStrings.colorPickerOpened)),e.preventDefault()}} @keydown=${e=>{" "===e.key&&e.preventDefault()}} tabindex="0" title=${i18nString(UIStrings.chooseElementOverlayColor)} class="color-picker-label" style="background: ${e.color};">
        <input @change=${s} @input=${s} class="color-picker" type="color" value=${e.color} />
      </label>
      <button tabindex="0" @click=${n} title=${i18nString(UIStrings.showElementInTheElementsPanel)} class="show-element"></button>
    </div>`}renderBooleanSetting(e){const t=this.onBooleanSettingChange.bind(this,e);return html`<label data-boolean-setting="true" class="checkbox-label" title=${e.title}>
      <input data-input="true" type="checkbox" .checked=${e.value} @change=${t} />
      <span data-label="true">${e.title}</span>
    </label>`}renderEnumSetting(e){const t=this.onEnumSettingChange.bind(this,e);return html`<label data-enum-setting="true" class="select-label" title=${e.title}>
      <select class="chrome-select" data-input="true" @change=${t}>
        ${e.options.map((t=>html`<option value=${t.value} .selected=${e.value===t.value}>${t.title}</option>`))}
      </select>
    </label>`}}ComponentHelpers.CustomElements.defineComponent("devtools-layout-pane",LayoutPane);