import*as i18n from"../../../core/i18n/i18n.js";import*as SDK from"../../../core/sdk/sdk.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as IconButton from"../../../ui/components/icon_button/icon_button.js";import*as ReportView from"../../../ui/components/report_view/report_view.js";import*as UI from"../../../ui/legacy/legacy.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import requestTrustTokensViewStyles from"./RequestTrustTokensView.css.js";const UIStrings={parameters:"Parameters",type:"Type",refreshPolicy:"Refresh policy",issuers:"Issuers",topLevelOrigin:"Top level origin",issuer:"Issuer",result:"Result",status:"Status",numberOfIssuedTokens:"Number of issued tokens",success:"Success",failure:"Failure",theOperationsResultWasServedFrom:"The operations result was served from cache.",theOperationWasFulfilledLocally:"The operation was fulfilled locally, no request was sent.",aClientprovidedArgumentWas:"A client-provided argument was malformed or otherwise invalid.",eitherNoInputsForThisOperation:"Either no inputs for this operation are available or the output exceeds the operations quota.",theServersResponseWasMalformedOr:"The servers response was malformed or otherwise invalid.",theOperationFailedForAnUnknown:"The operation failed for an unknown reason."},str_=i18n.i18n.registerUIStrings("panels/network/components/RequestTrustTokensView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class RequestTrustTokensView extends UI.Widget.VBox{reportView=new RequestTrustTokensReport;request;constructor(e){super(),this.request=e,this.contentElement.appendChild(this.reportView)}wasShown(){this.request.addEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this.refreshReportView,this),this.refreshReportView()}willHide(){this.request.removeEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this.refreshReportView,this)}refreshReportView(){this.reportView.data={params:this.request.trustTokenParams(),result:this.request.trustTokenOperationDoneEvent()}}}export class RequestTrustTokensReport extends HTMLElement{static litTagName=LitHtml.literal`devtools-trust-token-report`;shadow=this.attachShadow({mode:"open"});trustTokenData;set data(e){this.trustTokenData=e,this.render()}connectedCallback(){this.shadow.adoptedStyleSheets=[requestTrustTokensViewStyles]}render(){if(!this.trustTokenData)throw new Error("Trying to render a Trust Token report without providing data");LitHtml.render(LitHtml.html`<${ReportView.ReportView.Report.litTagName}>
        ${this.renderParameterSection()}
        ${this.renderResultSection()}
      </${ReportView.ReportView.Report.litTagName}>
    `,this.shadow,{host:this})}renderParameterSection(){return this.trustTokenData&&this.trustTokenData.params?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>${i18nString(UIStrings.parameters)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      ${renderRowWithCodeValue(i18nString(UIStrings.type),this.trustTokenData.params.type.toString())}
      ${this.renderRefreshPolicy(this.trustTokenData.params)}
      ${this.renderIssuers(this.trustTokenData.params)}
      ${this.renderIssuerAndTopLevelOriginFromResult()}
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
    `:LitHtml.nothing}renderRefreshPolicy(e){return"Redemption"!==e.type?LitHtml.nothing:renderRowWithCodeValue(i18nString(UIStrings.refreshPolicy),e.refreshPolicy.toString())}renderIssuers(e){return e.issuers&&0!==e.issuers.length?LitHtml.html`
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.issuers)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        <ul class="issuers-list">
          ${e.issuers.map((e=>LitHtml.html`<li>${e}</li>`))}
        </ul>
      </${ReportView.ReportView.ReportValue.litTagName}>
    `:LitHtml.nothing}renderIssuerAndTopLevelOriginFromResult(){return this.trustTokenData&&this.trustTokenData.result?LitHtml.html`
      ${renderSimpleRowIfValuePresent(i18nString(UIStrings.topLevelOrigin),this.trustTokenData.result.topLevelOrigin)}
      ${renderSimpleRowIfValuePresent(i18nString(UIStrings.issuer),this.trustTokenData.result.issuerOrigin)}`:LitHtml.nothing}renderResultSection(){return this.trustTokenData&&this.trustTokenData.result?LitHtml.html`
      <${ReportView.ReportView.ReportSectionHeader.litTagName}>${i18nString(UIStrings.result)}</${ReportView.ReportView.ReportSectionHeader.litTagName}>
      <${ReportView.ReportView.ReportKey.litTagName}>${i18nString(UIStrings.status)}</${ReportView.ReportView.ReportKey.litTagName}>
      <${ReportView.ReportView.ReportValue.litTagName}>
        <span>
          <${IconButton.Icon.Icon.litTagName} class="status-icon"
            .data=${getIconForStatusCode(this.trustTokenData.result.status)}>
          </${IconButton.Icon.Icon.litTagName}>
          <strong>${getSimplifiedStatusTextForStatusCode(this.trustTokenData.result.status)}</strong>
          ${getDetailedTextForStatusCode(this.trustTokenData.result.status)}
        </span>
      </${ReportView.ReportView.ReportValue.litTagName}>
      ${this.renderIssuedTokenCount(this.trustTokenData.result)}
      <${ReportView.ReportView.ReportSectionDivider.litTagName}></${ReportView.ReportView.ReportSectionDivider.litTagName}>
      `:LitHtml.nothing}renderIssuedTokenCount(e){return"Issuance"!==e.type?LitHtml.nothing:renderSimpleRowIfValuePresent(i18nString(UIStrings.numberOfIssuedTokens),e.issuedTokenCount)}}const SUCCESS_ICON_DATA={color:"rgb(12, 164, 12)",iconName:"ic_checkmark_16x16",width:"12px"},FAILURE_ICON_DATA={color:"",iconName:"error_icon",width:"12px"};export function statusConsideredSuccess(e){return"Ok"===e||"AlreadyExists"===e||"FulfilledLocally"===e}function getIconForStatusCode(e){return statusConsideredSuccess(e)?SUCCESS_ICON_DATA:FAILURE_ICON_DATA}function getSimplifiedStatusTextForStatusCode(e){return statusConsideredSuccess(e)?i18nString(UIStrings.success):i18nString(UIStrings.failure)}function getDetailedTextForStatusCode(e){switch(e){case"Ok":return null;case"AlreadyExists":return i18nString(UIStrings.theOperationsResultWasServedFrom);case"FulfilledLocally":return i18nString(UIStrings.theOperationWasFulfilledLocally);case"InvalidArgument":return i18nString(UIStrings.aClientprovidedArgumentWas);case"ResourceExhausted":return i18nString(UIStrings.eitherNoInputsForThisOperation);case"BadResponse":return i18nString(UIStrings.theServersResponseWasMalformedOr);case"FailedPrecondition":case"Unavailable":case"InternalError":case"UnknownError":return i18nString(UIStrings.theOperationFailedForAnUnknown)}}function renderSimpleRowIfValuePresent(e,t){return void 0===t?LitHtml.nothing:LitHtml.html`
    <${ReportView.ReportView.ReportKey.litTagName}>${e}</${ReportView.ReportView.ReportKey.litTagName}>
    <${ReportView.ReportView.ReportValue.litTagName}>${t}</${ReportView.ReportView.ReportValue.litTagName}>
  `}function renderRowWithCodeValue(e,t){return LitHtml.html`
    <${ReportView.ReportView.ReportKey.litTagName}>${e}</${ReportView.ReportView.ReportKey.litTagName}>
    <${ReportView.ReportView.ReportValue.litTagName} class="code">${t}</${ReportView.ReportView.ReportValue.litTagName}>
  `}ComponentHelpers.CustomElements.defineComponent("devtools-trust-token-report",RequestTrustTokensReport);