import*as Common from"../../../core/common/common.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as i18n from"../../../core/i18n/i18n.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import*as Settings from"../../../ui/components/settings/settings.js";import*as SDK from"../../../core/sdk/sdk.js";import syncSectionStyles from"./syncSection.css.js";const UIStrings={syncDisabled:"To turn this setting on, you must enable Chrome sync.",preferencesSyncDisabled:"To turn this setting on, you must first enable settings sync in Chrome.",settings:"Go to Settings",signedIn:"Signed into Chrome as:"},str_=i18n.i18n.registerUIStrings("panels/settings/components/SyncSection.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SyncSection extends HTMLElement{static litTagName=LitHtml.literal`devtools-sync-section`;shadow=this.attachShadow({mode:"open"});syncInfo={isSyncActive:!1};syncSetting;boundRender=this.render.bind(this);connectedCallback(){this.shadow.adoptedStyleSheets=[syncSectionStyles]}set data(n){this.syncInfo=n.syncInfo,this.syncSetting=n.syncSetting,ComponentHelpers.ScheduledRender.scheduleRender(this,this.boundRender)}render(){if(!this.syncSetting)throw new Error("SyncSection not properly initialized");const n=!this.syncInfo.isSyncActive||!this.syncInfo.arePreferencesSynced;LitHtml.render(LitHtml.html`
      <fieldset>
        <legend>${Common.Settings.getLocalizedSettingsCategory(Common.Settings.SettingCategory.SYNC)}</legend>
        ${renderAccountInfoOrWarning(this.syncInfo)}
        <${Settings.SettingCheckbox.SettingCheckbox.litTagName} .data=${{setting:this.syncSetting,disabled:n}}>
        </${Settings.SettingCheckbox.SettingCheckbox.litTagName}>
      </fieldset>
    `,this.shadow,{host:this})}}function renderAccountInfoOrWarning(n){if(!n.isSyncActive){const n="chrome://settings/syncSetup";return LitHtml.html`
      <span class="warning">
        ${i18nString(UIStrings.syncDisabled)} <a href="${n}" class="link" target="_blank"
          @click=${t=>openSettingsTab(n,t)}
          @keydown=${t=>openSettingsTab(n,t)}>${i18nString(UIStrings.settings)}</x-link>
      </span>`}if(!n.arePreferencesSynced){const n="chrome://settings/syncSetup/advanced";return LitHtml.html`
      <span class="warning">
        ${i18nString(UIStrings.preferencesSyncDisabled)} <a href="${n}" class="link" target="_blank"
          @click=${t=>openSettingsTab(n,t)}
          @keydown=${t=>openSettingsTab(n,t)}>${i18nString(UIStrings.settings)}</x-link>
      </span>`}return LitHtml.html`
    <div class="account-info">
      <img src="data:image/png;base64, ${n.accountImage}" alt="Account avatar" />
      <div class="account-email">
        <span>${i18nString(UIStrings.signedIn)}</span>
        <span>${n.accountEmail}</span>
      </div>
    </div>`}function openSettingsTab(n,t){if("click"===t.type||"keydown"===t.type&&self.isEnterOrSpaceKey(t)){const e=SDK.TargetManager.TargetManager.instance().mainTarget();e&&e.targetAgent().invoke_createTarget({url:n}),t.consume(!0)}}ComponentHelpers.CustomElements.defineComponent("devtools-sync-section",SyncSection);