import*as i18n from"../../../../core/i18n/i18n.js";import*as Buttons from"../../../../ui/components/buttons/buttons.js";import*as ComponentHelpers from"../../../../ui/components/helpers/helpers.js";import*as LitHtml from"../../../../ui/lit-html/lit-html.js";import userAgentClientHintsFormStyles from"./userAgentClientHintsForm.css.js";import*as IconButton from"../../../../ui/components/icon_button/icon_button.js";import*as EmulationUtils from"../utils/utils.js";const UIStrings={title:"User agent client hints",brands:"Brands",brandProperties:"Brand properties",brandName:"Brand",brandNameAriaLabel:"Brand {PH1}",version:"Version",brandVersionAriaLabel:"Version {PH1}",addBrand:"Add Brand",deleteTooltip:"Delete",brandDeleteAriaLabel:"Delete {PH1}",fullBrowserVersion:"Full browser version",fullBrowserVersionPlaceholder:"Full browser version (e.g. 87.0.4280.88)",platformLabel:"Platform",platformProperties:"Platform properties",platformVersion:"Platform version",platformPlaceholder:"Platform (e.g. Android)",architecture:"Architecture",architecturePlaceholder:"Architecture (e.g. x86)",deviceProperties:"Device properties",deviceModel:"Device model",mobileCheckboxLabel:"Mobile",update:"Update",notRepresentable:"Not representable as structured headers string.",userAgentClientHintsInfo:"User agent client hints are an alternative to the user agent string that identify the browser and the device in a more structured way with better privacy accounting. Click the button to learn more.",addedBrand:"Added brand row",deletedBrand:"Deleted brand row"},str_=i18n.i18n.registerUIStrings("panels/settings/emulation/components/UserAgentClientHintsForm.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ClientHintsChangeEvent extends Event{static eventName="clienthintschange";constructor(){super(ClientHintsChangeEvent.eventName)}}export class ClientHintsSubmitEvent extends Event{static eventName="clienthintssubmit";detail;constructor(t){super(ClientHintsSubmitEvent.eventName),this.detail={value:t}}}const DEFAULT_METADATA={brands:[{brand:"",version:""}],fullVersion:"",platform:"",platformVersion:"",architecture:"",model:"",mobile:!1};export class UserAgentClientHintsForm extends HTMLElement{static litTagName=LitHtml.literal`devtools-user-agent-client-hints-form`;shadow=this.attachShadow({mode:"open"});isFormOpened=!1;isFormDisabled=!1;metaData=DEFAULT_METADATA;showMobileCheckbox=!1;showSubmitButton=!1;brandsModifiedAriaMessage="";connectedCallback(){this.shadow.adoptedStyleSheets=[userAgentClientHintsFormStyles]}set value(t){const{metaData:e=DEFAULT_METADATA,showMobileCheckbox:n=!1,showSubmitButton:i=!1}=t;this.metaData={...this.metaData,...e},this.showMobileCheckbox=n,this.showSubmitButton=i,this.render()}get value(){return{metaData:this.metaData}}set disabled(t){this.isFormDisabled=t,this.isFormOpened=!1,this.render()}get disabled(){return this.isFormDisabled}handleTreeExpand=t=>{"Space"!==t.code&&"Enter"!==t.code&&"ArrowLeft"!==t.code&&"ArrowRight"!==t.code||(t.stopPropagation(),this.handleTreeClick(t.code))};handleTreeClick=t=>{this.isFormDisabled||"ArrowLeft"===t&&!this.isFormOpened||"ArrowRight"===t&&this.isFormOpened||(this.isFormOpened=!this.isFormOpened,this.render())};handleBrandInputChange=(t,e,n)=>{const i=this.metaData.brands?.map(((i,r)=>{if(r===e){const{brand:e,version:r}=i;return"brandName"===n?{brand:t,version:r}:{brand:e,version:t}}return i}));this.metaData={...this.metaData,brands:i},this.dispatchEvent(new ClientHintsChangeEvent),this.render()};handleBrandDelete=t=>{const{brands:e=[]}=this.metaData;e.splice(t,1),this.metaData={...this.metaData,brands:e},this.dispatchEvent(new ClientHintsChangeEvent),this.brandsModifiedAriaMessage=i18nString(UIStrings.deletedBrand),this.render();let n=this.shadowRoot?.getElementById(`brand-${t+1}-input`);n||(n=this.shadowRoot?.getElementById("add-brand-button")),n?.focus()};handleAddBrandClick=()=>{const{brands:t}=this.metaData;this.metaData={...this.metaData,brands:[...Array.isArray(t)?t:[],{brand:"",version:""}]},this.dispatchEvent(new ClientHintsChangeEvent),this.brandsModifiedAriaMessage=i18nString(UIStrings.addedBrand),this.render();const e=this.shadowRoot?.querySelectorAll(".brand-name-input");if(e){const t=Array.from(e).pop();t&&t.focus()}};handleAddBrandKeyPress=t=>{"Space"!==t.code&&"Enter"!==t.code||(t.preventDefault(),this.handleAddBrandClick())};handleInputChange=(t,e)=>{t in this.metaData&&(this.metaData={...this.metaData,[t]:e},this.render()),this.dispatchEvent(new ClientHintsChangeEvent)};handleLinkPress=t=>{"Space"!==t.code&&"Enter"!==t.code||(t.preventDefault(),t.target.click())};handleSubmit=t=>{t.preventDefault(),this.showSubmitButton&&(this.dispatchEvent(new ClientHintsSubmitEvent(this.metaData)),this.render())};renderInputWithLabel(t,e,n,i){return LitHtml.html`
      <label class="full-row label input-field-label-container">
        ${t}
        <input
          class="input-field"
          type="text"
          @input="${t=>{const e=t.target.value;this.handleInputChange(i,e)}}"
          .value="${n}"
          placeholder="${e}"
        />
      </label>
    `}renderPlatformSection(){const{platform:t,platformVersion:e}=this.metaData;return LitHtml.html`
      <span class="full-row label">${i18nString(UIStrings.platformLabel)}</span>
      <div class="full-row brand-row" aria-label="${i18nString(UIStrings.platformProperties)}" role="group">
        <input
          class="input-field half-row"
          type="text"
          @input="${t=>{const e=t.target.value;this.handleInputChange("platform",e)}}"
          .value="${t}"
          placeholder="${i18nString(UIStrings.platformPlaceholder)}"
          aria-label="${i18nString(UIStrings.platformLabel)}"
        />
        <input
          class="input-field half-row"
          type="text"
          @input="${t=>{const e=t.target.value;this.handleInputChange("platformVersion",e)}}"
          .value="${e}"
          placeholder="${i18nString(UIStrings.platformVersion)}"
          aria-label="${i18nString(UIStrings.platformVersion)}"
        />
      </div>
    `}renderDeviceModelSection(){const{model:t,mobile:e}=this.metaData,n=this.showMobileCheckbox?LitHtml.html`
      <label class="mobile-checkbox-container">
        <input type="checkbox" @input="${t=>{const e=t.target.checked;this.handleInputChange("mobile",e)}}" .checked="${e}" />
        ${i18nString(UIStrings.mobileCheckboxLabel)}
      </label>
    `:LitHtml.html``;return LitHtml.html`
      <span class="full-row label">${i18nString(UIStrings.deviceModel)}</span>
      <div class="full-row brand-row" aria-label="${i18nString(UIStrings.deviceProperties)}" role="group">
        <input
          class="input-field ${this.showMobileCheckbox?"device-model-input":"full-row"}"
          type="text"
          @input="${t=>{const e=t.target.value;this.handleInputChange("model",e)}}"
          .value="${t}"
          placeholder="${i18nString(UIStrings.deviceModel)}"
        />
        ${n}
      </div>
    `}renderBrands(){const{brands:t=[{brand:"",version:""}]}=this.metaData,e=t.map(((t,e)=>{const{brand:n,version:i}=t,r=()=>{this.handleBrandDelete(e)};return LitHtml.html`
        <div class="full-row brand-row" aria-label="${i18nString(UIStrings.brandProperties)}" role="group">
          <input
            class="input-field brand-name-input"
            type="text"
            @input="${t=>{const n=t.target.value;this.handleBrandInputChange(n,e,"brandName")}}"
            .value="${n}"
            id="brand-${e+1}-input"
            placeholder="${i18nString(UIStrings.brandName)}"
            aria-label="${i18nString(UIStrings.brandNameAriaLabel,{PH1:e+1})}"
          />
          <input
            class="input-field"
            type="text"
            @input="${t=>{const n=t.target.value;this.handleBrandInputChange(n,e,"brandVersion")}}"
            .value="${i}"
            placeholder="${i18nString(UIStrings.version)}"
            aria-label="${i18nString(UIStrings.brandVersionAriaLabel,{PH1:e+1})}"
          />
          <${IconButton.Icon.Icon.litTagName}
            .data=${{color:"var(--client-hints-form-icon-color)",iconName:"trash_bin_icon",width:"10px",height:"14px"}}
            title="${i18nString(UIStrings.deleteTooltip)}"
            class="delete-icon"
            tabindex="0"
            role="button"
            @click="${r}"
            @keypress="${t=>{"Space"!==t.code&&"Enter"!==t.code||(t.preventDefault(),r())}}"
            aria-label="${i18nString(UIStrings.brandDeleteAriaLabel,{PH1:e+1})}"
          >
          </${IconButton.Icon.Icon.litTagName}>
        </div>
      `}));return LitHtml.html`
      <span class="full-row label">${i18nString(UIStrings.brands)}</span>
      ${e}
      <div
        class="add-container full-row"
        role="button"
        tabindex="0"
        id="add-brand-button"
        aria-label="${i18nString(UIStrings.addBrand)}"
        @click="${this.handleAddBrandClick}"
        @keypress="${this.handleAddBrandKeyPress}"
      >
        <${IconButton.Icon.Icon.litTagName}
          aria-hidden="true"
          .data=${{color:"var(--client-hints-form-icon-color)",iconName:"add-icon",width:"10px"}}
        >
        </${IconButton.Icon.Icon.litTagName}>
        ${i18nString(UIStrings.addBrand)}
      </div>
    `}render(){const{fullVersion:t,architecture:e}=this.metaData,n=this.renderBrands(),i=this.renderInputWithLabel(i18nString(UIStrings.fullBrowserVersion),i18nString(UIStrings.fullBrowserVersionPlaceholder),t||"","fullVersion"),r=this.renderPlatformSection(),a=this.renderInputWithLabel(i18nString(UIStrings.architecture),i18nString(UIStrings.architecturePlaceholder),e,"architecture"),s=this.renderDeviceModelSection(),o=this.showSubmitButton?LitHtml.html`
      <${Buttons.Button.Button.litTagName}
        .variant=${"secondary"}
        .type=${"submit"}
      >
        ${i18nString(UIStrings.update)}
      </${Buttons.Button.Button.litTagName}>
    `:LitHtml.html``,l=LitHtml.html`
      <section class="root">
        <div
          class="tree-title"
          role="button"
          @click="${this.handleTreeClick}"
          tabindex="0"
          @keydown="${this.handleTreeExpand}"
          aria-expanded="${this.isFormOpened}"
          aria-controls="form-container"
          @disabled="${this.isFormDisabled}"
          aria-disabled="${this.isFormDisabled}"
        >
          <${IconButton.Icon.Icon.litTagName}
            class="${this.isFormOpened?"":"rotate-icon"}"
            .data=${{color:"var(--client-hints-form-icon-color)",iconName:"chromeSelect",width:"20px"}}
          >
          </${IconButton.Icon.Icon.litTagName}>
          ${i18nString(UIStrings.title)}
          <x-link
           tabindex="0"
           href="https://web.dev/user-agent-client-hints/"
           target="_blank"
           class="info-link"
           @keypress="${this.handleLinkPress}"
           aria-label="${i18nString(UIStrings.userAgentClientHintsInfo)}"
          >
            <${IconButton.Icon.Icon.litTagName}
              .data=${{color:"var(--client-hints-form-icon-color)",iconName:"ic_info_black_18dp",width:"14px"}}
            >
            </${IconButton.Icon.Icon.litTagName}>
          </x-link>
        </div>
        <form
          id="form-container"
          class="form-container ${this.isFormOpened?"":"hide-container"}"
          @submit="${this.handleSubmit}"
        >
          ${n}
          ${i}
          ${r}
          ${a}
          ${s}
          ${o}
        </form>
        <div aria-live="polite" aria-label="${this.brandsModifiedAriaMessage}"></div>
      </section>
    `;LitHtml.render(l,this.shadow,{host:this})}validate=()=>{for(const[t,e]of Object.entries(this.metaData))if("brands"===t){const t=this.metaData.brands?.every((({brand:t,version:e})=>{const n=EmulationUtils.UserAgentMetadata.validateAsStructuredHeadersString(t,i18nString(UIStrings.notRepresentable)),i=EmulationUtils.UserAgentMetadata.validateAsStructuredHeadersString(e,i18nString(UIStrings.notRepresentable));return n.valid&&i.valid}));if(!t)return{valid:!1,errorMessage:i18nString(UIStrings.notRepresentable)}}else{const t=EmulationUtils.UserAgentMetadata.validateAsStructuredHeadersString(e,i18nString(UIStrings.notRepresentable));if(!t.valid)return t}return{valid:!0}}}ComponentHelpers.CustomElements.defineComponent("devtools-user-agent-client-hints-form",UserAgentClientHintsForm);