import*as Host from"../../../core/host/host.js";import*as i18n from"../../../core/i18n/i18n.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as Coordinator from"../../../ui/components/render_coordinator/render_coordinator.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();import{WebVitalsEventLane,WebVitalsTimeboxLane}from"./WebVitalsLane.js";const UIStrings={fcp:"FCP",lcp:"LCP",ls:"LS",longTasks:"Long Tasks",longTask:"Long Task",firstContentfulPaint:"First Contentful Paint",largestContentfulPaint:"Largest Contentful Paint",good:"Good",needsImprovement:"Needs improvement",poor:"Poor"},str_=i18n.i18n.registerUIStrings("panels/timeline/components/WebVitalsTimeline.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export const LINE_HEIGHT=24;const NUMBER_OF_LANES=5,FCP_GOOD_TIMING=2e3,FCP_MEDIUM_TIMING=4e3,LCP_GOOD_TIMING=2500,LCP_MEDIUM_TIMING=4e3;export const LONG_TASK_THRESHOLD=50;export function assertInstanceOf(t,e){if(!(t instanceof e))throw new TypeError(`Instance expected to be of type ${e.name} but got ${t.constructor.name}`)}export class WebVitalsTimeline extends HTMLElement{static litTagName=LitHtml.literal`devtools-timeline-webvitals`;shadow=this.attachShadow({mode:"open"});mainFrameNavigations=[];startTime=0;duration=1e3;maxDuration=1e3;width=0;height=0;canvas;hoverLane=null;fcpLane;lcpLane;layoutShiftsLane;longTasksLane;context;animationFrame=null;overlay;constructor(){super(),this.canvas=document.createElement("canvas"),this.canvas.style.width="100%",this.canvas.style.height=`${Math.max(120,120)}px`,this.shadow.appendChild(this.canvas),this.canvas.addEventListener("pointermove",this.handlePointerMove.bind(this)),this.canvas.addEventListener("pointerout",this.handlePointerOut.bind(this)),this.canvas.addEventListener("click",this.handleClick.bind(this));const t=this.canvas.getContext("2d");assertInstanceOf(t,CanvasRenderingContext2D),this.context=t,this.fcpLane=new WebVitalsEventLane(this,i18nString(UIStrings.fcp),(t=>this.getMarkerTypeForFCPEvent(t)),this.getFCPMarkerOverlay),this.lcpLane=new WebVitalsEventLane(this,i18nString(UIStrings.lcp),(t=>this.getMarkerTypeForLCPEvent(t)),this.getLCPMarkerOverlay),this.layoutShiftsLane=new WebVitalsEventLane(this,i18nString(UIStrings.ls),(t=>"Bad")),this.longTasksLane=new WebVitalsTimeboxLane(this,i18nString(UIStrings.longTasks),this.getLongTaskOverlay),this.overlay=document.createElement("devtools-timeline-webvitals-tooltip"),this.overlay.style.position="absolute",this.overlay.style.visibility="hidden",this.ownerDocument.body.appendChild(this.overlay)}set data(t){this.startTime=t.startTime||this.startTime,this.duration=t.duration||this.duration,this.maxDuration=t.maxDuration||this.maxDuration,this.mainFrameNavigations=t.mainFrameNavigations||this.mainFrameNavigations,t.fcps&&this.fcpLane.setEvents(t.fcps),t.lcps&&this.lcpLane.setEvents(t.lcps),t.layoutShifts&&this.layoutShiftsLane.setEvents(t.layoutShifts),t.longTasks&&this.longTasksLane.setTimeboxes(t.longTasks),this.scheduleRender()}getContext(){return this.context}getLineHeight(){return 24}hideOverlay(){this.overlay.style.visibility="hidden"}showOverlay(t){this.overlay.data={content:t},this.overlay.style.visibility="visible"}handlePointerMove(t){this.updateOverlayPosition(t.clientX,t.clientY);const e=t.offsetX,i=t.offsetY,n=Math.floor(i/24);this.hoverLane=n,this.fcpLane.handlePointerMove(1===this.hoverLane?e:null),this.lcpLane.handlePointerMove(2===this.hoverLane?e:null),this.layoutShiftsLane.handlePointerMove(3===this.hoverLane?e:null),this.longTasksLane.handlePointerMove(4===this.hoverLane?e:null),this.scheduleRender()}updateOverlayPosition(t,e){coordinator.read((()=>{const i=this.getBoundingClientRect(),n=this.overlay.getBoundingClientRect(),s=t+10+n.width>i.x+i.width?t-n.width-10:t+10;coordinator.write((()=>{this.overlay.style.top=`${e+10}px`,this.overlay.style.left=`${s}px`}))}))}handlePointerOut(t){this.fcpLane.handlePointerMove(null),this.lcpLane.handlePointerMove(null),this.layoutShiftsLane.handlePointerMove(null),this.longTasksLane.handlePointerMove(null),this.scheduleRender()}handleClick(t){const e=t.offsetX;this.focus(),this.fcpLane.handleClick(1===this.hoverLane?e:null),this.lcpLane.handleClick(2===this.hoverLane?e:null),this.layoutShiftsLane.handleClick(3===this.hoverLane?e:null),this.longTasksLane.handleClick(4===this.hoverLane?e:null),this.scheduleRender()}tX(t){return(t-this.startTime)/this.duration*this.width}tD(t){return t/this.duration*this.width}setSize(t,e){const i=window.devicePixelRatio;this.width=t,this.height=Math.max(e,120),this.canvas.width=Math.floor(this.width*i),this.canvas.height=Math.floor(this.height*i),this.context.scale(i,i),this.style.width=this.width+"px",this.style.height=this.height+"px",this.render()}connectedCallback(){this.style.display="block",this.tabIndex=0;const t=this.canvas.getBoundingClientRect(),e=t.width,i=t.height;this.setSize(e,i),this.render()}disconnectedCallback(){this.overlay.remove()}getMarkerTypeForFCPEvent(t){const e=this.getTimeSinceLastMainFrameNavigation(t.timestamp);return e<=2e3?"Good":e<=4e3?"Medium":"Bad"}getMarkerTypeForLCPEvent(t){const e=this.getTimeSinceLastMainFrameNavigation(t.timestamp);return e<=2500?"Good":e<=4e3?"Medium":"Bad"}getFCPMarkerOverlay(){return LitHtml.html`
      <table class="table">
        <thead>
          <td colspan="3" class="title">${i18nString(UIStrings.firstContentfulPaint)}</td>
        </thead>
        <tbody>
          <tr>
            <td><span class="good"></span></td>
            <td>${i18nString(UIStrings.good)}</td>
            <td>
              ≤ ${i18n.TimeUtilities.millisToString(2e3)}</td>
          </tr>
          <tr>
            <td><span class="medium"></span></td>
            <td>${i18nString(UIStrings.needsImprovement)}</td>
            <td></td>
          </tr>
          <tr>
            <td><span class="bad"></span></td>
            <td>${i18nString(UIStrings.poor)}</td>
            <td>> ${i18n.TimeUtilities.millisToString(4e3)}</td>
          </tr>
        </tbody>
      </table>
    `}getLCPMarkerOverlay(){return LitHtml.html`
      <table class="table">
        <thead>
          <td colspan="3" class="title">${i18nString(UIStrings.largestContentfulPaint)}</td>
        </thead>
        <tbody>
          <tr>
            <td><span class="good"></span></td>
            <td>${i18nString(UIStrings.good)}</td>
            <td>
            ≤ ${i18n.TimeUtilities.millisToString(2500)}</td>
          </tr>
          <tr>
            <td><span class="medium"></span></td>
            <td>${i18nString(UIStrings.needsImprovement)}</td>
            <td></td>
          </tr>
          <tr>
            <td><span class="bad"></span></td>
            <td>${i18nString(UIStrings.poor)}</td>
            <td>> ${i18n.TimeUtilities.millisToString(4e3)}</td>
          </tr>
        </tbody>
      </table>
    `}getLongTaskOverlay(t){return LitHtml.html`
        <table class="table">
          <thead>
            <td colspan="3" class="title">
              ${i18nString(UIStrings.longTask)}
              <span class="small">
                ${i18n.TimeUtilities.millisToString(t.duration)}
              </span>
            </td>
          </thead>
          <tbody>
            <tr>
              <td><span class="good"></span></td>
              <td>${i18nString(UIStrings.good)}</td>
              <td>≤ ${i18n.TimeUtilities.millisToString(50)}</td>
            </tr>
            <tr>
              <td><span class="bad"></span></td>
              <td>${i18nString(UIStrings.poor)}</td>
              <td>> ${i18n.TimeUtilities.millisToString(50)}</td>
            </tr>
          </tbody>
        </table>
    `}renderMainFrameNavigations(t){this.context.save(),this.context.strokeStyle="blue",this.context.beginPath();for(const e of t)this.context.moveTo(this.tX(e),0),this.context.lineTo(this.tX(e),this.height);this.context.stroke(),this.context.restore()}getTimeSinceLastMainFrameNavigation(t){let e=0,i=0;for(;e<this.mainFrameNavigations.length&&this.mainFrameNavigations[e]<=t;)i=this.mainFrameNavigations[e],e++;return t-i}render(){this.context.save(),this.context.clearRect(0,0,this.width,this.height),this.context.strokeStyle="#dadce0",this.context.beginPath();for(let t=0;t<5;t++)this.context.moveTo(0,24*t+.5),this.context.lineTo(this.width,24*t+.5);this.context.moveTo(0,119.5),this.context.lineTo(this.width,119.5),this.context.stroke(),this.context.restore(),this.context.save(),this.context.font="11px "+Host.Platform.fontFamily();const t=this.context.measureText("Web Vitals"),e=t.actualBoundingBoxAscent-t.actualBoundingBoxDescent;this.context.fillStyle="#202124",this.context.fillText("Web Vitals",6,4+e),this.context.restore(),this.context.save(),this.context.translate(0,Number(24)),this.fcpLane.render(),this.context.translate(0,Number(24)),this.lcpLane.render(),this.context.translate(0,Number(24)),this.layoutShiftsLane.render(),this.context.translate(0,Number(24)),this.longTasksLane.render(),this.context.restore(),this.renderMainFrameNavigations(this.mainFrameNavigations)}scheduleRender(){this.animationFrame||(this.animationFrame=window.requestAnimationFrame((()=>{this.animationFrame=null,this.render()})))}}ComponentHelpers.CustomElements.defineComponent("devtools-timeline-webvitals",WebVitalsTimeline);