declare global {
    interface HTMLElementTagNameMap {
        'devtools-button': Button;
    }
}
export declare const enum Variant {
    PRIMARY = "primary",
    SECONDARY = "secondary",
    TOOLBAR = "toolbar"
}
export declare const enum Size {
    SMALL = "SMALL",
    MEDIUM = "MEDIUM"
}
declare type ButtonType = 'button' | 'submit' | 'reset';
export declare type ButtonData = {
    variant: Variant.TOOLBAR;
    iconUrl: string;
    size?: Size;
    disabled?: boolean;
    active?: boolean;
    spinner?: boolean;
    type?: ButtonType;
    value?: string;
} | {
    variant: Variant.PRIMARY | Variant.SECONDARY;
    iconUrl?: string;
    size?: Size;
    disabled?: boolean;
    active?: boolean;
    spinner?: boolean;
    type?: ButtonType;
    value?: string;
};
export declare class Button extends HTMLElement {
    #private;
    static formAssociated: boolean;
    static readonly litTagName: import("../../lit-html/static.js").Static;
    constructor();
    /**
     * Perfer using the .data= setter instead of setting the individual properties
     * for increased type-safety.
     */
    set data(data: ButtonData);
    set iconUrl(iconUrl: string | undefined);
    set variant(variant: Variant);
    set size(size: Size);
    set type(type: ButtonType);
    set disabled(disabled: boolean);
    set active(active: boolean);
    set spinner(spinner: boolean);
    private setDisabledProperty;
    focus(): void;
    connectedCallback(): void;
    private onClick;
    private onSlotChange;
    private render;
    get value(): string;
    set value(value: string);
    get form(): HTMLFormElement | undefined;
    get name(): string | null;
    get type(): ButtonType;
    get validity(): ValidityState;
    get validationMessage(): string;
    get willValidate(): boolean;
    checkValidity(): void;
    reportValidity(): void;
}
export {};
