import*as Host from"../../../core/host/host.js";import*as Platform from"../../../core/platform/platform.js";import*as UI from"../../legacy/legacy.js";import*as LitHtml from"../../lit-html/lit-html.js";import*as ComponentHelpers from"../helpers/helpers.js";import*as Coordinator from"../render_coordinator/render_coordinator.js";import dataGridStyles from"./dataGrid.css.js";import{BodyCellFocusedEvent,ColumnHeaderClickEvent,ContextMenuHeaderResetClickEvent}from"./DataGridEvents.js";const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();import{addColumnVisibilityCheckboxes,addSortableColumnItems}from"./DataGridContextMenuUtils.js";import{calculateColumnWidthPercentageFromWeighting,calculateFirstFocusableCell,getRowEntryForColumnId,handleArrowKeyNavigation,renderCellValue}from"./DataGridUtils.js";import*as i18n from"../../../core/i18n/i18n.js";const UIStrings={sortBy:"Sort By",resetColumns:"Reset Columns",headerOptions:"Header Options"},str_=i18n.i18n.registerUIStrings("ui/components/data_grid/DataGrid.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),KEYS_TREATED_AS_CLICKS=new Set([" ","Enter"]),ROW_HEIGHT_PIXELS=18,PADDING_ROWS_COUNT=10;export class DataGrid extends HTMLElement{static litTagName=LitHtml.literal`devtools-data-grid`;#e=this.attachShadow({mode:"open"});#t=[];#i=[];#s=null;#o=!1;#r="NOT_SCROLLED";#n=void 0;#l=null;#a=new WeakMap;#c=new ResizeObserver((()=>{this.alignScrollHandlers()}));#d=this.onResizePointerUp.bind(this);#h=this.onResizePointerMove.bind(this);#u=this.onResizePointerDown.bind(this);#m=[0,1];#C=null;#p=!1;#f=!1;#g=!1;connectedCallback(){this.#e.adoptedStyleSheets=[dataGridStyles],ComponentHelpers.SetCSSProperty.set(this,"--table-row-height","18px")}get data(){return{columns:this.#t,rows:this.#i,activeSort:this.#s,contextMenus:this.#n}}set data(e){if(this.#t=e.columns,this.#i=e.rows,this.#i.forEach(((e,t)=>{this.#a.set(e,t)})),this.#s=e.activeSort,this.#n=e.contextMenus,this.#p||(this.#m=calculateFirstFocusableCell({columns:this.#t,rows:this.#i})),this.#p&&this.userHasCellFocused()){const[e,t]=this.tabbableCell(),i=e>this.#t.length,s=t>this.#i.length;(i||s)&&(this.#C=[i?this.#t.length:e,s?this.#i.length:t])}this.render()}shouldAutoScrollToBottom(){return"SCROLLED_TO_BOTTOM"===this.#r||!this.#f&&"MANUAL_SCROLL_NOT_BOTTOM"!==this.#r}scrollToBottomIfRequired(){!1!==this.#p&&this.shouldAutoScrollToBottom()&&coordinator.read((()=>{const e=this.#e.querySelector(".wrapping-container");if(!e)return;const t=e.scrollHeight;coordinator.scroll((()=>{e.scrollTo(0,t)}))}))}engageResizeObserver(){this.#p||this.#c.observe(this.#e.host)}userHasCellFocused(){return null!==this.#C}getTableElementForCellUserHasFocused(){if(!this.#C)return null;const[e,t]=this.#C;return this.#e.querySelector(`[data-row-index="${t}"][data-col-index="${e}"]`)}async focusTableCellInDOM(e){await coordinator.write((()=>{e.focus()}))}focusCellIfRequired([e,t]){if(this.#f=!0,this.#C&&this.#C[0]===e&&this.#C[1]===t)return;this.#C=[e,t],this.render();const i=this.getTableElementForCellUserHasFocused();i&&this.focusTableCellInDOM(i)}onTableKeyDown(e){const t=e.key;if(!this.#C)return;if(KEYS_TREATED_AS_CLICKS.has(t)){const[e,t]=this.#C,i=this.#t[e];0===t&&i&&i.sortable&&this.onColumnHeaderClick(i,e)}if(!Platform.KeyboardUtilities.keyIsArrowKey(t))return;const i=handleArrowKeyNavigation({key:t,currentFocusedCell:this.#C,columns:this.#t,rows:this.#i});e.preventDefault(),this.focusCellIfRequired(i)}onColumnHeaderClick(e,t){this.dispatchEvent(new ColumnHeaderClickEvent(e,t))}ariaSortForHeader(e){return!e.sortable||this.#s&&this.#s.columnId===e.id?this.#s&&this.#s.columnId===e.id?"ASC"===this.#s.direction?"ascending":"descending":void 0:"none"}renderEmptyFillerRow(e){const t=this.#t.map(((e,t)=>{if(!e.visible)return LitHtml.nothing;const i=LitHtml.Directives.classMap({firstVisibleColumn:0===t});return LitHtml.html`<td tabindex="-1" class=${i} data-filler-row-column-index=${t}></td>`})),i=LitHtml.Directives.classMap({"filler-row":!0,"padding-row":!0,"empty-table":0===e});return LitHtml.html`<tr tabindex="-1" class=${i}>${t}</tr>`}cleanUpAfterResizeColumnComplete(){this.#l&&(this.#l.documentForCursorChange.body.style.cursor=this.#l.cursorToRestore,this.#l=null,this.alignScrollHandlers())}onResizePointerDown(e){if(1!==e.buttons||Host.Platform.isMac()&&e.ctrlKey)return;e.preventDefault();const t=e.target;if(!t)return;const i=t.dataset.columnIndex;if(!i)return;const s=globalThis.parseInt(i,10),o=this.#t.findIndex(((e,t)=>t>s&&!0===e.visible)),r=this.#e.querySelector(`td[data-filler-row-column-index="${s}"]`),n=this.#e.querySelector(`td[data-filler-row-column-index="${o}"]`);if(!r||!n)return;const l=this.#e.querySelector(`col[data-col-column-index="${s}"]`),a=this.#e.querySelector(`col[data-col-column-index="${o}"]`);if(!l||!a)return;const c=e.target.ownerDocument;c&&(this.#l={leftCellCol:l,rightCellCol:a,leftCellColInitialPercentageWidth:globalThis.parseInt(l.style.width,10),rightCellColInitialPercentageWidth:globalThis.parseInt(a.style.width,10),initialLeftCellWidth:r.clientWidth,initialRightCellWidth:n.clientWidth,initialMouseX:e.x,documentForCursorChange:c,cursorToRestore:t.style.cursor},c.body.style.cursor="col-resize",t.setPointerCapture(e.pointerId),t.addEventListener("pointermove",this.#h))}onResizePointerMove(e){if(e.preventDefault(),!this.#l)return;const t=this.#l.leftCellColInitialPercentageWidth+this.#l.rightCellColInitialPercentageWidth-10,i=e.x-this.#l.initialMouseX,s=Math.abs(i)/(this.#l.initialLeftCellWidth+this.#l.initialRightCellWidth)*100;let o,r;i>0?(o=Platform.NumberUtilities.clamp(this.#l.leftCellColInitialPercentageWidth+s,10,t),r=Platform.NumberUtilities.clamp(this.#l.rightCellColInitialPercentageWidth-s,10,t)):i<0&&(o=Platform.NumberUtilities.clamp(this.#l.leftCellColInitialPercentageWidth-s,10,t),r=Platform.NumberUtilities.clamp(this.#l.rightCellColInitialPercentageWidth+s,10,t)),o&&r&&(this.#l.leftCellCol.style.width=o.toFixed(2)+"%",this.#l.rightCellCol.style.width=r.toFixed(2)+"%")}onResizePointerUp(e){e.preventDefault();const t=e.target;t&&(t.releasePointerCapture(e.pointerId),t.removeEventListener("pointermove",this.#h),this.cleanUpAfterResizeColumnComplete())}renderResizeForCell(e,t){const[i]=t;return i!==this.getIndexOfLastVisibleColumn()&&e.visible?LitHtml.html`<span class="cell-resize-handle"
     @pointerdown=${this.#u}
     @pointerup=${this.#d}
     data-column-index=${i}
    ></span>`:LitHtml.nothing}getIndexOfLastVisibleColumn(){let e=this.#t.length-1;for(;e>-1;e--){if(this.#t[e].visible)break}return e}onHeaderContextMenu(e){if(2!==e.button)return;const t=new UI.ContextMenu.ContextMenu(e);addColumnVisibilityCheckboxes(this,t);const i=t.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,i),t.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.#n&&this.#n.headerRow&&this.#n.headerRow(t,this.#t),t.show()}onBodyRowContextMenu(e){if(2!==e.button)return;if(!(e.target&&e.target instanceof HTMLElement))return;const t=e.target.dataset.rowIndex;if(!t)return;const i=parseInt(t,10),s=this.#i[i-1],o=new UI.ContextMenu.ContextMenu(e),r=o.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,r);const n=o.defaultSection().appendSubMenuItem(i18nString(UIStrings.headerOptions));addColumnVisibilityCheckboxes(this,n),n.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.#n&&this.#n.bodyRow&&this.#n.bodyRow(o,this.#t,s),o.show()}onScroll(e){const t=e.target;if(!t)return;const i=Math.round(t.scrollTop+t.clientHeight)===Math.round(t.scrollHeight);this.#r=i?"SCROLLED_TO_BOTTOM":"MANUAL_SCROLL_NOT_BOTTOM",this.render()}alignScrollHandlers(){return coordinator.read((()=>{const e=this.#e.querySelectorAll("th:not(.hidden)"),t=this.#e.querySelectorAll(".cell-resize-handle");this.#e.querySelector("table")&&e.forEach((async(e,i)=>{const s=e.clientWidth,o=e.offsetLeft;if(t[i]){const e=t[i].clientWidth;coordinator.write((()=>{t[i].style.left=o+s-e+"px"}))}}))}))}calculateTopAndBottomRowIndexes(){return coordinator.read((()=>{const e=this.#e.querySelector(".wrapping-container");let t=0,i=window.innerHeight;e&&(t=e.scrollTop,i=e.clientHeight);let s=Math.floor((t-180)/18),o=Math.ceil((t+i+180)/18);return s=Math.max(0,s),o=Math.min(this.#i.filter((e=>!e.hidden)).length,o),{topVisibleRow:s,bottomVisibleRow:o}}))}onFocusOut(){this.#f=!1}tabbableCell(){return this.#C||this.#m}async render(){if(this.#o)return void(this.#g=!0);this.#o=!0;const{topVisibleRow:e,bottomVisibleRow:t}=await this.calculateTopAndBottomRowIndexes(),i=this.#i.filter((e=>!e.hidden)),s=i.filter(((i,s)=>s>=e&&s<=t)),o=this.#t.findIndex((e=>e.visible)),r=this.#t.some((e=>!0===e.sortable));await coordinator.write((()=>{LitHtml.render(LitHtml.html`
      ${this.#t.map(((e,t)=>this.renderResizeForCell(e,[t,0])))}
      <div class="wrapping-container" @scroll=${this.onScroll} @focusout=${this.onFocusOut}>
        <table
          aria-rowcount=${this.#i.length}
          aria-colcount=${this.#t.length}
          @keydown=${this.onTableKeyDown}
        >
          <colgroup>
            ${this.#t.map(((e,t)=>{const i=`width: ${calculateColumnWidthPercentageFromWeighting(this.#t,e.id)}%`;return e.visible?LitHtml.html`<col style=${i} data-col-column-index=${t}>`:LitHtml.nothing}))}
          </colgroup>
          <thead>
            <tr @contextmenu=${this.onHeaderContextMenu}>
              ${this.#t.map(((e,t)=>{const i=LitHtml.Directives.classMap({hidden:!e.visible,firstVisibleColumn:t===o}),s=this.tabbableCell(),n=r&&t===s[0]&&0===s[1];return LitHtml.html`<th class=${i}
                  style=${LitHtml.Directives.ifDefined(e.styles?LitHtml.Directives.styleMap(e.styles):void 0)}
                  data-grid-header-cell=${e.id}
                  @focus=${()=>{this.focusCellIfRequired([t,0])}}
                  @click=${()=>{this.onColumnHeaderClick(e,t)}}
                  title=${e.title}
                  aria-sort=${LitHtml.Directives.ifDefined(this.ariaSortForHeader(e))}
                  aria-colindex=${t+1}
                  data-row-index='0'
                  data-col-index=${t}
                  tabindex=${LitHtml.Directives.ifDefined(r?n?"0":"-1":void 0)}
                >${e.titleElement||e.title}</th>`}))}
            </tr>
          </thead>
          <tbody>
            <tr class="filler-row-top padding-row" style=${LitHtml.Directives.styleMap({height:18*e+"px"})}></tr>
            ${LitHtml.Directives.repeat(s,(e=>this.#a.get(e)),(e=>{const t=this.#a.get(e);if(void 0===t)throw new Error("Trying to render a row that has no index in the rowIndexMap");const i=this.tabbableCell(),s=t+1,r=!!this.#C&&s===this.#C[1],n=LitHtml.Directives.classMap({selected:r,hidden:!0===e.hidden});return LitHtml.html`
                <tr
                  aria-rowindex=${t+1}
                  class=${n}
                  style=${LitHtml.Directives.ifDefined(e.styles?LitHtml.Directives.styleMap(e.styles):void 0)}
                  @contextmenu=${this.onBodyRowContextMenu}
                >${this.#t.map(((t,r)=>{const n=getRowEntryForColumnId(e,t.id),l=LitHtml.Directives.classMap({hidden:!t.visible,firstVisibleColumn:r===o}),a=r===i[0]&&s===i[1],c=t.visible?renderCellValue(n):null;return LitHtml.html`<td
                    class=${l}
                    style=${LitHtml.Directives.ifDefined(t.styles?LitHtml.Directives.styleMap(t.styles):void 0)}
                    tabindex=${a?"0":"-1"}
                    aria-colindex=${r+1}
                    title=${n.title||String(n.value).substr(0,20)}
                    data-row-index=${s}
                    data-col-index=${r}
                    data-grid-value-cell-for-column=${t.id}
                    @focus=${()=>{this.focusCellIfRequired([r,s]),this.dispatchEvent(new BodyCellFocusedEvent(n,e))}}
                  >${c}</td>`}))}
              `}))}
            ${this.renderEmptyFillerRow(s.length)}
            <tr class="filler-row-bottom padding-row" style=${LitHtml.Directives.styleMap({height:18*Math.max(0,i.length-t)+"px"})}></tr>
          </tbody>
        </table>
      </div>
      `,this.#e,{host:this})}));const n=this.tabbableCell()[1],l=this.getTableElementForCellUserHasFocused();this.#f&&n>0&&l&&this.focusTableCellInDOM(l),this.scrollToBottomIfRequired(),this.engageResizeObserver(),this.#p&&this.alignScrollHandlers(),this.#o=!1,this.#p=!0,this.#g&&(this.#g=!1,this.render())}}ComponentHelpers.CustomElements.defineComponent("devtools-data-grid",DataGrid);