import*as Common from"../../../core/common/common.js";import*as LitHtml from"../../lit-html/lit-html.js";import*as ComponentHelpers from"../helpers/helpers.js";import linearMemoryInspectorStyles from"./linearMemoryInspector.css.js";const{render:render,html:html}=LitHtml;import{LinearMemoryNavigator}from"./LinearMemoryNavigator.js";import{LinearMemoryValueInterpreter}from"./LinearMemoryValueInterpreter.js";import{VALUE_INTEPRETER_MAX_NUM_BYTES,getDefaultValueTypeMapping}from"./ValueInterpreterDisplayUtils.js";import{formatAddress,parseAddress}from"./LinearMemoryInspectorUtils.js";import{LinearMemoryViewer}from"./LinearMemoryViewer.js";import*as i18n from"../../../core/i18n/i18n.js";const UIStrings={addressHasToBeANumberBetweenSAnd:"Address has to be a number between {PH1} and {PH2}"},str_=i18n.i18n.registerUIStrings("ui/components/linear_memory_inspector/LinearMemoryInspector.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class MemoryRequestEvent extends Event{static eventName="memoryrequest";data;constructor(e,t,s){super(MemoryRequestEvent.eventName),this.data={start:e,end:t,address:s}}}export class AddressChangedEvent extends Event{static eventName="addresschanged";data;constructor(e){super(AddressChangedEvent.eventName),this.data=e}}export class SettingsChangedEvent extends Event{static eventName="settingschanged";data;constructor(e){super(SettingsChangedEvent.eventName),this.data=e}}class AddressHistoryEntry{#e=0;#t;constructor(e,t){if(e<0)throw new Error("Address should be a greater or equal to zero");this.#e=e,this.#t=t}valid(){return!0}reveal(){this.#t(this.#e)}}export class LinearMemoryInspector extends HTMLElement{static litTagName=LitHtml.literal`devtools-linear-memory-inspector-inspector`;#s=this.attachShadow({mode:"open"});#r=new Common.SimpleHistoryManager.SimpleHistoryManager(10);#a=new Uint8Array;#i=0;#n=0;#e=-1;#o="Submitted";#d=`${this.#e}`;#h=4;#m=getDefaultValueTypeMapping();#l=new Set(this.#m.keys());#u="Little Endian";connectedCallback(){this.#s.adoptedStyleSheets=[linearMemoryInspectorStyles]}set data(e){if(e.address<e.memoryOffset||e.address>e.memoryOffset+e.memory.length||e.address<0)throw new Error("Address is out of bounds.");if(e.memoryOffset<0)throw new Error("Memory offset has to be greater or equal to zero.");this.#a=e.memory,this.#i=e.memoryOffset,this.#n=e.outerMemoryLength,this.#m=e.valueTypeModes||this.#m,this.#l=e.valueTypes||this.#l,this.#u=e.endianness||this.#u,this.setAddress(e.address),this.render()}render(){const{start:e,end:t}=this.getPageRangeForAddress(this.#e,this.#h),s="Submitted"===this.#o?formatAddress(this.#e):this.#d,r=this.isValidAddress(s),a=i18nString(UIStrings.addressHasToBeANumberBetweenSAnd,{PH1:formatAddress(0),PH2:formatAddress(this.#n)}),i=r?void 0:a,n=this.#r.canRollback(),o=this.#r.canRollover();render(html`
      <div class="view">
        <${LinearMemoryNavigator.litTagName}
          .data=${{address:s,valid:r,mode:this.#o,error:i,canGoBackInHistory:n,canGoForwardInHistory:o}}
          @refreshrequested=${this.onRefreshRequest}
          @addressinputchanged=${this.onAddressChange}
          @pagenavigation=${this.navigatePage}
          @historynavigation=${this.navigateHistory}></${LinearMemoryNavigator.litTagName}>
        <${LinearMemoryViewer.litTagName}
          .data=${{memory:this.#a.slice(e-this.#i,t-this.#i),address:this.#e,memoryOffset:e,focus:"Submitted"===this.#o}}
          @byteselected=${this.onByteSelected}
          @resize=${this.resize}>
        </${LinearMemoryViewer.litTagName}>
      </div>
      <div class="value-interpreter">
        <${LinearMemoryValueInterpreter.litTagName}
          .data=${{value:this.#a.slice(this.#e-this.#i,this.#e+VALUE_INTEPRETER_MAX_NUM_BYTES).buffer,valueTypes:this.#l,valueTypeModes:this.#m,endianness:this.#u,memoryLength:this.#n}}
          @valuetypetoggled=${this.onValueTypeToggled}
          @valuetypemodechanged=${this.onValueTypeModeChanged}
          @endiannesschanged=${this.onEndiannessChanged}
          @jumptopointeraddress=${this.onJumpToPointerAddress}
          >
        </${LinearMemoryValueInterpreter.litTagName}/>
      </div>
      `,this.#s,{host:this})}onJumpToPointerAddress(e){e.stopPropagation(),this.#o="Submitted";const t=Math.max(0,Math.min(e.data,this.#n-1));this.jumpToAddress(t)}onRefreshRequest(){const{start:e,end:t}=this.getPageRangeForAddress(this.#e,this.#h);this.dispatchEvent(new MemoryRequestEvent(e,t,this.#e))}onByteSelected(e){this.#o="Submitted";const t=Math.max(0,Math.min(e.data,this.#n-1));this.jumpToAddress(t)}createSettings(){return{valueTypes:this.#l,modes:this.#m,endianness:this.#u}}onEndiannessChanged(e){this.#u=e.data,this.dispatchEvent(new SettingsChangedEvent(this.createSettings())),this.render()}isValidAddress(e){const t=parseAddress(e);return void 0!==t&&t>=0&&t<this.#n}onAddressChange(e){const{address:t,mode:s}=e.data,r=this.isValidAddress(t),a=parseAddress(t);if(this.#d=t,void 0!==a&&r)return this.#o=s,void this.jumpToAddress(a);this.#o="Submitted"!==s||r?"Edit":"InvalidSubmit",this.render()}onValueTypeToggled(e){const{type:t,checked:s}=e.data;s?this.#l.add(t):this.#l.delete(t),this.dispatchEvent(new SettingsChangedEvent(this.createSettings())),this.render()}onValueTypeModeChanged(e){e.stopImmediatePropagation();const{type:t,mode:s}=e.data;this.#m.set(t,s),this.dispatchEvent(new SettingsChangedEvent(this.createSettings())),this.render()}navigateHistory(e){return"Forward"===e.data?this.#r.rollover():this.#r.rollback()}navigatePage(e){const t="Forward"===e.data?this.#e+this.#h:this.#e-this.#h,s=Math.max(0,Math.min(t,this.#n-1));this.jumpToAddress(s)}jumpToAddress(e){e<0||e>=this.#n?console.warn(`Specified address is out of bounds: ${e}`):(this.setAddress(e),this.update())}getPageRangeForAddress(e,t){const s=Math.floor(e/t)*t;return{start:s,end:Math.min(s+t,this.#n)}}resize(e){this.#h=e.data,this.update()}update(){const{start:e,end:t}=this.getPageRangeForAddress(this.#e,this.#h);e<this.#i||t>this.#i+this.#a.length?this.dispatchEvent(new MemoryRequestEvent(e,t,this.#e)):this.render()}setAddress(e){if(this.#e===e)return;const t=new AddressHistoryEntry(e,(()=>this.jumpToAddress(e)));this.#r.push(t),this.#e=e,this.dispatchEvent(new AddressChangedEvent(this.#e))}}ComponentHelpers.CustomElements.defineComponent("devtools-linear-memory-inspector-inspector",LinearMemoryInspector);