import*as i18n from"../../../core/i18n/i18n.js";import inspectorCommonStyles from"../../legacy/inspectorCommon.css.js";import*as LitHtml from"../../lit-html/lit-html.js";import*as ComponentHelpers from"../helpers/helpers.js";import*as IconButton from"../icon_button/icon_button.js";import valueInterpreterDisplayStyles from"./valueInterpreterDisplay.css.js";import{format,getDefaultValueTypeMapping,getPointerAddress,isNumber,isPointer,isValidMode,VALUE_TYPE_MODE_LIST}from"./ValueInterpreterDisplayUtils.js";const UIStrings={unsignedValue:"`Unsigned` value",changeValueTypeMode:"Change mode",signedValue:"`Signed` value",jumpToPointer:"Jump to address",addressOutOfRange:"Address out of memory range"},str_=i18n.i18n.registerUIStrings("ui/components/linear_memory_inspector/ValueInterpreterDisplay.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),{render:render,html:html}=LitHtml,SORTED_VALUE_TYPES=Array.from(getDefaultValueTypeMapping().keys());export class ValueTypeModeChangedEvent extends Event{static eventName="valuetypemodechanged";data;constructor(e,t){super(ValueTypeModeChangedEvent.eventName,{composed:!0}),this.data={type:e,mode:t}}}export class JumpToPointerAddressEvent extends Event{static eventName="jumptopointeraddress";data;constructor(e){super(JumpToPointerAddressEvent.eventName,{composed:!0}),this.data=e}}export class ValueInterpreterDisplay extends HTMLElement{static litTagName=LitHtml.literal`devtools-linear-memory-inspector-interpreter-display`;#e=this.attachShadow({mode:"open"});#t="Little Endian";#n=new ArrayBuffer(0);#s=new Set;#r=getDefaultValueTypeMapping();#i=0;constructor(){super(),this.#e.adoptedStyleSheets=[inspectorCommonStyles]}connectedCallback(){this.#e.adoptedStyleSheets=[valueInterpreterDisplayStyles]}set data(e){this.#n=e.buffer,this.#t=e.endianness,this.#s=e.valueTypes,this.#i=e.memoryLength,e.valueTypeModes&&e.valueTypeModes.forEach(((e,t)=>{isValidMode(t,e)&&this.#r.set(t,e)})),this.render()}render(){render(html`
      <div class="value-types">
        ${SORTED_VALUE_TYPES.map((e=>this.#s.has(e)?this.showValue(e):""))}
      </div>
    `,this.#e,{host:this})}showValue(e){if(isNumber(e))return this.renderNumberValues(e);if(isPointer(e))return this.renderPointerValue(e);throw new Error(`No known way to format ${e}`)}renderPointerValue(e){const t=this.parse({type:e,signed:!1}),n=getPointerAddress(e,this.#n,this.#t),s=Number.isNaN(n)||BigInt(n)>=BigInt(this.#i),r=i18nString(s?UIStrings.addressOutOfRange:UIStrings.jumpToPointer),i=s?"var(--color-text-secondary)":"var(--color-primary)";return html`
      <span class="value-type-cell-no-mode value-type-cell">${i18n.i18n.lockedString(e)}</span>
      <div class="value-type-cell">
        <div class="value-type-value-with-link" data-value="true">
        <span>${t}</span>
          ${html`
              <button class="jump-to-button" data-jump="true" title=${r} ?disabled=${s}
                @click=${this.onJumpToAddressClicked.bind(this,Number(n))}>
                <${IconButton.Icon.Icon.litTagName} .data=${{iconName:"link_icon",color:i,width:"14px"}}>
                </${IconButton.Icon.Icon.litTagName}>
              </button>`}
        </div>
      </div>
    `}onJumpToAddressClicked(e){this.dispatchEvent(new JumpToPointerAddressEvent(e))}renderNumberValues(e){return html`
      <span class="value-type-cell">${i18n.i18n.lockedString(e)}</span>
      <div>
        <select title=${i18nString(UIStrings.changeValueTypeMode)}
          data-mode-settings="true"
          class="chrome-select"
          style="border: none; background-color: transparent; cursor: pointer; color: var(--color-text-secondary);"
          @change=${this.onValueTypeModeChange.bind(this,e)}>
            ${VALUE_TYPE_MODE_LIST.filter((t=>isValidMode(e,t))).map((t=>html`
                <option value=${t} .selected=${this.#r.get(e)===t}>${i18n.i18n.lockedString(t)}
                </option>`))}
        </select>
      </div>
      ${this.renderSignedAndUnsigned(e)}
    `}renderSignedAndUnsigned(e){const t=this.parse({type:e,signed:!1}),n=this.parse({type:e,signed:!0}),s=this.#r.get(e),r=n!==t&&"hex"!==s&&"oct"!==s,i=html`<span class="value-type-cell"  title=${i18nString(UIStrings.unsignedValue)} data-value="true">${t}</span>`;if(!r)return i;const a="Integer 32-bit"===e||"Integer 64-bit"===e,o=html`<span data-value="true" title=${i18nString(UIStrings.signedValue)}>${n}</span>`;return a?html`
        <div class="value-type-cell">
          ${i}
          ${o}
        </div>
        `:html`
      <div class="value-type-cell" style="flex-direction: row;">
        ${i}
        <span class="signed-divider"></span>
        ${o}
      </div>
    `}onValueTypeModeChange(e,t){t.preventDefault();const n=t.target.value;this.dispatchEvent(new ValueTypeModeChangedEvent(e,n))}parse(e){const t=this.#r.get(e.type);return format({buffer:this.#n,type:e.type,endianness:this.#t,signed:e.signed||!1,mode:t})}}ComponentHelpers.CustomElements.defineComponent("devtools-linear-memory-inspector-interpreter-display",ValueInterpreterDisplay);