import*as Platform from"../../../core/platform/platform.js";import*as LitHtml from"../../lit-html/lit-html.js";import*as CodeHighlighter from"../code_highlighter/code_highlighter.js";import*as ComponentHelpers from"../helpers/helpers.js";import*as Coordinator from"../render_coordinator/render_coordinator.js";import treeOutlineStyles from"./treeOutline.css.js";import{findNextNodeForTreeOutlineKeyboardNavigation,getNodeChildren,getPathToTreeNode,isExpandableNode,trackDOMNodeToTreeNode}from"./TreeOutlineUtils.js";const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();export function defaultRenderer(e){return LitHtml.html`${e.treeNodeData}`}export class ItemSelectedEvent extends Event{static eventName="itemselected";data;constructor(e){super(ItemSelectedEvent.eventName,{bubbles:!0,composed:!0}),this.data={node:e}}}export class ItemMouseOverEvent extends Event{static eventName="itemmouseover";data;constructor(e){super(ItemMouseOverEvent.eventName,{bubbles:!0,composed:!0}),this.data={node:e}}}export class ItemMouseOutEvent extends Event{static eventName="itemmouseout";data;constructor(e){super(ItemMouseOutEvent.eventName,{bubbles:!0,composed:!0}),this.data={node:e}}}export class TreeOutline extends HTMLElement{static litTagName=LitHtml.literal`devtools-tree-outline`;#e=this.attachShadow({mode:"open"});#t=[];#o=new Map;#d=new WeakMap;#r=!1;#n=null;#s=null;#i=(e,t)=>("string"!=typeof e.treeNodeData&&console.warn(`The default TreeOutline renderer simply stringifies its given value. You passed in ${JSON.stringify(e.treeNodeData,null,2)}. Consider providing a different defaultRenderer that can handle nodes of this type.`),LitHtml.html`${String(e.treeNodeData)}`);#a;#l=!1;#h=!1;static get observedAttributes(){return["nowrap","toplevelbordercolor"]}attributeChangedCallback(e,t,o){switch(e){case"nowrap":this.setNodeKeyNoWrapCSSVariable(o);break;case"toplevelbordercolor":this.setTopLevelNodeBorderColorCSSVariable(o)}}connectedCallback(){this.setTopLevelNodeBorderColorCSSVariable(this.getAttribute("toplevelbordercolor")),this.setNodeKeyNoWrapCSSVariable(this.getAttribute("nowrap")),this.#e.adoptedStyleSheets=[treeOutlineStyles,CodeHighlighter.Style.default]}get data(){return{tree:this.#t,defaultRenderer:this.#i}}set data(e){this.#i=e.defaultRenderer,this.#t=e.tree,this.#a=e.filter,this.#r||(this.#s=this.#t[0]),this.render()}async expandRecursively(e=2){await Promise.all(this.#t.map((t=>this.expandAndRecurse(t,0,e)))),await this.render()}async collapseAllNodes(){this.#o.clear(),await this.render()}async expandToAndSelectTreeNode(e){return this.expandToAndSelectTreeNodeId(e.id)}async expandToAndSelectTreeNodeId(e){const t=await getPathToTreeNode(this.#t,e);if(null===t)throw new Error(`Could not find node with id ${e} in the tree.`);t.forEach(((e,o)=>{o<t.length-1&&this.setNodeExpandedState(e,!0)})),this.#n=e,await this.render()}expandNodeIds(e){return e.forEach((e=>this.#o.set(e,!0))),this.render()}focusNodeId(e){return this.#n=e,this.render()}async collapseChildrenOfNode(e){const t=this.#d.get(e);t&&(await this.recursivelyCollapseTreeNodeChildren(t),await this.render())}setNodeKeyNoWrapCSSVariable(e){ComponentHelpers.SetCSSProperty.set(this,"--override-key-whitespace-wrapping",null!==e?"nowrap":"initial")}setTopLevelNodeBorderColorCSSVariable(e){ComponentHelpers.SetCSSProperty.set(this,"--override-top-node-border",e?`1px solid ${e}`:"")}async recursivelyCollapseTreeNodeChildren(e){if(!isExpandableNode(e)||!this.nodeIsExpanded(e))return;const t=await this.fetchNodeChildren(e),o=Promise.all(t.map((e=>this.recursivelyCollapseTreeNodeChildren(e))));await o,this.setNodeExpandedState(e,!1)}getSelectedTreeNode(){if(!this.#s)throw new Error("getSelectedNode was called but selectedTreeNode is null");return this.#s}async fetchNodeChildren(e){const t=await getNodeChildren(e);if(!this.#a)return t;const o=[];for(const e of t){const t=this.#a(e.treeNodeData);if("SHOW"===t||this.isSelectedNode(e)||e.id===this.#n)o.push(e);else if("FLATTEN"===t&&isExpandableNode(e)){const t=await this.fetchNodeChildren(e);o.push(...t)}}return o}setNodeExpandedState(e,t){this.#o.set(e.id,t)}nodeIsExpanded(e){return this.#o.get(e.id)||!1}async expandAndRecurse(e,t,o){if(!isExpandableNode(e))return;if(this.setNodeExpandedState(e,!0),t===o||!isExpandableNode(e))return;const d=await this.fetchNodeChildren(e);await Promise.all(d.map((e=>this.expandAndRecurse(e,t+1,o))))}onArrowClick(e){return t=>{t.stopPropagation(),isExpandableNode(e)&&(this.setNodeExpandedState(e,!this.nodeIsExpanded(e)),this.render())}}onNodeClick(e){e.stopPropagation();const t=null!==this.getAttribute("clickabletitle"),o=e.currentTarget,d=this.#d.get(o);t&&d&&isExpandableNode(d)&&this.setNodeExpandedState(d,!this.nodeIsExpanded(d)),this.focusTreeNode(o)}async focusTreeNode(e){const t=this.#d.get(e);t&&(this.#s=t,await this.render(),this.dispatchEvent(new ItemSelectedEvent(t)),coordinator.write("DOMNode focus",(()=>{e.focus()})))}processHomeAndEndKeysNavigation(e){if("Home"===e){const e=this.#e.querySelector('ul[role="tree"] > li[role="treeitem"]');e&&this.focusTreeNode(e)}else if("End"===e){const e=this.#e.querySelectorAll('li[role="treeitem"]'),t=e[e.length-1];t&&this.focusTreeNode(t)}}async processArrowKeyNavigation(e,t){const o=this.#d.get(t);if(!o)return;const d=findNextNodeForTreeOutlineKeyboardNavigation({currentDOMNode:t,currentTreeNode:o,direction:e,setNodeExpandedState:(e,t)=>this.setNodeExpandedState(e,t)});await this.focusTreeNode(d)}processEnterOrSpaceNavigation(e){const t=this.#d.get(e);if(t&&isExpandableNode(t)){const e=this.nodeIsExpanded(t);this.setNodeExpandedState(t,!e),this.render()}}async onTreeKeyDown(e){if(!(e.target instanceof HTMLLIElement))throw new Error("event.target was not an <li> element");"Home"===e.key||"End"===e.key?(e.preventDefault(),this.processHomeAndEndKeysNavigation(e.key)):Platform.KeyboardUtilities.keyIsArrowKey(e.key)?(e.preventDefault(),await this.processArrowKeyNavigation(e.key,e.target)):"Enter"!==e.key&&" "!==e.key||(e.preventDefault(),this.processEnterOrSpaceNavigation(e.target))}focusPendingNode(e){this.#n=null,this.focusTreeNode(e)}isSelectedNode(e){return!!this.#s&&e.id===this.#s.id}renderNode(e,{depth:t,setSize:o,positionInSet:d}){let r;const n=this.nodeIsExpanded(e);if(isExpandableNode(e)&&n){const o=this.fetchNodeChildren(e).then((e=>e.map(((o,d)=>this.renderNode(o,{depth:t+1,setSize:e.length,positionInSet:d})))));r=LitHtml.html`<ul role="group">${LitHtml.Directives.until(o)}</ul>`}else r=LitHtml.nothing;const s=this.getSelectedTreeNode()===e?0:-1,i=LitHtml.Directives.classMap({expanded:isExpandableNode(e)&&n,parent:isExpandableNode(e),selected:this.isSelectedNode(e),"is-top-level":0===t}),a=LitHtml.Directives.ifDefined(isExpandableNode(e)?String(n):void 0);let l;return l=e.renderer?e.renderer(e,{isExpanded:n}):this.#i(e,{isExpanded:n}),LitHtml.html`
      <li role="treeitem"
        tabindex=${s}
        aria-setsize=${o}
        aria-expanded=${a}
        aria-level=${t+1}
        aria-posinset=${d+1}
        class=${i}
        @click=${this.onNodeClick}
        track-dom-node-to-tree-node=${trackDOMNodeToTreeNode(this.#d,e)}
        on-render=${ComponentHelpers.Directives.nodeRenderedCallback((t=>{t instanceof HTMLLIElement&&this.#n&&e.id===this.#n&&this.focusPendingNode(t)}))}
      >
        <span class="arrow-and-key-wrapper"
          @mouseover=${()=>{this.dispatchEvent(new ItemMouseOverEvent(e))}}
          @mouseout=${()=>{this.dispatchEvent(new ItemMouseOutEvent(e))}}
        >
          <span class="arrow-icon" @click=${this.onArrowClick(e)}>
          </span>
          <span class="tree-node-key" data-node-key=${e.treeNodeData}>${l}</span>
        </span>
        ${r}
      </li>
    `}async render(){if(!this.#l)return this.#l=!0,await coordinator.write("TreeOutline render",(()=>{LitHtml.render(LitHtml.html`
      <div class="wrapping-container">
      <ul role="tree" @keydown=${this.onTreeKeyDown}>
        ${this.#t.map(((e,t)=>this.renderNode(e,{depth:0,setSize:this.#t.length,positionInSet:t})))}
      </ul>
      </div>
      `,this.#e,{host:this})})),this.#r=!0,this.#l=!1,this.#h?(this.#h=!1,this.render()):void 0;this.#h=!0}}ComponentHelpers.CustomElements.defineComponent("devtools-tree-outline",TreeOutline);