import*as ComponentHelpers from"../../../components/helpers/helpers.js";import*as LitHtml from"../../../lit-html/lit-html.js";import pieChartStyles from"./pieChart.css.js";const{render:render,html:html,svg:svg}=LitHtml;import*as i18n from"../../../../core/i18n/i18n.js";const UIStrings={total:"Total"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/perf_ui/PieChart.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class PieChart extends HTMLElement{static litTagName=LitHtml.literal`devtools-perf-piechart`;shadow=this.attachShadow({mode:"open"});chartName="";size=0;formatter=t=>String(t);showLegend=!1;total=0;slices=[];totalSelected=!0;sliceSelected=-1;innerR=.618;lastAngle=-Math.PI/2;connectedCallback(){this.shadow.adoptedStyleSheets=[pieChartStyles]}set data(t){this.chartName=t.chartName,this.size=t.size,this.formatter=t.formatter,this.showLegend=t.showLegend,this.total=t.total,this.slices=t.slices,this.render()}render(){this.lastAngle=-Math.PI/2;const t=html`
      <div class="root" role="group" @keydown=${this.onKeyDown} aria-label=${this.chartName}>
        <div class="chart-root" style="width: ${this.size}px; height: ${this.size}px;">
          ${svg`
          <svg>
          <g transform="scale(${this.size/2}) translate(1, 1) scale(0.99, 0.99)">
            <circle r="1" stroke="hsl(0, 0%, 80%)" fill="transparent" stroke-width=${1/this.size}></circle>
            <circle r=${this.innerR} stroke="hsl(0, 0%, 80%)" fill="transparent" stroke-width=${1/this.size}></circle>
            ${this.slices.map(((t,e)=>{const s=this.sliceSelected===e,i=s&&!this.showLegend?"0":"-1";return svg`<path class="slice ${s?"selected":""}"
                  @click=${this.onSliceClicked(e)} tabIndex=${i}
                  fill=${t.color} d=${this.getPathStringForSlice(t)}
                  aria-label=${t.title} id=${s?"selectedSlice":""}></path>`}))}
            <!-- This is so that the selected slice is re-drawn on top, to avoid re-ordering slices
            just to render them properly. -->
            <use href="#selectedSlice" />
            </g>
          </svg>
          `}
          <div class="pie-chart-foreground">
            <div class="pie-chart-total ${this.totalSelected?"selected":""}" @click=${this.selectTotal}
                tabIndex=${this.totalSelected&&!this.showLegend?"1":"-1"}>
              ${this.total?this.formatter(this.total):""}
            </div>
          </div>
        </div>
        ${this.showLegend?html`
        <div class="pie-chart-legend">
          ${this.slices.map(((t,e)=>{const s=this.sliceSelected===e;return html`
              <div class="pie-chart-legend-row ${s?"selected":""}"
                  @click=${this.onSliceClicked(e)} tabIndex=${s?"0":"-1"}>
                <div class="pie-chart-size">${this.formatter(t.value)}</div>
                <div class="pie-chart-swatch" style="background-color: ${t.color};"></div>
                <div class="pie-chart-name">${t.title}</div>
              </div>`}))}
          <div class="pie-chart-legend-row ${this.totalSelected?"selected":""}"
              @click=${this.selectTotal} tabIndex=${this.totalSelected?"0":"-1"}>
            <div class="pie-chart-size">${this.formatter(this.total)}</div>
            <div class="pie-chart-swatch pie-chart-empty-swatch"></div>
            <div class="pie-chart-name">${i18nString(UIStrings.total)}</div>
          </div>
        </div>
        `:""}
    `;render(t,this.shadow,{host:this})}onSliceClicked(t){return()=>{this.selectSlice(t)}}selectSlice(t){this.totalSelected=!1,this.sliceSelected=t,this.render()}selectTotal(){this.totalSelected=!0,this.sliceSelected=-1,this.render()}selectAndFocusTotal(){this.selectTotal();const t=this.shadow.querySelector(".pie-chart-legend > :last-child");t&&t.focus()}selectAndFocusSlice(t){this.selectSlice(t);const e=this.shadow.querySelector(`.pie-chart-legend > :nth-child(${t+1})`);e&&e.focus()}focusNextElement(){this.totalSelected?this.selectAndFocusSlice(0):this.sliceSelected===this.slices.length-1?this.selectAndFocusTotal():this.selectAndFocusSlice(this.sliceSelected+1)}focusPreviousElement(){this.totalSelected?this.selectAndFocusSlice(this.slices.length-1):0===this.sliceSelected?this.selectAndFocusTotal():this.selectAndFocusSlice(this.sliceSelected-1)}onKeyDown(t){let e=!1;"ArrowDown"===t.key?(this.focusNextElement(),e=!0):"ArrowUp"===t.key&&(this.focusPreviousElement(),e=!0),e&&(t.stopImmediatePropagation(),t.preventDefault())}getPathStringForSlice(t){let e=t.value/this.total*2*Math.PI;if(!isFinite(e))return;e=Math.min(e,2*Math.PI*.9999);const s=Math.cos(this.lastAngle),i=Math.sin(this.lastAngle);this.lastAngle+=e;const l=Math.cos(this.lastAngle),c=Math.sin(this.lastAngle),h=this.innerR,a=l*h,r=c*h,o=s*h,n=i*h,d=e>Math.PI?1:0;return`M${s},${i} A1,1,0,${d},1,${l},${c} L${a},${r} A${h},${h},0,${d},0,${o},${n} Z`}}ComponentHelpers.CustomElements.defineComponent("devtools-perf-piechart",PieChart);