import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";export class ParsedURL{isValid;url;scheme;user;host;port;path;queryParams;fragment;folderPathComponents;lastPathComponent;blobInnerScheme;#t;#s;constructor(t){this.isValid=!1,this.url=t,this.scheme="",this.user="",this.host="",this.port="",this.path="",this.queryParams="",this.fragment="",this.folderPathComponents="",this.lastPathComponent="";const s=this.url.startsWith("blob:"),e=(s?t.substring(5):t).match(ParsedURL.urlRegex());if(e)this.isValid=!0,s?(this.blobInnerScheme=e[2].toLowerCase(),this.scheme="blob"):this.scheme=e[2].toLowerCase(),this.user=e[3],this.host=e[4],this.port=e[5],this.path=e[6]||"/",this.queryParams=e[7]||"",this.fragment=e[8];else{if(this.url.startsWith("data:"))return void(this.scheme="data");if(this.url.startsWith("blob:"))return void(this.scheme="blob");if("about:blank"===this.url)return void(this.scheme="about");this.path=this.url}const r=this.path.lastIndexOf("/");-1!==r?(this.folderPathComponents=this.path.substring(0,r),this.lastPathComponent=this.path.substring(r+1)):this.lastPathComponent=this.path}static fromString(t){const s=new ParsedURL(t.toString());return s.isValid?s:null}static rawPathToUrlString(t){let s=t;return s=s.replace(/\\/g,"/"),s.startsWith("file://")||(s=s.startsWith("/")?"file://"+s:"file:///"+s),s}static capFilePrefix(t,s){return console.assert(t.startsWith("file://"),"This must be a file URL."),s?t.substr("file:///".length).replace(/\//g,"\\"):t.substr("file://".length)}static urlWithoutHash(t){const s=t.indexOf("#");return-1!==s?t.substr(0,s):t}static urlRegex(){if(ParsedURL.urlRegexInstance)return ParsedURL.urlRegexInstance;return ParsedURL.urlRegexInstance=new RegExp("^("+/([A-Za-z][A-Za-z0-9+.-]*):\/\//.source+/(?:([A-Za-z0-9\-._~%!$&'()*+,;=:]*)@)?/.source+/((?:\[::\d?\])|(?:[^\s\/:]*))/.source+/(?::([\d]+))?/.source+")"+/(\/[^#?]*)?/.source+/(?:\?([^#]*))?/.source+/(?:#(.*))?/.source+"$"),ParsedURL.urlRegexInstance}static extractPath(t){const s=this.fromString(t);return s?s.path:""}static extractOrigin(t){const s=this.fromString(t);return s?s.securityOrigin():""}static extractExtension(t){const s=(t=ParsedURL.urlWithoutHash(t)).indexOf("?");-1!==s&&(t=t.substr(0,s));const e=t.lastIndexOf("/");-1!==e&&(t=t.substr(e+1));const r=t.lastIndexOf(".");if(-1!==r){const s=(t=t.substr(r+1)).indexOf("%");return-1!==s?t.substr(0,s):t}return""}static extractName(t){let s=t.lastIndexOf("/");const e=-1!==s?t.substr(s+1):t;return s=e.indexOf("?"),s<0?e:e.substr(0,s)}static completeURL(t,s){const e=s.trim();if(e.startsWith("data:")||e.startsWith("blob:")||e.startsWith("javascript:")||e.startsWith("mailto:"))return s;const r=this.fromString(e);if(r&&r.scheme)return e;const i=this.fromString(t);if(!i)return null;if(i.isDataURL())return s;if(s.length>1&&"/"===s.charAt(0)&&"/"===s.charAt(1))return i.scheme+":"+s;const a=i.securityOrigin(),n=i.path,h=i.queryParams?"?"+i.queryParams:"";if(!s.length)return a+n+h;if("#"===s.charAt(0))return a+n+h+s;if("?"===s.charAt(0))return a+n+s;const o=s.match(/^[^#?]*/);if(!o||!s.length)throw new Error("Invalid href");let l=o[0];const u=s.substring(l.length);return"/"!==l.charAt(0)&&(l=i.folderPathComponents+"/"+l),a+Root.Runtime.Runtime.normalizePath(l)+u}static splitLineAndColumn(t){const s=t.match(ParsedURL.urlRegex());let e="",r=t;s&&(e=s[1],r=t.substring(s[1].length));const i=/(?::(\d+))?(?::(\d+))?$/.exec(r);let a,n;if(console.assert(Boolean(i)),!i)return{url:t,lineNumber:0,columnNumber:0};"string"==typeof i[1]&&(a=parseInt(i[1],10),a=isNaN(a)?void 0:a-1),"string"==typeof i[2]&&(n=parseInt(i[2],10),n=isNaN(n)?void 0:n-1);let h=e+r.substring(0,r.length-i[0].length);if(void 0===i[1]&&void 0===i[2]){const t=/wasm-function\[\d+\]:0x([a-z0-9]+)$/g.exec(r);t&&"string"==typeof t[1]&&(h=ParsedURL.removeWasmFunctionInfoFromURL(h),n=parseInt(t[1],16),n=isNaN(n)?void 0:n)}return{url:h,lineNumber:a,columnNumber:n}}static removeWasmFunctionInfoFromURL(t){const s=t.search(/:wasm-function\[\d+\]/);return-1===s?t:t.substring(0,s)}static isRelativeURL(t){return!/^[A-Za-z][A-Za-z0-9+.-]*:/.test(t)}get displayName(){return this.#t?this.#t:this.isDataURL()?this.dataURLDisplayName():this.isBlobURL()||this.isAboutBlank()?this.url:(this.#t=this.lastPathComponent,this.#t||(this.#t=(this.host||"")+"/"),"/"===this.#t&&(this.#t=this.url),this.#t)}dataURLDisplayName(){return this.#s?this.#s:this.isDataURL()?(this.#s=Platform.StringUtilities.trimEndWithMaxLength(this.url,20),this.#s):""}isAboutBlank(){return"about:blank"===this.url}isDataURL(){return"data"===this.scheme}isHttpOrHttps(){return"http"===this.scheme||"https"===this.scheme}isBlobURL(){return this.url.startsWith("blob:")}lastPathComponentWithFragment(){return this.lastPathComponent+(this.fragment?"#"+this.fragment:"")}domain(){return this.isDataURL()?"data:":this.host+(this.port?":"+this.port:"")}securityOrigin(){if(this.isDataURL())return"data:";return(this.isBlobURL()?this.blobInnerScheme:this.scheme)+"://"+this.domain()}urlWithoutScheme(){return this.scheme&&this.url.startsWith(this.scheme+"://")?this.url.substring(this.scheme.length+3):this.url}static urlRegexInstance=null}