import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import{FrontendMessageSource,FrontendMessageType}from"./ConsoleModelTypes.js";export{FrontendMessageSource,FrontendMessageType}from"./ConsoleModelTypes.js";import{CPUProfilerModel,Events as CPUProfilerModelEvents}from"./CPUProfilerModel.js";import{Events as DebuggerModelEvents}from"./DebuggerModel.js";import{LogModel}from"./LogModel.js";import{RemoteObject}from"./RemoteObject.js";import{Events as ResourceTreeModelEvents,ResourceTreeModel}from"./ResourceTreeModel.js";import{Events as RuntimeModelEvents,RuntimeModel}from"./RuntimeModel.js";import{TargetManager}from"./TargetManager.js";const UIStrings={navigatedToS:"Navigated to {PH1}",profileSStarted:"Profile ''{PH1}'' started.",profileSFinished:"Profile ''{PH1}'' finished.",failedToSaveToTempVariable:"Failed to save to temp variable."},str_=i18n.i18n.registerUIStrings("core/sdk/ConsoleModel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let settingsInstance;export class ConsoleModel extends Common.ObjectWrapper.ObjectWrapper{#e;#t;#s;#n;#r;#o;#i;constructor(){super(),this.#e=[],this.#t=new Map,this.#s=0,this.#n=0,this.#r=0,this.#o=0,this.#i=new WeakMap,TargetManager.instance().observeTargets(this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return settingsInstance&&!t||(settingsInstance=new ConsoleModel),settingsInstance}targetAdded(e){const t=e.model(ResourceTreeModel);if(!t||t.cachedResourcesLoaded())return void this.initTarget(e);const s=t.addEventListener(ResourceTreeModelEvents.CachedResourcesLoaded,(()=>{Common.EventTarget.removeEventListeners([s]),this.initTarget(e)}))}initTarget(e){const t=[],s=e.model(CPUProfilerModel);s&&(t.push(s.addEventListener(CPUProfilerModelEvents.ConsoleProfileStarted,this.consoleProfileStarted.bind(this,s))),t.push(s.addEventListener(CPUProfilerModelEvents.ConsoleProfileFinished,this.consoleProfileFinished.bind(this,s))));const n=e.model(ResourceTreeModel);n&&!e.parentTarget()&&t.push(n.addEventListener(ResourceTreeModelEvents.MainFrameNavigated,this.mainFrameNavigated,this));const r=e.model(RuntimeModel);r&&(t.push(r.addEventListener(RuntimeModelEvents.ExceptionThrown,this.exceptionThrown.bind(this,r))),t.push(r.addEventListener(RuntimeModelEvents.ExceptionRevoked,this.exceptionRevoked.bind(this,r))),t.push(r.addEventListener(RuntimeModelEvents.ConsoleAPICalled,this.consoleAPICalled.bind(this,r))),e.parentTarget()||t.push(r.debuggerModel().addEventListener(DebuggerModelEvents.GlobalObjectCleared,this.clearIfNecessary,this)),t.push(r.addEventListener(RuntimeModelEvents.QueryObjectRequested,this.queryObjectRequested.bind(this,r)))),this.#i.set(e,t)}targetRemoved(e){const t=e.model(RuntimeModel);t&&this.#t.delete(t),Common.EventTarget.removeEventListeners(this.#i.get(e)||[])}async evaluateCommandInConsole(e,t,s,n){const r=await e.evaluate({expression:s,objectGroup:"console",includeCommandLineAPI:n,silent:!1,returnByValue:!1,generatePreview:!0,replMode:!0,allowUnsafeEvalBlockedByCSP:!1,disableBreaks:void 0,throwOnSideEffect:void 0,timeout:void 0},Common.Settings.Settings.instance().moduleSetting("consoleUserActivationEval").get(),!1);Host.userMetrics.actionTaken(Host.UserMetrics.Action.ConsoleEvaluated),"error"in r||(await Common.Console.Console.instance().showPromise(),this.dispatchEventToListeners(Events.CommandEvaluated,{result:r.object,commandMessage:t,exceptionDetails:r.exceptionDetails}))}addCommandMessage(e,t){const s=new ConsoleMessage(e.runtimeModel,"javascript",null,t,{type:FrontendMessageType.Command});return s.setExecutionContextId(e.id),this.addMessage(s),s}addMessage(e){e.setPageLoadSequenceNumber(this.#o),e.source===FrontendMessageSource.ConsoleAPI&&"clear"===e.type&&this.clearIfNecessary(),this.#e.push(e);const t=e.runtimeModel(),s=e.getExceptionId();if(s&&t){let n=this.#t.get(t);n||(n=new Map,this.#t.set(t,n)),n.set(s,e)}this.incrementErrorWarningCount(e),this.dispatchEventToListeners(Events.MessageAdded,e)}exceptionThrown(e,t){const s=t.data,n=extractExceptionMetaData(s.details.exceptionMetaData),r=ConsoleMessage.fromException(e,s.details,void 0,s.timestamp,void 0,n);r.setExceptionId(s.details.exceptionId),this.addMessage(r)}exceptionRevoked(e,t){const s=t.data,n=this.#t.get(e),r=n?n.get(s):null;r&&(this.#n--,r.level="verbose",this.dispatchEventToListeners(Events.MessageUpdated,r))}consoleAPICalled(e,t){const s=t.data;let n="info";"debug"===s.type?n="verbose":"error"===s.type||"assert"===s.type?n="error":"warning"===s.type?n="warning":"info"!==s.type&&"log"!==s.type||(n="info");let r="";s.args.length&&s.args[0].unserializableValue?r=s.args[0].unserializableValue:!s.args.length||"object"==typeof s.args[0].value&&null!==s.args[0].value?s.args.length&&s.args[0].description&&(r=s.args[0].description):r=String(s.args[0].value);const o=s.stackTrace&&s.stackTrace.callFrames.length?s.stackTrace.callFrames[0]:null,i={type:s.type,url:o?.url,line:o?.lineNumber,column:o?.columnNumber,parameters:s.args,stackTrace:s.stackTrace,timestamp:s.timestamp,executionContextId:s.executionContextId,context:s.context},a=new ConsoleMessage(e,FrontendMessageSource.ConsoleAPI,n,r,i);this.addMessage(a)}queryObjectRequested(e,t){const{objects:s,executionContextId:n}=t.data,r={type:FrontendMessageType.QueryObjectResult,parameters:[s],executionContextId:n},o=new ConsoleMessage(e,FrontendMessageSource.ConsoleAPI,"info","",r);this.addMessage(o)}clearIfNecessary(){Common.Settings.Settings.instance().moduleSetting("preserveConsoleLog").get()||this.clear(),++this.#o}mainFrameNavigated(e){Common.Settings.Settings.instance().moduleSetting("preserveConsoleLog").get()&&Common.Console.Console.instance().log(i18nString(UIStrings.navigatedToS,{PH1:e.data.url}))}consoleProfileStarted(e,t){const{data:s}=t;this.addConsoleProfileMessage(e,"profile",s.scriptLocation,i18nString(UIStrings.profileSStarted,{PH1:s.title}))}consoleProfileFinished(e,t){const{data:s}=t;this.addConsoleProfileMessage(e,"profileEnd",s.scriptLocation,i18nString(UIStrings.profileSFinished,{PH1:s.title}))}addConsoleProfileMessage(e,t,s,n){const r=s.script(),o=[{functionName:"",scriptId:s.scriptId,url:r?r.contentURL():"",lineNumber:s.lineNumber,columnNumber:s.columnNumber||0}];this.addMessage(new ConsoleMessage(e.runtimeModel(),FrontendMessageSource.ConsoleAPI,"info",n,{type:t,stackTrace:{callFrames:o}}))}incrementErrorWarningCount(e){if("violation"!==e.source)switch(e.level){case"warning":this.#s++;break;case"error":this.#n++}else this.#r++}messages(){return this.#e}requestClearMessages(){for(const e of TargetManager.instance().models(LogModel))e.requestClear();for(const e of TargetManager.instance().models(RuntimeModel))e.discardConsoleEntries();this.clear()}clear(){this.#e=[],this.#t.clear(),this.#n=0,this.#s=0,this.#r=0,this.dispatchEventToListeners(Events.ConsoleCleared)}errors(){return this.#n}warnings(){return this.#s}violations(){return this.#r}async saveToTempVariable(e,t){if(!t||!e)return void i(null);const s=e,n=await s.globalObject("",!1);if("error"in n||Boolean(n.exceptionDetails)||!n.object)return void i("object"in n&&n.object||null);const r=n.object,o=await r.callFunction((function(e){const t="temp";let s=1;for(;t+s in this;)++s;const n=t+s;return this[n]=e,n}),[RemoteObject.toCallArgument(t)]);if(r.release(),o.wasThrown||!o.object||"string"!==o.object.type)i(o.object||null);else{const e=o.object.value,t=this.addCommandMessage(s,e);this.evaluateCommandInConsole(s,t,e,!1)}function i(e){let t=i18nString(UIStrings.failedToSaveToTempVariable);e&&(t=t+" "+e.description),Common.Console.Console.instance().error(t)}o.object&&o.object.release()}}export var Events;function extractExceptionMetaData(e){if(e)return{requestId:e.requestId||void 0,issueId:e.issueId||void 0}}function areAffectedResourcesEquivalent(e,t){return e?.requestId===t?.requestId}function areStackTracesEquivalent(e,t){if(!e!=!t)return!1;if(!e||!t)return!0;const s=e.callFrames,n=t.callFrames;if(s.length!==n.length)return!1;for(let e=0,t=s.length;e<t;++e)if(s[e].scriptId!==n[e].scriptId||s[e].functionName!==n[e].functionName||s[e].lineNumber!==n[e].lineNumber||s[e].columnNumber!==n[e].columnNumber)return!1;return areStackTracesEquivalent(e.parent,t.parent)}!function(e){e.ConsoleCleared="ConsoleCleared",e.MessageAdded="MessageAdded",e.MessageUpdated="MessageUpdated",e.CommandEvaluated="CommandEvaluated"}(Events||(Events={}));export class ConsoleMessage{#a;source;level;messageText;type;url;line;column;parameters;stackTrace;timestamp;#l;scriptId;workerId;context;#c=null;#o=void 0;#d=void 0;#u;category;constructor(e,t,s,n,r){if(this.#a=e,this.source=t,this.level=s,this.messageText=n,this.type=r?.type||"log",this.url=r?.url,this.line=r?.line||0,this.column=r?.column||0,this.parameters=r?.parameters,this.stackTrace=r?.stackTrace,this.timestamp=r?.timestamp||Date.now(),this.#l=r?.executionContextId||0,this.scriptId=r?.scriptId,this.workerId=r?.workerId,this.#u=r?.affectedResources,this.category=r?.category,!this.#l&&this.#a&&(this.scriptId?this.#l=this.#a.executionContextIdForScriptId(this.scriptId):this.stackTrace&&(this.#l=this.#a.executionContextForStackTrace(this.stackTrace))),r?.context){const e=r?.context.match(/[^#]*/);this.context=e?.[0]}}getAffectedResources(){return this.#u}setPageLoadSequenceNumber(e){this.#o=e}static fromException(e,t,s,n,r,o){const i={type:s,url:r||t.url,line:t.lineNumber,column:t.columnNumber,parameters:t.exception?[RemoteObject.fromLocalObject(t.text),t.exception]:void 0,stackTrace:t.stackTrace,timestamp:n,executionContextId:t.executionContextId,scriptId:t.scriptId,affectedResources:o};return new ConsoleMessage(e,"javascript","error",RuntimeModel.simpleTextFromException(t),i)}runtimeModel(){return this.#a}target(){return this.#a?this.#a.target():null}setOriginatingMessage(e){this.#c=e,this.#l=e.#l}originatingMessage(){return this.#c}setExecutionContextId(e){this.#l=e}getExecutionContextId(){return this.#l}getExceptionId(){return this.#d}setExceptionId(e){this.#d=e}isGroupMessage(){return"startGroup"===this.type||"startGroupCollapsed"===this.type||"endGroup"===this.type}isGroupStartMessage(){return"startGroup"===this.type||"startGroupCollapsed"===this.type}isErrorOrWarning(){return"warning"===this.level||"error"===this.level}isGroupable(){const e="error"===this.level&&("javascript"===this.source||"network"===this.source);return this.source!==FrontendMessageSource.ConsoleAPI&&this.type!==FrontendMessageType.Command&&this.type!==FrontendMessageType.Result&&this.type!==FrontendMessageType.System&&!e}groupCategoryKey(){return[this.source,this.level,this.type,this.#o].join(":")}isEqual(e){if(!e)return!1;if(this.parameters){if(!e.parameters||this.parameters.length!==e.parameters.length)return!1;for(let t=0;t<e.parameters.length;++t){const s=e.parameters[t],n=this.parameters[t];if("string"==typeof s||"string"==typeof n)return!1;if("object"===s.type&&"error"!==s.subtype)return!1;if(n.type!==s.type||n.value!==s.value||n.description!==s.description)return!1}}return this.runtimeModel()===e.runtimeModel()&&this.source===e.source&&this.type===e.type&&this.level===e.level&&this.line===e.line&&this.url===e.url&&this.scriptId===e.scriptId&&this.messageText===e.messageText&&this.#l===e.#l&&areAffectedResourcesEquivalent(this.#u,e.#u)&&areStackTracesEquivalent(this.stackTrace,e.stackTrace)}}export const MessageSourceDisplayName=new Map([["xml","xml"],["javascript","javascript"],["network","network"],[FrontendMessageSource.ConsoleAPI,"console-api"],["storage","storage"],["appcache","appcache"],["rendering","rendering"],[FrontendMessageSource.CSS,"css"],["security","security"],["deprecation","deprecation"],["worker","worker"],["violation","violation"],["intervention","intervention"],["recommendation","recommendation"],["other","other"]]);