import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import{ScopeRef}from"./RemoteObject.js";import{Events as ResourceTreeModelEvents,ResourceTreeModel}from"./ResourceTreeModel.js";import{RuntimeModel}from"./RuntimeModel.js";import{Script}from"./Script.js";import{Capability,Type}from"./Target.js";import{SDKModel}from"./SDKModel.js";import{SourceMapManager}from"./SourceMapManager.js";const UIStrings={local:"Local",closure:"Closure",block:"Block",script:"Script",withBlock:"`With` Block",global:"Global",module:"Module",expression:"Expression"},str_=i18n.i18n.registerUIStrings("core/sdk/DebuggerModel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export function sortAndMergeRanges(e){if(0===e.length)return[];e.sort(LocationRange.comparator);let t=e[0];const n=[];for(let a=1;a<e.length;++a){const r=e[a];if(t.overlap(r)){const e=t.end.compareTo(r.end)>0?t.end:r.end;t=new LocationRange(t.scriptId,t.start,e)}else n.push(t),t=r}return n.push(t),n}export var StepMode;!function(e){e.StepInto="StepInto",e.StepOut="StepOut",e.StepOver="StepOver"}(StepMode||(StepMode={}));export class DebuggerModel extends SDKModel{agent;runtimeModelInternal;#e;#t;#n;#a;#r;#s;continueToLocationCallback;#i;#o;#l;#c;#u;#d;#p;evaluateOnCallFrameCallback;#g=new Common.ObjectWrapper.ObjectWrapper;#h;#m;constructor(e){super(e),e.registerDebuggerDispatcher(new DebuggerDispatcher(this)),this.agent=e.debuggerAgent(),this.runtimeModelInternal=e.model(RuntimeModel),this.#e=new SourceMapManager(e),this.#t=new Map,this.#n=null,this.#a=new Map,this.#r=new Map,this.#s=[],this.continueToLocationCallback=null,this.#i=null,this.#o=!1,this.#l=null,this.#c=0,this.#u=null,this.#d=null,this.#p=null,this.evaluateOnCallFrameCallback=null,this.#h=!1,this.#m=!1,Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").addChangeListener(this.pauseOnExceptionStateChanged,this),Common.Settings.Settings.instance().moduleSetting("pauseOnCaughtException").addChangeListener(this.pauseOnExceptionStateChanged,this),Common.Settings.Settings.instance().moduleSetting("disableAsyncStackTraces").addChangeListener(this.asyncStackTracesStateChanged,this),Common.Settings.Settings.instance().moduleSetting("breakpointsActive").addChangeListener(this.breakpointsActiveChanged,this),e.suspended()||this.enableDebugger(),this.#e.setEnabled(Common.Settings.Settings.instance().moduleSetting("jsSourceMapsEnabled").get()),Common.Settings.Settings.instance().moduleSetting("jsSourceMapsEnabled").addChangeListener((e=>this.#e.setEnabled(e.data)));const t=e.model(ResourceTreeModel);t&&t.addEventListener(ResourceTreeModelEvents.FrameNavigated,this.onFrameNavigated,this)}static sourceMapId(e,t,n){return n?e+":"+t+":"+n:null}sourceMapManager(){return this.#e}runtimeModel(){return this.runtimeModelInternal}debuggerEnabled(){return Boolean(this.#o)}async enableDebugger(){if(this.#o)return;this.#o=!0;const e=Root.Runtime.Runtime.queryParam("remoteFrontend")||Root.Runtime.Runtime.queryParam("ws")?1e7:1e8,t=this.agent.invoke_enable({maxScriptsCacheSize:e});t.then(this.registerDebugger.bind(this)),this.pauseOnExceptionStateChanged(),this.asyncStackTracesStateChanged(),Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get()||this.breakpointsActiveChanged(),_scheduledPauseOnAsyncCall&&this.pauseOnAsyncCall(_scheduledPauseOnAsyncCall),this.dispatchEventToListeners(Events.DebuggerWasEnabled,this),await t}async syncDebuggerId(){const e=Root.Runtime.Runtime.queryParam("remoteFrontend")||Root.Runtime.Runtime.queryParam("ws")?1e7:1e8,t=this.agent.invoke_enable({maxScriptsCacheSize:e});return t.then(this.registerDebugger.bind(this)),t}onFrameNavigated(){DebuggerModel.shouldResyncDebuggerId||(DebuggerModel.shouldResyncDebuggerId=!0)}registerDebugger(e){if(e.getError())return;const{debuggerId:t}=e;_debuggerIdToModel.set(t,this),this.#l=t,this.dispatchEventToListeners(Events.DebuggerIsReadyToPause,this)}isReadyToPause(){return Boolean(this.#l)}static async modelForDebuggerId(e){return DebuggerModel.shouldResyncDebuggerId&&(await DebuggerModel.resyncDebuggerIdForModels(),DebuggerModel.shouldResyncDebuggerId=!1),_debuggerIdToModel.get(e)||null}static async resyncDebuggerIdForModels(){const e=_debuggerIdToModel.values();for(const t of e)t.debuggerEnabled()&&await t.syncDebuggerId()}async disableDebugger(){this.#o&&(this.#o=!1,await this.asyncStackTracesStateChanged(),await this.agent.invoke_disable(),this.#m=!1,this.globalObjectCleared(),this.dispatchEventToListeners(Events.DebuggerWasDisabled),"string"==typeof this.#l&&_debuggerIdToModel.delete(this.#l),this.#l=null)}skipAllPauses(e){this.#c&&(clearTimeout(this.#c),this.#c=0),this.agent.invoke_setSkipAllPauses({skip:e})}skipAllPausesUntilReloadOrTimeout(e){this.#c&&clearTimeout(this.#c),this.agent.invoke_setSkipAllPauses({skip:!0}),this.#c=window.setTimeout(this.skipAllPauses.bind(this,!1),e)}pauseOnExceptionStateChanged(){let e;e=Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").get()?Common.Settings.Settings.instance().moduleSetting("pauseOnCaughtException").get()?"all":"uncaught":"none",this.agent.invoke_setPauseOnExceptions({state:e})}asyncStackTracesStateChanged(){const e=!Common.Settings.Settings.instance().moduleSetting("disableAsyncStackTraces").get()&&this.#o?32:0;return this.agent.invoke_setAsyncCallStackDepth({maxDepth:e})}breakpointsActiveChanged(){this.agent.invoke_setBreakpointsActive({active:Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get()})}setComputeAutoStepRangesCallback(e){this.#d=e}async computeAutoStepSkipList(e){let t=[];if(this.#d&&this.#n){const[n]=this.#n.callFrames;t=await this.#d.call(null,e,n)}return sortAndMergeRanges(t.map((e=>new LocationRange(e.start.scriptId,new ScriptPosition(e.start.lineNumber,e.start.columnNumber),new ScriptPosition(e.end.lineNumber,e.end.columnNumber))))).map((e=>e.payload()))}async stepInto(){const e=await this.computeAutoStepSkipList(StepMode.StepInto);this.agent.invoke_stepInto({breakOnAsyncCall:!1,skipList:e})}async stepOver(){this.#h=!0;const e=await this.computeAutoStepSkipList(StepMode.StepOver);this.agent.invoke_stepOver({skipList:e})}async stepOut(){const e=await this.computeAutoStepSkipList(StepMode.StepOut);0!==e.length?this.agent.invoke_stepOver({skipList:e}):this.agent.invoke_stepOut()}scheduleStepIntoAsync(){this.computeAutoStepSkipList(StepMode.StepInto).then((e=>{this.agent.invoke_stepInto({breakOnAsyncCall:!0,skipList:e})}))}resume(){this.agent.invoke_resume({terminateOnResume:!1}),this.#m=!1}pause(){this.#m=!0,this.skipAllPauses(!1),this.agent.invoke_pause()}pauseOnAsyncCall(e){return this.agent.invoke_pauseOnAsyncCall({parentStackTraceId:e})}async setBreakpointByURL(e,t,n,a){let r;if(this.target().type()===Type.Node&&e.startsWith("file://")){const t=Common.ParsedURL.ParsedURL.capFilePrefix(e,Host.Platform.isWin());r=`${Platform.StringUtilities.escapeForRegExp(t)}|${Platform.StringUtilities.escapeForRegExp(e)}`}let s=0;const i=this.#r.get(e)||[];for(let e=0,n=i.length;e<n;++e){const n=i[e];t===n.lineOffset&&(s=s?Math.min(s,n.columnOffset):n.columnOffset)}n=Math.max(n||0,s);const o=await this.agent.invoke_setBreakpointByUrl({lineNumber:t,url:r?void 0:e,urlRegex:r,columnNumber:n,condition:a});if(o.getError())return{locations:[],breakpointId:null};let l=[];return o.locations&&(l=o.locations.map((e=>Location.fromPayload(this,e)))),{locations:l,breakpointId:o.breakpointId}}async setBreakpointInAnonymousScript(e,t,n,a,r){const s=await this.agent.invoke_setBreakpointByUrl({lineNumber:n,scriptHash:t,columnNumber:a,condition:r}),i=s.getError();if(i)return"Either url or urlRegex must be specified."!==i?{locations:[],breakpointId:null}:this.setBreakpointBySourceId(e,n,a,r);let o=[];return s.locations&&(o=s.locations.map((e=>Location.fromPayload(this,e)))),{locations:o,breakpointId:s.breakpointId}}async setBreakpointBySourceId(e,t,n,a){const r=await this.agent.invoke_setBreakpoint({location:{scriptId:e,lineNumber:t,columnNumber:n},condition:a});if(r.getError())return{breakpointId:null,locations:[]};let s=[];return r.actualLocation&&(s=[Location.fromPayload(this,r.actualLocation)]),{locations:s,breakpointId:r.breakpointId}}async removeBreakpoint(e){const t=await this.agent.invoke_removeBreakpoint({breakpointId:e});t.getError()&&console.error("Failed to remove breakpoint: "+t.getError())}async getPossibleBreakpoints(e,t,n){const a=await this.agent.invoke_getPossibleBreakpoints({start:e.payload(),end:t?t.payload():void 0,restrictToFunction:n});return a.getError()||!a.locations?[]:a.locations.map((e=>BreakLocation.fromPayload(this,e)))}async fetchAsyncStackTrace(e){const t=await this.agent.invoke_getStackTrace({stackTraceId:e});return t.getError()?null:t.stackTrace}breakpointResolved(e,t){this.#g.dispatchEventToListeners(e,Location.fromPayload(this,t))}globalObjectCleared(){this.setDebuggerPausedDetails(null),this.reset(),this.dispatchEventToListeners(Events.GlobalObjectCleared,this)}reset(){for(const e of this.#t.values())this.#e.detachSourceMap(e);this.#t.clear(),this.#a.clear(),this.#r.clear(),this.#s=[],this.#h=!1}scripts(){return Array.from(this.#a.values())}scriptForId(e){return this.#a.get(e)||null}scriptsForSourceURL(e){return e&&this.#r.get(e)||[]}scriptsForExecutionContext(e){const t=[];for(const n of this.#a.values())n.executionContextId===e.id&&t.push(n);return t}setScriptSource(e,t,n){const a=this.#a.get(e);a&&a.editSource(t,this.didEditScriptSource.bind(this,e,t,n))}didEditScriptSource(e,t,n,a,r,s,i,o,l){n(a,r),l?this.stepInto():!a&&s&&s.length&&this.#n&&this.pausedScript(s,this.#n.reason,this.#n.auxData,this.#n.breakpointIds,i,o)}get callFrames(){return this.#n?this.#n.callFrames:null}debuggerPausedDetails(){return this.#n}setDebuggerPausedDetails(e){if(e){if(this.#m=!1,this.#n=e,this.#u&&!this.#u.call(null,e))return!1;this.#h=!1,this.dispatchEventToListeners(Events.DebuggerPaused,this),this.setSelectedCallFrame(e.callFrames[0])}else this.#m=!1,this.#n=null,this.setSelectedCallFrame(null);return!0}setBeforePausedCallback(e){this.#u=e}setExpandCallFramesCallback(e){this.#p=e}setEvaluateOnCallFrameCallback(e){this.evaluateOnCallFrameCallback=e}async pausedScript(e,t,n,a,r,s,i){if(i){_scheduledPauseOnAsyncCall=i;const e=[];for(const t of _debuggerIdToModel.values())e.push(t.pauseOnAsyncCall(i));return await Promise.all(e),void this.resume()}const o=new DebuggerPausedDetails(this,e,t,n,a,r,s);if(this.#p&&(o.callFrames=await this.#p.call(null,o.callFrames)),this.continueToLocationCallback){const e=this.continueToLocationCallback;if(this.continueToLocationCallback=null,e(o))return}this.setDebuggerPausedDetails(o)?Common.EventTarget.fireEvent("DevTools.DebuggerPaused"):this.#h?this.stepOver():this.stepInto(),_scheduledPauseOnAsyncCall=null}resumedScript(){this.setDebuggerPausedDetails(null),this.dispatchEventToListeners(Events.DebuggerResumed,this)}parsedScriptSource(e,t,n,a,r,s,i,o,l,c,u,d,p,g,h,m,b,S,I,k){const y=this.#a.get(e);if(y)return y;let C=!1;l&&"isDefault"in l&&(C=!l.isDefault);const M=new Script(this,e,t,n,a,r,s,i,o,C,c,u,d,g,h,m,b,S,I,k);this.registerScript(M),this.dispatchEventToListeners(Events.ParsedScriptSource,M);const f=DebuggerModel.sourceMapId(M.executionContextId,M.sourceURL,M.sourceMapURL);if(f&&!p){const e=this.#t.get(f);e&&this.#e.detachSourceMap(e),this.#t.set(f,M),this.#e.attachSourceMap(M,M.sourceURL,M.sourceMapURL)}return p&&M.isAnonymousScript()&&(this.#s.push(M),this.collectDiscardedScripts()),M}setSourceMapURL(e,t){let n=DebuggerModel.sourceMapId(e.executionContextId,e.sourceURL,e.sourceMapURL);n&&this.#t.get(n)===e&&this.#t.delete(n),this.#e.detachSourceMap(e),e.sourceMapURL=t,n=DebuggerModel.sourceMapId(e.executionContextId,e.sourceURL,e.sourceMapURL),n&&(this.#t.set(n,e),this.#e.attachSourceMap(e,e.sourceURL,e.sourceMapURL))}executionContextDestroyed(e){const t=Array.from(this.#t.keys());for(const n of t){const t=this.#t.get(n);t&&t.executionContextId===e.id&&(this.#t.delete(n),this.#e.detachSourceMap(t))}}registerScript(e){if(this.#a.set(e.scriptId,e),e.isAnonymousScript())return;let t=this.#r.get(e.sourceURL);t||(t=[],this.#r.set(e.sourceURL,t)),t.push(e)}unregisterScript(e){console.assert(e.isAnonymousScript()),this.#a.delete(e.scriptId)}collectDiscardedScripts(){if(this.#s.length<1e3)return;const e=this.#s.splice(0,100);for(const t of e)this.unregisterScript(t),this.dispatchEventToListeners(Events.DiscardedAnonymousScriptSource,t)}createRawLocation(e,t,n,a){return this.createRawLocationByScriptId(e.scriptId,t,n,a)}createRawLocationByURL(e,t,n,a){for(const r of this.#r.get(e)||[])if(!(r.lineOffset>t||r.lineOffset===t&&void 0!==n&&r.columnOffset>n||r.endLine<t||r.endLine===t&&void 0!==n&&r.endColumn<=n))return new Location(this,r.scriptId,t,n,a);return null}createRawLocationByScriptId(e,t,n,a){return new Location(this,e,t,n,a)}createRawLocationsByStackTrace(e){const t=[];for(let n=e;n;n=n.parent)for(const{scriptId:e,lineNumber:a,columnNumber:r}of n.callFrames)t.push(this.createRawLocationByScriptId(e,a,r));return t}isPaused(){return Boolean(this.debuggerPausedDetails())}isPausing(){return this.#m}setSelectedCallFrame(e){this.#i!==e&&(this.#i=e,this.dispatchEventToListeners(Events.CallFrameSelected,this))}selectedCallFrame(){return this.#i}async evaluateOnSelectedCallFrame(e){const t=this.selectedCallFrame();if(!t)throw new Error("No call frame selected");return t.evaluate(e)}functionDetailsPromise(e){return e.getAllProperties(!1,!1).then(function(e){if(!e)return null;let t=null;if(e.internalProperties)for(const n of e.internalProperties)"[[FunctionLocation]]"===n.name&&(t=n.value);let n=null;if(e.properties)for(const t of e.properties)"name"===t.name&&t.value&&"string"===t.value.type&&(n=t.value);let a=null;t&&(a=this.createRawLocationByScriptId(t.value.scriptId,t.value.lineNumber,t.value.columnNumber));return{location:a,functionName:n?n.value:""}}.bind(this))}async setVariableValue(e,t,n,a){const r=(await this.agent.invoke_setVariableValue({scopeNumber:e,variableName:t,newValue:n,callFrameId:a})).getError();return r&&console.error(r),r}addBreakpointListener(e,t,n){this.#g.addEventListener(e,t,n)}removeBreakpointListener(e,t,n){this.#g.removeEventListener(e,t,n)}async setBlackboxPatterns(e){const t=(await this.agent.invoke_setBlackboxPatterns({patterns:e})).getError();return t&&console.error(t),!t}dispose(){this.#e.dispose(),this.#l&&_debuggerIdToModel.delete(this.#l),Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").removeChangeListener(this.pauseOnExceptionStateChanged,this),Common.Settings.Settings.instance().moduleSetting("pauseOnCaughtException").removeChangeListener(this.pauseOnExceptionStateChanged,this),Common.Settings.Settings.instance().moduleSetting("disableAsyncStackTraces").removeChangeListener(this.asyncStackTracesStateChanged,this)}async suspendModel(){await this.disableDebugger()}async resumeModel(){await this.enableDebugger()}static shouldResyncDebuggerId=!1;getContinueToLocationCallback(){return this.continueToLocationCallback}getEvaluateOnCallFrameCallback(){return this.evaluateOnCallFrameCallback}}export const _debuggerIdToModel=new Map;export let _scheduledPauseOnAsyncCall=null;export var PauseOnExceptionsState;!function(e){e.DontPauseOnExceptions="none",e.PauseOnAllExceptions="all",e.PauseOnUncaughtExceptions="uncaught"}(PauseOnExceptionsState||(PauseOnExceptionsState={}));export var Events;!function(e){e.DebuggerWasEnabled="DebuggerWasEnabled",e.DebuggerWasDisabled="DebuggerWasDisabled",e.DebuggerPaused="DebuggerPaused",e.DebuggerResumed="DebuggerResumed",e.ParsedScriptSource="ParsedScriptSource",e.DiscardedAnonymousScriptSource="DiscardedAnonymousScriptSource",e.GlobalObjectCleared="GlobalObjectCleared",e.CallFrameSelected="CallFrameSelected",e.DebuggerIsReadyToPause="DebuggerIsReadyToPause"}(Events||(Events={}));class DebuggerDispatcher{#b;constructor(e){this.#b=e}paused({callFrames:e,reason:t,data:n,hitBreakpoints:a,asyncStackTrace:r,asyncStackTraceId:s,asyncCallStackTraceId:i}){this.#b.debuggerEnabled()&&this.#b.pausedScript(e,t,n,a||[],r,s,i)}resumed(){this.#b.debuggerEnabled()&&this.#b.resumedScript()}scriptParsed({scriptId:e,url:t,startLine:n,startColumn:a,endLine:r,endColumn:s,executionContextId:i,hash:o,executionContextAuxData:l,isLiveEdit:c,sourceMapURL:u,hasSourceURL:d,length:p,isModule:g,stackTrace:h,codeOffset:m,scriptLanguage:b,debugSymbols:S,embedderName:I}){this.#b.debuggerEnabled()&&this.#b.parsedScriptSource(e,t,n,a,r,s,i,o,l,Boolean(c),u,Boolean(d),!1,p||0,g||null,h||null,m||null,b||null,S||null,I||null)}scriptFailedToParse({scriptId:e,url:t,startLine:n,startColumn:a,endLine:r,endColumn:s,executionContextId:i,hash:o,executionContextAuxData:l,sourceMapURL:c,hasSourceURL:u,length:d,isModule:p,stackTrace:g,codeOffset:h,scriptLanguage:m,embedderName:b}){this.#b.debuggerEnabled()&&this.#b.parsedScriptSource(e,t,n,a,r,s,i,o,l,!1,c,Boolean(u),!0,d||0,p||null,g||null,h||null,m||null,null,b||null)}breakpointResolved({breakpointId:e,location:t}){this.#b.debuggerEnabled()&&this.#b.breakpointResolved(e,t)}}export class Location{debuggerModel;scriptId;lineNumber;columnNumber;inlineFrameIndex;constructor(e,t,n,a,r){this.debuggerModel=e,this.scriptId=t,this.lineNumber=n,this.columnNumber=a||0,this.inlineFrameIndex=r||0}static fromPayload(e,t,n){return new Location(e,t.scriptId,t.lineNumber,t.columnNumber,n)}payload(){return{scriptId:this.scriptId,lineNumber:this.lineNumber,columnNumber:this.columnNumber}}script(){return this.debuggerModel.scriptForId(this.scriptId)}continueToLocation(e){e&&(this.debuggerModel.continueToLocationCallback=this.paused.bind(this,e)),this.debuggerModel.agent.invoke_continueToLocation({location:this.payload(),targetCallFrames:"current"})}paused(e,t){const n=t.callFrames[0].location();return n.scriptId===this.scriptId&&n.lineNumber===this.lineNumber&&n.columnNumber===this.columnNumber&&(e(),!0)}id(){return this.debuggerModel.target().id()+":"+this.scriptId+":"+this.lineNumber+":"+this.columnNumber}}export class ScriptPosition{lineNumber;columnNumber;constructor(e,t){this.lineNumber=e,this.columnNumber=t}payload(){return{lineNumber:this.lineNumber,columnNumber:this.columnNumber}}compareTo(e){return this.lineNumber!==e.lineNumber?this.lineNumber-e.lineNumber:this.columnNumber-e.columnNumber}}export class LocationRange{scriptId;start;end;constructor(e,t,n){this.scriptId=e,this.start=t,this.end=n}payload(){return{scriptId:this.scriptId,start:this.start.payload(),end:this.end.payload()}}static comparator(e,t){return e.compareTo(t)}compareTo(e){if(this.scriptId!==e.scriptId)return this.scriptId>e.scriptId?1:-1;const t=this.start.compareTo(e.start);return t||this.end.compareTo(e.end)}overlap(e){if(this.scriptId!==e.scriptId)return!1;const t=this.start.compareTo(e.start);return t<0?this.end.compareTo(e.start)>=0:!(t>0)||this.start.compareTo(e.end)<=0}}export class BreakLocation extends Location{type;constructor(e,t,n,a,r){super(e,t,n,a),r&&(this.type=r)}static fromPayload(e,t){return new BreakLocation(e,t.scriptId,t.lineNumber,t.columnNumber,t.type)}}export class CallFrame{debuggerModel;#S;payload;#I;#k;#y;#C;#M;#f;#v;warnings=[];constructor(e,t,n,a,r){this.debuggerModel=e,this.#S=t,this.payload=n,this.#I=Location.fromPayload(e,n.location,a),this.#k=[],this.#y=null,this.#C=a||0,this.#M=r||n.functionName;for(let e=0;e<n.scopeChain.length;++e){const t=new Scope(this,e);this.#k.push(t),"local"===t.type()&&(this.#y=t)}n.functionLocation&&(this.#f=Location.fromPayload(e,n.functionLocation)),this.#v=n.returnValue?this.debuggerModel.runtimeModel().createRemoteObject(n.returnValue):null}static fromPayloadArray(e,t){const n=[];for(let a=0;a<t.length;++a){const r=t[a],s=e.scriptForId(r.location.scriptId);s&&n.push(new CallFrame(e,s,r))}return n}createVirtualCallFrame(e,t){return new CallFrame(this.debuggerModel,this.#S,this.payload,e,t)}addWarning(e){this.warnings.push(e)}get script(){return this.#S}get id(){return this.payload.callFrameId}get inlineFrameIndex(){return this.#C}scopeChain(){return this.#k}localScope(){return this.#y}thisObject(){return this.payload.this?this.debuggerModel.runtimeModel().createRemoteObject(this.payload.this):null}returnValue(){return this.#v}async setReturnValue(e){if(!this.#v)return null;const t=await this.debuggerModel.agent.invoke_evaluateOnCallFrame({callFrameId:this.id,expression:e,silent:!0,objectGroup:"backtrace"});if(t.getError()||t.exceptionDetails)return null;return(await this.debuggerModel.agent.invoke_setReturnValue({newValue:t.result})).getError()?null:(this.#v=this.debuggerModel.runtimeModel().createRemoteObject(t.result),this.#v)}get functionName(){return this.#M}location(){return this.#I}functionLocation(){return this.#f||null}async evaluate(e){const t=this.debuggerModel,n=t.runtimeModel();if((Boolean(e.throwOnSideEffect)||void 0!==e.timeout)&&(!1===n.hasSideEffectSupport()||null===n.hasSideEffectSupport()&&!await n.checkSideEffectSupport()))return{error:"Side-effect checks not supported by backend."};const a=t.getEvaluateOnCallFrameCallback();if(a){const t=await a(this,e);if(t)return t}const r=await this.debuggerModel.agent.invoke_evaluateOnCallFrame({callFrameId:this.id,expression:e.expression,objectGroup:e.objectGroup,includeCommandLineAPI:e.includeCommandLineAPI,silent:e.silent,returnByValue:e.returnByValue,generatePreview:e.generatePreview,throwOnSideEffect:e.throwOnSideEffect,timeout:e.timeout}),s=r.getError();return s?(console.error(s),{error:s}):{object:n.createRemoteObject(r.result),exceptionDetails:r.exceptionDetails}}getPayload(){return this.payload}}export class Scope{#L;#P;#R;#E;#D;#T;#x;#F;constructor(e,t){this.#L=e,this.#P=e.getPayload().scopeChain[t],this.#R=this.#P.type,this.#E=this.#P.name,this.#D=t,this.#T=this.#P.startLocation?Location.fromPayload(e.debuggerModel,this.#P.startLocation):null,this.#x=this.#P.endLocation?Location.fromPayload(e.debuggerModel,this.#P.endLocation):null,this.#F=null}callFrame(){return this.#L}type(){return this.#R}typeName(){switch(this.#R){case"local":return i18nString(UIStrings.local);case"closure":return i18nString(UIStrings.closure);case"catch":return i18n.i18n.lockedString("Catch");case"block":return i18nString(UIStrings.block);case"script":return i18nString(UIStrings.script);case"with":return i18nString(UIStrings.withBlock);case"global":return i18nString(UIStrings.global);case"module":return i18nString(UIStrings.module);case"wasm-expression-stack":return i18nString(UIStrings.expression)}return""}name(){return this.#E}startLocation(){return this.#T}endLocation(){return this.#x}object(){if(this.#F)return this.#F;const e=this.#L.debuggerModel.runtimeModel(),t="with"!==this.#R&&"global"!==this.#R;return this.#F=t?e.createScopeRemoteObject(this.#P.object,new ScopeRef(this.#D,this.#L.id)):e.createRemoteObject(this.#P.object),this.#F}description(){return"with"!==this.#R&&"global"!==this.#R?"":this.#P.object.description||""}icon(){}}export class DebuggerPausedDetails{debuggerModel;callFrames;reason;auxData;breakpointIds;asyncStackTrace;asyncStackTraceId;constructor(e,t,n,a,r,s,i){this.debuggerModel=e,this.callFrames=CallFrame.fromPayloadArray(e,t),this.reason=n,this.auxData=a,this.breakpointIds=r,s&&(this.asyncStackTrace=this.cleanRedundantFrames(s)),this.asyncStackTraceId=i}exception(){return"exception"!==this.reason&&"promiseRejection"!==this.reason?null:this.debuggerModel.runtimeModel().createRemoteObject(this.auxData)}cleanRedundantFrames(e){let t=e,n=null;for(;t;)"async function"===t.description&&t.callFrames.length&&t.callFrames.shift(),n&&!t.callFrames.length?n.parent=t.parent:n=t,t=t.parent;return e}}SDKModel.register(DebuggerModel,{capabilities:Capability.JS,autostart:!0});