import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import{Cookie}from"./Cookie.js";import{Events as NetworkRequestEvents,NetworkRequest}from"./NetworkRequest.js";import{Capability}from"./Target.js";import{SDKModel}from"./SDKModel.js";import{TargetManager}from"./TargetManager.js";const UIStrings={noContentForWebSocket:"Content for WebSockets is currently not supported",noContentForRedirect:"No content available because this request was redirected",noContentForPreflight:"No content available for preflight request",noThrottling:"No throttling",offline:"Offline",slowG:"Slow 3G",fastG:"Fast 3G",requestWasBlockedByDevtoolsS:'Request was blocked by DevTools: "{PH1}"',crossoriginReadBlockingCorb:"Cross-Origin Read Blocking (CORB) blocked cross-origin response {PH1} with MIME type {PH2}. See https://www.chromestatus.com/feature/5629709824032768 for more details.",sFailedLoadingSS:'{PH1} failed loading: {PH2} "{PH3}".',sFinishedLoadingSS:'{PH1} finished loading: {PH2} "{PH3}".'},str_=i18n.i18n.registerUIStrings("core/sdk/NetworkManager.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_),requestToManagerMap=new WeakMap,CONNECTION_TYPES=new Map([["2g","cellular2g"],["3g","cellular3g"],["4g","cellular4g"],["bluetooth","bluetooth"],["wifi","wifi"],["wimax","wimax"]]);export class NetworkManager extends SDKModel{dispatcher;#e;#t;constructor(e){super(e),this.dispatcher=new NetworkDispatcher(this),this.#e=e.networkAgent(),e.registerNetworkDispatcher(this.dispatcher),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()&&this.#e.invoke_setCacheDisabled({cacheDisabled:!0}),this.#e.invoke_enable({maxPostDataSize:MAX_EAGER_POST_REQUEST_BODY_LENGTH}),this.#e.invoke_setAttachDebugStack({enabled:!0}),this.#t=Common.Settings.Settings.instance().createSetting("bypassServiceWorker",!1),this.#t.get()&&this.bypassServiceWorkerChanged(),this.#t.addChangeListener(this.bypassServiceWorkerChanged,this),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").addChangeListener(this.cacheDisabledSettingChanged,this)}static forRequest(e){return requestToManagerMap.get(e)||null}static canReplayRequest(e){return Boolean(requestToManagerMap.get(e))&&Boolean(e.backendRequestId())&&!e.isRedirect()&&e.resourceType()===Common.ResourceType.resourceTypes.XHR}static replayRequest(e){const t=requestToManagerMap.get(e),s=e.backendRequestId();t&&s&&!e.isRedirect()&&t.#e.invoke_replayXHR({requestId:s})}static async searchInRequest(e,t,s,r){const n=NetworkManager.forRequest(e),o=e.backendRequestId();if(!n||!o||e.isRedirect())return[];return(await n.#e.invoke_searchInResponseBody({requestId:o,query:t,caseSensitive:s,isRegex:r})).result||[]}static async requestContentData(e){if(e.resourceType()===Common.ResourceType.resourceTypes.WebSocket)return{error:i18nString(UIStrings.noContentForWebSocket),content:null,encoded:!1};if(e.finished||await e.once(NetworkRequestEvents.FinishedLoading),e.isRedirect())return{error:i18nString(UIStrings.noContentForRedirect),content:null,encoded:!1};if(e.isPreflightRequest())return{error:i18nString(UIStrings.noContentForPreflight),content:null,encoded:!1};const t=NetworkManager.forRequest(e);if(!t)return{error:"No network manager for request",content:null,encoded:!1};const s=e.backendRequestId();if(!s)return{error:"No backend request id for request",content:null,encoded:!1};const r=await t.#e.invoke_getResponseBody({requestId:s}),n=r.getError()||null;return{error:n,content:n?null:r.body,encoded:r.base64Encoded}}static async requestPostData(e){const t=NetworkManager.forRequest(e);if(!t)return console.error("No network manager for request"),null;const s=e.backendRequestId();if(!s)return console.error("No backend request id for request"),null;try{const{postData:e}=await t.#e.invoke_getRequestPostData({requestId:s});return e}catch(e){return e.message}}static connectionType(e){if(!e.download&&!e.upload)return"none";const t="function"==typeof e.title?e.title().toLowerCase():e.title.toLowerCase();for(const[e,s]of CONNECTION_TYPES)if(t.includes(e))return s;return"other"}static lowercaseHeaders(e){const t={};for(const s in e)t[s.toLowerCase()]=e[s];return t}requestForURL(e){return this.dispatcher.requestForURL(e)}cacheDisabledSettingChanged({data:e}){this.#e.invoke_setCacheDisabled({cacheDisabled:e})}dispose(){Common.Settings.Settings.instance().moduleSetting("cacheDisabled").removeChangeListener(this.cacheDisabledSettingChanged,this)}bypassServiceWorkerChanged(){this.#e.invoke_setBypassServiceWorker({bypass:this.#t.get()})}async getSecurityIsolationStatus(e){const t=await this.#e.invoke_getSecurityIsolationStatus({frameId:e??void 0});return t.getError()?null:t.status}async enableReportingApi(e=!0){return this.#e.invoke_enableReportingApi({enable:e})}async loadNetworkResource(e,t,s){const r=await this.#e.invoke_loadNetworkResource({frameId:e??void 0,url:t,options:s});if(r.getError())throw new Error(r.getError());return r.resource}clearRequests(){this.dispatcher.clearRequests()}}export var Events;!function(e){e.RequestStarted="RequestStarted",e.RequestUpdated="RequestUpdated",e.RequestFinished="RequestFinished",e.RequestUpdateDropped="RequestUpdateDropped",e.ResponseReceived="ResponseReceived",e.MessageGenerated="MessageGenerated",e.RequestRedirected="RequestRedirected",e.LoadingFinished="LoadingFinished",e.ReportingApiReportAdded="ReportingApiReportAdded",e.ReportingApiReportUpdated="ReportingApiReportUpdated",e.ReportingApiEndpointsChangedForOrigin="ReportingApiEndpointsChangedForOrigin"}(Events||(Events={}));export const NoThrottlingConditions={title:i18nLazyString(UIStrings.noThrottling),i18nTitleKey:UIStrings.noThrottling,download:-1,upload:-1,latency:0};export const OfflineConditions={title:i18nLazyString(UIStrings.offline),i18nTitleKey:UIStrings.offline,download:0,upload:0,latency:0};export const Slow3GConditions={title:i18nLazyString(UIStrings.slowG),i18nTitleKey:UIStrings.slowG,download:5e4,upload:5e4,latency:2e3};export const Fast3GConditions={title:i18nLazyString(UIStrings.fastG),i18nTitleKey:UIStrings.fastG,download:18e4,upload:84375,latency:562.5};const MAX_EAGER_POST_REQUEST_BODY_LENGTH=65536;export class NetworkDispatcher{#s;#r;#n;#o;#i;constructor(e){this.#s=e,this.#r=new Map,this.#n=new Map,this.#o=new Map,this.#i=new Map}headersMapToHeadersArray(e){const t=[];for(const s in e){const r=e[s].split("\n");for(let e=0;e<r.length;++e)t.push({name:s,value:r[e]})}return t}updateNetworkRequestWithRequest(e,t){e.requestMethod=t.method,e.setRequestHeaders(this.headersMapToHeadersArray(t.headers)),e.setRequestFormData(Boolean(t.hasPostData),t.postData||null),e.setInitialPriority(t.initialPriority),e.mixedContentType=t.mixedContentType||"none",e.setReferrerPolicy(t.referrerPolicy),e.setIsSameSite(t.isSameSite||!1)}updateNetworkRequestWithResponse(e,t){t.url&&e.url()!==t.url&&e.setUrl(t.url),e.mimeType=t.mimeType,e.statusCode||(e.statusCode=t.status),e.statusText||(e.statusText=t.statusText),e.hasExtraResponseInfo()||(e.responseHeaders=this.headersMapToHeadersArray(t.headers)),t.encodedDataLength>=0&&e.setTransferSize(t.encodedDataLength),t.requestHeaders&&!e.hasExtraRequestInfo()&&(e.setRequestHeaders(this.headersMapToHeadersArray(t.requestHeaders)),e.setRequestHeadersText(t.requestHeadersText||"")),e.connectionReused=t.connectionReused,e.connectionId=String(t.connectionId),t.remoteIPAddress&&e.setRemoteAddress(t.remoteIPAddress,t.remotePort||-1),t.fromServiceWorker&&(e.fetchedViaServiceWorker=!0),t.fromDiskCache&&e.setFromDiskCache(),t.fromPrefetchCache&&e.setFromPrefetchCache(),t.cacheStorageCacheName&&e.setResponseCacheStorageCacheName(t.cacheStorageCacheName),t.responseTime&&e.setResponseRetrievalTime(new Date(t.responseTime)),e.timing=t.timing,e.protocol=t.protocol||"",t.serviceWorkerResponseSource&&e.setServiceWorkerResponseSource(t.serviceWorkerResponseSource),e.setSecurityState(t.securityState),t.securityDetails&&e.setSecurityDetails(t.securityDetails);const s=Common.ResourceType.ResourceType.fromMimeTypeOverride(e.mimeType);s&&e.setResourceType(s)}requestForId(e){return this.#r.get(e)||null}requestForURL(e){return this.#n.get(e)||null}resourceChangedPriority({requestId:e,newPriority:t}){const s=this.#r.get(e);s&&s.setPriority(t)}signedExchangeReceived({requestId:e,info:t}){let s=this.#r.get(e);(s||(s=this.#n.get(t.outerResponse.url),s))&&(s.setSignedExchangeInfo(t),s.setResourceType(Common.ResourceType.resourceTypes.SignedExchange),this.updateNetworkRequestWithResponse(s,t.outerResponse),this.updateNetworkRequest(s),this.#s.dispatchEventToListeners(Events.ResponseReceived,{request:s,response:t.outerResponse}))}requestWillBeSent({requestId:e,loaderId:t,documentURL:s,request:r,timestamp:n,wallTime:o,initiator:i,redirectResponse:a,type:d,frameId:u}){let c=this.#r.get(e);if(c){if(!a)return;c.signedExchangeInfo()||this.responseReceived({requestId:e,loaderId:t,timestamp:n,type:d||"Other",response:a,hasExtraInfo:!1,frameId:u}),c=this.appendRedirect(e,n,r.url),this.#s.dispatchEventToListeners(Events.RequestRedirected,c)}else c=NetworkRequest.create(e,r.url,s,u??null,t,i),requestToManagerMap.set(c,this.#s);c.hasNetworkData=!0,this.updateNetworkRequestWithRequest(c,r),c.setIssueTime(n,o),c.setResourceType(d?Common.ResourceType.resourceTypes[d]:Common.ResourceType.resourceTypes.Other),r.trustTokenParams&&c.setTrustTokenParams(r.trustTokenParams);const l=this.#i.get(e);l&&(c.setTrustTokenOperationDoneEvent(l),this.#i.delete(e)),this.getExtraInfoBuilder(e).addRequest(c),this.startNetworkRequest(c,r)}requestServedFromCache({requestId:e}){const t=this.#r.get(e);t&&t.setFromMemoryCache()}responseReceived({requestId:e,loaderId:t,timestamp:s,type:r,response:n,frameId:o}){const i=this.#r.get(e),a=NetworkManager.lowercaseHeaders(n.headers);if(i)i.responseReceivedTime=s,i.setResourceType(Common.ResourceType.resourceTypes[r]),this.updateNetworkRequestWithResponse(i,n),this.updateNetworkRequest(i),this.#s.dispatchEventToListeners(Events.ResponseReceived,{request:i,response:n});else{const e=a["last-modified"],s={url:n.url,frameId:o??null,loaderId:t,resourceType:r,mimeType:n.mimeType,lastModified:e?new Date(e):null};this.#s.dispatchEventToListeners(Events.RequestUpdateDropped,s)}}dataReceived({requestId:e,timestamp:t,dataLength:s,encodedDataLength:r}){let n=this.#r.get(e);n||(n=this.maybeAdoptMainResourceRequest(e)),n&&(n.resourceSize+=s,-1!==r&&n.increaseTransferSize(r),n.endTime=t,this.updateNetworkRequest(n))}loadingFinished({requestId:e,timestamp:t,encodedDataLength:s,shouldReportCorbBlocking:r}){let n=this.#r.get(e);n||(n=this.maybeAdoptMainResourceRequest(e)),n&&(this.getExtraInfoBuilder(e).finished(),this.finishNetworkRequest(n,t,s,r),this.#s.dispatchEventToListeners(Events.LoadingFinished,n))}loadingFailed({requestId:e,timestamp:t,type:s,errorText:r,canceled:n,blockedReason:o,corsErrorStatus:i}){const a=this.#r.get(e);if(a){if(a.failed=!0,a.setResourceType(Common.ResourceType.resourceTypes[s]),a.canceled=Boolean(n),o&&(a.setBlockedReason(o),"inspector"===o)){const t=i18nString(UIStrings.requestWasBlockedByDevtoolsS,{PH1:a.url()});this.#s.dispatchEventToListeners(Events.MessageGenerated,{message:t,requestId:e,warning:!0})}i&&a.setCorsErrorStatus(i),a.localizedFailDescription=r,this.getExtraInfoBuilder(e).finished(),this.finishNetworkRequest(a,t,-1)}}webSocketCreated({requestId:e,url:t,initiator:s}){const r=NetworkRequest.createForWebSocket(e,t,s);requestToManagerMap.set(r,this.#s),r.setResourceType(Common.ResourceType.resourceTypes.WebSocket),this.startNetworkRequest(r,null)}webSocketWillSendHandshakeRequest({requestId:e,timestamp:t,wallTime:s,request:r}){const n=this.#r.get(e);n&&(n.requestMethod="GET",n.setRequestHeaders(this.headersMapToHeadersArray(r.headers)),n.setIssueTime(t,s),this.updateNetworkRequest(n))}webSocketHandshakeResponseReceived({requestId:e,timestamp:t,response:s}){const r=this.#r.get(e);r&&(r.statusCode=s.status,r.statusText=s.statusText,r.responseHeaders=this.headersMapToHeadersArray(s.headers),r.responseHeadersText=s.headersText||"",s.requestHeaders&&r.setRequestHeaders(this.headersMapToHeadersArray(s.requestHeaders)),s.requestHeadersText&&r.setRequestHeadersText(s.requestHeadersText),r.responseReceivedTime=t,r.protocol="websocket",this.updateNetworkRequest(r))}webSocketFrameReceived({requestId:e,timestamp:t,response:s}){const r=this.#r.get(e);r&&(r.addProtocolFrame(s,t,!1),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketFrameSent({requestId:e,timestamp:t,response:s}){const r=this.#r.get(e);r&&(r.addProtocolFrame(s,t,!0),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketFrameError({requestId:e,timestamp:t,errorMessage:s}){const r=this.#r.get(e);r&&(r.addProtocolFrameError(s,t),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketClosed({requestId:e,timestamp:t}){const s=this.#r.get(e);s&&this.finishNetworkRequest(s,t,-1)}eventSourceMessageReceived({requestId:e,timestamp:t,eventName:s,eventId:r,data:n}){const o=this.#r.get(e);o&&o.addEventSourceMessage(t,s,r,n)}requestIntercepted({interceptionId:e,request:t,frameId:s,resourceType:r,isNavigationRequest:n,isDownload:o,redirectUrl:i,authChallenge:a,responseErrorReason:d,responseStatusCode:u,responseHeaders:c,requestId:l}){MultitargetNetworkManager.instance().requestIntercepted(new InterceptedRequest(this.#s.target().networkAgent(),e,t,s,r,n,o,i,a,d,u,c,l))}requestWillBeSentExtraInfo({requestId:e,associatedCookies:t,headers:s,clientSecurityState:r,connectTiming:n}){const o=[],i=[];for(const{blockedReasons:e,cookie:s}of t)0===e.length?i.push(Cookie.fromProtocolCookie(s)):o.push({blockedReasons:e,cookie:Cookie.fromProtocolCookie(s)});const a={blockedRequestCookies:o,includedRequestCookies:i,requestHeaders:this.headersMapToHeadersArray(s),clientSecurityState:r,connectTiming:n};this.getExtraInfoBuilder(e).addRequestExtraInfo(a)}responseReceivedExtraInfo({requestId:e,blockedCookies:t,headers:s,headersText:r,resourceIPAddressSpace:n,statusCode:o}){const i={blockedResponseCookies:t.map((e=>({blockedReasons:e.blockedReasons,cookieLine:e.cookieLine,cookie:e.cookie?Cookie.fromProtocolCookie(e.cookie):null}))),responseHeaders:this.headersMapToHeadersArray(s),responseHeadersText:r,resourceIPAddressSpace:n,statusCode:o};this.getExtraInfoBuilder(e).addResponseExtraInfo(i)}getExtraInfoBuilder(e){let t;return this.#o.has(e)?t=this.#o.get(e):(t=new ExtraInfoBuilder,this.#o.set(e,t)),t}appendRedirect(e,t,s){const r=this.#r.get(e);if(!r)throw new Error(`Could not find original network request for ${e}`);let n=0;for(let e=r.redirectSource();e;e=e.redirectSource())n++;r.markAsRedirect(n),this.finishNetworkRequest(r,t,-1);const o=NetworkRequest.create(e,s,r.documentURL,r.frameId,r.loaderId,r.initiator());return requestToManagerMap.set(o,this.#s),o.setRedirectSource(r),r.setRedirectDestination(o),o}maybeAdoptMainResourceRequest(e){const t=MultitargetNetworkManager.instance().inflightMainResourceRequests.get(e);if(!t)return null;const s=NetworkManager.forRequest(t).dispatcher;return s.#r.delete(e),s.#n.delete(t.url()),this.#r.set(e,t),this.#n.set(t.url(),t),requestToManagerMap.set(t,this.#s),t}startNetworkRequest(e,t){this.#r.set(e.requestId(),e),this.#n.set(e.url(),e),e.loaderId===e.requestId()&&MultitargetNetworkManager.instance().inflightMainResourceRequests.set(e.requestId(),e),this.#s.dispatchEventToListeners(Events.RequestStarted,{request:e,originalRequest:t})}updateNetworkRequest(e){this.#s.dispatchEventToListeners(Events.RequestUpdated,e)}finishNetworkRequest(e,t,s,r){if(e.endTime=t,e.finished=!0,s>=0){const t=e.redirectSource();t&&t.signedExchangeInfo()?(e.setTransferSize(0),t.setTransferSize(s),this.updateNetworkRequest(t)):e.setTransferSize(s)}if(this.#s.dispatchEventToListeners(Events.RequestFinished,e),MultitargetNetworkManager.instance().inflightMainResourceRequests.delete(e.requestId()),r){const t=i18nString(UIStrings.crossoriginReadBlockingCorb,{PH1:e.url(),PH2:e.mimeType});this.#s.dispatchEventToListeners(Events.MessageGenerated,{message:t,requestId:e.requestId(),warning:!0})}if(Common.Settings.Settings.instance().moduleSetting("monitoringXHREnabled").get()&&e.resourceType().category()===Common.ResourceType.resourceCategories.XHR){let t;const s=e.failed||e.hasErrorStatusCode();t=i18nString(s?UIStrings.sFailedLoadingSS:UIStrings.sFinishedLoadingSS,{PH1:e.resourceType().title(),PH2:e.requestMethod,PH3:e.url()}),this.#s.dispatchEventToListeners(Events.MessageGenerated,{message:t,requestId:e.requestId(),warning:!1})}}clearRequests(){this.#r.clear(),this.#n.clear(),this.#o.clear()}webTransportCreated({transportId:e,url:t,timestamp:s,initiator:r}){const n=NetworkRequest.createForWebSocket(e,t,r);n.hasNetworkData=!0,requestToManagerMap.set(n,this.#s),n.setResourceType(Common.ResourceType.resourceTypes.WebTransport),n.setIssueTime(s,0),this.startNetworkRequest(n,null)}webTransportConnectionEstablished({transportId:e,timestamp:t}){const s=this.#r.get(e);s&&(s.responseReceivedTime=t,s.endTime=t+.001,this.updateNetworkRequest(s))}webTransportClosed({transportId:e,timestamp:t}){const s=this.#r.get(e);s&&(s.endTime=t,this.finishNetworkRequest(s,t,0))}trustTokenOperationDone(e){const t=this.#r.get(e.requestId);t?t.setTrustTokenOperationDoneEvent(e):this.#i.set(e.requestId,e)}subresourceWebBundleMetadataReceived({requestId:e,urls:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInfo({resourceUrls:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleMetadataError({requestId:e,errorMessage:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInfo({errorMessage:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleInnerResponseParsed({innerRequestId:e,bundleRequestId:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInnerRequestInfo({bundleRequestId:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleInnerResponseError({innerRequestId:e,errorMessage:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInnerRequestInfo({errorMessage:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}reportingApiReportAdded(e){this.#s.dispatchEventToListeners(Events.ReportingApiReportAdded,e.report)}reportingApiReportUpdated(e){this.#s.dispatchEventToListeners(Events.ReportingApiReportUpdated,e.report)}reportingApiEndpointsChangedForOrigin(e){this.#s.dispatchEventToListeners(Events.ReportingApiEndpointsChangedForOrigin,e)}createNetworkRequest(e,t,s,r,n,o){const i=NetworkRequest.create(e,r,n,t,s,o);return requestToManagerMap.set(i,this.#s),i}}let multiTargetNetworkManagerInstance;export class MultitargetNetworkManager extends Common.ObjectWrapper.ObjectWrapper{#a;#d;#u;#c;inflightMainResourceRequests;#l;#h;#g;#p;#R;#q;#f;#k;constructor(){super(),this.#a="",this.#d=null,this.#u=null,this.#c=new Set,this.inflightMainResourceRequests=new Map,this.#l=NoThrottlingConditions,this.#h=null,this.#g=Common.Settings.Settings.instance().moduleSetting("requestBlockingEnabled"),this.#p=Common.Settings.Settings.instance().createSetting("networkBlockedPatterns",[]),this.#R=[],this.updateBlockedPatterns(),this.#q=new Platform.MapUtilities.Multimap,TargetManager.instance().observeModels(NetworkManager,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return multiTargetNetworkManagerInstance&&!t||(multiTargetNetworkManagerInstance=new MultitargetNetworkManager),multiTargetNetworkManagerInstance}static getChromeVersion(){const e=navigator.userAgent.match(/(?:^|\W)(?:Chrome|HeadlessChrome)\/(\S+)/);return e&&e.length>1?e[1]:""}static patchUserAgentWithChromeVersion(e){const t=MultitargetNetworkManager.getChromeVersion();if(t.length>0){const s=t.split(".",1)[0]+".0.100.0";return Platform.StringUtilities.sprintf(e,t,s)}return e}static patchUserAgentMetadataWithChromeVersion(e){if(!e.brands)return;const t=MultitargetNetworkManager.getChromeVersion();if(0===t.length)return;const s=t.split(".",1)[0];for(const t of e.brands)t.version.includes("%s")&&(t.version=Platform.StringUtilities.sprintf(t.version,s));e.fullVersion&&e.fullVersion.includes("%s")&&(e.fullVersion=Platform.StringUtilities.sprintf(e.fullVersion,t))}modelAdded(e){const t=e.target().networkAgent();this.#f&&t.invoke_setExtraHTTPHeaders({headers:this.#f}),this.currentUserAgent()&&t.invoke_setUserAgentOverride({userAgent:this.currentUserAgent(),userAgentMetadata:this.#d||void 0}),this.#R.length&&t.invoke_setBlockedURLs({urls:this.#R}),this.isIntercepting()&&t.invoke_setRequestInterception({patterns:this.#q.valuesArray()}),null===this.#u?t.invoke_clearAcceptedEncodingsOverride():t.invoke_setAcceptedEncodings({encodings:this.#u}),this.#c.add(t),this.isThrottling()&&this.updateNetworkConditions(t)}modelRemoved(e){for(const t of this.inflightMainResourceRequests){NetworkManager.forRequest(t[1])===e&&this.inflightMainResourceRequests.delete(t[0])}this.#c.delete(e.target().networkAgent())}isThrottling(){return this.#l.download>=0||this.#l.upload>=0||this.#l.latency>0}isOffline(){return!this.#l.download&&!this.#l.upload}setNetworkConditions(e){this.#l=e;for(const e of this.#c)this.updateNetworkConditions(e);this.dispatchEventToListeners(MultitargetNetworkManager.Events.ConditionsChanged)}networkConditions(){return this.#l}updateNetworkConditions(e){const t=this.#l;this.isThrottling()?e.invoke_emulateNetworkConditions({offline:this.isOffline(),latency:t.latency,downloadThroughput:t.download<0?0:t.download,uploadThroughput:t.upload<0?0:t.upload,connectionType:NetworkManager.connectionType(t)}):e.invoke_emulateNetworkConditions({offline:!1,latency:0,downloadThroughput:0,uploadThroughput:0})}setExtraHTTPHeaders(e){this.#f=e;for(const e of this.#c)e.invoke_setExtraHTTPHeaders({headers:this.#f})}currentUserAgent(){return this.#k?this.#k:this.#a}updateUserAgentOverride(){const e=this.currentUserAgent();for(const t of this.#c)t.invoke_setUserAgentOverride({userAgent:e,userAgentMetadata:this.#d||void 0})}setUserAgentOverride(e,t){const s=this.#a!==e;this.#a=e,this.#k?this.#d=null:(this.#d=t,this.updateUserAgentOverride()),s&&this.dispatchEventToListeners(MultitargetNetworkManager.Events.UserAgentChanged)}userAgentOverride(){return this.#a}setCustomUserAgentOverride(e,t=null){this.#k=e,this.#d=t,this.updateUserAgentOverride()}setCustomAcceptedEncodingsOverride(e){this.#u=e,this.updateAcceptedEncodingsOverride(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.AcceptedEncodingsChanged)}clearCustomAcceptedEncodingsOverride(){this.#u=null,this.updateAcceptedEncodingsOverride(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.AcceptedEncodingsChanged)}isAcceptedEncodingOverrideSet(){return null!==this.#u}updateAcceptedEncodingsOverride(){const e=this.#u;for(const t of this.#c)null===e?t.invoke_clearAcceptedEncodingsOverride():t.invoke_setAcceptedEncodings({encodings:e})}blockedPatterns(){return this.#p.get().slice()}blockingEnabled(){return this.#g.get()}isBlocking(){return Boolean(this.#R.length)}setBlockedPatterns(e){this.#p.set(e),this.updateBlockedPatterns(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.BlockedPatternsChanged)}setBlockingEnabled(e){this.#g.get()!==e&&(this.#g.set(e),this.updateBlockedPatterns(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.BlockedPatternsChanged))}updateBlockedPatterns(){const e=[];if(this.#g.get())for(const t of this.#p.get())t.enabled&&e.push(t.url);if(e.length||this.#R.length){this.#R=e;for(const e of this.#c)e.invoke_setBlockedURLs({urls:this.#R})}}isIntercepting(){return Boolean(this.#q.size)}setInterceptionHandlerForPatterns(e,t){this.#q.deleteAll(t);for(const s of e)this.#q.set(t,s);return this.updateInterceptionPatternsOnNextTick()}updateInterceptionPatternsOnNextTick(){return this.#h||(this.#h=Promise.resolve().then(this.updateInterceptionPatterns.bind(this))),this.#h}async updateInterceptionPatterns(){Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()||Common.Settings.Settings.instance().moduleSetting("cacheDisabled").set(!0),this.#h=null;const e=[];for(const t of this.#c)e.push(t.invoke_setRequestInterception({patterns:this.#q.valuesArray()}));this.dispatchEventToListeners(MultitargetNetworkManager.Events.InterceptorsChanged),await Promise.all(e)}async requestIntercepted(e){for(const t of this.#q.keysArray())if(await t(e),e.hasResponded())return;e.hasResponded()||e.continueRequestWithoutChange()}clearBrowserCache(){for(const e of this.#c)e.invoke_clearBrowserCache()}clearBrowserCookies(){for(const e of this.#c)e.invoke_clearBrowserCookies()}async getCertificate(e){const t=TargetManager.instance().mainTarget();if(!t)return[];const s=await t.networkAgent().invoke_getCertificate({origin:e});return s?s.tableNames:[]}async loadResource(e){const t={},s=this.currentUserAgent();return s&&(t["User-Agent"]=s),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()&&(t["Cache-Control"]="no-cache"),new Promise((s=>Host.ResourceLoader.load(e,t,((e,t,r,n)=>{s({success:e,content:r,errorDescription:n})}))))}}!function(e){let t;!function(e){e.BlockedPatternsChanged="BlockedPatternsChanged",e.ConditionsChanged="ConditionsChanged",e.UserAgentChanged="UserAgentChanged",e.InterceptorsChanged="InterceptorsChanged",e.AcceptedEncodingsChanged="AcceptedEncodingsChanged"}(t=e.Events||(e.Events={}))}(MultitargetNetworkManager||(MultitargetNetworkManager={}));export class InterceptedRequest{#e;#I;#m;request;frameId;resourceType;isNavigationRequest;isDownload;redirectUrl;authChallenge;responseErrorReason;responseStatusCode;responseHeaders;requestId;constructor(e,t,s,r,n,o,i,a,d,u,c,l,h){this.#e=e,this.#I=t,this.#m=!1,this.request=s,this.frameId=r,this.resourceType=n,this.isNavigationRequest=o,this.isDownload=Boolean(i),this.redirectUrl=a,this.authChallenge=d,this.responseErrorReason=u,this.responseStatusCode=c,this.responseHeaders=l,this.requestId=h}hasResponded(){return this.#m}async continueRequestWithContent(e){this.#m=!0;const t=["HTTP/1.1 200 OK","Date: "+(new Date).toUTCString(),"Server: Chrome Devtools Request Interceptor","Connection: closed","Content-Length: "+e.size,"Content-Type: "+e.type||"text/x-unknown"],s=await async function(e){const t=new FileReader,s=new Promise((e=>{t.onloadend=e}));if(t.readAsDataURL(e),await s,t.error)return console.error("Could not convert blob to base64.",t.error),"";const r=t.result;if(null==r||"string"!=typeof r)return console.error("Could not convert blob to base64."),"";return r.substring(r.indexOf(",")+1)}(new Blob([t.join("\r\n"),"\r\n\r\n",e]));this.#e.invoke_continueInterceptedRequest({interceptionId:this.#I,rawResponse:s})}continueRequestWithoutChange(){console.assert(!this.#m),this.#m=!0,this.#e.invoke_continueInterceptedRequest({interceptionId:this.#I})}continueRequestWithError(e){console.assert(!this.#m),this.#m=!0,this.#e.invoke_continueInterceptedRequest({interceptionId:this.#I,errorReason:e})}async responseBody(){const e=await this.#e.invoke_getResponseBodyForInterception({interceptionId:this.#I}),t=e.getError()||null;return{error:t,content:t?null:e.body,encoded:e.base64Encoded}}}class ExtraInfoBuilder{#w;#T;#v;#S;#y;#E;#C;constructor(){this.#w=[],this.#T=[],this.#v=[],this.#S=!1,this.#y=!1,this.#E=null,this.#C=null}addRequest(e){this.#w.push(e),this.sync(this.#w.length-1)}addRequestExtraInfo(e){this.#y=!0,this.#T.push(e),this.sync(this.#T.length-1)}addResponseExtraInfo(e){this.#v.push(e),this.sync(this.#v.length-1)}setWebBundleInfo(e){this.#E=e,this.updateFinalRequest()}setWebBundleInnerRequestInfo(e){this.#C=e,this.updateFinalRequest()}finished(){this.#S=!0,this.updateFinalRequest()}sync(e){const t=this.#w[e];if(!t)return;const s=this.#T[e];s&&(t.addExtraRequestInfo(s),this.#T[e]=null);const r=this.#v[e];r&&(t.addExtraResponseInfo(r),this.#v[e]=null)}finalRequest(){return this.#S&&this.#w[this.#w.length-1]||null}updateFinalRequest(){if(!this.#S)return;const e=this.finalRequest();e?.setWebBundleInfo(this.#E),e?.setWebBundleInnerRequestInfo(this.#C)}}SDKModel.register(NetworkManager,{capabilities:Capability.Network,autostart:!0});export class ConditionsSerializer{stringify(e){const t=e;return JSON.stringify({...t,title:"function"==typeof t.title?t.title():t.title})}parse(e){const t=JSON.parse(e);return{...t,title:t.i18nTitleKey?i18nLazyString(t.i18nTitleKey):t.title}}}export function networkConditionsEqual(e,t){const s="function"==typeof e.title?e.title():e.title,r="function"==typeof t.title?t.title():t.title;return t.download===e.download&&t.upload===e.upload&&t.latency===e.latency&&r===s}