import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import{Attributes}from"./Cookie.js";import{CookieParser}from"./CookieParser.js";import{NetworkManager,Events as NetworkManagerEvents}from"./NetworkManager.js";import{Type}from"./Target.js";import{ServerTiming}from"./ServerTiming.js";const UIStrings={binary:"(binary)",secureOnly:'This cookie was blocked because it had the "`Secure`" attribute and the connection was not secure.',notOnPath:"This cookie was blocked because its path was not an exact match for or a superdirectory of the request url's path.",domainMismatch:"This cookie was blocked because neither did the request URL's domain exactly match the cookie's domain, nor was the request URL's domain a subdomain of the cookie's Domain attribute value.",sameSiteStrict:'This cookie was blocked because it had the "`SameSite=Strict`" attribute and the request was made from a different site. This includes top-level navigation requests initiated by other sites.',sameSiteLax:'This cookie was blocked because it had the "`SameSite=Lax`" attribute and the request was made from a different site and was not initiated by a top-level navigation.',sameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "`SameSite`" attribute when it was stored and was defaulted to "SameSite=Lax," and was blocked because the request was made from a different site and was not initiated by a top-level navigation. The cookie had to have been set with "`SameSite=None`" to enable cross-site usage.',sameSiteNoneInsecure:'This cookie was blocked because it had the "`SameSite=None`" attribute but was not marked "Secure". Cookies without SameSite restrictions must be marked "Secure" and sent over a secure connection.',userPreferences:"This cookie was blocked due to user preferences.",unknownError:"An unknown error was encountered when trying to send this cookie.",schemefulSameSiteStrict:'This cookie was blocked because it had the "`SameSite=Strict`" attribute but the request was cross-site. This includes top-level navigation requests initiated by other sites. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteLax:'This cookie was blocked because it had the "`SameSite=Lax`" attribute but the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "`SameSite`" attribute when it was stored, was defaulted to "`SameSite=Lax"`, and was blocked because the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',samePartyFromCrossPartyContext:"This cookie was blocked because it had the \"`SameParty`\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",nameValuePairExceedsMaxSize:"This cookie was blocked because it was too large. The combined size of the name and value must be less than or equal to 4096 characters.",thisSetcookieWasBlockedDueToUser:"This attempt to set a cookie via a `Set-Cookie` header was blocked due to user preferences.",thisSetcookieHadInvalidSyntax:"This `Set-Cookie` header had invalid syntax.",theSchemeOfThisConnectionIsNot:"The scheme of this connection is not allowed to store cookies.",anUnknownErrorWasEncounteredWhenTrying:"An unknown error was encountered when trying to store this cookie.",thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "{PH1}" attribute but came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieDidntSpecifyASamesite:'This `Set-Cookie` header didn\'t specify a "`SameSite`" attribute, was defaulted to "`SameSite=Lax"`, and was blocked because it came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieWasBlockedBecauseItHadTheSameparty:"This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the \"`SameParty`\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "`SameParty`" attribute but also had other conflicting attributes. Chrome requires cookies that use the "`SameParty`" attribute to also have the "Secure" attribute, and to not be restricted to "`SameSite=Strict`".',blockedReasonSecureOnly:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "Secure" attribute but was not received over a secure connection.',blockedReasonSameSiteStrictLax:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "{PH1}" attribute but came from a cross-site response which was not the response to a top-level navigation.',blockedReasonSameSiteUnspecifiedTreatedAsLax:'This `Set-Cookie` header didn\'t specify a "`SameSite`" attribute and was defaulted to "`SameSite=Lax,`" and was blocked because it came from a cross-site response which was not the response to a top-level navigation. The `Set-Cookie` had to have been set with "`SameSite=None`" to enable cross-site usage.',blockedReasonSameSiteNoneInsecure:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "`SameSite=None`" attribute but did not have the "Secure" attribute, which is required in order to use "`SameSite=None`".',blockedReasonOverwriteSecure:"This attempt to set a cookie via a `Set-Cookie` header was blocked because it was not sent over a secure connection and would have overwritten a cookie with the Secure attribute.",blockedReasonInvalidDomain:"This attempt to set a cookie via a `Set-Cookie` header was blocked because its Domain attribute was invalid with regards to the current host url.",blockedReasonInvalidPrefix:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it used the "`__Secure-`" or "`__Host-`" prefix in its name and broke the additional rules applied to cookies with these prefixes as defined in `https://tools.ietf.org/html/draft-west-cookie-prefixes-05`.',thisSetcookieWasBlockedBecauseTheNameValuePairExceedsMaxSize:"This attempt to set a cookie via a `Set-Cookie` header was blocked because the cookie was too large. The combined size of the name and value must be less than or equal to 4096 characters.",setcookieHeaderIsIgnoredIn:"Set-Cookie header is ignored in response from url: {PH1}. The combined size of the name and value must be less than or equal to 4096 characters."},str_=i18n.i18n.registerUIStrings("core/sdk/NetworkRequest.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export var MIME_TYPE;!function(e){e.HTML="text/html",e.XML="text/xml",e.PLAIN="text/plain",e.XHTML="application/xhtml+xml",e.SVG="image/svg+xml",e.CSS="text/css",e.XSL="text/xsl",e.VTT="text/vtt",e.PDF="application/pdf",e.EVENTSTREAM="text/event-stream"}(MIME_TYPE||(MIME_TYPE={}));export class NetworkRequest extends Common.ObjectWrapper.ObjectWrapper{#e;#t;#r;#s;#n;#a;#i;#o;#c;#h;#l;#u;#d;#m;#I;#S;statusCode;statusText;requestMethod;requestTime;protocol;mixedContentType;#p;#f;#g;#k;#T;#R;#b;#v;#y;#P;#x;#q;#C;#w;#U;#L;#E;#H;connectionId;connectionReused;hasNetworkData;#D;#A;#N;#M;#F;#B;#W;localizedFailDescription;#V;#O;#z;#j;#$;#_;#Q;#X;#Y;#G;#J;#K;#Z;#ee;#te;#re;#se;#ne;#ae;#ie;#oe;#ce;#he;#le;#ue;#de;#me;#Ie;#Se;#pe;#fe;#ge;#ke;constructor(e,t,r,s,n,a,i){super(),this.#e=e,this.#t=t,this.setUrl(r),this.#r=s,this.#s=n,this.#n=a,this.#a=i,this.#i=null,this.#o=null,this.#c=null,this.#h=!1,this.#l=null,this.#u=-1,this.#d=-1,this.#m=-1,this.#I=void 0,this.#S=void 0,this.statusCode=0,this.statusText="",this.requestMethod="",this.requestTime=0,this.protocol="",this.mixedContentType="none",this.#p=null,this.#f=null,this.#g=null,this.#k=null,this.#T=null,this.#R=Common.ResourceType.resourceTypes.Other,this.#b=null,this.#v=[],this.#y=[],this.#P={},this.#x="",this.#q=[],this.#C={},this.#w="",this.#U="Unknown",this.#L=null,this.#E="unknown",this.#H=null,this.connectionId="0",this.connectionReused=!1,this.hasNetworkData=!1,this.#D=null,this.#A=Promise.resolve(null),this.#N=!1,this.#M=!1,this.#F=[],this.#B=[],this.#W=[],this.localizedFailDescription=null,this.#ke=null}static create(e,t,r,s,n,a){return new NetworkRequest(e,e,t,r,s,n,a)}static createForWebSocket(e,t,r){return new NetworkRequest(e,e,t,"",null,null,r||null)}static createWithoutBackendRequest(e,t,r,s){return new NetworkRequest(e,void 0,t,r,null,null,s)}identityCompare(e){const t=this.requestId(),r=e.requestId();return t>r?1:t<r?-1:0}requestId(){return this.#e}backendRequestId(){return this.#t}url(){return this.#V}isBlobRequest(){return this.#V.startsWith("blob:")}setUrl(e){this.#V!==e&&(this.#V=e,this.#Y=new Common.ParsedURL.ParsedURL(e),this.#pe=void 0,this.#fe=void 0,this.#G=void 0,this.#J=void 0)}get documentURL(){return this.#r}get parsedURL(){return this.#Y}get frameId(){return this.#s}get loaderId(){return this.#n}setRemoteAddress(e,t){this.#w=e+":"+t,this.dispatchEventToListeners(Events.RemoteAddressChanged,this)}remoteAddress(){return this.#w}remoteAddressSpace(){return this.#U}getResponseCacheStorageCacheName(){return this.#te}setResponseCacheStorageCacheName(e){this.#te=e}serviceWorkerResponseSource(){return this.#re}setServiceWorkerResponseSource(e){this.#re=e}setReferrerPolicy(e){this.#L=e}referrerPolicy(){return this.#L}securityState(){return this.#E}setSecurityState(e){this.#E=e}securityDetails(){return this.#H}securityOrigin(){return this.#Y.securityOrigin()}setSecurityDetails(e){this.#H=e}get startTime(){return this.#d||-1}setIssueTime(e,t){this.#u=e,this.#se=t,this.#d=e}issueTime(){return this.#u}pseudoWallTime(e){return this.#se?this.#se-this.#u+e:e}get responseReceivedTime(){return this.#O||-1}set responseReceivedTime(e){this.#O=e}getResponseRetrievalTime(){return this.#ne}setResponseRetrievalTime(e){this.#ne=e}get endTime(){return this.#m||-1}set endTime(e){this.timing&&this.timing.requestTime?this.#m=Math.max(e,this.responseReceivedTime):(this.#m=e,this.#O>e&&(this.#O=e)),this.dispatchEventToListeners(Events.TimingChanged,this)}get duration(){return-1===this.#m||-1===this.#d?-1:this.#m-this.#d}get latency(){return-1===this.#O||-1===this.#d?-1:this.#O-this.#d}get resourceSize(){return this.#ae||0}set resourceSize(e){this.#ae=e}get transferSize(){return this.#z||0}increaseTransferSize(e){this.#z=(this.#z||0)+e}setTransferSize(e){this.#z=e}get finished(){return this.#j}set finished(e){this.#j!==e&&(this.#j=e,e&&this.dispatchEventToListeners(Events.FinishedLoading,this))}get failed(){return this.#$}set failed(e){this.#$=e}get canceled(){return this.#_}set canceled(e){this.#_=e}get preserved(){return this.#Q}set preserved(e){this.#Q=e}blockedReason(){return this.#I}setBlockedReason(e){this.#I=e}corsErrorStatus(){return this.#S}setCorsErrorStatus(e){this.#S=e}wasBlocked(){return Boolean(this.#I)}cached(){return(Boolean(this.#ie)||Boolean(this.#oe))&&!this.#z}cachedInMemory(){return Boolean(this.#ie)&&!this.#z}fromPrefetchCache(){return Boolean(this.#ce)}setFromMemoryCache(){this.#ie=!0,this.#le=void 0}get fromDiskCache(){return this.#oe}setFromDiskCache(){this.#oe=!0}setFromPrefetchCache(){this.#ce=!0}get fetchedViaServiceWorker(){return Boolean(this.#he)}set fetchedViaServiceWorker(e){this.#he=e}initiatedByServiceWorker(){const e=NetworkManager.forRequest(this);return!!e&&e.target().type()===Type.ServiceWorker}get timing(){return this.#le}set timing(e){if(!e||this.#ie)return;this.#d=e.requestTime;const t=e.requestTime+e.receiveHeadersEnd/1e3;((this.#O||-1)<0||this.#O>t)&&(this.#O=t),this.#d>this.#O&&(this.#O=this.#d),this.#le=e,this.dispatchEventToListeners(Events.TimingChanged,this)}setConnectTimingFromExtraInfo(e){this.#d=e.requestTime,this.dispatchEventToListeners(Events.TimingChanged,this)}get mimeType(){return this.#X}set mimeType(e){this.#X=e}get displayName(){return this.#Y.displayName}name(){return this.#G||this.parseNameAndPathFromURL(),this.#G}path(){return this.#J||this.parseNameAndPathFromURL(),this.#J}parseNameAndPathFromURL(){if(this.#Y.isDataURL())this.#G=this.#Y.dataURLDisplayName(),this.#J="";else if(this.#Y.isBlobURL())this.#G=this.#Y.url,this.#J="";else if(this.#Y.isAboutBlank())this.#G=this.#Y.url,this.#J="";else{this.#J=this.#Y.host+this.#Y.folderPathComponents;const e=NetworkManager.forRequest(this),t=e?Common.ParsedURL.ParsedURL.fromString(e.target().inspectedURL()):null;this.#J=Platform.StringUtilities.trimURL(this.#J,t?t.host:""),this.#Y.lastPathComponent||this.#Y.queryParams?this.#G=this.#Y.lastPathComponent+(this.#Y.queryParams?"?"+this.#Y.queryParams:""):this.#Y.folderPathComponents?(this.#G=this.#Y.folderPathComponents.substring(this.#Y.folderPathComponents.lastIndexOf("/")+1)+"/",this.#J=this.#J.substring(0,this.#J.lastIndexOf("/"))):(this.#G=this.#Y.host,this.#J="")}}get folder(){let e=this.#Y.path;const t=e.indexOf("?");-1!==t&&(e=e.substring(0,t));const r=e.lastIndexOf("/");return-1!==r?e.substring(0,r):""}get pathname(){return this.#Y.path}resourceType(){return this.#R}setResourceType(e){this.#R=e}get domain(){return this.#Y.host}get scheme(){return this.#Y.scheme}redirectSource(){return this.#i}setRedirectSource(e){this.#i=e}preflightRequest(){return this.#o}setPreflightRequest(e){this.#o=e}preflightInitiatorRequest(){return this.#c}setPreflightInitiatorRequest(e){this.#c=e}isPreflightRequest(){return null!==this.#a&&void 0!==this.#a&&"preflight"===this.#a.type}redirectDestination(){return this.#l}setRedirectDestination(e){this.#l=e}requestHeaders(){return this.#q}setRequestHeaders(e){this.#q=e,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeadersText(){return this.#ue}setRequestHeadersText(e){this.#ue=e,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeaderValue(e){return this.#C[e]||(this.#C[e]=this.computeHeaderValue(this.requestHeaders(),e)),this.#C[e]}requestFormData(){return this.#A||(this.#A=NetworkManager.requestPostData(this)),this.#A}setRequestFormData(e,t){this.#A=e&&null===t?null:Promise.resolve(t),this.#D=null}filteredProtocolName(){const e=this.protocol.toLowerCase();return"h2"===e?"http/2.0":e.replace(/^http\/2(\.0)?\+/,"http/2.0+")}requestHttpVersion(){const e=this.requestHeadersText();if(!e){const e=this.requestHeaderValue("version")||this.requestHeaderValue(":version");return e||this.filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/(HTTP\/\d+\.\d+)$/);return t?t[1]:"HTTP/0.9"}get responseHeaders(){return this.#de||[]}set responseHeaders(e){this.#de=e,this.#me=void 0,this.#Se=void 0,this.#Ie=void 0,this.#P={},this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get responseHeadersText(){return this.#x}set responseHeadersText(e){this.#x=e,this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get sortedResponseHeaders(){return void 0!==this.#me||(this.#me=this.responseHeaders.slice(),this.#me.sort((function(e,t){return Platform.StringUtilities.compare(e.name.toLowerCase(),t.name.toLowerCase())}))),this.#me}responseHeaderValue(e){return e in this.#P||(this.#P[e]=this.computeHeaderValue(this.responseHeaders,e)),this.#P[e]}get responseCookies(){return this.#Ie||(this.#Ie=CookieParser.parseSetCookie(this.responseHeaderValue("Set-Cookie"),this.domain)||[]),this.#Ie}responseLastModified(){return this.responseHeaderValue("last-modified")}allCookiesIncludingBlockedOnes(){return[...this.includedRequestCookies(),...this.responseCookies,...this.blockedRequestCookies().map((e=>e.cookie)),...this.blockedResponseCookies().map((e=>e.cookie))].filter((e=>Boolean(e)))}get serverTimings(){return void 0===this.#Se&&(this.#Se=ServerTiming.parseHeaders(this.responseHeaders)),this.#Se}queryString(){if(void 0!==this.#pe)return this.#pe;let e=null;const t=this.url(),r=t.indexOf("?");if(-1!==r){e=t.substring(r+1);const s=e.indexOf("#");-1!==s&&(e=e.substring(0,s))}return this.#pe=e,this.#pe}get queryParameters(){if(this.#fe)return this.#fe;const e=this.queryString();return e?(this.#fe=this.parseParameters(e),this.#fe):null}async parseFormParameters(){const e=this.requestContentType();if(!e)return null;if(e.match(/^application\/x-www-form-urlencoded\s*(;.*)?$/i)){const e=await this.requestFormData();return e?this.parseParameters(e):null}const t=e.match(/^multipart\/form-data\s*;\s*boundary\s*=\s*(\S+)\s*$/);if(!t)return null;const r=t[1];if(!r)return null;const s=await this.requestFormData();return s?this.parseMultipartFormDataParameters(s,r):null}formParameters(){return this.#D||(this.#D=this.parseFormParameters()),this.#D}responseHttpVersion(){const e=this.#x;if(!e){const e=this.responseHeaderValue("version")||this.responseHeaderValue(":version");return e||this.filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/^(HTTP\/\d+\.\d+)/);return t?t[1]:"HTTP/0.9"}parseParameters(e){return e.split("&").map((function(e){const t=e.indexOf("=");return-1===t?{name:e,value:""}:{name:e.substring(0,t),value:e.substring(t+1)}}))}parseMultipartFormDataParameters(e,t){const r=Platform.StringUtilities.escapeForRegExp(t),s=new RegExp('^\\r\\ncontent-disposition\\s*:\\s*form-data\\s*;\\s*name="([^"]*)"(?:\\s*;\\s*filename="([^"]*)")?(?:\\r\\ncontent-type\\s*:\\s*([^\\r\\n]*))?\\r\\n\\r\\n(.*)\\r\\n$',"is");return e.split(new RegExp(`--${r}(?:--s*$)?`,"g")).reduce((function(e,t){const[r,n,a,i,o]=t.match(s)||[];if(!r)return e;const c=a||i?i18nString(UIStrings.binary):o;return e.push({name:n,value:c}),e}),[])}computeHeaderValue(e,t){t=t.toLowerCase();const r=[];for(let s=0;s<e.length;++s)e[s].name.toLowerCase()===t&&r.push(e[s].value);if(r.length)return"set-cookie"===t?r.join("\n"):r.join(", ")}contentData(){return this.#b||(this.#ge?this.#b=this.#ge():this.#b=NetworkManager.requestContentData(this)),this.#b}setContentDataProvider(e){console.assert(!this.#b,"contentData can only be set once."),this.#ge=e}contentURL(){return this.#V}contentType(){return this.#R}async contentEncoded(){return(await this.contentData()).encoded}async requestContent(){const{content:e,error:t,encoded:r}=await this.contentData();return{content:e,error:t,isEncoded:r}}async searchInContent(e,t,r){if(!this.#ge)return NetworkManager.searchInRequest(this,e,t,r);const s=await this.contentData();let n=s.content;return n?(s.encoded&&(n=window.atob(n)),TextUtils.TextUtils.performSearchInContent(n,e,t,r)):[]}isHttpFamily(){return Boolean(this.url().match(/^https?:/i))}requestContentType(){return this.requestHeaderValue("Content-Type")}hasErrorStatusCode(){return this.statusCode>=400}setInitialPriority(e){this.#p=e}initialPriority(){return this.#p}setPriority(e){this.#f=e}priority(){return this.#f||this.#p||null}setSignedExchangeInfo(e){this.#g=e}signedExchangeInfo(){return this.#g}setWebBundleInfo(e){this.#k=e}webBundleInfo(){return this.#k}setWebBundleInnerRequestInfo(e){this.#T=e}webBundleInnerRequestInfo(){return this.#T}async populateImageSource(e){const{content:t,encoded:r}=await this.contentData();let s=TextUtils.ContentProvider.contentAsDataURL(t,this.#X,r);if(null===s&&!this.#$){(this.responseHeaderValue("cache-control")||"").includes("no-cache")||(s=this.#V)}null!==s&&(e.src=s)}initiator(){return this.#a||null}frames(){return this.#v}addProtocolFrameError(e,t){this.addFrame({type:WebSocketFrameType.Error,text:e,time:this.pseudoWallTime(t),opCode:-1,mask:!1})}addProtocolFrame(e,t,r){const s=r?WebSocketFrameType.Send:WebSocketFrameType.Receive;this.addFrame({type:s,text:e.payloadData,time:this.pseudoWallTime(t),opCode:e.opcode,mask:e.mask})}addFrame(e){this.#v.push(e),this.dispatchEventToListeners(Events.WebsocketFrameAdded,e)}eventSourceMessages(){return this.#y}addEventSourceMessage(e,t,r,s){const n={time:this.pseudoWallTime(e),eventName:t,eventId:r,data:s};this.#y.push(n),this.dispatchEventToListeners(Events.EventSourceMessageAdded,n)}markAsRedirect(e){this.#h=!0,this.#e=`${this.#t}:redirected.${e}`}isRedirect(){return this.#h}setRequestIdForTest(e){this.#t=e,this.#e=e}charset(){const e=this.responseHeaderValue("content-type");if(!e)return null;const t=e.replace(/ /g,"").split(";").filter((e=>e.toLowerCase().startsWith("charset="))).map((e=>e.slice("charset=".length)));return t.length?t[0]:null}addExtraRequestInfo(e){this.#F=e.blockedRequestCookies,this.#B=e.includedRequestCookies,this.setRequestHeaders(e.requestHeaders),this.#N=!0,this.setRequestHeadersText(""),this.#K=e.clientSecurityState,this.setConnectTimingFromExtraInfo(e.connectTiming)}hasExtraRequestInfo(){return this.#N}blockedRequestCookies(){return this.#F}includedRequestCookies(){return this.#B}hasRequestCookies(){return this.#B.length>0||this.#F.length>0}addExtraResponseInfo(e){if(this.#W=e.blockedResponseCookies,this.responseHeaders=e.responseHeaders,e.responseHeadersText&&(this.responseHeadersText=e.responseHeadersText,!this.requestHeadersText())){let e=`${this.requestMethod} ${this.parsedURL.path}`;this.parsedURL.queryParams&&(e+=`?${this.parsedURL.queryParams}`),e+=" HTTP/1.1\r\n";for(const{name:t,value:r}of this.requestHeaders())e+=`${t}: ${r}\r\n`;this.setRequestHeadersText(e)}this.#U=e.resourceIPAddressSpace,e.statusCode&&(this.statusCode=e.statusCode),this.#M=!0;const t=NetworkManager.forRequest(this);if(t)for(const e of this.#W)if(e.blockedReasons.includes("NameValuePairExceedsMaxSize")){const e=i18nString(UIStrings.setcookieHeaderIsIgnoredIn,{PH1:this.url()});t.dispatchEventToListeners(NetworkManagerEvents.MessageGenerated,{message:e,requestId:this.#e,warning:!0})}}hasExtraResponseInfo(){return this.#M}blockedResponseCookies(){return this.#W}redirectSourceSignedExchangeInfoHasNoErrors(){return null!==this.#i&&null!==this.#i.#g&&!this.#i.#g.errors}clientSecurityState(){return this.#K}setTrustTokenParams(e){this.#Z=e}trustTokenParams(){return this.#Z}setTrustTokenOperationDoneEvent(e){this.#ee=e,this.dispatchEventToListeners(Events.TrustTokenResultAdded)}trustTokenOperationDoneEvent(){return this.#ee}setIsSameSite(e){this.#ke=e}isSameSite(){return this.#ke}}export var Events;!function(e){e.FinishedLoading="FinishedLoading",e.TimingChanged="TimingChanged",e.RemoteAddressChanged="RemoteAddressChanged",e.RequestHeadersChanged="RequestHeadersChanged",e.ResponseHeadersChanged="ResponseHeadersChanged",e.WebsocketFrameAdded="WebsocketFrameAdded",e.EventSourceMessageAdded="EventSourceMessageAdded",e.TrustTokenResultAdded="TrustTokenResultAdded"}(Events||(Events={}));export var InitiatorType;!function(e){e.Other="other",e.Parser="parser",e.Redirect="redirect",e.Script="script",e.Preload="preload",e.SignedExchange="signedExchange",e.Preflight="preflight"}(InitiatorType||(InitiatorType={}));export var WebSocketFrameType;!function(e){e.Send="send",e.Receive="receive",e.Error="error"}(WebSocketFrameType||(WebSocketFrameType={}));export const cookieBlockedReasonToUiString=function(e){switch(e){case"SecureOnly":return i18nString(UIStrings.secureOnly);case"NotOnPath":return i18nString(UIStrings.notOnPath);case"DomainMismatch":return i18nString(UIStrings.domainMismatch);case"SameSiteStrict":return i18nString(UIStrings.sameSiteStrict);case"SameSiteLax":return i18nString(UIStrings.sameSiteLax);case"SameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.sameSiteUnspecifiedTreatedAsLax);case"SameSiteNoneInsecure":return i18nString(UIStrings.sameSiteNoneInsecure);case"UserPreferences":return i18nString(UIStrings.userPreferences);case"UnknownError":return i18nString(UIStrings.unknownError);case"SchemefulSameSiteStrict":return i18nString(UIStrings.schemefulSameSiteStrict);case"SchemefulSameSiteLax":return i18nString(UIStrings.schemefulSameSiteLax);case"SchemefulSameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.schemefulSameSiteUnspecifiedTreatedAsLax);case"SamePartyFromCrossPartyContext":return i18nString(UIStrings.samePartyFromCrossPartyContext);case"NameValuePairExceedsMaxSize":return i18nString(UIStrings.nameValuePairExceedsMaxSize)}return""};export const setCookieBlockedReasonToUiString=function(e){switch(e){case"SecureOnly":return i18nString(UIStrings.blockedReasonSecureOnly);case"SameSiteStrict":return i18nString(UIStrings.blockedReasonSameSiteStrictLax,{PH1:"SameSite=Strict"});case"SameSiteLax":return i18nString(UIStrings.blockedReasonSameSiteStrictLax,{PH1:"SameSite=Lax"});case"SameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.blockedReasonSameSiteUnspecifiedTreatedAsLax);case"SameSiteNoneInsecure":return i18nString(UIStrings.blockedReasonSameSiteNoneInsecure);case"UserPreferences":return i18nString(UIStrings.thisSetcookieWasBlockedDueToUser);case"SyntaxError":return i18nString(UIStrings.thisSetcookieHadInvalidSyntax);case"SchemeNotSupported":return i18nString(UIStrings.theSchemeOfThisConnectionIsNot);case"OverwriteSecure":return i18nString(UIStrings.blockedReasonOverwriteSecure);case"InvalidDomain":return i18nString(UIStrings.blockedReasonInvalidDomain);case"InvalidPrefix":return i18nString(UIStrings.blockedReasonInvalidPrefix);case"UnknownError":return i18nString(UIStrings.anUnknownErrorWasEncounteredWhenTrying);case"SchemefulSameSiteStrict":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax,{PH1:"SameSite=Strict"});case"SchemefulSameSiteLax":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax,{PH1:"SameSite=Lax"});case"SchemefulSameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.thisSetcookieDidntSpecifyASamesite);case"SamePartyFromCrossPartyContext":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSameparty);case"SamePartyConflictsWithOtherAttributes":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute);case"NameValuePairExceedsMaxSize":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseTheNameValuePairExceedsMaxSize)}return""};export const cookieBlockedReasonToAttribute=function(e){switch(e){case"SecureOnly":return Attributes.Secure;case"NotOnPath":return Attributes.Path;case"DomainMismatch":return Attributes.Domain;case"SameSiteStrict":case"SameSiteLax":case"SameSiteUnspecifiedTreatedAsLax":case"SameSiteNoneInsecure":case"SchemefulSameSiteStrict":case"SchemefulSameSiteLax":case"SchemefulSameSiteUnspecifiedTreatedAsLax":return Attributes.SameSite;case"SamePartyFromCrossPartyContext":return Attributes.SameParty;case"NameValuePairExceedsMaxSize":case"UserPreferences":case"UnknownError":return null}return null};export const setCookieBlockedReasonToAttribute=function(e){switch(e){case"SecureOnly":case"OverwriteSecure":return Attributes.Secure;case"SameSiteStrict":case"SameSiteLax":case"SameSiteUnspecifiedTreatedAsLax":case"SameSiteNoneInsecure":case"SchemefulSameSiteStrict":case"SchemefulSameSiteLax":case"SchemefulSameSiteUnspecifiedTreatedAsLax":return Attributes.SameSite;case"InvalidDomain":return Attributes.Domain;case"InvalidPrefix":return Attributes.Name;case"SamePartyConflictsWithOtherAttributes":case"SamePartyFromCrossPartyContext":return Attributes.SameParty;case"NameValuePairExceedsMaxSize":case"UserPreferences":case"SyntaxError":case"SchemeNotSupported":case"UnknownError":return null}return null};