import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import{Location}from"./DebuggerModel.js";import{ResourceTreeModel}from"./ResourceTreeModel.js";const UIStrings={scriptRemovedOrDeleted:"Script removed or deleted.",unableToFetchScriptSource:"Unable to fetch script source."},str_=i18n.i18n.registerUIStrings("core/sdk/Script.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class Script{debuggerModel;scriptId;sourceURL;lineOffset;columnOffset;endLine;endColumn;executionContextId;hash;#e;#t;sourceMapURL;debugSymbols;hasSourceURL;contentLength;#r;originStackTrace;#n;#i;#s;#o;isModule;constructor(e,t,r,n,i,s,o,c,a,d,u,l,h,g,m,p,f,I,S,b){this.debuggerModel=e,this.scriptId=t,this.sourceURL=r,this.lineOffset=n,this.columnOffset=i,this.endLine=s,this.endColumn=o,this.isModule=m,this.executionContextId=c,this.hash=a,this.#e=d,this.#t=u,this.sourceMapURL=l,this.debugSymbols=S,this.hasSourceURL=h,this.contentLength=g,this.#r=null,this.originStackTrace=p,this.#n=f,this.#i=I,this.#s=null,this.#o=b}embedderName(){return this.#o}target(){return this.debuggerModel.target()}static trimSourceURLComment(e){let t=e.lastIndexOf("//# sourceURL=");if(-1===t&&(t=e.lastIndexOf("//@ sourceURL="),-1===t))return e;const r=e.lastIndexOf("\n",t);if(-1===r)return e;return e.substr(r+1).match(sourceURLRegex)?e.substr(0,r):e}isContentScript(){return this.#e}codeOffset(){return this.#n}isJavaScript(){return"JavaScript"===this.#i}isWasm(){return"WebAssembly"===this.#i}scriptLanguage(){return this.#i}executionContext(){return this.debuggerModel.runtimeModel().executionContext(this.executionContextId)}isLiveEdit(){return this.#t}contentURL(){return this.sourceURL}contentType(){return Common.ResourceType.resourceTypes.Script}async contentEncoded(){return!1}requestContent(){return this.#s||(this.#s=this.originalContentProvider().requestContent()),this.#s}async getWasmBytecode(){const e=await this.debuggerModel.target().debuggerAgent().invoke_getWasmBytecode({scriptId:this.scriptId});return(await fetch(`data:application/wasm;base64,${e.bytecode}`)).arrayBuffer()}originalContentProvider(){if(!this.#r){let e;this.#r=new TextUtils.StaticContentProvider.StaticContentProvider(this.contentURL(),this.contentType(),(()=>(e||(e=(async()=>{if(!this.scriptId)return{content:null,error:i18nString(UIStrings.scriptRemovedOrDeleted),isEncoded:!1};try{const e=await this.debuggerModel.target().debuggerAgent().invoke_getScriptSource({scriptId:this.scriptId});if(e.getError())throw new Error(e.getError());const{scriptSource:t,bytecode:r}=e;if(r)return{content:r,isEncoded:!0};let n=t||"";return this.hasSourceURL&&(n=Script.trimSourceURLComment(n)),{content:n,isEncoded:!1}}catch(e){return{content:null,error:i18nString(UIStrings.unableToFetchScriptSource),isEncoded:!1}}})()),e)))}return this.#r}async searchInContent(e,t,r){if(!this.scriptId)return[];return((await this.debuggerModel.target().debuggerAgent().invoke_searchInContent({scriptId:this.scriptId,query:e,caseSensitive:t,isRegex:r})).result||[]).map((e=>new TextUtils.ContentProvider.SearchMatch(e.lineNumber,e.lineContent)))}appendSourceURLCommentIfNeeded(e){return this.hasSourceURL?e+"\n //# sourceURL="+this.sourceURL:e}async editSource(e,t){if(e=Script.trimSourceURLComment(e),e=this.appendSourceURLCommentIfNeeded(e),!this.scriptId)return void t("Script failed to parse");const{content:r}=await this.requestContent();if(r===e)return void t(null);const n=await this.debuggerModel.target().debuggerAgent().invoke_setScriptSource({scriptId:this.scriptId,scriptSource:e});n.getError()||n.exceptionDetails||(this.#s=Promise.resolve({content:e,isEncoded:!1}));const i=Boolean(n.stackChanged);t(n.getError()||null,n.exceptionDetails,n.callFrames,n.asyncStackTrace,n.asyncStackTraceId,i)}rawLocation(e,t){return this.containsLocation(e,t)?new Location(this.debuggerModel,this.scriptId,e,t):null}toRelativeLocation(e){console.assert(e.scriptId===this.scriptId,"`toRelativeLocation` must be used with location of the same script");const t=e.lineNumber-this.lineOffset;return[t,(e.columnNumber||0)-(0===t?this.columnOffset:0)]}isInlineScript(){const e=!this.lineOffset&&!this.columnOffset;return!this.isWasm()&&Boolean(this.sourceURL)&&!e}isAnonymousScript(){return!this.sourceURL}async setBlackboxedRanges(e){return!(await this.debuggerModel.target().debuggerAgent().invoke_setBlackboxedRanges({scriptId:this.scriptId,positions:e})).getError()}containsLocation(e,t){const r=e===this.lineOffset&&t>=this.columnOffset||e>this.lineOffset,n=e<this.endLine||e===this.endLine&&t<=this.endColumn;return r&&n}get frameId(){return"string"!=typeof this[frameIdSymbol]&&(this[frameIdSymbol]=frameIdForScript(this)),this[frameIdSymbol]}createPageResourceLoadInitiator(){return{target:this.target(),frameId:this.frameId,initiatorUrl:this.embedderName()}}}const frameIdSymbol=Symbol("frameid");function frameIdForScript(e){const t=e.executionContext();if(t)return t.frameId||null;const r=e.debuggerModel.target().model(ResourceTreeModel);return r&&r.mainFrame?r.mainFrame.id:null}export const sourceURLRegex=/^[\040\t]*\/\/[@#] sourceURL=\s*(\S*?)\s*$/;