import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import{Capability}from"./Target.js";import{SDKModel}from"./SDKModel.js";import{Events as SecurityOriginManagerEvents,SecurityOriginManager}from"./SecurityOriginManager.js";const UIStrings={serviceworkercacheagentError:"`ServiceWorkerCacheAgent` error deleting cache entry {PH1} in cache: {PH2}"},str_=i18n.i18n.registerUIStrings("core/sdk/ServiceWorkerCacheModel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ServiceWorkerCacheModel extends SDKModel{cacheAgent;#e;#t;#r=new Map;#i=new Set;#s=new Common.Throttler.Throttler(2e3);#a=!1;#c=!1;constructor(e){super(e),e.registerStorageDispatcher(this),this.cacheAgent=e.cacheStorageAgent(),this.#e=e.storageAgent(),this.#t=e.model(SecurityOriginManager)}enable(){if(!this.#a){this.#t.addEventListener(SecurityOriginManagerEvents.SecurityOriginAdded,this.securityOriginAdded,this),this.#t.addEventListener(SecurityOriginManagerEvents.SecurityOriginRemoved,this.securityOriginRemoved,this);for(const e of this.#t.securityOrigins())this.addOrigin(e);this.#a=!0}}clearForOrigin(e){this.removeOrigin(e),this.addOrigin(e)}refreshCacheNames(){for(const e of this.#r.values())this.cacheRemoved(e);this.#r.clear();const e=this.#t.securityOrigins();for(const t of e)this.loadCacheNames(t)}async deleteCache(e){const t=await this.cacheAgent.invoke_deleteCache({cacheId:e.cacheId});t.getError()?console.error(`ServiceWorkerCacheAgent error deleting cache ${e.toString()}: ${t.getError()}`):(this.#r.delete(e.cacheId),this.cacheRemoved(e))}async deleteCacheEntry(e,t){const r=await this.cacheAgent.invoke_deleteEntry({cacheId:e.cacheId,request:t});r.getError()&&Common.Console.Console.instance().error(i18nString(UIStrings.serviceworkercacheagentError,{PH1:e.toString(),PH2:String(r.getError())}))}loadCacheData(e,t,r,i,s){this.requestEntries(e,t,r,i,s)}loadAllCacheData(e,t,r){this.requestAllEntries(e,t,r)}caches(){const e=new Array;for(const t of this.#r.values())e.push(t);return e}dispose(){for(const e of this.#r.values())this.cacheRemoved(e);this.#r.clear(),this.#a&&(this.#t.removeEventListener(SecurityOriginManagerEvents.SecurityOriginAdded,this.securityOriginAdded,this),this.#t.removeEventListener(SecurityOriginManagerEvents.SecurityOriginRemoved,this.securityOriginRemoved,this))}addOrigin(e){this.loadCacheNames(e),this.isValidSecurityOrigin(e)&&this.#e.invoke_trackCacheStorageForOrigin({origin:e})}removeOrigin(e){for(const[t,r]of this.#r.entries())r.securityOrigin===e&&(this.#r.delete(t),this.cacheRemoved(r));this.isValidSecurityOrigin(e)&&this.#e.invoke_untrackCacheStorageForOrigin({origin:e})}isValidSecurityOrigin(e){const t=Common.ParsedURL.ParsedURL.fromString(e);return null!==t&&t.scheme.startsWith("http")}async loadCacheNames(e){const t=await this.cacheAgent.invoke_requestCacheNames({securityOrigin:e});t.getError()||this.updateCacheNames(e,t.caches)}updateCacheNames(e,t){const r=new Set,i=new Map,s=new Map;for(const e of t){const t=new Cache(this,e.securityOrigin,e.cacheName,e.cacheId);r.add(t.cacheId),this.#r.has(t.cacheId)||(i.set(t.cacheId,t),this.#r.set(t.cacheId,t))}this.#r.forEach((function(t){t.securityOrigin!==e||r.has(t.cacheId)||(s.set(t.cacheId,t),this.#r.delete(t.cacheId))}),this),i.forEach(this.cacheAdded,this),s.forEach(this.cacheRemoved,this)}securityOriginAdded(e){this.addOrigin(e.data)}securityOriginRemoved(e){this.removeOrigin(e.data)}cacheAdded(e){this.dispatchEventToListeners(Events.CacheAdded,{model:this,cache:e})}cacheRemoved(e){this.dispatchEventToListeners(Events.CacheRemoved,{model:this,cache:e})}async requestEntries(e,t,r,i,s){const a=await this.cacheAgent.invoke_requestEntries({cacheId:e.cacheId,skipCount:t,pageSize:r,pathFilter:i});a.getError()?console.error("ServiceWorkerCacheAgent error while requesting entries: ",a.getError()):s(a.cacheDataEntries,a.returnCount)}async requestAllEntries(e,t,r){const i=await this.cacheAgent.invoke_requestEntries({cacheId:e.cacheId,pathFilter:t});i.getError()?console.error("ServiceWorkerCacheAgent error while requesting entries: ",i.getError()):r(i.cacheDataEntries,i.returnCount)}cacheStorageListUpdated({origin:e}){this.#i.add(e),this.#s.schedule((()=>{const e=Array.from(this.#i,(e=>this.loadCacheNames(e)));return this.#i.clear(),Promise.all(e)}),this.#c)}cacheStorageContentUpdated({origin:e,cacheName:t}){this.dispatchEventToListeners(Events.CacheStorageContentUpdated,{origin:e,cacheName:t})}indexedDBListUpdated(e){}indexedDBContentUpdated(e){}setThrottlerSchedulesAsSoonAsPossibleForTest(){this.#c=!0}}export var Events;!function(e){e.CacheAdded="CacheAdded",e.CacheRemoved="CacheRemoved",e.CacheStorageContentUpdated="CacheStorageContentUpdated"}(Events||(Events={}));export class Cache{#n;securityOrigin;cacheName;cacheId;constructor(e,t,r,i){this.#n=e,this.securityOrigin=t,this.cacheName=r,this.cacheId=i}equals(e){return this.cacheId===e.cacheId}toString(){return this.securityOrigin+this.cacheName}async requestCachedResponse(e,t){const r=await this.#n.cacheAgent.invoke_requestCachedResponse({cacheId:this.cacheId,requestURL:e,requestHeaders:t});return r.getError()?null:r.response}}SDKModel.register(ServiceWorkerCacheModel,{capabilities:Capability.Storage,autostart:!1});