import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import{Events as RuntimeModelEvents,RuntimeModel}from"./RuntimeModel.js";import{Capability,Type}from"./Target.js";import{SDKModel}from"./SDKModel.js";import{TargetManager}from"./TargetManager.js";const UIStrings={running:"running",starting:"starting",stopped:"stopped",stopping:"stopping",activated:"activated",activating:"activating",installed:"installed",installing:"installing",new:"new",redundant:"redundant",sSS:"{PH1} #{PH2} ({PH3})"},str_=i18n.i18n.registerUIStrings("core/sdk/ServiceWorkerManager.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class ServiceWorkerManager extends SDKModel{#t;#e;#i;#r;#n;serviceWorkerNetworkRequestsPanelStatus;constructor(t){super(t),t.registerServiceWorkerDispatcher(new ServiceWorkerDispatcher(this)),this.#t=0,this.#e=t.serviceWorkerAgent(),this.#i=new Map,this.#r=!1,this.enable(),this.#n=Common.Settings.Settings.instance().createSetting("serviceWorkerUpdateOnReload",!1),this.#n.get()&&this.forceUpdateSettingChanged(),this.#n.addChangeListener(this.forceUpdateSettingChanged,this),new ServiceWorkerContextNamer(t,this),this.serviceWorkerNetworkRequestsPanelStatus={isOpen:!1,openedAt:0}}async enable(){this.#r||(this.#r=!0,await this.#e.invoke_enable())}async disable(){this.#r&&(this.#r=!1,this.#i.clear(),await this.#e.invoke_enable())}registrations(){return this.#i}hasRegistrationForURLs(t){for(const e of this.#i.values())if(t.filter((t=>t&&t.startsWith(e.scopeURL))).length===t.length)return!0;return!1}findVersion(t){for(const e of this.registrations().values()){const i=e.versions.get(t);if(i)return i}return null}deleteRegistration(t){const e=this.#i.get(t);if(e){if(e.isRedundant())return this.#i.delete(t),void this.dispatchEventToListeners(Events.RegistrationDeleted,e);e.deleting=!0;for(const t of e.versions.values())this.stopWorker(t.id);this.unregister(e.scopeURL)}}async updateRegistration(t){const e=this.#i.get(t);e&&await this.#e.invoke_updateRegistration({scopeURL:e.scopeURL})}async deliverPushMessage(t,e){const i=this.#i.get(t);if(!i)return;const r=Common.ParsedURL.ParsedURL.extractOrigin(i.scopeURL);await this.#e.invoke_deliverPushMessage({origin:r,registrationId:t,data:e})}async dispatchSyncEvent(t,e,i){const r=this.#i.get(t);if(!r)return;const n=Common.ParsedURL.ParsedURL.extractOrigin(r.scopeURL);await this.#e.invoke_dispatchSyncEvent({origin:n,registrationId:t,tag:e,lastChance:i})}async dispatchPeriodicSyncEvent(t,e){const i=this.#i.get(t);if(!i)return;const r=Common.ParsedURL.ParsedURL.extractOrigin(i.scopeURL);await this.#e.invoke_dispatchPeriodicSyncEvent({origin:r,registrationId:t,tag:e})}async unregister(t){await this.#e.invoke_unregister({scopeURL:t})}async startWorker(t){await this.#e.invoke_startWorker({scopeURL:t})}async skipWaiting(t){await this.#e.invoke_skipWaiting({scopeURL:t})}async stopWorker(t){await this.#e.invoke_stopWorker({versionId:t})}async inspectWorker(t){await this.#e.invoke_inspectWorker({versionId:t})}workerRegistrationUpdated(t){for(const e of t){let t=this.#i.get(e.registrationId);t?(t.update(e),t.shouldBeRemoved()?(this.#i.delete(t.id),this.dispatchEventToListeners(Events.RegistrationDeleted,t)):this.dispatchEventToListeners(Events.RegistrationUpdated,t)):(t=new ServiceWorkerRegistration(e),this.#i.set(e.registrationId,t),this.dispatchEventToListeners(Events.RegistrationUpdated,t))}}workerVersionUpdated(t){const e=new Set;for(const i of t){const t=this.#i.get(i.registrationId);t&&(t.updateVersion(i),e.add(t))}for(const t of e)t.shouldBeRemoved()?(this.#i.delete(t.id),this.dispatchEventToListeners(Events.RegistrationDeleted,t)):this.dispatchEventToListeners(Events.RegistrationUpdated,t)}workerErrorReported(t){const e=this.#i.get(t.registrationId);e&&(e.errors.push(t),this.dispatchEventToListeners(Events.RegistrationErrorAdded,{registration:e,error:t}))}forceUpdateOnReloadSetting(){return this.#n}forceUpdateSettingChanged(){const t=this.#n.get();this.#e.invoke_setForceUpdateOnPageLoad({forceUpdateOnPageLoad:t})}}export var Events;!function(t){t.RegistrationUpdated="RegistrationUpdated",t.RegistrationErrorAdded="RegistrationErrorAdded",t.RegistrationDeleted="RegistrationDeleted"}(Events||(Events={}));class ServiceWorkerDispatcher{#s;constructor(t){this.#s=t}workerRegistrationUpdated({registrations:t}){this.#s.workerRegistrationUpdated(t)}workerVersionUpdated({versions:t}){this.#s.workerVersionUpdated(t)}workerErrorReported({errorMessage:t}){this.#s.workerErrorReported(t)}}export class ServiceWorkerVersionState{runningStatus;status;last_updated_timestamp;previousState;constructor(t,e,i,r){this.runningStatus=t,this.status=e,this.last_updated_timestamp=r,this.previousState=i}}export class ServiceWorkerVersion{id;scriptURL;parsedURL;securityOrigin;scriptLastModified;scriptResponseTime;controlledClients;targetId;currentState;registration;constructor(t,e){this.registration=t,this.update(e)}update(t){this.id=t.versionId,this.scriptURL=t.scriptURL;const e=new Common.ParsedURL.ParsedURL(t.scriptURL);this.securityOrigin=e.securityOrigin(),this.currentState=new ServiceWorkerVersionState(t.runningStatus,t.status,this.currentState,Date.now()),this.scriptLastModified=t.scriptLastModified,this.scriptResponseTime=t.scriptResponseTime,t.controlledClients?this.controlledClients=t.controlledClients.slice():this.controlledClients=[],this.targetId=t.targetId||null}isStartable(){return!this.registration.isDeleted&&this.isActivated()&&this.isStopped()}isStoppedAndRedundant(){return"stopped"===this.runningStatus&&"redundant"===this.status}isStopped(){return"stopped"===this.runningStatus}isStarting(){return"starting"===this.runningStatus}isRunning(){return"running"===this.runningStatus}isStopping(){return"stopping"===this.runningStatus}isNew(){return"new"===this.status}isInstalling(){return"installing"===this.status}isInstalled(){return"installed"===this.status}isActivating(){return"activating"===this.status}isActivated(){return"activated"===this.status}isRedundant(){return"redundant"===this.status}get status(){return this.currentState.status}get runningStatus(){return this.currentState.runningStatus}mode(){return this.isNew()||this.isInstalling()?ServiceWorkerVersion.Modes.Installing:this.isInstalled()?ServiceWorkerVersion.Modes.Waiting:this.isActivating()||this.isActivated()?ServiceWorkerVersion.Modes.Active:ServiceWorkerVersion.Modes.Redundant}}!function(t){let e;t.RunningStatus={running:i18nLazyString(UIStrings.running),starting:i18nLazyString(UIStrings.starting),stopped:i18nLazyString(UIStrings.stopped),stopping:i18nLazyString(UIStrings.stopping)},t.Status={activated:i18nLazyString(UIStrings.activated),activating:i18nLazyString(UIStrings.activating),installed:i18nLazyString(UIStrings.installed),installing:i18nLazyString(UIStrings.installing),new:i18nLazyString(UIStrings.new),redundant:i18nLazyString(UIStrings.redundant)},function(t){t.Installing="installing",t.Waiting="waiting",t.Active="active",t.Redundant="redundant"}(e=t.Modes||(t.Modes={}))}(ServiceWorkerVersion||(ServiceWorkerVersion={}));export class ServiceWorkerRegistration{#a;id;scopeURL;securityOrigin;isDeleted;versions;deleting;errors;constructor(t){this.update(t),this.versions=new Map,this.deleting=!1,this.errors=[]}update(t){this.#a=Symbol("fingerprint"),this.id=t.registrationId,this.scopeURL=t.scopeURL;const e=new Common.ParsedURL.ParsedURL(t.scopeURL);this.securityOrigin=e.securityOrigin(),this.isDeleted=t.isDeleted}fingerprint(){return this.#a}versionsByMode(){const t=new Map;for(const e of this.versions.values())t.set(e.mode(),e);return t}updateVersion(t){this.#a=Symbol("fingerprint");let e=this.versions.get(t.versionId);return e?(e.update(t),e):(e=new ServiceWorkerVersion(this,t),this.versions.set(t.versionId,e),e)}isRedundant(){for(const t of this.versions.values())if(!t.isStoppedAndRedundant())return!1;return!0}shouldBeRemoved(){return this.isRedundant()&&(!this.errors.length||this.deleting)}canBeRemoved(){return this.isDeleted||this.deleting}clearErrors(){this.#a=Symbol("fingerprint"),this.errors=[]}}class ServiceWorkerContextNamer{#o;#d;#g;constructor(t,e){this.#o=t,this.#d=e,this.#g=new Map,e.addEventListener(Events.RegistrationUpdated,this.registrationsUpdated,this),e.addEventListener(Events.RegistrationDeleted,this.registrationsUpdated,this),TargetManager.instance().addModelListener(RuntimeModel,RuntimeModelEvents.ExecutionContextCreated,this.executionContextCreated,this)}registrationsUpdated(){this.#g.clear();const t=this.#d.registrations().values();for(const e of t)for(const t of e.versions.values())t.targetId&&this.#g.set(t.targetId,t);this.updateAllContextLabels()}executionContextCreated(t){const e=t.data,i=this.serviceWorkerTargetId(e.target());i&&this.updateContextLabel(e,this.#g.get(i)||null)}serviceWorkerTargetId(t){return t.parentTarget()!==this.#o||t.type()!==Type.ServiceWorker?null:t.id()}updateAllContextLabels(){for(const t of TargetManager.instance().targets()){const e=this.serviceWorkerTargetId(t);if(!e)continue;const i=this.#g.get(e)||null,r=t.model(RuntimeModel),n=r?r.executionContexts():[];for(const t of n)this.updateContextLabel(t,i)}}updateContextLabel(t,e){if(!e)return void t.setLabel("");const i=Common.ParsedURL.ParsedURL.fromString(t.origin),r=i?i.lastPathComponentWithFragment():t.name,n=ServiceWorkerVersion.Status[e.status];t.setLabel(i18nString(UIStrings.sSS,{PH1:r,PH2:e.id,PH3:n()}))}}SDKModel.register(ServiceWorkerManager,{capabilities:Capability.ServiceWorker,autostart:!0});