import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import{CompilerSourceMappingContentProvider}from"./CompilerSourceMappingContentProvider.js";import{PageResourceLoader}from"./PageResourceLoader.js";const UIStrings={couldNotLoadContentForSS:"Could not load content for {PH1}: {PH2}",couldNotParseContentForSS:"Could not parse content for {PH1}: {PH2}"},str_=i18n.i18n.registerUIStrings("core/sdk/SourceMap.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SourceMapV3{version;file;sources;sections;mappings;sourceRoot;names;sourcesContent;constructor(){}}export class Section{map;offset;url;constructor(){}}export class Offset{line;column;constructor(){}}export class SourceMapEntry{lineNumber;columnNumber;sourceURL;sourceLineNumber;sourceColumnNumber;name;constructor(e,t,r,n,s,o){this.lineNumber=e,this.columnNumber=t,this.sourceURL=r,this.sourceLineNumber=n,this.sourceColumnNumber=s,this.name=o}static compare(e,t){return e.lineNumber!==t.lineNumber?e.lineNumber-t.lineNumber:e.columnNumber-t.columnNumber}}const base64Digits="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",base64Map=new Map;for(let e=0;e<base64Digits.length;++e)base64Map.set(base64Digits.charAt(e),e);const sourceMapToSourceList=new WeakMap;export class TextSourceMap{#e;#t;#r;#n;#s;#o;#i;constructor(e,t,r,n){if(this.#e=n,this.#t=r,this.#r=e,this.#n=t,this.#s=t.startsWith("data:")?e:t,this.#o=null,this.#i=new Map,this.#t.sections){Boolean(this.#t.sections.find((e=>Boolean(e.url))))&&Common.Console.Console.instance().warn(`SourceMap "${t}" contains unsupported "URL" field in one of its sections.`)}this.eachSection(this.parseSources.bind(this))}static async load(e,t,r){let n;try{const{content:t}=await PageResourceLoader.instance().loadResource(e,r);n=t,")]}"===t.slice(0,3)&&(n=t.substring(t.indexOf("\n")))}catch(t){throw new Error(i18nString(UIStrings.couldNotLoadContentForSS,{PH1:e,PH2:t.message}))}try{const s=JSON.parse(n);return new TextSourceMap(t,e,s,r)}catch(t){throw new Error(i18nString(UIStrings.couldNotParseContentForSS,{PH1:e,PH2:t.message}))}}compiledURL(){return this.#r}url(){return this.#n}sourceURLs(){return[...this.#i.keys()]}sourceContentProvider(e,t){const r=this.#i.get(e);return r&&r.content?TextUtils.StaticContentProvider.StaticContentProvider.fromString(e,t,r.content):new CompilerSourceMappingContentProvider(e,t,this.#e)}embeddedContentByURL(e){const t=this.#i.get(e);return t?t.content:null}findEntry(e,t){const r=this.mappings(),n=Platform.ArrayUtilities.upperBound(r,void 0,((r,n)=>e-n.lineNumber||t-n.columnNumber));return n?r[n-1]:null}sourceLineMapping(e,t,r){const n=this.mappings(),s=this.reversedMappings(e),o=Platform.ArrayUtilities.lowerBound(s,t,a),i=Platform.ArrayUtilities.upperBound(s,t,a);if(o>=s.length||n[s[o]].sourceLineNumber!==t)return null;const u=s.slice(o,i);if(!u.length)return null;const c=Platform.ArrayUtilities.lowerBound(u,r,((e,t)=>e-n[t].sourceColumnNumber));return c>=u.length?n[u[u.length-1]]:n[u[c]];function a(e,t){return e-n[t].sourceLineNumber}}findReverseIndices(e,t,r){const n=this.mappings(),s=this.reversedMappings(e),o=Platform.ArrayUtilities.upperBound(s,void 0,((e,s)=>t-n[s].sourceLineNumber||r-n[s].sourceColumnNumber));let i=o;for(;i>0&&n[s[i-1]].sourceLineNumber===n[s[o-1]].sourceLineNumber&&n[s[i-1]].sourceColumnNumber===n[s[o-1]].sourceColumnNumber;)--i;return s.slice(i,o)}findReverseEntries(e,t,r){const n=this.mappings();return this.findReverseIndices(e,t,r).map((e=>n[e]))}findReverseRanges(e,t,r){const n=this.mappings(),s=this.findReverseIndices(e,t,r),o=[];for(let e=0;e<s.length;++e){const t=s[e];let r=t+1;for(;e+1<s.length&&r===s[e+1];)++r,++e;const i=r<n.length?n[r].lineNumber:1/0,u=r<n.length?n[r].columnNumber:0;o.push(new TextUtils.TextRange.TextRange(n[t].lineNumber,n[t].columnNumber,i,u))}return o}mappings(){return null===this.#o&&(this.#o=[],this.eachSection(this.parseMap.bind(this)),this.#t=null),this.#o}reversedMappings(e){const t=this.#i.get(e);if(!t)return[];const r=this.mappings();if(null===t.reverseMappings){const n=Array(r.length).fill(0).map(((e,t)=>t));t.reverseMappings=n.filter((t=>r[t].sourceURL===e)).sort((function(e,t){const n=r[e],s=r[t];if(n.sourceLineNumber!==s.sourceLineNumber)return n.sourceLineNumber-s.sourceLineNumber;if(n.sourceColumnNumber!==s.sourceColumnNumber)return n.sourceColumnNumber-s.sourceColumnNumber;if(n.lineNumber!==s.lineNumber)return n.lineNumber-s.lineNumber;return n.columnNumber-s.columnNumber}))}return t.reverseMappings}eachSection(e){if(this.#t)if(this.#t.sections)for(const t of this.#t.sections)e(t.map,t.offset.line,t.offset.column);else e(this.#t,0,0)}parseSources(e){const t=[];let r=e.sourceRoot||"";r&&!r.endsWith("/")&&(r+="/");for(let n=0;n<e.sources.length;++n){const s=r+e.sources[n];let o=Common.ParsedURL.ParsedURL.completeURL(this.#s,s)||s;const i=e.sourcesContent&&e.sourcesContent[n];o===this.#r&&i&&(o+="? [sm]"),this.#i.set(o,new TextSourceMap.SourceInfo(i||null,null)),t.push(o)}sourceMapToSourceList.set(e,t)}parseMap(e,t,r){let n=0,s=0,o=0,i=0;const u=sourceMapToSourceList.get(e),c=e.names||[],a=new TextSourceMap.StringCharIterator(e.mappings);let l=u&&u[n];for(;;){if(","===a.peek())a.next();else{for(;";"===a.peek();)t+=1,r=0,a.next();if(!a.hasNext())break}if(r+=this.decodeVLQ(a),!a.hasNext()||this.isSeparator(a.peek())){this.mappings().push(new SourceMapEntry(t,r));continue}const e=this.decodeVLQ(a);e&&(n+=e,u&&(l=u[n])),s+=this.decodeVLQ(a),o+=this.decodeVLQ(a),a.hasNext()&&!this.isSeparator(a.peek())?(i+=this.decodeVLQ(a),this.mappings().push(new SourceMapEntry(t,r,l,s,o,c[i]))):this.mappings().push(new SourceMapEntry(t,r,l,s,o))}this.mappings().sort(SourceMapEntry.compare)}isSeparator(e){return","===e||";"===e}decodeVLQ(e){let t=0,r=0,n=TextSourceMap._VLQ_CONTINUATION_MASK;for(;n&TextSourceMap._VLQ_CONTINUATION_MASK;)n=base64Map.get(e.next())||0,t+=(n&TextSourceMap._VLQ_BASE_MASK)<<r,r+=TextSourceMap._VLQ_BASE_SHIFT;const s=1&t;return t>>=1,s?-t:t}reverseMapTextRange(e,t){function r(e,t){return e.lineNumber!==s[t].sourceLineNumber?e.lineNumber-s[t].sourceLineNumber:e.columnNumber-s[t].sourceColumnNumber}const n=this.reversedMappings(e),s=this.mappings();if(!n.length)return null;const o=Platform.ArrayUtilities.lowerBound(n,{lineNumber:t.startLine,columnNumber:t.startColumn},r),i=Platform.ArrayUtilities.upperBound(n,{lineNumber:t.endLine,columnNumber:t.endColumn},r);if(i>=n.length)return null;const u=s[n[o]],c=s[n[i]];return new TextUtils.TextRange.TextRange(u.lineNumber,u.columnNumber,c.lineNumber,c.columnNumber)}mapsOrigin(){const e=this.mappings();if(e.length>0){const t=e[0];return 0===t?.lineNumber||0===t.columnNumber}return!1}}!function(e){e._VLQ_BASE_SHIFT=5,e._VLQ_BASE_MASK=31,e._VLQ_CONTINUATION_MASK=32;e.StringCharIterator=class{string;position;constructor(e){this.string=e,this.position=0}next(){return this.string.charAt(this.position++)}peek(){return this.string.charAt(this.position)}hasNext(){return this.position<this.string.length}};e.SourceInfo=class{content;reverseMappings;constructor(e,t){this.content=e,this.reverseMappings=t}}}(TextSourceMap||(TextSourceMap={}));