import*as Platform from"../../core/platform/platform.js";import{CSSFormatter}from"./CSSFormatter.js";import{AbortTokenization,createTokenizer}from"./FormatterWorker.js";import{JavaScriptFormatter}from"./JavaScriptFormatter.js";export class HTMLFormatter{builder;jsFormatter;cssFormatter;text;lineEndings;model;constructor(t){this.builder=t,this.jsFormatter=new JavaScriptFormatter(t),this.cssFormatter=new CSSFormatter(t)}format(t,e){this.text=t,this.lineEndings=e,this.model=new HTMLModel(t),this.walk(this.model.document())}formatTokensTill(t,e){if(!this.model)return;let s=this.model.peekToken();for(;s&&s.startOffset<e;){const e=this.model.nextToken();this.formatToken(t,e),s=this.model.peekToken()}}walk(t){if(!t.openTag||!t.closeTag)throw new Error("Element is missing open or close tag");t.parent&&this.formatTokensTill(t.parent,t.openTag.startOffset),this.beforeOpenTag(t),this.formatTokensTill(t,t.openTag.endOffset),this.afterOpenTag(t);for(let e=0;e<t.children.length;++e)this.walk(t.children[e]);this.formatTokensTill(t,t.closeTag.startOffset),this.beforeCloseTag(t),this.formatTokensTill(t,t.closeTag.endOffset),this.afterCloseTag(t)}beforeOpenTag(t){this.model&&t.children.length&&t!==this.model.document()&&this.builder.addNewLine()}afterOpenTag(t){this.model&&t.children.length&&t!==this.model.document()&&(this.builder.increaseNestingLevel(),this.builder.addNewLine())}beforeCloseTag(t){this.model&&t.children.length&&t!==this.model.document()&&(this.builder.decreaseNestingLevel(),this.builder.addNewLine())}afterCloseTag(t){this.builder.addNewLine()}formatToken(t,e){if(Platform.StringUtilities.isWhitespace(e.value))return;if(hasTokenInSet(e.type,"comment")||hasTokenInSet(e.type,"meta"))return this.builder.addNewLine(),this.builder.addToken(e.value.trim(),e.startOffset),void this.builder.addNewLine();if(!t.openTag||!t.closeTag)return;const s=t.openTag.endOffset<=e.startOffset&&e.startOffset<t.closeTag.startOffset;return s&&"style"===t.name?(this.builder.addNewLine(),this.builder.increaseNestingLevel(),this.cssFormatter.format(this.text||"",this.lineEndings||[],e.startOffset,e.endOffset),void this.builder.decreaseNestingLevel()):s&&"script"===t.name?(this.builder.addNewLine(),this.builder.increaseNestingLevel(),this.scriptTagIsJavaScript(t)?this.jsFormatter.format(this.text||"",this.lineEndings||[],e.startOffset,e.endOffset):(this.builder.addToken(e.value,e.startOffset),this.builder.addNewLine()),void this.builder.decreaseNestingLevel()):(!s&&hasTokenInSet(e.type,"attribute")&&this.builder.addSoftSpace(),void this.builder.addToken(e.value,e.startOffset))}scriptTagIsJavaScript(t){if(!t.openTag)return!0;if(!t.openTag.attributes.has("type"))return!0;let e=t.openTag.attributes.get("type");if(!e)return!0;e=e.toLowerCase();const s=/^(["\'])(.*)\1$/.exec(e.trim());return s&&(e=s[2]),HTMLFormatter.SupportedJavaScriptMimeTypes.has(e.trim())}static SupportedJavaScriptMimeTypes=new Set(["application/ecmascript","application/javascript","application/x-ecmascript","application/x-javascript","text/ecmascript","text/javascript","text/javascript1.0","text/javascript1.1","text/javascript1.2","text/javascript1.3","text/javascript1.4","text/javascript1.5","text/jscript","text/livescript","text/x-ecmascript","text/x-javascript"])}function hasTokenInSet(t,e){return t.has(e)||t.has(`xml-${e}`)}export class HTMLModel{state;documentInternal;stack;tokens;tokenIndex;attributes;attributeName;tagName;isOpenTag;tagStartOffset;tagEndOffset;constructor(t){this.state="Initial",this.documentInternal=new FormatterElement("document"),this.documentInternal.openTag=new Tag("document",0,0,new Map,!0,!1),this.documentInternal.closeTag=new Tag("document",t.length,t.length,new Map,!1,!1),this.stack=[this.documentInternal],this.tokens=[],this.tokenIndex=0,this.build(t),this.attributes=new Map,this.attributeName="",this.tagName="",this.isOpenTag=!1}build(t){const e=createTokenizer("text/html");let s=0;const a=t.toLowerCase();for(;e(t.substring(s),n.bind(this,s)),!(s>=t.length);){const e=this.stack[this.stack.length-1];if(!e)break;if(s=a.indexOf("</"+e.name,s),-1===s&&(s=t.length),!e.openTag)break;const n=e.openTag.endOffset,i=s,r=t.substring(n,i);this.tokens.push(new Token(r,new Set,n,i))}for(;this.stack.length>1;){const e=this.stack[this.stack.length-1];if(!e)break;this.popElement(new Tag(e.name,t.length,t.length,new Map,!1,!1))}function n(t,e,a,n,i){n+=t,s=i+=t;const r=a?new Set(a.split(" ")):new Set,o=new Token(e,r,n,i);this.tokens.push(o),this.updateDOM(o);const h=this.stack[this.stack.length-1];if(h&&("script"===h.name||"style"===h.name)&&h.openTag&&h.openTag.endOffset===s)return AbortTokenization}}updateDOM(t){const e=t.value,s=t.type;switch(this.state){case"Initial":return void(!hasTokenInSet(s,"bracket")||"<"!==e&&"</"!==e||(this.onStartTag(t),this.state="Tag"));case"Tag":return void(hasTokenInSet(s,"tag")&&!hasTokenInSet(s,"bracket")?this.tagName=e.trim().toLowerCase():hasTokenInSet(s,"attribute")?(this.attributeName=e.trim().toLowerCase(),this.attributes.set(this.attributeName,""),this.state="AttributeName"):!hasTokenInSet(s,"bracket")||">"!==e&&"/>"!==e||(this.onEndTag(t),this.state="Initial"));case"AttributeName":return void(s.size||"="!==e?!hasTokenInSet(s,"bracket")||">"!==e&&"/>"!==e||(this.onEndTag(t),this.state="Initial"):this.state="AttributeValue");case"AttributeValue":return void(hasTokenInSet(s,"string")?(this.attributes.set(this.attributeName,e),this.state="Tag"):!hasTokenInSet(s,"bracket")||">"!==e&&"/>"!==e||(this.onEndTag(t),this.state="Initial"))}}onStartTag(t){this.tagName="",this.tagStartOffset=t.startOffset,this.tagEndOffset=null,this.attributes=new Map,this.attributeName="",this.isOpenTag="<"===t.value}onEndTag(t){this.tagEndOffset=t.endOffset;const e="/>"===t.value||SelfClosingTags.has(this.tagName),s=new Tag(this.tagName,this.tagStartOffset||0,this.tagEndOffset,this.attributes,this.isOpenTag,e);this.onTagComplete(s)}onTagComplete(t){if(t.isOpenTag){const e=this.stack[this.stack.length-1];if(e){const a=AutoClosingTags.get(e.name);e!==this.documentInternal&&e.openTag&&e.openTag.selfClosingTag?this.popElement(s(e,e.openTag.endOffset)):a&&a.has(t.name)&&this.popElement(s(e,t.startOffset)),this.pushElement(t)}return}let e=this.stack[this.stack.length-1];for(;this.stack.length>1&&e&&e.name!==t.name;)this.popElement(s(e,t.startOffset)),e=this.stack[this.stack.length-1];function s(t,e){return new Tag(t.name,e,e,new Map,!1,!1)}1!==this.stack.length&&this.popElement(t)}popElement(t){const e=this.stack.pop();e&&(e.closeTag=t)}pushElement(t){const e=this.stack[this.stack.length-1],s=new FormatterElement(t.name);e&&(s.parent=e,e.children.push(s)),s.openTag=t,this.stack.push(s)}peekToken(){return this.tokenIndex<this.tokens.length?this.tokens[this.tokenIndex]:null}nextToken(){return this.tokens[this.tokenIndex++]}document(){return this.documentInternal}}const SelfClosingTags=new Set(["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"]),AutoClosingTags=new Map([["head",new Set(["body"])],["li",new Set(["li"])],["dt",new Set(["dt","dd"])],["dd",new Set(["dt","dd"])],["p",new Set(["address","article","aside","blockquote","div","dl","fieldset","footer","form","h1","h2","h3","h4","h5","h6","header","hgroup","hr","main","nav","ol","p","pre","section","table","ul"])],["rb",new Set(["rb","rt","rtc","rp"])],["rt",new Set(["rb","rt","rtc","rp"])],["rtc",new Set(["rb","rtc","rp"])],["rp",new Set(["rb","rt","rtc","rp"])],["optgroup",new Set(["optgroup"])],["option",new Set(["option","optgroup"])],["colgroup",new Set(["colgroup"])],["thead",new Set(["tbody","tfoot"])],["tbody",new Set(["tbody","tfoot"])],["tfoot",new Set(["tbody"])],["tr",new Set(["tr"])],["td",new Set(["td","th"])],["th",new Set(["td","th"])]]);class Token{value;type;startOffset;endOffset;constructor(t,e,s,a){this.value=t,this.type=e,this.startOffset=s,this.endOffset=a}}class Tag{name;startOffset;endOffset;attributes;isOpenTag;selfClosingTag;constructor(t,e,s,a,n,i){this.name=t,this.startOffset=e,this.endOffset=s,this.attributes=a,this.isOpenTag=n,this.selfClosingTag=i}}class FormatterElement{name;children=[];parent=null;openTag=null;closeTag=null;constructor(t){this.name=t}}