import*as HeapSnapshotModel from"../../models/heap_snapshot_model/heap_snapshot_model.js";export class AllocationProfile{strings;liveObjectStats;nextNodeId;functionInfos;idToNode;idToTopDownNode;collapsedTopNodeIdToFunctionInfo;traceTops;traceTree;constructor(t,o){this.strings=t.strings,this.liveObjectStats=o,this.nextNodeId=1,this.functionInfos=[],this.idToNode={},this.idToTopDownNode={},this.collapsedTopNodeIdToFunctionInfo={},this.traceTops=null,this.buildFunctionAllocationInfos(t),this.traceTree=this.buildAllocationTree(t,o)}buildFunctionAllocationInfos(t){const o=this.strings,e=t.snapshot.meta.trace_function_info_fields,i=e.indexOf("name"),n=e.indexOf("script_name"),l=e.indexOf("script_id"),s=e.indexOf("line"),a=e.indexOf("column"),c=e.length,r=t.trace_function_infos,h=r.length,d=this.functionInfos=new Array(h/c);let u=0;for(let t=0;t<h;t+=c)d[u++]=new FunctionAllocationInfo(o[r[t+i]],o[r[t+n]],r[t+l],r[t+s],r[t+a])}buildAllocationTree(t,o){const e=t.trace_tree,i=this.functionInfos,n=this.idToTopDownNode,l=t.snapshot.meta.trace_node_fields,s=l.indexOf("id"),a=l.indexOf("function_info_index"),c=l.indexOf("count"),r=l.indexOf("size"),h=l.indexOf("children"),d=l.length;return function t(e,l,u){const p=i[e[l+a]],f=e[l+s],T=o[f],I=T?T.count:0,N=T?T.size:0,z=new TopDownAllocationNode(f,p,e[l+c],e[l+r],I,N,u);n[f]=z,p.addTraceTopNode(z);const m=e[l+h];for(let o=0;o<m.length;o+=d)z.children.push(t(m,o,z));return z}(e,0,null)}serializeTraceTops(){if(this.traceTops)return this.traceTops;const t=this.traceTops=[],o=this.functionInfos;for(let e=0;e<o.length;e++){const i=o[e];if(0===i.totalCount)continue;const n=this.nextNodeId++,l=0===e;t.push(this.serializeNode(n,i,i.totalCount,i.totalSize,i.totalLiveCount,i.totalLiveSize,!l)),this.collapsedTopNodeIdToFunctionInfo[n]=i}return t.sort((function(t,o){return o.size-t.size})),t}serializeCallers(t){let o=this.ensureBottomUpNode(t);const e=[];for(;1===o.callers().length;)o=o.callers()[0],e.push(this.serializeCaller(o));const i=[],n=o.callers();for(let t=0;t<n.length;t++)i.push(this.serializeCaller(n[t]));return new HeapSnapshotModel.HeapSnapshotModel.AllocationNodeCallers(e,i)}serializeAllocationStack(t){let o=this.idToTopDownNode[t];const e=[];for(;o;){const t=o.functionInfo;e.push(new HeapSnapshotModel.HeapSnapshotModel.AllocationStackFrame(t.functionName,t.scriptName,t.scriptId,t.line,t.column)),o=o.parent}return e}traceIds(t){return this.ensureBottomUpNode(t).traceTopIds}ensureBottomUpNode(t){let o=this.idToNode[t];if(!o){o=this.collapsedTopNodeIdToFunctionInfo[t].bottomUpRoot(),delete this.collapsedTopNodeIdToFunctionInfo[t],this.idToNode[t]=o}return o}serializeCaller(t){const o=this.nextNodeId++;return this.idToNode[o]=t,this.serializeNode(o,t.functionInfo,t.allocationCount,t.allocationSize,t.liveCount,t.liveSize,t.hasCallers())}serializeNode(t,o,e,i,n,l,s){return new HeapSnapshotModel.HeapSnapshotModel.SerializedAllocationNode(t,o.functionName,o.scriptName,o.scriptId,o.line,o.column,e,i,n,l,s)}}export class TopDownAllocationNode{id;functionInfo;allocationCount;allocationSize;liveCount;liveSize;parent;children;constructor(t,o,e,i,n,l,s){this.id=t,this.functionInfo=o,this.allocationCount=e,this.allocationSize=i,this.liveCount=n,this.liveSize=l,this.parent=s,this.children=[]}}export class BottomUpAllocationNode{functionInfo;allocationCount;allocationSize;liveCount;liveSize;traceTopIds;callersInternal;constructor(t){this.functionInfo=t,this.allocationCount=0,this.allocationSize=0,this.liveCount=0,this.liveSize=0,this.traceTopIds=[],this.callersInternal=[]}addCaller(t){const o=t.functionInfo;let e;for(let t=0;t<this.callersInternal.length;t++){const i=this.callersInternal[t];if(i.functionInfo===o){e=i;break}}return e||(e=new BottomUpAllocationNode(o),this.callersInternal.push(e)),e}callers(){return this.callersInternal}hasCallers(){return this.callersInternal.length>0}}export class FunctionAllocationInfo{functionName;scriptName;scriptId;line;column;totalCount;totalSize;totalLiveCount;totalLiveSize;traceTops;bottomUpTree;constructor(t,o,e,i,n){this.functionName=t,this.scriptName=o,this.scriptId=e,this.line=i,this.column=n,this.totalCount=0,this.totalSize=0,this.totalLiveCount=0,this.totalLiveSize=0,this.traceTops=[]}addTraceTopNode(t){0!==t.allocationCount&&(this.traceTops.push(t),this.totalCount+=t.allocationCount,this.totalSize+=t.allocationSize,this.totalLiveCount+=t.liveCount,this.totalLiveSize+=t.liveSize)}bottomUpRoot(){return this.traceTops.length?(this.bottomUpTree||this.buildAllocationTraceTree(),this.bottomUpTree):null}buildAllocationTraceTree(){this.bottomUpTree=new BottomUpAllocationNode(this);for(let t=0;t<this.traceTops.length;t++){let o=this.traceTops[t],e=this.bottomUpTree;const i=o.allocationCount,n=o.allocationSize,l=o.liveCount,s=o.liveSize,a=o.id;for(;e.allocationCount+=i,e.allocationSize+=n,e.liveCount+=l,e.liveSize+=s,e.traceTopIds.push(a),o=o.parent,null!==o;)e=e.addCaller(o)}}}