import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as ProtocolClient from"../../core/protocol_client/protocol_client.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Extensions from"../../models/extensions/extensions.js";import*as IssuesManager from"../../models/issues_manager/issues_manager.js";import*as Logs from"../../models/logs/logs.js";import*as Persistence from"../../models/persistence/persistence.js";import*as Workspace from"../../models/workspace/workspace.js";import*as Snippets from"../../panels/snippets/snippets.js";import*as Timeline from"../../panels/timeline/timeline.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import{ExecutionContextSelector}from"./ExecutionContextSelector.js";const UIStrings={theSystempreferredColorSchemeHas:"The system-preferred color scheme has changed. To apply this change to DevTools, reload.",customizeAndControlDevtools:"Customize and control DevTools",dockSide:"Dock side",placementOfDevtoolsRelativeToThe:"Placement of DevTools relative to the page. ({PH1} to restore last position)",undockIntoSeparateWindow:"Undock into separate window",dockToBottom:"Dock to bottom",dockToRight:"Dock to right",dockToLeft:"Dock to left",focusDebuggee:"Focus debuggee",hideConsoleDrawer:"Hide console drawer",showConsoleDrawer:"Show console drawer",moreTools:"More tools",help:"Help"},str_=i18n.i18n.registerUIStrings("entrypoints/main/MainImpl.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class MainImpl{lateInitDonePromise;constructor(){MainImpl.instanceForTest=this,Platform.runOnWindowLoad((()=>{this.loaded()}))}static time(e){Host.InspectorFrontendHost.isUnderTest()||console.time(e)}static timeEnd(e){Host.InspectorFrontendHost.isUnderTest()||console.timeEnd(e)}async loaded(){console.timeStamp("Main._loaded"),await Root.Runtime.appStarted,Root.Runtime.Runtime.setPlatform(Host.Platform.platform());const e=await new Promise((e=>{Host.InspectorFrontendHost.InspectorFrontendHostInstance.getPreferences(e)}));console.timeStamp("Main._gotPreferences"),this.initializeGlobalsForLayoutTests(),this.createSettings(e),await this.requestAndRegisterLocaleData(),Root.Runtime.experiments.isEnabled(Root.Runtime.ExperimentName.SYNC_SETTINGS)&&Host.userMetrics.syncSetting(Common.Settings.Settings.instance().moduleSetting("sync_preferences").get()),this.createAppUI()}initializeGlobalsForLayoutTests(){self.Common=self.Common||{},self.UI=self.UI||{},self.UI.panels=self.UI.panels||{},self.SDK=self.SDK||{},self.Bindings=self.Bindings||{},self.Persistence=self.Persistence||{},self.Workspace=self.Workspace||{},self.Extensions=self.Extensions||{},self.Host=self.Host||{},self.Host.userMetrics=self.Host.userMetrics||Host.userMetrics,self.Host.UserMetrics=self.Host.UserMetrics||Host.UserMetrics}async requestAndRegisterLocaleData(){const e=Common.Settings.Settings.instance().moduleSetting("language").get(),t=i18n.DevToolsLocale.DevToolsLocale.instance({create:!0,data:{navigatorLanguage:navigator.language,settingLanguage:e,lookupClosestDevToolsLocale:i18n.i18n.lookupClosestSupportedDevToolsLocale}});Host.userMetrics.language(t.locale),"en-US"!==t.locale&&await i18n.i18n.fetchAndRegisterLocaleData("en-US");try{await i18n.i18n.fetchAndRegisterLocaleData(t.locale)}catch(e){console.error(e),t.forceFallbackLocale()}}createSettings(e){this.initializeExperiments();let t,n="";if(Host.Platform.isCustomDevtoolsFrontend()?n="__custom__":Root.Runtime.Runtime.queryParam("can_dock")||!Boolean(Root.Runtime.Runtime.queryParam("debugFrontend"))||Host.InspectorFrontendHost.isUnderTest()||(n="__bundled__"),!Host.InspectorFrontendHost.isUnderTest()&&window.localStorage){const e={...Common.Settings.NOOP_STORAGE,clear:()=>window.localStorage.clear()};t=new Common.Settings.SettingsStorage(window.localStorage,e,n)}else t=new Common.Settings.SettingsStorage({},Common.Settings.NOOP_STORAGE,n);const o={register:e=>Host.InspectorFrontendHost.InspectorFrontendHostInstance.registerPreference(e,{synced:!1}),set:Host.InspectorFrontendHost.InspectorFrontendHostInstance.setPreference,remove:Host.InspectorFrontendHost.InspectorFrontendHostInstance.removePreference,clear:Host.InspectorFrontendHost.InspectorFrontendHostInstance.clearPreferences},s={...o,register:e=>Host.InspectorFrontendHost.InspectorFrontendHostInstance.registerPreference(e,{synced:!0})},i=new Common.Settings.SettingsStorage(e,s,n),r=new Common.Settings.SettingsStorage(e,o,n);Common.Settings.Settings.instance({forceNew:!0,syncedStorage:i,globalStorage:r,localStorage:t}),self.Common.settings=Common.Settings.Settings.instance(),Host.InspectorFrontendHost.isUnderTest()||(new Common.Settings.VersionController).updateVersion()}initializeExperiments(){Root.Runtime.experiments.register("applyCustomStylesheet","Allow extensions to load custom stylesheets"),Root.Runtime.experiments.register("captureNodeCreationStacks","Capture node creation stacks"),Root.Runtime.experiments.register("sourcesPrettyPrint","Automatically pretty print in the Sources Panel"),Root.Runtime.experiments.register("backgroundServices","Background web platform feature events",!0),Root.Runtime.experiments.register("backgroundServicesNotifications","Background services section for Notifications"),Root.Runtime.experiments.register("backgroundServicesPaymentHandler","Background services section for Payment Handler"),Root.Runtime.experiments.register("backgroundServicesPushMessaging","Background services section for Push Messaging"),Root.Runtime.experiments.register("ignoreListJSFramesOnTimeline","Ignore List for JavaScript frames on Timeline",!0),Root.Runtime.experiments.register("inputEventsOnTimelineOverview","Input events on Timeline overview",!0),Root.Runtime.experiments.register("liveHeapProfile","Live heap profile",!0),Root.Runtime.experiments.register("protocolMonitor","Protocol Monitor",void 0,"https://developer.chrome.com/blog/new-in-devtools-92/#protocol-monitor"),Root.Runtime.experiments.register("developerResourcesView","Show developer resources view"),Root.Runtime.experiments.register("cspViolationsView","Show CSP Violations view",void 0,"https://developer.chrome.com/blog/new-in-devtools-89/#csp"),Root.Runtime.experiments.register("recordCoverageWithPerformanceTracing","Record coverage while performance tracing"),Root.Runtime.experiments.register("samplingHeapProfilerTimeline","Sampling heap profiler timeline",!0),Root.Runtime.experiments.register("showOptionToNotTreatGlobalObjectsAsRoots","Show option to take heap snapshot where globals are not treated as root"),Root.Runtime.experiments.register("sourceOrderViewer","Source order viewer",void 0,"https://developer.chrome.com/blog/new-in-devtools-92/#source-order"),Root.Runtime.experiments.register("webauthnPane","WebAuthn Pane"),Root.Runtime.experiments.register("keyboardShortcutEditor","Enable keyboard shortcut editor",!0,"https://developer.chrome.com/blog/new-in-devtools-88/#keyboard-shortcuts"),Root.Runtime.experiments.register("timelineEventInitiators","Timeline: event initiators"),Root.Runtime.experiments.register("timelineInvalidationTracking","Timeline: invalidation tracking",!0),Root.Runtime.experiments.register("timelineShowAllEvents","Timeline: show all events",!0),Root.Runtime.experiments.register("timelineV8RuntimeCallStats","Timeline: V8 Runtime Call Stats on Timeline",!0),Root.Runtime.experiments.register("timelineWebGL","Timeline: WebGL-based flamechart"),Root.Runtime.experiments.register("timelineReplayEvent","Timeline: Replay input events",!0),Root.Runtime.experiments.register("wasmDWARFDebugging","WebAssembly Debugging: Enable DWARF support",void 0,"https://developer.chrome.com/blog/wasm-debugging-2020/"),Root.Runtime.experiments.register("dualScreenSupport","Emulation: Support dual screen mode",void 0,"https://developer.chrome.com/blog/new-in-devtools-89#dual-screen"),Root.Runtime.experiments.setEnabled("dualScreenSupport",!0),Root.Runtime.experiments.register("APCA","Enable new Advanced Perceptual Contrast Algorithm (APCA) replacing previous contrast ratio and AA/AAA guidelines",void 0,"https://developer.chrome.com/blog/new-in-devtools-89/#apca"),Root.Runtime.experiments.register("fullAccessibilityTree","Enable full accessibility tree view in the Elements panel",void 0,"https://developer.chrome.com/blog/new-in-devtools-90/#accesibility-tree"),Root.Runtime.experiments.register("fontEditor","Enable new Font Editor tool within the Styles Pane.",void 0,"https://developer.chrome.com/blog/new-in-devtools-89/#font"),Root.Runtime.experiments.register("contrastIssues","Enable automatic contrast issue reporting via the Issues panel",void 0,"https://developer.chrome.com/blog/new-in-devtools-90/#low-contrast"),Root.Runtime.experiments.register("experimentalCookieFeatures","Enable experimental cookie features"),Root.Runtime.experiments.register("hideIssuesFeature","Enable experimental hide issues menu",void 0,"https://developer.chrome.com/blog/new-in-devtools-94/#hide-issues"),Root.Runtime.experiments.register("groupAndHideIssuesByKind","Allow grouping and hiding of issues by IssueKind"),Root.Runtime.experiments.register(Root.Runtime.ExperimentName.SYNC_SETTINGS,"Sync DevTools settings with Chrome Sync"),Root.Runtime.experiments.register("reportingApiDebugging","Enable Reporting API panel in the Application panel"),Root.Runtime.experiments.register("cssTypeComponentLength","Enable CSS <length> authoring tool in the Styles pane (https://goo.gle/length-feedback)",void 0,"https://developer.chrome.com/blog/new-in-devtools-96/#length"),Root.Runtime.experiments.register("preciseChanges","Display more precise changes in the Changes tab"),Root.Runtime.experiments.enableExperimentsByDefault(["sourceOrderViewer","hideIssuesFeature","cssTypeComponentLength","preciseChanges",Root.Runtime.ExperimentName.SYNC_SETTINGS]),Root.Runtime.experiments.cleanUpStaleExperiments();const e=Root.Runtime.Runtime.queryParam("enabledExperiments");if(e&&Root.Runtime.experiments.setServerEnabledExperiments(e.split(";")),Root.Runtime.experiments.enableExperimentsTransiently(["backgroundServices","backgroundServicesNotifications","backgroundServicesPushMessaging","backgroundServicesPaymentHandler","webauthnPane","developerResourcesView"]),Host.InspectorFrontendHost.isUnderTest()){const e=Root.Runtime.Runtime.queryParam("test");e&&e.includes("live-line-level-heap-profile.js")&&Root.Runtime.experiments.enableForTest("liveHeapProfile")}for(const e of Root.Runtime.experiments.enabledExperiments())Host.userMetrics.experimentEnabledAtLaunch(e.name)}async createAppUI(){MainImpl.time("Main._createAppUI"),self.UI.viewManager=UI.ViewManager.ViewManager.instance(),self.Persistence.isolatedFileSystemManager=Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance();const e="systemPreferred",t=Common.Settings.Settings.instance().createSetting("uiTheme",e);if(UI.UIUtils.initializeUIUtils(document,t),t.get()===e){window.matchMedia("(prefers-color-scheme: dark)").addEventListener("change",(()=>{UI.InspectorView.InspectorView.instance().displayReloadRequiredWarning(i18nString(UIStrings.theSystempreferredColorSchemeHas))}))}UI.UIUtils.installComponentRootStyles(document.body),this.addMainEventListeners(document);const n=Boolean(Root.Runtime.Runtime.queryParam("can_dock"));self.UI.zoomManager=UI.ZoomManager.ZoomManager.instance({forceNew:!0,win:window,frontendHost:Host.InspectorFrontendHost.InspectorFrontendHostInstance}),self.UI.inspectorView=UI.InspectorView.InspectorView.instance(),UI.ContextMenu.ContextMenu.initialize(),UI.ContextMenu.ContextMenu.installHandler(document),Logs.NetworkLog.NetworkLog.instance(),SDK.FrameManager.FrameManager.instance(),Logs.LogManager.LogManager.instance(),IssuesManager.IssuesManager.IssuesManager.instance({forceNew:!0,ensureFirst:!0,showThirdPartyIssuesSetting:IssuesManager.Issue.getShowThirdPartyIssuesSetting(),hideIssueSetting:IssuesManager.IssuesManager.getHideIssueByCodeSetting()}),IssuesManager.ContrastCheckTrigger.ContrastCheckTrigger.instance(),self.SDK.consoleModel=SDK.ConsoleModel.ConsoleModel.instance(),self.UI.dockController=UI.DockController.DockController.instance({forceNew:!0,canDock:n}),self.SDK.multitargetNetworkManager=SDK.NetworkManager.MultitargetNetworkManager.instance({forceNew:!0}),self.SDK.domDebuggerManager=SDK.DOMDebuggerModel.DOMDebuggerManager.instance({forceNew:!0}),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.SuspendStateChanged,this.onSuspendStateChanged.bind(this)),self.Workspace.fileManager=Workspace.FileManager.FileManager.instance({forceNew:!0}),self.Workspace.workspace=Workspace.Workspace.WorkspaceImpl.instance(),self.Bindings.networkProjectManager=Bindings.NetworkProject.NetworkProjectManager.instance(),self.Bindings.resourceMapping=Bindings.ResourceMapping.ResourceMapping.instance({forceNew:!0,targetManager:SDK.TargetManager.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),new Bindings.PresentationConsoleMessageHelper.PresentationConsoleMessageManager,self.Bindings.cssWorkspaceBinding=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance({forceNew:!0,targetManager:SDK.TargetManager.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),self.Bindings.debuggerWorkspaceBinding=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance({forceNew:!0,targetManager:SDK.TargetManager.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),self.Bindings.breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance(),targetManager:SDK.TargetManager.TargetManager.instance(),debuggerWorkspaceBinding:Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance()}),self.Extensions.extensionServer=Extensions.ExtensionServer.ExtensionServer.instance({forceNew:!0}),new Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding(Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance(),Workspace.Workspace.WorkspaceImpl.instance()),Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance().addPlatformFileSystem("snippet://",new Snippets.ScriptSnippetFileSystem.SnippetFileSystem),self.Persistence.persistence=Persistence.Persistence.PersistenceImpl.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance(),breakpointManager:Bindings.BreakpointManager.BreakpointManager.instance()}),self.Persistence.networkPersistenceManager=Persistence.NetworkPersistenceManager.NetworkPersistenceManager.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance()}),new ExecutionContextSelector(SDK.TargetManager.TargetManager.instance(),UI.Context.Context.instance()),self.Bindings.ignoreListManager=Bindings.IgnoreListManager.IgnoreListManager.instance({forceNew:!0,debuggerWorkspaceBinding:Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance()}),new PauseListener;const o=UI.ActionRegistry.ActionRegistry.instance({forceNew:!0});self.UI.actionRegistry=o,self.UI.shortcutRegistry=UI.ShortcutRegistry.ShortcutRegistry.instance({forceNew:!0,actionRegistry:o}),this.registerMessageSinkListener(),MainImpl.timeEnd("Main._createAppUI");const s=Common.AppProvider.getRegisteredAppProviders()[0];if(!s)throw new Error("Unable to boot DevTools, as the appprovider is missing");await this.showAppUI(await s.loadAppProvider())}async showAppUI(e){MainImpl.time("Main._showAppUI");const t=e.createApp();UI.DockController.DockController.instance().initialize(),t.presentUI(document);const n=UI.ActionRegistry.ActionRegistry.instance().action("elements.toggle-element-search");n&&Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.EnterInspectElementMode,(()=>{n.execute()}),this),Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.RevealSourceLine,this.revealSourceLine,this),await UI.InspectorView.InspectorView.instance().createToolbars(),Host.InspectorFrontendHost.InspectorFrontendHostInstance.loadCompleted();const o=Root.Runtime.Runtime.queryParam("loadTimelineFromURL");null!==o&&Timeline.TimelinePanel.LoadTimelineHandler.instance().handleQueryParam(o),UI.ARIAUtils.alertElementInstance(),setTimeout(this.initializeTarget.bind(this),0),MainImpl.timeEnd("Main._showAppUI")}async initializeTarget(){MainImpl.time("Main._initializeTarget");for(const e of Common.Runnable.earlyInitializationRunnables())await e().run();Host.InspectorFrontendHost.InspectorFrontendHostInstance.readyForTest(),setTimeout(this.lateInitialization.bind(this),100),MainImpl.timeEnd("Main._initializeTarget")}lateInitialization(){MainImpl.time("Main._lateInitialization"),Extensions.ExtensionServer.ExtensionServer.instance().initializeExtensions();const e=Common.Runnable.lateInitializationRunnables().map((async e=>(await e()).run()));if(Root.Runtime.experiments.isEnabled("liveHeapProfile")){const t="memoryLiveHeapProfile";if(Common.Settings.Settings.instance().moduleSetting(t).get())e.push(PerfUI.LiveHeapProfile.LiveHeapProfile.instance().run());else{const e=async n=>{n.data&&(Common.Settings.Settings.instance().moduleSetting(t).removeChangeListener(e),PerfUI.LiveHeapProfile.LiveHeapProfile.instance().run())};Common.Settings.Settings.instance().moduleSetting(t).addChangeListener(e)}}this.lateInitDonePromise=Promise.all(e).then((()=>{})),MainImpl.timeEnd("Main._lateInitialization")}lateInitDonePromiseForTest(){return this.lateInitDonePromise}registerMessageSinkListener(){Common.Console.Console.instance().addEventListener(Common.Console.Events.MessageAdded,(function({data:e}){e.show&&Common.Console.Console.instance().show()}))}revealSourceLine(e){const{url:t,lineNumber:n,columnNumber:o}=e.data,s=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(t);s?Common.Revealer.reveal(s.uiLocation(n,o)):Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,(function e(s){const i=s.data;i.url()===t&&(Common.Revealer.reveal(i.uiLocation(n,o)),Workspace.Workspace.WorkspaceImpl.instance().removeEventListener(Workspace.Workspace.Events.UISourceCodeAdded,e))}))}postDocumentKeyDown(e){e.handled||UI.ShortcutRegistry.ShortcutRegistry.instance().handleShortcut(e)}redispatchClipboardEvent(e){const t=new CustomEvent("clipboard-"+e.type,{bubbles:!0});t.original=e;const n=e.target&&e.target.ownerDocument,o=n?n.deepActiveElement():null;o&&o.dispatchEvent(t),t.handled&&e.preventDefault()}contextMenuEventFired(e){(e.handled||e.target.classList.contains("popup-glasspane"))&&e.preventDefault()}addMainEventListeners(e){e.addEventListener("keydown",this.postDocumentKeyDown.bind(this),!1),e.addEventListener("beforecopy",this.redispatchClipboardEvent.bind(this),!0),e.addEventListener("copy",this.redispatchClipboardEvent.bind(this),!1),e.addEventListener("cut",this.redispatchClipboardEvent.bind(this),!1),e.addEventListener("paste",this.redispatchClipboardEvent.bind(this),!1),e.addEventListener("contextmenu",this.contextMenuEventFired.bind(this),!0)}onSuspendStateChanged(){const e=SDK.TargetManager.TargetManager.instance().allTargetsSuspended();UI.InspectorView.InspectorView.instance().onSuspendStateChanged(e)}static instanceForTest=null}let zoomActionDelegateInstance,searchActionDelegateInstance,mainMenuItemInstance,settingsButtonProviderInstance,reloadActionDelegateInstance;globalThis.Main=globalThis.Main||{},globalThis.Main.Main=MainImpl;export class ZoomActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return zoomActionDelegateInstance&&!t||(zoomActionDelegateInstance=new ZoomActionDelegate),zoomActionDelegateInstance}handleAction(e,t){if(Host.InspectorFrontendHost.InspectorFrontendHostInstance.isHostedMode())return!1;switch(t){case"main.zoom-in":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.zoomIn(),!0;case"main.zoom-out":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.zoomOut(),!0;case"main.zoom-reset":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.resetZoom(),!0}return!1}}export class SearchActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return searchActionDelegateInstance&&!t||(searchActionDelegateInstance=new SearchActionDelegate),searchActionDelegateInstance}handleAction(e,t){let n=UI.SearchableView.SearchableView.fromElement(document.deepActiveElement());if(!n){const e=UI.InspectorView.InspectorView.instance().currentPanelDeprecated();if(e&&e.searchableView&&(n=e.searchableView()),!n)return!1}switch(t){case"main.search-in-panel.find":return n.handleFindShortcut();case"main.search-in-panel.cancel":return n.handleCancelSearchShortcut();case"main.search-in-panel.find-next":return n.handleFindNextShortcut();case"main.search-in-panel.find-previous":return n.handleFindPreviousShortcut()}return!1}}export class MainMenuItem{itemInternal;constructor(){this.itemInternal=new UI.Toolbar.ToolbarMenuButton(this.handleContextMenu.bind(this),!0),this.itemInternal.element.classList.add("main-menu"),this.itemInternal.setTitle(i18nString(UIStrings.customizeAndControlDevtools))}static instance(e={forceNew:null}){const{forceNew:t}=e;return mainMenuItemInstance&&!t||(mainMenuItemInstance=new MainMenuItem),mainMenuItemInstance}item(){return this.itemInternal}handleContextMenu(e){if(UI.DockController.DockController.instance().canDock()){const t=document.createElement("div");t.classList.add("flex-centered"),t.classList.add("flex-auto"),t.tabIndex=-1,UI.ARIAUtils.setAccessibleName(t,UIStrings.dockSide);const o=t.createChild("span","flex-auto");o.textContent=i18nString(UIStrings.dockSide);const s=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("main.toggle-dock");UI.Tooltip.Tooltip.install(o,i18nString(UIStrings.placementOfDevtoolsRelativeToThe,{PH1:s[0].title()})),t.appendChild(o);const i=new UI.Toolbar.Toolbar("",t);i.makeBlueOnHover();const r=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.undockIntoSeparateWindow),"largeicon-undock"),a=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToBottom),"largeicon-dock-to-bottom"),c=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToRight),"largeicon-dock-to-right"),l=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToLeft),"largeicon-dock-to-left");r.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),a.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),c.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),l.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),r.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,"undocked")),a.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,"bottom")),c.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,"right")),l.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,"left")),r.setToggled("undocked"===UI.DockController.DockController.instance().dockSide()),a.setToggled("bottom"===UI.DockController.DockController.instance().dockSide()),c.setToggled("right"===UI.DockController.DockController.instance().dockSide()),l.setToggled("left"===UI.DockController.DockController.instance().dockSide()),i.appendToolbarItem(r),i.appendToolbarItem(l),i.appendToolbarItem(a),i.appendToolbarItem(c),t.addEventListener("keydown",(e=>{let t=0;if("ArrowLeft"===e.key)t=-1;else{if("ArrowRight"!==e.key)return;t=1}const n=[r,l,a,c];let o=n.findIndex((e=>e.element.hasFocus()));o=Platform.NumberUtilities.clamp(o+t,0,n.length-1),n[o].element.focus(),e.consume(!0)})),e.headerSection().appendCustomItem(t)}const t=this.itemInternal.element;function n(n){UI.DockController.DockController.instance().once("AfterDockSideChanged").then((()=>{t.focus()})),UI.DockController.DockController.instance().setDockSide(n),e.discard()}if("undocked"===UI.DockController.DockController.instance().dockSide()){const t=SDK.TargetManager.TargetManager.instance().mainTarget();t&&t.type()===SDK.Target.Type.Frame&&e.defaultSection().appendAction("inspector_main.focus-debuggee",i18nString(UIStrings.focusDebuggee))}e.defaultSection().appendAction("main.toggle-drawer",UI.InspectorView.InspectorView.instance().drawerVisible()?i18nString(UIStrings.hideConsoleDrawer):i18nString(UIStrings.showConsoleDrawer)),e.appendItemsAtLocation("mainMenu");const o=e.defaultSection().appendSubMenuItem(i18nString(UIStrings.moreTools)),s=UI.ViewManager.getRegisteredViewExtensions();s.sort(((e,t)=>{const n=e.title(),o=t.title();return n.localeCompare(o)}));for(const e of s){const t=e.location(),n=e.persistence(),s=e.title(),i=e.viewId();if("issues-pane"!==i){if("closeable"===n&&("drawer-view"===t||"panel"===t))if(e.isPreviewFeature()){const e=new IconButton.Icon.Icon;e.data={iconName:"ic_preview_feature",color:"var(--icon-color)",width:"14px",height:"14px"},o.defaultSection().appendItem(s,(()=>{UI.ViewManager.ViewManager.instance().showView(i,!0,!1)}),!1,e)}else o.defaultSection().appendItem(s,(()=>{UI.ViewManager.ViewManager.instance().showView(i,!0,!1)}))}else o.defaultSection().appendItem(s,(()=>{Host.userMetrics.issuesPanelOpenedFrom(Host.UserMetrics.IssueOpener.HamburgerMenu),UI.ViewManager.ViewManager.instance().showView("issues-pane",!0)}))}e.footerSection().appendSubMenuItem(i18nString(UIStrings.help)).appendItemsAtLocation("mainMenuHelp")}}export class SettingsButtonProvider{settingsButton;constructor(){this.settingsButton=UI.Toolbar.Toolbar.createActionButtonForId("settings.show",{showLabel:!1,userActionCode:void 0})}static instance(e={forceNew:null}){const{forceNew:t}=e;return settingsButtonProviderInstance&&!t||(settingsButtonProviderInstance=new SettingsButtonProvider),settingsButtonProviderInstance}item(){return this.settingsButton}}export class PauseListener{constructor(){SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this.debuggerPaused,this)}debuggerPaused(e){SDK.TargetManager.TargetManager.instance().removeModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this.debuggerPaused,this);const t=e.data,n=t.debuggerPausedDetails();UI.Context.Context.instance().setFlavor(SDK.Target.Target,t.target()),Common.Revealer.reveal(n)}}export function sendOverProtocol(e,t){return new Promise(((n,o)=>{const s=ProtocolClient.InspectorBackend.test.sendRawMessage;if(!s)return o("Unable to send message to test client");s(e,t,((e,...t)=>e?o(e):n(t)))}))}export class ReloadActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return reloadActionDelegateInstance&&!t||(reloadActionDelegateInstance=new ReloadActionDelegate),reloadActionDelegateInstance}handleAction(e,t){return"main.debug-reload"===t&&(Components.Reload.reload(),!0)}}