import*as Common from"../../core/common/common.js";import*as SDK from"../../core/sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{DebuggerWorkspaceBinding}from"./DebuggerWorkspaceBinding.js";import{LiveLocationPool}from"./LiveLocation.js";let breakpointManagerInstance;export class BreakpointManager extends Common.ObjectWrapper.ObjectWrapper{storage;#e;targetManager;debuggerWorkspaceBinding;#t;#o;constructor(e,t,o){super(),this.storage=new Storage,this.#e=t,this.targetManager=e,this.debuggerWorkspaceBinding=o,this.#t=new Map,this.#o=new Map,this.#e.addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this.uiSourceCodeAdded,this),this.#e.addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this.uiSourceCodeRemoved,this),this.#e.addEventListener(Workspace.Workspace.Events.ProjectRemoved,this.projectRemoved,this)}static instance(e={forceNew:null,targetManager:null,workspace:null,debuggerWorkspaceBinding:null}){const{forceNew:t,targetManager:o,workspace:i,debuggerWorkspaceBinding:n}=e;if(!breakpointManagerInstance||t){if(!o||!i||!n)throw new Error(`Unable to create settings: targetManager, workspace, and debuggerWorkspaceBinding must be provided: ${(new Error).stack}`);breakpointManagerInstance=new BreakpointManager(o,i,n)}return breakpointManagerInstance}static breakpointStorageId(e,t,o){return e?`${e}:${t}`+("number"==typeof o?`:${o}`:""):""}async copyBreakpoints(e,t){const o=this.storage.breakpointItems(e);for(const e of o)await this.setBreakpoint(t,e.lineNumber,e.columnNumber,e.condition,e.enabled)}restoreBreakpoints(e){const t=e.url();if(!t)return;this.storage.mute();const o=this.storage.breakpointItems(t);for(const t of o)this.innerSetBreakpoint(e,t.lineNumber,t.columnNumber,t.condition,t.enabled);this.storage.unmute()}uiSourceCodeAdded(e){const t=e.data;this.restoreBreakpoints(t)}uiSourceCodeRemoved(e){const t=e.data;this.removeUISourceCode(t)}projectRemoved(e){const t=e.data;for(const e of t.uiSourceCodes())this.removeUISourceCode(e)}removeUISourceCode(e){this.breakpointLocationsForUISourceCode(e).forEach((t=>t.breakpoint.removeUISourceCode(e)))}async setBreakpoint(e,t,o,i,n){let r=new Workspace.UISourceCode.UILocation(e,t,o);const s=await this.debuggerWorkspaceBinding.normalizeUILocation(r);return s.id()!==r.id()&&(Common.Revealer.reveal(s),r=s),this.innerSetBreakpoint(r.uiSourceCode,r.lineNumber,r.columnNumber,i,n)}innerSetBreakpoint(e,t,o,i,n){const r=BreakpointManager.breakpointStorageId(e.url(),t,o);let s=this.#o.get(r);return s?(s.updateState(i,n),s.addUISourceCode(e),s.updateBreakpoint(),s):(s=new Breakpoint(this,e,e.url(),t,o,i,n),this.#o.set(r,s),s)}findBreakpoint(e){const t=this.#t.get(e.uiSourceCode);return t&&t.get(e.id())||null}async possibleBreakpoints(e,t){const{pluginManager:o}=this.debuggerWorkspaceBinding;if(o){const i=await o.uiLocationToRawLocations(e,t.startLine);if(i){const e=[];for(const t of i){const o=await this.debuggerWorkspaceBinding.rawLocationToUILocation(t);o&&e.push(o)}return e}}const i=DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(e,t.startLine,t.startColumn),n=DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(e,t.endLine,t.endColumn),[r,s]=await Promise.all([i,n]),a=new Map;for(const e of s)a.set(e.debuggerModel,e);let d=null,u=null;for(const e of r){const t=a.get(e.debuggerModel);if(t){d=e,u=t;break}}return d&&u?d.debuggerModel.getPossibleBreakpoints(d,u,!1).then(async function(t){const o=t.map((e=>this.debuggerWorkspaceBinding.rawLocationToUILocation(e))),i=(await Promise.all(o)).filter((t=>t&&t.uiSourceCode===e));if(!i.length)return[];i.sort(Workspace.UISourceCode.UILocation.comparator);let n=i[0];const r=[n];for(const e of i)e.id()!==n.id()&&(r.push(e),n=e);return r}.bind(this)):[]}breakpointLocationsForUISourceCode(e){const t=this.#t.get(e);return t?Array.from(t.values()):[]}allBreakpointLocations(){const e=[];for(const t of this.#t.values())e.push(...t.values());return e}removeBreakpoint(e,t){t&&this.storage.removeBreakpoint(e),this.#o.delete(e.breakpointStorageId())}uiLocationAdded(e,t){let o=this.#t.get(t.uiSourceCode);o||(o=new Map,this.#t.set(t.uiSourceCode,o));const i={breakpoint:e,uiLocation:t};o.set(t.id(),i),this.dispatchEventToListeners(Events.BreakpointAdded,i)}uiLocationRemoved(e,t){const o=this.#t.get(t.uiSourceCode);if(!o)return;o.get(t.id())&&(o.delete(t.id()),0===o.size&&this.#t.delete(t.uiSourceCode),this.dispatchEventToListeners(Events.BreakpointRemoved,{breakpoint:e,uiLocation:t}))}}export var Events;!function(e){e.BreakpointAdded="breakpoint-added",e.BreakpointRemoved="breakpoint-removed"}(Events||(Events={}));export class Breakpoint{breakpointManager;urlInternal;#i;#n;#r;uiSourceCodes;#s;#a;isRemoved;currentState;#d;constructor(e,t,o,i,n,r,s){this.breakpointManager=e,this.urlInternal=o,this.#i=i,this.#n=n,this.#r=new Set,this.uiSourceCodes=new Set,this.currentState=null,this.#d=new Map,this.updateState(r,s),this.addUISourceCode(t),this.breakpointManager.targetManager.observeModels(SDK.DebuggerModel.DebuggerModel,this)}async refreshInDebugger(){if(!this.isRemoved){const e=Array.from(this.#d.values());await Promise.all(e.map((e=>e.refreshBreakpoint())))}}modelAdded(e){const t=this.breakpointManager.debuggerWorkspaceBinding;this.#d.set(e,new ModelBreakpoint(e,this,t))}modelRemoved(e){const t=this.#d.get(e);this.#d.delete(e),t&&(t.cleanUpAfterDebuggerIsGone(),t.removeEventListeners())}addUISourceCode(e){this.uiSourceCodes.has(e)||(this.uiSourceCodes.add(e),this.bound()||this.breakpointManager.uiLocationAdded(this,this.defaultUILocation(e)))}clearUISourceCodes(){this.bound()||this.removeAllUnboundLocations(),this.uiSourceCodes.clear()}removeUISourceCode(e){if(this.uiSourceCodes.has(e)&&(this.uiSourceCodes.delete(e),this.bound()||this.breakpointManager.uiLocationRemoved(this,this.defaultUILocation(e))),this.bound()){for(const t of this.#r)t.uiSourceCode===e&&(this.#r.delete(t),this.breakpointManager.uiLocationRemoved(this,t));this.bound()||this.isRemoved||this.addAllUnboundLocations()}}url(){return this.urlInternal}lineNumber(){return this.#i}columnNumber(){return this.#n}uiLocationAdded(e){this.isRemoved||(this.bound()||this.removeAllUnboundLocations(),this.#r.add(e),this.breakpointManager.uiLocationAdded(this,e))}uiLocationRemoved(e){this.#r.has(e)&&(this.#r.delete(e),this.breakpointManager.uiLocationRemoved(this,e),this.bound()||this.isRemoved||this.addAllUnboundLocations())}enabled(){return this.#a}bound(){return 0!==this.#r.size}hasBoundScript(){for(const e of this.uiSourceCodes)if(e.project().type()===Workspace.Workspace.projectTypes.Network)return!0;return!1}setEnabled(e){this.updateState(this.#s,e)}condition(){return this.#s}setCondition(e){this.updateState(e,this.#a)}updateState(e,t){this.#a===t&&this.#s===e||(this.#a=t,this.#s=e,this.breakpointManager.storage.updateBreakpoint(this),this.updateBreakpoint())}updateBreakpoint(){this.bound()||(this.removeAllUnboundLocations(),this.isRemoved||this.addAllUnboundLocations());for(const e of this.#d.values())e.scheduleUpdateInDebugger()}remove(e){this.isRemoved=!0;const t=!e;for(const e of this.#d.values())e.scheduleUpdateInDebugger(),e.removeEventListeners();this.breakpointManager.removeBreakpoint(this,t),this.breakpointManager.targetManager.unobserveModels(SDK.DebuggerModel.DebuggerModel,this),this.clearUISourceCodes()}breakpointStorageId(){return BreakpointManager.breakpointStorageId(this.urlInternal,this.#i,this.#n)}resetLocations(){this.clearUISourceCodes();for(const e of this.#d.values())e.resetLocations()}defaultUILocation(e){return e.uiLocation(this.#i,this.#n)}removeAllUnboundLocations(){for(const e of this.uiSourceCodes)this.breakpointManager.uiLocationRemoved(this,this.defaultUILocation(e))}addAllUnboundLocations(){for(const e of this.uiSourceCodes)this.breakpointManager.uiLocationAdded(this,this.defaultUILocation(e))}getUiSourceCodes(){return this.uiSourceCodes}getIsRemoved(){return this.isRemoved}}export class ModelBreakpoint{#u;#c;#h;#l;#r;#p;#g;#b;#k;#m;constructor(e,t,o){this.#u=e,this.#c=t,this.#h=o,this.#l=new LiveLocationPool,this.#r=new Map,this.#u.addEventListener(SDK.DebuggerModel.Events.DebuggerWasDisabled,this.cleanUpAfterDebuggerIsGone,this),this.#u.addEventListener(SDK.DebuggerModel.Events.DebuggerWasEnabled,this.scheduleUpdateInDebugger,this),this.#p=!1,this.#g=!1,this.#b=!1,this.#k=null,this.#m=[],this.#u.debuggerEnabled()&&this.scheduleUpdateInDebugger()}resetLocations(){for(const e of this.#r.values())this.#c.uiLocationRemoved(e);this.#r.clear(),this.#l.disposeAll()}scheduleUpdateInDebugger(){this.#g?this.#p=!0:(this.#g=!0,this.updateInDebugger().then((()=>{this.#g=!1,this.#p&&(this.#p=!1,this.scheduleUpdateInDebugger())})))}scriptDiverged(){for(const e of this.#c.getUiSourceCodes()){const t=this.#h.scriptFile(e,this.#u);if(t&&t.hasDivergedFromVM())return!0}return!1}async updateInDebugger(){if(this.#u.target().isDisposed())return void this.cleanUpAfterDebuggerIsGone();const e=this.#c.lineNumber(),t=this.#c.columnNumber(),o=this.#c.condition();let i=null;if(!this.#c.getIsRemoved()&&this.#c.enabled()&&!this.scriptDiverged()){let n=[];for(const o of this.#c.getUiSourceCodes()){if(n=(await DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(o,e,t)).filter((e=>e.debuggerModel===this.#u)),n.length)break}if(n.length&&n.every((e=>e.script()))){const e=n.map((e=>{const t=e.script();return{url:t.sourceURL,scriptId:t.scriptId,scriptHash:t.hash,lineNumber:e.lineNumber,columnNumber:e.columnNumber}}));i=new Breakpoint.State(e,o)}else if(this.#c.currentState)i=new Breakpoint.State(this.#c.currentState.positions,o);else{const n={url:this.#c.url(),scriptId:"",scriptHash:"",lineNumber:e,columnNumber:t};i=new Breakpoint.State([n],o)}}if(this.#m.length&&Breakpoint.State.equals(i,this.#k))return;if(this.#c.currentState=i,this.#m.length)return void await this.refreshBreakpoint();if(!i)return;const n=await Promise.all(i.positions.map((e=>e.url?this.#u.setBreakpointByURL(e.url,e.lineNumber,e.columnNumber,o):this.#u.setBreakpointInAnonymousScript(e.scriptId,e.scriptHash,e.lineNumber,e.columnNumber,o)))),r=[];let s=[],a=!1;for(const e of n)e.breakpointId?(r.push(e.breakpointId),s=s.concat(e.locations)):this.#u.debuggerEnabled()&&!this.#u.isReadyToPause()&&(a=!0);r.length||!a?(this.#k=i,this.#b?this.#b=!1:r.length?(this.#m=r,this.#m.forEach((e=>this.#u.addBreakpointListener(e,this.breakpointResolved,this))),await Promise.all(s.map((e=>this.addResolvedLocation(e))))):this.#c.remove(!0)):this.scheduleUpdateInDebugger()}async refreshBreakpoint(){this.#m.length&&(this.resetLocations(),await Promise.all(this.#m.map((e=>this.#u.removeBreakpoint(e)))),this.didRemoveFromDebugger(),this.#k=null,this.scheduleUpdateInDebugger())}didRemoveFromDebugger(){this.#b?this.#b=!1:(this.resetLocations(),this.#m.forEach((e=>this.#u.removeBreakpointListener(e,this.breakpointResolved,this))),this.#m=[])}async breakpointResolved({data:e}){await this.addResolvedLocation(e)}async locationUpdated(e){const t=this.#r.get(e),o=await e.uiLocation();t&&this.#c.uiLocationRemoved(t),o?(this.#r.set(e,o),this.#c.uiLocationAdded(o)):this.#r.delete(e)}async addResolvedLocation(e){const t=await this.#h.rawLocationToUILocation(e);if(!t)return;const o=this.#c.breakpointManager.findBreakpoint(t);o&&o.breakpoint!==this.#c?this.#c.remove(!1):await this.#h.createLiveLocation(e,this.locationUpdated.bind(this),this.#l)}cleanUpAfterDebuggerIsGone(){this.#g&&(this.#b=!0),this.resetLocations(),this.#k=null,this.#m.length&&this.didRemoveFromDebugger()}removeEventListeners(){this.#u.removeEventListener(SDK.DebuggerModel.Events.DebuggerWasDisabled,this.cleanUpAfterDebuggerIsGone,this),this.#u.removeEventListener(SDK.DebuggerModel.Events.DebuggerWasEnabled,this.scheduleUpdateInDebugger,this)}}!function(e){e.State=class{positions;condition;constructor(e,t){this.positions=e,this.condition=t}static equals(e,t){if(!e||!t)return!1;if(e.condition!==t.condition)return!1;if(e.positions.length!==t.positions.length)return!1;for(let o=0;o<e.positions.length;o++){const i=e.positions[o],n=t.positions[o];if(i.url!==n.url)return!1;if(i.scriptId!==n.scriptId)return!1;if(i.scriptHash!==n.scriptHash)return!1;if(i.lineNumber!==n.lineNumber)return!1;if(i.columnNumber!==n.columnNumber)return!1}return!0}}}(Breakpoint||(Breakpoint={}));class Storage{#I;#v;#S;constructor(){this.#I=Common.Settings.Settings.instance().createLocalSetting("breakpoints",[]),this.#v=new Map;const e=this.#I.get();for(const t of e)this.#v.set(BreakpointManager.breakpointStorageId(t.url,t.lineNumber,t.columnNumber),t)}get setting(){return this.#I}mute(){this.#S=!0}unmute(){this.#S=void 0}breakpointItems(e){return Array.from(this.#v.values()).filter((t=>t.url===e))}updateBreakpoint(e){!this.#S&&e.breakpointStorageId()&&(this.#v.set(e.breakpointStorageId(),new Storage.Item(e)),this.save())}removeBreakpoint(e){this.#S||(this.#v.delete(e.breakpointStorageId()),this.save())}save(){this.#I.set(Array.from(this.#v.values()))}}!function(e){e.Item=class{url;lineNumber;columnNumber;condition;enabled;constructor(e){this.url=e.url(),this.lineNumber=e.lineNumber(),this.columnNumber=e.columnNumber(),this.condition=e.condition(),this.enabled=e.enabled()}}}(Storage||(Storage={}));