import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import{CompilerScriptMapping}from"./CompilerScriptMapping.js";import{DebuggerLanguagePluginManager}from"./DebuggerLanguagePlugins.js";import{DefaultScriptMapping}from"./DefaultScriptMapping.js";import{IgnoreListManager}from"./IgnoreListManager.js";import{LiveLocationWithPool}from"./LiveLocation.js";import{ResourceMapping}from"./ResourceMapping.js";import{ResourceScriptMapping}from"./ResourceScriptMapping.js";let debuggerWorkspaceBindingInstance;export class DebuggerWorkspaceBinding{workspace;#e;#o;#t;pluginManager;constructor(e,o){this.workspace=o,this.#e=[],this.#o=new Map,e.addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.GlobalObjectCleared,this.globalObjectCleared,this),e.addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerResumed,this.debuggerResumed,this),e.observeModels(SDK.DebuggerModel.DebuggerModel,this),this.#t=new Set,this.pluginManager=Root.Runtime.experiments.isEnabled("wasmDWARFDebugging")?new DebuggerLanguagePluginManager(e,o,this):null}static instance(e={forceNew:null,targetManager:null,workspace:null}){const{forceNew:o,targetManager:t,workspace:i}=e;if(!debuggerWorkspaceBindingInstance||o){if(!t||!i)throw new Error(`Unable to create DebuggerWorkspaceBinding: targetManager and workspace must be provided: ${(new Error).stack}`);debuggerWorkspaceBindingInstance=new DebuggerWorkspaceBinding(t,i)}return debuggerWorkspaceBindingInstance}static removeInstance(){debuggerWorkspaceBindingInstance=void 0}addSourceMapping(e){this.#e.push(e)}async computeAutoStepRanges(e,o){function t(e,o){const{start:t,end:i}=o;return t.scriptId===e.scriptId&&(!(e.lineNumber<t.lineNumber||e.lineNumber>i.lineNumber)&&(!(e.lineNumber===t.lineNumber&&e.columnNumber<t.columnNumber)&&!(e.lineNumber===i.lineNumber&&e.columnNumber>=i.columnNumber)))}const i=o.location();if(!i)return[];const a=this.pluginManager;let r=[];if(a){if(e===SDK.DebuggerModel.StepMode.StepOut)return await a.getInlinedFunctionRanges(i);const o=await a.rawLocationToUILocation(i);if(o)return r=await a.uiLocationToRawLocationRanges(o.uiSourceCode,o.lineNumber,o.columnNumber)||[],r=r.filter((e=>t(i,e))),e===SDK.DebuggerModel.StepMode.StepOver&&(r=r.concat(await a.getInlinedCalleesRanges(i))),r}const n=this.#o.get(i.debuggerModel)?.compilerMapping;return n?(r=n.getLocationRangesForSameSourceLocation(i),r=r.filter((e=>t(i,e))),r):[]}modelAdded(e){this.#o.set(e,new ModelData(e,this)),e.setComputeAutoStepRangesCallback(this.computeAutoStepRanges.bind(this))}modelRemoved(e){e.setComputeAutoStepRangesCallback(null);const o=this.#o.get(e);o&&(o.dispose(),this.#o.delete(e))}async pendingLiveLocationChangesPromise(){await Promise.all(this.#t)}recordLiveLocationChange(e){e.then((()=>{this.#t.delete(e)})),this.#t.add(e)}async updateLocations(e){const o=this.#o.get(e.debuggerModel);if(o){const t=o.updateLocations(e);this.recordLiveLocationChange(t),await t}}async createLiveLocation(e,o,t){const i=this.#o.get(e.debuggerModel);if(!i)return null;const a=i.createLiveLocation(e,o,t);return this.recordLiveLocationChange(a),a}async createStackTraceTopFrameLiveLocation(e,o,t){console.assert(e.length>0);const i=StackTraceTopFrameLocation.createStackTraceTopFrameLocation(e,this,o,t);return this.recordLiveLocationChange(i),i}async createCallFrameLiveLocation(e,o,t){if(!e.script())return null;const i=e.debuggerModel,a=this.createLiveLocation(e,o,t);this.recordLiveLocationChange(a);const r=await a;return r?(this.registerCallFrameLiveLocation(i,r),r):null}async rawLocationToUILocation(e){for(const o of this.#e){const t=o.rawLocationToUILocation(e);if(t)return t}if(this.pluginManager){const o=await this.pluginManager.rawLocationToUILocation(e);if(o)return o}const o=this.#o.get(e.debuggerModel);return o?o.rawLocationToUILocation(e):null}uiSourceCodeForSourceMapSourceURL(e,o,t){const i=this.#o.get(e);return i?i.compilerMapping.uiSourceCodeForURL(o,t):null}async uiLocationToRawLocations(e,o,t){for(const i of this.#e){const a=i.uiLocationToRawLocations(e,o,t);if(a.length)return a}const i=await(this.pluginManager?.uiLocationToRawLocations(e,o,t));if(i)return i;for(const i of this.#o.values()){const a=i.uiLocationToRawLocations(e,o,t);if(a.length)return a}return[]}uiLocationToRawLocationsForUnformattedJavaScript(e,o,t){console.assert(e.contentType().isScript());const i=[];for(const a of this.#o.values())i.push(...a.uiLocationToRawLocations(e,o,t));return i}async normalizeUILocation(e){const o=await this.uiLocationToRawLocations(e.uiSourceCode,e.lineNumber,e.columnNumber);for(const e of o){const o=await this.rawLocationToUILocation(e);if(o)return o}return e}scriptFile(e,o){const t=this.#o.get(o);return t?t.getResourceMapping().scriptFile(e):null}scriptsForUISourceCode(e){const o=new Set;this.pluginManager&&this.pluginManager.scriptsForUISourceCode(e).forEach((e=>o.add(e)));for(const t of this.#o.values()){const i=t.getResourceMapping().scriptFile(e);i&&i.script&&o.add(i.script),t.compilerMapping.scriptsForUISourceCode(e).forEach((e=>o.add(e)))}return[...o]}scriptsForResource(e){const o=new Set;for(const t of this.#o.values()){const i=t.getResourceMapping().scriptFile(e);i&&i.script&&o.add(i.script)}return[...o]}supportsConditionalBreakpoints(e){if(!this.pluginManager)return!0;return this.pluginManager.scriptsForUISourceCode(e).every((e=>e.isJavaScript()))}sourceMapForScript(e){const o=this.#o.get(e.debuggerModel);return o?o.compilerMapping.sourceMapForScript(e):null}globalObjectCleared(e){this.reset(e.data)}reset(e){const o=this.#o.get(e);if(o){for(const e of o.callFrameLocations.values())this.removeLiveLocation(e);o.callFrameLocations.clear()}}resetForTest(e){const o=e.model(SDK.DebuggerModel.DebuggerModel),t=this.#o.get(o);t&&t.getResourceMapping().resetForTest()}registerCallFrameLiveLocation(e,o){const t=this.#o.get(e);if(t){t.callFrameLocations.add(o)}}removeLiveLocation(e){const o=this.#o.get(e.rawLocation.debuggerModel);o&&o.disposeLocation(e)}debuggerResumed(e){this.reset(e.data)}}class ModelData{#i;#a;callFrameLocations;#r;resourceMapping;compilerMapping;#n;constructor(e,o){this.#i=e,this.#a=o,this.callFrameLocations=new Set;const t=o.workspace;this.#r=new DefaultScriptMapping(e,t,o),this.resourceMapping=new ResourceScriptMapping(e,t,o),this.compilerMapping=new CompilerScriptMapping(e,t,o),this.#n=new Platform.MapUtilities.Multimap,e.setBeforePausedCallback(this.beforePaused.bind(this))}async createLiveLocation(e,o,t){console.assert(""!==e.scriptId);const i=e.scriptId,a=new Location(i,e,this.#a,o,t);return this.#n.set(i,a),await a.update(),a}disposeLocation(e){this.#n.delete(e.scriptId,e)}async updateLocations(e){const o=[];for(const t of this.#n.get(e.scriptId))o.push(t.update());await Promise.all(o)}rawLocationToUILocation(e){let o=this.compilerMapping.rawLocationToUILocation(e);return o=o||this.resourceMapping.rawLocationToUILocation(e),o=o||ResourceMapping.instance().jsLocationToUILocation(e),o=o||this.#r.rawLocationToUILocation(e),o}uiLocationToRawLocations(e,o,t=0){let i=this.compilerMapping.uiLocationToRawLocations(e,o,t);return i=i.length?i:this.resourceMapping.uiLocationToRawLocations(e,o,t),i=i.length?i:ResourceMapping.instance().uiLocationToJSLocations(e,o,t),i=i.length?i:this.#r.uiLocationToRawLocations(e,o,t),i}beforePaused(e){return Boolean(e.callFrames[0])}dispose(){this.#i.setBeforePausedCallback(null),this.compilerMapping.dispose(),this.resourceMapping.dispose(),this.#r.dispose()}getResourceMapping(){return this.resourceMapping}}export class Location extends LiveLocationWithPool{scriptId;rawLocation;#s;constructor(e,o,t,i,a){super(i,a),this.scriptId=e,this.rawLocation=o,this.#s=t}async uiLocation(){const e=this.rawLocation;return this.#s.rawLocationToUILocation(e)}dispose(){super.dispose(),this.#s.removeLiveLocation(this)}async isIgnoreListed(){const e=await this.uiLocation();return!!e&&IgnoreListManager.instance().isIgnoreListedUISourceCode(e.uiSourceCode)}}class StackTraceTopFrameLocation extends LiveLocationWithPool{#c;#u;#n;constructor(e,o){super(e,o),this.#c=!0,this.#u=null,this.#n=null}static async createStackTraceTopFrameLocation(e,o,t,i){const a=new StackTraceTopFrameLocation(t,i),r=e.map((e=>o.createLiveLocation(e,a.scheduleUpdate.bind(a),i)));return a.#n=(await Promise.all(r)).filter((e=>Boolean(e))),await a.updateLocation(),a}async uiLocation(){return this.#u?this.#u.uiLocation():null}async isIgnoreListed(){return!!this.#u&&this.#u.isIgnoreListed()}dispose(){if(super.dispose(),this.#n)for(const e of this.#n)e.dispose();this.#n=null,this.#u=null}async scheduleUpdate(){this.#c||(this.#c=!0,queueMicrotask((()=>{this.updateLocation()})))}async updateLocation(){if(this.#c=!1,this.#n&&0!==this.#n.length){this.#u=this.#n[0];for(const e of this.#n)if(!await e.isIgnoreListed()){this.#u=e;break}this.update()}}}