import*as Common from"../../core/common/common.js";import*as SDK from"../../core/sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as Workspace from"../workspace/workspace.js";import{ContentProviderBasedProject}from"./ContentProviderBasedProject.js";import{CSSWorkspaceBinding}from"./CSSWorkspaceBinding.js";import{DebuggerWorkspaceBinding}from"./DebuggerWorkspaceBinding.js";import{NetworkProject}from"./NetworkProject.js";import{resourceMetadata}from"./ResourceUtils.js";let resourceMappingInstance;const styleSheetOffsetMap=new WeakMap,scriptOffsetMap=new WeakMap,boundUISourceCodes=new WeakSet;export class ResourceMapping{#e;#t;constructor(e,t){this.#e=t,this.#t=new Map,e.observeModels(SDK.ResourceTreeModel.ResourceTreeModel,this)}static instance(e={forceNew:null,targetManager:null,workspace:null}){const{forceNew:t,targetManager:o,workspace:r}=e;if(!resourceMappingInstance||t){if(!o||!r)throw new Error(`Unable to create ResourceMapping: targetManager and workspace must be provided: ${(new Error).stack}`);resourceMappingInstance=new ResourceMapping(o,r)}return resourceMappingInstance}modelAdded(e){const t=new ModelInfo(this.#e,e);this.#t.set(e,t)}modelRemoved(e){const t=this.#t.get(e);t&&(t.dispose(),this.#t.delete(e))}infoForTarget(e){const t=e.model(SDK.ResourceTreeModel.ResourceTreeModel);return t&&this.#t.get(t)||null}cssLocationToUILocation(e){const t=e.header();if(!t)return null;const o=this.infoForTarget(e.cssModel().target());if(!o)return null;const r=o.getProject().uiSourceCodeForURL(e.url);if(!r)return null;const s=styleSheetOffsetMap.get(t)||TextUtils.TextRange.TextRange.createFromLocation(t.startLine,t.startColumn),n=e.lineNumber+s.startLine-t.startLine;let i=e.columnNumber;return e.lineNumber===t.startLine&&(i+=s.startColumn-t.startColumn),r.uiLocation(n,i)}jsLocationToUILocation(e){const t=e.script();if(!t)return null;const o=this.infoForTarget(e.debuggerModel.target());if(!o)return null;const r=o.getProject().uiSourceCodeForURL(t.sourceURL);if(!r)return null;const s=scriptOffsetMap.get(t)||TextUtils.TextRange.TextRange.createFromLocation(t.lineOffset,t.columnOffset),n=e.lineNumber+s.startLine-t.lineOffset;let i=e.columnNumber;return e.lineNumber===t.lineOffset&&(i+=s.startColumn-t.columnOffset),r.uiLocation(n,i)}uiLocationToJSLocations(e,t,o){if(!boundUISourceCodes.has(e))return[];const r=NetworkProject.targetForUISourceCode(e);if(!r)return[];const s=r.model(SDK.DebuggerModel.DebuggerModel);if(!s)return[];const n=s.createRawLocationByURL(e.url(),t,o);if(n){const e=n.script();if(e&&e.containsLocation(t,o))return[n]}return[]}uiLocationToCSSLocations(e){if(!boundUISourceCodes.has(e.uiSourceCode))return[];const t=NetworkProject.targetForUISourceCode(e.uiSourceCode);if(!t)return[];const o=t.model(SDK.CSSModel.CSSModel);return o?o.createRawLocationsByURL(e.uiSourceCode.url(),e.lineNumber,e.columnNumber):[]}resetForTest(e){const t=e.model(SDK.ResourceTreeModel.ResourceTreeModel),o=t?this.#t.get(t):null;o&&o.resetForTest()}}class ModelInfo{project;#o;#r;#s;constructor(e,t){const o=t.target();this.project=new ContentProviderBasedProject(e,"resources:"+o.id(),Workspace.Workspace.projectTypes.Network,"",!1),NetworkProject.setTargetForProject(this.project,o),this.#o=new Map;const r=o.model(SDK.CSSModel.CSSModel);console.assert(Boolean(r)),this.#r=r,this.#s=[t.addEventListener(SDK.ResourceTreeModel.Events.ResourceAdded,this.resourceAdded,this),t.addEventListener(SDK.ResourceTreeModel.Events.FrameWillNavigate,this.frameWillNavigate,this),t.addEventListener(SDK.ResourceTreeModel.Events.FrameDetached,this.frameDetached,this),this.#r.addEventListener(SDK.CSSModel.Events.StyleSheetChanged,(e=>{this.styleSheetChanged(e)}),this)]}async styleSheetChanged(e){const t=this.#r.styleSheetHeaderForId(e.data.styleSheetId);if(!t||!t.isInline||t.isInline&&t.isMutable)return;const o=this.#o.get(t.resourceURL());o&&await o.styleSheetChanged(t,e.data.edit||null)}acceptsResource(e){const t=e.resourceType();return(t===Common.ResourceType.resourceTypes.Image||t===Common.ResourceType.resourceTypes.Font||t===Common.ResourceType.resourceTypes.Document||t===Common.ResourceType.resourceTypes.Manifest)&&(!(t===Common.ResourceType.resourceTypes.Image&&e.mimeType&&!e.mimeType.startsWith("image"))&&(!(t===Common.ResourceType.resourceTypes.Font&&e.mimeType&&!e.mimeType.includes("font"))&&(t!==Common.ResourceType.resourceTypes.Image&&t!==Common.ResourceType.resourceTypes.Font||!e.contentURL().startsWith("data:"))))}resourceAdded(e){const t=e.data;if(!this.acceptsResource(t))return;let o=this.#o.get(t.url);o?o.addResource(t):(o=new Binding(this.project,t),this.#o.set(t.url,o))}removeFrameResources(e){for(const t of e.resources()){if(!this.acceptsResource(t))continue;const e=this.#o.get(t.url);e&&(1===e.resources.size?(e.dispose(),this.#o.delete(t.url)):e.removeResource(t))}}frameWillNavigate(e){this.removeFrameResources(e.data)}frameDetached(e){this.removeFrameResources(e.data.frame)}resetForTest(){for(const e of this.#o.values())e.dispose();this.#o.clear()}dispose(){Common.EventTarget.removeEventListeners(this.#s);for(const e of this.#o.values())e.dispose();this.#o.clear(),this.project.removeProject()}getProject(){return this.project}}class Binding{resources;#n;#i;#c;constructor(e,t){this.resources=new Set([t]),this.#n=e,this.#i=this.#n.createUISourceCode(t.url,t.contentType()),boundUISourceCodes.add(this.#i),t.frameId&&NetworkProject.setInitialFrameAttribution(this.#i,t.frameId),this.#n.addUISourceCodeWithProvider(this.#i,this,resourceMetadata(t),t.mimeType),this.#c=[]}inlineStyles(){const e=NetworkProject.targetForUISourceCode(this.#i),t=[];if(!e)return t;const o=e.model(SDK.CSSModel.CSSModel);if(o)for(const e of o.getStyleSheetIdsForURL(this.#i.url())){const r=o.styleSheetHeaderForId(e);r&&t.push(r)}return t}inlineScripts(){const e=NetworkProject.targetForUISourceCode(this.#i);if(!e)return[];const t=e.model(SDK.DebuggerModel.DebuggerModel);return t?t.scriptsForSourceURL(this.#i.url()):[]}async styleSheetChanged(e,t){if(this.#c.push({stylesheet:e,edit:t}),this.#c.length>1)return;const{content:o}=await this.#i.requestContent();null!==o&&await this.innerStyleSheetChanged(o),this.#c=[]}async innerStyleSheetChanged(e){const t=this.inlineScripts(),o=this.inlineStyles();let r=new TextUtils.Text.Text(e);for(const e of this.#c){const s=e.edit;if(!s)continue;const n=e.stylesheet,i=styleSheetOffsetMap.get(n)||TextUtils.TextRange.TextRange.createFromLocation(n.startLine,n.startColumn),c=s.oldRange.relativeFrom(i.startLine,i.startColumn),a=s.newRange.relativeFrom(i.startLine,i.startColumn);r=new TextUtils.Text.Text(r.replaceRange(c,s.newText));const u=[];for(const e of t){const t=scriptOffsetMap.get(e)||TextUtils.TextRange.TextRange.createFromLocation(e.lineOffset,e.columnOffset);t.follows(c)&&(scriptOffsetMap.set(e,t.rebaseAfterTextEdit(c,a)),u.push(DebuggerWorkspaceBinding.instance().updateLocations(e)))}for(const e of o){const t=styleSheetOffsetMap.get(e)||TextUtils.TextRange.TextRange.createFromLocation(e.startLine,e.startColumn);t.follows(c)&&(styleSheetOffsetMap.set(e,t.rebaseAfterTextEdit(c,a)),u.push(CSSWorkspaceBinding.instance().updateLocations(e)))}await Promise.all(u)}this.#i.addRevision(r.value())}addResource(e){this.resources.add(e),e.frameId&&NetworkProject.addFrameAttribution(this.#i,e.frameId)}removeResource(e){this.resources.delete(e),e.frameId&&NetworkProject.removeFrameAttribution(this.#i,e.frameId)}dispose(){this.#n.removeFile(this.#i.url())}firstResource(){return console.assert(this.resources.size>0),this.resources.values().next().value}contentURL(){return this.firstResource().contentURL()}contentType(){return this.firstResource().contentType()}contentEncoded(){return this.firstResource().contentEncoded()}requestContent(){return this.firstResource().requestContent()}searchInContent(e,t,o){return this.firstResource().searchInContent(e,t,o)}}