import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{BreakpointManager}from"./BreakpointManager.js";import{ContentProviderBasedProject}from"./ContentProviderBasedProject.js";import{NetworkProject}from"./NetworkProject.js";import{metadataForURL}from"./ResourceUtils.js";const UIStrings={liveEditFailed:"`LiveEdit` failed: {PH1}",liveEditCompileFailed:"`LiveEdit` compile failed: {PH1}"},str_=i18n.i18n.registerUIStrings("models/bindings/ResourceScriptMapping.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ResourceScriptMapping{debuggerModel;#e;debuggerWorkspaceBinding;#t;#r;#i;#o;constructor(e,t,r){this.debuggerModel=e,this.#e=t,this.debuggerWorkspaceBinding=r,this.#t=new Map,this.#r=new Map,this.#i=new Set;const i=e.runtimeModel();this.#o=[this.debuggerModel.addEventListener(SDK.DebuggerModel.Events.ParsedScriptSource,(e=>{this.parsedScriptSource(e)}),this),this.debuggerModel.addEventListener(SDK.DebuggerModel.Events.GlobalObjectCleared,this.globalObjectCleared,this),i.addEventListener(SDK.RuntimeModel.Events.ExecutionContextDestroyed,this.executionContextDestroyed,this)]}project(e){const t=(e.isContentScript()?"js:extensions:":"js::")+this.debuggerModel.target().id()+":"+e.frameId;let r=this.#r.get(t);if(!r){const i=e.isContentScript()?Workspace.Workspace.projectTypes.ContentScripts:Workspace.Workspace.projectTypes.Network;r=new ContentProviderBasedProject(this.#e,t,i,"",!1),NetworkProject.setTargetForProject(r,this.debuggerModel.target()),this.#r.set(t,r)}return r}rawLocationToUILocation(e){const t=e.script();if(!t)return null;const r=this.project(t).uiSourceCodeForURL(t.sourceURL);if(!r)return null;const i=this.#t.get(r);if(!i)return null;if(i.hasDivergedFromVM()&&!i.isMergingToVM()||i.isDivergingFromVM())return null;if(!i.hasScripts([t]))return null;const{lineNumber:o,columnNumber:s=0}=e;return r.uiLocation(o,s)}uiLocationToRawLocations(e,t,r){const i=this.#t.get(e);if(!i)return[];const{script:o}=i;return o?[this.debuggerModel.createRawLocation(o,t,r)]:[]}acceptsScript(e){if(!e.sourceURL||e.isLiveEdit()||e.isInlineScript()&&!e.hasSourceURL)return!1;if(e.isContentScript()&&!e.hasSourceURL){if(!new Common.ParsedURL.ParsedURL(e.sourceURL).isValid)return!1}return!0}async parsedScriptSource(e){const t=e.data;if(!this.acceptsScript(t))return;this.#i.add(t);const r=t.originalContentProvider(),i=t.sourceURL,o=this.project(t),s=o.uiSourceCodeForURL(i);if(s){const e=this.#t.get(s);e&&e.script&&await this.removeScript(e.script)}const n=o.createUISourceCode(i,r.contentType());NetworkProject.setInitialFrameAttribution(n,t.frameId);const c=metadataForURL(this.debuggerModel.target(),t.frameId,i),a=new ResourceScriptFile(this,n,[t]);this.#t.set(n,a);const p=t.isWasm()?"application/wasm":"text/javascript";o.addUISourceCodeWithProvider(n,r,c,p),await this.debuggerWorkspaceBinding.updateLocations(t)}scriptFile(e){return this.#t.get(e)||null}async removeScript(e){if(!this.#i.has(e))return;this.#i.delete(e);const t=this.project(e),r=t.uiSourceCodeForURL(e.sourceURL),i=this.#t.get(r);i&&i.dispose(),this.#t.delete(r),t.removeFile(e.sourceURL),await this.debuggerWorkspaceBinding.updateLocations(e)}executionContextDestroyed(e){const t=e.data,r=this.debuggerModel.scriptsForExecutionContext(t);for(const e of r)this.removeScript(e)}globalObjectCleared(){const e=Array.from(this.#i);for(const t of e)this.removeScript(t)}resetForTest(){const e=Array.from(this.#i);for(const t of e)this.removeScript(t)}dispose(){Common.EventTarget.removeEventListeners(this.#o);const e=Array.from(this.#i);for(const t of e)this.removeScript(t);for(const e of this.#r.values())e.removeProject();this.#r.clear()}}export class ResourceScriptFile extends Common.ObjectWrapper.ObjectWrapper{#s;#n;scriptInternal;#c;#a;#p;#d;constructor(e,t,r){super(),console.assert(r.length>0),this.#s=e,this.#n=t,this.#n.contentType().isScript()&&(this.scriptInternal=r[r.length-1]),this.#n.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.workingCopyChanged,this),this.#n.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.workingCopyCommitted,this)}hasScripts(e){return Boolean(this.scriptInternal)&&this.scriptInternal===e[0]}isDiverged(){if(this.#n.isDirty())return!0;if(!this.scriptInternal)return!1;if(void 0===this.#c||null===this.#c)return!1;const e=this.#n.workingCopy();if(!e)return!1;if(!e.startsWith(this.#c.trimRight()))return!0;const t=this.#n.workingCopy().substr(this.#c.length);return Boolean(t.length)&&!t.match(SDK.Script.sourceURLRegex)}workingCopyChanged(){this.update()}workingCopyCommitted(){if(this.#n.project().canSetFileContent())return;if(!this.scriptInternal)return;const e=this.#s.debuggerModel,t=BreakpointManager.instance().breakpointLocationsForUISourceCode(this.#n).map((e=>e.breakpoint)),r=this.#n.workingCopy();e.setScriptSource(this.scriptInternal.scriptId,r,((e,i)=>{this.scriptSourceWasSet(r,t,e,i)}))}async scriptSourceWasSet(e,t,r,i){if(r||i||(this.#c=e),await this.update(),!r&&!i)return void await Promise.all(t.map((e=>e.refreshInDebugger())));if(!i)return void Common.Console.Console.instance().addMessage(i18nString(UIStrings.liveEditFailed,{PH1:String(r)}),Common.Console.MessageLevel.Warning);const o=i18nString(UIStrings.liveEditCompileFailed,{PH1:i.text});this.#n.addLineMessage(Workspace.UISourceCode.Message.Level.Error,o,i.lineNumber,i.columnNumber)}async update(){this.isDiverged()&&!this.#p?await this.divergeFromVM():!this.isDiverged()&&this.#p&&await this.mergeToVM()}async divergeFromVM(){this.scriptInternal&&(this.#a=!0,await this.#s.debuggerWorkspaceBinding.updateLocations(this.scriptInternal),this.#a=void 0,this.#p=!0,this.dispatchEventToListeners("DidDivergeFromVM"))}async mergeToVM(){this.scriptInternal&&(this.#p=void 0,this.#d=!0,await this.#s.debuggerWorkspaceBinding.updateLocations(this.scriptInternal),this.#d=void 0,this.dispatchEventToListeners("DidMergeToVM"))}hasDivergedFromVM(){return Boolean(this.#p)}isDivergingFromVM(){return Boolean(this.#a)}isMergingToVM(){return Boolean(this.#d)}checkMapping(){this.scriptInternal&&void 0===this.#c?this.scriptInternal.requestContent().then((e=>{this.#c=e.content,this.update().then((()=>this.mappingCheckedForTest()))})):this.mappingCheckedForTest()}mappingCheckedForTest(){}dispose(){this.#n.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.workingCopyChanged,this),this.#n.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.workingCopyCommitted,this)}addSourceMapURL(e){this.scriptInternal&&this.scriptInternal.debuggerModel.setSourceMapURL(this.scriptInternal,e)}hasSourceMapURL(){return void 0!==this.scriptInternal&&Boolean(this.scriptInternal.sourceMapURL)}get script(){return this.scriptInternal||null}get uiSourceCode(){return this.#n}}