import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Logs from"../../models/logs/logs.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import*as ThemeSupport from"../../ui/legacy/theme_support/theme_support.js";import*as Bindings from"../bindings/bindings.js";import*as HAR from"../har/har.js";import*as Workspace from"../workspace/workspace.js";import{ExtensionButton,ExtensionPanel,ExtensionSidebarPane}from"./ExtensionPanel.js";import{ExtensionTraceProvider}from"./ExtensionTraceProvider.js";import{LanguageExtensionEndpoint}from"./LanguageExtensionEndpoint.js";const extensionOrigins=new WeakMap,kAllowedOrigins=["chrome://newtab","chrome://new-tab-page"].map((e=>new URL(e).origin));let extensionServerInstance;export class ExtensionServer extends Common.ObjectWrapper.ObjectWrapper{clientObjects;handlers;subscribers;subscriptionStartHandlers;subscriptionStopHandlers;extraHeaders;requests;requestIds;lastRequestId;registeredExtensions;status;sidebarPanesInternal;traceProvidersInternal;traceSessions;extensionsEnabled;inspectedTabId;extensionAPITestHook;constructor(){super(),this.clientObjects=new Map,this.handlers=new Map,this.subscribers=new Map,this.subscriptionStartHandlers=new Map,this.subscriptionStopHandlers=new Map,this.extraHeaders=new Map,this.requests=new Map,this.requestIds=new Map,this.lastRequestId=0,this.registeredExtensions=new Map,this.status=new ExtensionStatus,this.sidebarPanesInternal=[],this.traceProvidersInternal=[],this.traceSessions=new Map,this.extensionsEnabled=!0,this.registerHandler("addRequestHeaders",this.onAddRequestHeaders.bind(this)),this.registerHandler("addTraceProvider",this.onAddTraceProvider.bind(this)),this.registerHandler("applyStyleSheet",this.onApplyStyleSheet.bind(this)),this.registerHandler("completeTra.eSession",this.onCompleteTraceSession.bind(this)),this.registerHandler("createPanel",this.onCreatePanel.bind(this)),this.registerHandler("createSidebarPane",this.onCreateSidebarPane.bind(this)),this.registerHandler("createToolbarButton",this.onCreateToolbarButton.bind(this)),this.registerHandler("evaluateOnInspectedPage",this.onEvaluateOnInspectedPage.bind(this)),this.registerHandler("_forwardKeyboardEvent",this.onForwardKeyboardEvent.bind(this)),this.registerHandler("getHAR",this.onGetHAR.bind(this)),this.registerHandler("getPageResources",this.onGetPageResources.bind(this)),this.registerHandler("getRequestContent",this.onGetRequestContent.bind(this)),this.registerHandler("getResourceContent",this.onGetResourceContent.bind(this)),this.registerHandler("Reload",this.onReload.bind(this)),this.registerHandler("setOpenResourceHandler",this.onSetOpenResourceHandler.bind(this)),this.registerHandler("setResourceContent",this.onSetResourceContent.bind(this)),this.registerHandler("setSidebarHeight",this.onSetSidebarHeight.bind(this)),this.registerHandler("setSidebarContent",this.onSetSidebarContent.bind(this)),this.registerHandler("setSidebarPage",this.onSetSidebarPage.bind(this)),this.registerHandler("showPanel",this.onShowPanel.bind(this)),this.registerHandler("subscribe",this.onSubscribe.bind(this)),this.registerHandler("openResource",this.onOpenResource.bind(this)),this.registerHandler("unsubscribe",this.onUnsubscribe.bind(this)),this.registerHandler("updateButton",this.onUpdateButton.bind(this)),this.registerHandler("registerLanguageExtensionPlugin",this.registerLanguageExtensionEndpoint.bind(this)),window.addEventListener("message",this.onWindowMessage.bind(this),!1);const e=window.DevToolsAPI&&window.DevToolsAPI.getInspectedTabId&&window.DevToolsAPI.getInspectedTabId();e&&this.setInspectedTabId({data:e}),Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.SetInspectedTabId,this.setInspectedTabId,this),this.initExtensions()}static instance(e={forceNew:null}){const{forceNew:t}=e;return extensionServerInstance&&!t||(extensionServerInstance=new ExtensionServer),extensionServerInstance}initializeExtensions(){null!==this.inspectedTabId&&Host.InspectorFrontendHost.InspectorFrontendHostInstance.setAddExtensionCallback(this.addExtension.bind(this))}hasExtensions(){return Boolean(this.registeredExtensions.size)}notifySearchAction(e,t,s){this.postNotification("panel-search-"+e,t,s)}notifyViewShown(e,t){this.postNotification("view-shown-"+e,t)}notifyViewHidden(e){this.postNotification("view-hidden,"+e)}notifyButtonClicked(e){this.postNotification("button-clicked-"+e)}registerLanguageExtensionEndpoint(e,t){if("registerLanguageExtensionPlugin"!==e.command)return this.status.E_BADARG("command","expected subscribe");const{pluginManager:s}=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance();if(!s)return this.status.E_FAILED("WebAssembly DWARF support needs to be enabled to use this extension");const{pluginName:n,port:i,supportedScriptTypes:{language:r,symbol_types:o}}=e,a=Array.isArray(o)&&o.every((e=>"string"==typeof e))?o:[],c=new LanguageExtensionEndpoint(n,{language:r,symbol_types:a},i);return s.addPlugin(c),this.status.OK()}inspectedURLChanged(e){if(!this.canInspectURL(e.data.inspectedURL()))return void this.disableExtensions();if(e.data!==SDK.TargetManager.TargetManager.instance().mainTarget())return;this.requests=new Map;const t=e.data.inspectedURL();this.postNotification("inspected-url-changed",t)}startTraceRecording(e,t,s){this.traceSessions.set(t,s),this.postNotification("trace-recording-started-"+e,t)}stopTraceRecording(e){this.postNotification("trace-recording-stopped-"+e)}hasSubscribers(e){return this.subscribers.has(e)}postNotification(e,...t){if(!this.extensionsEnabled)return;const s=this.subscribers.get(e);if(!s)return;const n={command:"notify-"+e,arguments:Array.prototype.slice.call(arguments,1)};for(const e of s)e.postMessage(n)}onSubscribe(e,t){if("subscribe"!==e.command)return this.status.E_BADARG("command","expected subscribe");const s=this.subscribers.get(e.type);if(s)s.add(t);else{this.subscribers.set(e.type,new Set([t]));const s=this.subscriptionStartHandlers.get(e.type);s&&s()}}onUnsubscribe(e,t){if("unsubscribe"!==e.command)return this.status.E_BADARG("command","expected unsubscribe");const s=this.subscribers.get(e.type);if(s&&(s.delete(t),!s.size)){this.subscribers.delete(e.type);const t=this.subscriptionStopHandlers.get(e.type);t&&t()}}onAddRequestHeaders(e){if("addRequestHeaders"!==e.command)return this.status.E_BADARG("command","expected addRequestHeaders");const t=e.extensionId;if("string"!=typeof t)return this.status.E_BADARGTYPE("extensionId",typeof t,"string");let s=this.extraHeaders.get(t);s||(s=new Map,this.extraHeaders.set(t,s));for(const t in e.headers)s.set(t,e.headers[t]);const n={};for(const e of this.extraHeaders.values())for(const[t,s]of e)"__proto__"!==t&&"string"==typeof s&&(n[t]=s);SDK.NetworkManager.MultitargetNetworkManager.instance().setExtraHTTPHeaders(n)}onApplyStyleSheet(e){if("applyStyleSheet"!==e.command)return this.status.E_BADARG("command","expected applyStyleSheet");if(!Root.Runtime.experiments.isEnabled("applyCustomStylesheet"))return;const t=document.createElement("style");t.textContent=e.styleSheet,document.head.appendChild(t),ThemeSupport.ThemeSupport.instance().addCustomStylesheet(e.styleSheet);for(let e=document.body;e;e=e.traverseNextNode(document.body))e instanceof ShadowRoot&&ThemeSupport.ThemeSupport.instance().injectCustomStyleSheets(e)}getExtensionOrigin(e){const t=extensionOrigins.get(e);if(!t)throw new Error("Received a message from an unregistered extension");return t}onCreatePanel(e,t){if("createPanel"!==e.command)return this.status.E_BADARG("command","expected createPanel");const s=e.id;if(this.clientObjects.has(s)||UI.InspectorView.InspectorView.instance().hasPanel(s))return this.status.E_EXISTS(s);const n=this.expandResourcePath(this.getExtensionOrigin(t),e.page);let i=this.getExtensionOrigin(t)+e.title;i=i.replace(/\s/g,"");const r=new ExtensionServerPanelView(i,e.title,new ExtensionPanel(this,i,s,n));return this.clientObjects.set(s,r),UI.InspectorView.InspectorView.instance().addPanel(r),this.status.OK()}onShowPanel(e){if("showPanel"!==e.command)return this.status.E_BADARG("command","expected showPanel");let t=e.id;const s=this.clientObjects.get(e.id);s&&s instanceof ExtensionServerPanelView&&(t=s.viewId()),UI.InspectorView.InspectorView.instance().showPanel(t)}onCreateToolbarButton(e,t){if("createToolbarButton"!==e.command)return this.status.E_BADARG("command","expected createToolbarButton");const s=this.clientObjects.get(e.panel);if(!(s&&s instanceof ExtensionServerPanelView))return this.status.E_NOTFOUND(e.panel);const n=new ExtensionButton(this,e.id,this.expandResourcePath(this.getExtensionOrigin(t),e.icon),e.tooltip,e.disabled);return this.clientObjects.set(e.id,n),s.widget().then((function(e){e.addToolbarItem(n.toolbarButton())})),this.status.OK()}onUpdateButton(e,t){if("updateButton"!==e.command)return this.status.E_BADARG("command","expected updateButton");const s=this.clientObjects.get(e.id);return s&&s instanceof ExtensionButton?(s.update(e.icon&&this.expandResourcePath(this.getExtensionOrigin(t),e.icon),e.tooltip,e.disabled),this.status.OK()):this.status.E_NOTFOUND(e.id)}onCompleteTraceSession(e){if("completeTra.eSession"!==e.command)return this.status.E_BADARG("command","expected completeTra.eSession");const t=this.traceSessions.get(e.id);if(!t)return this.status.E_NOTFOUND(e.id);this.traceSessions.delete(e.id),t.complete(e.url,e.timeOffset)}onCreateSidebarPane(e){if("createSidebarPane"!==e.command)return this.status.E_BADARG("command","expected createSidebarPane");const t=e.id,s=new ExtensionSidebarPane(this,e.panel,e.title,t);return this.sidebarPanesInternal.push(s),this.clientObjects.set(t,s),this.dispatchEventToListeners(Events.SidebarPaneAdded,s),this.status.OK()}sidebarPanes(){return this.sidebarPanesInternal}onSetSidebarHeight(e){if("setSidebarHeight"!==e.command)return this.status.E_BADARG("command","expected setSidebarHeight");const t=this.clientObjects.get(e.id);return t&&t instanceof ExtensionSidebarPane?(t.setHeight(e.height),this.status.OK()):this.status.E_NOTFOUND(e.id)}onSetSidebarContent(e,t){if("setSidebarContent"!==e.command)return this.status.E_BADARG("command","expected setSidebarContent");const{requestId:s,id:n,rootTitle:i,expression:r,evaluateOptions:o,evaluateOnPage:a}=e,c=this.clientObjects.get(n);if(!(c&&c instanceof ExtensionSidebarPane))return this.status.E_NOTFOUND(e.id);function d(e){const n=e?this.status.E_FAILED(e):this.status.OK();this.dispatchCallback(s,t,n)}a?c.setExpression(r,i,o,this.getExtensionOrigin(t),d.bind(this)):c.setObject(e.expression,e.rootTitle,d.bind(this))}onSetSidebarPage(e,t){if("setSidebarPage"!==e.command)return this.status.E_BADARG("command","expected setSidebarPage");const s=this.clientObjects.get(e.id);if(!(s&&s instanceof ExtensionSidebarPane))return this.status.E_NOTFOUND(e.id);s.setPage(this.expandResourcePath(this.getExtensionOrigin(t),e.page))}onOpenResource(e){if("openResource"!==e.command)return this.status.E_BADARG("command","expected openResource");const t=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(e.url);if(t)return Common.Revealer.reveal(t.uiLocation(e.lineNumber,e.columnNumber)),this.status.OK();const s=Bindings.ResourceUtils.resourceForURL(e.url);if(s)return Common.Revealer.reveal(s),this.status.OK();const n=Logs.NetworkLog.NetworkLog.instance().requestForURL(e.url);return n?(Common.Revealer.reveal(n),this.status.OK()):this.status.E_NOTFOUND(e.url)}onSetOpenResourceHandler(e,t){if("setOpenResourceHandler"!==e.command)return this.status.E_BADARG("command","expected setOpenResourceHandler");const s=this.registeredExtensions.get(this.getExtensionOrigin(t));if(!s)throw new Error("Received a message from an unregistered extension");const{name:n}=s;e.handlerPresent?Components.Linkifier.Linkifier.registerLinkHandler(n,this.handleOpenURL.bind(this,t)):Components.Linkifier.Linkifier.unregisterLinkHandler(n)}handleOpenURL(e,t,s){e.postMessage({command:"open-resource",resource:this.makeResource(t),lineNumber:s+1})}onReload(e){if("Reload"!==e.command)return this.status.E_BADARG("command","expected Reload");const t=e.options||{};let s;return SDK.NetworkManager.MultitargetNetworkManager.instance().setUserAgentOverride("string"==typeof t.userAgent?t.userAgent:"",null),t.injectedScript&&(s="(function(){"+t.injectedScript+"})()"),SDK.ResourceTreeModel.ResourceTreeModel.reloadAllPages(Boolean(t.ignoreCache),s),this.status.OK()}onEvaluateOnInspectedPage(e,t){if("evaluateOnInspectedPage"!==e.command)return this.status.E_BADARG("command","expected evaluateOnInspectedPage");const{requestId:s,expression:n,evaluateOptions:i}=e;return this.evaluate(n,!0,!0,i,this.getExtensionOrigin(t),function(e,n,i){let r;r=e||!n?this.status.E_PROTOCOLERROR(e?.toString()):i?{isException:!0,value:n.description}:{value:n.value},this.dispatchCallback(s,t,r)}.bind(this))}async onGetHAR(e){if("getHAR"!==e.command)return this.status.E_BADARG("command","expected getHAR");const t=Logs.NetworkLog.NetworkLog.instance().requests(),s=await HAR.Log.Log.build(t);for(let e=0;e<s.entries.length;++e)s.entries[e]._requestId=this.requestId(t[e]);return s}makeResource(e){return{url:e.contentURL(),type:e.contentType().name()}}onGetPageResources(){const e=new Map;function t(t){return e.has(t.contentURL())||e.set(t.contentURL(),this.makeResource(t)),!1}let s=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodesForProjectType(Workspace.Workspace.projectTypes.Network);s=s.concat(Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodesForProjectType(Workspace.Workspace.projectTypes.ContentScripts)),s.forEach(t.bind(this));for(const e of SDK.TargetManager.TargetManager.instance().models(SDK.ResourceTreeModel.ResourceTreeModel))e.forAllResources(t.bind(this));return[...e.values()]}async getResourceContent(e,t,s){const{content:n}=await e.requestContent(),i=await e.contentEncoded();this.dispatchCallback(t.requestId,s,{encoding:i?"base64":"",content:n})}onGetRequestContent(e,t){if("getRequestContent"!==e.command)return this.status.E_BADARG("command","expected getRequestContent");const s=this.requestById(e.id);if(!s)return this.status.E_NOTFOUND(e.id);this.getResourceContent(s,e,t)}onGetResourceContent(e,t){if("getResourceContent"!==e.command)return this.status.E_BADARG("command","expected getResourceContent");const s=e.url,n=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(s)||Bindings.ResourceUtils.resourceForURL(s);if(!n)return this.status.E_NOTFOUND(s);this.getResourceContent(n,e,t)}onSetResourceContent(e,t){if("setResourceContent"!==e.command)return this.status.E_BADARG("command","expected setResourceContent");const{url:s,requestId:n,content:i,commit:r}=e;const o=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(s);if(!o||!o.contentType().isDocumentOrScriptOrStyleSheet()){return SDK.ResourceTreeModel.ResourceTreeModel.resourceForURL(s)?this.status.E_NOTSUPPORTED("Resource is not editable"):this.status.E_NOTFOUND(s)}o.setWorkingCopy(i),r&&o.commitWorkingCopy(),function(e){const s=e?this.status.E_FAILED(e):this.status.OK();this.dispatchCallback(n,t,s)}.call(this,null)}requestId(e){const t=this.requestIds.get(e);if(void 0===t){const t=++this.lastRequestId;return this.requestIds.set(e,t),this.requests.set(t,e),t}return t}requestById(e){return this.requests.get(e)}onAddTraceProvider(e,t){if("addTraceProvider"!==e.command)return this.status.E_BADARG("command","expected addTraceProvider");const s=new ExtensionTraceProvider(this.getExtensionOrigin(t),e.id,e.categoryName,e.categoryTooltip);this.clientObjects.set(e.id,s),this.traceProvidersInternal.push(s),this.dispatchEventToListeners(Events.TraceProviderAdded,s)}traceProviders(){return this.traceProvidersInternal}onForwardKeyboardEvent(e){if("_forwardKeyboardEvent"!==e.command)return this.status.E_BADARG("command","expected _forwardKeyboardEvent");e.entries.forEach((function(e){const t=new window.KeyboardEvent(e.eventType,{key:e.key,code:e.code,keyCode:e.keyCode,location:e.location,ctrlKey:e.ctrlKey,altKey:e.altKey,shiftKey:e.shiftKey,metaKey:e.metaKey});t.__keyCode=function(e){let t=e.keyCode;t||e.key===Platform.KeyboardUtilities.ESCAPE_KEY&&(t=27);return t||0}(e),document.dispatchEvent(t)}))}dispatchCallback(e,t,s){e&&t.postMessage({command:"callback",requestId:e,result:s})}initExtensions(){this.registerAutosubscriptionHandler("resource-added",Workspace.Workspace.WorkspaceImpl.instance(),Workspace.Workspace.Events.UISourceCodeAdded,this.notifyResourceAdded),this.registerAutosubscriptionTargetManagerHandler("network-request-finished",SDK.NetworkManager.NetworkManager,SDK.NetworkManager.Events.RequestFinished,this.notifyRequestFinished),this.registerSubscriptionHandler("panel-objectSelected-elements",function(){UI.Context.Context.instance().addFlavorChangeListener(SDK.DOMModel.DOMNode,this.notifyElementsSelectionChanged,this)}.bind(this),function(){UI.Context.Context.instance().removeFlavorChangeListener(SDK.DOMModel.DOMNode,this.notifyElementsSelectionChanged,this)}.bind(this)),this.registerResourceContentCommittedHandler(this.notifyUISourceCodeContentCommitted),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.InspectedURLChanged,this.inspectedURLChanged,this)}notifyResourceAdded(e){const t=e.data;this.postNotification("resource-added",this.makeResource(t))}notifyUISourceCodeContentCommitted(e){const{uiSourceCode:t,content:s}=e.data;this.postNotification("resource-content-committed",this.makeResource(t),s)}async notifyRequestFinished(e){const t=e.data,s=await HAR.Log.Entry.build(t);this.postNotification("network-request-finished",this.requestId(t),s)}notifyElementsSelectionChanged(){this.postNotification("panel-objectSelected-elements")}sourceSelectionChanged(e,t){this.postNotification("panel-objectSelected-sources",{startLine:t.startLine,startColumn:t.startColumn,endLine:t.endLine,endColumn:t.endColumn,url:e})}setInspectedTabId(e){const t=this.inspectedTabId;this.inspectedTabId=e.data,null===t&&this.initializeExtensions()}addExtension(e){const t=e.startPage,s=SDK.TargetManager.TargetManager.instance().mainTarget()?.inspectedURL()??"";if(""===s||this.canInspectURL(s)||this.disableExtensions(),this.extensionsEnabled){try{const s=new URL(t).origin;if(!this.registeredExtensions.get(s)){const t=self.buildExtensionAPIInjectedScript(e,this.inspectedTabId,ThemeSupport.ThemeSupport.instance().themeName(),UI.ShortcutRegistry.ShortcutRegistry.instance().globalShortcutKeys(),ExtensionServer.instance().extensionAPITestHook);Host.InspectorFrontendHost.InspectorFrontendHostInstance.setInjectedScriptForOrigin(s,t);const n=e.name||`Extension ${s}`;this.registeredExtensions.set(s,{name:n})}const n=document.createElement("iframe");n.src=t,n.dataset.devtoolsExtension=e.name,n.style.display="none",document.body.appendChild(n)}catch(e){return console.error("Failed to initialize extension "+t+":"+e),!1}return!0}}registerExtension(e,t){this.registeredExtensions.has(e)?(extensionOrigins.set(t,e),t.addEventListener("message",this.onmessage.bind(this),!1),t.start()):e!==window.location.origin&&console.error("Ignoring unauthorized client request from "+e)}onWindowMessage(e){"registerExtension"===e.data&&this.registerExtension(e.origin,e.ports[0])}async onmessage(e){const t=e.data;let s;const n=this.handlers.get(t.command);s=n?this.extensionsEnabled?await n(t,e.target):this.status.E_FAILED("Permission denied"):this.status.E_NOTSUPPORTED(t.command),s&&t.requestId&&this.dispatchCallback(t.requestId,e.target,s)}registerHandler(e,t){console.assert(Boolean(e)),this.handlers.set(e,t)}registerSubscriptionHandler(e,t,s){this.subscriptionStartHandlers.set(e,t),this.subscriptionStopHandlers.set(e,s)}registerAutosubscriptionHandler(e,t,s,n){this.registerSubscriptionHandler(e,(()=>t.addEventListener(s,n,this)),(()=>t.removeEventListener(s,n,this)))}registerAutosubscriptionTargetManagerHandler(e,t,s,n){this.registerSubscriptionHandler(e,(()=>SDK.TargetManager.TargetManager.instance().addModelListener(t,s,n,this)),(()=>SDK.TargetManager.TargetManager.instance().removeModelListener(t,s,n,this)))}registerResourceContentCommittedHandler(e){this.registerSubscriptionHandler("resource-content-committed",function(){Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.WorkingCopyCommittedByUser,e,this),Workspace.Workspace.WorkspaceImpl.instance().setHasResourceContentTrackingExtensions(!0)}.bind(this),function(){Workspace.Workspace.WorkspaceImpl.instance().setHasResourceContentTrackingExtensions(!1),Workspace.Workspace.WorkspaceImpl.instance().removeEventListener(Workspace.Workspace.Events.WorkingCopyCommittedByUser,e,this)}.bind(this))}expandResourcePath(e,t){return e+this.normalizePath(t)}normalizePath(e){const t=e.split("/"),s=[];for(let e=0;e<t.length;++e)"."!==t[e]&&""!==t[e]&&(".."===t[e]?s.pop():s.push(t[e]));return"/"+s.join("/")}evaluate(e,t,s,n,i,r){let o,a,c;if((n=n||{}).frameURL)a=function(e){let t=null;return SDK.ResourceTreeModel.ResourceTreeModel.frames().some((function(s){return t=s.url===e?s:null,t})),t}(n.frameURL);else{const e=SDK.TargetManager.TargetManager.instance().mainTarget(),t=e&&e.model(SDK.ResourceTreeModel.ResourceTreeModel);a=t&&t.mainFrame}if(!a)return n.frameURL?console.warn("evaluate: there is no frame with URL "+n.frameURL):console.warn("evaluate: the main frame is not yet available"),this.status.E_NOTFOUND(n.frameURL||"<top>");if(!this.canInspectURL(a.url))return this.status.E_FAILED("Permission denied");n.useContentScriptContext?c=i:n.scriptExecutionContext&&(c=n.scriptExecutionContext);const d=a.resourceTreeModel().target().model(SDK.RuntimeModel.RuntimeModel),u=d?d.executionContexts():[];if(c){for(let e=0;e<u.length;++e){const t=u[e];t.frameId!==a.id||t.origin!==c||t.isDefault||(o=t)}if(!o)return console.warn("The JavaScript context "+c+" was not found in the frame "+a.url),this.status.E_NOTFOUND(c)}else{for(let e=0;e<u.length;++e){const t=u[e];t.frameId===a.id&&t.isDefault&&(o=t)}if(!o)return this.status.E_FAILED(a.url+" has no execution context")}if(!this.canInspectURL(o.origin))return this.status.E_FAILED("Permission denied");o.evaluate({expression:e,objectGroup:"extension",includeCommandLineAPI:t,silent:!0,returnByValue:s,generatePreview:!1},!1,!1).then((function(e){if("error"in e)return void r(e.error,null,!1);r(null,e.object||null,Boolean(e.exceptionDetails))}))}canInspectURL(e){let t;try{t=new URL(e)}catch(e){return!1}return!!kAllowedOrigins.includes(t.origin)||"chrome:"!==t.protocol&&"devtools:"!==t.protocol&&(!t.protocol.startsWith("http")||"chrome.google.com"!==t.hostname||!t.pathname.startsWith("/webstore"))}disableExtensions(){this.extensionsEnabled=!1}}export var Events;!function(e){e.SidebarPaneAdded="SidebarPaneAdded",e.TraceProviderAdded="TraceProviderAdded"}(Events||(Events={}));class ExtensionServerPanelView extends UI.View.SimpleView{name;panel;constructor(e,t,s){super(t),this.name=e,this.panel=s}viewId(){return this.name}widget(){return Promise.resolve(this.panel)}}export class ExtensionStatus{OK;E_EXISTS;E_BADARG;E_BADARGTYPE;E_NOTFOUND;E_NOTSUPPORTED;E_PROTOCOLERROR;E_FAILED;constructor(){function e(e,t){const s=Array.prototype.slice.call(arguments,2),n={code:e,description:t,details:s};return"OK"!==e&&(n.isError=!0,console.error("Extension server error: "+Platform.StringUtilities.vsprintf(t,s))),n}this.OK=e.bind(null,"OK","OK"),this.E_EXISTS=e.bind(null,"E_EXISTS","Object already exists: %s"),this.E_BADARG=e.bind(null,"E_BADARG","Invalid argument %s: %s"),this.E_BADARGTYPE=e.bind(null,"E_BADARGTYPE","Invalid type for argument %s: got %s, expected %s"),this.E_NOTFOUND=e.bind(null,"E_NOTFOUND","Object not found: %s"),this.E_NOTSUPPORTED=e.bind(null,"E_NOTSUPPORTED","Object does not support requested operation: %s"),this.E_PROTOCOLERROR=e.bind(null,"E_PROTOCOLERROR","Inspector protocol error: %s"),this.E_FAILED=e.bind(null,"E_FAILED","Operation failed: %s")}}