import*as Common from"../../core/common/common.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../bindings/bindings.js";import*as TextUtils from"../text_utils/text_utils.js";import*as Workspace from"../workspace/workspace.js";import{format}from"./ScriptFormatter.js";const objectToFormattingResult=new WeakMap;export class SourceFormatData{originalSourceCode;formattedSourceCode;mapping;constructor(e,o,t){this.originalSourceCode=e,this.formattedSourceCode=o,this.mapping=t}originalPath(){return this.originalSourceCode.project().id()+":"+this.originalSourceCode.url()}static for(e){return objectToFormattingResult.get(e)||null}}let sourceFormatterInstance=null;export class SourceFormatter{projectId;project;formattedSourceCodes;scriptMapping;styleMapping;constructor(){this.projectId="formatter:",this.project=new Bindings.ContentProviderBasedProject.ContentProviderBasedProject(Workspace.Workspace.WorkspaceImpl.instance(),this.projectId,Workspace.Workspace.projectTypes.Formatter,"formatter",!0),this.formattedSourceCodes=new Map,this.scriptMapping=new ScriptMapping,this.styleMapping=new StyleMapping,Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,(e=>{this.onUISourceCodeRemoved(e)}),this)}static instance({forceNew:e=!1}={}){return sourceFormatterInstance&&!e||(sourceFormatterInstance=new SourceFormatter),sourceFormatterInstance}async onUISourceCodeRemoved(e){const o=e.data,t=this.formattedSourceCodes.get(o);t&&t.formatData&&await this.discardFormatData(t.formatData),this.formattedSourceCodes.delete(o)}async discardFormattedUISourceCode(e){const o=SourceFormatData.for(e);return o?(await this.discardFormatData(o),this.formattedSourceCodes.delete(o.originalSourceCode),o.originalSourceCode):null}async discardFormatData(e){objectToFormattingResult.delete(e.formattedSourceCode),await this.scriptMapping.setSourceMappingEnabled(e,!1),this.styleMapping.setSourceMappingEnabled(e,!1),this.project.removeFile(e.formattedSourceCode.url())}hasFormatted(e){return this.formattedSourceCodes.has(e)}getOriginalUISourceCode(e){const o=objectToFormattingResult.get(e);return o?o.originalSourceCode:e}async format(e){const o=this.formattedSourceCodes.get(e);if(o)return o.promise;const t=new Promise((async(o,r)=>{const{content:n}=await e.requestContent();try{const{formattedContent:r,formattedMapping:a}=await format(e.contentType(),e.mimeType(),n||""),i=this.formattedSourceCodes.get(e);if(!i||i.promise!==t)return;let c,s=0,u="";do{c=`${e.url()}:formatted${u}`,u=":"+s++}while(this.project.uiSourceCodeForURL(c));const d=TextUtils.StaticContentProvider.StaticContentProvider.fromString(c,e.contentType(),r),p=this.project.createUISourceCode(c,d.contentType()),m=new SourceFormatData(e,p,a);objectToFormattingResult.set(p,m),this.project.addUISourceCodeWithProvider(p,d,null,e.mimeType()),await this.scriptMapping.setSourceMappingEnabled(m,!0),await this.styleMapping.setSourceMappingEnabled(m,!0),i.formatData=m,o(m)}catch(e){r(e)}}));return this.formattedSourceCodes.set(e,{promise:t,formatData:null}),t}}class ScriptMapping{constructor(){Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().addSourceMapping(this)}rawLocationToUILocation(e){const o=e.script(),t=o&&SourceFormatData.for(o);if(!t||!o)return null;const[r,n]=t.mapping.originalToFormatted(e.lineNumber,e.columnNumber||0);return t.formattedSourceCode.uiLocation(r,n)}uiLocationToRawLocations(e,o,t){const r=SourceFormatData.for(e);if(!r)return[];const[n,a]=r.mapping.formattedToOriginal(o,t);if(r.originalSourceCode.contentType().isScript()){const e=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(r.originalSourceCode,n,a);return console.assert(e.every((e=>e&&Boolean(e.script())))),e}if(r.originalSourceCode.contentType()===Common.ResourceType.resourceTypes.Document){const e=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(r.originalSourceCode),o=e&&e.model(SDK.DebuggerModel.DebuggerModel);if(o){const e=o.scriptsForSourceURL(r.originalSourceCode.url()).filter((e=>e.isInlineScript()&&!e.hasSourceURL)).map((e=>e.rawLocation(n,a))).filter((e=>Boolean(e)));return console.assert(e.every((e=>e&&Boolean(e.script())))),e}}return[]}async setSourceMappingEnabled(e,o){const t=this.scriptsForUISourceCode(e.originalSourceCode);if(!t.length)return;if(o)for(const o of t)objectToFormattingResult.set(o,e);else for(const e of t)objectToFormattingResult.delete(e);const r=t.map((e=>Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().updateLocations(e)));await Promise.all(r)}scriptsForUISourceCode(e){if(e.contentType()===Common.ResourceType.resourceTypes.Document){const o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),t=o&&o.model(SDK.DebuggerModel.DebuggerModel);if(t){return t.scriptsForSourceURL(e.url()).filter((e=>e.isInlineScript()&&!e.hasSourceURL))}}if(e.contentType().isScript()){console.assert(!objectToFormattingResult.has(e));return Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(e,0,0).map((e=>e.script())).filter((e=>Boolean(e)))}return[]}}const sourceCodeToHeaders=new WeakMap;class StyleMapping{headersSymbol;constructor(){Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().addSourceMapping(this),this.headersSymbol=Symbol("Formatter.SourceFormatter.StyleMapping._headersSymbol")}rawLocationToUILocation(e){const o=e.header(),t=o&&SourceFormatData.for(o);if(!t)return null;const r=t.mapping.originalToFormatted(e.lineNumber,e.columnNumber||0);return t.formattedSourceCode.uiLocation(r[0],r[1])}uiLocationToRawLocations(e){const o=SourceFormatData.for(e.uiSourceCode);if(!o)return[];const[t,r]=o.mapping.formattedToOriginal(e.lineNumber,e.columnNumber),n=sourceCodeToHeaders.get(o.originalSourceCode);if(!n)return[];return n.filter((e=>e.containsLocation(t,r))).map((e=>new SDK.CSSModel.CSSLocation(e,t,r)))}async setSourceMappingEnabled(e,o){const t=e.originalSourceCode,r=this.headersForUISourceCode(t);o?(sourceCodeToHeaders.set(t,r),r.forEach((o=>{objectToFormattingResult.set(o,e)}))):(sourceCodeToHeaders.delete(t),r.forEach((e=>{objectToFormattingResult.delete(e)})));const n=r.map((e=>Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().updateLocations(e)));await Promise.all(n)}headersForUISourceCode(e){if(e.contentType()===Common.ResourceType.resourceTypes.Document){const o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),t=o&&o.model(SDK.CSSModel.CSSModel);if(t)return t.headersForSourceURL(e.url()).filter((e=>e.isInline&&!e.hasSourceURL))}else if(e.contentType().isStyleSheet()){return Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().uiLocationToRawLocations(e.uiLocation(0,0)).map((e=>e.header())).filter((e=>Boolean(e)))}return[]}}