import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import{Issue,IssueCategory,IssueKind}from"./Issue.js";import{resolveLazyDescription}from"./MarkdownIssueDescription.js";const UIStrings={samesiteCookiesExplained:"SameSite cookies explained",howSchemefulSamesiteWorks:"How Schemeful Same-Site Works",aSecure:"a secure",anInsecure:"an insecure",firstPartySetsExplained:"`First-Party Sets` and the `SameParty` attribute"},str_=i18n.i18n.registerUIStrings("models/issues_manager/SameSiteCookieIssue.ts",UIStrings),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class SameSiteCookieIssue extends Issue{issueDetails;constructor(e,i,t){super(e,t),this.issueDetails=i}cookieId(){if(this.issueDetails.cookie){const{domain:e,path:i,name:t}=this.issueDetails.cookie;return`${e};${i};${t}`}return this.issueDetails.rawCookieLine??"no-cookie-info"}primaryKey(){const e=this.issueDetails.request?this.issueDetails.request.requestId:"no-request";return`${this.code()}-(${this.cookieId()})-(${e})`}static createIssuesFromSameSiteDetails(e,i){const t=[];if(e.cookieExclusionReasons&&e.cookieExclusionReasons.length>0){for(const s of e.cookieExclusionReasons){const a=SameSiteCookieIssue.codeForSameSiteDetails(s,e.cookieWarningReasons,e.operation,e.cookieUrl);a&&t.push(new SameSiteCookieIssue(a,e,i))}return t}if(e.cookieWarningReasons)for(const s of e.cookieWarningReasons){const a=SameSiteCookieIssue.codeForSameSiteDetails(s,[],e.operation,e.cookieUrl);a&&t.push(new SameSiteCookieIssue(a,e,i))}return t}static codeForSameSiteDetails(e,i,t,s){const a=s&&(s.startsWith("https://")||s.startsWith("wss://"))?"Secure":"Insecure";if("ExcludeSameSiteStrict"===e||"ExcludeSameSiteLax"===e||"ExcludeSameSiteUnspecifiedTreatedAsLax"===e){if(i&&i.length>0){if(i.includes("WarnSameSiteStrictLaxDowngradeStrict"))return["SameSiteCookieIssue","ExcludeNavigationContextDowngrade",a].join("::");if(i.includes("WarnSameSiteStrictCrossDowngradeStrict")||i.includes("WarnSameSiteStrictCrossDowngradeLax")||i.includes("WarnSameSiteLaxCrossDowngradeStrict")||i.includes("WarnSameSiteLaxCrossDowngradeLax"))return["SameSiteCookieIssue","ExcludeContextDowngrade",t,a].join("::")}return"ExcludeSameSiteUnspecifiedTreatedAsLax"===e?["SameSiteCookieIssue",e,t].join("::"):null}return"WarnSameSiteStrictLaxDowngradeStrict"===e?["SameSiteCookieIssue",e,a].join("::"):"WarnSameSiteStrictCrossDowngradeStrict"===e||"WarnSameSiteStrictCrossDowngradeLax"===e||"WarnSameSiteLaxCrossDowngradeLax"===e||"WarnSameSiteLaxCrossDowngradeStrict"===e?["SameSiteCookieIssue","WarnCrossDowngrade",t,a].join("::"):["SameSiteCookieIssue",e,t].join("::")}cookies(){return this.issueDetails.cookie?[this.issueDetails.cookie]:[]}rawCookieLines(){return this.issueDetails.rawCookieLine?[this.issueDetails.rawCookieLine]:[]}requests(){return this.issueDetails.request?[this.issueDetails.request]:[]}getCategory(){return IssueCategory.SameSiteCookie}getDescription(){const e=issueDescriptions.get(this.code());return e?resolveLazyDescription(e):null}isCausedByThirdParty(){return isCausedByThirdParty(SDK.FrameManager.FrameManager.instance().getTopFrame(),this.issueDetails.cookieUrl)}getKind(){return this.issueDetails.cookieExclusionReasons?.length>0?IssueKind.PageError:IssueKind.BreakingChange}static fromInspectorIssue(e,i){const t=i.details.sameSiteCookieIssueDetails;return t?SameSiteCookieIssue.createIssuesFromSameSiteDetails(t,e):(console.warn("SameSite issue without details received."),[])}}export function isCausedByThirdParty(e,i){if(!e)return!0;if(!i||""===e.domainAndRegistry())return!1;const t=Common.ParsedURL.ParsedURL.fromString(i);return!!t&&!isSubdomainOf(t.domain(),e.domainAndRegistry())}function isSubdomainOf(e,i){if(e.length<=i.length)return e===i;if(!e.endsWith(i))return!1;return e.substr(0,e.length-i.length).endsWith(".")}const sameSiteUnspecifiedErrorRead={file:"SameSiteUnspecifiedTreatedAsLaxRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedErrorSet={file:"SameSiteUnspecifiedTreatedAsLaxSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedWarnRead={file:"SameSiteUnspecifiedLaxAllowUnsafeRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedWarnSet={file:"SameSiteUnspecifiedLaxAllowUnsafeSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureErrorRead={file:"SameSiteNoneInsecureErrorRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureErrorSet={file:"SameSiteNoneInsecureErrorSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureWarnRead={file:"SameSiteNoneInsecureWarnRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureWarnSet={file:"SameSiteNoneInsecureWarnSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},schemefulSameSiteArticles=[{link:"https://web.dev/schemeful-samesite/",linkTitle:i18nLazyString(UIStrings.howSchemefulSamesiteWorks)}];function schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:i}){return new Map([["PLACEHOLDER_destination",()=>e?"a secure":"an insecure"],["PLACEHOLDER_origin",()=>i?"a secure":"an insecure"]])}function sameSiteWarnStrictLaxDowngradeStrict(e){return{file:"SameSiteWarnStrictLaxDowngradeStrict.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:!e}),links:schemefulSameSiteArticles}}function sameSiteExcludeNavigationContextDowngrade(e){return{file:"SameSiteExcludeNavigationContextDowngrade.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:!e}),links:schemefulSameSiteArticles}}function sameSiteWarnCrossDowngradeRead(e){return{file:"SameSiteWarnCrossDowngradeRead.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:!e}),links:schemefulSameSiteArticles}}function sameSiteExcludeContextDowngradeRead(e){return{file:"SameSiteExcludeContextDowngradeRead.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:!e}),links:schemefulSameSiteArticles}}function sameSiteWarnCrossDowngradeSet(e){return{file:"SameSiteWarnCrossDowngradeSet.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:!e,isOriginSecure:e}),links:schemefulSameSiteArticles}}function sameSiteExcludeContextDowngradeSet(e){return{file:"SameSiteExcludeContextDowngradeSet.md",substitutions:schemefulSameSiteSubstitutions({isDestinationSecure:e,isOriginSecure:!e}),links:schemefulSameSiteArticles}}const sameSiteInvalidSameParty={file:"SameSiteInvalidSameParty.md",links:[{link:"https://developer.chrome.com/blog/first-party-sets-sameparty/",linkTitle:i18nLazyString(UIStrings.firstPartySetsExplained)}]},samePartyCrossPartyContextSet={file:"SameSiteSamePartyCrossPartyContextSet.md",links:[{link:"https://developer.chrome.com/blog/first-party-sets-sameparty/",linkTitle:i18nLazyString(UIStrings.firstPartySetsExplained)}]},issueDescriptions=new Map([["SameSiteCookieIssue::ExcludeSameSiteUnspecifiedTreatedAsLax::ReadCookie",sameSiteUnspecifiedErrorRead],["SameSiteCookieIssue::ExcludeSameSiteUnspecifiedTreatedAsLax::SetCookie",sameSiteUnspecifiedErrorSet],["SameSiteCookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::ReadCookie",sameSiteUnspecifiedWarnRead],["SameSiteCookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::SetCookie",sameSiteUnspecifiedWarnSet],["SameSiteCookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::ReadCookie",sameSiteUnspecifiedWarnRead],["SameSiteCookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::SetCookie",sameSiteUnspecifiedWarnSet],["SameSiteCookieIssue::ExcludeSameSiteNoneInsecure::ReadCookie",sameSiteNoneInsecureErrorRead],["SameSiteCookieIssue::ExcludeSameSiteNoneInsecure::SetCookie",sameSiteNoneInsecureErrorSet],["SameSiteCookieIssue::WarnSameSiteNoneInsecure::ReadCookie",sameSiteNoneInsecureWarnRead],["SameSiteCookieIssue::WarnSameSiteNoneInsecure::SetCookie",sameSiteNoneInsecureWarnSet],["SameSiteCookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Secure",sameSiteWarnStrictLaxDowngradeStrict(!0)],["SameSiteCookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Insecure",sameSiteWarnStrictLaxDowngradeStrict(!1)],["SameSiteCookieIssue::WarnCrossDowngrade::ReadCookie::Secure",sameSiteWarnCrossDowngradeRead(!0)],["SameSiteCookieIssue::WarnCrossDowngrade::ReadCookie::Insecure",sameSiteWarnCrossDowngradeRead(!1)],["SameSiteCookieIssue::WarnCrossDowngrade::SetCookie::Secure",sameSiteWarnCrossDowngradeSet(!0)],["SameSiteCookieIssue::WarnCrossDowngrade::SetCookie::Insecure",sameSiteWarnCrossDowngradeSet(!1)],["SameSiteCookieIssue::ExcludeNavigationContextDowngrade::Secure",sameSiteExcludeNavigationContextDowngrade(!0)],["SameSiteCookieIssue::ExcludeNavigationContextDowngrade::Insecure",sameSiteExcludeNavigationContextDowngrade(!1)],["SameSiteCookieIssue::ExcludeContextDowngrade::ReadCookie::Secure",sameSiteExcludeContextDowngradeRead(!0)],["SameSiteCookieIssue::ExcludeContextDowngrade::ReadCookie::Insecure",sameSiteExcludeContextDowngradeRead(!1)],["SameSiteCookieIssue::ExcludeContextDowngrade::SetCookie::Secure",sameSiteExcludeContextDowngradeSet(!0)],["SameSiteCookieIssue::ExcludeContextDowngrade::SetCookie::Insecure",sameSiteExcludeContextDowngradeSet(!1)],["SameSiteCookieIssue::ExcludeInvalidSameParty::SetCookie",sameSiteInvalidSameParty],["SameSiteCookieIssue::ExcludeSamePartyCrossPartyContext::SetCookie",samePartyCrossPartyContextSet]]);