import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import{Events}from"./IsolatedFileSystemManager.js";import{PlatformFileSystem}from"./PlatformFileSystem.js";const UIStrings={fileSystemErrorS:"File system error: {PH1}",blobCouldNotBeLoaded:"Blob could not be loaded.",cantReadFileSS:"Can't read file: {PH1}: {PH2}",unknownErrorReadingFileS:"Unknown error reading file: {PH1}",linkedToS:"Linked to {PH1}"},str_=i18n.i18n.registerUIStrings("models/persistence/IsolatedFileSystem.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class IsolatedFileSystem extends PlatformFileSystem{manager;embedderPathInternal;domFileSystem;excludedFoldersSetting;excludedFoldersInternal;excludedEmbedderFolders;initialFilePathsInternal;initialGitFoldersInternal;fileLocks;constructor(e,t,r,n,i){super(t,i),this.manager=e,this.embedderPathInternal=r,this.domFileSystem=n,this.excludedFoldersSetting=Common.Settings.Settings.instance().createLocalSetting("workspaceExcludedFolders",{}),this.excludedFoldersInternal=new Set(this.excludedFoldersSetting.get()[t]||[]),this.excludedEmbedderFolders=[],this.initialFilePathsInternal=new Set,this.initialGitFoldersInternal=new Set,this.fileLocks=new Map}static create(e,t,r,n,i,s){const o=Host.InspectorFrontendHost.InspectorFrontendHostInstance.isolatedFileSystem(i,s);if(!o)return Promise.resolve(null);const l=new IsolatedFileSystem(e,t,r,o,n);return l.initializeFilePaths().then((()=>l)).catch((e=>(console.error(e),null)))}static errorMessage(e){return i18nString(UIStrings.fileSystemErrorS,{PH1:e.message})}serializedFileOperation(e,t){const r=Promise.resolve(this.fileLocks.get(e)).then((()=>t.call(null)));return this.fileLocks.set(e,r),r}getMetadata(e){let t;const r=new Promise((e=>{t=e}));return this.domFileSystem.root.getFile(e,void 0,(function(e){e.getMetadata(t,n)}),n),r;function n(r){const n=IsolatedFileSystem.errorMessage(r);console.error(n+" when getting file metadata '"+e),t(null)}}initialFilePaths(){return[...this.initialFilePathsInternal]}initialGitFolders(){return[...this.initialGitFoldersInternal]}embedderPath(){return this.embedderPathInternal}initializeFilePaths(){return new Promise((e=>{let t=1;const r=function(n){for(let e=0;e<n.length;++e){const i=n[e];if(i.isDirectory){if(i.fullPath.endsWith("/.git")){const e=i.fullPath.lastIndexOf("/"),t=i.fullPath.substring(1,e);this.initialGitFoldersInternal.add(t)}if(this.isFileExcluded(i.fullPath+"/")){this.excludedEmbedderFolders.push(Common.ParsedURL.ParsedURL.capFilePrefix(this.path()+i.fullPath,Host.Platform.isWin()));continue}++t,this.requestEntries(i.fullPath,r)}else{if(this.isFileExcluded(i.fullPath))continue;this.initialFilePathsInternal.add(i.fullPath.substr(1))}}0==--t&&e()}.bind(this);this.requestEntries("",r)}))}async createFoldersIfNotExist(e){let t=await new Promise((t=>this.domFileSystem.root.getDirectory(e,void 0,t,(()=>t(null)))));if(t)return t;const r=e.split("/");let n="";for(const e of r)if(n=n+"/"+e,t=await this.innerCreateFolderIfNeeded(n),!t)return null;return t}innerCreateFolderIfNeeded(e){return new Promise((t=>{this.domFileSystem.root.getDirectory(e,{create:!0},(e=>t(e)),(r=>{const n=IsolatedFileSystem.errorMessage(r);console.error(n+" trying to create directory '"+e+"'"),t(null)}))}))}async createFile(e,t){const r=await this.createFoldersIfNotExist(e);if(!r)return null;const n=await this.serializedFileOperation(e,function t(n,i){return new Promise((s=>{const o=n+(i||"");r.getFile(o,{create:!0,exclusive:!0},s,(r=>{if("InvalidModificationError"===r.name)return void s(t.call(this,n,i?i+1:1));const l=IsolatedFileSystem.errorMessage(r);console.error(l+" when testing if file exists '"+this.path()+"/"+e+"/"+o+"'"),s(null)}))}))}.bind(this,t||"NewFile"));return n?n.fullPath.substr(1):null}deleteFile(e){let t;const r=new Promise((e=>{t=e}));return this.domFileSystem.root.getFile(e,void 0,function(e){e.remove(n,i.bind(this))}.bind(this),i.bind(this)),r;function n(){t(!0)}function i(r){const n=IsolatedFileSystem.errorMessage(r);console.error(n+" when deleting file '"+this.path()+"/"+e+"'"),t(!1)}}requestFileBlob(e){return new Promise((t=>{function r(r){if("NotFoundError"===r.name)return void t(null);const n=IsolatedFileSystem.errorMessage(r);console.error(n+" when getting content for file '"+this.path()+"/"+e+"'"),t(null)}this.domFileSystem.root.getFile(e,void 0,(e=>{e.file(t,r.bind(this))}),r.bind(this))}))}requestFileContent(e){return this.serializedFileOperation(e,(()=>this.innerRequestFileContent(e)))}async innerRequestFileContent(e){const t=await this.requestFileBlob(e);if(!t)return{content:null,error:i18nString(UIStrings.blobCouldNotBeLoaded),isEncoded:!1};const r=new FileReader,n=Common.ParsedURL.ParsedURL.extractExtension(e),i=BinaryExtensions.has(n),s=new Promise((e=>{r.onloadend=e}));if(i?r.readAsBinaryString(t):r.readAsText(t),await s,r.error){const t=i18nString(UIStrings.cantReadFileSS,{PH1:e,PH2:r.error.toString()});return console.error(t),{content:null,isEncoded:!1,error:t}}let o=null,l=null;try{o=r.result}catch(t){o=null,l=i18nString(UIStrings.cantReadFileSS,{PH1:e,PH2:t.message})}return null==o?(l=l||i18nString(UIStrings.unknownErrorReadingFileS,{PH1:e}),console.error(l),{content:null,isEncoded:!1,error:l}):{isEncoded:i,content:i?btoa(o):o}}async setFileContent(e,t,r){let n;Host.userMetrics.actionTaken(Host.UserMetrics.Action.FileSavedInWorkspace);function i(e){e.createWriter(s.bind(this),o.bind(this))}async function s(e){let i;e.onerror=o.bind(this),e.onwriteend=function(){e.onwriteend=n,e.truncate(i.size)},i=r?await(await fetch(`data:application/octet-stream;base64,${t}`)).blob():new Blob([t],{type:"text/plain"}),e.write(i)}function o(t){const r=IsolatedFileSystem.errorMessage(t);console.error(r+" when setting content for file '"+this.path()+"/"+e+"'"),n(void 0)}this.serializedFileOperation(e,(()=>{const t=new Promise((e=>{n=e}));return this.domFileSystem.root.getFile(e,{create:!0},i.bind(this),o.bind(this)),t}))}renameFile(e,t,r){if(!(t=t?t.trim():t)||-1!==t.indexOf("/"))return void r(!1);let n,i;function s(e){i=e,i.getFile(t,void 0,o,l.bind(this))}function o(e){r(!1)}function l(e){"NotFoundError"===e.name?n.moveTo(i,t,a,d.bind(this)):r(!1)}function a(e){r(!0,e.name)}function d(n){const i=IsolatedFileSystem.errorMessage(n);console.error(i+" when renaming file '"+this.path()+"/"+e+"' to '"+t+"'"),r(!1)}this.domFileSystem.root.getFile(e,void 0,function(e){if(e.name===t)return void r(!1);n=e,n.getParent(s.bind(this),d.bind(this))}.bind(this),d.bind(this))}readDirectory(e,t){const r=e.createReader();let n=[];function i(r){const n=IsolatedFileSystem.errorMessage(r);console.error(n+" when reading directory '"+e.fullPath+"'"),t([])}r.readEntries((function e(s){var o;s.length?(n=n.concat((o=s,Array.prototype.slice.call(o||[],0))),r.readEntries(e,i)):t(n.sort())}),i)}requestEntries(e,t){this.domFileSystem.root.getDirectory(e,void 0,function(e){this.readDirectory(e,t)}.bind(this),(function(r){const n=IsolatedFileSystem.errorMessage(r);console.error(n+" when requesting entry '"+e+"'"),t([])}))}saveExcludedFolders(){const e=this.excludedFoldersSetting.get();e[this.path()]=[...this.excludedFoldersInternal],this.excludedFoldersSetting.set(e)}addExcludedFolder(e){this.excludedFoldersInternal.add(e),this.saveExcludedFolders(),this.manager.dispatchEventToListeners(Events.ExcludedFolderAdded,e)}removeExcludedFolder(e){this.excludedFoldersInternal.delete(e),this.saveExcludedFolders(),this.manager.dispatchEventToListeners(Events.ExcludedFolderRemoved,e)}fileSystemRemoved(){const e=this.excludedFoldersSetting.get();delete e[this.path()],this.excludedFoldersSetting.set(e)}isFileExcluded(e){if(this.excludedFoldersInternal.has(e))return!0;const t=this.manager.workspaceFolderExcludePatternSetting().asRegExp();return Boolean(t&&t.test(e))}excludedFolders(){return this.excludedFoldersInternal}searchInPath(e,t){return new Promise((r=>{const n=this.manager.registerCallback((function(e){r(e.map((e=>Common.ParsedURL.ParsedURL.rawPathToUrlString(e)))),t.incrementWorked(1)}));Host.InspectorFrontendHost.InspectorFrontendHostInstance.searchInPath(n,this.embedderPathInternal,e)}))}indexContent(e){e.setTotalWork(1);const t=this.manager.registerProgress(e);Host.InspectorFrontendHost.InspectorFrontendHostInstance.indexPath(t,this.embedderPathInternal,JSON.stringify(this.excludedEmbedderFolders))}mimeFromPath(e){return Common.ResourceType.ResourceType.mimeFromURL(e)||"text/plain"}canExcludeFolder(e){return Boolean(e)&&"overrides"!==this.type()}contentType(e){const t=Common.ParsedURL.ParsedURL.extractExtension(e);return STYLE_SHEET_EXTENSIONS.has(t)?Common.ResourceType.resourceTypes.Stylesheet:DOCUMENT_EXTENSIONS.has(t)?Common.ResourceType.resourceTypes.Document:IMAGE_EXTENSIONS.has(t)?Common.ResourceType.resourceTypes.Image:SCRIPT_EXTENSIONS.has(t)?Common.ResourceType.resourceTypes.Script:BinaryExtensions.has(t)?Common.ResourceType.resourceTypes.Other:Common.ResourceType.resourceTypes.Document}tooltipForURL(e){const t=Platform.StringUtilities.trimMiddle(Common.ParsedURL.ParsedURL.capFilePrefix(e,Host.Platform.isWin()),150);return i18nString(UIStrings.linkedToS,{PH1:t})}supportsAutomapping(){return"overrides"!==this.type()}}const STYLE_SHEET_EXTENSIONS=new Set(["css","scss","sass","less"]),DOCUMENT_EXTENSIONS=new Set(["htm","html","asp","aspx","phtml","jsp"]),SCRIPT_EXTENSIONS=new Set(["asp","aspx","c","cc","cljs","coffee","cpp","cs","dart","java","js","jsp","jsx","h","m","mjs","mm","py","sh","ts","tsx","ls"]),IMAGE_EXTENSIONS=new Set(["jpeg","jpg","svg","gif","webp","png","ico","tiff","tif","bmp"]);export const BinaryExtensions=new Set(["cmd","com","exe","a","ar","iso","tar","bz2","gz","lz","lzma","z","7z","apk","arc","cab","dmg","jar","pak","rar","zip","3gp","aac","aiff","flac","m4a","mmf","mp3","ogg","oga","raw","sln","wav","wma","webm","mkv","flv","vob","ogv","gifv","avi","mov","qt","mp4","m4p","m4v","mpg","mpeg","jpeg","jpg","gif","webp","png","ico","tiff","tif","bmp"]);