import*as Common from"../../core/common/common.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{FileSystemWorkspaceBinding}from"./FileSystemWorkspaceBinding.js";import{PersistenceBinding,PersistenceImpl}from"./PersistenceImpl.js";let networkPersistenceManagerInstance;export class NetworkPersistenceManager extends Common.ObjectWrapper.ObjectWrapper{bindings;originalResponseContentPromises;savingForOverrides;savingSymbol;enabledSetting;workspace;networkUISourceCodeForEncodedPath;interceptionHandlerBound;updateInterceptionThrottler;projectInternal;activeProject;activeInternal;enabled;eventDescriptors;constructor(e){super(),this.bindings=new WeakMap,this.originalResponseContentPromises=new WeakMap,this.savingForOverrides=new WeakSet,this.savingSymbol=Symbol("SavingForOverrides"),this.enabledSetting=Common.Settings.Settings.instance().moduleSetting("persistenceNetworkOverridesEnabled"),this.enabledSetting.addChangeListener(this.enabledChanged,this),this.workspace=e,this.networkUISourceCodeForEncodedPath=new Map,this.interceptionHandlerBound=this.interceptionHandler.bind(this),this.updateInterceptionThrottler=new Common.Throttler.Throttler(50),this.projectInternal=null,this.activeProject=null,this.activeInternal=!1,this.enabled=!1,this.workspace.addEventListener(Workspace.Workspace.Events.ProjectAdded,(e=>{this.onProjectAdded(e.data)})),this.workspace.addEventListener(Workspace.Workspace.Events.ProjectRemoved,(e=>{this.onProjectRemoved(e.data)})),PersistenceImpl.instance().addNetworkInterceptor(this.canHandleNetworkUISourceCode.bind(this)),this.eventDescriptors=[],this.enabledChanged(),SDK.TargetManager.TargetManager.instance().observeTargets(this)}targetAdded(){this.updateActiveProject()}targetRemoved(){this.updateActiveProject()}static instance(e={forceNew:null,workspace:null}){const{forceNew:t,workspace:n}=e;if(!networkPersistenceManagerInstance||t){if(!n)throw new Error("Missing workspace for NetworkPersistenceManager");networkPersistenceManagerInstance=new NetworkPersistenceManager(n)}return networkPersistenceManagerInstance}active(){return this.activeInternal}project(){return this.projectInternal}originalContentForUISourceCode(e){const t=this.bindings.get(e);if(!t)return null;const n=t.fileSystem;return this.originalResponseContentPromises.get(n)||null}async enabledChanged(){this.enabled!==this.enabledSetting.get()&&(this.enabled=this.enabledSetting.get(),this.enabled?(this.eventDescriptors=[Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRenamed,(e=>{this.uiSourceCodeRenamedListener(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,(e=>{this.uiSourceCodeAdded(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,(e=>{this.uiSourceCodeRemovedListener(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.WorkingCopyCommitted,(e=>this.onUISourceCodeWorkingCopyCommitted(e.data.uiSourceCode)))],await this.updateActiveProject()):(Common.EventTarget.removeEventListeners(this.eventDescriptors),await this.updateActiveProject()))}async uiSourceCodeRenamedListener(e){const t=e.data.uiSourceCode;await this.onUISourceCodeRemoved(t),await this.onUISourceCodeAdded(t)}async uiSourceCodeRemovedListener(e){await this.onUISourceCodeRemoved(e.data)}async uiSourceCodeAdded(e){await this.onUISourceCodeAdded(e.data)}async updateActiveProject(){const e=this.activeInternal;if(this.activeInternal=Boolean(this.enabledSetting.get()&&SDK.TargetManager.TargetManager.instance().mainTarget()&&this.projectInternal),this.activeInternal!==e){if(this.activeInternal&&this.projectInternal){await Promise.all(this.projectInternal.uiSourceCodes().map((e=>this.filesystemUISourceCodeAdded(e))));const e=this.workspace.projectsForType(Workspace.Workspace.projectTypes.Network);for(const t of e)await Promise.all(t.uiSourceCodes().map((e=>this.networkUISourceCodeAdded(e))))}else this.projectInternal&&(await Promise.all(this.projectInternal.uiSourceCodes().map((e=>this.filesystemUISourceCodeRemoved(e)))),this.networkUISourceCodeForEncodedPath.clear());PersistenceImpl.instance().refreshAutomapping()}}encodedPathFromUrl(e){if(!this.activeInternal||!this.projectInternal)return"";let t=Common.ParsedURL.ParsedURL.urlWithoutHash(e.replace(/^https?:\/\//,""));t.endsWith("/")&&-1===t.indexOf("?")&&(t+="index.html");let n=function(e){const t=[];for(const n of function(e){const t=(e=Common.ParsedURL.ParsedURL.urlWithoutHash(e)).indexOf("?");if(-1===t)return e.split("/");if(0===t)return[e];const n=e.substr(t),r=e.substr(0,e.length-n.length).split("/");return r[r.length-1]+=n,r}(e)){if(!n)continue;let e=encodeURI(n).replace(/[\/:\?\*]/g,(e=>"%"+e[0].charCodeAt(0).toString(16)));RESERVED_FILENAMES.has(e.toLowerCase())&&(e=e.split("").map((e=>"%"+e.charCodeAt(0).toString(16))).join(""));"."===e.charAt(e.length-1)&&(e=e.substr(0,e.length-1)+"%2e"),t.push(e)}return t}(t);const r=FileSystemWorkspaceBinding.fileSystemPath(this.projectInternal.id()),o=n.join("/");if(r.length+o.length>200){const e=n[0],r=n[n.length-1],s=r?r.substr(0,10)+"-":"",i=Common.ParsedURL.ParsedURL.extractExtension(t),a=i?"."+i.substr(0,10):"";n=[e,"longurls",s+Platform.StringUtilities.hashCode(o).toString(16)+a]}return n.join("/")}decodeLocalPathToUrlPath(e){try{return unescape(e)}catch(e){console.error(e)}return e}async unbind(e){const t=this.bindings.get(e);t&&(this.bindings.delete(t.network),this.bindings.delete(t.fileSystem),await PersistenceImpl.instance().removeBinding(t))}async bind(e,t){this.bindings.has(e)&&await this.unbind(e),this.bindings.has(t)&&await this.unbind(t);const n=new PersistenceBinding(e,t);this.bindings.set(e,n),this.bindings.set(t,n),await PersistenceImpl.instance().addBinding(n);const r=this.savingForOverrides.has(e)?e:t,[{content:o},s]=await Promise.all([r.requestContent(),r.contentEncoded()]);PersistenceImpl.instance().syncContent(r,o||"",s)}onUISourceCodeWorkingCopyCommitted(e){this.saveUISourceCodeForOverrides(e)}canSaveUISourceCodeForOverrides(e){return this.activeInternal&&e.project().type()===Workspace.Workspace.projectTypes.Network&&!this.bindings.has(e)&&!this.savingForOverrides.has(e)}async saveUISourceCodeForOverrides(e){if(!this.canSaveUISourceCodeForOverrides(e))return;this.savingForOverrides.add(e);let t=this.encodedPathFromUrl(e.url());const n=(await e.requestContent()).content||"",r=await e.contentEncoded(),o=t.lastIndexOf("/"),s=t.substr(o+1);t=t.substr(0,o),this.projectInternal&&await this.projectInternal.createFile(t,s,n,r),this.fileCreatedForTest(t,s),this.savingForOverrides.delete(e)}fileCreatedForTest(e,t){}patternForFileSystemUISourceCode(e){const t=FileSystemWorkspaceBinding.relativePath(e);return t.length<2?"":"longurls"===t[1]&&2!==t.length?"http?://"+t[0]+"/*":"http?://"+this.decodeLocalPathToUrlPath(t.join("/"))}async onUISourceCodeAdded(e){await this.networkUISourceCodeAdded(e),await this.filesystemUISourceCodeAdded(e)}canHandleNetworkUISourceCode(e){return this.activeInternal&&!e.url().startsWith("snippet://")}async networkUISourceCodeAdded(e){if(e.project().type()!==Workspace.Workspace.projectTypes.Network||!this.canHandleNetworkUISourceCode(e))return;const t=Common.ParsedURL.ParsedURL.urlWithoutHash(e.url());this.networkUISourceCodeForEncodedPath.set(this.encodedPathFromUrl(t),e);const n=this.projectInternal,r=n.uiSourceCodeForURL(n.fileSystemPath()+"/"+this.encodedPathFromUrl(t));r&&await this.bind(e,r)}async filesystemUISourceCodeAdded(e){if(!this.activeInternal||e.project()!==this.projectInternal)return;this.updateInterceptionPatterns();const t=FileSystemWorkspaceBinding.relativePath(e),n=this.networkUISourceCodeForEncodedPath.get(t.join("/"));n&&await this.bind(n,e)}updateInterceptionPatterns(){this.updateInterceptionThrottler.schedule(function(){if(!this.activeInternal||!this.projectInternal)return SDK.NetworkManager.MultitargetNetworkManager.instance().setInterceptionHandlerForPatterns([],this.interceptionHandlerBound);const e=new Set,t="index.html";for(const n of this.projectInternal.uiSourceCodes()){const r=this.patternForFileSystemUISourceCode(n);e.add(r),r.endsWith("/index.html")&&e.add(r.substr(0,r.length-t.length))}return SDK.NetworkManager.MultitargetNetworkManager.instance().setInterceptionHandlerForPatterns(Array.from(e).map((e=>({urlPattern:e,interceptionStage:"HeadersReceived"}))),this.interceptionHandlerBound)}.bind(this))}async onUISourceCodeRemoved(e){await this.networkUISourceCodeRemoved(e),await this.filesystemUISourceCodeRemoved(e)}async networkUISourceCodeRemoved(e){e.project().type()===Workspace.Workspace.projectTypes.Network&&(await this.unbind(e),this.networkUISourceCodeForEncodedPath.delete(this.encodedPathFromUrl(e.url())))}async filesystemUISourceCodeRemoved(e){e.project()===this.projectInternal&&(this.updateInterceptionPatterns(),this.originalResponseContentPromises.delete(e),await this.unbind(e))}async setProject(e){e!==this.projectInternal&&(this.projectInternal&&await Promise.all(this.projectInternal.uiSourceCodes().map((e=>this.filesystemUISourceCodeRemoved(e)))),this.projectInternal=e,this.projectInternal&&await Promise.all(this.projectInternal.uiSourceCodes().map((e=>this.filesystemUISourceCodeAdded(e)))),await this.updateActiveProject(),this.dispatchEventToListeners(Events.ProjectChanged,this.projectInternal))}async onProjectAdded(e){if(e.type()!==Workspace.Workspace.projectTypes.FileSystem||"overrides"!==FileSystemWorkspaceBinding.fileSystemType(e))return;FileSystemWorkspaceBinding.fileSystemPath(e.id())&&(this.projectInternal&&this.projectInternal.remove(),await this.setProject(e))}async onProjectRemoved(e){e===this.projectInternal&&await this.setProject(null)}async interceptionHandler(e){const t=e.request.method;if(!this.activeInternal||"GET"!==t&&"POST"!==t)return;const n=this.projectInternal,r=n.fileSystemPath()+"/"+this.encodedPathFromUrl(e.request.url),o=n.uiSourceCodeForURL(r);if(!o)return;let s="";if(e.responseHeaders){s=SDK.NetworkManager.NetworkManager.lowercaseHeaders(e.responseHeaders)["content-type"]}if(!s){const t=Common.ResourceType.resourceTypes[e.resourceType]||Common.ResourceType.resourceTypes.Other;s=o.mimeType(),Common.ResourceType.ResourceType.fromMimeType(s)!==t&&(s=t.canonicalMimeType())}const i=o.project();this.originalResponseContentPromises.set(o,e.responseBody().then((e=>{if(e.error||null===e.content)return null;if(e.encoded){const t=atob(e.content),n=new Uint8Array(t.length);for(let e=0;e<t.length;++e)n[e]=t.charCodeAt(e);return new TextDecoder("utf-8").decode(n)}return e.content})));const a=await i.requestFileBlob(o);a&&e.continueRequestWithContent(new Blob([a],{type:s}))}}const RESERVED_FILENAMES=new Set(["con","prn","aux","nul","com1","com2","com3","com4","com5","com6","com7","com8","com9","lpt1","lpt2","lpt3","lpt4","lpt5","lpt6","lpt7","lpt8","lpt9"]);export var Events;!function(e){e.ProjectChanged="ProjectChanged"}(Events||(Events={}));