import*as Common from"../../core/common/common.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as Bindings from"../bindings/bindings.js";import*as Workspace from"../workspace/workspace.js";import{Automapping}from"./Automapping.js";import{LinkDecorator}from"./PersistenceUtils.js";let persistenceInstance;export class PersistenceImpl extends Common.ObjectWrapper.ObjectWrapper{workspace;breakpointManager;filePathPrefixesToBindingCount;subscribedBindingEventListeners;mapping;constructor(e,n){super(),this.workspace=e,this.breakpointManager=n,this.filePathPrefixesToBindingCount=new Map,this.subscribedBindingEventListeners=new Platform.MapUtilities.Multimap;const t=new LinkDecorator(this);Components.Linkifier.Linkifier.setLinkDecorator(t),this.mapping=new Automapping(this.workspace,this.onStatusAdded.bind(this),this.onStatusRemoved.bind(this))}static instance(e={forceNew:null,workspace:null,breakpointManager:null}){const{forceNew:n,workspace:t,breakpointManager:i}=e;if(!persistenceInstance||n){if(!t||!i)throw new Error("Missing arguments for workspace");persistenceInstance=new PersistenceImpl(t,i)}return persistenceInstance}addNetworkInterceptor(e){this.mapping.addNetworkInterceptor(e)}refreshAutomapping(){this.mapping.scheduleRemap()}async addBinding(e){await this.innerAddBinding(e)}async addBindingForTest(e){await this.innerAddBinding(e)}async removeBinding(e){await this.innerRemoveBinding(e)}async removeBindingForTest(e){await this.innerRemoveBinding(e)}async innerAddBinding(e){bindings.set(e.network,e),bindings.set(e.fileSystem,e),e.fileSystem.forceLoadOnCheckContent(),e.network.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.onWorkingCopyCommitted,this),e.fileSystem.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.onWorkingCopyCommitted,this),e.network.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.onWorkingCopyChanged,this),e.fileSystem.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.onWorkingCopyChanged,this),this.addFilePathBindingPrefixes(e.fileSystem.url()),await this.moveBreakpoints(e.fileSystem,e.network),console.assert(!e.fileSystem.isDirty()||!e.network.isDirty()),e.fileSystem.isDirty()?this.syncWorkingCopy(e.fileSystem):e.network.isDirty()?this.syncWorkingCopy(e.network):e.network.hasCommits()&&e.network.content()!==e.fileSystem.content()&&(e.network.setWorkingCopy(e.network.content()),this.syncWorkingCopy(e.network)),this.notifyBindingEvent(e.network),this.notifyBindingEvent(e.fileSystem),this.dispatchEventToListeners(Events.BindingCreated,e)}async innerRemoveBinding(e){bindings.get(e.network)===e&&(console.assert(bindings.get(e.network)===bindings.get(e.fileSystem),"ERROR: inconsistent binding for networkURL "+e.network.url()),bindings.delete(e.network),bindings.delete(e.fileSystem),e.network.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.onWorkingCopyCommitted,this),e.fileSystem.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.onWorkingCopyCommitted,this),e.network.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.onWorkingCopyChanged,this),e.fileSystem.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.onWorkingCopyChanged,this),this.removeFilePathBindingPrefixes(e.fileSystem.url()),await this.breakpointManager.copyBreakpoints(e.network.url(),e.fileSystem),this.notifyBindingEvent(e.network),this.notifyBindingEvent(e.fileSystem),this.dispatchEventToListeners(Events.BindingRemoved,e))}async onStatusAdded(e){const n=new PersistenceBinding(e.network,e.fileSystem);statusBindings.set(e,n),await this.innerAddBinding(n)}async onStatusRemoved(e){const n=statusBindings.get(e);await this.innerRemoveBinding(n)}onWorkingCopyChanged(e){const n=e.data;this.syncWorkingCopy(n)}syncWorkingCopy(e){const n=bindings.get(e);if(!n||mutedWorkingCopies.has(n))return;const t=n.network===e?n.fileSystem:n.network;if(!e.isDirty())return mutedWorkingCopies.add(n),t.resetWorkingCopy(),mutedWorkingCopies.delete(n),void this.contentSyncedForTest();const i=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(n.network);if(i&&i.type()===SDK.Target.Type.Node){const n=e.workingCopy();t.requestContent().then((()=>{const e=PersistenceImpl.rewrapNodeJSContent(t,t.workingCopy(),n);o.call(this,(()=>e))}))}else o.call(this,(()=>e.workingCopy()));function o(e){n&&mutedWorkingCopies.add(n),t.setWorkingCopyGetter(e),n&&mutedWorkingCopies.delete(n),this.contentSyncedForTest()}}onWorkingCopyCommitted(e){const n=e.data.uiSourceCode,t=e.data.content;this.syncContent(n,t,Boolean(e.data.encoded))}syncContent(e,n,t){const i=bindings.get(e);if(!i||mutedCommits.has(i))return;const o=i.network===e?i.fileSystem:i.network,s=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(i.network);function r(e){i&&mutedCommits.add(i),o.setContent(e,t),i&&mutedCommits.delete(i),this.contentSyncedForTest()}s&&s.type()===SDK.Target.Type.Node?o.requestContent().then((e=>{const t=PersistenceImpl.rewrapNodeJSContent(o,e.content||"",n);r.call(this,t)})):r.call(this,n)}static rewrapNodeJSContent(e,n,t){return e.project().type()===Workspace.Workspace.projectTypes.FileSystem?(t.startsWith(NodePrefix)&&t.endsWith(NodeSuffix)&&(t=t.substring(NodePrefix.length,t.length-NodeSuffix.length)),n.startsWith(NodeShebang)&&(t=NodeShebang+t)):(t.startsWith(NodeShebang)&&(t=t.substring(NodeShebang.length)),n.startsWith(NodePrefix)&&n.endsWith(NodeSuffix)&&(t=NodePrefix+t+NodeSuffix)),t}contentSyncedForTest(){}async moveBreakpoints(e,n){const t=this.breakpointManager.breakpointLocationsForUISourceCode(e).map((e=>e.breakpoint));await Promise.all(t.map((e=>(e.remove(!1),this.breakpointManager.setBreakpoint(n,e.lineNumber(),e.columnNumber(),e.condition(),e.enabled())))))}hasUnsavedCommittedChanges(e){return!this.workspace.hasResourceContentTrackingExtensions()&&(!e.project().canSetFileContent()&&(!bindings.has(e)&&Boolean(e.hasCommits())))}binding(e){return bindings.get(e)||null}subscribeForBindingEvent(e,n){this.subscribedBindingEventListeners.set(e,n)}unsubscribeFromBindingEvent(e,n){this.subscribedBindingEventListeners.delete(e,n)}notifyBindingEvent(e){if(!this.subscribedBindingEventListeners.has(e))return;const n=Array.from(this.subscribedBindingEventListeners.get(e));for(const e of n)e.call(null)}fileSystem(e){const n=this.binding(e);return n?n.fileSystem:null}network(e){const n=this.binding(e);return n?n.network:null}addFilePathBindingPrefixes(e){let n="";for(const t of e.split("/")){n+=t+"/";const e=this.filePathPrefixesToBindingCount.get(n)||0;this.filePathPrefixesToBindingCount.set(n,e+1)}}removeFilePathBindingPrefixes(e){let n="";for(const t of e.split("/")){n+=t+"/";const e=this.filePathPrefixesToBindingCount.get(n);1===e?this.filePathPrefixesToBindingCount.delete(n):void 0!==e&&this.filePathPrefixesToBindingCount.set(n,e-1)}}filePathHasBindings(e){return e.endsWith("/")||(e+="/"),this.filePathPrefixesToBindingCount.has(e)}}const bindings=new WeakMap,statusBindings=new WeakMap,mutedCommits=new WeakSet,mutedWorkingCopies=new WeakSet;export const NodePrefix="(function (exports, require, module, __filename, __dirname) { ";export const NodeSuffix="\n});";export const NodeShebang="#!/usr/bin/env node";export var Events;!function(e){e.BindingCreated="BindingCreated",e.BindingRemoved="BindingRemoved"}(Events||(Events={}));export class PathEncoder{encoder;constructor(){this.encoder=new Common.CharacterIdMap.CharacterIdMap}encode(e){return e.split("/").map((e=>this.encoder.toChar(e))).join("")}decode(e){return e.split("").map((e=>this.encoder.fromChar(e))).join("/")}}export class PersistenceBinding{network;fileSystem;constructor(e,n){this.network=e,this.fileSystem=n}}