import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import{TimelineJSProfileProcessor}from"./TimelineJSProfile.js";const UIStrings={threadS:"Thread {PH1}",workerS:"`Worker` — {PH1}",dedicatedWorker:"Dedicated `Worker`",workerSS:"`Worker`: {PH1} — {PH2}"},str_=i18n.i18n.registerUIStrings("models/timeline_model/TimelineModel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineModelImpl{isGenericTraceInternal;tracksInternal;namedTracks;inspectedTargetEventsInternal;timeMarkerEventsInternal;sessionId;mainFrameNodeId;pageFrames;cpuProfilesInternal;workerIdByThread;requestsFromBrowser;mainFrame;minimumRecordTimeInternal;maximumRecordTimeInternal;totalBlockingTimeInternal;estimatedTotalBlockingTime;asyncEventTracker;invalidationTracker;layoutInvalidate;lastScheduleStyleRecalculation;paintImageEventByPixelRefId;lastPaintForLayer;lastRecalculateStylesEvent;currentScriptEvent;eventStack;knownInputEvents;browserFrameTracking;persistentIds;legacyCurrentPage;currentTaskLayoutAndRecalcEvents;tracingModelInternal;mainFrameLayerTreeId;constructor(){this.minimumRecordTimeInternal=0,this.maximumRecordTimeInternal=0,this.totalBlockingTimeInternal=0,this.estimatedTotalBlockingTime=0,this.reset(),this.resetProcessingState(),this.currentTaskLayoutAndRecalcEvents=[],this.tracingModelInternal=null}static forEachEvent(e,t,a,r,n,i,s){n=n||0,i=i||1/0;const o=[];for(let c=TimelineModelImpl.topLevelEventEndingAfter(e,n);c<e.length;++c){const d=e[c];if((d.endTime||d.startTime)<n)continue;if(d.startTime>=i)break;if(SDK.TracingModel.TracingModel.isAsyncPhase(d.phase)||SDK.TracingModel.TracingModel.isFlowPhase(d.phase))continue;let l=o[o.length-1];for(;l&&void 0!==l.endTime&&l.endTime<=d.startTime;)o.pop(),a(l),l=o[o.length-1];s&&!s(d)||(d.duration?(t(d),o.push(d)):r&&r(d,o[o.length-1]||null))}for(;o.length;){const e=o.pop();e&&a(e)}}static topLevelEventEndingAfter(e,t){let a=Platform.ArrayUtilities.upperBound(e,t,((e,t)=>e-t.startTime))-1;for(;a>0&&!SDK.TracingModel.TracingModel.isTopLevelEvent(e[a]);)a--;return Math.max(a,0)}isMarkerEvent(e){switch(e.name){case RecordType.TimeStamp:return!0;case RecordType.MarkFirstPaint:case RecordType.MarkFCP:return Boolean(this.mainFrame)&&e.args.frame===this.mainFrame.frameId&&Boolean(e.args.data);case RecordType.MarkDOMContent:case RecordType.MarkLoad:case RecordType.MarkLCPCandidate:case RecordType.MarkLCPInvalidate:return Boolean(e.args.data.isMainFrame);default:return!1}}isInteractiveTimeEvent(e){return e.name===RecordType.InteractiveTime}isLayoutShiftEvent(e){return e.name===RecordType.LayoutShift}isUserTimingEvent(e){return e.categoriesString===TimelineModelImpl.Category.UserTiming}isParseHTMLEvent(e){return e.name===RecordType.ParseHTML}isLCPCandidateEvent(e){return e.name===RecordType.MarkLCPCandidate&&Boolean(e.args.data.isMainFrame)}isLCPInvalidateEvent(e){return e.name===RecordType.MarkLCPInvalidate&&Boolean(e.args.data.isMainFrame)}isFCPEvent(e){return e.name===RecordType.MarkFCP&&Boolean(this.mainFrame)&&e.args.frame===this.mainFrame.frameId}isLongRunningTask(e){return e.name===RecordType.Task&&TimelineData.forEvent(e).warning===TimelineModelImpl.WarningType.LongTask}isNavigationStartEvent(e){return e.name===RecordType.NavigationStart}isMainFrameNavigationStartEvent(e){return this.isNavigationStartEvent(e)&&e.args.data.isLoadingMainFrame&&e.args.data.documentLoaderURL}static globalEventId(e,t){const a=e.args.data||e.args.beginData,r=a&&a[t];return r?`${e.thread.process().id()}.${r}`:""}static eventFrameId(e){const t=e.args.data||e.args.beginData;return t&&t.frame||null}cpuProfiles(){return this.cpuProfilesInternal}totalBlockingTime(){return-1===this.totalBlockingTimeInternal?{time:this.estimatedTotalBlockingTime,estimated:!0}:{time:this.totalBlockingTimeInternal,estimated:!1}}targetByEvent(e){const t=this.workerIdByThread.get(e.thread),a=SDK.TargetManager.TargetManager.instance().mainTarget();return t?SDK.TargetManager.TargetManager.instance().targetById(t):a}navStartTimes(){return this.tracingModelInternal?this.tracingModelInternal.navStartTimes():new Map}setEvents(e){this.reset(),this.resetProcessingState(),this.tracingModelInternal=e,this.minimumRecordTimeInternal=e.minimumRecordTime(),this.maximumRecordTimeInternal=e.maximumRecordTime();const t=[];for(const a of e.sortedProcesses())if("Renderer"===a.name())for(const e of a.sortedThreads()){const a=e.removeEventsByName(RecordType.LayoutShift);t.push(...a)}if(this.processSyncBrowserEvents(e),this.browserFrameTracking)this.processThreadsForBrowserFrames(e);else{const t=this.processMetadataEvents(e);this.isGenericTraceInternal=!t,t?this.processMetadataAndThreads(e,t):this.processGenericTrace(e)}this.inspectedTargetEventsInternal.sort(SDK.TracingModel.Event.compareStartTime),this.processAsyncBrowserEvents(e),this.buildGPUEvents(e),this.buildLoadingEvents(e,t),this.resetProcessingState()}processGenericTrace(e){let t=SDK.TracingModel.TracingModel.browserMainThread(e);!t&&e.sortedProcesses().length&&(t=e.sortedProcesses()[0].sortedThreads()[0]);for(const a of e.sortedProcesses())for(const r of a.sortedThreads())this.processThreadEvents(e,[{from:0,to:1/0}],r,r===t,!1,!0,null)}processMetadataAndThreads(e,t){let a=0;for(let r=0,n=t.page.length;r<n;r++){const i=t.page[r],s=i.thread.process(),o=r+1<n?t.page[r+1].startTime:1/0;if(a!==o){this.legacyCurrentPage=i.args.data&&i.args.data.page;for(const r of s.sortedThreads()){let n=null;if(r.name()===TimelineModelImpl.WorkerThreadName||r.name()===TimelineModelImpl.WorkerThreadNameLegacy){const e=t.workers.find((e=>{if(e.args.data.workerThreadId!==r.id())return!1;if(e.args.data.sessionId===this.sessionId)return!0;const t=TimelineModelImpl.eventFrameId(e);return!!t&&Boolean(this.pageFrames.get(t))}));if(!e)continue;const a=e.args.data.workerId;a&&this.workerIdByThread.set(r,a),n=e.args.data.url||""}this.processThreadEvents(e,[{from:a,to:o}],r,r===i.thread,Boolean(n),!0,n)}a=o}}}processThreadsForBrowserFrames(e){const t=new Map;for(const e of this.pageFrames.values())for(let a=0;a<e.processes.length;a++){const r=e.processes[a].processId;let n=t.get(r);n||(n=[],t.set(r,n));const i=a===e.processes.length-1?e.deletedTime||1/0:e.processes[a+1].time;n.push({from:e.processes[a].time,to:i,main:!e.parent,url:e.processes[a].url})}const a=e.devToolsMetadataEvents();for(const r of e.sortedProcesses()){const n=t.get(r.id());if(!n)continue;n.sort(((e,t)=>e.from-t.from||e.to-t.to));const i=[];let s=null,o=null,c=!1;for(const e of n){const t=i[i.length-1];!t||e.from>t.to?i.push({from:e.from,to:e.to}):t.to=e.to,e.main&&(c=!0),e.url&&(e.main&&(o=e.url),s=e.url)}for(const t of r.sortedThreads())if(t.name()===TimelineModelImpl.RendererMainThreadName)this.processThreadEvents(e,i,t,!0,!1,c,c?o:s);else if(t.name()===TimelineModelImpl.WorkerThreadName||t.name()===TimelineModelImpl.WorkerThreadNameLegacy){const n=a.find((e=>{if(e.name!==TimelineModelImpl.DevToolsMetadataEvent.TracingSessionIdForWorker)return!1;if(e.thread.process()!==r)return!1;if(e.args.data.workerThreadId!==t.id())return!1;const a=TimelineModelImpl.eventFrameId(e);return!!a&&Boolean(this.pageFrames.get(a))}));if(!n)continue;this.workerIdByThread.set(t,n.args.data.workerId||""),this.processThreadEvents(e,i,t,!1,!0,!1,n.args.data.url||"")}else this.processThreadEvents(e,i,t,!1,!1,!1,null)}}processMetadataEvents(e){const t=e.devToolsMetadataEvents(),a=[],r=[];for(const e of t)if(e.name===TimelineModelImpl.DevToolsMetadataEvent.TracingStartedInPage){a.push(e),e.args.data&&e.args.data.persistentIds&&(this.persistentIds=!0);(e.args.data&&e.args.data.frames||[]).forEach((t=>this.addPageFrame(e,t))),this.mainFrame=this.rootFrames()[0]}else e.name===TimelineModelImpl.DevToolsMetadataEvent.TracingSessionIdForWorker?r.push(e):e.name===TimelineModelImpl.DevToolsMetadataEvent.TracingStartedInBrowser&&(console.assert(!this.mainFrameNodeId,"Multiple sessions in trace"),this.mainFrameNodeId=e.args.frameTreeNodeId);if(!a.length)return null;const n=a[0].args.sessionId||a[0].args.data.sessionId;this.sessionId=n;const i=new Set;const s={page:a.filter((function(e){let t=e.args;t.data&&(t=t.data);const a=t.sessionId;return a===n||(i.add(a),!1)})).sort(SDK.TracingModel.Event.compareStartTime),workers:r.sort(SDK.TracingModel.Event.compareStartTime)};return i.size&&Common.Console.Console.instance().error("Timeline recording was started in more than one page simultaneously. Session id mismatch: "+this.sessionId+" and "+[...i]+"."),s}processSyncBrowserEvents(e){const t=SDK.TracingModel.TracingModel.browserMainThread(e);t&&t.events().forEach(this.processBrowserEvent,this)}processAsyncBrowserEvents(e){const t=SDK.TracingModel.TracingModel.browserMainThread(e);t&&this.processAsyncEvents(t,[{from:0,to:1/0}])}buildGPUEvents(e){const t=e.getThreadByName("GPU Process","CrGpuMain");if(!t)return;const a=RecordType.GPUTask,r=this.ensureNamedTrack(TrackType.GPU);r.thread=t,r.events=t.events().filter((e=>e.name===a))}buildLoadingEvents(e,t){const a=e.getThreadByName("Renderer","CrRendererMain");if(!a)return;const r=this.ensureNamedTrack(TrackType.Experience);r.thread=a,r.events=t;for(const e of r.events)if(e.categoriesString="experience",e.name===RecordType.LayoutShift){const t=e.args.data||e.args.beginData||{},a=TimelineData.forEvent(e);if(t.impacted_nodes)for(let e=0;e<t.impacted_nodes.length;++e)a.backendNodeIds.push(t.impacted_nodes[e].node_id)}}resetProcessingState(){this.asyncEventTracker=new TimelineAsyncEventTracker,this.invalidationTracker=new InvalidationTracker,this.layoutInvalidate={},this.lastScheduleStyleRecalculation={},this.paintImageEventByPixelRefId={},this.lastPaintForLayer={},this.lastRecalculateStylesEvent=null,this.currentScriptEvent=null,this.eventStack=[],this.knownInputEvents=new Set,this.browserFrameTracking=!1,this.persistentIds=!1,this.legacyCurrentPage=null}extractCpuProfile(e,t){const a=t.events();let r,n=null,i=a[a.length-1];if(i&&i.name===RecordType.CpuProfile){const e=i.args.data;r=e&&e.cpuProfile,n=this.targetByEvent(i)}if(!r){if(i=a.find((e=>e.name===RecordType.Profile)),!i)return null;n=this.targetByEvent(i);const t=e.profileGroup(i);if(!t)return Common.Console.Console.instance().error("Invalid CPU profile format."),null;r={startTime:1e3*i.startTime,endTime:0,nodes:[],samples:[],timeDeltas:[],lines:[]};for(const e of t.children){const t=e.args.data;"startTime"in t&&(r.startTime=1e3*e.startTime),"endTime"in t&&(r.endTime=1e3*e.startTime);const a=t.cpuProfile||{},n=a.samples||[],i=t.lines||Array(n.length).fill(0);if(r.nodes.push(...a.nodes||[]),r.lines.push(...i),r.samples&&r.samples.push(...n),r.timeDeltas&&r.timeDeltas.push(...t.timeDeltas||[]),r.samples&&r.timeDeltas&&r.samples.length!==r.timeDeltas.length)return Common.Console.Console.instance().error("Failed to parse CPU profile."),null}if(!r.endTime&&r.timeDeltas){const e=r.timeDeltas;r.endTime=e.reduce(((e,t)=>e+t),r.startTime)}}try{const e=r,t=new SDK.CPUProfileDataModel.CPUProfileDataModel(e,n);return this.cpuProfilesInternal.push(t),t}catch(e){Common.Console.Console.instance().error("Failed to parse CPU profile.")}return null}injectJSFrameEvents(e,t){const a=this.extractCpuProfile(e,t);let r=t.events();const n=a?TimelineJSProfileProcessor.generateTracingEventsFromCpuProfile(a,t):null;if(n&&n.length&&(r=Platform.ArrayUtilities.mergeOrdered(r,n,SDK.TracingModel.Event.orderedCompareStartTime)),n||r.some((e=>e.name===RecordType.JSSample))){const e=TimelineJSProfileProcessor.generateJSFrameEvents(r,{showAllEvents:Root.Runtime.experiments.isEnabled("timelineShowAllEvents"),showRuntimeCallStats:Root.Runtime.experiments.isEnabled("timelineV8RuntimeCallStats"),showNativeFunctions:Common.Settings.Settings.instance().moduleSetting("showNativeFunctionsInJSProfile").get()});e&&e.length&&(r=Platform.ArrayUtilities.mergeOrdered(e,r,SDK.TracingModel.Event.orderedCompareStartTime))}return r}processThreadEvents(e,t,a,r,n,i,s){const o=new Track;o.name=a.name()||i18nString(UIStrings.threadS,{PH1:a.id()}),o.type=TrackType.Other,o.thread=a,r?(o.type=TrackType.MainThread,o.url=s||"",o.forMainFrame=i):n?(o.type=TrackType.Worker,o.url=s||"",o.name=o.url?i18nString(UIStrings.workerS,{PH1:o.url}):i18nString(UIStrings.dedicatedWorker)):a.name().startsWith("CompositorTileWorker")&&(o.type=TrackType.Raster),this.tracksInternal.push(o);const c=this.injectJSFrameEvents(e,a);this.eventStack=[];const d=this.eventStack;if(n){const e=c.find((e=>e.name===RecordType.Profile));if(e){const t=this.targetByEvent(e);t&&(o.name=i18nString(UIStrings.workerSS,{PH1:t.name(),PH2:o.url}))}}for(const e of t){let t=Platform.ArrayUtilities.lowerBound(c,e.from,((e,t)=>e-t.startTime));for(;t<c.length;t++){const a=c[t];if(a.startTime>=e.to)break;this.isInteractiveTimeEvent(a)&&-1===this.totalBlockingTimeInternal&&(this.totalBlockingTimeInternal=a.args.args.total_blocking_time_ms);const n=a.name===RecordType.Task&&a.duration&&a.duration>50;r&&n&&a.duration&&(this.estimatedTotalBlockingTime+=a.duration-50);let i=d[d.length-1];for(;i&&void 0!==i.endTime&&i.endTime<=a.startTime;)d.pop(),i=d[d.length-1];if(this.processEvent(a)){if(!SDK.TracingModel.TracingModel.isAsyncPhase(a.phase)&&a.duration){if(d.length){const e=d[d.length-1];e&&(e.selfTime-=a.duration,e.selfTime<0&&this.fixNegativeDuration(e,a))}a.selfTime=a.duration,d.length||o.tasks.push(a),d.push(a)}this.isMarkerEvent(a)&&this.timeMarkerEventsInternal.push(a),o.events.push(a),this.inspectedTargetEventsInternal.push(a)}}}this.processAsyncEvents(a,t)}fixNegativeDuration(e,t){e.selfTime<-.001&&console.error(`Children are longer than parent at ${e.startTime} (${(t.startTime-this.minimumRecordTime()).toFixed(3)} by ${(-e.selfTime).toFixed(3)}`),e.selfTime=0}processAsyncEvents(e,t){const a=e.asyncEvents(),r=new Map;function n(e){return r.has(e)||r.set(e,[]),r.get(e)}for(const e of t){let t=Platform.ArrayUtilities.lowerBound(a,e.from,(function(e,t){return e-t.startTime}));for(;t<a.length;++t){const r=a[t];if(r.startTime>=e.to)break;if(r.hasCategory(TimelineModelImpl.Category.Console))n(TrackType.Console).push(r);else if(r.hasCategory(TimelineModelImpl.Category.UserTiming))n(TrackType.Timings).push(r);else if(r.name!==RecordType.Animation)if(r.hasCategory(TimelineModelImpl.Category.LatencyInfo)||r.name===RecordType.ImplSideFling){const e=r.steps[r.steps.length-1];if(!e)throw new Error("AsyncEvent.steps access is out of bounds.");if(e.phase!==SDK.TracingModel.Phase.AsyncEnd)continue;const t=e.args.data;if(r.causedFrame=Boolean(t&&t.INPUT_EVENT_LATENCY_RENDERER_SWAP_COMPONENT),r.hasCategory(TimelineModelImpl.Category.LatencyInfo)){if(e.id&&!this.knownInputEvents.has(e.id))continue;if(r.name===RecordType.InputLatencyMouseMove&&!r.causedFrame)continue;if(t.is_coalesced)continue;const a=t.INPUT_EVENT_LATENCY_RENDERER_MAIN_COMPONENT;if(a){const e=a.time/1e3;TimelineData.forEvent(r.steps[0]).timeWaitingForMainThread=e-r.steps[0].startTime}}n(TrackType.Input).push(r)}else;else n(TrackType.Animation).push(r)}}for(const[t,a]of r){const r=this.ensureNamedTrack(t);r.thread=e,r.asyncEvents=Platform.ArrayUtilities.mergeOrdered(r.asyncEvents,a,SDK.TracingModel.Event.compareStartTime)}}processEvent(e){const t=this.eventStack;if(!t.length){if(this.currentTaskLayoutAndRecalcEvents&&this.currentTaskLayoutAndRecalcEvents.length){const e=this.currentTaskLayoutAndRecalcEvents.reduce(((e,t)=>void 0===t.duration?e:e+t.duration),0);if(e>TimelineModelImpl.Thresholds.ForcedLayout)for(const e of this.currentTaskLayoutAndRecalcEvents){TimelineData.forEvent(e).warning=e.name===RecordType.Layout?TimelineModelImpl.WarningType.ForcedLayout:TimelineModelImpl.WarningType.ForcedStyle}}this.currentTaskLayoutAndRecalcEvents=[]}this.currentScriptEvent&&void 0!==this.currentScriptEvent.endTime&&e.startTime>this.currentScriptEvent.endTime&&(this.currentScriptEvent=null);const a=e.args.data||e.args.beginData||{},r=TimelineData.forEvent(e);a.stackTrace&&(r.stackTrace=a.stackTrace.map((t=>{if(e.name!==RecordType.JSSample){const e={...t};return--e.lineNumber,--e.columnNumber,e}return t})));let n=TimelineModelImpl.eventFrameId(e);const i=t[t.length-1];switch(!n&&i&&(n=TimelineData.forEvent(i).frameId),r.frameId=n||this.mainFrame&&this.mainFrame.frameId||"",this.asyncEventTracker.processEvent(e),this.isMarkerEvent(e)&&this.ensureNamedTrack(TrackType.Timings),e.name){case RecordType.ResourceSendRequest:case RecordType.WebSocketCreate:r.setInitiator(t[t.length-1]||null),r.url=a.url;break;case RecordType.ScheduleStyleRecalculation:this.lastScheduleStyleRecalculation[a.frame]=e;break;case RecordType.UpdateLayoutTree:case RecordType.RecalculateStyles:this.invalidationTracker.didRecalcStyle(e),e.args.beginData&&r.setInitiator(this.lastScheduleStyleRecalculation[e.args.beginData.frame]),this.lastRecalculateStylesEvent=e,this.currentScriptEvent&&this.currentTaskLayoutAndRecalcEvents.push(e);break;case RecordType.ScheduleStyleInvalidationTracking:case RecordType.StyleRecalcInvalidationTracking:case RecordType.StyleInvalidatorInvalidationTracking:case RecordType.LayoutInvalidationTracking:this.invalidationTracker.addInvalidation(new InvalidationTrackingEvent(e,r));break;case RecordType.InvalidateLayout:{let t=e;const r=a.frame;!this.layoutInvalidate[r]&&this.lastRecalculateStylesEvent&&void 0!==this.lastRecalculateStylesEvent.endTime&&this.lastRecalculateStylesEvent.endTime>e.startTime&&(t=TimelineData.forEvent(this.lastRecalculateStylesEvent).initiator()),this.layoutInvalidate[r]=t;break}case RecordType.Layout:{this.invalidationTracker.didLayout(e);const t=e.args.beginData.frame;if(r.setInitiator(this.layoutInvalidate[t]),e.args.endData)if(e.args.endData.layoutRoots)for(let t=0;t<e.args.endData.layoutRoots.length;++t)r.backendNodeIds.push(e.args.endData.layoutRoots[t].nodeId);else r.backendNodeIds.push(e.args.endData.rootNode);this.layoutInvalidate[t]=null,this.currentScriptEvent&&this.currentTaskLayoutAndRecalcEvents.push(e);break}case RecordType.Task:void 0!==e.duration&&e.duration>TimelineModelImpl.Thresholds.LongTask&&(r.warning=TimelineModelImpl.WarningType.LongTask);break;case RecordType.EventDispatch:void 0!==e.duration&&e.duration>TimelineModelImpl.Thresholds.RecurringHandler&&(r.warning=TimelineModelImpl.WarningType.LongHandler);break;case RecordType.TimerFire:case RecordType.FireAnimationFrame:void 0!==e.duration&&e.duration>TimelineModelImpl.Thresholds.RecurringHandler&&(r.warning=TimelineModelImpl.WarningType.LongRecurringHandler);break;case RecordType.FunctionCall:"string"==typeof a.scriptName&&(a.url=a.scriptName),"number"==typeof a.scriptLine&&(a.lineNumber=a.scriptLine);case RecordType.EvaluateScript:case RecordType.CompileScript:case RecordType.CacheScript:"number"==typeof a.lineNumber&&--a.lineNumber,"number"==typeof a.columnNumber&&--a.columnNumber;case RecordType.RunMicrotasks:this.currentScriptEvent||(this.currentScriptEvent=e);break;case RecordType.SetLayerTreeId:{if(this.sessionId&&a.sessionId&&this.sessionId===a.sessionId){this.mainFrameLayerTreeId=a.layerTreeId;break}const t=TimelineModelImpl.eventFrameId(e),r=t?this.pageFrames.get(t):null;if(!r||r.parent)return!1;this.mainFrameLayerTreeId=a.layerTreeId;break}case RecordType.Paint:{if(this.invalidationTracker.didPaint=!0,"nodeId"in a&&r.backendNodeIds.push(a.nodeId),!a.layerId)break;const t=a.layerId;this.lastPaintForLayer[t]=e;break}case RecordType.DisplayItemListSnapshot:case RecordType.PictureSnapshot:{const t=this.findAncestorEvent(RecordType.UpdateLayer);if(!t||t.args.layerTreeId!==this.mainFrameLayerTreeId)break;const a=this.lastPaintForLayer[t.args.layerId];a&&(TimelineData.forEvent(a).picture=e);break}case RecordType.ScrollLayer:r.backendNodeIds.push(a.nodeId);break;case RecordType.PaintImage:r.backendNodeIds.push(a.nodeId),r.url=a.url;break;case RecordType.DecodeImage:case RecordType.ResizeImage:{let e=this.findAncestorEvent(RecordType.PaintImage);if(!e){const t=this.findAncestorEvent(RecordType.DecodeLazyPixelRef);e=t&&this.paintImageEventByPixelRefId[t.args.LazyPixelRef]}if(!e)break;const t=TimelineData.forEvent(e);r.backendNodeIds.push(t.backendNodeIds[0]),r.url=t.url;break}case RecordType.DrawLazyPixelRef:{const t=this.findAncestorEvent(RecordType.PaintImage);if(!t)break;this.paintImageEventByPixelRefId[e.args.LazyPixelRef]=t;const a=TimelineData.forEvent(t);r.backendNodeIds.push(a.backendNodeIds[0]),r.url=a.url;break}case RecordType.FrameStartedLoading:if(r.frameId!==e.args.frame)return!1;break;case RecordType.MarkLCPCandidate:r.backendNodeIds.push(a.nodeId);break;case RecordType.MarkDOMContent:case RecordType.MarkLoad:{const t=TimelineModelImpl.eventFrameId(e);if(!t||!this.pageFrames.has(t))return!1;break}case RecordType.CommitLoad:{if(this.browserFrameTracking)break;const t=TimelineModelImpl.eventFrameId(e),r=Boolean(a.isMainFrame),n=t?this.pageFrames.get(t):null;if(n)n.update(e.startTime,a);else if(this.persistentIds){if(r)return!1;if(!this.addPageFrame(e,a))return!1}else if(a.page&&a.page!==this.legacyCurrentPage)return!1;if(r&&t){const e=this.pageFrames.get(t);e&&(this.mainFrame=e)}break}case RecordType.FireIdleCallback:void 0!==e.duration&&e.duration>a.allottedMilliseconds+TimelineModelImpl.Thresholds.IdleCallbackAddon&&(r.warning=TimelineModelImpl.WarningType.IdleDeadlineExceeded)}return!0}processBrowserEvent(e){if(e.name!==RecordType.LatencyInfoFlow)if(e.name!==RecordType.ResourceWillSendRequest){if(e.hasCategory(SDK.TracingModel.DevToolsMetadataEventCategory)&&e.args.data){const t=e.args.data;if(e.name===TimelineModelImpl.DevToolsMetadataEvent.TracingStartedInBrowser){if(!t.persistentIds)return;this.browserFrameTracking=!0,this.mainFrameNodeId=t.frameTreeNodeId;return void(t.frames||[]).forEach((e=>{const t=e.parent&&this.pageFrames.get(e.parent);if(e.parent&&!t)return;let a=this.pageFrames.get(e.frame);a||(a=new PageFrame(e),this.pageFrames.set(a.frameId,a),t?t.addChild(a):this.mainFrame=a),a.update(this.minimumRecordTimeInternal,e)}))}if(e.name===TimelineModelImpl.DevToolsMetadataEvent.FrameCommittedInBrowser&&this.browserFrameTracking){let a=this.pageFrames.get(t.frame);if(!a){const e=t.parent&&this.pageFrames.get(t.parent);if(!e)return;a=new PageFrame(t),this.pageFrames.set(a.frameId,a),e.addChild(a)}return void a.update(e.startTime,t)}if(e.name===TimelineModelImpl.DevToolsMetadataEvent.ProcessReadyInBrowser&&this.browserFrameTracking){const e=this.pageFrames.get(t.frame);return void(e&&e.processReady(t.processPseudoId,t.processId))}if(e.name===TimelineModelImpl.DevToolsMetadataEvent.FrameDeletedInBrowser&&this.browserFrameTracking){const a=this.pageFrames.get(t.frame);return void(a&&(a.deletedTime=e.startTime))}}}else{const t=e.args?.data?.requestId;"string"==typeof t&&this.requestsFromBrowser.set(t,e)}else{const t=e.args.frameTreeNodeId;"number"==typeof t&&t===this.mainFrameNodeId&&e.bind_id&&this.knownInputEvents.add(e.bind_id)}}ensureNamedTrack(e){let t=this.namedTracks.get(e);return t||(t=new Track,t.type=e,this.tracksInternal.push(t),this.namedTracks.set(e,t),t)}findAncestorEvent(e){for(let t=this.eventStack.length-1;t>=0;--t){const a=this.eventStack[t];if(a.name===e)return a}return null}addPageFrame(e,t){const a=t.parent&&this.pageFrames.get(t.parent);if(t.parent&&!a)return!1;const r=new PageFrame(t);return this.pageFrames.set(r.frameId,r),r.update(e.startTime,t),a&&a.addChild(r),!0}reset(){this.isGenericTraceInternal=!1,this.tracksInternal=[],this.namedTracks=new Map,this.inspectedTargetEventsInternal=[],this.timeMarkerEventsInternal=[],this.sessionId=null,this.mainFrameNodeId=null,this.cpuProfilesInternal=[],this.workerIdByThread=new WeakMap,this.pageFrames=new Map,this.requestsFromBrowser=new Map,this.minimumRecordTimeInternal=0,this.maximumRecordTimeInternal=0,this.totalBlockingTimeInternal=-1,this.estimatedTotalBlockingTime=0}isGenericTrace(){return this.isGenericTraceInternal}tracingModel(){return this.tracingModelInternal}minimumRecordTime(){return this.minimumRecordTimeInternal}maximumRecordTime(){return this.maximumRecordTimeInternal}inspectedTargetEvents(){return this.inspectedTargetEventsInternal}tracks(){return this.tracksInternal}isEmpty(){return 0===this.minimumRecordTime()&&0===this.maximumRecordTime()}timeMarkerEvents(){return this.timeMarkerEventsInternal}rootFrames(){return Array.from(this.pageFrames.values()).filter((e=>!e.parent))}pageURL(){return this.mainFrame&&this.mainFrame.url||""}pageFrameById(e){return e&&this.pageFrames.get(e)||null}networkRequests(){if(this.isGenericTrace())return[];const e=new Map,t=[],a=[],r=new Set([RecordType.ResourceWillSendRequest,RecordType.ResourceSendRequest,RecordType.ResourceReceiveResponse,RecordType.ResourceReceivedData,RecordType.ResourceFinish,RecordType.ResourceMarkAsCached]),n=this.inspectedTargetEvents();for(let e=0;e<n.length;++e){const t=n[e];if(!r.has(t.name))continue;const a=TimelineModelImpl.globalEventId(t,"requestId"),s=t.args?.data?.requestId;if(t.name===RecordType.ResourceSendRequest&&s&&this.requestsFromBrowser.has(s)){const e=this.requestsFromBrowser.get(s);e&&i(e,a)}i(t,a)}function i(r,n){let i=e.get(n);i?i.addEvent(r):(i=new NetworkRequest(r),e.set(n,i),i.startTime?t.push(i):a.push(i))}return a.concat(t)}}export var RecordType;!function(e){e.Task="RunTask",e.Program="Program",e.EventDispatch="EventDispatch",e.GPUTask="GPUTask",e.Animation="Animation",e.RequestMainThreadFrame="RequestMainThreadFrame",e.BeginFrame="BeginFrame",e.NeedsBeginFrameChanged="NeedsBeginFrameChanged",e.BeginMainThreadFrame="BeginMainThreadFrame",e.ActivateLayerTree="ActivateLayerTree",e.DrawFrame="DrawFrame",e.DroppedFrame="DroppedFrame",e.HitTest="HitTest",e.ScheduleStyleRecalculation="ScheduleStyleRecalculation",e.RecalculateStyles="RecalculateStyles",e.UpdateLayoutTree="UpdateLayoutTree",e.InvalidateLayout="InvalidateLayout",e.Layout="Layout",e.LayoutShift="LayoutShift",e.UpdateLayer="UpdateLayer",e.UpdateLayerTree="UpdateLayerTree",e.PaintSetup="PaintSetup",e.Paint="Paint",e.PaintImage="PaintImage",e.Rasterize="Rasterize",e.RasterTask="RasterTask",e.ScrollLayer="ScrollLayer",e.CompositeLayers="CompositeLayers",e.ComputeIntersections="IntersectionObserverController::computeIntersections",e.InteractiveTime="InteractiveTime",e.ScheduleStyleInvalidationTracking="ScheduleStyleInvalidationTracking",e.StyleRecalcInvalidationTracking="StyleRecalcInvalidationTracking",e.StyleInvalidatorInvalidationTracking="StyleInvalidatorInvalidationTracking",e.LayoutInvalidationTracking="LayoutInvalidationTracking",e.ParseHTML="ParseHTML",e.ParseAuthorStyleSheet="ParseAuthorStyleSheet",e.TimerInstall="TimerInstall",e.TimerRemove="TimerRemove",e.TimerFire="TimerFire",e.XHRReadyStateChange="XHRReadyStateChange",e.XHRLoad="XHRLoad",e.CompileScript="v8.compile",e.CompileCode="V8.CompileCode",e.OptimizeCode="V8.OptimizeCode",e.EvaluateScript="EvaluateScript",e.CacheScript="v8.produceCache",e.CompileModule="v8.compileModule",e.EvaluateModule="v8.evaluateModule",e.CacheModule="v8.produceModuleCache",e.WasmStreamFromResponseCallback="v8.wasm.streamFromResponseCallback",e.WasmCompiledModule="v8.wasm.compiledModule",e.WasmCachedModule="v8.wasm.cachedModule",e.WasmModuleCacheHit="v8.wasm.moduleCacheHit",e.WasmModuleCacheInvalid="v8.wasm.moduleCacheInvalid",e.FrameStartedLoading="FrameStartedLoading",e.CommitLoad="CommitLoad",e.MarkLoad="MarkLoad",e.MarkDOMContent="MarkDOMContent",e.MarkFirstPaint="firstPaint",e.MarkFCP="firstContentfulPaint",e.MarkLCPCandidate="largestContentfulPaint::Candidate",e.MarkLCPInvalidate="largestContentfulPaint::Invalidate",e.NavigationStart="navigationStart",e.TimeStamp="TimeStamp",e.ConsoleTime="ConsoleTime",e.UserTiming="UserTiming",e.ResourceWillSendRequest="ResourceWillSendRequest",e.ResourceSendRequest="ResourceSendRequest",e.ResourceReceiveResponse="ResourceReceiveResponse",e.ResourceReceivedData="ResourceReceivedData",e.ResourceFinish="ResourceFinish",e.ResourceMarkAsCached="ResourceMarkAsCached",e.RunMicrotasks="RunMicrotasks",e.FunctionCall="FunctionCall",e.GCEvent="GCEvent",e.MajorGC="MajorGC",e.MinorGC="MinorGC",e.JSFrame="JSFrame",e.JSSample="JSSample",e.V8Sample="V8Sample",e.JitCodeAdded="JitCodeAdded",e.JitCodeMoved="JitCodeMoved",e.StreamingCompileScript="v8.parseOnBackground",e.StreamingCompileScriptWaiting="v8.parseOnBackgroundWaiting",e.StreamingCompileScriptParsing="v8.parseOnBackgroundParsing",e.V8Execute="V8.Execute",e.UpdateCounters="UpdateCounters",e.RequestAnimationFrame="RequestAnimationFrame",e.CancelAnimationFrame="CancelAnimationFrame",e.FireAnimationFrame="FireAnimationFrame",e.RequestIdleCallback="RequestIdleCallback",e.CancelIdleCallback="CancelIdleCallback",e.FireIdleCallback="FireIdleCallback",e.WebSocketCreate="WebSocketCreate",e.WebSocketSendHandshakeRequest="WebSocketSendHandshakeRequest",e.WebSocketReceiveHandshakeResponse="WebSocketReceiveHandshakeResponse",e.WebSocketDestroy="WebSocketDestroy",e.EmbedderCallback="EmbedderCallback",e.SetLayerTreeId="SetLayerTreeId",e.TracingStartedInPage="TracingStartedInPage",e.TracingSessionIdForWorker="TracingSessionIdForWorker",e.DecodeImage="Decode Image",e.ResizeImage="Resize Image",e.DrawLazyPixelRef="Draw LazyPixelRef",e.DecodeLazyPixelRef="Decode LazyPixelRef",e.LazyPixelRef="LazyPixelRef",e.LayerTreeHostImplSnapshot="cc::LayerTreeHostImpl",e.PictureSnapshot="cc::Picture",e.DisplayItemListSnapshot="cc::DisplayItemList",e.LatencyInfo="LatencyInfo",e.LatencyInfoFlow="LatencyInfo.Flow",e.InputLatencyMouseMove="InputLatency::MouseMove",e.InputLatencyMouseWheel="InputLatency::MouseWheel",e.ImplSideFling="InputHandlerProxy::HandleGestureFling::started",e.GCCollectGarbage="BlinkGC.AtomicPhase",e.CryptoDoEncrypt="DoEncrypt",e.CryptoDoEncryptReply="DoEncryptReply",e.CryptoDoDecrypt="DoDecrypt",e.CryptoDoDecryptReply="DoDecryptReply",e.CryptoDoDigest="DoDigest",e.CryptoDoDigestReply="DoDigestReply",e.CryptoDoSign="DoSign",e.CryptoDoSignReply="DoSignReply",e.CryptoDoVerify="DoVerify",e.CryptoDoVerifyReply="DoVerifyReply",e.CpuProfile="CpuProfile",e.Profile="Profile",e.AsyncTask="AsyncTask"}(RecordType||(RecordType={})),function(e){let t;e.Category={Console:"blink.console",UserTiming:"blink.user_timing",LatencyInfo:"latencyInfo",Loading:"loading"},function(e){e.LongTask="LongTask",e.ForcedStyle="ForcedStyle",e.ForcedLayout="ForcedLayout",e.IdleDeadlineExceeded="IdleDeadlineExceeded",e.LongHandler="LongHandler",e.LongRecurringHandler="LongRecurringHandler",e.V8Deopt="V8Deopt"}(t=e.WarningType||(e.WarningType={})),e.WorkerThreadName="DedicatedWorker thread",e.WorkerThreadNameLegacy="DedicatedWorker Thread",e.RendererMainThreadName="CrRendererMain",e.BrowserMainThreadName="CrBrowserMain",e.DevToolsMetadataEvent={TracingStartedInBrowser:"TracingStartedInBrowser",TracingStartedInPage:"TracingStartedInPage",TracingSessionIdForWorker:"TracingSessionIdForWorker",FrameCommittedInBrowser:"FrameCommittedInBrowser",ProcessReadyInBrowser:"ProcessReadyInBrowser",FrameDeletedInBrowser:"FrameDeletedInBrowser"},e.Thresholds={LongTask:50,Handler:150,RecurringHandler:50,ForcedLayout:30,IdleCallbackAddon:5}}(TimelineModelImpl||(TimelineModelImpl={}));export class Track{name;type;forMainFrame;url;events;asyncEvents;tasks;syncEventsInternal;thread;constructor(){this.name="",this.type=TrackType.Other,this.forMainFrame=!1,this.url="",this.events=[],this.asyncEvents=[],this.tasks=[],this.syncEventsInternal=null,this.thread=null}syncEvents(){if(this.events.length)return this.events;if(this.syncEventsInternal)return this.syncEventsInternal;const e=[];function t(){const t=e[e.length-1];if(void 0!==t){const e=t.endTime;if(void 0!==e)return e}throw new Error("End time does not exist on event.")}this.syncEventsInternal=[];for(const a of this.asyncEvents){const r=a.startTime;let n=a.endTime;for(void 0===n&&(n=r);e.length&&r>=t();)e.pop();if(e.length&&n>t()){this.syncEventsInternal=[];break}const i=new SDK.TracingModel.Event(a.categoriesString,a.name,SDK.TracingModel.Phase.Complete,r,a.thread);i.setEndTime(n),i.addArgs(a.args),this.syncEventsInternal.push(i),e.push(i)}return this.syncEventsInternal}}export var TrackType;!function(e){e.MainThread="MainThread",e.Worker="Worker",e.Input="Input",e.Animation="Animation",e.Timings="Timings",e.Console="Console",e.Raster="Raster",e.GPU="GPU",e.Experience="Experience",e.Other="Other"}(TrackType||(TrackType={}));export class PageFrame{frameId;url;name;children;parent;processes;deletedTime;ownerNode;constructor(e){this.frameId=e.frame,this.url=e.url||"",this.name=e.name,this.children=[],this.parent=null,this.processes=[],this.deletedTime=null,this.ownerNode=null}update(e,t){this.url=t.url||"",this.name=t.name,t.processId?this.processes.push({time:e,processId:t.processId,processPseudoId:"",url:t.url||""}):this.processes.push({time:e,processId:-1,processPseudoId:t.processPseudoId,url:t.url||""})}processReady(e,t){for(const a of this.processes)a.processPseudoId===e&&(a.processPseudoId="",a.processId=t)}addChild(e){this.children.push(e),e.parent=this}}export class NetworkRequest{startTime;endTime;encodedDataLength;decodedBodyLength;children;timing;mimeType;url;requestMethod;transferSize;maybeDiskCached;memoryCachedInternal;priority;finishTime;responseTime;fromServiceWorker;hasCachedResource;constructor(e){const t=e.name===RecordType.ResourceSendRequest||e.name===RecordType.ResourceWillSendRequest;this.startTime=t?e.startTime:0,this.endTime=1/0,this.encodedDataLength=0,this.decodedBodyLength=0,this.children=[],this.transferSize=0,this.maybeDiskCached=!1,this.memoryCachedInternal=!1,this.addEvent(e)}addEvent(e){this.children.push(e),this.startTime=Math.min(this.startTime,e.startTime);const t=e.args.data;t.mimeType&&(this.mimeType=t.mimeType),"priority"in t&&(this.priority=t.priority),e.name===RecordType.ResourceFinish&&(this.endTime=e.startTime),t.finishTime&&(this.finishTime=1e3*t.finishTime),this.responseTime||e.name!==RecordType.ResourceReceiveResponse&&e.name!==RecordType.ResourceReceivedData||(this.responseTime=e.startTime);const a=t.encodedDataLength||0;e.name===RecordType.ResourceMarkAsCached&&(this.memoryCachedInternal=!0),e.name===RecordType.ResourceReceiveResponse&&(t.fromCache&&(this.maybeDiskCached=!0),t.fromServiceWorker&&(this.fromServiceWorker=!0),t.hasCachedResource&&(this.hasCachedResource=!0),this.encodedDataLength=a),e.name===RecordType.ResourceReceivedData&&(this.encodedDataLength+=a),e.name===RecordType.ResourceFinish&&a&&(this.encodedDataLength=a,this.transferSize=a);const r=t.decodedBodyLength;e.name===RecordType.ResourceFinish&&r&&(this.decodedBodyLength=r),this.url||(this.url=t.url),this.requestMethod||(this.requestMethod=t.requestMethod),this.timing||(this.timing=t.timing),t.fromServiceWorker&&(this.fromServiceWorker=!0)}cached(){return Boolean(this.memoryCachedInternal)||Boolean(this.maybeDiskCached)&&!this.transferSize&&!this.fromServiceWorker}memoryCached(){return this.memoryCachedInternal}getSendReceiveTiming(){if(this.cached()||!this.timing)return{sendStartTime:this.startTime,headersEndTime:this.startTime};const e=1e3*this.timing.requestTime;return{sendStartTime:e+this.timing.sendStart,headersEndTime:e+this.timing.receiveHeadersEnd}}getStartTime(){return Math.min(this.startTime,!this.cached()&&this.timing&&1e3*this.timing.requestTime||1/0)}beginTime(){return Math.min(this.getStartTime(),!this.cached()&&this.timing&&1e3*this.timing.pushStart||1/0)}}export class InvalidationTrackingEvent{type;startTime;tracingEvent;frame;nodeId;nodeName;invalidationSet;invalidatedSelectorId;changedId;changedClass;changedAttribute;changedPseudo;selectorPart;extraData;invalidationList;cause;linkedRecalcStyleEvent;linkedLayoutEvent;constructor(e,t){this.type=e.name,this.startTime=e.startTime,this.tracingEvent=e;const a=e.args.data;this.frame=a.frame,this.nodeId=a.nodeId,this.nodeName=a.nodeName,this.invalidationSet=a.invalidationSet,this.invalidatedSelectorId=a.invalidatedSelectorId,this.changedId=a.changedId,this.changedClass=a.changedClass,this.changedAttribute=a.changedAttribute,this.changedPseudo=a.changedPseudo,this.selectorPart=a.selectorPart,this.extraData=a.extraData,this.invalidationList=a.invalidationList,this.cause={reason:a.reason,stackTrace:t.stackTrace},this.linkedRecalcStyleEvent=!1,this.linkedLayoutEvent=!1,!this.cause.reason&&this.cause.stackTrace&&this.type===RecordType.LayoutInvalidationTracking&&(this.cause.reason="Layout forced")}}export class InvalidationTracker{lastRecalcStyle;lastPaintWithLayer;didPaint;invalidations;invalidationsByNodeId;constructor(){this.lastRecalcStyle=null,this.lastPaintWithLayer=null,this.didPaint=!1,this.initializePerFrameState(),this.invalidations={},this.invalidationsByNodeId={}}static invalidationEventsFor(e){return eventToInvalidation.get(e)||null}addInvalidation(e){if(this.startNewFrameIfNeeded(),!e.nodeId)return console.error("Invalidation lacks node information."),void console.error(e);if(e.type===RecordType.StyleRecalcInvalidationTracking&&"StyleInvalidator"===e.cause.reason)return;if(e.type===RecordType.ScheduleStyleInvalidationTracking||e.type===RecordType.StyleInvalidatorInvalidationTracking||e.type===RecordType.StyleRecalcInvalidationTracking){e.startTime&&this.lastRecalcStyle&&void 0!==this.lastRecalcStyle.endTime&&e.startTime>=this.lastRecalcStyle.startTime&&e.startTime<=this.lastRecalcStyle.endTime&&this.associateWithLastRecalcStyleEvent(e)}this.invalidations[e.type]?this.invalidations[e.type].push(e):this.invalidations[e.type]=[e],e.nodeId&&(this.invalidationsByNodeId[e.nodeId]?this.invalidationsByNodeId[e.nodeId].push(e):this.invalidationsByNodeId[e.nodeId]=[e])}didRecalcStyle(e){this.lastRecalcStyle=e;const t=[RecordType.ScheduleStyleInvalidationTracking,RecordType.StyleInvalidatorInvalidationTracking,RecordType.StyleRecalcInvalidationTracking];for(const e of this.invalidationsOfTypes(t))this.associateWithLastRecalcStyleEvent(e)}associateWithLastRecalcStyleEvent(e){if(e.linkedRecalcStyleEvent)return;if(!this.lastRecalcStyle)throw new Error("Last recalculate style event not set.");const t=this.lastRecalcStyle.args.beginData.frame;e.type===RecordType.StyleInvalidatorInvalidationTracking?this.addSyntheticStyleRecalcInvalidations(this.lastRecalcStyle,t,e):e.type===RecordType.ScheduleStyleInvalidationTracking||this.addInvalidationToEvent(this.lastRecalcStyle,t,e),e.linkedRecalcStyleEvent=!0}addSyntheticStyleRecalcInvalidations(e,t,a){if(a.invalidationList){if(!a.nodeId)return console.error("Invalidation lacks node information."),void console.error(a);for(let e=0;e<a.invalidationList.length;e++){const r=a.invalidationList[e].id;let n;const i=this.invalidationsByNodeId[a.nodeId]||[];for(let e=0;e<i.length;e++){const a=i[e];a.frame===t&&a.invalidationSet===r&&a.type===RecordType.ScheduleStyleInvalidationTracking&&(n=a)}n?this.addSyntheticStyleRecalcInvalidation(n.tracingEvent,a):console.error("Failed to lookup the event that scheduled a style invalidator invalidation.")}}else this.addSyntheticStyleRecalcInvalidation(a.tracingEvent,a)}addSyntheticStyleRecalcInvalidation(e,t){const a=TimelineData.forEvent(e),r=new InvalidationTrackingEvent(e,a);r.type=RecordType.StyleRecalcInvalidationTracking,t.cause.reason&&(r.cause.reason=t.cause.reason),t.selectorPart&&(r.selectorPart=t.selectorPart),this.addInvalidation(r),r.linkedRecalcStyleEvent||this.associateWithLastRecalcStyleEvent(r)}didLayout(e){const t=e.args.beginData.frame;for(const a of this.invalidationsOfTypes([RecordType.LayoutInvalidationTracking]))a.linkedLayoutEvent||(this.addInvalidationToEvent(e,t,a),a.linkedLayoutEvent=!0)}addInvalidationToEvent(e,t,a){if(t!==a.frame)return;const r=eventToInvalidation.get(e);r?r.push(a):eventToInvalidation.set(e,[a])}invalidationsOfTypes(e){const t=this.invalidations;return e||(e=Object.keys(t)),function*(){if(e)for(let a=0;a<e.length;++a){const r=t[e[a]]||[];for(let e=0;e<r.length;++e)yield r[e]}}()}startNewFrameIfNeeded(){this.didPaint&&this.initializePerFrameState()}initializePerFrameState(){this.invalidations={},this.invalidationsByNodeId={},this.lastRecalcStyle=null,this.lastPaintWithLayer=null,this.didPaint=!1}}export class TimelineAsyncEventTracker{initiatorByType;constructor(){if(TimelineAsyncEventTracker.initialize(),this.initiatorByType=new Map,TimelineAsyncEventTracker.asyncEvents)for(const e of TimelineAsyncEventTracker.asyncEvents.keys())this.initiatorByType.set(e,new Map)}static initialize(){if(TimelineAsyncEventTracker.asyncEvents)return;const e=new Map;e.set(RecordType.TimerInstall,{causes:[RecordType.TimerFire],joinBy:"timerId"}),e.set(RecordType.ResourceSendRequest,{causes:[RecordType.ResourceMarkAsCached,RecordType.ResourceReceiveResponse,RecordType.ResourceReceivedData,RecordType.ResourceFinish],joinBy:"requestId"}),e.set(RecordType.RequestAnimationFrame,{causes:[RecordType.FireAnimationFrame],joinBy:"id"}),e.set(RecordType.RequestIdleCallback,{causes:[RecordType.FireIdleCallback],joinBy:"id"}),e.set(RecordType.WebSocketCreate,{causes:[RecordType.WebSocketSendHandshakeRequest,RecordType.WebSocketReceiveHandshakeResponse,RecordType.WebSocketDestroy],joinBy:"identifier"}),TimelineAsyncEventTracker.asyncEvents=e,TimelineAsyncEventTracker.typeToInitiator=new Map;for(const t of e){const e=t[1].causes;for(const a of e)TimelineAsyncEventTracker.typeToInitiator.set(a,t[0])}}processEvent(e){if(!TimelineAsyncEventTracker.typeToInitiator||!TimelineAsyncEventTracker.asyncEvents)return;let t=TimelineAsyncEventTracker.typeToInitiator.get(e.name);const a=!t;t||(t=e.name);const r=TimelineAsyncEventTracker.asyncEvents.get(t);if(!r)return;const n=TimelineModelImpl.globalEventId(e,r.joinBy);if(!n)return;const i=this.initiatorByType.get(t);if(i){if(a)return void i.set(n,e);const t=i.get(n),r=TimelineData.forEvent(e);r.setInitiator(t||null),!r.frameId&&t&&(r.frameId=TimelineModelImpl.eventFrameId(t))}}static asyncEvents=null;static typeToInitiator=null}export class TimelineData{warning;previewElement;url;backendNodeIds;stackTrace;picture;initiatorInternal;frameId;timeWaitingForMainThread;constructor(){this.warning=null,this.previewElement=null,this.url=null,this.backendNodeIds=[],this.stackTrace=null,this.picture=null,this.initiatorInternal=null,this.frameId=null}setInitiator(e){if(this.initiatorInternal=e,!e||this.url)return;const t=TimelineData.forEvent(e).url;t&&(this.url=t)}initiator(){return this.initiatorInternal}topFrame(){const e=this.stackTraceForSelfOrInitiator();return e&&e[0]||null}stackTraceForSelfOrInitiator(){return this.stackTrace||this.initiatorInternal&&TimelineData.forEvent(this.initiatorInternal).stackTrace}static forEvent(e){let t=eventToData.get(e);return t||(t=new TimelineData,eventToData.set(e,t)),t}}const eventToData=new WeakMap,eventToInvalidation=new WeakMap;