import*as Common from"../../core/common/common.js";import*as SDK from"../../core/sdk/sdk.js";export class IndexedDBModel extends SDK.SDKModel.SDKModel{securityOriginManager;indexedDBAgent;storageAgent;databasesInternal;databaseNamesBySecurityOrigin;originsUpdated;throttler;enabled;constructor(e){super(e),e.registerStorageDispatcher(this),this.securityOriginManager=e.model(SDK.SecurityOriginManager.SecurityOriginManager),this.indexedDBAgent=e.indexedDBAgent(),this.storageAgent=e.storageAgent(),this.databasesInternal=new Map,this.databaseNamesBySecurityOrigin={},this.originsUpdated=new Set,this.throttler=new Common.Throttler.Throttler(1e3)}static keyFromIDBKey(e){if(null==e)return;let t;switch(typeof e){case"number":t={type:"number",number:e};break;case"string":t={type:"string",string:e};break;case"object":if(e instanceof Date)t={type:"date",date:e.getTime()};else{if(!Array.isArray(e))return;{const a=[];for(let t=0;t<e.length;++t){const i=IndexedDBModel.keyFromIDBKey(e[t]);i&&a.push(i)}t={type:"array",array:a}}}break;default:return}return t}static keyRangeFromIDBKeyRange(e){return{lower:IndexedDBModel.keyFromIDBKey(e.lower),upper:IndexedDBModel.keyFromIDBKey(e.upper),lowerOpen:Boolean(e.lowerOpen),upperOpen:Boolean(e.upperOpen)}}static idbKeyPathFromKeyPath(e){let t;switch(e.type){case"null":t=null;break;case"string":t=e.string;break;case"array":t=e.array}return t}static keyPathStringFromIDBKeyPath(e){return"string"==typeof e?'"'+e+'"':e instanceof Array?'["'+e.join('", "')+'"]':null}enable(){if(!this.enabled){if(this.indexedDBAgent.invoke_enable(),this.securityOriginManager){this.securityOriginManager.addEventListener(SDK.SecurityOriginManager.Events.SecurityOriginAdded,this.securityOriginAdded,this),this.securityOriginManager.addEventListener(SDK.SecurityOriginManager.Events.SecurityOriginRemoved,this.securityOriginRemoved,this);for(const e of this.securityOriginManager.securityOrigins())this.addOrigin(e)}this.enabled=!0}}clearForOrigin(e){this.enabled&&this.databaseNamesBySecurityOrigin[e]&&(this.removeOrigin(e),this.addOrigin(e))}async deleteDatabase(e){this.enabled&&(await this.indexedDBAgent.invoke_deleteDatabase({securityOrigin:e.securityOrigin,databaseName:e.name}),this.loadDatabaseNames(e.securityOrigin))}async refreshDatabaseNames(){for(const e in this.databaseNamesBySecurityOrigin)await this.loadDatabaseNames(e);this.dispatchEventToListeners(Events.DatabaseNamesRefreshed)}refreshDatabase(e){this.loadDatabase(e,!0)}async clearObjectStore(e,t){await this.indexedDBAgent.invoke_clearObjectStore({securityOrigin:e.securityOrigin,databaseName:e.name,objectStoreName:t})}async deleteEntries(e,t,a){const i=IndexedDBModel.keyRangeFromIDBKeyRange(a);await this.indexedDBAgent.invoke_deleteObjectStoreEntries({securityOrigin:e.securityOrigin,databaseName:e.name,objectStoreName:t,keyRange:i})}securityOriginAdded(e){this.addOrigin(e.data)}securityOriginRemoved(e){this.removeOrigin(e.data)}addOrigin(e){console.assert(!this.databaseNamesBySecurityOrigin[e]),this.databaseNamesBySecurityOrigin[e]=[],this.loadDatabaseNames(e),this.isValidSecurityOrigin(e)&&this.storageAgent.invoke_trackIndexedDBForOrigin({origin:e})}removeOrigin(e){console.assert(Boolean(this.databaseNamesBySecurityOrigin[e]));for(let t=0;t<this.databaseNamesBySecurityOrigin[e].length;++t)this.databaseRemoved(e,this.databaseNamesBySecurityOrigin[e][t]);delete this.databaseNamesBySecurityOrigin[e],this.isValidSecurityOrigin(e)&&this.storageAgent.invoke_untrackIndexedDBForOrigin({origin:e})}isValidSecurityOrigin(e){const t=Common.ParsedURL.ParsedURL.fromString(e);return null!==t&&t.scheme.startsWith("http")}updateOriginDatabaseNames(e,t){const a=new Set(t),i=new Set(this.databaseNamesBySecurityOrigin[e]);this.databaseNamesBySecurityOrigin[e]=t;for(const t of i)a.has(t)||this.databaseRemoved(e,t);for(const t of a)i.has(t)||this.databaseAdded(e,t)}databases(){const e=[];for(const t in this.databaseNamesBySecurityOrigin){const a=this.databaseNamesBySecurityOrigin[t];for(let i=0;i<a.length;++i)e.push(new DatabaseId(t,a[i]))}return e}databaseAdded(e,t){const a=new DatabaseId(e,t);this.dispatchEventToListeners(Events.DatabaseAdded,{model:this,databaseId:a})}databaseRemoved(e,t){const a=new DatabaseId(e,t);this.dispatchEventToListeners(Events.DatabaseRemoved,{model:this,databaseId:a})}async loadDatabaseNames(e){const{databaseNames:t}=await this.indexedDBAgent.invoke_requestDatabaseNames({securityOrigin:e});return t&&this.databaseNamesBySecurityOrigin[e]?(this.updateOriginDatabaseNames(e,t),t):[]}async loadDatabase(e,t){const{databaseWithObjectStores:a}=await this.indexedDBAgent.invoke_requestDatabase({securityOrigin:e.securityOrigin,databaseName:e.name});if(!a)return;if(!this.databaseNamesBySecurityOrigin[e.securityOrigin])return;const i=new Database(e,a.version);this.databasesInternal.set(e,i);for(const e of a.objectStores){const t=IndexedDBModel.idbKeyPathFromKeyPath(e.keyPath),a=new ObjectStore(e.name,t,e.autoIncrement);for(let t=0;t<e.indexes.length;++t){const i=e.indexes[t],s=IndexedDBModel.idbKeyPathFromKeyPath(i.keyPath),r=new Index(i.name,s,i.unique,i.multiEntry);a.indexes.set(r.name,r)}i.objectStores.set(a.name,a)}this.dispatchEventToListeners(Events.DatabaseLoaded,{model:this,database:i,entriesUpdated:t})}loadObjectStoreData(e,t,a,i,s,r){this.requestData(e,e.name,t,"",a,i,s,r)}loadIndexData(e,t,a,i,s,r,n){this.requestData(e,e.name,t,a,i,s,r,n)}async requestData(e,t,a,i,s,r,n,d){const o=s?IndexedDBModel.keyRangeFromIDBKeyRange(s):void 0,c=await this.indexedDBAgent.invoke_requestData({securityOrigin:e.securityOrigin,databaseName:t,objectStoreName:a,indexName:i,skipCount:r,pageSize:n,keyRange:o});if(c.getError())return void console.error("IndexedDBAgent error: "+c.getError());const h=this.target().model(SDK.RuntimeModel.RuntimeModel);if(!h||!this.databaseNamesBySecurityOrigin[e.securityOrigin])return;const g=c.objectStoreDataEntries,y=[];for(const e of g){const t=h.createRemoteObject(e.key),a=h.createRemoteObject(e.primaryKey),i=h.createRemoteObject(e.value);y.push(new Entry(t,a,i))}d(y,c.hasMore)}async getMetadata(e,t){const a=e.securityOrigin,i=e.name,s=t.name,r=await this.indexedDBAgent.invoke_getMetadata({securityOrigin:a,databaseName:i,objectStoreName:s});return r.getError()?(console.error("IndexedDBAgent error: "+r.getError()),null):{entriesCount:r.entriesCount,keyGeneratorValue:r.keyGeneratorValue}}async refreshDatabaseList(e){const t=await this.loadDatabaseNames(e);for(const a of t)this.loadDatabase(new DatabaseId(e,a),!1)}indexedDBListUpdated({origin:e}){this.originsUpdated.add(e),this.throttler.schedule((()=>{const e=Array.from(this.originsUpdated,(e=>{this.refreshDatabaseList(e)}));return this.originsUpdated.clear(),Promise.all(e)}))}indexedDBContentUpdated({origin:e,databaseName:t,objectStoreName:a}){const i=new DatabaseId(e,t);this.dispatchEventToListeners(Events.IndexedDBContentUpdated,{databaseId:i,objectStoreName:a,model:this})}cacheStorageListUpdated(e){}cacheStorageContentUpdated(e){}}SDK.SDKModel.SDKModel.register(IndexedDBModel,{capabilities:SDK.Target.Capability.Storage,autostart:!1});export var Events;!function(e){e.DatabaseAdded="DatabaseAdded",e.DatabaseRemoved="DatabaseRemoved",e.DatabaseLoaded="DatabaseLoaded",e.DatabaseNamesRefreshed="DatabaseNamesRefreshed",e.IndexedDBContentUpdated="IndexedDBContentUpdated"}(Events||(Events={}));export class Entry{key;primaryKey;value;constructor(e,t,a){this.key=e,this.primaryKey=t,this.value=a}}export class DatabaseId{securityOrigin;name;constructor(e,t){this.securityOrigin=e,this.name=t}equals(e){return this.name===e.name&&this.securityOrigin===e.securityOrigin}}export class Database{databaseId;version;objectStores;constructor(e,t){this.databaseId=e,this.version=t,this.objectStores=new Map}}export class ObjectStore{name;keyPath;autoIncrement;indexes;constructor(e,t,a){this.name=e,this.keyPath=t,this.autoIncrement=a,this.indexes=new Map}get keyPathString(){return IndexedDBModel.keyPathStringFromIDBKeyPath(this.keyPath)}}export class Index{name;keyPath;unique;multiEntry;constructor(e,t,a,i){this.name=e,this.keyPath=t,this.unique=a,this.multiEntry=i}get keyPathString(){return IndexedDBModel.keyPathStringFromIDBKeyPath(this.keyPath)}}