import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as UI from"../../ui/legacy/legacy.js";import{DatabaseModel}from"./DatabaseModel.js";import{DOMStorageModel}from"./DOMStorageModel.js";import{IndexedDBModel}from"./IndexedDBModel.js";import storageViewStyles from"./storageView.css.js";const UIStrings={storageQuotaUsed:"{PH1} used out of {PH2} storage quota",storageQuotaUsedWithBytes:"{PH1} bytes used out of {PH2} bytes storage quota",storageWithCustomMarker:"{PH1} (custom)",storageTitle:"Storage",usage:"Usage",mb:"MB",learnMore:"Learn more",clearSiteData:"Clear site data",application:"Application",unregisterServiceWorker:"Unregister service workers",localAndSessionStorage:"Local and session storage",indexDB:"IndexedDB",webSql:"Web SQL",cookies:"Cookies",cache:"Cache",cacheStorage:"Cache storage",includingThirdPartyCookies:"including third-party cookies",sFailedToLoad:"{PH1} (failed to load)",internalError:"Internal error",pleaseEnterANumber:"Please enter a number",numberMustBeNonNegative:"Number must be non-negative",clearing:"Clearing...",storageQuotaIsLimitedIn:"Storage quota is limited in Incognito mode",fileSystem:"File System",other:"Other",storageUsage:"Storage usage",serviceWorkers:"Service Workers",simulateCustomStorage:"Simulate custom storage quota"},str_=i18n.i18n.registerUIStrings("panels/application/StorageView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class StorageView extends UI.ThrottledWidget.ThrottledWidget{pieColors;reportView;target;securityOrigin;settings;includeThirdPartyCookiesSetting;quotaRow;quotaUsage;pieChart;previousOverrideFieldValue;quotaOverrideCheckbox;quotaOverrideControlRow;quotaOverrideEditor;quotaOverrideErrorMessage;clearButton;constructor(){super(!0,1e3),this.contentElement.classList.add("clear-storage-container"),this.pieColors=new Map([["appcache","rgb(110, 161, 226)"],["cache_storage","rgb(229, 113, 113)"],["cookies","rgb(239, 196, 87)"],["indexeddb","rgb(155, 127, 230)"],["local_storage","rgb(116, 178, 102)"],["service_workers","rgb(255, 167, 36)"],["websql","rgb(203, 220, 56)"]]),this.reportView=new UI.ReportView.ReportView(i18nString(UIStrings.storageTitle)),this.reportView.element.classList.add("clear-storage-header"),this.reportView.show(this.contentElement),this.target=null,this.securityOrigin=null,this.settings=new Map;for(const e of AllStorageTypes)this.settings.set(e,Common.Settings.Settings.instance().createSetting("clear-storage-"+e,!0));this.includeThirdPartyCookiesSetting=Common.Settings.Settings.instance().createSetting("clear-storage-include-third-party-cookies",!1);const e=this.reportView.appendSection(i18nString(UIStrings.usage));this.quotaRow=e.appendSelectableRow(),this.quotaRow.classList.add("quota-usage-row");const t=e.appendRow(),i=UI.XLink.XLink.create("https://developer.chrome.com/docs/devtools/progressive-web-apps#opaque-responses",i18nString(UIStrings.learnMore));t.appendChild(i),this.quotaUsage=null,this.pieChart=new PerfUI.PieChart.PieChart,this.populatePieChart(0,[]);const r=e.appendRow();r.classList.add("usage-breakdown-row"),r.appendChild(this.pieChart),this.previousOverrideFieldValue="";const o=e.appendRow();this.quotaOverrideCheckbox=UI.UIUtils.CheckboxLabel.create(i18nString(UIStrings.simulateCustomStorage),!1,""),o.appendChild(this.quotaOverrideCheckbox),this.quotaOverrideCheckbox.checkboxElement.addEventListener("click",this.onClickCheckbox.bind(this),!1),this.quotaOverrideControlRow=e.appendRow(),this.quotaOverrideEditor=this.quotaOverrideControlRow.createChild("input","quota-override-notification-editor"),this.quotaOverrideControlRow.appendChild(UI.UIUtils.createLabel(i18nString(UIStrings.mb))),this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideEditor.addEventListener("keyup",(e=>{"Enter"===e.key&&(this.applyQuotaOverrideFromInputField(),e.consume(!0))})),this.quotaOverrideEditor.addEventListener("focusout",(e=>{this.applyQuotaOverrideFromInputField(),e.consume(!0)}));const s=e.appendRow();this.quotaOverrideErrorMessage=s.createChild("div","quota-override-error");const a=this.reportView.appendSection("","clear-storage-button").appendRow();this.clearButton=UI.UIUtils.createTextButton(i18nString(UIStrings.clearSiteData),this.clear.bind(this)),this.clearButton.id="storage-view-clear-button",a.appendChild(this.clearButton);const n=UI.SettingsUI.createSettingCheckbox(i18nString(UIStrings.includingThirdPartyCookies),this.includeThirdPartyCookiesSetting,!0);if(n.classList.add("include-third-party-cookies"),a.appendChild(n),(!globalThis).chii){const e=this.reportView.appendSection(i18nString(UIStrings.application));this.appendItem(e,i18nString(UIStrings.unregisterServiceWorker),"service_workers"),e.markFieldListAsGroup()}const g=this.reportView.appendSection(i18nString(UIStrings.storageTitle));if(this.appendItem(g,i18nString(UIStrings.localAndSessionStorage),"local_storage"),globalThis.chii||(this.appendItem(g,i18nString(UIStrings.indexDB),"indexeddb"),this.appendItem(g,i18nString(UIStrings.webSql),"websql")),this.appendItem(g,i18nString(UIStrings.cookies),"cookies"),g.markFieldListAsGroup(),!globalThis.chii){const e=this.reportView.appendSection(i18nString(UIStrings.cache));this.appendItem(e,i18nString(UIStrings.cacheStorage),"cache_storage"),e.markFieldListAsGroup()}SDK.TargetManager.TargetManager.instance().observeTargets(this)}appendItem(e,t,i){const r=e.appendRow(),o=this.settings.get(i);o&&r.appendChild(UI.SettingsUI.createSettingCheckbox(t,o,!0))}targetAdded(e){if(this.target)return;this.target=e;const t=e.model(SDK.SecurityOriginManager.SecurityOriginManager);this.updateOrigin(t.mainSecurityOrigin(),t.unreachableMainSecurityOrigin()),t.addEventListener(SDK.SecurityOriginManager.Events.MainSecurityOriginChanged,this.originChanged,this)}targetRemoved(e){if(this.target!==e)return;e.model(SDK.SecurityOriginManager.SecurityOriginManager).removeEventListener(SDK.SecurityOriginManager.Events.MainSecurityOriginChanged,this.originChanged,this)}originChanged(e){const{mainSecurityOrigin:t,unreachableMainSecurityOrigin:i}=e.data;this.updateOrigin(t,i)}updateOrigin(e,t){const i=this.securityOrigin;t?(this.securityOrigin=t,this.reportView.setSubtitle(i18nString(UIStrings.sFailedToLoad,{PH1:t}))):(this.securityOrigin=e,this.reportView.setSubtitle(e)),i!==this.securityOrigin&&(this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!1,this.quotaOverrideErrorMessage.textContent=""),this.doUpdate()}async applyQuotaOverrideFromInputField(){if(!this.target||!this.securityOrigin)return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.internalError));this.quotaOverrideErrorMessage.textContent="";const e=this.quotaOverrideEditor.value;if(""===e)return await this.clearQuotaForOrigin(this.target,this.securityOrigin),void(this.previousOverrideFieldValue="");const t=parseFloat(e);if(!Number.isFinite(t))return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.pleaseEnterANumber));if(t<0)return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.numberMustBeNonNegative));const i=1e6,r=Math.round(t*i),o=""+r/i;this.quotaOverrideEditor.value=o,this.previousOverrideFieldValue=o,await this.target.storageAgent().invoke_overrideQuotaForOrigin({origin:this.securityOrigin,quotaSize:r})}async clearQuotaForOrigin(e,t){await e.storageAgent().invoke_overrideQuotaForOrigin({origin:t})}async onClickCheckbox(){this.quotaOverrideControlRow.classList.contains("hidden")?(this.quotaOverrideControlRow.classList.remove("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!0,this.quotaOverrideEditor.value=this.previousOverrideFieldValue,this.quotaOverrideEditor.focus()):this.target&&this.securityOrigin&&(this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!1,await this.clearQuotaForOrigin(this.target,this.securityOrigin),this.quotaOverrideErrorMessage.textContent="")}clear(){if(!this.securityOrigin)return;const e=[];for(const t of this.settings.keys()){const i=this.settings.get(t);i&&i.get()&&e.push(t)}if(this.target){const t=this.includeThirdPartyCookiesSetting.get();StorageView.clear(this.target,this.securityOrigin,e,t)}this.clearButton.disabled=!0;const t=this.clearButton.textContent;this.clearButton.textContent=i18nString(UIStrings.clearing),setTimeout((()=>{this.clearButton.disabled=!1,this.clearButton.textContent=t,this.clearButton.focus()}),500)}static clear(e,t,i,r){e.storageAgent().invoke_clearDataForOrigin({origin:t,storageTypes:i.join(",")});const o=new Set(i),s=o.has("all");if(o.has("cookies")||s){const i=e.model(SDK.CookieModel.CookieModel);i&&i.clear(void 0,r?void 0:t)}if(o.has("indexeddb")||s)for(const e of SDK.TargetManager.TargetManager.instance().targets()){const i=e.model(IndexedDBModel);i&&i.clearForOrigin(t)}if(o.has("local_storage")||s){const i=e.model(DOMStorageModel);i&&i.clearForOrigin(t)}if(o.has("websql")||s){const t=e.model(DatabaseModel);t&&(t.disable(),t.enable())}if(o.has("cache_storage")||s){const e=SDK.TargetManager.TargetManager.instance().mainTarget(),i=e&&e.model(SDK.ServiceWorkerCacheModel.ServiceWorkerCacheModel);i&&i.clearForOrigin(t)}}async doUpdate(){if(!this.securityOrigin||!this.target)return this.quotaRow.textContent="",void this.populatePieChart(0,[]);const e=this.securityOrigin,t=await this.target.storageAgent().invoke_getUsageAndQuota({origin:e});if(this.quotaRow.textContent="",t.getError())return void this.populatePieChart(0,[]);const i=t.overrideActive,r=Platform.NumberUtilities.bytesToString(t.quota),o=Platform.NumberUtilities.bytesToString(t.usage),s=i18nString(UIStrings.storageWithCustomMarker,{PH1:r}),a=i?UI.Fragment.Fragment.build`<b>${s}</b>`.element():r,n=i18n.i18n.getFormatLocalizedString(str_,UIStrings.storageQuotaUsed,{PH1:o,PH2:a});if(this.quotaRow.appendChild(n),UI.Tooltip.Tooltip.install(this.quotaRow,i18nString(UIStrings.storageQuotaUsedWithBytes,{PH1:t.usage.toLocaleString(),PH2:t.quota.toLocaleString()})),!t.overrideActive&&t.quota<125829120&&(UI.Tooltip.Tooltip.install(this.quotaRow,i18nString(UIStrings.storageQuotaIsLimitedIn)),this.quotaRow.appendChild(UI.Icon.Icon.create("smallicon-info"))),null===this.quotaUsage||this.quotaUsage!==t.usage){this.quotaUsage=t.usage;const e=[];for(const i of t.usageBreakdown.sort(((e,t)=>t.usage-e.usage))){const t=i.usage;if(!t)continue;const r=this.getStorageTypeName(i.storageType),o=this.pieColors.get(i.storageType)||"#ccc";e.push({value:t,color:o,title:r})}this.populatePieChart(t.usage,e)}this.update()}populatePieChart(e,t){this.pieChart.data={chartName:i18nString(UIStrings.storageUsage),size:110,formatter:Platform.NumberUtilities.bytesToString,showLegend:!0,total:e,slices:t}}getStorageTypeName(e){switch(e){case"file_systems":return i18nString(UIStrings.fileSystem);case"websql":return i18nString(UIStrings.webSql);case"appcache":return i18nString(UIStrings.application);case"indexeddb":return i18nString(UIStrings.indexDB);case"cache_storage":return i18nString(UIStrings.cacheStorage);case"service_workers":return i18nString(UIStrings.serviceWorkers);default:return i18nString(UIStrings.other)}}wasShown(){super.wasShown(),this.reportView.registerCSSFiles([storageViewStyles]),this.registerCSSFiles([storageViewStyles])}}export const AllStorageTypes=["appcache","cache_storage","cookies","indexeddb","local_storage","service_workers","websql"];let actionDelegateInstance;export class ActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return actionDelegateInstance&&!t||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(e,t){switch(t){case"resources.clear":return this.handleClear(!1);case"resources.clear-incl-third-party-cookies":return this.handleClear(!0)}return!1}handleClear(e){const t=SDK.TargetManager.TargetManager.instance().mainTarget();if(!t)return!1;const i=t.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!i)return!1;const r=i.getMainSecurityOrigin();return!!r&&(StorageView.clear(t,r,AllStorageTypes,e),!0)}}