import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as CodeMirror from"../../third_party/codemirror.next/codemirror.next.js";import*as TextEditor from"../../ui/components/text_editor/text_editor.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import*as UI from"../../ui/legacy/legacy.js";import{ConsolePanel}from"./ConsolePanel.js";import consolePromptStyles from"./consolePrompt.css.js";const UIStrings={consolePrompt:"Console prompt"},str_=i18n.i18n.registerUIStrings("panels/console/ConsolePrompt.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ConsolePrompt extends(Common.ObjectWrapper.eventMixin(UI.Widget.Widget)){addCompletionsFromHistory;historyInternal;initialText;editor;eagerPreviewElement;textChangeThrottler;formatter;requestPreviewBound;requestPreviewCurrent=0;innerPreviewElement;promptIcon;iconThrottler;eagerEvalSetting;previewRequestForTest;highlightingNode;constructor(){super(),this.addCompletionsFromHistory=!0,this.historyInternal=new ConsoleHistoryManager,this.initialText="",this.eagerPreviewElement=document.createElement("div"),this.eagerPreviewElement.classList.add("console-eager-preview"),this.textChangeThrottler=new Common.Throttler.Throttler(150),this.formatter=new ObjectUI.RemoteObjectPreviewFormatter.RemoteObjectPreviewFormatter,this.requestPreviewBound=this.requestPreview.bind(this),this.innerPreviewElement=this.eagerPreviewElement.createChild("div","console-eager-inner-preview"),this.eagerPreviewElement.appendChild(UI.Icon.Icon.create("smallicon-command-result","preview-result-icon"));const t=this.element.createChild("div","console-prompt-editor-container");this.element.appendChild(this.eagerPreviewElement),this.promptIcon=UI.Icon.Icon.create("smallicon-text-prompt","console-prompt-icon"),this.element.appendChild(this.promptIcon),this.iconThrottler=new Common.Throttler.Throttler(0),this.eagerEvalSetting=Common.Settings.Settings.instance().moduleSetting("consoleEagerEval"),this.eagerEvalSetting.addChangeListener(this.eagerSettingChanged.bind(this)),this.eagerPreviewElement.classList.toggle("hidden",!this.eagerEvalSetting.get()),this.element.tabIndex=0,this.previewRequestForTest=null,this.highlightingNode=!1;const e=CodeMirror.EditorState.create({doc:this.initialText,extensions:[CodeMirror.keymap.of(this.editorKeymap()),CodeMirror.EditorView.updateListener.of((t=>this.editorUpdate(t))),TextEditor.JavaScript.argumentHints(),TextEditor.JavaScript.completion(),TextEditor.Config.showCompletionHint,CodeMirror.javascript.javascript(),TextEditor.Config.baseConfiguration(this.initialText),TextEditor.Config.autocompletion,CodeMirror.javascript.javascriptLanguage.data.of({autocomplete:t=>this.historyCompletions(t)}),CodeMirror.EditorView.contentAttributes.of({"aria-label":i18nString(UIStrings.consolePrompt)}),CodeMirror.EditorView.lineWrapping,CodeMirror.autocompletion({aboveCursor:!0})]});this.editor=new TextEditor.TextEditor.TextEditor(e),this.editor.addEventListener("keydown",(t=>{t.defaultPrevented&&t.stopPropagation()})),t.appendChild(this.editor),this.hasFocus()&&this.focus(),this.element.removeAttribute("tabindex"),this.editorSetForTest(),Host.userMetrics.panelLoaded("console","DevTools.Launch.Console")}eagerSettingChanged(){const t=this.eagerEvalSetting.get();this.eagerPreviewElement.classList.toggle("hidden",!t),t&&this.requestPreview()}belowEditorElement(){return this.eagerPreviewElement}onTextChanged(){if(this.eagerEvalSetting.get()){const t=!TextEditor.Config.contentIncludingHint(this.editor.editor);this.previewRequestForTest=this.textChangeThrottler.schedule(this.requestPreviewBound,t)}this.updatePromptIcon(),this.dispatchEventToListeners("TextChanged")}async requestPreview(){const t=++this.requestPreviewCurrent,e=TextEditor.Config.contentIncludingHint(this.editor.editor).trim(),o=UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext),{preview:i,result:r}=await ObjectUI.JavaScriptREPL.JavaScriptREPL.evaluateAndBuildPreview(e,!0,!0,500);this.requestPreviewCurrent===t&&(this.innerPreviewElement.removeChildren(),i.deepTextContent()!==TextEditor.Config.contentIncludingHint(this.editor.editor).trim()&&this.innerPreviewElement.appendChild(i),r&&"object"in r&&r.object&&"node"===r.object.subtype?(this.highlightingNode=!0,SDK.OverlayModel.OverlayModel.highlightObjectAsDOMNode(r.object)):this.highlightingNode&&(this.highlightingNode=!1,SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()),r&&o&&o.runtimeModel.releaseEvaluationResult(r))}wasShown(){super.wasShown(),this.registerCSSFiles([consolePromptStyles])}willHide(){this.highlightingNode&&(this.highlightingNode=!1,SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight())}history(){return this.historyInternal}clearAutocomplete(){CodeMirror.closeCompletion(this.editor.editor)}isCaretAtEndOfPrompt(){return this.editor.state.selection.main.head===this.editor.state.doc.length}moveCaretToEndOfPrompt(){this.editor.dispatch({selection:CodeMirror.EditorSelection.cursor(this.editor.state.doc.length)})}clear(){this.editor.dispatch({changes:{from:0,to:this.editor.state.doc.length}})}text(){return this.editor.state.doc.toString()}setAddCompletionsFromHistory(t){this.addCompletionsFromHistory=t}editorKeymap(){return[{key:"ArrowUp",run:()=>this.moveHistory(-1)},{key:"ArrowDown",run:()=>this.moveHistory(1)},{mac:"Ctrl-p",run:()=>this.moveHistory(-1,!0)},{mac:"Ctrl-n",run:()=>this.moveHistory(1,!0)},{key:"Enter",run:()=>this.evaluate(),shift:CodeMirror.insertNewlineAndIndent}]}moveHistory(t,e=!1){const{editor:o}=this.editor,{main:i}=o.state.selection;if(!e){if(!i.empty)return!1;const e=o.coordsAtPos(i.head),r=o.coordsAtPos(t<0?0:o.state.doc.length);if(e&&r&&(t<0?e.top>r.top+5:e.bottom<r.bottom-5))return!1}const r=this.historyInternal,s=t<0?r.previous(this.text()):r.next();if(void 0===s)return!1;const n=t<0?s.search(/\n|$/):s.length;return this.editor.dispatch({changes:{from:0,to:this.editor.state.doc.length,insert:s},selection:CodeMirror.EditorSelection.cursor(n),scrollIntoView:!0}),!0}enterWillEvaluate(){const{state:t}=this.editor;return t.doc.length>0&&TextEditor.JavaScript.isExpressionComplete(t)}evaluate(){if(this.enterWillEvaluate())this.appendCommand(this.text(),!0),this.editor.dispatch({changes:{from:0,to:this.editor.state.doc.length},scrollIntoView:!0});else{if(this.editor.state.doc.length)return CodeMirror.insertNewlineAndIndent(this.editor.editor);this.editor.dispatch({scrollIntoView:!0})}return this.enterProcessedForTest(),!0}updatePromptIcon(){this.iconThrottler.schedule((async()=>{this.promptIcon.classList.toggle("console-prompt-incomplete",!this.enterWillEvaluate())}))}appendCommand(t,e){const o=UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext);if(o){const i=o,r=SDK.ConsoleModel.ConsoleModel.instance().addCommandMessage(i,t),s=ObjectUI.JavaScriptREPL.JavaScriptREPL.preprocessExpression(t);SDK.ConsoleModel.ConsoleModel.instance().evaluateCommandInConsole(i,r,s,e),ConsolePanel.instance().isShowing()&&Host.userMetrics.actionTaken(Host.UserMetrics.Action.CommandEvaluatedInConsolePanel)}}enterProcessedForTest(){}editorUpdate(t){t.docChanged||CodeMirror.selectedCompletion(t.state)!==CodeMirror.selectedCompletion(t.startState)?this.onTextChanged():t.selectionSet&&this.updatePromptIcon()}historyCompletions(t){const e=this.text();if(!this.addCompletionsFromHistory||!this.isCaretAtEndOfPrompt()||!e.length&&!t.explicit)return null;const o=[],i=new Set,r=this.historyInternal.historyData();for(let t=r.length-1;t>=0&&o.length<50;--t){const s=r[t];s.startsWith(e)&&(i.has(s)||(i.add(s),o.push({label:s,type:"secondary",boost:-1e5})))}return o.length?{from:0,to:e.length,options:o}:null}focus(){this.editor.focus()}editorSetForTest(){}}export class ConsoleHistoryManager{data;historyOffset;uncommittedIsTop;constructor(){this.data=[],this.historyOffset=1}historyData(){return this.data}setHistoryData(t){this.data=t.slice(),this.historyOffset=1}pushHistoryItem(t){this.uncommittedIsTop&&(this.data.pop(),delete this.uncommittedIsTop),this.historyOffset=1,t!==this.currentHistoryItem()&&this.data.push(t)}pushCurrentText(t){this.uncommittedIsTop&&this.data.pop(),this.uncommittedIsTop=!0,this.data.push(t)}previous(t){if(!(this.historyOffset>this.data.length))return 1===this.historyOffset&&this.pushCurrentText(t),++this.historyOffset,this.currentHistoryItem()}next(){if(1!==this.historyOffset)return--this.historyOffset,this.currentHistoryItem()}currentHistoryItem(){return this.data[this.data.length-this.historyOffset]}}