import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Logs from"../../models/logs/logs.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Workspace from"../../models/workspace/workspace.js";import*as CodeHighlighter from"../../ui/components/code_highlighter/code_highlighter.js";import*as IssueCounter from"../../ui/components/issue_counter/issue_counter.js";import*as RequestLinkIcon from"../../ui/components/request_link_icon/request_link_icon.js";import*as DataGrid from"../../ui/legacy/components/data_grid/data_grid.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import*as ThemeSupport from"../../ui/legacy/theme_support/theme_support.js";import objectValueStyles from"../../ui/legacy/components/object_ui/objectValue.css.js";import consoleViewStyles from"./consoleView.css.js";const UIStrings={consoleclearWasPreventedDueTo:"`console.clear()` was prevented due to 'Preserve log'",consoleWasCleared:"Console was cleared",clearAllMessagesWithS:"Clear all messages with {PH1}",assertionFailed:"Assertion failed: ",violationS:"`[Violation]` {PH1}",interventionS:"`[Intervention]` {PH1}",deprecationS:"`[Deprecation]` {PH1}",thisValueWillNotBeCollectedUntil:"This value will not be collected until console is cleared.",thisValueWasEvaluatedUponFirst:"This value was evaluated upon first expanding. It may have changed since then.",functionWasResolvedFromBound:"Function was resolved from bound function.",exception:"<exception>",warning:"Warning",error:"Error",repeatS:"{n, plural, =1 {Repeated # time} other {Repeated # times}}",warningS:"{n, plural, =1 {Warning, Repeated # time} other {Warning, Repeated # times}}",errorS:"{n, plural, =1 {Error, Repeated # time} other {Error, Repeated # times}}",url:"<URL>",tookNms:"took <N>ms",someEvent:"<some> event",Mxx:" M<XX>",attribute:"<attribute>",index:"(index)",value:"Value",console:"Console",stackMessageExpanded:"Stack table expanded",stackMessageCollapsed:"Stack table collapsed"},str_=i18n.i18n.registerUIStrings("panels/console/ConsoleViewMessage.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),elementToMessage=new WeakMap;export const getMessageForElement=e=>elementToMessage.get(e);const defaultConsoleRowHeight=19,parameterToRemoteObject=e=>t=>t instanceof SDK.RemoteObject.RemoteObject?t:e?"object"==typeof t?e.createRemoteObject(t):e.createRemoteObjectFromPrimitiveValue(t):SDK.RemoteObject.RemoteObject.fromLocalObject(t);export class ConsoleViewMessage{message;linkifier;repeatCountInternal;closeGroupDecorationCount;nestingLevelInternal;selectableChildren;messageResized;elementInternal;previewFormatter;searchRegexInternal;messageLevelIcon;traceExpanded;expandTrace;anchorElement;contentElementInternal;nestingLevelMarkers;searchHighlightNodes;searchHighlightNodeChanges;isVisibleInternal;cachedHeight;messagePrefix;timestampElement;inSimilarGroup;similarGroupMarker;lastInSimilarGroup;groupKeyInternal;repeatCountElement;requestResolver;issueResolver;constructor(e,t,s,n,i,r){this.message=e,this.linkifier=t,this.requestResolver=s,this.issueResolver=n,this.repeatCountInternal=1,this.closeGroupDecorationCount=0,this.nestingLevelInternal=i,this.selectableChildren=[],this.messageResized=r,this.elementInternal=null,this.previewFormatter=new ObjectUI.RemoteObjectPreviewFormatter.RemoteObjectPreviewFormatter,this.searchRegexInternal=null,this.messageLevelIcon=null,this.traceExpanded=!1,this.expandTrace=null,this.anchorElement=null,this.contentElementInternal=null,this.nestingLevelMarkers=null,this.searchHighlightNodes=[],this.searchHighlightNodeChanges=[],this.isVisibleInternal=!1,this.cachedHeight=0,this.messagePrefix="",this.timestampElement=null,this.inSimilarGroup=!1,this.similarGroupMarker=null,this.lastInSimilarGroup=!1,this.groupKeyInternal="",this.repeatCountElement=null}element(){return this.toMessageElement()}wasShown(){this.isVisibleInternal=!0}onResize(){}willHide(){this.isVisibleInternal=!1,this.cachedHeight=this.element().offsetHeight}isVisible(){return this.isVisibleInternal}fastHeight(){return this.cachedHeight?this.cachedHeight:this.approximateFastHeight()}approximateFastHeight(){return 19}consoleMessage(){return this.message}buildMessage(){let e,t=this.message.messageText;if(this.message.source===SDK.ConsoleModel.FrontendMessageSource.ConsoleAPI)switch(this.message.type){case"trace":e=this.format(this.message.parameters||["console.trace"]);break;case"clear":e=document.createElement("span"),e.classList.add("console-info"),Common.Settings.Settings.instance().moduleSetting("preserveConsoleLog").get()?e.textContent=i18nString(UIStrings.consoleclearWasPreventedDueTo):e.textContent=i18nString(UIStrings.consoleWasCleared),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.clearAllMessagesWithS,{PH1:String(UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("console.clear"))}));break;case"dir":{const t=["%O",this.message.parameters?this.message.parameters[0]:void 0];e=this.format(t);break}case"profile":case"profileEnd":e=this.format([t]);break;default:{if("assert"===this.message.type&&(this.messagePrefix=i18nString(UIStrings.assertionFailed)),this.message.parameters&&1===this.message.parameters.length){const t=this.message.parameters[0];"string"!=typeof t&&"string"===t.type&&(e=this.tryFormatAsError(t.value))}const s=this.message.parameters||[t];e=e||this.format(s)}}else if("network"===this.message.source)e=this.formatAsNetworkRequest()||this.format([t]);else{const s=this.message.parameters&&t===this.message.parameters[0];"violation"===this.message.source?t=i18nString(UIStrings.violationS,{PH1:t}):"intervention"===this.message.source?t=i18nString(UIStrings.interventionS,{PH1:t}):"deprecation"===this.message.source&&(t=i18nString(UIStrings.deprecationS,{PH1:t}));const n=this.message.parameters||[t];s&&(n[0]=t),e=this.format(n)}e.classList.add("console-message-text");const s=document.createElement("span");return s.classList.add("source-code"),this.anchorElement=this.buildMessageAnchor(),this.anchorElement&&s.appendChild(this.anchorElement),s.appendChild(e),s}formatAsNetworkRequest(){const e=Logs.NetworkLog.NetworkLog.requestForConsoleMessage(this.message);if(!e)return null;const t=document.createElement("span");if("error"===this.message.level){UI.UIUtils.createTextChild(t,e.requestMethod+" ");const s=Components.Linkifier.Linkifier.linkifyRevealable(e,e.url(),e.url());s.tabIndex=-1,this.selectableChildren.push({element:s,forceSelect:()=>s.focus()}),t.appendChild(s),e.failed&&UI.UIUtils.createTextChildren(t," ",e.localizedFailDescription||""),0!==e.statusCode&&UI.UIUtils.createTextChildren(t," ",String(e.statusCode)),e.statusText&&UI.UIUtils.createTextChildren(t," (",e.statusText,")")}else{const s=this.message.messageText,n=this.linkifyWithCustomLinkifier(s,((t,s,n,i)=>{const r=s===e.url()?Components.Linkifier.Linkifier.linkifyRevealable(e,s,e.url()):Components.Linkifier.Linkifier.linkifyURL(s,{text:t,lineNumber:n,columnNumber:i});return r.tabIndex=-1,this.selectableChildren.push({element:r,forceSelect:()=>r.focus()}),r}));t.appendChild(n)}return t}createAffectedResourceLinks(){const e=[],t=this.message.getAffectedResources()?.requestId;if(t){const s=new RequestLinkIcon.RequestLinkIcon.RequestLinkIcon;s.classList.add("resource-links"),s.data={affectedRequest:{requestId:t},requestResolver:this.requestResolver,displayURL:!1},e.push(s)}const s=this.message.getAffectedResources()?.issueId;if(s){const t=new IssueCounter.IssueLinkIcon.IssueLinkIcon;t.classList.add("resource-links"),t.data={issueId:s,issueResolver:this.issueResolver},e.push(t)}return e}buildMessageAnchor(){const e=(e=>e.scriptId?this.linkifyScriptId(e.scriptId,e.url||"",e.line,e.column):e.stackTrace&&e.stackTrace.callFrames.length?this.linkifyStackTraceTopFrame(e.stackTrace):e.url&&"undefined"!==e.url?this.linkifyLocation(e.url,e.line,e.column):null)(this.message);if(e){e.tabIndex=-1,this.selectableChildren.push({element:e,forceSelect:()=>e.focus()});const t=document.createElement("span");t.classList.add("console-message-anchor"),t.appendChild(e);for(const e of this.createAffectedResourceLinks())UI.UIUtils.createTextChild(t," "),t.append(e);return UI.UIUtils.createTextChild(t," "),t}return null}buildMessageWithStackTrace(e){const t=document.createElement("div");t.classList.add("console-message-stack-trace-toggle");const s=t.createChild("div","console-message-stack-trace-wrapper"),n=this.buildMessage(),i=UI.Icon.Icon.create("smallicon-triangle-right","console-message-expand-icon"),r=s.createChild("div");UI.ARIAUtils.setExpanded(r,!1),r.appendChild(i),r.tabIndex=-1,r.appendChild(n);const o=s.createChild("div"),a=Components.JSPresentationUtils.buildStackTracePreviewContents(e.target(),this.linkifier,{stackTrace:this.message.stackTrace,tabStops:void 0});o.appendChild(a.element);for(const e of a.links)this.selectableChildren.push({element:e,forceSelect:()=>e.focus()});o.classList.add("hidden"),UI.ARIAUtils.setAccessibleName(s,`${n.textContent} ${i18nString(UIStrings.stackMessageCollapsed)}`),UI.ARIAUtils.markAsGroup(o),this.expandTrace=e=>{i.setIconType(e?"smallicon-triangle-down":"smallicon-triangle-right"),o.classList.toggle("hidden",!e);const t=i18nString(e?UIStrings.stackMessageExpanded:UIStrings.stackMessageCollapsed);UI.ARIAUtils.setAccessibleName(s,`${n.textContent} ${t}`),UI.ARIAUtils.alert(t),UI.ARIAUtils.setExpanded(r,e),this.traceExpanded=e};return r.addEventListener("click",(e=>{UI.UIUtils.isEditing()||s.hasSelection()||(this.expandTrace&&this.expandTrace(o.classList.contains("hidden")),e.consume())}),!1),"trace"===this.message.type&&this.expandTrace(!0),t._expandStackTraceForTest=this.expandTrace.bind(this,!0),t}linkifyLocation(e,t,s){const n=this.message.runtimeModel();return n?this.linkifier.linkifyScriptLocation(n.target(),null,e,t,{columnNumber:s,className:void 0,tabStop:void 0,inlineFrameIndex:0}):null}linkifyStackTraceTopFrame(e){const t=this.message.runtimeModel();return t?this.linkifier.linkifyStackTraceTopFrame(t.target(),e):null}linkifyScriptId(e,t,s,n){const i=this.message.runtimeModel();return i?this.linkifier.linkifyScriptLocation(i.target(),e,t,s,{columnNumber:n,className:void 0,tabStop:void 0,inlineFrameIndex:0}):null}format(e){const t=document.createElement("span");if(this.messagePrefix&&(t.createChild("span").textContent=this.messagePrefix),!e.length)return t;let s=e.map(parameterToRemoteObject(this.message.runtimeModel()));const n="string"===SDK.RemoteObject.RemoteObject.type(s[0])&&(this.message.type!==SDK.ConsoleModel.FrontendMessageType.Result||"error"===this.message.level);if(n){const e=this.formatWithSubstitutionString(s[0].description,s.slice(1),t);s=Array.from(e.unusedSubstitutions||[]),s.length&&UI.UIUtils.createTextChild(t," ")}for(let e=0;e<s.length;++e)n&&"string"===s[e].type?t.appendChild(this.linkifyStringAsFragment(s[e].description||"")):t.appendChild(this.formatParameter(s[e],!1,!0)),e<s.length-1&&UI.UIUtils.createTextChild(t," ");return t}formatParameter(e,t,s){if(e.customPreview())return new ObjectUI.CustomPreviewComponent.CustomPreviewComponent(e).element;const n=t?"object":e.subtype||e.type;let i;switch(n){case"error":i=this.formatParameterAsError(e);break;case"function":i=this.formatParameterAsFunction(e,s);break;case"array":case"arraybuffer":case"blob":case"dataview":case"generator":case"iterator":case"map":case"object":case"promise":case"proxy":case"set":case"typedarray":case"wasmvalue":case"weakmap":case"weakset":case"webassemblymemory":i=this.formatParameterAsObject(e,s);break;case"node":i=e.isNode()?this.formatParameterAsNode(e):this.formatParameterAsObject(e,!1);break;case"trustedtype":i=this.formatParameterAsObject(e,!1);break;case"string":i=this.formatParameterAsString(e);break;case"boolean":case"date":case"null":case"number":case"regexp":case"symbol":case"undefined":case"bigint":i=this.formatParameterAsValue(e);break;default:i=this.formatParameterAsValue(e),console.error(`Tried to format remote object of unknown type ${n}.`)}return i.classList.add(`object-value-${n}`),i.classList.add("source-code"),i}formatParameterAsValue(e){const t=document.createElement("span"),s=e.description||"";if(s.length>getMaxTokenizableStringLength()){const e=new ObjectUI.ObjectPropertiesSection.ExpandableTextPropertyValue(document.createElement("span"),s,getLongStringVisibleLength());t.appendChild(e.element)}else UI.UIUtils.createTextChild(t,s);return t.addEventListener("contextmenu",this.contextMenuEventFired.bind(this,e),!1),t}formatParameterAsTrustedType(e){const t=document.createElement("span"),s=document.createElement("span");return s.appendChild(this.formatParameterAsString(e)),s.classList.add("object-value-string"),UI.UIUtils.createTextChild(t,`${e.className} `),t.appendChild(s),t}formatParameterAsObject(e,t){const s=document.createElement("span");if(s.classList.add("console-object"),t&&e.preview)s.classList.add("console-object-preview"),this.previewFormatter.appendObjectPreview(s,e.preview,!1);else if("function"===e.type){const t=s.createChild("span");ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.formatObjectAsFunction(e,t,!1),s.classList.add("object-value-function")}else"trustedtype"===e.subtype?s.appendChild(this.formatParameterAsTrustedType(e)):UI.UIUtils.createTextChild(s,e.description||"");if(!e.hasChildren||e.customPreview())return s;const n=s.createChild("span","object-state-note info-note");this.message.type===SDK.ConsoleModel.FrontendMessageType.QueryObjectResult?UI.Tooltip.Tooltip.install(n,i18nString(UIStrings.thisValueWillNotBeCollectedUntil)):UI.Tooltip.Tooltip.install(n,i18nString(UIStrings.thisValueWasEvaluatedUponFirst));const i=new ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection(e,s,this.linkifier);return i.element.classList.add("console-view-object-properties-section"),i.enableContextMenu(),i.setShowSelectionOnKeyboardFocus(!0,!0),this.selectableChildren.push(i),i.addEventListener(UI.TreeOutline.Events.ElementAttached,this.messageResized),i.addEventListener(UI.TreeOutline.Events.ElementExpanded,this.messageResized),i.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this.messageResized),i.element}formatParameterAsFunction(e,t){const s=document.createElement("span");return SDK.RemoteObject.RemoteFunction.objectAsFunction(e).targetFunction().then(function(n){const i=document.createElement("span"),r=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.formatObjectAsFunction(n,i,!0,t);if(s.appendChild(i),n!==e){const e=s.createChild("span","object-state-note info-note");UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.functionWasResolvedFromBound))}s.addEventListener("contextmenu",this.contextMenuEventFired.bind(this,n),!1),r.then((()=>this.formattedParameterAsFunctionForTest()))}.bind(this)),s}formattedParameterAsFunctionForTest(){}contextMenuEventFired(e,t){const s=new UI.ContextMenu.ContextMenu(t);s.appendApplicableItems(e),s.show()}renderPropertyPreviewOrAccessor(e,t,s){return"accessor"===t.type?this.formatAsAccessorProperty(e,s.map((e=>e.name.toString())),!1):this.previewFormatter.renderPropertyPreview(t.type,"subtype"in t?t.subtype:void 0,null,t.value)}formatParameterAsNode(e){const t=document.createElement("span"),s=e.runtimeModel().target().model(SDK.DOMModel.DOMModel);return s?(s.pushObjectAsNodeToFrontend(e).then((async s=>{if(!s)return void t.appendChild(this.formatParameterAsObject(e,!1));const n=await UI.UIUtils.Renderer.render(s);n?(n.tree&&(this.selectableChildren.push(n.tree),n.tree.addEventListener(UI.TreeOutline.Events.ElementAttached,this.messageResized),n.tree.addEventListener(UI.TreeOutline.Events.ElementExpanded,this.messageResized),n.tree.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this.messageResized)),t.appendChild(n.node)):t.appendChild(this.formatParameterAsObject(e,!1)),this.formattedParameterAsNodeForTest()})),t):t}formattedParameterAsNodeForTest(){}formatParameterAsString(e){const t=e.description??"",s=Platform.StringUtilities.formatAsJSLiteral(t),n=document.createElement("span");return n.addEventListener("contextmenu",this.contextMenuEventFired.bind(this,e),!1),n.appendChild(this.linkifyStringAsFragment(s)),n}formatParameterAsError(e){const t=document.createElement("span"),s=this.tryFormatAsError(e.description||"");return t.appendChild(s||this.linkifyStringAsFragment(e.description||"")),t}formatAsArrayEntry(e){return this.previewFormatter.renderPropertyPreview(e.type,e.subtype,e.className,e.description)}formatAsAccessorProperty(e,t,s){const n=ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement.createRemoteObjectAccessorPropertySpan(e,t,function(e){const t=e.wasThrown,i=e.object;if(!i)return;if(n.removeChildren(),t){const e=n.createChild("span");e.textContent=i18nString(UIStrings.exception),UI.Tooltip.Tooltip.install(e,i.description)}else if(s)n.appendChild(this.formatAsArrayEntry(i));else{const e=100,t=i.type,s=i.subtype;let r="";"function"!==t&&i.description&&(r="string"===t||"regexp"===s||"trustedtype"===s?Platform.StringUtilities.trimMiddle(i.description,e):Platform.StringUtilities.trimEndWithMaxLength(i.description,e)),n.appendChild(this.previewFormatter.renderPropertyPreview(t,s,i.className,r))}}.bind(this));return n}formatWithSubstitutionString(e,t,s){function n(e,t,s){return s instanceof SDK.RemoteObject.RemoteObject?this.formatParameter(s,e,t):i(s)}function i(e){if(void 0!==e)return"string"==typeof e?e:e.description}function r(e){if(e instanceof SDK.RemoteObject.RemoteObject)return"bigint"===e.type?e.description:"number"!=typeof e.value?"NaN":Math.floor(e.value)}let o=null;function a(e){const t=["background","border","color","font","line","margin","padding","text","-webkit-background","-webkit-border","-webkit-font","-webkit-margin","-webkit-padding","-webkit-text"];for(const s of t)if(e.startsWith(s))return!0;return!1}const l={};function c(e){if(o)for(const[t,{value:s,priority:n}]of o.entries())e.style.setProperty(t,s,n)}return l.o=n.bind(this,!1,!0),l.s=i,l.f=function(e){if(e instanceof SDK.RemoteObject.RemoteObject)return"number"!=typeof e.value?"NaN":e.value},l.i=r,l.d=r,l.c=function(e){o=new Map;const t=document.createElement("span");if(void 0!==e&&"string"!=typeof e&&e.description){t.setAttribute("style",e.description);for(const e of t.style)if(a(e)){const s={value:t.style.getPropertyValue(e),priority:t.style.getPropertyPriority(e)};o.set(e,s)}}},l.O=n.bind(this,!0,!1),l._=function(e){return e instanceof Node?e:""},Platform.StringUtilities.format(e,t,l,s,function(e,t){if(t instanceof Node)return e.appendChild(t),e;if(void 0===t)return e;if(!o)return e.appendChild(this.linkifyStringAsFragment(String(t))),e;const s=String(t).split("\n");for(let t=0;t<s.length;t++){const n=s[t],i=this.linkifyStringAsFragment(n),r=document.createElement("span");r.style.setProperty("contain","paint"),r.style.setProperty("display","inline-block"),r.style.setProperty("max-width","100%"),r.appendChild(i),c(r);for(const e of r.children)e.classList.contains("devtools-link")&&e instanceof HTMLElement&&this.applyForcedVisibleStyle(e);e.appendChild(r),t<s.length-1&&e.appendChild(document.createElement("br"))}return e}.bind(this))}applyForcedVisibleStyle(e){e.style.setProperty("-webkit-text-stroke","0","important"),e.style.setProperty("text-decoration","underline","important");const t=ThemeSupport.ThemeSupport.instance().patchColorText("rgb(33%, 33%, 33%)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);e.style.setProperty("color",t,"important");let s="hsl(0, 0%, 100%)";"error"===this.message.level?s="hsl(0, 100%, 97%)":("warning"===this.message.level||this.shouldRenderAsWarning())&&(s="hsl(50, 100%, 95%)");const n=ThemeSupport.ThemeSupport.instance().patchColorText(s,ThemeSupport.ThemeSupport.ColorUsage.Background);e.style.setProperty("background-color",n,"important")}matchesFilterRegex(e){e.lastIndex=0;const t=this.contentElement(),s=this.anchorElement?this.anchorElement.deepTextContent():"";return Boolean(s)&&e.test(s.trim())||e.test(t.deepTextContent().slice(s.length))}matchesFilterText(e){return this.contentElement().deepTextContent().toLowerCase().includes(e.toLowerCase())}updateTimestamp(){this.contentElementInternal&&(Common.Settings.Settings.instance().moduleSetting("consoleTimestampsEnabled").get()?(this.timestampElement||(this.timestampElement=document.createElement("span"),this.timestampElement.classList.add("console-timestamp")),this.timestampElement.textContent=UI.UIUtils.formatTimestamp(this.message.timestamp,!1)+" ",UI.Tooltip.Tooltip.install(this.timestampElement,UI.UIUtils.formatTimestamp(this.message.timestamp,!0)),this.contentElementInternal.insertBefore(this.timestampElement,this.contentElementInternal.firstChild)):this.timestampElement&&(this.timestampElement.remove(),this.timestampElement=null))}nestingLevel(){return this.nestingLevelInternal}setInSimilarGroup(e,t){this.inSimilarGroup=e,this.lastInSimilarGroup=e&&Boolean(t),this.similarGroupMarker&&!e?(this.similarGroupMarker.remove(),this.similarGroupMarker=null):this.elementInternal&&!this.similarGroupMarker&&e&&(this.similarGroupMarker=document.createElement("div"),this.similarGroupMarker.classList.add("nesting-level-marker"),this.elementInternal.insertBefore(this.similarGroupMarker,this.elementInternal.firstChild),this.similarGroupMarker.classList.toggle("group-closed",this.lastInSimilarGroup))}isLastInSimilarGroup(){return Boolean(this.inSimilarGroup)&&Boolean(this.lastInSimilarGroup)}resetCloseGroupDecorationCount(){this.closeGroupDecorationCount&&(this.closeGroupDecorationCount=0,this.updateCloseGroupDecorations())}incrementCloseGroupDecorationCount(){++this.closeGroupDecorationCount,this.updateCloseGroupDecorations()}updateCloseGroupDecorations(){if(this.nestingLevelMarkers)for(let e=0,t=this.nestingLevelMarkers.length;e<t;++e){this.nestingLevelMarkers[e].classList.toggle("group-closed",t-e<=this.closeGroupDecorationCount)}}focusedChildIndex(){return this.selectableChildren.length?this.selectableChildren.findIndex((e=>e.element.hasFocus())):-1}onKeyDown(e){!UI.UIUtils.isEditing()&&this.elementInternal&&this.elementInternal.hasFocus()&&!this.elementInternal.hasSelection()&&this.maybeHandleOnKeyDown(e)&&e.consume(!0)}maybeHandleOnKeyDown(e){const t=this.focusedChildIndex(),s=-1===t;if(this.expandTrace&&s&&("ArrowLeft"===e.key&&this.traceExpanded||"ArrowRight"===e.key&&!this.traceExpanded))return this.expandTrace(!this.traceExpanded),!0;if(!this.selectableChildren.length)return!1;if("ArrowLeft"===e.key)return this.elementInternal&&this.elementInternal.focus(),!0;if("ArrowRight"===e.key&&s&&this.selectNearestVisibleChild(0))return!0;if("ArrowUp"===e.key){const e=this.nearestVisibleChild(0);if(this.selectableChildren[t]===e&&e)return this.elementInternal&&this.elementInternal.focus(),!0;if(this.selectNearestVisibleChild(t-1,!0))return!0}if("ArrowDown"===e.key){if(s&&this.selectNearestVisibleChild(0))return!0;if(!s&&this.selectNearestVisibleChild(t+1))return!0}return!1}selectNearestVisibleChild(e,t){const s=this.nearestVisibleChild(e,t);return!!s&&(s.forceSelect(),!0)}nearestVisibleChild(e,t){const s=this.selectableChildren.length;if(e<0||e>=s)return null;const n=t?-1:1;let i=e;for(;!this.selectableChildren[i].element.offsetParent;)if(i+=n,i<0||i>=s)return null;return this.selectableChildren[i]}focusLastChildOrSelf(){this.elementInternal&&!this.selectNearestVisibleChild(this.selectableChildren.length-1,!0)&&this.elementInternal.focus()}setContentElement(e){console.assert(!this.contentElementInternal,"Cannot set content element twice"),this.contentElementInternal=e}getContentElement(){return this.contentElementInternal}contentElement(){if(this.contentElementInternal)return this.contentElementInternal;const e=document.createElement("div");e.classList.add("console-message"),this.messageLevelIcon&&e.appendChild(this.messageLevelIcon),this.contentElementInternal=e;const t=this.message.runtimeModel();let s;const n=Boolean(this.message.stackTrace)&&("network"===this.message.source||"violation"===this.message.source||"error"===this.message.level||"warning"===this.message.level||"trace"===this.message.type);return s=t&&n?this.buildMessageWithStackTrace(t):this.buildMessage(),e.appendChild(s),this.updateTimestamp(),this.contentElementInternal}toMessageElement(){return this.elementInternal||(this.elementInternal=document.createElement("div"),this.elementInternal.tabIndex=-1,this.elementInternal.addEventListener("keydown",this.onKeyDown.bind(this)),this.updateMessageElement()),this.elementInternal}updateMessageElement(){if(this.elementInternal){this.elementInternal.className="console-message-wrapper",this.elementInternal.removeChildren(),this.message.isGroupStartMessage()&&this.elementInternal.classList.add("console-group-title"),this.message.source===SDK.ConsoleModel.FrontendMessageSource.ConsoleAPI&&this.elementInternal.classList.add("console-from-api"),this.inSimilarGroup&&(this.similarGroupMarker=this.elementInternal.createChild("div","nesting-level-marker"),this.similarGroupMarker.classList.toggle("group-closed",this.lastInSimilarGroup)),this.nestingLevelMarkers=[];for(let e=0;e<this.nestingLevelInternal;++e)this.nestingLevelMarkers.push(this.elementInternal.createChild("div","nesting-level-marker"));switch(this.updateCloseGroupDecorations(),elementToMessage.set(this.elementInternal,this),this.message.level){case"verbose":this.elementInternal.classList.add("console-verbose-level");break;case"info":this.elementInternal.classList.add("console-info-level"),this.message.type===SDK.ConsoleModel.FrontendMessageType.System&&this.elementInternal.classList.add("console-system-type");break;case"warning":this.elementInternal.classList.add("console-warning-level");break;case"error":this.elementInternal.classList.add("console-error-level")}this.updateMessageLevelIcon(),this.shouldRenderAsWarning()&&this.elementInternal.classList.add("console-warning-level"),this.elementInternal.appendChild(this.contentElement()),this.repeatCountInternal>1&&this.showRepeatCountElement()}}shouldRenderAsWarning(){return!("verbose"!==this.message.level&&"info"!==this.message.level||"violation"!==this.message.source&&"deprecation"!==this.message.source&&"intervention"!==this.message.source&&"recommendation"!==this.message.source)}updateMessageLevelIcon(){let e="",t="";if("warning"===this.message.level?(e="smallicon-warning",t=i18nString(UIStrings.warning)):"error"===this.message.level&&(e="smallicon-error",t=i18nString(UIStrings.error)),!this.messageLevelIcon){if(!e)return;this.messageLevelIcon=UI.Icon.Icon.create("","message-level-icon"),this.contentElementInternal&&this.contentElementInternal.insertBefore(this.messageLevelIcon,this.contentElementInternal.firstChild)}this.messageLevelIcon.setIconType(e),UI.ARIAUtils.setAccessibleName(this.messageLevelIcon,t)}repeatCount(){return this.repeatCountInternal||1}resetIncrementRepeatCount(){this.repeatCountInternal=1,this.repeatCountElement&&(this.repeatCountElement.remove(),this.contentElementInternal&&this.contentElementInternal.classList.remove("repeated-message"),this.repeatCountElement=null)}incrementRepeatCount(){this.repeatCountInternal++,this.showRepeatCountElement()}setRepeatCount(e){this.repeatCountInternal=e,this.showRepeatCountElement()}showRepeatCountElement(){if(!this.elementInternal)return;if(!this.repeatCountElement){switch(this.repeatCountElement=document.createElement("span",{is:"dt-small-bubble"}),this.repeatCountElement.classList.add("console-message-repeat-count"),this.message.level){case"warning":this.repeatCountElement.type="warning";break;case"error":this.repeatCountElement.type="error";break;case"verbose":this.repeatCountElement.type="verbose";break;default:this.repeatCountElement.type="info"}this.shouldRenderAsWarning()&&(this.repeatCountElement.type="warning"),this.elementInternal.insertBefore(this.repeatCountElement,this.contentElementInternal),this.contentElement().classList.add("repeated-message")}let e;this.repeatCountElement.textContent=`${this.repeatCountInternal}`,e="warning"===this.message.level?i18nString(UIStrings.warningS,{n:this.repeatCountInternal}):"error"===this.message.level?i18nString(UIStrings.errorS,{n:this.repeatCountInternal}):i18nString(UIStrings.repeatS,{n:this.repeatCountInternal}),UI.ARIAUtils.setAccessibleName(this.repeatCountElement,e)}get text(){return this.message.messageText}toExportString(){const e=[],t=this.contentElement().childTextNodes().map(Components.Linkifier.Linkifier.untruncatedNodeText).join("");for(let s=0;s<this.repeatCount();++s)e.push(t);return e.join("\n")}setSearchRegex(e){if(this.searchHighlightNodeChanges&&this.searchHighlightNodeChanges.length&&UI.UIUtils.revertDomChanges(this.searchHighlightNodeChanges),this.searchRegexInternal=e,this.searchHighlightNodes=[],this.searchHighlightNodeChanges=[],!this.searchRegexInternal)return;const t=this.contentElement().deepTextContent();let s;this.searchRegexInternal.lastIndex=0;const n=[];for(;(s=this.searchRegexInternal.exec(t))&&s[0];)n.push(new TextUtils.TextRange.SourceRange(s.index,s[0].length));n.length&&(this.searchHighlightNodes=UI.UIUtils.highlightSearchResults(this.contentElement(),n,this.searchHighlightNodeChanges))}searchRegex(){return this.searchRegexInternal}searchCount(){return this.searchHighlightNodes.length}searchHighlightNode(e){return this.searchHighlightNodes[e]}async getInlineFrames(e,t,s,n){const i=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance();if(i.pluginManager){const r=Workspace.Workspace.WorkspaceImpl.instance().projects().map((e=>e.uiSourceCodeForURL(t))).flat().filter((e=>Boolean(e))).map((e=>i.scriptsForUISourceCode(e))).flat();if(r.length){const t=new SDK.DebuggerModel.Location(e,r[0].scriptId,s||0,n);return await i.pluginManager.getFunctionInfo(r[0],t)??{frames:[]}}}return{frames:[]}}async expandInlineStackFrames(e,t,s,n,i,r,o,a){const{frames:l}=await this.getInlineFrames(e,n,i,r);if(!l.length)return!1;for(let c=0;c<l.length;++c){const{name:m}=l[c],h=document.createElement("span");h.appendChild(this.linkifyStringAsFragment(`${t} ${m} (`));const d=this.linkifier.linkifyScriptLocation(e.target(),null,n,i,{columnNumber:r,className:void 0,tabStop:void 0,inlineFrameIndex:c});d.tabIndex=-1,this.selectableChildren.push({element:d,forceSelect:()=>d.focus()}),h.appendChild(d),h.appendChild(this.linkifyStringAsFragment(s)),o.insertBefore(h,a)}return!0}tryFormatAsError(e){const t=this.message.runtimeModel();if(!t||!["AggregateError","Error","EvalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError"].some((function(t){return e.startsWith(t)}))&&!/^[\w.]+Error\b/.test(e))return null;const s=t.debuggerModel(),n=t.target().inspectedURL(),i=e.split("\n"),r=[];for(const e of i){const t=/^\s*at\s/.test(e);if(!t&&r.length&&r[r.length-1].link)return null;if(!t){r.push({line:e});continue}let s=-1,i=-1;const o=/\([^\)\(]+:\d+:\d+\)/g,l=/\([^\)\(]+\)/g;let c,m=null;for(;c=o.exec(e);)m=c;if(!m)for(;c=l.exec(e);)m=c;m&&(s=m.index,i=m.index+m[0].length-1);const h=-1!==s;let d=h?s+1:e.indexOf("at")+3;h||e.indexOf("async ")!==d||(d+=6);const u=h?i:e.length,p=e.substring(d,u),g=Common.ParsedURL.ParsedURL.splitLineAndColumn(p);if(!g)return null;if("<anonymous>"===g.url){r.push({line:e});continue}let f=a(g.url);if(!f&&Common.ParsedURL.ParsedURL.isRelativeURL(g.url)&&(f=a(Common.ParsedURL.ParsedURL.completeURL(n,g.url))),!f)return null;r.push({line:e,link:{url:f,enclosedInBraces:h,positionLeft:d,positionRight:u,lineNumber:g.lineNumber,columnNumber:g.columnNumber}})}if(!r.length)return null;const o=document.createElement("span");for(let e=0;e<r.length;++e){const t=e<r.length-1?"\n":"",{line:n,link:i}=r[e];if(!i){o.appendChild(this.linkifyStringAsFragment(`${n}${t}`));continue}const a=document.createElement("span"),l=n.substring(0,i.positionLeft),c=`${n.substring(i.positionRight)}${t}`;a.appendChild(this.linkifyStringAsFragment(l));const m=this.linkifier.linkifyScriptLocation(s.target(),null,i.url,i.lineNumber,{columnNumber:i.columnNumber,className:void 0,tabStop:void 0,inlineFrameIndex:0,showColumnNumber:!0});if(m.tabIndex=-1,this.selectableChildren.push({element:m,forceSelect:()=>m.focus()}),a.appendChild(m),a.appendChild(this.linkifyStringAsFragment(c)),o.appendChild(a),!i.enclosedInBraces)continue;const h=l.substring(0,l.lastIndexOf(" ",l.length-3)),d=this.selectableChildren.length-1;this.expandInlineStackFrames(s,h,c,i.url,i.lineNumber,i.columnNumber,o,a).then((e=>{e&&(o.removeChild(a),this.selectableChildren.splice(d,1))}))}return o;function a(e){if(!e)return null;const t=Common.ParsedURL.ParsedURL.fromString(e);if(t)return t.url;if(s.scriptsForSourceURL(e).length)return e;const n=new URL(e,"file://");return s.scriptsForSourceURL(n.href).length?n.href:null}}linkifyWithCustomLinkifier(e,t){if(e.length>getMaxTokenizableStringLength()){const t=new ObjectUI.ObjectPropertiesSection.ExpandableTextPropertyValue(document.createElement("span"),e,getLongStringVisibleLength()),s=document.createDocumentFragment();return s.appendChild(t.element),s}const s=document.createDocumentFragment(),n=ConsoleViewMessage.tokenizeMessageText(e);let i=!1;for(const e of n)if(e.text)switch(i&&(e.text=`blob:${e.text}`,i=!i),"'blob:"===e.text&&e===n[0]&&(i=!0,e.text="'"),e.type){case"url":{const n=e.text.startsWith("www.")?"http://"+e.text:e.text,i=Common.ParsedURL.ParsedURL.splitLineAndColumn(n),r=Common.ParsedURL.ParsedURL.removeWasmFunctionInfoFromURL(i.url);let o;o=i?t(e.text,r,i.lineNumber,i.columnNumber):t(e.text,""),s.appendChild(o);break}default:s.appendChild(document.createTextNode(e.text))}return s}linkifyStringAsFragment(e){return this.linkifyWithCustomLinkifier(e,((e,t,s,n)=>{const i={text:e,lineNumber:s,columnNumber:n},r=Components.Linkifier.Linkifier.linkifyURL(t,i);return r.tabIndex=-1,this.selectableChildren.push({element:r,forceSelect:()=>r.focus()}),r}))}static tokenizeMessageText(e){const{tokenizerRegexes:t,tokenizerTypes:s}=getOrCreateTokenizers();if(e.length>getMaxTokenizableStringLength())return[{text:e,type:void 0}];return TextUtils.TextUtils.Utils.splitStringByRegexes(e,t).map((e=>({text:e.value,type:s[e.regexIndex]})))}groupKey(){return this.groupKeyInternal||(this.groupKeyInternal=this.message.groupCategoryKey()+":"+this.groupTitle()),this.groupKeyInternal}groupTitle(){return ConsoleViewMessage.tokenizeMessageText(this.message.messageText).reduce(((e,t)=>{let s=t.text;return"url"===t.type?s=i18nString(UIStrings.url):"time"===t.type?s=i18nString(UIStrings.tookNms):"event"===t.type?s=i18nString(UIStrings.someEvent):"milestone"===t.type?s=i18nString(UIStrings.Mxx):"autofill"===t.type&&(s=i18nString(UIStrings.attribute)),e+s}),"").replace(/[%]o/g,"")}}let tokenizerRegexes=null,tokenizerTypes=null;function getOrCreateTokenizers(){if(!tokenizerRegexes||!tokenizerTypes){const e="\\u0000-\\u0020\\u007f-\\u009f",t=new RegExp("(?:[a-zA-Z][a-zA-Z0-9+.-]{2,}:\\/\\/|data:|www\\.)[^\\s"+e+'"]{2,}[^\\s'+e+"\"')}\\],:;.!?]","u"),s=/(?:\/[\w\.-]*)+\:[\d]+/,n=/took [\d]+ms/,i=/'\w+' event/,r=/\sM[6-7]\d/,o=/\(suggested: \"[\w-]+\"\)/,a=new Map;return a.set(t,"url"),a.set(s,"url"),a.set(n,"time"),a.set(i,"event"),a.set(r,"milestone"),a.set(o,"autofill"),tokenizerRegexes=Array.from(a.keys()),tokenizerTypes=Array.from(a.values()),{tokenizerRegexes:tokenizerRegexes,tokenizerTypes:tokenizerTypes}}return{tokenizerRegexes:tokenizerRegexes,tokenizerTypes:tokenizerTypes}}export class ConsoleGroupViewMessage extends ConsoleViewMessage{collapsedInternal;expandGroupIcon;onToggle;constructor(e,t,s,n,i,r,o){console.assert(e.isGroupStartMessage()),super(e,t,s,n,i,o),this.collapsedInternal="startGroupCollapsed"===e.type,this.expandGroupIcon=null,this.onToggle=r}setCollapsed(e){this.collapsedInternal=e,this.expandGroupIcon&&this.expandGroupIcon.setIconType(this.collapsedInternal?"smallicon-triangle-right":"smallicon-triangle-down"),this.onToggle.call(null)}collapsed(){return this.collapsedInternal}maybeHandleOnKeyDown(e){return-1===this.focusedChildIndex()&&("ArrowLeft"===e.key&&!this.collapsedInternal||"ArrowRight"===e.key&&this.collapsedInternal)?(this.setCollapsed(!this.collapsedInternal),!0):super.maybeHandleOnKeyDown(e)}toMessageElement(){let e=this.elementInternal||null;if(!e){e=super.toMessageElement();const t=this.collapsedInternal?"smallicon-triangle-right":"smallicon-triangle-down";this.expandGroupIcon=UI.Icon.Icon.create(t,"expand-group-icon"),this.contentElement().tabIndex=-1,this.repeatCountElement?this.repeatCountElement.insertBefore(this.expandGroupIcon,this.repeatCountElement.firstChild):e.insertBefore(this.expandGroupIcon,this.contentElementInternal),e.addEventListener("click",(()=>this.setCollapsed(!this.collapsedInternal)))}return e}showRepeatCountElement(){super.showRepeatCountElement(),this.repeatCountElement&&this.expandGroupIcon&&this.repeatCountElement.insertBefore(this.expandGroupIcon,this.repeatCountElement.firstChild)}}export class ConsoleCommand extends ConsoleViewMessage{formattedCommand;constructor(e,t,s,n,i,r){super(e,t,s,n,i,r),this.formattedCommand=null}contentElement(){const e=this.getContentElement();if(e)return e;const t=document.createElement("div");this.setContentElement(t),t.classList.add("console-user-command");const s=UI.Icon.Icon.create("smallicon-user-command","command-result-icon");return t.appendChild(s),elementToMessage.set(t,this),this.formattedCommand=document.createElement("span"),this.formattedCommand.classList.add("source-code"),this.formattedCommand.textContent=Platform.StringUtilities.replaceControlCharacters(this.text),t.appendChild(this.formattedCommand),this.formattedCommand.textContent.length<MaxLengthToIgnoreHighlighter?CodeHighlighter.CodeHighlighter.highlightNode(this.formattedCommand,"text/javascript").then(this.updateSearch.bind(this)):this.updateSearch(),this.updateTimestamp(),t}updateSearch(){this.setSearchRegex(this.searchRegex())}}export class ConsoleCommandResult extends ConsoleViewMessage{contentElement(){const e=super.contentElement();if(!e.classList.contains("console-user-command-result")&&(e.classList.add("console-user-command-result"),"info"===this.consoleMessage().level)){const t=UI.Icon.Icon.create("smallicon-command-result","command-result-icon");e.insertBefore(t,e.firstChild)}return e}}export class ConsoleTableMessageView extends ConsoleViewMessage{dataGrid;constructor(e,t,s,n,i,r){super(e,t,s,n,i,r),console.assert("table"===e.type),this.dataGrid=null}wasShown(){this.dataGrid&&this.dataGrid.updateWidths(),super.wasShown()}onResize(){this.isVisible()&&this.dataGrid&&this.dataGrid.onResize()}contentElement(){const e=this.getContentElement();if(e)return e;const t=document.createElement("div");return t.classList.add("console-message"),this.messageLevelIcon&&t.appendChild(this.messageLevelIcon),this.setContentElement(t),t.appendChild(this.buildTableMessage()),this.updateTimestamp(),t}buildTableMessage(){const e=document.createElement("span");e.classList.add("source-code"),this.anchorElement=this.buildMessageAnchor(),this.anchorElement&&e.appendChild(this.anchorElement);const t=this.message.parameters&&this.message.parameters.length?this.message.parameters[0]:null;if(!t)return this.buildMessage();const s=parameterToRemoteObject(this.message.runtimeModel())(t);if(!s||!s.preview)return this.buildMessage();const n=Symbol("rawValueColumn"),i=[],r=s.preview,o=[];for(let e=0;e<r.properties.length;++e){const t=r.properties[e];let a;if(t.valuePreview&&t.valuePreview.properties.length)a=t.valuePreview.properties;else{if(!t.value)continue;a=[{name:n,type:t.type,value:t.value}]}const l=new Map,c=20;for(let e=0;e<a.length;++e){const n=a[e];let r=-1!==i.indexOf(n.name);if(!r){if(i.length===c)continue;r=!0,i.push(n.name)}if(r){const e=this.renderPropertyPreviewOrAccessor(s,n,[t,n]);e.classList.add("console-message-nowrap-below"),l.set(n.name,e)}}o.push({rowName:t.name,rowValue:l})}const a=[];for(const{rowName:e,rowValue:t}of o){a.push(e);for(let e=0;e<i.length;++e)a.push(t.get(i[e]))}i.unshift(i18nString(UIStrings.index));const l=i.map((e=>e===n?i18nString(UIStrings.value):e.toString()));if(a.length&&(this.dataGrid=DataGrid.SortableDataGrid.SortableDataGrid.create(l,a,i18nString(UIStrings.console)),this.dataGrid)){this.dataGrid.setStriped(!0),this.dataGrid.setFocusable(!1);const t=document.createElement("span");t.classList.add("console-message-text");const n=t.createChild("div","console-message-formatted-table"),i=n.createChild("span");n.appendChild(this.formatParameter(s,!0,!1));const r=i.attachShadow({mode:"open"}),o=this.dataGrid.asWidget();o.markAsRoot(),o.show(r),o.registerCSSFiles([consoleViewStyles,objectValueStyles]),e.appendChild(t),this.dataGrid.renderInline()}return e}approximateFastHeight(){const e=this.message.parameters&&this.message.parameters[0];return e&&"string"!=typeof e&&e.preview?19*e.preview.properties.length:19}}const MaxLengthToIgnoreHighlighter=1e4;export const MaxLengthForLinks=40;let maxTokenizableStringLength=1e4,longStringVisibleLength=5e3;export const getMaxTokenizableStringLength=()=>maxTokenizableStringLength;export const setMaxTokenizableStringLength=e=>{maxTokenizableStringLength=e};export const getLongStringVisibleLength=()=>longStringVisibleLength;export const setLongStringVisibleLength=e=>{longStringVisibleLength=e};