import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as CodeMirror from"../../third_party/codemirror.next/codemirror.next.js";import*as Adorners from"../../ui/components/adorners/adorners.js";import*as CodeHighlighter from"../../ui/components/code_highlighter/code_highlighter.js";import*as TextEditor from"../../ui/components/text_editor/text_editor.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import*as Emulation from"../emulation/emulation.js";import*as ElementsComponents from"./components/components.js";import{canGetJSPath,cssPath,jsPath,xPath}from"./DOMPath.js";import{ElementsPanel}from"./ElementsPanel.js";import{MappedCharToEntity}from"./ElementsTreeOutline.js";import{ImagePreviewPopover}from"./ImagePreviewPopover.js";import{getRegisteredDecorators}from"./MarkerDecorator.js";const UIStrings={thisFrameWasIdentifiedAsAnAd:"This frame was identified as an ad frame",forceState:"Force state",useSInTheConsoleToReferToThis:"Use {PH1} in the console to refer to this element.",addAttribute:"Add attribute",editAttribute:"Edit attribute",focus:"Focus",scrollIntoView:"Scroll into view",enterIsolationMode:"Enter Isolation Mode",exitIsolationMode:"Exit Isolation Mode",editText:"Edit text",editAsHtml:"Edit as HTML",cut:"Cut",copy:"Copy",paste:"Paste",copyOuterhtml:"Copy outerHTML",copySelector:"Copy `selector`",copyJsPath:"Copy JS path",copyStyles:"Copy styles",copyXpath:"Copy XPath",copyFullXpath:"Copy full XPath",copyElement:"Copy element",duplicateElement:"Duplicate element",hideElement:"Hide element",deleteElement:"Delete element",expandRecursively:"Expand recursively",collapseChildren:"Collapse children",captureNodeScreenshot:"Capture node screenshot",showFrameDetails:"Show `iframe` details",valueIsTooLargeToEdit:"<value is too large to edit>",children:"Children:",enableGridMode:"Enable grid mode",disableGridMode:"Disable grid mode",enableFlexMode:"Enable flex mode",disableFlexMode:"Disable flex mode",enableScrollSnap:"Enable scroll-snap overlay",disableScrollSnap:"Disable scroll-snap overlay"},str_=i18n.i18n.registerUIStrings("panels/elements/ElementsTreeElement.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ElementsTreeElement extends UI.TreeOutline.TreeElement{nodeInternal;treeOutline;gutterContainer;decorationsElement;isClosingTagInternal;canAddAttributes;searchQuery;expandedChildrenLimitInternal;decorationsThrottler;inClipboard;hoveredInternal;editing;highlightResult;adornerContainer;adorners;styleAdorners;adornersThrottler;htmlEditElement;expandAllButtonElement;searchHighlightsVisible;selectionElement;hintElement;constructor(e,t){super(),this.nodeInternal=e,this.treeOutline=null,this.gutterContainer=this.listItemElement.createChild("div","gutter-container"),this.gutterContainer.addEventListener("click",this.showContextMenu.bind(this));const n=UI.Icon.Icon.create("largeicon-menu","gutter-menu-icon");if(this.gutterContainer.appendChild(n),this.decorationsElement=this.gutterContainer.createChild("div","hidden"),this.isClosingTagInternal=t,this.nodeInternal.nodeType()!==Node.ELEMENT_NODE||t||(this.canAddAttributes=!0),this.searchQuery=null,this.expandedChildrenLimitInternal=InitialChildrenLimit,this.decorationsThrottler=new Common.Throttler.Throttler(100),this.inClipboard=!1,this.hoveredInternal=!1,this.editing=null,this.highlightResult=[],!t&&(this.adornerContainer=this.listItemElement.createChild("div","adorner-container hidden"),this.adorners=[],this.styleAdorners=[],this.adornersThrottler=new Common.Throttler.Throttler(100),this.updateStyleAdorners(),e.isAdFrameNode())){const e=ElementsComponents.AdornerManager.getRegisteredAdorner(ElementsComponents.AdornerManager.RegisteredAdorners.AD),t=this.adorn(e);UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.thisFrameWasIdentifiedAsAnAd))}this.expandAllButtonElement=null}static animateOnDOMUpdate(e){const t=e.listItemElement.querySelector(".webkit-html-tag-name");UI.UIUtils.runCSSAnimationOnce(t||e.listItemElement,"dom-update-highlight")}static visibleShadowRoots(e){let t=e.shadowRoots();return t.length&&!Common.Settings.Settings.instance().moduleSetting("showUAShadowDOM").get()&&(t=t.filter((function(e){return e.shadowRootType()!==SDK.DOMModel.DOMNode.ShadowRootTypes.UserAgent}))),t}static canShowInlineText(e){if(e.contentDocument()||e.templateContent()||ElementsTreeElement.visibleShadowRoots(e).length||e.hasPseudoElements())return!1;if(e.nodeType()!==Node.ELEMENT_NODE)return!1;if(!e.firstChild||e.firstChild!==e.lastChild||e.firstChild.nodeType()!==Node.TEXT_NODE)return!1;return e.firstChild.nodeValue().length<80}static populateForcedPseudoStateItems(e,t){const n=["active","hover","focus","visited","focus-within","focus-visible"],i=t.domModel().cssModel().pseudoState(t),s=e.debugSection().appendSubMenuItem(i18nString(UIStrings.forceState));for(const e of n){const t=!!i&&i.indexOf(e)>=0;s.defaultSection().appendCheckboxItem(":"+e,r.bind(null,e,!t),t,!1)}function r(e,n){t.domModel().cssModel().forcePseudoState(t,e,n)}}isClosingTag(){return Boolean(this.isClosingTagInternal)}node(){return this.nodeInternal}isEditing(){return Boolean(this.editing)}highlightSearchResults(e){this.searchQuery!==e&&this.hideSearchHighlight(),this.searchQuery=e,this.searchHighlightsVisible=!0,this.updateTitle(null,!0)}hideSearchHighlights(){delete this.searchHighlightsVisible,this.hideSearchHighlight()}hideSearchHighlight(){if(0!==this.highlightResult.length){for(let e=this.highlightResult.length-1;e>=0;--e){const t=this.highlightResult[e];switch(t.type){case"added":t.node.remove();break;case"changed":t.node.textContent=t.oldText||null}}this.highlightResult=[]}}setInClipboard(e){this.inClipboard!==e&&(this.inClipboard=e,this.listItemElement.classList.toggle("in-clipboard",e))}get hovered(){return this.hoveredInternal}set hovered(e){this.hoveredInternal!==e&&(this.hoveredInternal=e,this.listItemElement&&(e?(this.createSelection(),this.listItemElement.classList.add("hovered")):this.listItemElement.classList.remove("hovered")))}expandedChildrenLimit(){return this.expandedChildrenLimitInternal}setExpandedChildrenLimit(e){this.expandedChildrenLimitInternal=e}createSelection(){const e=this.listItemElement;e&&(this.selectionElement||(this.selectionElement=document.createElement("div"),this.selectionElement.className="selection fill",this.selectionElement.style.setProperty("margin-left",-this.computeLeftIndent()+"px"),e.insertBefore(this.selectionElement,e.firstChild)))}createHint(){if(this.listItemElement&&!this.hintElement){this.hintElement=this.listItemElement.createChild("span","selected-hint");const e="$0";UI.Tooltip.Tooltip.install(this.hintElement,i18nString(UIStrings.useSInTheConsoleToReferToThis,{PH1:e})),UI.ARIAUtils.markAsHidden(this.hintElement)}}onbind(){this.treeOutline&&!this.isClosingTagInternal&&this.treeOutline.treeElementByNode.set(this.nodeInternal,this)}onunbind(){this.editing&&this.editing.cancel(),this.treeOutline&&this.treeOutline.treeElementByNode.get(this.nodeInternal)===this&&this.treeOutline.treeElementByNode.delete(this.nodeInternal)}onattach(){this.hoveredInternal&&(this.createSelection(),this.listItemElement.classList.add("hovered")),this.updateTitle(),this.listItemElement.draggable=!0}async onpopulate(){if(this.treeOutline)return this.treeOutline.populateTreeElement(this)}async expandRecursively(){await this.nodeInternal.getSubtree(-1,!0),await super.expandRecursively(Number.MAX_VALUE)}onexpand(){this.isClosingTagInternal||this.updateTitle()}oncollapse(){this.isClosingTagInternal||this.updateTitle()}select(e,t){return!this.editing&&super.select(e,t)}onselect(e){return!!this.treeOutline&&(this.treeOutline.suppressRevealAndSelect=!0,this.treeOutline.selectDOMNode(this.nodeInternal,e),e&&(this.nodeInternal.highlight(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.ChangeInspectedNodeInElementsPanel)),this.createSelection(),this.createHint(),this.treeOutline.suppressRevealAndSelect=!1,!0)}ondelete(){if(!this.treeOutline)return!1;const e=this.treeOutline.findTreeElement(this.nodeInternal);return e?e.remove():this.remove(),!0}onenter(){return!this.editing&&(this.startEditing(),!0)}selectOnMouseDown(e){super.selectOnMouseDown(e),this.editing||e.detail>=2&&e.preventDefault()}ondblclick(e){return this.editing||this.isClosingTagInternal||this.startEditingTarget(e.target)||this.isExpandable()&&!this.expanded&&this.expand(),!1}hasEditableNode(){return!this.nodeInternal.isShadowRoot()&&!this.nodeInternal.ancestorUserAgentShadowRoot()}insertInLastAttributePosition(e,t){if(e.getElementsByClassName("webkit-html-attribute").length>0)e.insertBefore(t,e.lastChild);else if(null!==e.textContent){const n=e.textContent.match(/^<(.*?)>$/);if(!n)return;const i=n[1];e.textContent="",UI.UIUtils.createTextChild(e,"<"+i),e.appendChild(t),UI.UIUtils.createTextChild(e,">")}}startEditingTarget(e){if(!this.treeOutline||this.treeOutline.selectedDOMNode()!==this.nodeInternal)return!1;if(this.nodeInternal.nodeType()!==Node.ELEMENT_NODE&&this.nodeInternal.nodeType()!==Node.TEXT_NODE)return!1;const t=e.enclosingNodeOrSelfWithClass("webkit-html-text-node");if(t)return this.startEditingTextNode(t);const n=e.enclosingNodeOrSelfWithClass("webkit-html-attribute");if(n)return this.startEditingAttribute(n,e);const i=e.enclosingNodeOrSelfWithClass("webkit-html-tag-name");if(i)return this.startEditingTagName(i);return!!e.enclosingNodeOrSelfWithClass("add-attribute")&&this.addNewAttribute()}showContextMenu(e){this.treeOutline&&this.treeOutline.showContextMenu(this,e)}populateTagContextMenu(e,t){const n=this.isClosingTagInternal&&this.treeOutline?this.treeOutline.findTreeElement(this.nodeInternal):this;if(!n)return;e.editSection().appendItem(i18nString(UIStrings.addAttribute),n.addNewAttribute.bind(n));const i=t.target,s=i.enclosingNodeOrSelfWithClass("webkit-html-attribute"),r=i.enclosingNodeOrSelfWithClass("add-attribute");s&&!r&&e.editSection().appendItem(i18nString(UIStrings.editAttribute),this.startEditingAttribute.bind(this,s,i)),this.populateNodeContextMenu(e),globalThis.chii||ElementsTreeElement.populateForcedPseudoStateItems(e,n.node()),this.populateScrollIntoView(e),globalThis.chii||e.viewSection().appendItem(i18nString(UIStrings.focus),(async()=>{await this.nodeInternal.focus()}));const o=this.nodeInternal.domModel().overlayModel();o.isHighlightedIsolatedElementInPersistentOverlay(this.nodeInternal.id)?e.viewSection().appendItem(i18nString(UIStrings.exitIsolationMode),(()=>{o.hideIsolatedElementInPersistentOverlay(this.nodeInternal.id)})):e.viewSection().appendItem(i18nString(UIStrings.enterIsolationMode),(()=>{o.highlightIsolatedElementInPersistentOverlay(this.nodeInternal.id)}))}populateScrollIntoView(e){e.viewSection().appendItem(i18nString(UIStrings.scrollIntoView),(()=>this.nodeInternal.scrollIntoView()))}populateTextContextMenu(e,t){this.editing||e.editSection().appendItem(i18nString(UIStrings.editText),this.startEditingTextNode.bind(this,t)),this.populateNodeContextMenu(e)}populateNodeContextMenu(e){const t=this.hasEditableNode();t&&!this.editing&&e.editSection().appendItem(i18nString(UIStrings.editAsHtml),this.editAsHTML.bind(this));const n=this.nodeInternal.isShadowRoot(),i=UI.KeyboardShortcut.KeyboardShortcut.shortcutToString.bind(null),s=UI.KeyboardShortcut.Modifiers.CtrlOrMeta,r=this.treeOutline;if(!r)return;let o;o=e.clipboardSection().appendItem(i18nString(UIStrings.cut),r.performCopyOrCut.bind(r,!0,this.nodeInternal),!this.hasEditableNode()),o.setShortcut(i("X",s));const l=e.clipboardSection().appendSubMenuItem(i18nString(UIStrings.copy)),a=l.section();if(n||(o=a.appendItem(i18nString(UIStrings.copyOuterhtml),r.performCopyOrCut.bind(r,!1,this.nodeInternal)),o.setShortcut(i("V",s))),this.nodeInternal.nodeType()===Node.ELEMENT_NODE&&(a.appendItem(i18nString(UIStrings.copySelector),this.copyCSSPath.bind(this)),a.appendItem(i18nString(UIStrings.copyJsPath),this.copyJSPath.bind(this),!canGetJSPath(this.nodeInternal)),a.appendItem(i18nString(UIStrings.copyStyles),this.copyStyles.bind(this))),n||(a.appendItem(i18nString(UIStrings.copyXpath),this.copyXPath.bind(this)),a.appendItem(i18nString(UIStrings.copyFullXpath),this.copyFullXPath.bind(this))),!n){o=l.clipboardSection().appendItem(i18nString(UIStrings.copyElement),r.performCopyOrCut.bind(r,!1,this.nodeInternal)),o.setShortcut(i("C",s));const t=!this.nodeInternal.parentNode||"#document"===this.nodeInternal.parentNode.nodeName();o=e.editSection().appendItem(i18nString(UIStrings.duplicateElement),r.duplicateNode.bind(r,this.nodeInternal),this.nodeInternal.isInShadowTree()||t)}o=e.clipboardSection().appendItem(i18nString(UIStrings.paste),r.pasteNode.bind(r,this.nodeInternal),!r.canPaste(this.nodeInternal)),o.setShortcut(i("V",s)),o=e.debugSection().appendCheckboxItem(i18nString(UIStrings.hideElement),r.toggleHideElement.bind(r,this.nodeInternal),r.isToggledToHidden(this.nodeInternal)),o.setShortcut(UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("elements.hide-element")||""),t&&e.editSection().appendItem(i18nString(UIStrings.deleteElement),this.remove.bind(this)),e.viewSection().appendItem(i18nString(UIStrings.expandRecursively),this.expandRecursively.bind(this)),e.viewSection().appendItem(i18nString(UIStrings.collapseChildren),this.collapseChildren.bind(this));const d=new Emulation.DeviceModeWrapper.ActionDelegate;e.viewSection().appendItem(i18nString(UIStrings.captureNodeScreenshot),d.handleAction.bind(null,UI.Context.Context.instance(),"emulation.capture-node-screenshot")),this.nodeInternal.frameOwnerFrameId()&&e.viewSection().appendItem(i18nString(UIStrings.showFrameDetails),(()=>{const e=this.nodeInternal.frameOwnerFrameId();if(e){const t=SDK.FrameManager.FrameManager.instance().getFrame(e);Common.Revealer.reveal(t)}}))}startEditing(){if(!this.treeOutline||this.treeOutline.selectedDOMNode()!==this.nodeInternal)return;const e=this.listItemElement;if(this.canAddAttributes){const t=e.getElementsByClassName("webkit-html-attribute")[0];return t?this.startEditingAttribute(t,t.getElementsByClassName("webkit-html-attribute-value")[0]):this.addNewAttribute()}if(this.nodeInternal.nodeType()===Node.TEXT_NODE){const t=e.getElementsByClassName("webkit-html-text-node")[0];if(t)return this.startEditingTextNode(t)}}addNewAttribute(){const e=document.createElement("span"),t=this.buildAttributeDOM(e," ","",null);t.style.marginLeft="2px",t.style.marginRight="2px";const n=this.listItemElement.getElementsByClassName("webkit-html-tag")[0];return this.insertInLastAttributePosition(n,t),t.scrollIntoViewIfNeeded(!0),this.startEditingAttribute(t,t)}triggerEditAttribute(e){const t=this.listItemElement.getElementsByClassName("webkit-html-attribute-name");for(let n=0,i=t.length;n<i;++n)if(t[n].textContent===e)for(let e=t[n].nextSibling;e;e=e.nextSibling)if(e.nodeType===Node.ELEMENT_NODE&&e.classList.contains("webkit-html-attribute-value"))return this.startEditingAttribute(e.parentElement,e)}startEditingAttribute(e,t){if(console.assert(this.listItemElement.isAncestor(e)),UI.UIUtils.isBeingEdited(e))return!0;const n=e.getElementsByClassName("webkit-html-attribute-name")[0];if(!n)return!1;const i=n.textContent,s=e.getElementsByClassName("webkit-html-attribute-value")[0];t=s.isAncestor(t)?s:t;const r=i&&s?this.nodeInternal.getAttribute(i):void 0;void 0!==r&&s.setTextContentTruncatedIfNeeded(r,i18nString(UIStrings.valueIsTooLargeToEdit)),function e(t){if(t.nodeType!==Node.TEXT_NODE){if(t.nodeType===Node.ELEMENT_NODE)for(let n=t.firstChild;n;n=n.nextSibling)e(n)}else t.nodeValue=t.nodeValue?t.nodeValue.replace(/\u200B/g,""):""}(e);const o=new UI.InplaceEditor.Config(this.attributeEditingCommitted.bind(this),this.editingCancelled.bind(this),i||void 0);Common.ParsedURL.ParsedURL.fromString(s.textContent||"")||o.setPostKeydownFinishHandler((function(t){return UI.UIUtils.handleElementValueModifications(t,e),""})),this.updateEditorHandles(e,o);const l=this.listItemElement.getComponentSelection();return l&&l.selectAllChildren(t),!0}startEditingTextNode(e){if(UI.UIUtils.isBeingEdited(e))return!0;let t=this.nodeInternal;t.nodeType()===Node.ELEMENT_NODE&&t.firstChild&&(t=t.firstChild);const n=e.enclosingNodeOrSelfWithClass("webkit-html-text-node");n&&(n.textContent=t.nodeValue());const i=new UI.InplaceEditor.Config(this.textNodeEditingCommitted.bind(this,t),this.editingCancelled.bind(this));this.updateEditorHandles(e,i);const s=this.listItemElement.getComponentSelection();return s&&s.selectAllChildren(e),!0}startEditingTagName(e){if(!e&&!(e=this.listItemElement.getElementsByClassName("webkit-html-tag-name")[0]))return!1;const t=e.textContent;if(null!==t&&EditTagBlocklist.has(t.toLowerCase()))return!1;if(UI.UIUtils.isBeingEdited(e))return!0;const n=this.distinctClosingTagElement();function i(){n&&e&&(n.textContent="</"+e.textContent+">")}const s=e=>{" "===e.key&&(this.editing&&this.editing.commit(),e.consume(!0))};e.addEventListener("keyup",i,!1),e.addEventListener("keydown",s,!1);const r=new UI.InplaceEditor.Config(function(t,n,r,o,l){e&&(e.removeEventListener("keyup",i,!1),e.removeEventListener("keydown",s,!1),this.tagNameEditingCommitted(t,n,r,o,l))}.bind(this),function(t,n){e&&(e.removeEventListener("keyup",i,!1),e.removeEventListener("keydown",s,!1),this.editingCancelled(t,n))}.bind(this),t);this.updateEditorHandles(e,r);const o=this.listItemElement.getComponentSelection();return o&&o.selectAllChildren(e),!0}updateEditorHandles(e,t){const n=UI.InplaceEditor.InplaceEditor.startEditing(e,t);this.editing=n?{commit:n.commit,cancel:n.cancel,editor:void 0,resize:()=>{}}:null}async startEditingAsHTML(e,t,n){if(null===n)return;if(this.editing)return;const i=this.convertWhitespaceToEntities(n).text;this.htmlEditElement=document.createElement("div"),this.htmlEditElement.className="source-code elements-tree-editor";let s=this.listItemElement.firstChild;for(;s;)s.style.display="none",s=s.nextSibling;this.childrenListElement&&(this.childrenListElement.style.display="none"),this.listItemElement.appendChild(this.htmlEditElement),this.htmlEditElement.addEventListener("keydown",(e=>{"Escape"===e.key&&e.consume(!0)}));const r=new TextEditor.TextEditor.TextEditor(CodeMirror.EditorState.create({doc:i,extensions:[CodeMirror.keymap.of([{key:"Mod-Enter",run:()=>(this.editing?.commit(),!0)},{key:"Escape",run:()=>(this.editing?.cancel(),!0)}]),TextEditor.Config.baseConfiguration(i),TextEditor.Config.closeBrackets,TextEditor.Config.autocompletion,CodeMirror.html.html(),TextEditor.Config.domWordWrap.instance(),CodeMirror.EditorView.theme({"&.cm-editor":{maxHeight:"300px"},".cm-scroller":{overflowY:"auto"}}),CodeMirror.EditorView.domEventHandlers({focusout:e=>{const t=e.relatedTarget;t&&!t.isSelfOrDescendant(r)&&this.editing&&this.editing.commit()}})]}));function o(){this.treeOutline&&this.htmlEditElement&&(this.htmlEditElement.style.width=this.treeOutline.visibleWidth()-this.computeLeftIndent()-30+"px")}function l(){if(!this.editing||!this.editing.editor)return;this.editing=null,this.htmlEditElement&&this.listItemElement.removeChild(this.htmlEditElement),this.htmlEditElement=void 0,this.childrenListElement&&this.childrenListElement.style.removeProperty("display");let e=this.listItemElement.firstChild;for(;e;)e.style.removeProperty("display"),e=e.nextSibling;this.treeOutline&&(this.treeOutline.setMultilineEditing(null),this.treeOutline.focus()),t()}this.editing={commit:function(){this.editing&&this.editing.editor&&e(i,this.editing.editor.state.doc.toString());l.call(this)}.bind(this),cancel:l.bind(this),editor:r,resize:o.bind(this)},o.call(this),this.htmlEditElement.appendChild(r),r.editor.focus(),this.treeOutline&&this.treeOutline.setMultilineEditing(this.editing)}attributeEditingCommitted(e,t,n,i,s){this.editing=null;const r=this.treeOutline;function o(n){if(n&&this.editingCancelled(e,i),!s)return;r&&(r.runPendingUpdates(),r.focus());const o=this.nodeInternal.attributes();for(let e=0;e<o.length;++e)if(o[e].name===i)return void("backward"===s?0===e?this.startEditingTagName():this.triggerEditAttribute(o[e-1].name):e===o.length-1?this.addNewAttribute():this.triggerEditAttribute(o[e+1].name));"backward"===s?" "===t?o.length>0&&this.triggerEditAttribute(o[o.length-1].name):o.length>1&&this.triggerEditAttribute(o[o.length-2].name):"forward"===s&&(Platform.StringUtilities.isWhitespace(t)?this.startEditingTagName():this.addNewAttribute())}!i.trim()&&!t.trim()||n===t?(this.updateTitle(),o.call(this)):this.nodeInternal.setAttribute(i,t,o.bind(this))}tagNameEditingCommitted(e,t,n,i,s){this.editing=null;const r=this;function o(){const t=r.distinctClosingTagElement();t&&(t.textContent="</"+i+">"),r.editingCancelled(e,i),l.call(r)}function l(){if("forward"!==s)return void this.addNewAttribute();const e=this.nodeInternal.attributes();e.length>0?this.triggerEditAttribute(e[0].name):this.addNewAttribute()}if((t=t.trim())===n)return void o();const a=this.treeOutline,d=this.expanded;this.nodeInternal.setNodeName(t,((e,t)=>{if(e||!t)return void o();if(!a)return;const n=a.selectNodeAfterEdit(d,e,t);l.call(n)}))}textNodeEditingCommitted(e,t,n){this.editing=null,e.setNodeValue(n,function(){this.updateTitle()}.bind(this))}editingCancelled(e,t){this.editing=null,this.updateTitle()}distinctClosingTagElement(){if(this.expanded){const e=this.childrenListElement.querySelectorAll(".close");return e[e.length-1]}const e=this.listItemElement.getElementsByClassName("webkit-html-tag");return 1===e.length?null:e[e.length-1]}updateTitle(e,t){if(!this.editing){if(t)this.hideSearchHighlight();else{const t=this.nodeTitleInfo(e||null);if(this.nodeInternal.nodeType()===Node.DOCUMENT_FRAGMENT_NODE&&this.nodeInternal.isInShadowTree()&&this.nodeInternal.shadowRootType()){this.childrenListElement.classList.add("shadow-root");let e=4;for(let t=this.nodeInternal;e&&t;t=t.parentNode)t.nodeType()===Node.DOCUMENT_FRAGMENT_NODE&&e--;e?this.childrenListElement.classList.add("shadow-root-depth-"+e):this.childrenListElement.classList.add("shadow-root-deep")}const n=document.createElement("span");n.className="highlight",n.appendChild(t),this.title=n,this.updateDecorations(),this.listItemElement.insertBefore(this.gutterContainer,this.listItemElement.firstChild),!this.isClosingTagInternal&&this.adornerContainer&&this.listItemElement.appendChild(this.adornerContainer),this.highlightResult=[],delete this.selectionElement,delete this.hintElement,this.selected&&(this.createSelection(),this.createHint())}this.highlightSearchResultsInternal()}}computeLeftIndent(){let e=this.parent,t=0;for(;null!==e;)t++,e=e.parent;return 12*(t-2)+(this.isExpandable()?1:12)}updateDecorations(){this.gutterContainer.style.left=-this.computeLeftIndent()+"px",this.isClosingTag()||this.nodeInternal.nodeType()===Node.ELEMENT_NODE&&this.decorationsThrottler.schedule(this.updateDecorationsInternal.bind(this))}updateDecorationsInternal(){if(!this.treeOutline)return Promise.resolve();const e=this.nodeInternal;this.treeOutline.decoratorExtensions||(this.treeOutline.decoratorExtensions=getRegisteredDecorators());const t=new Map;for(const e of this.treeOutline.decoratorExtensions)t.set(e.marker,e);const n=[],i=[],s=[];function r(t,n){const r=n.decorate(t);r&&(t===e?i:s).push(r)}return e.traverseMarkers((function(e,i){const s=t.get(i);if(!s)return;n.push(Promise.resolve(s.decorator()).then(r.bind(null,e)))})),Promise.all(n).then(function(){if(this.decorationsElement.removeChildren(),this.decorationsElement.classList.add("hidden"),this.gutterContainer.classList.toggle("has-decorations",Boolean(i.length||s.length)),UI.ARIAUtils.setAccessibleName(this.decorationsElement,""),!i.length&&!s.length)return;const e=new Set,t=document.createElement("div");for(const n of i){t.createChild("div").textContent=n.title,e.add(n.color)}if(this.expanded&&!i.length)return;const n=new Set;if(s.length){let e=t.createChild("div");e.textContent=i18nString(UIStrings.children);for(const i of s)e=t.createChild("div"),e.style.marginLeft="15px",e.textContent=i.title,n.add(i.color)}let r=0;o.call(this,e,"elements-gutter-decoration"),this.expanded||o.call(this,n,"elements-gutter-decoration elements-has-decorated-children");function o(e,t){for(const n of e){const e=this.decorationsElement.createChild("div",t);this.decorationsElement.classList.remove("hidden"),e.style.backgroundColor=n,e.style.borderColor=n,r&&(e.style.marginLeft=r+"px"),r+=3}}UI.Tooltip.Tooltip.install(this.decorationsElement,t.textContent),UI.ARIAUtils.setAccessibleName(this.decorationsElement,t.textContent||"")}.bind(this))}buildAttributeDOM(e,t,n,i,s,r){const o=/[\/;:\)\]\}]/g;let l=0,a=0,d=0;function h(e,t){const n=this.convertWhitespaceToEntities(t);for(a=n.entityRanges.length,t=n.text.replace(o,((e,t)=>{for(;l<a&&n.entityRanges[l].offset<t;)n.entityRanges[l].offset+=d,++l;return d+=1,e+"​"}));l<a;)n.entityRanges[l].offset+=d,++l;e.setTextContentTruncatedIfNeeded(t),UI.UIUtils.highlightRangesWithStyleClass(e,n.entityRanges,"webkit-html-entity-value")}const c=s||n.length>0,m=e.createChild("span","webkit-html-attribute"),g=m.createChild("span","webkit-html-attribute-name");g.textContent=t,c&&UI.UIUtils.createTextChild(m,'=​"');const u=m.createChild("span","webkit-html-attribute-value");function p(e){const t=r?r.resolveURL(e):null;if(null===t){const t=document.createElement("span");return h.call(this,t,e),t}(e=e.replace(o,"$&​")).startsWith("data:")&&(e=Platform.StringUtilities.trimMiddle(e,60));const n=r&&"a"===r.nodeName().toLowerCase()?UI.XLink.XLink.create(t,e,"",!0):Components.Linkifier.Linkifier.linkifyURL(t,{text:e,preventClick:!0,className:void 0,lineNumber:void 0,columnNumber:void 0,showColumnNumber:!1,inlineFrameIndex:0,maxLength:void 0,tabStop:void 0,bypassURLTrimming:void 0});return ImagePreviewPopover.setImageUrl(n,t)}i&&i.isAttributeModified(t)&&UI.UIUtils.runCSSAnimationOnce(c?u:g,"dom-update-highlight");const I=r?r.nodeName().toLowerCase():"";function E(e){const t=document.createDocumentFragment();let n=0;for(;e.length;){n++>0&&UI.UIUtils.createTextChild(t," ");let i="",s="";const r=(e=e.trim()).search(/\s/);if(-1===r)i=e;else if(r>0&&","===e[r-1])i=e.substring(0,r);else{i=e.substring(0,r);const t=e.indexOf(",",r);s=-1!==t?e.substring(r,t+1):e.substring(r)}i&&(i.endsWith(",")?(t.appendChild(p.call(this,i.substring(0,i.length-1))),UI.UIUtils.createTextChild(t,",")):t.appendChild(p.call(this,i))),s&&UI.UIUtils.createTextChild(t,s),e=e.substring(i.length+s.length)}return t}return!I||"src"!==t&&"href"!==t?("img"!==I&&"source"!==I||"srcset"!==t)&&("image"!==I||"xlink:href"!==t&&"href"!==t)?h.call(this,u,n):u.appendChild(E.call(this,n)):u.appendChild(p.call(this,n)),c&&UI.UIUtils.createTextChild(m,'"'),m}buildPseudoElementDOM(e,t){e.createChild("span","webkit-html-pseudo-element").textContent="::"+t,UI.UIUtils.createTextChild(e,"​")}buildTagDOM(e,t,n,i,s){const r=this.nodeInternal,o=["webkit-html-tag"];n&&i&&o.push("close");const l=e.createChild("span",o.join(" "));UI.UIUtils.createTextChild(l,"<");const a=l.createChild("span",n?"webkit-html-close-tag-name":"webkit-html-tag-name");if(a.textContent=(n?"/":"")+t,!n){if(r.hasAttributes()){const e=r.attributes();for(let t=0;t<e.length;++t){const n=e[t];UI.UIUtils.createTextChild(l," "),this.buildAttributeDOM(l,n.name,n.value,s,!1,r)}}if(s){let e=s.hasRemovedAttributes()||s.hasRemovedChildren();e=e||!this.expanded&&s.hasChangedChildren(),e&&UI.UIUtils.runCSSAnimationOnce(a,"dom-update-highlight")}}UI.UIUtils.createTextChild(l,">"),UI.UIUtils.createTextChild(e,"​"),l.textContent&&UI.ARIAUtils.setAccessibleName(l,l.textContent)}convertWhitespaceToEntities(e){let t="",n=0;const i=[],s=MappedCharToEntity;for(let r=0,o=e.length;r<o;++r){const o=e.charAt(r);if(s.has(o)){t+=e.substring(n,r);const l="&"+s.get(o)+";";i.push({offset:t.length,length:l.length}),t+=l,n=r+1}}return t&&(t+=e.substring(n)),{text:t||e,entityRanges:i}}nodeTitleInfo(e){const t=this.nodeInternal,n=document.createDocumentFragment(),i=()=>{this.highlightResult=[],this.highlightSearchResultsInternal()};switch(t.nodeType()){case Node.ATTRIBUTE_NODE:this.buildAttributeDOM(n,t.name,t.value,e,!0);break;case Node.ELEMENT_NODE:{const i=t.pseudoType();if(i){this.buildPseudoElementDOM(n,i);break}const s=t.nodeNameInCorrectCase();if(this.isClosingTagInternal){this.buildTagDOM(n,s,!0,!0,e);break}if(this.buildTagDOM(n,s,!1,!1,e),this.isExpandable()){if(!this.expanded){n.createChild("span","webkit-html-text-node bogus").textContent="…",UI.UIUtils.createTextChild(n,"​"),this.buildTagDOM(n,s,!0,!1,e)}break}if(ElementsTreeElement.canShowInlineText(t)){const i=n.createChild("span","webkit-html-text-node"),r=t.firstChild;if(!r)throw new Error("ElementsTreeElement._nodeTitleInfo expects node.firstChild to be defined.");const o=this.convertWhitespaceToEntities(r.nodeValue());i.textContent=Platform.StringUtilities.collapseWhitespace(o.text),UI.UIUtils.highlightRangesWithStyleClass(i,o.entityRanges,"webkit-html-entity-value"),UI.UIUtils.createTextChild(n,"​"),this.buildTagDOM(n,s,!0,!1,e),e&&e.hasChangedChildren()&&UI.UIUtils.runCSSAnimationOnce(i,"dom-update-highlight"),e&&e.isCharDataModified()&&UI.UIUtils.runCSSAnimationOnce(i,"dom-update-highlight");break}(this.treeOutline&&this.treeOutline.isXMLMimeType||!ForbiddenClosingTagElements.has(s))&&this.buildTagDOM(n,s,!0,!1,e);break}case Node.TEXT_NODE:if(t.parentNode&&"script"===t.parentNode.nodeName().toLowerCase()){const e=n.createChild("span","webkit-html-text-node webkit-html-js-node"),s=t.nodeValue();e.textContent=s.replace(/^[\n\r]+|\s+$/g,""),CodeHighlighter.CodeHighlighter.highlightNode(e,"text/javascript").then(i)}else if(t.parentNode&&"style"===t.parentNode.nodeName().toLowerCase()){const e=n.createChild("span","webkit-html-text-node webkit-html-css-node"),s=t.nodeValue();e.textContent=s.replace(/^[\n\r]+|\s+$/g,""),CodeHighlighter.CodeHighlighter.highlightNode(e,"text/css").then(i)}else{UI.UIUtils.createTextChild(n,'"');const i=n.createChild("span","webkit-html-text-node"),s=this.convertWhitespaceToEntities(t.nodeValue());i.textContent=Platform.StringUtilities.collapseWhitespace(s.text),UI.UIUtils.highlightRangesWithStyleClass(i,s.entityRanges,"webkit-html-entity-value"),UI.UIUtils.createTextChild(n,'"'),e&&e.isCharDataModified()&&UI.UIUtils.runCSSAnimationOnce(i,"dom-update-highlight")}break;case Node.COMMENT_NODE:{const e=n.createChild("span","webkit-html-comment");UI.UIUtils.createTextChild(e,"\x3c!--"+t.nodeValue()+"--\x3e");break}case Node.DOCUMENT_TYPE_NODE:{const e=n.createChild("span","webkit-html-doctype");UI.UIUtils.createTextChild(e,"<!DOCTYPE "+t.nodeName()),t.publicId?(UI.UIUtils.createTextChild(e,' PUBLIC "'+t.publicId+'"'),t.systemId&&UI.UIUtils.createTextChild(e,' "'+t.systemId+'"')):t.systemId&&UI.UIUtils.createTextChild(e,' SYSTEM "'+t.systemId+'"'),t.internalSubset&&UI.UIUtils.createTextChild(e," ["+t.internalSubset+"]"),UI.UIUtils.createTextChild(e,">");break}case Node.CDATA_SECTION_NODE:{const e=n.createChild("span","webkit-html-text-node");UI.UIUtils.createTextChild(e,"<![CDATA["+t.nodeValue()+"]]>");break}case Node.DOCUMENT_FRAGMENT_NODE:n.createChild("span","webkit-html-fragment").textContent=Platform.StringUtilities.collapseWhitespace(t.nodeNameInCorrectCase());break;default:{const e=Platform.StringUtilities.collapseWhitespace(t.nodeNameInCorrectCase());UI.UIUtils.createTextChild(n,e)}}return n}remove(){if(this.nodeInternal.pseudoType())return;this.parent&&this.nodeInternal.parentNode&&this.nodeInternal.parentNode.nodeType()!==Node.DOCUMENT_NODE&&this.nodeInternal.removeNode()}toggleEditAsHTML(e,t){if(this.editing&&this.htmlEditElement)return void this.editing.commit();if(!1===t)return;function n(t){e&&e(!t)}const i=this.nodeInternal;i.getOuterHTML().then(this.startEditingAsHTML.bind(this,(function(e,t){e!==t&&i.setOuterHTML(t,n)}),(function(){e&&e(!1)})))}copyCSSPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(cssPath(this.nodeInternal,!0))}copyJSPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(jsPath(this.nodeInternal,!0))}copyXPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(xPath(this.nodeInternal,!0))}copyFullXPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(xPath(this.nodeInternal,!1))}async copyStyles(){const e=this.nodeInternal,t=e.domModel().cssModel(),n=await t.cachedMatchedCascadeForNode(e);if(!n)return;const i=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),s=[];for(const e of n.nodeStyles().reverse())for(const t of e.leadingProperties())t.parsedOk&&!t.disabled&&t.activeInStyle()&&!t.implicit&&(n.isInherited(e)&&!SDK.CSSMetadata.cssMetadata().isPropertyInherited(t.name)||e.parentRule&&e.parentRule.isUserAgent()||n.propertyState(t)===SDK.CSSMatchedStyles.PropertyState.Active&&s.push(`${i}${t.name}: ${t.value};`));Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(s.join("\n"))}highlightSearchResultsInternal(){if(!this.searchQuery||!this.searchHighlightsVisible)return;this.hideSearchHighlight();const e=this.listItemElement.textContent||"",t=createPlainTextSearchRegex(this.searchQuery,"gi");let n=t.exec(e);const i=[];for(;n;)i.push(new TextUtils.TextRange.SourceRange(n.index,n[0].length)),n=t.exec(e);i.length||i.push(new TextUtils.TextRange.SourceRange(0,e.length)),this.highlightResult=[],UI.UIUtils.highlightSearchResults(this.listItemElement,i,this.highlightResult)}editAsHTML(){Common.Revealer.reveal(this.node()).then((()=>{const e=UI.ActionRegistry.ActionRegistry.instance().action("elements.edit-as-html");if(e)return e.execute()}))}adorn({name:e}){const t=document.createElement("span");t.textContent=e;const n=new Adorners.Adorner.Adorner;return n.data={name:e,content:t},this.adorners.push(n),ElementsPanel.instance().registerAdorner(n),this.updateAdorners(),n}removeAdorner(e){const t=this.adorners;ElementsPanel.instance().deregisterAdorner(e),e.remove();for(let n=0;n<t.length;++n)if(t[n]===e)return t.splice(n,1),void this.updateAdorners()}removeAllAdorners(){for(const e of this.adorners)ElementsPanel.instance().deregisterAdorner(e),e.remove();this.adorners=[],this.updateAdorners()}updateAdorners(){this.adornersThrottler.schedule(this.updateAdornersInternal.bind(this))}updateAdornersInternal(){const e=this.adornerContainer;if(!e)return Promise.resolve();const t=this.adorners;if(0===t.length)return e.classList.add("hidden"),Promise.resolve();t.sort(adornerComparator),e.removeChildren();for(const n of t)e.appendChild(n);return e.classList.remove("hidden"),Promise.resolve()}async updateStyleAdorners(){if(this.isClosingTagInternal)return;const e=this.node(),t=e.id;if(e.nodeType()===Node.COMMENT_NODE||e.nodeType()===Node.DOCUMENT_FRAGMENT_NODE||e.nodeType()===Node.TEXT_NODE||void 0===t)return;const n=await e.domModel().cssModel().computedStylePromise(t);for(const e of this.styleAdorners)this.removeAdorner(e);if(this.styleAdorners=[],!n)return;const i=n.get("display"),s="grid"===i||"inline-grid"===i,r="flex"===i||"inline-flex"===i,o=n.get("container-type"),l=n.get("contain"),a=""!==SDK.CSSContainerQuery.getQueryAxis(`${o} ${l}`),d=e=>{e&&this.styleAdorners.push(e)};s&&d(this.createGridAdorner()),r&&d(this.createFlexAdorner()),n.get("scroll-snap-type")&&"none"!==n.get("scroll-snap-type")&&d(this.createScrollSnapAdorner()),a&&d(this.createContainerAdorner())}createGridAdorner(){const e=this.node(),t=e.id;if(!t)return null;const n=ElementsComponents.AdornerManager.getRegisteredAdorner(ElementsComponents.AdornerManager.RegisteredAdorners.GRID),i=this.adorn(n);i.classList.add("grid");return i.addInteraction((()=>{i.isActive()?e.domModel().overlayModel().highlightGridInPersistentOverlay(t):e.domModel().overlayModel().hideGridInPersistentOverlay(t)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableGridMode),ariaLabelActive:i18nString(UIStrings.disableGridMode)}),e.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentGridOverlayStateChanged,(e=>{const{nodeId:n,enabled:s}=e.data;n===t&&i.toggle(s)})),i}createScrollSnapAdorner(){const e=this.node(),t=e.id;if(!t)return null;const n=ElementsComponents.AdornerManager.getRegisteredAdorner(ElementsComponents.AdornerManager.RegisteredAdorners.SCROLL_SNAP),i=this.adorn(n);i.classList.add("scroll-snap");return i.addInteraction((()=>{const n=e.domModel().overlayModel();i.isActive()?n.highlightScrollSnapInPersistentOverlay(t):n.hideScrollSnapInPersistentOverlay(t)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableScrollSnap),ariaLabelActive:i18nString(UIStrings.disableScrollSnap)}),e.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentScrollSnapOverlayStateChanged,(e=>{const{nodeId:n,enabled:s}=e.data;n===t&&i.toggle(s)})),i}createFlexAdorner(){const e=this.node(),t=e.id;if(!t)return null;const n=ElementsComponents.AdornerManager.getRegisteredAdorner(ElementsComponents.AdornerManager.RegisteredAdorners.FLEX),i=this.adorn(n);i.classList.add("flex");return i.addInteraction((()=>{const n=e.domModel().overlayModel();i.isActive()?n.highlightFlexContainerInPersistentOverlay(t):n.hideFlexContainerInPersistentOverlay(t)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableFlexMode),ariaLabelActive:i18nString(UIStrings.disableFlexMode)}),e.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentFlexContainerOverlayStateChanged,(e=>{const{nodeId:n,enabled:s}=e.data;n===t&&i.toggle(s)})),i}createContainerAdorner(){const e=this.node(),t=e.id;if(!t)return null;const n=ElementsComponents.AdornerManager.getRegisteredAdorner(ElementsComponents.AdornerManager.RegisteredAdorners.CONTAINER),i=this.adorn(n);i.classList.add("container");return i.addInteraction((()=>{const n=e.domModel().overlayModel();i.isActive()?n.highlightContainerQueryInPersistentOverlay(t):n.hideContainerQueryInPersistentOverlay(t)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableScrollSnap),ariaLabelActive:i18nString(UIStrings.disableScrollSnap)}),e.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentContainerQueryOverlayStateChanged,(e=>{const{nodeId:n,enabled:s}=e.data;n===t&&i.toggle(s)})),i}}export const InitialChildrenLimit=500;export const ForbiddenClosingTagElements=new Set(["area","base","basefont","br","canvas","col","command","embed","frame","hr","img","input","keygen","link","menuitem","meta","param","source","track","wbr"]);export const EditTagBlocklist=new Set(["html","head","body"]);export function adornerComparator(e,t){const n=ElementsComponents.AdornerManager.compareAdornerNamesByCategory(t.name,t.name);return 0===n?e.name.localeCompare(t.name):n}