import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as ColorPicker from"../../ui/legacy/components/color_picker/color_picker.js";import*as InlineEditor from"../../ui/legacy/components/inline_editor/inline_editor.js";import*as UI from"../../ui/legacy/legacy.js";import{BezierPopoverIcon,ColorSwatchPopoverIcon,ShadowSwatchPopoverHelper}from"./ColorSwatchPopoverIcon.js";import*as ElementsComponents from"./components/components.js";import{ElementsPanel}from"./ElementsPanel.js";import{StyleEditorWidget}from"./StyleEditorWidget.js";import{CSSPropertyPrompt,StylesSidebarPane,StylesSidebarPropertyRenderer}from"./StylesSidebarPane.js";import{getCssDeclarationAsJavascriptProperty}from"./StylePropertyUtils.js";const FlexboxEditor=ElementsComponents.StylePropertyEditor.FlexboxEditor,GridEditor=ElementsComponents.StylePropertyEditor.GridEditor,UIStrings={shiftClickToChangeColorFormat:"Shift + Click to change color format.",openColorPickerS:"Open color picker. {PH1}",valueForSettingSSIsOutsideThe:"Value for setting “{PH1}” {PH2} is outside the supported range [{PH3}, {PH4}] for font-family “{PH5}”.",togglePropertyAndContinueEditing:"Toggle property and continue editing",revealInSourcesPanel:"Reveal in Sources panel",copyDeclaration:"Copy declaration",copyProperty:"Copy property",copyValue:"Copy value",copyRule:"Copy rule",copyAllDeclarations:"Copy all declarations",viewComputedValue:"View computed value",flexboxEditorButton:"Open `flexbox` editor",gridEditorButton:"Open `grid` editor",copyCssDeclarationAsJs:"Copy declaration as JS",copyAllCssDeclarationsAsJs:"Copy all declarations as JS"},str_=i18n.i18n.registerUIStrings("panels/elements/StylePropertyTreeElement.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),parentMap=new WeakMap;export class StylePropertyTreeElement extends UI.TreeOutline.TreeElement{style;matchedStylesInternal;property;inheritedInternal;overloadedInternal;parentPaneInternal;isShorthand;applyStyleThrottler;newProperty;expandedDueToFilter;valueElement;nameElement;expandElement;originalPropertyText;hasBeenEditedIncrementally;prompt;lastComputedValue;contextForTest;constructor(e,t,n,i,r,s,o){super("",i),this.style=n.ownerStyle,this.matchedStylesInternal=t,this.property=n,this.inheritedInternal=r,this.overloadedInternal=s,this.selectable=!1,this.parentPaneInternal=e,this.isShorthand=i,this.applyStyleThrottler=new Common.Throttler.Throttler(0),this.newProperty=o,this.newProperty&&(this.listItemElement.textContent=""),this.expandedDueToFilter=!1,this.valueElement=null,this.nameElement=null,this.expandElement=null,this.originalPropertyText="",this.hasBeenEditedIncrementally=!1,this.prompt=null,this.lastComputedValue=null}matchedStyles(){return this.matchedStylesInternal}editable(){return Boolean(this.style.styleSheetId&&this.style.range)}inherited(){return this.inheritedInternal}overloaded(){return this.overloadedInternal}setOverloaded(e){e!==this.overloadedInternal&&(this.overloadedInternal=e,this.updateState())}get name(){return this.property.name}get value(){return this.property.value}updateFilter(){const e=this.parentPaneInternal.filterRegex(),t=null!==e&&(e.test(this.property.name)||e.test(this.property.value));this.listItemElement.classList.toggle("filter-match",t),this.onpopulate();let n=!1;for(let e=0;e<this.childCount();++e){const t=this.childAt(e);!t||t&&!t.updateFilter()||(n=!0)}return e?n&&!this.expanded?(this.expand(),this.expandedDueToFilter=!0):!n&&this.expanded&&this.expandedDueToFilter&&(this.collapse(),this.expandedDueToFilter=!1):(this.expandedDueToFilter&&this.collapse(),this.expandedDueToFilter=!1),t}processColor(e,t){const n=this.editable(),i=i18nString(UIStrings.shiftClickToChangeColorFormat),r=this.editable()?i18nString(UIStrings.openColorPickerS,{PH1:i}):i,s=new InlineEditor.ColorSwatch.ColorSwatch;if(s.renderColor(e,n,r),!t){t=s.createChild("span");const n=s.getColor();t.textContent=n?n.asString(s.getFormat()):e}s.appendChild(t);return s.addEventListener(InlineEditor.ColorSwatch.FormatChangedEvent.eventName,(e=>{const{data:t}=e;s.firstElementChild&&s.firstElementChild.remove(),s.createChild("span").textContent=t.text})),this.editable()&&this.addColorContrastInfo(s),s}processVar(e){const t=this.matchedStylesInternal.computeSingleVariableValue(this.style,e);if(!t)return document.createTextNode(e);const{computedValue:n,fromFallback:i}=t,r=new InlineEditor.CSSVarSwatch.CSSVarSwatch;return UI.UIUtils.createTextChild(r,e),r.data={text:e,computedValue:n,fromFallback:i,onLinkActivate:this.handleVarDefinitionActivate.bind(this)},n&&Common.Color.Color.parse(n)?this.processColor(n,r):r}handleVarDefinitionActivate(e){Host.userMetrics.actionTaken(Host.UserMetrics.Action.CustomPropertyLinkClicked),this.parentPaneInternal.jumpToProperty(e)}async addColorContrastInfo(e){const t=this.parentPaneInternal.swatchPopoverHelper(),n=new ColorSwatchPopoverIcon(this,t,e);if("color"!==this.property.name||!this.parentPaneInternal.cssModel()||!this.node())return;const i=this.parentPaneInternal.cssModel(),r=this.node();if(i&&r&&void 0!==r.id){const e=new ColorPicker.ContrastInfo.ContrastInfo(await i.backgroundColorsPromise(r.id));n.setContrastInfo(e)}}renderedPropertyText(){return this.nameElement&&this.valueElement?this.nameElement.textContent+": "+this.valueElement.textContent:""}processBezier(e){if(!this.editable()||!UI.Geometry.CubicBezier.parse(e))return document.createTextNode(e);const t=this.parentPaneInternal.swatchPopoverHelper(),n=InlineEditor.Swatches.BezierSwatch.create();return n.setBezierText(e),new BezierPopoverIcon(this,t,n),n}processFont(e){const t=this.section();return t&&t.registerFontProperty(this),document.createTextNode(e)}processShadow(e,t){if(!this.editable())return document.createTextNode(e);let n;if(n="text-shadow"===t?InlineEditor.CSSShadowModel.CSSShadowModel.parseTextShadow(e):InlineEditor.CSSShadowModel.CSSShadowModel.parseBoxShadow(e),!n.length)return document.createTextNode(e);const i=document.createDocumentFragment(),r=this.parentPaneInternal.swatchPopoverHelper();for(let e=0;e<n.length;e++){0!==e&&i.appendChild(document.createTextNode(", "));const t=InlineEditor.Swatches.CSSShadowSwatch.create();t.setCSSShadow(n[e]),new ShadowSwatchPopoverHelper(this,r,t);const s=t.colorSwatch();s&&new ColorSwatchPopoverIcon(this,r,s),i.appendChild(t)}return i}processGrid(e,t){const n=TextUtils.TextUtils.Utils.splitStringByRegexes(e,[SDK.CSSMetadata.GridAreaRowRegex]);if(n.length<=1)return document.createTextNode(e);const i=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),r=document.createDocumentFragment();for(const e of n){const t=e.value.trim(),n=UI.Fragment.html`<br /><span class='styles-clipboard-only'>${i.repeat(2)}</span>${t}`;r.appendChild(n)}return r}processAngle(e){if(!this.editable())return document.createTextNode(e);const t=new InlineEditor.CSSAngle.CSSAngle,n=document.createElement("span");n.textContent=e;const i=this.matchedStylesInternal.computeValue(this.property.ownerStyle,this.property.value)||"";t.data={propertyName:this.property.name,propertyValue:i,angleText:e,containingPane:this.parentPaneInternal.element.enclosingNodeOrSelfWithClass("style-panes-wrapper")},t.append(n);return t.addEventListener("popovertoggled",(e=>{const n=this.section();if(!n)return;const{data:i}=e;i.open&&(this.parentPaneInternal.hideAllPopovers(),this.parentPaneInternal.activeCSSAngle=t),n.element.classList.toggle("has-open-popover",i.open),this.parentPaneInternal.setEditingStyle(i.open)})),t.addEventListener("valuechanged",(async e=>{const{data:i}=e;n.textContent=i.value,await this.applyStyleText(this.renderedPropertyText(),!1);const r=this.matchedStylesInternal.computeValue(this.property.ownerStyle,this.property.value)||"";t.updateProperty(this.property.name,r)})),t.addEventListener("unitchanged",(async e=>{const{data:t}=e;n.textContent=t.value})),t}processLength(e){if(!this.editable())return document.createTextNode(e);const t=new InlineEditor.CSSLength.CSSLength,n=document.createElement("span");n.textContent=e,t.data={lengthText:e},t.append(n);return t.addEventListener("valuechanged",(e=>{const{data:t}=e;n.textContent=t.value,this.parentPaneInternal.setEditingStyle(!0),this.applyStyleText(this.renderedPropertyText(),!1)})),t.addEventListener("draggingfinished",(()=>{this.parentPaneInternal.setEditingStyle(!1)})),t}updateState(){if(!this.listItemElement)return;this.style.isPropertyImplicit(this.name)?this.listItemElement.classList.add("implicit"):this.listItemElement.classList.remove("implicit");!this.property.parsedOk&&StylesSidebarPane.ignoreErrorsForProperty(this.property)?this.listItemElement.classList.add("has-ignorable-error"):this.listItemElement.classList.remove("has-ignorable-error"),this.inherited()?this.listItemElement.classList.add("inherited"):this.listItemElement.classList.remove("inherited"),this.overloaded()?this.listItemElement.classList.add("overloaded"):this.listItemElement.classList.remove("overloaded"),this.property.disabled?this.listItemElement.classList.add("disabled"):this.listItemElement.classList.remove("disabled")}node(){return this.parentPaneInternal.node()}parentPane(){return this.parentPaneInternal}section(){return this.treeOutline?this.treeOutline.section:null}updatePane(){const e=this.section();e&&e.refreshUpdate(this)}async toggleDisabled(e){if(!this.style.range)return;this.parentPaneInternal.setUserOperation(!0);const t=await this.property.setDisabled(e);this.parentPaneInternal.setUserOperation(!1),t&&(this.matchedStylesInternal.resetActiveProperties(),this.updatePane(),this.styleTextAppliedForTest())}async onpopulate(){if(this.childCount()||!this.isShorthand)return;const e=this.style.longhandProperties(this.name),t=this.style.leadingProperties();for(let n=0;n<e.length;++n){const i=e[n].name;let r=!1,s=!1;const o=this.section();o&&(r=o.isPropertyInherited(i),s=this.matchedStylesInternal.propertyState(e[n])===SDK.CSSMatchedStyles.PropertyState.Overloaded);t.find((e=>e.name===i&&e.activeInStyle()))&&(s=!0);const a=new StylePropertyTreeElement(this.parentPaneInternal,this.matchedStylesInternal,e[n],!1,r,s,!1);this.appendChild(a)}}onattach(){this.updateTitle(),this.listItemElement.addEventListener("mousedown",(e=>{0===e.button&&parentMap.set(this.parentPaneInternal,this)}),!1),this.listItemElement.addEventListener("mouseup",this.mouseUp.bind(this)),this.listItemElement.addEventListener("click",(e=>{if(!e.target)return;e.target.hasSelection()||e.target===this.listItemElement||e.consume(!0)})),this.listItemElement.addEventListener("contextmenu",this.handleCopyContextMenuEvent.bind(this))}onexpand(){this.updateExpandElement()}oncollapse(){this.updateExpandElement()}updateExpandElement(){this.expandElement&&(this.expanded?this.expandElement.setIconType("smallicon-triangle-down"):this.expandElement.setIconType("smallicon-triangle-right"))}updateTitleIfComputedValueChanged(){const e=this.matchedStylesInternal.computeValue(this.property.ownerStyle,this.property.value);e!==this.lastComputedValue&&(this.lastComputedValue=e,this.innerUpdateTitle())}updateTitle(){this.lastComputedValue=this.matchedStylesInternal.computeValue(this.property.ownerStyle,this.property.value),this.innerUpdateTitle()}innerUpdateTitle(){this.updateState(),this.isExpandable()?this.expandElement=UI.Icon.Icon.create("smallicon-triangle-right","expand-icon"):this.expandElement=null;const e=new StylesSidebarPropertyRenderer(this.style.parentRule,this.node(),this.name,this.value);if(this.property.parsedOk&&(e.setVarHandler(this.processVar.bind(this)),e.setColorHandler(this.processColor.bind(this)),e.setBezierHandler(this.processBezier.bind(this)),e.setFontHandler(this.processFont.bind(this)),e.setShadowHandler(this.processShadow.bind(this)),e.setGridHandler(this.processGrid.bind(this)),e.setAngleHandler(this.processAngle.bind(this)),e.setLengthHandler(this.processLength.bind(this))),this.listItemElement.removeChildren(),this.nameElement=e.renderName(),this.property.name.startsWith("--")&&this.nameElement&&UI.Tooltip.Tooltip.install(this.nameElement,this.matchedStylesInternal.computeCSSVariable(this.style,this.property.name)||""),this.valueElement=e.renderValue(),!this.treeOutline)return;const t=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get();if(UI.UIUtils.createTextChild(this.listItemElement.createChild("span","styles-clipboard-only"),t+(this.property.disabled?"/* ":"")),this.nameElement&&this.listItemElement.appendChild(this.nameElement),this.valueElement){const e=this.valueElement.firstElementChild&&"BR"===this.valueElement.firstElementChild.tagName?":":": ";this.listItemElement.createChild("span","styles-name-value-separator").textContent=e,this.expandElement&&this.listItemElement.appendChild(this.expandElement),this.listItemElement.appendChild(this.valueElement),UI.UIUtils.createTextChild(this.listItemElement,";"),this.property.disabled&&UI.UIUtils.createTextChild(this.listItemElement.createChild("span","styles-clipboard-only")," */")}const n=this.section();if(this.valueElement&&n&&n.editable&&"display"===this.property.name){const e=this.property.trimmedValueWithoutImportant(),t="flex"===e||"inline-flex"===e,i="grid"===e||"inline-grid"===e;if(t||i){const e=`${n.getSectionIdx()}_${n.nextEditorTriggerButtonIdx}`,i=StyleEditorWidget.createTriggerButton(this.parentPaneInternal,n,t?FlexboxEditor:GridEditor,i18nString(t?UIStrings.flexboxEditorButton:UIStrings.gridEditorButton),e);n.nextEditorTriggerButtonIdx++,this.listItemElement.appendChild(i);const r=this.parentPaneInternal.swatchPopoverHelper();r.isShowing(StyleEditorWidget.instance())&&StyleEditorWidget.instance().getTriggerKey()===e&&r.setAnchorElement(i)}}if(this.property.parsedOk?this.updateFontVariationSettingsWarning():(this.listItemElement.classList.add("not-parsed-ok"),this.listItemElement.insertBefore(StylesSidebarPane.createExclamationMark(this.property,null),this.listItemElement.firstChild)),this.property.activeInStyle()||this.listItemElement.classList.add("inactive"),this.updateFilter(),this.property.parsedOk&&this.section()&&this.parent&&this.parent.root){const e=document.createElement("input");e.className="enabled-button",e.type="checkbox",e.checked=!this.property.disabled,e.addEventListener("mousedown",(e=>e.consume()),!1),e.addEventListener("click",(e=>{this.toggleDisabled(!this.property.disabled),e.consume()}),!1),this.nameElement&&this.valueElement&&UI.ARIAUtils.setAccessibleName(e,`${this.nameElement.textContent} ${this.valueElement.textContent}`),this.listItemElement.insertBefore(e,this.listItemElement.firstChild)}}async updateFontVariationSettingsWarning(){if("font-variation-settings"!==this.property.name)return;const e=this.property.value,t=this.parentPaneInternal.cssModel();if(!t)return;const n=this.parentPaneInternal.computedStyleModel(),i=await n.fetchComputedStyle();if(!i)return;const r=i.computedStyle.get("font-family");if(!r)return;const s=new Set(SDK.CSSPropertyParser.parseFontFamily(r)),o=t.fontFaces().filter((e=>s.has(e.getFontFamily()))),a=SDK.CSSPropertyParser.parseFontVariationSettings(e),l=[];for(const e of a)for(const t of o){const n=t.getVariationAxisByTag(e.tag);n&&((e.value<n.minValue||e.value>n.maxValue)&&l.push(i18nString(UIStrings.valueForSettingSSIsOutsideThe,{PH1:e.tag,PH2:e.value,PH3:n.minValue,PH4:n.maxValue,PH5:t.getFontFamily()})))}l.length&&(this.listItemElement.classList.add("has-warning"),this.listItemElement.insertBefore(StylesSidebarPane.createExclamationMark(this.property,l.join(" ")),this.listItemElement.firstChild))}mouseUp(e){const t=parentMap.get(this.parentPaneInternal);if(parentMap.delete(this.parentPaneInternal),!t)return;if(this.listItemElement.hasSelection())return;if(UI.UIUtils.isBeingEdited(e.target))return;if(e.consume(!0),e.target===this.listItemElement)return;const n=this.section();UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e)&&n&&n.navigable?this.navigateToSource(e.target):this.startEditing(e.target)}handleContextMenuEvent(e,t){const n=new UI.ContextMenu.ContextMenu(t);if(this.property.parsedOk&&this.section()&&this.parent&&this.parent.root){const i=this.parentPaneInternal.focusedSectionIndex();n.defaultSection().appendCheckboxItem(i18nString(UIStrings.togglePropertyAndContinueEditing),(async()=>{if(this.treeOutline){const n=this.treeOutline.rootElement().indexOfChild(this);this.editingCancelled(null,e),await this.toggleDisabled(!this.property.disabled),t.consume(),this.parentPaneInternal.continueEditingElement(i,n)}}),!this.property.disabled)}const i=this.navigateToSource.bind(this);n.defaultSection().appendItem(i18nString(UIStrings.revealInSourcesPanel),i),n.show()}handleCopyContextMenuEvent(e){if(!e.target)return;const t=new UI.ContextMenu.ContextMenu(e);t.clipboardSection().appendItem(i18nString(UIStrings.copyDeclaration),(()=>{const e=`${this.property.name}: ${this.property.value};`;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyProperty),(()=>{Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(this.property.name)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyValue),(()=>{Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(this.property.value)})),t.defaultSection().appendItem(i18nString(UIStrings.copyRule),(()=>{const e=this.section(),t=StylesSidebarPane.formatLeadingProperties(e).ruleText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(t)})),t.defaultSection().appendItem(i18nString(UIStrings.copyAllDeclarations),(()=>{const e=this.section(),t=StylesSidebarPane.formatLeadingProperties(e).allDeclarationText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(t)})),t.defaultSection().appendItem(i18nString(UIStrings.viewComputedValue),(()=>{this.viewComputedValue()})),t.clipboardSection().appendItem(i18nString(UIStrings.copyCssDeclarationAsJs),this.copyCssDeclarationAsJs.bind(this)),t.defaultSection().appendItem(i18nString(UIStrings.copyAllCssDeclarationsAsJs),this.copyAllCssDeclarationAsJs.bind(this)),t.show()}async viewComputedValue(){const e=ElementsPanel.instance().getComputedStyleWidget();e.isShowing()||await UI.ViewManager.ViewManager.instance().showView("Computed");let t="";t=this.isShorthand?"^"+this.property.name+"-":"^"+this.property.name+"$";const n=new RegExp(t,"i");e.filterComputedStyles(n);const i=e.input;i.value=this.property.name,i.focus()}copyCssDeclarationAsJs(){const e=getCssDeclarationAsJavascriptProperty(this.property);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)}copyAllCssDeclarationAsJs(){const e=this.section().style().leadingProperties().filter((e=>!e.disabled)).map(getCssDeclarationAsJavascriptProperty);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e.join(",\n"))}navigateToSource(e,t){const n=this.section();if(!n||!n.navigable)return;const i=e===this.nameElement,r=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().propertyUILocation(this.property,i);r&&Common.Revealer.reveal(r,t)}startEditing(e){if(this.parent instanceof StylePropertyTreeElement&&this.parent.isShorthand)return;if(this.expandElement&&e===this.expandElement)return;const t=this.section();if(t&&!t.editable)return;if(e&&(e=e.enclosingNodeOrSelfWithClass("webkit-css-property")||e.enclosingNodeOrSelfWithClass("value")),e||(e=this.nameElement),UI.UIUtils.isBeingEdited(e))return;const n=e===this.nameElement;var i;!n&&this.valueElement&&(SDK.CSSMetadata.cssMetadata().isGridAreaDefiningProperty(this.name)&&(this.valueElement.textContent=(i=this.value,TextUtils.TextUtils.Utils.splitStringByRegexes(i,[SDK.CSSMetadata.GridAreaRowRegex]).map((e=>e.value.trim())).join("\n"))),this.valueElement.textContent=function(e,t){const n=e.split(SDK.CSSMetadata.URLRegex);if(1===n.length)return e;const i=new RegExp(SDK.CSSMetadata.URLRegex);for(let e=1;e<n.length;e+=2){const r=i.exec(t);r&&(n[e]=r[0])}return n.join("")}(this.valueElement.textContent||"",this.value));const r=e&&e.textContent||"",s={expanded:this.expanded,hasChildren:this.isExpandable(),isEditingName:n,originalProperty:this.property,previousContent:r,originalName:void 0,originalValue:void 0};this.contextForTest=s,this.setExpandable(!1),e&&(e.parentElement&&e.parentElement.classList.add("child-editing"),e.textContent=e.textContent),this.originalPropertyText=this.property.propertyText||"",this.parentPaneInternal.setEditingStyle(!0,this),e&&e.parentElement&&e.parentElement.scrollIntoViewIfNeeded(!1),this.prompt=new CSSPropertyPrompt(this,n),this.prompt.setAutocompletionTimeout(0),this.prompt.addEventListener(UI.TextPrompt.Events.TextChanged,(e=>{this.applyFreeFlowStyleTextEdit(s)}));const o=this.property.getInvalidStringForInvalidProperty();if(o&&e&&UI.ARIAUtils.alert(o),e){const t=this.prompt.attachAndStartEditing(e,function(e,t){let n=t.target.textContent;e.isEditingName||(n=this.value||n),this.editingCommitted(n||"",e,"")}.bind(this,s));this.navigateToSource(e,!0),t.addEventListener("keydown",this.editingNameValueKeyDown.bind(this,s),!1),t.addEventListener("keypress",this.editingNameValueKeyPress.bind(this,s),!1),n&&(t.addEventListener("paste",function(e,t){const n=t.clipboardData;if(!n)return;const i=n.getData("Text");if(!i)return;const r=i.indexOf(":");if(r<0)return;const s=i.substring(0,r).trim(),o=i.substring(r+1).trim();t.preventDefault(),void 0===e.originalName&&(this.nameElement&&(e.originalName=this.nameElement.textContent||""),this.valueElement&&(e.originalValue=this.valueElement.textContent||"")),this.property.name=s,this.property.value=o,this.nameElement&&(this.nameElement.textContent=s,this.nameElement.normalize()),this.valueElement&&(this.valueElement.textContent=o,this.valueElement.normalize());const a=t.target;this.editingCommitted(a.textContent||"",e,"forward")}.bind(this,s),!1),t.addEventListener("contextmenu",this.handleContextMenuEvent.bind(this,s),!1));const i=e.getComponentSelection();i&&i.selectAllChildren(e)}}editingNameValueKeyDown(e,t){if(t.handled)return;const n=t,i=n.target;let r;if("Enter"!==n.key||n.shiftKey)if(n.keyCode===UI.KeyboardShortcut.Keys.Esc.code||n.key===Platform.KeyboardUtilities.ESCAPE_KEY)r="cancel";else if(!e.isEditingName&&this.newProperty&&n.keyCode===UI.KeyboardShortcut.Keys.Backspace.code){const e=i.getComponentSelection();e&&e.isCollapsed&&!e.focusOffset&&(t.preventDefault(),r="backward")}else"Tab"===n.key&&(r=n.shiftKey?"backward":"forward",t.preventDefault());else r="forward";if(r){switch(r){case"cancel":this.editingCancelled(null,e);break;case"forward":case"backward":this.editingCommitted(i.textContent||"",e,r)}t.consume()}else;}editingNameValueKeyPress(e,t){const n=t,i=n.target,r=String.fromCharCode(n.charCode),s=i.selectionLeftOffset();if(e.isEditingName?":"===r:";"===r&&null!==s&&function(e,t){let n="";for(let i=0;i<t;++i){const t=e[i];"\\"===t&&""!==n?++i:n||'"'!==t&&"'"!==t?n===t&&(n=""):n=t}return!n}(i.textContent||"",s))return t.consume(!0),void this.editingCommitted(i.textContent||"",e,"forward")}async applyFreeFlowStyleTextEdit(e){if(!this.prompt||!this.parentPaneInternal.node())return;const t=this.prompt.text();if(e.isEditingName&&t.includes(":"))return void this.editingCommitted(t,e,"forward");const n=this.prompt.textWithCurrentSuggestion();if(n.includes(";"))return;const i=this.parentPaneInternal.node();if(i){if(Boolean(i.pseudoType())){if("content"===this.name.toLowerCase())return;const e=n.trim().toLowerCase();if(e.startsWith("content:")||"display: none"===e)return}}e.isEditingName?n.includes(":")?await this.applyStyleText(n,!1):this.hasBeenEditedIncrementally&&await this.applyOriginalStyle(e):this.nameElement&&await this.applyStyleText(`${this.nameElement.textContent}: ${n}`,!1)}kickFreeFlowStyleEditForTest(){const e=this.contextForTest;return this.applyFreeFlowStyleTextEdit(e)}editingEnded(e){this.setExpandable(e.hasChildren),e.expanded&&this.expand();const t=e.isEditingName?this.nameElement:this.valueElement;t&&t.parentElement&&t.parentElement.classList.remove("child-editing"),this.parentPaneInternal.setEditingStyle(!1)}editingCancelled(e,t){this.removePrompt(),this.hasBeenEditedIncrementally?this.applyOriginalStyle(t):this.newProperty&&this.treeOutline&&this.treeOutline.removeChild(this),this.updateTitle(),this.editingEnded(t)}async applyOriginalStyle(e){await this.applyStyleText(this.originalPropertyText,!1,e.originalProperty)}findSibling(e){let t=this;do{const n="forward"===e?t.nextSibling:t.previousSibling;t=n instanceof StylePropertyTreeElement?n:null}while(t&&t.inherited());return t}async editingCommitted(e,t,n){this.removePrompt(),this.editingEnded(t);const i=t.isEditingName;if(!this.nameElement||!this.valueElement)return;const r=this.nameElement.textContent||"",s=i&&r.includes(":")||!this.property;let o=!1,a=!1;const l=void 0!==t.originalName,d=l&&(this.nameElement.textContent!==t.originalName||this.valueElement.textContent!==t.originalValue),p=l&&i&&this.valueElement.textContent!==t.originalValue;let h=this;const c=i!==("forward"===n),m=this.newProperty&&!e&&(c||i);("forward"===n&&(!i||p)||"backward"===n&&i)&&(h=h.findSibling(n),h||("forward"!==n||this.newProperty&&!e?"backward"===n&&(a=!0):o=!0));let u=-1;null!==h&&this.treeOutline&&(u=this.treeOutline.rootElement().indexOfChild(h));const y=Platform.StringUtilities.isWhitespace(e),g=this.newProperty&&(p||c||!n&&!i||i&&y||s),S=this.section();if((e!==t.previousContent||d)&&!this.newProperty||g){let t;t=s?this.nameElement.textContent:y||this.newProperty&&Platform.StringUtilities.isWhitespace(this.valueElement.textContent||"")?"":i?e+": "+this.property.value:this.property.name+": "+e,await this.applyStyleText(t||"",!0),E.call(this,this.newProperty,!y,S)}else i?this.property.name=e:this.property.value=e,l||this.newProperty||this.updateTitle(),E.call(this,this.newProperty,!1,S);function E(e,t,r){if(n)if(h&&h.parent)h.startEditing(i?h.valueElement:h.nameElement);else{if(h&&!h.parent){const t=r.propertiesTreeOutline.rootElement();if("forward"===n&&y&&!i&&--u,u>=t.childCount()&&!this.newProperty)o=!0;else{const r=u>=0?t.childAt(u):null;if(r){let t=!i||p?r.nameElement:r.valueElement;return e&&y&&(t="forward"===n?r.nameElement:r.valueElement),void r.startEditing(t)}e||(a=!0)}}if(o){if(e&&!t&&i!==("backward"===n))return;r.addNewBlankProperty().startEditing()}else if(m){h=this.findSibling(n);const e=h||"backward"===n?r:r.nextEditableSibling();e&&(e.style().parentRule?e.startEditingSelector():e.moveEditorFromSelector(n))}else a&&(r.style().parentRule?r.startEditingSelector():r.moveEditorFromSelector(n))}else this.parentPaneInternal.resetFocus()}}removePrompt(){this.prompt&&(this.prompt.detach(),this.prompt=null)}styleTextAppliedForTest(){}applyStyleText(e,t,n){return this.applyStyleThrottler.schedule(this.innerApplyStyleText.bind(this,e,t,n))}async innerApplyStyleText(e,t,n){if(!this.treeOutline||!this.property)return;if(!this.style.range)return;const i=this.hasBeenEditedIncrementally;if(!(e=e.replace(/[\xA0\t]/g," ").trim()).length&&t&&this.newProperty&&!i)return void(this.parent&&this.parent.removeChild(this));const r=this.parentPaneInternal.node();this.parentPaneInternal.setUserOperation(!0),(e+=Platform.StringUtilities.findUnclosedCssQuote(e)).length&&!/;\s*$/.test(e)&&(e+=";");const s=!this.newProperty||i;let o=await this.property.setText(e,t,s);i&&t&&!o&&(t=!1,o=await this.property.setText(this.originalPropertyText,t,s)),this.parentPaneInternal.setUserOperation(!1);const a=n||this.style.propertyAt(this.property.index),l=this.property.index<this.style.allProperties().length;if(!o||!a&&l)return t&&(this.newProperty?this.treeOutline.removeChild(this):this.updateTitle()),void this.styleTextAppliedForTest();this.matchedStylesInternal.resetActiveProperties(),this.hasBeenEditedIncrementally=!0;const d=t&&!e.length,p=this.section();d&&p?p.resetToolbars():!d&&a&&(this.property=a),r===this.node()&&this.updatePane(),this.styleTextAppliedForTest()}ondblclick(){return!0}isEventWithinDisclosureTriangle(e){return e.target===this.expandElement}}