import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import*as InlineEditor from"../../ui/legacy/components/inline_editor/inline_editor.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import{FontEditorSectionManager}from"./ColorSwatchPopoverIcon.js";import*as ElementsComponents from"./components/components.js";import{ComputedStyleModel}from"./ComputedStyleModel.js";import{linkifyDeferredNodeReference}from"./DOMLinkifier.js";import{ElementsPanel}from"./ElementsPanel.js";import{ElementsSidebarPane}from"./ElementsSidebarPane.js";import{ImagePreviewPopover}from"./ImagePreviewPopover.js";import{StyleEditorWidget}from"./StyleEditorWidget.js";import{StylePropertyHighlighter}from"./StylePropertyHighlighter.js";import stylesSectionTreeStyles from"./stylesSectionTree.css.js";import stylesSidebarPaneStyles from"./stylesSidebarPane.css.js";import{StylePropertyTreeElement}from"./StylePropertyTreeElement.js";const UIStrings={noMatchingSelectorOrStyle:"No matching selector or style",invalidPropertyValue:"Invalid property value",unknownPropertyName:"Unknown property name",filter:"Filter",filterStyles:"Filter Styles",pseudoSElement:"Pseudo ::{PH1} element",inheritedFroms:"Inherited from ",insertStyleRuleBelow:"Insert Style Rule Below",constructedStylesheet:"constructed stylesheet",userAgentStylesheet:"user agent stylesheet",injectedStylesheet:"injected stylesheet",viaInspector:"via inspector",styleAttribute:"`style` attribute",sattributesStyle:"{PH1}[Attributes Style]",showAllPropertiesSMore:"Show All Properties ({PH1} more)",copySelector:"Copy `selector`",copyRule:"Copy rule",copyAllDeclarations:"Copy all declarations",incrementdecrementWithMousewheelOne:"Increment/decrement with mousewheel or up/down keys. {PH1}: R ±1, Shift: G ±1, Alt: B ±1",incrementdecrementWithMousewheelHundred:"Increment/decrement with mousewheel or up/down keys. {PH1}: ±100, Shift: ±10, Alt: ±0.1",invalidString:"{PH1}, property name: {PH2}, property value: {PH3}",newStyleRule:"New Style Rule",cssPropertyName:"`CSS` property name",cssPropertyValue:"`CSS` property value",cssSelector:"`CSS` selector"},str_=i18n.i18n.registerUIStrings("panels/elements/StylesSidebarPane.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),HIGHLIGHTABLE_PROPERTIES=[{mode:"padding",properties:["padding"]},{mode:"border",properties:["border"]},{mode:"margin",properties:["margin"]},{mode:"gap",properties:["gap","grid-gap"]},{mode:"column-gap",properties:["column-gap","grid-column-gap"]},{mode:"row-gap",properties:["row-gap","grid-row-gap"]},{mode:"grid-template-columns",properties:["grid-template-columns"]},{mode:"grid-template-rows",properties:["grid-template-rows"]},{mode:"grid-template-areas",properties:["grid-areas"]},{mode:"justify-content",properties:["justify-content"]},{mode:"align-content",properties:["align-content"]},{mode:"align-items",properties:["align-items"]},{mode:"flexibility",properties:["flex","flex-basis","flex-grow","flex-shrink"]}];let _stylesSidebarPaneInstance;const STYLE_TAG="<style>";export class StylesSidebarPane extends(Common.ObjectWrapper.eventMixin(ElementsSidebarPane)){currentToolbarPane;animatedToolbarPane;pendingWidget;pendingWidgetToggle;toolbar;toolbarPaneElement;noMatchesElement;sectionsContainer;sectionByElement;swatchPopoverHelperInternal;linkifier;decorator;lastRevealedProperty;userOperation;isEditingStyle;filterRegexInternal;isActivePropertyHighlighted;initialUpdateCompleted;hasMatchedStyles;sectionBlocks;idleCallbackManager;needsForceUpdate;resizeThrottler;imagePreviewPopover;activeCSSAngle;static instance(){return _stylesSidebarPaneInstance||(_stylesSidebarPaneInstance=new StylesSidebarPane),_stylesSidebarPaneInstance}constructor(){super(!0),this.setMinimumSize(96,26),this.registerCSSFiles([stylesSidebarPaneStyles]),Common.Settings.Settings.instance().moduleSetting("colorFormat").addChangeListener(this.update.bind(this)),Common.Settings.Settings.instance().moduleSetting("textEditorIndent").addChangeListener(this.update.bind(this)),this.currentToolbarPane=null,this.animatedToolbarPane=null,this.pendingWidget=null,this.pendingWidgetToggle=null,this.toolbar=null,this.toolbarPaneElement=this.createStylesSidebarToolbar(),this.computedStyleModelInternal=new ComputedStyleModel,this.noMatchesElement=this.contentElement.createChild("div","gray-info-message hidden"),this.noMatchesElement.textContent=i18nString(UIStrings.noMatchingSelectorOrStyle),this.sectionsContainer=this.contentElement.createChild("div"),UI.ARIAUtils.markAsList(this.sectionsContainer),this.sectionsContainer.addEventListener("keydown",this.sectionsContainerKeyDown.bind(this),!1),this.sectionsContainer.addEventListener("focusin",this.sectionsContainerFocusChanged.bind(this),!1),this.sectionsContainer.addEventListener("focusout",this.sectionsContainerFocusChanged.bind(this),!1),this.sectionByElement=new WeakMap,this.swatchPopoverHelperInternal=new InlineEditor.SwatchPopoverHelper.SwatchPopoverHelper,this.swatchPopoverHelperInternal.addEventListener(InlineEditor.SwatchPopoverHelper.Events.WillShowPopover,this.hideAllPopovers,this),this.linkifier=new Components.Linkifier.Linkifier(_maxLinkLength,!0),this.decorator=new StylePropertyHighlighter(this),this.lastRevealedProperty=null,this.userOperation=!1,this.isEditingStyle=!1,this.filterRegexInternal=null,this.isActivePropertyHighlighted=!1,this.initialUpdateCompleted=!1,this.hasMatchedStyles=!1,this.contentElement.classList.add("styles-pane"),this.sectionBlocks=[],this.idleCallbackManager=null,this.needsForceUpdate=!1,_stylesSidebarPaneInstance=this,UI.Context.Context.instance().addFlavorChangeListener(SDK.DOMModel.DOMNode,this.forceUpdate,this),this.contentElement.addEventListener("copy",this.clipboardCopy.bind(this)),this.resizeThrottler=new Common.Throttler.Throttler(100),this.imagePreviewPopover=new ImagePreviewPopover(this.contentElement,(e=>{const t=e.composedPath()[0];return t instanceof Element?t:null}),(()=>this.node())),this.activeCSSAngle=null}swatchPopoverHelper(){return this.swatchPopoverHelperInternal}setUserOperation(e){this.userOperation=e}static createExclamationMark(e,t){const n=document.createElement("span",{is:"dt-icon-label"});let i;n.className="exclamation-mark",StylesSidebarPane.ignoreErrorsForProperty(e)||(n.type="smallicon-warning"),t?(UI.Tooltip.Tooltip.install(n,t),i=t):(i=SDK.CSSMetadata.cssMetadata().isCSSPropertyName(e.name)?i18nString(UIStrings.invalidPropertyValue):i18nString(UIStrings.unknownPropertyName),UI.Tooltip.Tooltip.install(n,i));const s=i18nString(UIStrings.invalidString,{PH1:i,PH2:e.name,PH3:e.value});return e.setDisplayedStringForInvalidProperty(s),n}static ignoreErrorsForProperty(e){function t(e){return!e.startsWith("-webkit-")&&/^[-_][\w\d]+-\w/.test(e)}const n=e.name.toLowerCase();if("_"===n.charAt(0))return!0;if("filter"===n)return!0;if(n.startsWith("scrollbar-"))return!0;if(t(n))return!0;const i=e.value.toLowerCase();return!!i.endsWith("\\9")||!!t(i)}static createPropertyFilterElement(e,t,n){const i=document.createElement("input");function s(){const e=i.value?new RegExp(Platform.StringUtilities.escapeForRegExp(i.value),"i"):null;n(e)}return i.type="search",i.classList.add("custom-search-input"),i.placeholder=e,i.addEventListener("input",s,!1),i.addEventListener("keydown",(function(e){const t=e;t.key===Platform.KeyboardUtilities.ESCAPE_KEY&&i.value&&(t.consume(!0),i.value="",s())}),!1),i}static formatLeadingProperties(e){const t=e.headerText(),n=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),i=e.style(),s=[];for(const e of i.leadingProperties())e.disabled?s.push(`${n}/* ${e.name}: ${e.value}; */`):s.push(`${n}${e.name}: ${e.value};`);const r=s.join("\n");return{allDeclarationText:r,ruleText:`${t} {\n${r}\n}`}}revealProperty(e){this.decorator.highlightProperty(e),this.lastRevealedProperty=e,this.update()}jumpToProperty(e){this.decorator.findAndHighlightPropertyName(e)}forceUpdate(){this.needsForceUpdate=!0,this.swatchPopoverHelperInternal.hide(),this.resetCache(),this.update()}sectionsContainerKeyDown(e){const t=this.sectionsContainer.ownerDocument.deepActiveElement();if(!t)return;const n=this.sectionByElement.get(t);if(!n)return;let i=null,s=!1;switch(e.key){case"ArrowUp":case"ArrowLeft":i=n.previousSibling()||n.lastSibling(),s=!1;break;case"ArrowDown":case"ArrowRight":i=n.nextSibling()||n.firstSibling(),s=!0;break;case"Home":i=n.firstSibling(),s=!0;break;case"End":i=n.lastSibling(),s=!1}i&&this.filterRegexInternal&&(i=i.findCurrentOrNextVisible(s)),i&&(i.element.focus(),e.consume(!0))}sectionsContainerFocusChanged(){this.resetFocus()}resetFocus(){if(this.noMatchesElement.classList.contains("hidden")&&this.sectionBlocks[0]&&this.sectionBlocks[0].sections[0]){const e=this.sectionBlocks[0].sections[0].findCurrentOrNextVisible(!0);e&&(e.element.tabIndex=this.sectionsContainer.hasFocus()?-1:0)}}onAddButtonLongClick(e){const t=this.cssModel();if(!t)return;const n=t.styleSheetHeaders().filter((function(e){return!e.isViaInspector()&&!e.isInline&&Boolean(e.resourceURL())})),i=[];for(let e=0;e<n.length;++e){const t=n[e],s=this.createNewRuleInStyleSheet.bind(this,t);i.push({text:Bindings.ResourceUtils.displayNameForURL(t.resourceURL()),handler:s})}i.sort((function(e,t){return Platform.StringUtilities.naturalOrderComparator(e.text,t.text)}));const s=new UI.ContextMenu.ContextMenu(e);for(let e=0;e<i.length;++e){const t=i[e];s.defaultSection().appendItem(t.text,t.handler)}s.footerSection().appendItem("inspector-stylesheet",this.createNewRuleInViaInspectorStyleSheet.bind(this)),s.show()}onFilterChanged(e){this.filterRegexInternal=e,this.updateFilter(),this.resetFocus()}refreshUpdate(e,t){if(t)for(const e of this.allSections())e instanceof BlankStylePropertiesSection&&e.isBlank||e.updateVarFunctions(t);if(this.isEditingStyle)return;const n=this.node();if(n){for(const t of this.allSections())t instanceof BlankStylePropertiesSection&&t.isBlank||t.update(t===e);this.filterRegexInternal&&this.updateFilter(),this.swatchPopoverHelper().reposition(),this.nodeStylesUpdatedForTest(n,!1)}}async doUpdate(){this.initialUpdateCompleted||setTimeout((()=>{this.initialUpdateCompleted||this.sectionsContainer.createChild("span","spinner")}),200);const e=await this.fetchMatchedCascade();await this.innerRebuildUpdate(e),this.initialUpdateCompleted||(this.initialUpdateCompleted=!0,this.dispatchEventToListeners("InitialUpdateCompleted")),this.dispatchEventToListeners("StylesUpdateCompleted",{hasMatchedStyles:this.hasMatchedStyles})}onResize(){this.resizeThrottler.schedule(this.innerResize.bind(this))}innerResize(){const e=this.contentElement.getBoundingClientRect().width+"px";return this.allSections().forEach((t=>{t.propertiesTreeOutline.element.style.width=e})),Promise.resolve()}resetCache(){const e=this.cssModel();e&&e.discardCachedMatchedCascade()}fetchMatchedCascade(){const e=this.node();if(!e||!this.cssModel())return Promise.resolve(null);const t=this.cssModel();return t?t.cachedMatchedCascadeForNode(e).then(function(e){return e&&e.node()===this.node()?e:null}.bind(this)):Promise.resolve(null)}setEditingStyle(e,t){this.isEditingStyle!==e&&(this.contentElement.classList.toggle("is-editing-style",e),this.isEditingStyle=e,this.setActiveProperty(null))}setActiveProperty(e){if(this.isActivePropertyHighlighted&&SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight(),this.isActivePropertyHighlighted=!1,!this.node())return;if(!e||e.overloaded()||e.inherited())return;const t=e.property.ownerStyle.parentRule,n=t instanceof SDK.CSSRule.CSSStyleRule?t.selectorText():void 0;for(const{properties:t,mode:i}of HIGHLIGHTABLE_PROPERTIES){if(!t.includes(e.name))continue;const s=this.node();if(s){s.domModel().overlayModel().highlightInOverlay({node:this.node(),selectorList:n},i),this.isActivePropertyHighlighted=!0;break}}}onCSSModelChanged(e){const t=e?.data&&"edit"in e.data?e.data.edit:null;if(t)for(const e of this.allSections())e.styleSheetEdited(t);else this.userOperation||this.isEditingStyle||(this.resetCache(),this.update())}focusedSectionIndex(){let e=0;for(const t of this.sectionBlocks)for(const n of t.sections){if(n.element.hasFocus())return e;e++}return-1}continueEditingElement(e,t){const n=this.allSections()[e];if(n){const e=n.closestPropertyForEditing(t);if(!e)return void n.element.focus();e.startEditing()}}async innerRebuildUpdate(e){if(this.needsForceUpdate)this.needsForceUpdate=!1;else if(this.isEditingStyle||this.userOperation)return;const t=this.focusedSectionIndex();this.linkifier.reset();const n=this.sectionBlocks.map((e=>e.sections)).flat();this.sectionBlocks=[];const i=this.node();if(this.hasMatchedStyles=null!==e&&null!==i,!this.hasMatchedStyles)return this.sectionsContainer.removeChildren(),void this.noMatchesElement.classList.remove("hidden");this.sectionBlocks=await this.rebuildSectionsForMatchedStyleRules(e);const s=this.sectionBlocks.map((e=>e.sections)).flat(),r=StyleEditorWidget.instance(),o=r.getSection();if(o){r.unbindContext();for(const[e,t]of n.entries())o===t&&e<s.length&&r.bindContext(this,s[e])}this.sectionsContainer.removeChildren();const l=document.createDocumentFragment();let a=0,c=null;for(const e of this.sectionBlocks){const n=e.titleElement();n&&l.appendChild(n);for(const n of e.sections)l.appendChild(n.element),a===t&&(c=n.element),a++}this.sectionsContainer.appendChild(l),c&&c.focus(),t>=a&&this.sectionBlocks[0].sections[0].element.focus(),this.sectionsContainerFocusChanged(),this.filterRegexInternal?this.updateFilter():this.noMatchesElement.classList.toggle("hidden",this.sectionBlocks.length>0),this.nodeStylesUpdatedForTest(i,!0),this.lastRevealedProperty&&(this.decorator.highlightProperty(this.lastRevealedProperty),this.lastRevealedProperty=null),this.swatchPopoverHelper().reposition(),Host.userMetrics.panelLoaded("elements","DevTools.Launch.Elements"),this.dispatchEventToListeners("StylesUpdateCompleted",{hasMatchedStyles:!1})}nodeStylesUpdatedForTest(e,t){}async rebuildSectionsForMatchedStyleRules(e){this.idleCallbackManager&&this.idleCallbackManager.discard(),this.idleCallbackManager=new IdleCallbackManager;const t=[new SectionBlock(null)];let n=0,i=null;for(const s of e.nodeStyles()){const r=e.isInherited(s)?e.nodeForStyle(s):null;if(r&&r!==i){i=r;const e=await SectionBlock.createInheritedNodeBlock(i);t.push(e)}const o=t[t.length-1];o&&this.idleCallbackManager.schedule((()=>{const t=new StylePropertiesSection(this,e,s,n);n++,o.sections.push(t)}))}let s=[];const r=e.pseudoTypes();r.delete("before")&&s.push("before"),s=s.concat([...r].sort());for(const i of s){const s=SectionBlock.createPseudoTypeBlock(i);for(const t of e.pseudoStyles(i))this.idleCallbackManager.schedule((()=>{const i=new StylePropertiesSection(this,e,t,n);n++,s.sections.push(i)}));t.push(s)}for(const i of e.keyframes()){const s=SectionBlock.createKeyframesBlock(i.name().text);for(const t of i.keyframes())this.idleCallbackManager.schedule((()=>{s.sections.push(new KeyframePropertiesSection(this,e,t.style,n)),n++}));t.push(s)}return await this.idleCallbackManager.awaitDone(),t}async createNewRuleInViaInspectorStyleSheet(){const e=this.cssModel(),t=this.node();if(!e||!t)return;this.setUserOperation(!0);const n=await e.requestViaInspectorStylesheet(t);this.setUserOperation(!1),await this.createNewRuleInStyleSheet(n)}async createNewRuleInStyleSheet(e){if(!e)return;const t=((await e.requestContent()).content||"").split("\n"),n=TextUtils.TextRange.TextRange.createFromLocation(t.length-1,t[t.length-1].length);this.sectionBlocks&&this.sectionBlocks.length>0&&this.addBlankSection(this.sectionBlocks[0].sections[0],e.id,n)}addBlankSection(e,t,n){const i=this.node(),s=new BlankStylePropertiesSection(this,e.matchedStyles,i?i.simpleSelector():"",t,n,e.style(),0);this.sectionsContainer.insertBefore(s.element,e.element.nextSibling);for(const t of this.sectionBlocks){const n=t.sections.indexOf(e);-1!==n&&(t.sections.splice(n+1,0,s),s.startEditingSelector())}let r=0;for(const e of this.sectionBlocks)for(const t of e.sections)t.setSectionIdx(r),r++}removeSection(e){for(const t of this.sectionBlocks){const n=t.sections.indexOf(e);-1!==n&&(t.sections.splice(n,1),e.element.remove())}}filterRegex(){return this.filterRegexInternal}updateFilter(){let e=!1;for(const t of this.sectionBlocks)e=t.updateFilter()||e;this.noMatchesElement.classList.toggle("hidden",Boolean(e))}willHide(){this.hideAllPopovers(),super.willHide()}hideAllPopovers(){this.swatchPopoverHelperInternal.hide(),this.imagePreviewPopover.hide(),this.activeCSSAngle&&(this.activeCSSAngle.minify(),this.activeCSSAngle=null)}allSections(){let e=[];for(const t of this.sectionBlocks)e=e.concat(t.sections);return e}clipboardCopy(e){Host.userMetrics.actionTaken(Host.UserMetrics.Action.StyleRuleCopied)}createStylesSidebarToolbar(){const e=this.contentElement.createChild("div","styles-sidebar-pane-toolbar-container"),t=e.createChild("div","hbox styles-sidebar-pane-toolbar"),n=t.createChild("div","styles-sidebar-pane-filter-box"),i=StylesSidebarPane.createPropertyFilterElement(i18nString(UIStrings.filter),t,this.onFilterChanged.bind(this));UI.ARIAUtils.setAccessibleName(i,i18nString(UIStrings.filterStyles)),n.appendChild(i);const s=new UI.Toolbar.Toolbar("styles-pane-toolbar",t);s.makeToggledGray(),s.appendItemsAtLocation("styles-sidebarpane-toolbar"),this.toolbar=s;return e.createChild("div","styles-sidebar-toolbar-pane-container").createChild("div","styles-sidebar-toolbar-pane")}showToolbarPane(e,t){this.pendingWidgetToggle&&this.pendingWidgetToggle.setToggled(!1),this.pendingWidgetToggle=t,this.animatedToolbarPane?this.pendingWidget=e:this.startToolbarPaneAnimation(e),e&&t&&t.setToggled(!0)}appendToolbarItem(e){this.toolbar&&this.toolbar.appendToolbarItem(e)}startToolbarPaneAnimation(e){if(e===this.currentToolbarPane)return;if(e&&this.currentToolbarPane)return this.currentToolbarPane.detach(),e.show(this.toolbarPaneElement),this.currentToolbarPane=e,void this.currentToolbarPane.focus();this.animatedToolbarPane=e,this.currentToolbarPane?this.toolbarPaneElement.style.animationName="styles-element-state-pane-slideout":e&&(this.toolbarPaneElement.style.animationName="styles-element-state-pane-slidein"),e&&e.show(this.toolbarPaneElement);const t=function(){this.toolbarPaneElement.style.removeProperty("animation-name"),this.toolbarPaneElement.removeEventListener("animationend",t,!1),this.currentToolbarPane&&this.currentToolbarPane.detach();this.currentToolbarPane=this.animatedToolbarPane,this.currentToolbarPane&&this.currentToolbarPane.focus();this.animatedToolbarPane=null,this.pendingWidget&&(this.startToolbarPaneAnimation(this.pendingWidget),this.pendingWidget=null)}.bind(this);this.toolbarPaneElement.addEventListener("animationend",t,!1)}}export const _maxLinkLength=23;export class SectionBlock{titleElementInternal;sections;constructor(e){this.titleElementInternal=e,this.sections=[]}static createPseudoTypeBlock(e){const t=document.createElement("div");return t.className="sidebar-separator",t.textContent=i18nString(UIStrings.pseudoSElement,{PH1:e}),new SectionBlock(t)}static createKeyframesBlock(e){const t=document.createElement("div");return t.className="sidebar-separator",t.textContent=`@keyframes ${e}`,new SectionBlock(t)}static async createInheritedNodeBlock(e){const t=document.createElement("div");t.className="sidebar-separator",UI.UIUtils.createTextChild(t,i18nString(UIStrings.inheritedFroms));const n=await Common.Linkifier.Linkifier.linkify(e,{preventKeyboardFocus:!0,tooltip:void 0});return t.appendChild(n),new SectionBlock(t)}updateFilter(){let e=!1;for(const t of this.sections)e=t.updateFilter()||e;return this.titleElementInternal&&this.titleElementInternal.classList.toggle("hidden",!e),Boolean(e)}titleElement(){return this.titleElementInternal}}export class IdleCallbackManager{discarded;promises;constructor(){this.discarded=!1,this.promises=[]}discard(){this.discarded=!0}schedule(e,t=100){this.discarded||this.promises.push(new Promise(((n,i)=>{window.requestIdleCallback((()=>{if(this.discarded)return n();(()=>{try{e(),n()}catch(e){i(e)}})()}),{timeout:t})})))}awaitDone(){return Promise.all(this.promises)}}export class StylePropertiesSection{parentPane;styleInternal;matchedStyles;editable;hoverTimer;willCauseCancelEditing;forceShowAll;originalPropertiesCount;element;innerElement;titleElement;propertiesTreeOutline;showAllButton;selectorElement;newStyleRuleToolbar;fontEditorToolbar;fontEditorSectionManager;fontEditorButton;selectedSinceMouseDown;elementToSelectorIndex;navigable;selectorRefElement;selectorContainer;fontPopoverIcon;hoverableSelectorsMode;isHiddenInternal;queryListElement;nextEditorTriggerButtonIdx=1;sectionIdx=0;constructor(e,t,n,i){this.parentPane=e,this.sectionIdx=i,this.styleInternal=n,this.matchedStyles=t,this.editable=Boolean(n.styleSheetId&&n.range),this.hoverTimer=null,this.willCauseCancelEditing=!1,this.forceShowAll=!1,this.originalPropertiesCount=n.leadingProperties().length;const s=n.parentRule;this.element=document.createElement("div"),this.element.classList.add("styles-section"),this.element.classList.add("matched-styles"),this.element.classList.add("monospace"),UI.ARIAUtils.setAccessibleName(this.element,`${this.headerText()}, css selector`),this.element.tabIndex=-1,UI.ARIAUtils.markAsListitem(this.element),this.element.addEventListener("keydown",this.onKeyDown.bind(this),!1),e.sectionByElement.set(this.element,this),this.innerElement=this.element.createChild("div"),this.titleElement=this.innerElement.createChild("div","styles-section-title "+(s?"styles-selector":"")),this.propertiesTreeOutline=new UI.TreeOutline.TreeOutlineInShadow,this.propertiesTreeOutline.setFocusable(!1),this.propertiesTreeOutline.registerCSSFiles([stylesSectionTreeStyles]),this.propertiesTreeOutline.element.classList.add("style-properties","matched-styles","monospace"),this.propertiesTreeOutline.section=this,this.innerElement.appendChild(this.propertiesTreeOutline.element),this.showAllButton=UI.UIUtils.createTextButton("",this.showAllItems.bind(this),"styles-show-all"),this.innerElement.appendChild(this.showAllButton);const r=document.createElement("div");this.selectorElement=document.createElement("span"),UI.ARIAUtils.setAccessibleName(this.selectorElement,i18nString(UIStrings.cssSelector)),this.selectorElement.classList.add("selector"),this.selectorElement.textContent=this.headerText(),r.appendChild(this.selectorElement),this.selectorElement.addEventListener("mouseenter",this.onMouseEnterSelector.bind(this),!1),this.selectorElement.addEventListener("mousemove",(e=>e.consume()),!1),this.selectorElement.addEventListener("mouseleave",this.onMouseOutSelector.bind(this),!1);r.createChild("span","sidebar-pane-open-brace").textContent=" {",r.addEventListener("mousedown",this.handleEmptySpaceMouseDown.bind(this),!1),r.addEventListener("click",this.handleSelectorContainerClick.bind(this),!1);if(this.innerElement.createChild("div","sidebar-pane-closing-brace").textContent="}",this.styleInternal.parentRule){const e=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.insertStyleRuleBelow),"largeicon-add");e.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.onNewRuleClick,this),e.element.tabIndex=-1,this.newStyleRuleToolbar||(this.newStyleRuleToolbar=new UI.Toolbar.Toolbar("sidebar-pane-section-toolbar new-rule-toolbar",this.innerElement)),this.newStyleRuleToolbar.appendToolbarItem(e),UI.ARIAUtils.markAsHidden(this.newStyleRuleToolbar.element)}if(Root.Runtime.experiments.isEnabled("fontEditor")&&this.editable&&(this.fontEditorToolbar=new UI.Toolbar.Toolbar("sidebar-pane-section-toolbar",this.innerElement),this.fontEditorSectionManager=new FontEditorSectionManager(this.parentPane.swatchPopoverHelper(),this),this.fontEditorButton=new UI.Toolbar.ToolbarButton("Font Editor","largeicon-font-editor"),this.fontEditorButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this.onFontEditorButtonClicked()}),this),this.fontEditorButton.element.addEventListener("keydown",(e=>{isEnterOrSpaceKey(e)&&(e.consume(!0),this.onFontEditorButtonClicked())}),!1),this.fontEditorToolbar.appendToolbarItem(this.fontEditorButton),this.styleInternal.type===SDK.CSSStyleDeclaration.Type.Inline?this.newStyleRuleToolbar&&this.newStyleRuleToolbar.element.classList.add("shifted-toolbar"):this.fontEditorToolbar.element.classList.add("font-toolbar-hidden")),this.selectorElement.addEventListener("click",this.handleSelectorClick.bind(this),!1),this.element.addEventListener("contextmenu",this.handleContextMenuEvent.bind(this),!1),this.element.addEventListener("mousedown",this.handleEmptySpaceMouseDown.bind(this),!1),this.element.addEventListener("click",this.handleEmptySpaceClick.bind(this),!1),this.element.addEventListener("mousemove",this.onMouseMove.bind(this),!1),this.element.addEventListener("mouseleave",this.onMouseLeave.bind(this),!1),this.selectedSinceMouseDown=!1,this.elementToSelectorIndex=new WeakMap,s)if(s.isUserAgent()||s.isInjected())this.editable=!1;else if(s.styleSheetId){const e=s.cssModel().styleSheetHeaderForId(s.styleSheetId);this.navigable=e&&!e.isAnonymousInlineStyleSheet()}this.queryListElement=this.titleElement.createChild("div","query-list query-matches"),this.selectorRefElement=this.titleElement.createChild("div","styles-section-subtitle"),this.updateQueryList(),this.updateRuleOrigin(),this.titleElement.appendChild(r),this.selectorContainer=r,this.navigable&&this.element.classList.add("navigable"),this.editable||(this.element.classList.add("read-only"),this.propertiesTreeOutline.element.classList.add("read-only")),this.fontPopoverIcon=null,this.hoverableSelectorsMode=!1,this.isHiddenInternal=!1,this.markSelectorMatches(),this.onpopulate()}setSectionIdx(e){this.sectionIdx=e,this.onpopulate()}getSectionIdx(){return this.sectionIdx}registerFontProperty(e){this.fontEditorSectionManager&&this.fontEditorSectionManager.registerFontProperty(e),this.fontEditorToolbar&&(this.fontEditorToolbar.element.classList.remove("font-toolbar-hidden"),this.newStyleRuleToolbar&&this.newStyleRuleToolbar.element.classList.add("shifted-toolbar"))}resetToolbars(){this.parentPane.swatchPopoverHelper().isShowing()||this.styleInternal.type===SDK.CSSStyleDeclaration.Type.Inline||(this.fontEditorToolbar&&this.fontEditorToolbar.element.classList.add("font-toolbar-hidden"),this.newStyleRuleToolbar&&this.newStyleRuleToolbar.element.classList.remove("shifted-toolbar"))}static createRuleOriginNode(e,t,n){if(!n)return document.createTextNode("");const i=this.getRuleLocationFromCSSRule(n),s=n.styleSheetId?e.cssModel().styleSheetHeaderForId(n.styleSheetId):null;function r(){return n&&i&&n.styleSheetId&&s&&!s.isAnonymousInlineStyleSheet()?StylePropertiesSection.linkifyRuleLocation(e.cssModel(),t,n.styleSheetId,i):null}function o(e){if(s?.ownerNode){const t=linkifyDeferredNodeReference(s.ownerNode,{preventKeyboardFocus:!1,tooltip:void 0});return t.textContent=e,t}return null}if(s?.isMutable&&!s.isViaInspector()){const e=s.isConstructedByNew()?null:r();if(e)return e;const t=s.isConstructedByNew()?i18nString(UIStrings.constructedStylesheet):"<style>",n=o(t);return n||document.createTextNode(t)}const l=r();if(l)return l;if(n.isUserAgent())return document.createTextNode(i18nString(UIStrings.userAgentStylesheet));if(n.isInjected())return document.createTextNode(i18nString(UIStrings.injectedStylesheet));if(n.isViaInspector())return document.createTextNode(i18nString(UIStrings.viaInspector));const a=o("<style>");return a||document.createTextNode("")}static getRuleLocationFromCSSRule(e){let t;return e instanceof SDK.CSSRule.CSSStyleRule?t=e.style.range:e instanceof SDK.CSSRule.CSSKeyframeRule&&(t=e.key().range),t}static tryNavigateToRuleLocation(e,t){if(!t)return;const n=this.getRuleLocationFromCSSRule(t),i=t.styleSheetId?e.cssModel().styleSheetHeaderForId(t.styleSheetId):null;if(n&&t.styleSheetId&&i&&!i.isAnonymousInlineStyleSheet()){const i=this.getCSSSelectorLocation(e.cssModel(),t.styleSheetId,n);this.revealSelectorSource(i,!0)}}static linkifyRuleLocation(e,t,n,i){const s=this.getCSSSelectorLocation(e,n,i);return t.linkifyCSSLocation(s)}static getCSSSelectorLocation(e,t,n){const i=e.styleSheetHeaderForId(t),s=i.lineNumberInSource(n.startLine),r=i.columnNumberInSource(n.startLine,n.startColumn);return new SDK.CSSModel.CSSLocation(i,s,r)}getFocused(){return this.propertiesTreeOutline.shadowRoot.activeElement||null}focusNext(e){const t=this.getFocused();t&&(t.tabIndex=-1),e.focus(),this.propertiesTreeOutline.shadowRoot.contains(e)&&(e.tabIndex=0)}ruleNavigation(e){if(e.altKey||e.ctrlKey||e.metaKey||e.shiftKey)return;const t=this.getFocused();let n=null;const i=Array.from(this.propertiesTreeOutline.shadowRoot.querySelectorAll("[tabindex]"));if(0===i.length)return;const s=t?i.indexOf(t):-1;if("ArrowLeft"===e.key)n=i[s-1]||this.element;else if("ArrowRight"===e.key)n=i[s+1]||this.element;else if("ArrowUp"===e.key||"ArrowDown"===e.key)return void this.focusNext(this.element);n&&(this.focusNext(n),e.consume(!0))}onKeyDown(e){const t=e;if(!(UI.UIUtils.isEditing()||!this.editable||t.altKey||t.ctrlKey||t.metaKey))switch(t.key){case"Enter":case" ":this.startEditingAtFirstPosition(),t.consume(!0);break;case"ArrowLeft":case"ArrowRight":case"ArrowUp":case"ArrowDown":this.ruleNavigation(t);break;default:1===t.key.length&&this.addNewBlankProperty(0).startEditing()}}setSectionHovered(e){this.element.classList.toggle("styles-panel-hovered",e),this.propertiesTreeOutline.element.classList.toggle("styles-panel-hovered",e),this.hoverableSelectorsMode!==e&&(this.hoverableSelectorsMode=e,this.markSelectorMatches())}onMouseLeave(e){this.setSectionHovered(!1),this.parentPane.setActiveProperty(null)}onMouseMove(e){const t=UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e);this.setSectionHovered(t);const n=this.propertiesTreeOutline.treeElementFromEvent(e);n instanceof StylePropertyTreeElement?this.parentPane.setActiveProperty(n):this.parentPane.setActiveProperty(null);const i=this.element.getComponentSelection();!this.selectedSinceMouseDown&&i&&i.toString()&&(this.selectedSinceMouseDown=!0)}onFontEditorButtonClicked(){this.fontEditorSectionManager&&this.fontEditorButton&&this.fontEditorSectionManager.showPopover(this.fontEditorButton.element,this.parentPane)}style(){return this.styleInternal}headerText(){const e=this.matchedStyles.nodeForStyle(this.styleInternal);return this.styleInternal.type===SDK.CSSStyleDeclaration.Type.Inline?this.matchedStyles.isInherited(this.styleInternal)?i18nString(UIStrings.styleAttribute):"element.style":e&&this.styleInternal.type===SDK.CSSStyleDeclaration.Type.Attributes?i18nString(UIStrings.sattributesStyle,{PH1:e.nodeNameInCorrectCase()}):this.styleInternal.parentRule instanceof SDK.CSSRule.CSSStyleRule?this.styleInternal.parentRule.selectorText():""}onMouseOutSelector(){this.hoverTimer&&clearTimeout(this.hoverTimer),SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()}onMouseEnterSelector(){this.hoverTimer&&clearTimeout(this.hoverTimer),this.hoverTimer=setTimeout(this.highlight.bind(this),300)}highlight(e="all"){SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight();const t=this.parentPane.node();if(!t)return;const n=this.styleInternal.parentRule&&this.styleInternal.parentRule instanceof SDK.CSSRule.CSSStyleRule?this.styleInternal.parentRule.selectorText():void 0;t.domModel().overlayModel().highlightInOverlay({node:t,selectorList:n},e)}firstSibling(){const e=this.element.parentElement;if(!e)return null;let t=e.firstChild;for(;t;){const e=this.parentPane.sectionByElement.get(t);if(e)return e;t=t.nextSibling}return null}findCurrentOrNextVisible(e,t){if(!this.isHidden())return this;if(this===t)return null;t||(t=this);let n=null;const i=e?this.nextSibling():this.previousSibling();if(i)n=i.findCurrentOrNextVisible(e,t);else{const i=e?this.firstSibling():this.lastSibling();i&&(n=i.findCurrentOrNextVisible(e,t))}return n}lastSibling(){const e=this.element.parentElement;if(!e)return null;let t=e.lastChild;for(;t;){const e=this.parentPane.sectionByElement.get(t);if(e)return e;t=t.previousSibling}return null}nextSibling(){let e=this.element;do{e=e.nextSibling}while(e&&!this.parentPane.sectionByElement.has(e));if(e)return this.parentPane.sectionByElement.get(e)}previousSibling(){let e=this.element;do{e=e.previousSibling}while(e&&!this.parentPane.sectionByElement.has(e));if(e)return this.parentPane.sectionByElement.get(e)}onNewRuleClick(e){e.data.consume();const t=this.styleInternal.parentRule;if(!t||!t.style.range||void 0===t.styleSheetId)return;const n=TextUtils.TextRange.TextRange.createFromLocation(t.style.range.endLine,t.style.range.endColumn+1);this.parentPane.addBlankSection(this,t.styleSheetId,n)}styleSheetEdited(e){const t=this.styleInternal.parentRule;t?t.rebase(e):this.styleInternal.rebase(e),this.updateQueryList(),this.updateRuleOrigin()}createMediaList(e){for(let t=e.length-1;t>=0;--t){const n=e[t];if(!n.text||!n.text.includes("(")&&"print"!==n.text)continue;let i,s="",r="";switch(n.source){case SDK.CSSMedia.Source.LINKED_SHEET:case SDK.CSSMedia.Source.INLINE_SHEET:r=`media="${n.text}"`;break;case SDK.CSSMedia.Source.MEDIA_RULE:s="@media",r=n.text,n.styleSheetId&&(i=this.handleQueryRuleClick.bind(this,n));break;case SDK.CSSMedia.Source.IMPORT_RULE:r=`@import ${n.text}`}const o=new ElementsComponents.CSSQuery.CSSQuery;o.data={queryPrefix:s,queryText:r,onQueryTextClick:i},this.queryListElement.append(o)}}createContainerQueryList(e){for(let t=e.length-1;t>=0;--t){const n=e[t];if(!n.text)continue;let i;n.styleSheetId&&(i=this.handleQueryRuleClick.bind(this,n));const s=new ElementsComponents.CSSQuery.CSSQuery;s.data={queryPrefix:"@container",queryName:n.name,queryText:n.text,onQueryTextClick:i},this.queryListElement.append(s),this.addContainerForContainerQuery(n)}}async addContainerForContainerQuery(e){const t=await e.getContainerForNode(this.matchedStyles.node().id);if(!t)return;const n=new ElementsComponents.QueryContainer.QueryContainer;n.data={container:ElementsComponents.Helper.legacyNodeToElementsComponentsNode(t.containerNode),queryName:e.name,onContainerLinkClick:e=>{e.preventDefault(),ElementsPanel.instance().revealAndSelectNode(t.containerNode,!0,!0),t.containerNode.scrollIntoView()}},n.addEventListener("queriedsizerequested",(async()=>{const e=await t.getContainerSizeDetails();e&&n.updateContainerQueriedSizeDetails(e)})),this.queryListElement.prepend(n)}updateQueryList(){this.queryListElement.removeChildren(),this.styleInternal.parentRule&&this.styleInternal.parentRule instanceof SDK.CSSRule.CSSStyleRule&&(this.createMediaList(this.styleInternal.parentRule.media),this.createContainerQueryList(this.styleInternal.parentRule.containerQueries))}isPropertyInherited(e){return!!this.matchedStyles.isInherited(this.styleInternal)&&!SDK.CSSMetadata.cssMetadata().isPropertyInherited(e)}nextEditableSibling(){let e=this;do{e=e.nextSibling()}while(e&&!e.editable);if(!e)for(e=this.firstSibling();e&&!e.editable;)e=e.nextSibling();return e&&e.editable?e:null}previousEditableSibling(){let e=this;do{e=e.previousSibling()}while(e&&!e.editable);if(!e)for(e=this.lastSibling();e&&!e.editable;)e=e.previousSibling();return e&&e.editable?e:null}refreshUpdate(e){this.parentPane.refreshUpdate(this,e)}updateVarFunctions(e){let t=this.propertiesTreeOutline.firstChild();for(;t;)t!==e&&t instanceof StylePropertyTreeElement&&t.updateTitleIfComputedValueChanged(),t=t.traverseNextTreeElement(!1,null,!0)}update(e){if(this.selectorElement.textContent=this.headerText(),this.markSelectorMatches(),e)this.onpopulate();else{let e=this.propertiesTreeOutline.firstChild();for(;e&&e instanceof StylePropertyTreeElement;)e.setOverloaded(this.isPropertyOverloaded(e.property)),e=e.traverseNextTreeElement(!1,null,!0)}}showAllItems(e){e&&e.consume(),this.forceShowAll||(this.forceShowAll=!0,this.onpopulate())}onpopulate(){this.parentPane.setActiveProperty(null),this.nextEditorTriggerButtonIdx=1,this.propertiesTreeOutline.removeChildren();const e=this.styleInternal;let t=0;const n=e.leadingProperties(),i=StylePropertiesSection.MaxProperties+n.length-this.originalPropertiesCount;for(const s of n){if(!this.forceShowAll&&t>=i)break;t++;const n=Boolean(e.longhandProperties(s.name).length),r=this.isPropertyInherited(s.name),o=this.isPropertyOverloaded(s);if(e.parentRule&&e.parentRule.isUserAgent()&&r)continue;const l=new StylePropertyTreeElement(this.parentPane,this.matchedStyles,s,n,r,o,!1);this.propertiesTreeOutline.appendChild(l)}t<n.length?(this.showAllButton.classList.remove("hidden"),this.showAllButton.textContent=i18nString(UIStrings.showAllPropertiesSMore,{PH1:n.length-t})):this.showAllButton.classList.add("hidden")}isPropertyOverloaded(e){return this.matchedStyles.propertyState(e)===SDK.CSSMatchedStyles.PropertyState.Overloaded}updateFilter(){let e=!1;this.showAllItems();for(const t of this.propertiesTreeOutline.rootElement().children())if(t instanceof StylePropertyTreeElement){const n=t.updateFilter();e=e||n}const t=this.parentPane.filterRegex(),n=!e&&null!==t&&!t.test(this.element.deepTextContent());return this.isHiddenInternal=n,this.element.classList.toggle("hidden",n),!n&&this.styleInternal.parentRule&&this.markSelectorHighlights(),!n}isHidden(){return this.isHiddenInternal}markSelectorMatches(){const e=this.styleInternal.parentRule;if(!(e&&e instanceof SDK.CSSRule.CSSStyleRule))return;this.queryListElement.classList.toggle("query-matches",this.matchedStyles.mediaMatches(this.styleInternal));const t=e.selectors.map((e=>e.text)),n=this.matchedStyles.getMatchingSelectors(e),i=new Array(t.length).fill(!1);for(const e of n)i[e]=!0;if(this.parentPane.isEditingStyle)return;const s=this.hoverableSelectorsMode?this.renderHoverableSelectors(t,i):this.renderSimplifiedSelectors(t,i);this.selectorElement.removeChildren(),this.selectorElement.appendChild(s),this.markSelectorHighlights()}renderHoverableSelectors(e,t){const n=document.createDocumentFragment();for(let i=0;i<e.length;++i)i&&UI.UIUtils.createTextChild(n,", "),n.appendChild(this.createSelectorElement(e[i],t[i],i));return n}createSelectorElement(e,t,n){const i=document.createElement("span");return i.classList.add("simple-selector"),i.classList.toggle("selector-matches",t),"number"==typeof n&&this.elementToSelectorIndex.set(i,n),i.textContent=e,i}renderSimplifiedSelectors(e,t){const n=document.createDocumentFragment();let i=!1,s="";for(let r=0;r<e.length;++r)i!==t[r]&&s&&(n.appendChild(this.createSelectorElement(s,i)),s=""),i=t[r],s+=e[r]+(r===e.length-1?"":", ");return s&&n.appendChild(this.createSelectorElement(s,i)),n}markSelectorHighlights(){const e=this.selectorElement.getElementsByClassName("simple-selector"),t=this.parentPane.filterRegex();for(let n=0;n<e.length;++n){const i=null!==t&&t.test(e[n].textContent||"");e[n].classList.toggle("filter-match",i)}}checkWillCancelEditing(){const e=this.willCauseCancelEditing;return this.willCauseCancelEditing=!1,e}handleSelectorContainerClick(e){!this.checkWillCancelEditing()&&this.editable&&e.target===this.selectorContainer&&(this.addNewBlankProperty(0).startEditing(),e.consume(!0))}addNewBlankProperty(e=this.propertiesTreeOutline.rootElement().childCount()){const t=this.styleInternal.newBlankProperty(e),n=new StylePropertyTreeElement(this.parentPane,this.matchedStyles,t,!1,!1,!1,!0);return this.propertiesTreeOutline.insertChild(n,t.index),n}handleEmptySpaceMouseDown(){this.willCauseCancelEditing=this.parentPane.isEditingStyle,this.selectedSinceMouseDown=!1}handleEmptySpaceClick(e){if(!this.editable||this.element.hasSelection()||this.checkWillCancelEditing()||this.selectedSinceMouseDown)return;const t=e.target;if(t.classList.contains("header")||this.element.classList.contains("read-only")||t.enclosingNodeOrSelfWithClass("query"))return void e.consume();const n=UI.UIUtils.deepElementFromEvent(e),i=n&&UI.TreeOutline.TreeElement.getTreeElementBylistItemNode(n);i&&i instanceof StylePropertyTreeElement?this.addNewBlankProperty(i.property.index+1).startEditing():this.addNewBlankProperty().startEditing(),e.consume(!0)}handleQueryRuleClick(e,t){const n=t.currentTarget;if(UI.UIUtils.isBeingEdited(n))return;if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(t)&&this.navigable){const n=e.rawLocation();if(!n)return void t.consume(!0);const i=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().rawLocationToUILocation(n);return i&&Common.Revealer.reveal(i),void t.consume(!0)}if(!this.editable)return;const i=new UI.InplaceEditor.Config(this.editingMediaCommitted.bind(this,e),this.editingMediaCancelled.bind(this,n),void 0,this.editingMediaBlurHandler.bind(this));UI.InplaceEditor.InplaceEditor.startEditing(n,i);const s=n.getComponentSelection();s&&s.selectAllChildren(n),this.parentPane.setEditingStyle(!0);n.enclosingNodeOrSelfWithClass("query").classList.add("editing-query"),t.consume(!0)}editingMediaFinished(e){this.parentPane.setEditingStyle(!1);e.enclosingNodeOrSelfWithClass("query").classList.remove("editing-query")}editingMediaCancelled(e){this.editingMediaFinished(e),this.markSelectorMatches();const t=e.getComponentSelection();t&&t.collapse(e,0)}editingMediaBlurHandler(){return!0}editingMediaCommitted(e,t,n,i,s,r){this.parentPane.setEditingStyle(!1),this.editingMediaFinished(t),n&&(n=n.trim()),this.parentPane.setUserOperation(!0);const o=this.parentPane.cssModel();if(o&&e.styleSheetId){(e instanceof SDK.CSSMedia.CSSMedia?o.setMediaText:o.setContainerQueryText).call(o,e.styleSheetId,e.range,n).then(function(e){e&&(this.matchedStyles.resetActiveProperties(),this.parentPane.refreshUpdate(this)),this.parentPane.setUserOperation(!1),this.editingMediaTextCommittedForTest()}.bind(this))}}editingMediaTextCommittedForTest(){}handleSelectorClick(e){const t=e.target;if(t){if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e)&&this.navigable&&t.classList.contains("simple-selector")){const n=this.elementToSelectorIndex.get(t);return n&&this.navigateToSelectorSource(n,!0),void e.consume(!0)}this.element.hasSelection()||(this.startEditingAtFirstPosition(),e.consume(!0))}}handleContextMenuEvent(e){if(!e.target)return;const t=new UI.ContextMenu.ContextMenu(e);t.clipboardSection().appendItem(i18nString(UIStrings.copySelector),(()=>{const e=this.headerText();Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyRule),(()=>{const e=StylesSidebarPane.formatLeadingProperties(this).ruleText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyAllDeclarations),(()=>{const e=StylesSidebarPane.formatLeadingProperties(this).allDeclarationText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.show()}navigateToSelectorSource(e,t){const n=this.parentPane.cssModel();if(!n)return;const i=this.styleInternal.parentRule;if(!i||void 0===i.styleSheetId)return;const s=n.styleSheetHeaderForId(i.styleSheetId);if(!s)return;const r=new SDK.CSSModel.CSSLocation(s,i.lineNumberInSource(e),i.columnNumberInSource(e));StylePropertiesSection.revealSelectorSource(r,t)}static revealSelectorSource(e,t){const n=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().rawLocationToUILocation(e);n&&Common.Revealer.reveal(n,!t)}startEditingAtFirstPosition(){this.editable&&(this.styleInternal.parentRule?this.startEditingSelector():this.moveEditorFromSelector("forward"))}startEditingSelector(){const e=this.selectorElement;if(UI.UIUtils.isBeingEdited(e))return;e.scrollIntoViewIfNeeded(!1);const t=e.textContent;null!==t&&(e.textContent=t.replace(/\s+/g," ").trim());const n=new UI.InplaceEditor.Config(this.editingSelectorCommitted.bind(this),this.editingSelectorCancelled.bind(this));UI.InplaceEditor.InplaceEditor.startEditing(this.selectorElement,n);const i=e.getComponentSelection();i&&i.selectAllChildren(e),this.parentPane.setEditingStyle(!0),e.classList.contains("simple-selector")&&this.navigateToSelectorSource(0,!1)}moveEditorFromSelector(e){if(this.markSelectorMatches(),e)if("forward"===e){let e=this.propertiesTreeOutline.firstChild();for(;e&&e.inherited();){const t=e.nextSibling;e=t instanceof StylePropertyTreeElement?t:null}e?e.startEditing(e.nameElement):this.addNewBlankProperty().startEditing()}else{const e=this.previousEditableSibling();if(!e)return;e.addNewBlankProperty().startEditing()}}editingSelectorCommitted(e,t,n,i,s){if(this.editingSelectorEnded(),t&&(t=t.trim()),t===n)return this.selectorElement.textContent=t,void this.moveEditorFromSelector(s);const r=this.styleInternal.parentRule;r&&(this.parentPane.setUserOperation(!0),this.setHeaderText(r,t).then(function(){this.parentPane.setUserOperation(!1),this.moveEditorFromSelector(s),this.editingSelectorCommittedForTest()}.bind(this)))}setHeaderText(e,t){function n(e){const t=this.matchedStyles.getMatchingSelectors(e).length>0;this.propertiesTreeOutline.element.classList.toggle("no-affect",!t),this.matchedStyles.resetActiveProperties(),this.parentPane.refreshUpdate(this)}if(!(e instanceof SDK.CSSRule.CSSStyleRule))return Promise.resolve();const i=e.selectorRange();return i?e.setSelectorText(t).then(function(e,t){return t?this.matchedStyles.recomputeMatchingSelectors(e).then(n.bind(this,e)):Promise.resolve()}.bind(this,e,Boolean(i))):Promise.resolve()}editingSelectorCommittedForTest(){}updateRuleOrigin(){this.selectorRefElement.removeChildren(),this.selectorRefElement.appendChild(StylePropertiesSection.createRuleOriginNode(this.matchedStyles,this.parentPane.linkifier,this.styleInternal.parentRule))}editingSelectorEnded(){this.parentPane.setEditingStyle(!1)}editingSelectorCancelled(){this.editingSelectorEnded(),this.markSelectorMatches()}closestPropertyForEditing(e){const t=this.propertiesTreeOutline.rootElement();return e>=t.childCount()?t.lastChild():t.childAt(e)}static MaxProperties=50}export class BlankStylePropertiesSection extends StylePropertiesSection{normal;ruleLocation;styleSheetId;constructor(e,t,n,i,s,r,o){const l=e.cssModel();super(e,t,SDK.CSSRule.CSSStyleRule.createDummyRule(l,n).style,o),this.normal=!1,this.ruleLocation=s,this.styleSheetId=i,this.selectorRefElement.removeChildren(),this.selectorRefElement.appendChild(StylePropertiesSection.linkifyRuleLocation(l,this.parentPane.linkifier,i,this.actualRuleLocation())),r&&r.parentRule&&r.parentRule instanceof SDK.CSSRule.CSSStyleRule&&(this.createMediaList(r.parentRule.media),this.createContainerQueryList(r.parentRule.containerQueries)),this.element.classList.add("blank-section")}actualRuleLocation(){const e=this.rulePrefix().split("\n"),t=e[e.length-1],n=new TextUtils.TextRange.TextRange(0,0,e.length-1,t?t.length:0);return this.ruleLocation.rebaseAfterTextEdit(TextUtils.TextRange.TextRange.createFromLocation(0,0),n)}rulePrefix(){return 0===this.ruleLocation.startLine&&0===this.ruleLocation.startColumn?"":"\n\n"}get isBlank(){return!this.normal}editingSelectorCommitted(e,t,n,i,s){if(!this.isBlank)return void super.editingSelectorCommitted(e,t,n,i,s);function r(e){const t=this.matchedStyles.getMatchingSelectors(e).length>0;this.makeNormal(e),t||this.propertiesTreeOutline.element.classList.add("no-affect"),this.updateRuleOrigin(),this.parentPane.setUserOperation(!1),this.editingSelectorEnded(),this.element.parentElement&&this.moveEditorFromSelector(s),this.markSelectorMatches(),this.editingSelectorCommittedForTest()}t&&(t=t.trim()),this.parentPane.setUserOperation(!0);const o=this.parentPane.cssModel(),l=this.rulePrefix()+t+" {}";o&&o.addRule(this.styleSheetId,l,this.ruleLocation).then(function(e){return e?this.matchedStyles.addNewRule(e,this.matchedStyles.node()).then(r.bind(this,e)):(this.editingSelectorCancelled(),this.editingSelectorCommittedForTest(),Promise.resolve())}.bind(this))}editingSelectorCancelled(){this.parentPane.setUserOperation(!1),this.isBlank?(this.editingSelectorEnded(),this.parentPane.removeSection(this)):super.editingSelectorCancelled()}makeNormal(e){this.element.classList.remove("blank-section"),this.styleInternal=e.style,this.normal=!0}}export class KeyframePropertiesSection extends StylePropertiesSection{constructor(e,t,n,i){super(e,t,n,i),this.selectorElement.className="keyframe-key"}headerText(){return this.styleInternal.parentRule instanceof SDK.CSSRule.CSSKeyframeRule?this.styleInternal.parentRule.key().text:""}setHeaderText(e,t){if(!(e instanceof SDK.CSSRule.CSSKeyframeRule))return Promise.resolve();return e.key().range?e.setKeyText(t).then(function(e){e&&this.parentPane.refreshUpdate(this)}.bind(this)):Promise.resolve()}isPropertyInherited(e){return!1}isPropertyOverloaded(e){return!1}markSelectorHighlights(){}markSelectorMatches(){this.styleInternal.parentRule instanceof SDK.CSSRule.CSSKeyframeRule&&(this.selectorElement.textContent=this.styleInternal.parentRule.key().text)}highlight(){}}export function quoteFamilyName(e){return`'${e.replaceAll("'","\\'")}'`}export class CSSPropertyPrompt extends UI.TextPrompt.TextPrompt{isColorAware;cssCompletions;selectedNodeComputedStyles;parentNodeComputedStyles;treeElement;isEditingName;cssVariables;constructor(e,t){super(),this.initialize(this.buildPropertyCompletions.bind(this),UI.UIUtils.StyleValueDelimiters);const n=SDK.CSSMetadata.cssMetadata();this.isColorAware=SDK.CSSMetadata.cssMetadata().isColorAwareProperty(e.property.name),this.cssCompletions=[];const i=e.node();if(t)this.cssCompletions=n.allProperties(),i&&!i.isSVGNode()&&(this.cssCompletions=this.cssCompletions.filter((e=>!n.isSVGProperty(e))));else if(this.cssCompletions=n.getPropertyValues(e.property.name),i&&n.isFontFamilyProperty(e.property.name)){const e=i.domModel().cssModel().fontFaces().map((e=>quoteFamilyName(e.getFontFamily())));this.cssCompletions.unshift(...e)}if(this.selectedNodeComputedStyles=null,this.parentNodeComputedStyles=null,this.treeElement=e,this.isEditingName=t,this.cssVariables=e.matchedStyles().availableCSSVariables(e.property.ownerStyle),this.cssVariables.length<1e3?this.cssVariables.sort(Platform.StringUtilities.naturalOrderComparator):this.cssVariables.sort(),!t&&(this.disableDefaultSuggestionForEmptyInput(),e&&e.valueElement)){const t=e.valueElement.textContent,n=Host.Platform.isMac()?"Cmd":"Ctrl";null!==t&&(t.match(/#[\da-f]{3,6}$/i)?this.setTitle(i18nString(UIStrings.incrementdecrementWithMousewheelOne,{PH1:n})):t.match(/\d+/)&&this.setTitle(i18nString(UIStrings.incrementdecrementWithMousewheelHundred,{PH1:n})))}}onKeyDown(e){const t=e;switch(t.key){case"ArrowUp":case"ArrowDown":case"PageUp":case"PageDown":if(!this.isSuggestBoxVisible()&&this.handleNameOrValueUpDown(t))return void t.preventDefault();break;case"Enter":if(t.shiftKey)return;return this.tabKeyPressed(),void t.preventDefault()}super.onKeyDown(t)}onMouseWheel(e){this.handleNameOrValueUpDown(e)?e.consume(!0):super.onMouseWheel(e)}tabKeyPressed(){return this.acceptAutoComplete(),!1}handleNameOrValueUpDown(e){return!(this.isEditingName||!this.treeElement.valueElement||!UI.UIUtils.handleElementValueModifications(e,this.treeElement.valueElement,function(e,t){this.treeElement.nameElement&&this.treeElement.valueElement&&this.treeElement.applyStyleText(this.treeElement.nameElement.textContent+": "+this.treeElement.valueElement.textContent,!1)}.bind(this),this.isValueSuggestion.bind(this),function(e,t,n){return 0===t||n.length||!SDK.CSSMetadata.cssMetadata().isLengthProperty(this.treeElement.property.name)||this.treeElement.property.value.toLowerCase().startsWith("calc(")||(n="px"),e+t+n}.bind(this)))}isValueSuggestion(e){return!!e&&(e=e.toLowerCase(),-1!==this.cssCompletions.indexOf(e)||e.startsWith("--"))}async buildPropertyCompletions(e,t,n){const i=t.toLowerCase(),s=!this.isEditingName&&e.trim().endsWith("var(");if(!t&&!n&&!s&&(this.isEditingName||e))return Promise.resolve([]);const r=[],o=[];s||this.cssCompletions.forEach((e=>h.call(this,e,!1)));const l=this.treeElement.node();if(this.isEditingName&&l){SDK.CSSMetadata.cssMetadata().nameValuePresets(l.isSVGNode()).forEach((e=>h.call(this,e,!1,!0)))}(this.isEditingName||s)&&this.cssVariables.forEach((e=>h.call(this,e,!0)));const a=r.concat(o);!this.isEditingName&&!a.length&&t.length>1&&"!important".startsWith(i)&&a.push({text:"!important",title:void 0,subtitle:void 0,iconType:void 0,priority:void 0,isSecondary:void 0,subtitleRenderer:void 0,selectionRange:void 0,hideGhostText:void 0,iconElement:void 0});const c=t.replace("-","");if(c&&c===c.toUpperCase())for(let e=0;e<a.length;++e)a[e].text.startsWith("--")||(a[e].text=a[e].text.toUpperCase());for(const e of a){if(s){e.title=e.text,e.text+=")";continue}const t=SDK.CSSMetadata.cssMetadata().getValuePreset(this.treeElement.name,e.text);!this.isEditingName&&t&&(e.title=e.text,e.text=t.text,e.selectionRange={startColumn:t.startColumn,endColumn:t.endColumn})}const d=async()=>{if(!l||this.selectedNodeComputedStyles)return;this.selectedNodeComputedStyles=await l.domModel().cssModel().computedStylePromise(l.id);const e=l.parentNode;e&&(this.parentNodeComputedStyles=await e.domModel().cssModel().computedStylePromise(e.id))};for(const e of a){await d();const t=ElementsComponents.CSSPropertyIconResolver.findIcon(this.isEditingName?e.text:`${this.treeElement.property.name}: ${e.text}`,this.selectedNodeComputedStyles,this.parentNodeComputedStyles);if(!t)continue;const n=new IconButton.Icon.Icon,i="12.5px",s="12.5px";n.data={iconName:t.iconName,width:i,height:s,color:"black"},n.style.transform=`rotate(${t.rotate}deg) scale(${1.1*t.scaleX}, ${1.1*t.scaleY})`,n.style.maxHeight=s,n.style.maxWidth=i,e.iconElement=n}return this.isColorAware&&!this.isEditingName&&a.sort(((e,t)=>Boolean(e.subtitleRenderer)===Boolean(t.subtitleRenderer)?0:e.subtitleRenderer?-1:1)),Promise.resolve(a);function h(e,t,n){const s=e.toLowerCase().indexOf(i),l={text:e,title:void 0,subtitle:void 0,iconType:void 0,priority:void 0,isSecondary:void 0,subtitleRenderer:void 0,selectionRange:void 0,hideGhostText:void 0,iconElement:void 0};if(t){const t=this.treeElement.matchedStyles().computeCSSVariable(this.treeElement.property.ownerStyle,e);if(t){const e=Common.Color.Color.parse(t);e&&(l.subtitleRenderer=u.bind(null,e))}}n&&(l.hideGhostText=!0),0===s?(l.priority=this.isEditingName?SDK.CSSMetadata.cssMetadata().propertyUsageWeight(e):1,r.push(l)):s>-1&&o.push(l)}function u(e){const t=new InlineEditor.ColorSwatch.ColorSwatch;return t.renderColor(e),t.style.pointerEvents="none",t}}}export function unescapeCssString(e){return e.replace(/(?<!\\)\\(?:([a-fA-F0-9]{1,6})|(.))[\n\t\x20]?/gs,((e,t,n)=>{if(n)return n;const i=parseInt(t,16);return 55296<=i&&i<=57343||0===i||i>1114111?"�":String.fromCodePoint(i)}))}export class StylesSidebarPropertyRenderer{rule;node;propertyName;propertyValue;colorHandler;bezierHandler;fontHandler;shadowHandler;gridHandler;varHandler;angleHandler;lengthHandler;constructor(e,t,n,i){this.rule=e,this.node=t,this.propertyName=n,this.propertyValue=i,this.colorHandler=null,this.bezierHandler=null,this.fontHandler=null,this.shadowHandler=null,this.gridHandler=null,this.varHandler=document.createTextNode.bind(document),this.angleHandler=null,this.lengthHandler=null}setColorHandler(e){this.colorHandler=e}setBezierHandler(e){this.bezierHandler=e}setFontHandler(e){this.fontHandler=e}setShadowHandler(e){this.shadowHandler=e}setGridHandler(e){this.gridHandler=e}setVarHandler(e){this.varHandler=e}setAngleHandler(e){this.angleHandler=e}setLengthHandler(e){this.lengthHandler=e}renderName(){const e=document.createElement("span");return UI.ARIAUtils.setAccessibleName(e,i18nString(UIStrings.cssPropertyName)),e.className="webkit-css-property",e.textContent=this.propertyName,e.normalize(),e}renderValue(){const e=document.createElement("span");if(UI.ARIAUtils.setAccessibleName(e,i18nString(UIStrings.cssPropertyValue)),e.className="value",!this.propertyValue)return e;const t=SDK.CSSMetadata.cssMetadata();if(this.shadowHandler&&t.isShadowProperty(this.propertyName)&&!SDK.CSSMetadata.VariableRegex.test(this.propertyValue))return e.appendChild(this.shadowHandler(this.propertyValue,this.propertyName)),e.normalize(),e;if(this.gridHandler&&t.isGridAreaDefiningProperty(this.propertyName))return e.appendChild(this.gridHandler(this.propertyValue,this.propertyName)),e.normalize(),e;t.isStringProperty(this.propertyName)&&UI.Tooltip.Tooltip.install(e,unescapeCssString(this.propertyValue));const n=[SDK.CSSMetadata.VariableRegex,SDK.CSSMetadata.URLRegex],i=[this.varHandler,this.processURL.bind(this)];this.bezierHandler&&t.isBezierAwareProperty(this.propertyName)&&(n.push(UI.Geometry.CubicBezier.Regex),i.push(this.bezierHandler)),this.colorHandler&&t.isColorAwareProperty(this.propertyName)&&(n.push(Common.Color.Regex),i.push(this.colorHandler)),this.angleHandler&&t.isAngleAwareProperty(this.propertyName)&&(n.push(InlineEditor.CSSAngleUtils.CSSAngleRegex),i.push(this.angleHandler)),this.fontHandler&&t.isFontAwareProperty(this.propertyName)&&("font-family"===this.propertyName?n.push(InlineEditor.FontEditorUtils.FontFamilyRegex):n.push(InlineEditor.FontEditorUtils.FontPropertiesRegex),i.push(this.fontHandler)),Root.Runtime.experiments.isEnabled("cssTypeComponentLength")&&this.lengthHandler&&(n.push(InlineEditor.CSSLengthUtils.CSSLengthRegex),i.push(this.lengthHandler));const s=TextUtils.TextUtils.Utils.splitStringByRegexes(this.propertyValue,n);for(let t=0;t<s.length;t++){const n=s[t],r=-1===n.regexIndex?document.createTextNode.bind(document):i[n.regexIndex];r&&e.appendChild(r(n.value))}return e.normalize(),e}processURL(e){let t=e.substring(4,e.length-1).trim();(/^'.*'$/s.test(t)||/^".*"$/s.test(t))&&(t=t.substring(1,t.length-1));const n=document.createDocumentFragment();UI.UIUtils.createTextChild(n,"url(");let i=null;this.rule&&this.rule.resourceURL()?i=Common.ParsedURL.ParsedURL.completeURL(this.rule.resourceURL(),t):this.node&&(i=this.node.resolveURL(t));const s=ImagePreviewPopover.setImageUrl(Components.Linkifier.Linkifier.linkifyURL(i||t,{text:t,preventClick:!1,bypassURLTrimming:!0,className:void 0,lineNumber:void 0,columnNumber:void 0,showColumnNumber:!1,inlineFrameIndex:0,maxLength:void 0,tabStop:void 0}),i||t);return n.appendChild(s),UI.UIUtils.createTextChild(n,")"),n}}let buttonProviderInstance;export class ButtonProvider{button;constructor(){this.button=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.newStyleRule),"largeicon-add"),this.button.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.clicked,this);const e=UI.Icon.Icon.create("largeicon-longclick-triangle","long-click-glyph");function t(){let e=UI.Context.Context.instance().flavor(SDK.DOMModel.DOMNode);e=e?e.enclosingElementOrSelf():null,this.button.setEnabled(Boolean(e))}this.button.element.appendChild(e),new UI.UIUtils.LongClickController(this.button.element,this.longClicked.bind(this)),UI.Context.Context.instance().addFlavorChangeListener(SDK.DOMModel.DOMNode,t.bind(this)),t.call(this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return buttonProviderInstance&&!t||(buttonProviderInstance=new ButtonProvider),buttonProviderInstance}clicked(){StylesSidebarPane.instance().createNewRuleInViaInspectorStyleSheet()}longClicked(e){StylesSidebarPane.instance().onAddButtonLongClick(e)}item(){return this.button}}