const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2021 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n* {\n  box-sizing: border-box;\n  font-size: 12px;\n}\n\n.header {\n  background-color: var(--color-background-elevation-1);\n  border-bottom: var(--legacy-divider-border);\n  line-height: 1.6;\n  overflow: hidden;\n  padding: 0 5px;\n  white-space: nowrap;\n}\n\n.header::marker {\n  color: rgb(110 110 110); /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  font-size: 11px;\n  line-height: 1;\n}\n\n.header:focus {\n  background-color: var(--legacy-focus-bg-color);\n}\n\n.content-section {\n  padding: 16px;\n  border-bottom: var(--legacy-divider-border);\n  overflow-x: hidden;\n}\n\n.content-section-title {\n  font-size: 12px;\n  font-weight: 500;\n  line-height: 1.1;\n  margin: 0;\n  padding: 0;\n}\n\n.checkbox-settings {\n  margin-top: 8px;\n  display: grid;\n  grid-template-columns: 1fr;\n  gap: 5px;\n}\n\n.checkbox-label {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  min-width: 40px;\n}\n\n.checkbox-settings .checkbox-label {\n  margin-bottom: 8px;\n}\n\n.checkbox-settings .checkbox-label:last-child {\n  margin-bottom: 0;\n}\n\n.checkbox-label input {\n  margin: 0 6px 0 0;\n  padding: 0;\n  flex: none;\n}\n\n.checkbox-label input:focus {\n  outline: auto 5px -webkit-focus-ring-color;\n}\n\n.checkbox-label > span {\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  overflow: hidden;\n}\n\n.select-settings {\n  margin-top: 16px;\n}\n\n.select-label {\n  display: flex;\n  flex-direction: column;\n}\n\n.select-label span {\n  margin-bottom: 4px;\n}\n\n.elements {\n  margin-top: 12px;\n  color: var(--color-token-tag);\n  display: grid;\n  grid-template-columns: repeat(auto-fill, minmax(min(250px, 100%), 1fr));\n  gap: 8px;\n}\n\n.element {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n\n.show-element {\n  margin: 0 0 0 8px;\n  padding: 0;\n  background: none;\n  border: none;\n  -webkit-mask-image: var(--image-file-ic_show_node_16x16);\n  background-color: #333; /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  width: 16px;\n  height: 16px;\n  display: block;\n  cursor: pointer;\n  flex: none;\n}\n\n.show-element:focus,\n.show-element:hover {\n  background-color: #6e6e6e; /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n}\n\n.chrome-select {\n  min-width: 0;\n  max-width: 150px;\n}\n\n:host-context(.-theme-with-dark-background) .show-element {\n  background-color: rgb(204 204 204);\n}\n\n:host-context(.-theme-with-dark-background) .show-element:focus,\n:host-context(.-theme-with-dark-background) .show-element:hover {\n  background-color: #6e6e6e;\n}\n\n.color-picker {\n  opacity: 0%;\n}\n\n.color-picker-label {\n  border: 1px solid rgb(128 128 128 / 60%); /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  cursor: default;\n  display: inline-block;\n  flex: none;\n  height: 10px;\n  margin: 0 0 0 8px;\n  width: 10px;\n  position: relative;\n}\n/* We set dimensions for the invisible input to support quick highlight a11y feature\nthat uses the dimensions to draw an outline around the element. */\n.color-picker-label input[type="color"] {\n  width: 100%;\n  height: 100%;\n  position: absolute;\n}\n\n.color-picker-label:hover,\n.color-picker-label:focus {\n  border: 1px solid var(--legacy-accent-color-hover);\n  transform: scale(1.2);\n}\n\n.node-text-container {\n  line-height: 16px;\n  padding: 0 0.5ex;\n  border-radius: 5px;\n}\n\n.node-text-container:hover {\n  background-color: var(--item-hover-color);\n}\n\n:host-context(.-theme-with-dark-background) input[type="checkbox"] {\n  filter: invert(80%);\n}\n\n/*# sourceURL=layoutPane.css */\n');export default styles;