import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as UI from"../../ui/legacy/legacy.js";import*as Timeline from"../timeline/timeline.js";import inputTimelineStyles from"./inputTimeline.css.js";import{InputModel}from"./InputModel.js";const UIStrings={clearAll:"Clear all",loadProfile:"Load profile…",saveProfile:"Save profile…"},str_=i18n.i18n.registerUIStrings("panels/input//InputTimeline.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let inputTimelineInstance,actionDelegateInstance;export class InputTimeline extends UI.Widget.VBox{tracingClient;tracingModel;inputModel;state;toggleRecordAction;startReplayAction;togglePauseAction;panelToolbar;clearButton;loadButton;saveButton;fileSelectorElement;loader;constructor(){super(!0),this.element.classList.add("inputs-timeline"),this.tracingClient=null,this.tracingModel=null,this.inputModel=null,this.state="Idle",this.toggleRecordAction=UI.ActionRegistry.ActionRegistry.instance().action("input.toggle-recording"),this.startReplayAction=UI.ActionRegistry.ActionRegistry.instance().action("input.start-replaying"),this.togglePauseAction=UI.ActionRegistry.ActionRegistry.instance().action("input.toggle-pause");const t=this.contentElement.createChild("div","input-timeline-toolbar-container");this.panelToolbar=new UI.Toolbar.Toolbar("input-timeline-toolbar",t),this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.toggleRecordAction)),this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.startReplayAction)),this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.togglePauseAction)),this.clearButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearAll),"largeicon-clear"),this.clearButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.reset.bind(this)),this.panelToolbar.appendToolbarItem(this.clearButton),this.panelToolbar.appendSeparator(),this.loadButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.loadProfile),"largeicon-load"),this.loadButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>this.selectFileToLoad())),this.saveButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.saveProfile),"largeicon-download"),this.saveButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(t=>{this.saveToFile()})),this.panelToolbar.appendSeparator(),this.panelToolbar.appendToolbarItem(this.loadButton),this.panelToolbar.appendToolbarItem(this.saveButton),this.panelToolbar.appendSeparator(),this.createFileSelector(),this.updateControls()}static instance(t={forceNew:!1}){const{forceNew:e}=t;return inputTimelineInstance&&!e||(inputTimelineInstance=new InputTimeline),inputTimelineInstance}reset(){this.tracingClient=null,this.tracingModel=null,this.inputModel=null,this.setState("Idle")}createFileSelector(){this.fileSelectorElement&&this.fileSelectorElement.remove(),this.fileSelectorElement=UI.UIUtils.createFileSelectorElement(this.loadFromFile.bind(this)),this.element.appendChild(this.fileSelectorElement)}wasShown(){super.wasShown(),this.registerCSSFiles([inputTimelineStyles])}willHide(){}setState(t){this.state=t,this.updateControls()}isAvailableState(){return"Idle"===this.state||"ReplayPaused"===this.state}updateControls(){this.toggleRecordAction.setToggled("Recording"===this.state),this.toggleRecordAction.setEnabled(this.isAvailableState()||"Recording"===this.state),this.startReplayAction.setEnabled(this.isAvailableState()&&Boolean(this.tracingModel)),this.togglePauseAction.setEnabled("Replaying"===this.state||"ReplayPaused"===this.state),this.togglePauseAction.setToggled("ReplayPaused"===this.state),this.clearButton.setEnabled(this.isAvailableState()),this.loadButton.setEnabled(this.isAvailableState()),this.saveButton.setEnabled(this.isAvailableState()&&Boolean(this.tracingModel))}toggleRecording(){switch(this.state){case"Recording":this.stopRecording();break;case"Idle":this.startRecording()}}startReplay(){this.replayEvents()}toggleReplayPause(){switch(this.state){case"Replaying":this.pauseReplay();break;case"ReplayPaused":this.resumeReplay()}}async saveToFile(){if(console.assert("Idle"===this.state),!this.tracingModel)return;const t=`InputProfile-${Platform.DateUtilities.toISO8601Compact(new Date)}.json`,e=new Bindings.FileUtils.FileOutputStream;if(!await e.open(t))return;const i=this.tracingModel.backingStorage();await i.writeToStream(e),e.close()}selectFileToLoad(){this.fileSelectorElement&&this.fileSelectorElement.click()}loadFromFile(t){console.assert(this.isAvailableState()),this.setState("Loading"),this.loader=Timeline.TimelineLoader.TimelineLoader.loadFromFile(t,this),this.createFileSelector()}async startRecording(){this.setState("StartPending"),this.tracingClient=new TracingClient(SDK.TargetManager.TargetManager.instance().mainTarget(),this);const t=await this.tracingClient.startRecording();!t||t.getError()?this.recordingFailed():this.setState("Recording")}async stopRecording(){this.tracingClient&&(this.setState("StopPending"),await this.tracingClient.stopRecording(),this.tracingClient=null)}async replayEvents(){this.inputModel&&(this.setState("Replaying"),await this.inputModel.startReplay(this.replayStopped.bind(this)))}pauseReplay(){this.inputModel&&(this.inputModel.pause(),this.setState("ReplayPaused"))}resumeReplay(){this.inputModel&&(this.inputModel.resume(),this.setState("Replaying"))}loadingStarted(){}loadingProgress(t){}processingStarted(){}loadingComplete(t){t?(this.inputModel=new InputModel(SDK.TargetManager.TargetManager.instance().mainTarget()),this.tracingModel=t,this.inputModel.setEvents(t),this.setState("Idle")):this.reset()}recordingFailed(){this.tracingClient=null,this.setState("Idle")}replayStopped(){this.setState("Idle")}}export class ActionDelegate{static instance(t={forceNew:null}){const{forceNew:e}=t;return actionDelegateInstance&&!e||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(t,e){const i="Inputs";return UI.ViewManager.ViewManager.instance().showView(i).then((()=>UI.ViewManager.ViewManager.instance().view(i).widget())).then((t=>this.innerHandleAction(t,e))),!0}innerHandleAction(t,e){switch(e){case"input.toggle-recording":t.toggleRecording();break;case"input.start-replaying":t.startReplay();break;case"input.toggle-pause":t.toggleReplayPause();break;default:console.assert(!1,`Unknown action: ${e}`)}}}export class TracingClient{target;tracingManager;client;tracingModel;tracingCompleteCallback;constructor(t,e){this.target=t,this.tracingManager=t.model(SDK.TracingManager.TracingManager),this.client=e;const i=new Bindings.TempFile.TempFileBackingStorage;this.tracingModel=new SDK.TracingModel.TracingModel(i),this.tracingCompleteCallback=null}async startRecording(){if(!this.tracingManager)return;const t=["devtools.timeline","disabled-by-default-devtools.timeline.inputs"].join(","),e=await this.tracingManager.start(this,t,"");return e.getError()&&await this.waitForTracingToStop(!1),e}async stopRecording(){this.tracingManager&&this.tracingManager.stop(),await this.waitForTracingToStop(!0),await SDK.TargetManager.TargetManager.instance().resumeAllTargets(),this.tracingModel.tracingComplete(),this.client.loadingComplete(this.tracingModel)}traceEventsCollected(t){this.tracingModel.addEvents(t)}tracingComplete(){this.tracingCompleteCallback&&this.tracingCompleteCallback(),this.tracingCompleteCallback=null}tracingBufferUsage(t){}eventsRetrievalProgress(t){}waitForTracingToStop(t){return new Promise((e=>{this.tracingManager&&t?this.tracingCompleteCallback=e:e()}))}}