import*as Common from"../../core/common/common.js";import*as IssuesManager from"../../models/issues_manager/issues_manager.js";export class AggregatedIssue extends IssuesManager.Issue.Issue{affectedCookies=new Map;affectedRawCookieLines=new Map;affectedRequests=new Map;affectedLocations=new Map;heavyAdIssues=new Set;blockedByResponseDetails=new Map;corsIssues=new Set;cspIssues=new Set;issueKind=IssuesManager.Issue.IssueKind.Improvement;lowContrastIssues=new Set;mixedContentIssues=new Set;sharedArrayBufferIssues=new Set;trustedWebActivityIssues=new Set;quirksModeIssues=new Set;attributionReportingIssues=new Set;wasmCrossOriginModuleSharingIssues=new Set;genericIssues=new Set;representative;aggregatedIssuesCount=0;key;constructor(e,s){super(e),this.key=s}primaryKey(){throw new Error("This should never be called")}aggregationKey(){return this.key}getBlockedByResponseDetails(){return this.blockedByResponseDetails.values()}cookies(){return Array.from(this.affectedCookies.values()).map((e=>e.cookie))}getRawCookieLines(){return this.affectedRawCookieLines.values()}sources(){return this.affectedLocations.values()}cookiesWithRequestIndicator(){return this.affectedCookies.values()}getHeavyAdIssues(){return this.heavyAdIssues}getMixedContentIssues(){return this.mixedContentIssues}getTrustedWebActivityIssues(){return this.trustedWebActivityIssues}getCorsIssues(){return this.corsIssues}getCspIssues(){return this.cspIssues}getLowContrastIssues(){return this.lowContrastIssues}requests(){return this.affectedRequests.values()}getSharedArrayBufferIssues(){return this.sharedArrayBufferIssues}getQuirksModeIssues(){return this.quirksModeIssues}getAttributionReportingIssues(){return this.attributionReportingIssues}getWasmCrossOriginModuleSharingIssue(){return this.wasmCrossOriginModuleSharingIssues}getGenericIssues(){return this.genericIssues}getDescription(){return this.representative?this.representative.getDescription():null}getCategory(){return this.representative?this.representative.getCategory():IssuesManager.Issue.IssueCategory.Other}getAggregatedIssuesCount(){return this.aggregatedIssuesCount}keyForCookie(e){const{domain:s,path:t,name:r}=e;return`${s};${t};${r}`}addInstance(e){this.aggregatedIssuesCount++,this.representative||(this.representative=e),this.issueKind=IssuesManager.Issue.unionIssueKind(this.issueKind,e.getKind());let s=!1;for(const t of e.requests())s=!0,this.affectedRequests.has(t.requestId)||this.affectedRequests.set(t.requestId,t);for(const t of e.cookies()){const e=this.keyForCookie(t);this.affectedCookies.has(e)||this.affectedCookies.set(e,{cookie:t,hasRequest:s})}for(const t of e.rawCookieLines())this.affectedRawCookieLines.has(t)||this.affectedRawCookieLines.set(t,{rawCookieLine:t,hasRequest:s});for(const s of e.sources()){const e=JSON.stringify(s);this.affectedLocations.has(e)||this.affectedLocations.set(e,s)}e instanceof IssuesManager.MixedContentIssue.MixedContentIssue&&this.mixedContentIssues.add(e),e instanceof IssuesManager.HeavyAdIssue.HeavyAdIssue&&this.heavyAdIssues.add(e);for(const s of e.getBlockedByResponseDetails()){const e=JSON.stringify(s,["parentFrame","blockedFrame","requestId","frameId","reason","request"]);this.blockedByResponseDetails.set(e,s)}e instanceof IssuesManager.TrustedWebActivityIssue.TrustedWebActivityIssue&&this.trustedWebActivityIssues.add(e),e instanceof IssuesManager.ContentSecurityPolicyIssue.ContentSecurityPolicyIssue&&this.cspIssues.add(e),e instanceof IssuesManager.SharedArrayBufferIssue.SharedArrayBufferIssue&&this.sharedArrayBufferIssues.add(e),e instanceof IssuesManager.LowTextContrastIssue.LowTextContrastIssue&&this.lowContrastIssues.add(e),e instanceof IssuesManager.CorsIssue.CorsIssue&&this.corsIssues.add(e),e instanceof IssuesManager.QuirksModeIssue.QuirksModeIssue&&this.quirksModeIssues.add(e),e instanceof IssuesManager.AttributionReportingIssue.AttributionReportingIssue&&this.attributionReportingIssues.add(e),e instanceof IssuesManager.WasmCrossOriginModuleSharingIssue.WasmCrossOriginModuleSharingIssue&&this.wasmCrossOriginModuleSharingIssues.add(e),e instanceof IssuesManager.GenericIssue.GenericIssue&&this.genericIssues.add(e)}getKind(){return this.issueKind}isHidden(){return this.representative?.isHidden()||!1}setHidden(e){throw new Error("Should not call setHidden on aggregatedIssue")}}export class IssueAggregator extends Common.ObjectWrapper.ObjectWrapper{issuesManager;aggregatedIssuesByKey=new Map;hiddenAggregatedIssuesByKey=new Map;constructor(e){super(),this.issuesManager=e,this.issuesManager.addEventListener("IssueAdded",this.onIssueAdded,this),this.issuesManager.addEventListener("FullUpdateRequired",this.onFullUpdateRequired,this);for(const e of this.issuesManager.issues())this.aggregateIssue(e)}onIssueAdded(e){this.aggregateIssue(e.data.issue)}onFullUpdateRequired(){this.aggregatedIssuesByKey.clear(),this.hiddenAggregatedIssuesByKey.clear();for(const e of this.issuesManager.issues())this.aggregateIssue(e);this.dispatchEventToListeners("FullUpdateRequired")}aggregateIssue(e){const s=e.isHidden()?this.hiddenAggregatedIssuesByKey:this.aggregatedIssuesByKey,t=this.aggregateIssueByStatus(s,e);return this.dispatchEventToListeners("AggregatedIssueUpdated",t),t}aggregateIssueByStatus(e,s){const t=s.code();let r=e.get(t);return r||(r=new AggregatedIssue(s.code(),t),e.set(t,r)),r.addInstance(s),r}aggregatedIssues(){return[...this.aggregatedIssuesByKey.values(),...this.hiddenAggregatedIssuesByKey.values()]}hiddenAggregatedIssues(){return this.hiddenAggregatedIssuesByKey.values()}aggregatedIssueCodes(){return new Set([...this.aggregatedIssuesByKey.keys(),...this.hiddenAggregatedIssuesByKey.keys()])}aggregatedIssueCategories(){const e=new Set;for(const s of this.aggregatedIssuesByKey.values())e.add(s.getCategory());return e}aggregatedIssueKinds(){const e=new Set;for(const s of this.aggregatedIssuesByKey.values())e.add(s.getKind());return e}numberOfAggregatedIssues(){return this.aggregatedIssuesByKey.size}numberOfHiddenAggregatedIssues(){return this.hiddenAggregatedIssuesByKey.size}keyForIssue(e){return e.code()}}