import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as IssuesManager from"../../models/issues_manager/issues_manager.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import*as IssueCounter from"../../ui/components/issue_counter/issue_counter.js";import*as MarkdownView from"../../ui/components/markdown_view/markdown_view.js";import*as UI from"../../ui/legacy/legacy.js";import*as Adorners from"../../ui/components/adorners/adorners.js";import*as NetworkForward from"../../panels/network/forward/forward.js";import*as Root from"../../core/root/root.js";import*as Components from"./components/components.js";import{AffectedDirectivesView}from"./AffectedDirectivesView.js";import{AffectedBlockedByResponseView}from"./AffectedBlockedByResponseView.js";import{AffectedCookiesView,AffectedRawCookieLinesView}from"./AffectedCookiesView.js";import{AffectedDocumentsInQuirksModeView}from"./AffectedDocumentsInQuirksModeView.js";import{AffectedElementsView}from"./AffectedElementsView.js";import{AffectedElementsWithLowContrastView}from"./AffectedElementsWithLowContrastView.js";import{AffectedHeavyAdView}from"./AffectedHeavyAdView.js";import{AffectedResourcesView,extractShortPath}from"./AffectedResourcesView.js";import{AffectedSharedArrayBufferIssueDetailsView}from"./AffectedSharedArrayBufferIssueDetailsView.js";import{AffectedSourcesView}from"./AffectedSourcesView.js";import{AffectedTrustedWebActivityIssueDetailsView}from"./AffectedTrustedWebActivityIssueDetailsView.js";import{CorsIssueDetailsView}from"./CorsIssueDetailsView.js";import{GenericIssueDetailsView}from"./GenericIssueDetailsView.js";import{WasmCrossOriginModuleSharingAffectedResourcesView}from"./WasmCrossOriginModuleSharingAffectedResourcesView.js";import{AttributionReportingIssueDetailsView}from"./AttributionReportingIssueDetailsView.js";const UIStrings={name:"Name",blocked:"blocked",nRequests:"{n, plural, =1 {# request} other {# requests}}",nResources:"{n, plural, =1 {# resource} other {# resources}}",restrictionStatus:"Restriction Status",warned:"Warned",affectedResources:"Affected Resources",learnMoreS:"Learn more: {PH1}",automaticallyUpgraded:"automatically upgraded",hideIssuesLikeThis:"Hide issues like this",unhideIssuesLikeThis:"Unhide issues like this"},str_=i18n.i18n.registerUIStrings("panels/issues/IssueView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class AffectedRequestsView extends AffectedResourcesView{appendAffectedRequests(e){let s=0;for(const t of e){const e=document.createElement("tr");e.classList.add("affected-resource-request");const i=this.issue.getCategory(),n=issueTypeToNetworkHeaderMap.get(i)||NetworkForward.UIRequestLocation.UIRequestTabs.Headers;e.appendChild(this.createRequestCell(t,{networkTab:n,additionalOnClickAction(){Host.userMetrics.issuesPanelResourceOpened(i,"Request")}})),this.affectedResources.appendChild(e),s++}this.updateAffectedResourceCount(s)}getResourceNameWithCount(e){return i18nString(UIStrings.nRequests,{n:e})}update(){this.clear();for(const e of this.issue.getBlockedByResponseDetails())return void this.updateAffectedResourceCount(0);this.issue.getCategory()!==IssuesManager.Issue.IssueCategory.MixedContent?this.appendAffectedRequests(this.issue.requests()):this.updateAffectedResourceCount(0)}}const issueTypeToNetworkHeaderMap=new Map([[IssuesManager.Issue.IssueCategory.SameSiteCookie,NetworkForward.UIRequestLocation.UIRequestTabs.Cookies],[IssuesManager.Issue.IssueCategory.CrossOriginEmbedderPolicy,NetworkForward.UIRequestLocation.UIRequestTabs.Headers],[IssuesManager.Issue.IssueCategory.MixedContent,NetworkForward.UIRequestLocation.UIRequestTabs.Headers]]);class AffectedMixedContentView extends AffectedResourcesView{appendAffectedMixedContentDetails(e){const s=document.createElement("tr");this.appendColumnTitle(s,i18nString(UIStrings.name)),this.appendColumnTitle(s,i18nString(UIStrings.restrictionStatus)),this.affectedResources.appendChild(s);let t=0;for(const s of e){const e=s.getDetails();this.appendAffectedMixedContent(e),t++}this.updateAffectedResourceCount(t)}getResourceNameWithCount(e){return i18nString(UIStrings.nResources,{n:e})}appendAffectedMixedContent(e){const s=document.createElement("tr");if(s.classList.add("affected-resource-mixed-content"),e.request){const t=issueTypeToNetworkHeaderMap.get(this.issue.getCategory())||NetworkForward.UIRequestLocation.UIRequestTabs.Headers;s.appendChild(this.createRequestCell(e.request,{networkTab:t,additionalOnClickAction(){Host.userMetrics.issuesPanelResourceOpened(IssuesManager.Issue.IssueCategory.MixedContent,"Request")}}))}else{const t=extractShortPath(e.insecureURL);this.appendIssueDetailCell(s,t,"affected-resource-mixed-content-info").title=e.insecureURL}this.appendIssueDetailCell(s,AffectedMixedContentView.translateStatus(e.resolutionStatus),"affected-resource-mixed-content-info"),this.affectedResources.appendChild(s)}static translateStatus(e){switch(e){case"MixedContentBlocked":return i18nString(UIStrings.blocked);case"MixedContentAutomaticallyUpgraded":return i18nString(UIStrings.automaticallyUpgraded);case"MixedContentWarning":return i18nString(UIStrings.warned)}}update(){this.clear(),this.appendAffectedMixedContentDetails(this.issue.getMixedContentIssues())}}export class IssueView extends UI.TreeOutline.TreeElement{issue;description;toggleOnClick;affectedResources;affectedResourceViews;aggregatedIssuesCount;issueKindIcon=null;hasBeenExpandedBefore;throttle;needsUpdateOnExpand=!0;hiddenIssuesMenu;contentCreated=!1;constructor(e,s){super(),this.issue=e,this.description=s,this.throttle=new Common.Throttler.Throttler(250),this.toggleOnClick=!0,this.listItemElement.classList.add("issue"),this.childrenListElement.classList.add("body"),this.childrenListElement.classList.add(IssueView.getBodyCSSClass(this.issue.getKind())),this.affectedResources=this.createAffectedResources(),this.affectedResourceViews=[new AffectedCookiesView(this,this.issue),new AffectedElementsView(this,this.issue),new AffectedRequestsView(this,this.issue),new AffectedMixedContentView(this,this.issue),new AffectedSourcesView(this,this.issue),new AffectedHeavyAdView(this,this.issue),new AffectedDirectivesView(this,this.issue),new AffectedBlockedByResponseView(this,this.issue),new AffectedSharedArrayBufferIssueDetailsView(this,this.issue),new AffectedElementsWithLowContrastView(this,this.issue),new AffectedTrustedWebActivityIssueDetailsView(this,this.issue),new CorsIssueDetailsView(this,this.issue),new GenericIssueDetailsView(this,this.issue),new AffectedDocumentsInQuirksModeView(this,this.issue),new AttributionReportingIssueDetailsView(this,this.issue),new WasmCrossOriginModuleSharingAffectedResourcesView(this,this.issue),new AffectedRawCookieLinesView(this,this.issue)],Root.Runtime.experiments.isEnabled("hideIssuesFeature")&&(this.hiddenIssuesMenu=new Components.HideIssuesMenu.HideIssuesMenu),this.aggregatedIssuesCount=null,this.hasBeenExpandedBefore=!1}setIssue(e){this.issue!==e&&(this.needsUpdateOnExpand=!0),this.issue=e,this.affectedResourceViews.forEach((s=>s.setIssue(e)))}static getBodyCSSClass(e){switch(e){case IssuesManager.Issue.IssueKind.BreakingChange:return"issue-kind-breaking-change";case IssuesManager.Issue.IssueKind.PageError:return"issue-kind-page-error";case IssuesManager.Issue.IssueKind.Improvement:return"issue-kind-improvement"}}getIssueTitle(){return this.description.title}onattach(){this.contentCreated?this.update():this.createContent()}createContent(){this.appendHeader(),this.createBody(),this.appendChild(this.affectedResources);for(const e of this.affectedResourceViews)this.appendAffectedResource(e),e.update();this.createReadMoreLinks(),this.updateAffectedResourceVisibility(),this.contentCreated=!0}appendAffectedResource(e){this.affectedResources.appendChild(e)}appendHeader(){const e=document.createElement("div");e.classList.add("header"),this.issueKindIcon=new IconButton.Icon.Icon,this.issueKindIcon.classList.add("leading-issue-icon"),this.aggregatedIssuesCount=document.createElement("span");const s=new Adorners.Adorner.Adorner;s.data={name:"countWrapper",content:this.aggregatedIssuesCount},s.classList.add("aggregated-issues-count"),e.appendChild(this.issueKindIcon),e.appendChild(s);const t=document.createElement("div");t.classList.add("title"),t.textContent=this.description.title,e.appendChild(t),this.hiddenIssuesMenu&&e.appendChild(this.hiddenIssuesMenu),this.updateFromIssue(),this.listItemElement.appendChild(e)}onexpand(){if(Host.userMetrics.issuesPanelIssueExpanded(this.issue.getCategory()),this.needsUpdateOnExpand&&this.doUpdate(),!this.hasBeenExpandedBefore){this.hasBeenExpandedBefore=!0;for(const e of this.affectedResourceViews)e.expandIfOneResource()}}updateFromIssue(){if(this.issueKindIcon){const e=this.issue.getKind();this.issueKindIcon.data=IssueCounter.IssueCounter.getIssueKindIconData(e),this.issueKindIcon.title=IssuesManager.Issue.getIssueKindDescription(e)}if(this.aggregatedIssuesCount&&(this.aggregatedIssuesCount.textContent=`${this.issue.getAggregatedIssuesCount()}`),this.listItemElement.classList.toggle("hidden-issue",this.issue.isHidden()),this.hiddenIssuesMenu){const e={menuItemLabel:this.issue.isHidden()?i18nString(UIStrings.unhideIssuesLikeThis):i18nString(UIStrings.hideIssuesLikeThis),menuItemAction:()=>{const e=IssuesManager.IssuesManager.getHideIssueByCodeSetting(),s=e.get();s[this.issue.code()]=this.issue.isHidden()?"Unhidden":"Hidden",e.set(s)}};this.hiddenIssuesMenu.data=e}}updateAffectedResourceVisibility(){const e=this.affectedResourceViews.every((e=>e.isEmpty()));this.affectedResources.hidden=e}createAffectedResources(){const e=new UI.TreeOutline.TreeElement;return e.setCollapsible(!1),e.setExpandable(!0),e.expand(),e.selectable=!1,e.listItemElement.classList.add("affected-resources-label"),e.listItemElement.textContent=i18nString(UIStrings.affectedResources),e.childrenListElement.classList.add("affected-resources"),e}createBody(){const e=new UI.TreeOutline.TreeElement;e.setCollapsible(!1),e.selectable=!1;const s=new MarkdownView.MarkdownView.MarkdownView;s.data={tokens:this.description.markdown},e.listItemElement.appendChild(s),this.appendChild(e)}createReadMoreLinks(){if(0===this.description.links.length)return;const e=new UI.TreeOutline.TreeElement;e.setCollapsible(!1),e.listItemElement.classList.add("link-wrapper");const s=e.listItemElement.createChild("ul","link-list");for(const e of this.description.links){const t=UI.Fragment.html`<x-link class="link devtools-link" tabindex="0" href=${e.link}>${i18nString(UIStrings.learnMoreS,{PH1:e.linkTitle})}</x-link>`,i=new IconButton.Icon.Icon;i.data={iconName:"link_icon",color:"var(--color-link)",width:"16px",height:"16px"},i.classList.add("link-icon"),t.prepend(i),t.addEventListener("x-link-invoke",(()=>{Host.userMetrics.issuesPanelResourceOpened(this.issue.getCategory(),"LearnMore")}));s.createChild("li").appendChild(t)}this.appendChild(e)}doUpdate(){this.expanded&&(this.affectedResourceViews.forEach((e=>e.update())),this.updateAffectedResourceVisibility()),this.needsUpdateOnExpand=!this.expanded,this.updateFromIssue()}update(){this.throttle.schedule((async()=>this.doUpdate()))}getIssueKind(){return this.issue.getKind()}isForHiddenIssue(){return this.issue.isHidden()}toggle(e){e||void 0===e&&!this.expanded?this.expand():this.collapse()}}