import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Root from"../../core/root/root.js";import*as IssuesManager from"../../models/issues_manager/issues_manager.js";import*as IssueCounter from"../../ui/components/issue_counter/issue_counter.js";import*as UI from"../../ui/legacy/legacy.js";import{HiddenIssuesRow}from"./HiddenIssuesRow.js";import issuesPaneStyles from"./issuesPane.css.js";import issuesTreeStyles from"./issuesTree.css.js";import{IssueAggregator}from"./IssueAggregator.js";import{IssueView}from"./IssueView.js";import{IssueKindView,getGroupIssuesByKindSetting,issueKindViewSortPriority}from"./IssueKindView.js";const UIStrings={crossOriginEmbedderPolicy:"Cross Origin Embedder Policy",mixedContent:"Mixed Content",samesiteCookie:"SameSite Cookie",heavyAds:"Heavy Ads",contentSecurityPolicy:"Content Security Policy",trustedWebActivity:"Trusted Web Activity",other:"Other",lowTextContrast:"Low Text Contrast",cors:"Cross Origin Resource Sharing",groupDisplayedIssuesUnder:"Group displayed issues under associated categories",groupByCategory:"Group by category",groupDisplayedIssuesUnderKind:"Group displayed issues as Page errors, Breaking changes and Improvements",groupByKind:"Group by kind",includeCookieIssuesCausedBy:"Include cookie Issues caused by third-party sites",includeThirdpartyCookieIssues:"Include third-party cookie issues",onlyThirdpartyCookieIssues:"Only third-party cookie issues detected so far",noIssuesDetectedSoFar:"No issues detected so far",attributionReporting:"Attribution Reporting `API`",quirksMode:"Quirks Mode",generic:"Generic"},str_=i18n.i18n.registerUIStrings("panels/issues/IssuesPane.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class IssueCategoryView extends UI.TreeOutline.TreeElement{category;issues;constructor(e){super(),this.category=e,this.issues=[],this.toggleOnClick=!0,this.listItemElement.classList.add("issue-category"),this.childrenListElement.classList.add("issue-category-body")}getCategoryName(){switch(this.category){case IssuesManager.Issue.IssueCategory.CrossOriginEmbedderPolicy:return i18nString(UIStrings.crossOriginEmbedderPolicy);case IssuesManager.Issue.IssueCategory.MixedContent:return i18nString(UIStrings.mixedContent);case IssuesManager.Issue.IssueCategory.SameSiteCookie:return i18nString(UIStrings.samesiteCookie);case IssuesManager.Issue.IssueCategory.HeavyAd:return i18nString(UIStrings.heavyAds);case IssuesManager.Issue.IssueCategory.ContentSecurityPolicy:return i18nString(UIStrings.contentSecurityPolicy);case IssuesManager.Issue.IssueCategory.TrustedWebActivity:return i18nString(UIStrings.trustedWebActivity);case IssuesManager.Issue.IssueCategory.LowTextContrast:return i18nString(UIStrings.lowTextContrast);case IssuesManager.Issue.IssueCategory.Cors:return i18nString(UIStrings.cors);case IssuesManager.Issue.IssueCategory.AttributionReporting:return i18nString(UIStrings.attributionReporting);case IssuesManager.Issue.IssueCategory.QuirksMode:return i18nString(UIStrings.quirksMode);case IssuesManager.Issue.IssueCategory.Generic:return i18nString(UIStrings.generic);case IssuesManager.Issue.IssueCategory.Other:return i18nString(UIStrings.other)}}onattach(){this.appendHeader()}appendHeader(){const e=document.createElement("div");e.classList.add("header");const s=document.createElement("div");s.classList.add("title"),s.textContent=this.getCategoryName(),e.appendChild(s),this.listItemElement.appendChild(e)}}export function getGroupIssuesByCategorySetting(){return Common.Settings.Settings.instance().createSetting("groupIssuesByCategory",!1)}let issuesPaneInstance;export class IssuesPane extends UI.Widget.VBox{categoryViews;issueViews;kindViews;showThirdPartyCheckbox;issuesTree;hiddenIssuesRow;noIssuesMessageDiv;issuesManager;aggregator;issueViewUpdatePromise=Promise.resolve();constructor(){super(!0),this.contentElement.classList.add("issues-pane"),this.categoryViews=new Map,this.kindViews=new Map,this.issueViews=new Map,this.showThirdPartyCheckbox=null,this.createToolbars(),this.issuesTree=new UI.TreeOutline.TreeOutlineInShadow,this.issuesTree.setShowSelectionOnKeyboardFocus(!0),this.issuesTree.contentElement.classList.add("issues"),this.contentElement.appendChild(this.issuesTree.element),this.hiddenIssuesRow=new HiddenIssuesRow,this.issuesTree.appendChild(this.hiddenIssuesRow),this.noIssuesMessageDiv=document.createElement("div"),this.noIssuesMessageDiv.classList.add("issues-pane-no-issues"),this.contentElement.appendChild(this.noIssuesMessageDiv),this.issuesManager=IssuesManager.IssuesManager.IssuesManager.instance(),this.aggregator=new IssueAggregator(this.issuesManager),this.aggregator.addEventListener("AggregatedIssueUpdated",this.issueUpdated,this),this.aggregator.addEventListener("FullUpdateRequired",this.onFullUpdate,this),this.hiddenIssuesRow.hidden=0===this.issuesManager.numberOfHiddenIssues(),this.onFullUpdate(),this.issuesManager.addEventListener("IssuesCountUpdated",this.updateCounts,this)}static instance(e={forceNew:null}){const{forceNew:s}=e;return issuesPaneInstance&&!s||(issuesPaneInstance=new IssuesPane),issuesPaneInstance}elementsToRestoreScrollPositionsFor(){return[this.issuesTree.element]}createToolbars(){const e=this.contentElement.createChild("div","issues-toolbar-container");new UI.Toolbar.Toolbar("issues-toolbar-left",e);const s=new UI.Toolbar.Toolbar("issues-toolbar-right",e),t=getGroupIssuesByCategorySetting(),i=new UI.Toolbar.ToolbarSettingCheckbox(t,i18nString(UIStrings.groupDisplayedIssuesUnder),i18nString(UIStrings.groupByCategory));i.setVisible(!1),s.appendToolbarItem(i),t.addChangeListener((()=>{this.fullUpdate(!0)}));const n=getGroupIssuesByKindSetting(),r=new UI.Toolbar.ToolbarSettingCheckbox(n,i18nString(UIStrings.groupDisplayedIssuesUnderKind),i18nString(UIStrings.groupByKind));s.appendToolbarItem(r),n.addChangeListener((()=>{this.fullUpdate(!0)})),r.setVisible(Root.Runtime.experiments.isEnabled("groupAndHideIssuesByKind"));const o=IssuesManager.Issue.getShowThirdPartyIssuesSetting();this.showThirdPartyCheckbox=new UI.Toolbar.ToolbarSettingCheckbox(o,i18nString(UIStrings.includeCookieIssuesCausedBy),i18nString(UIStrings.includeThirdpartyCookieIssues)),s.appendToolbarItem(this.showThirdPartyCheckbox),this.setDefaultFocusedElement(this.showThirdPartyCheckbox.inputElement),s.appendSeparator();const a=new IssueCounter.IssueCounter.IssueCounter;a.data={tooltipCallback:()=>{const e=IssueCounter.IssueCounter.getIssueCountsEnumeration(IssuesManager.IssuesManager.IssuesManager.instance(),!1);a.title=e},displayMode:"ShowAlways",issuesManager:IssuesManager.IssuesManager.IssuesManager.instance()},a.id="console-issues-counter";const u=new UI.Toolbar.ToolbarItem(a);return s.appendToolbarItem(u),{toolbarContainer:e}}issueUpdated(e){this.scheduleIssueViewUpdate(e.data)}scheduleIssueViewUpdate(e){this.issueViewUpdatePromise=this.issueViewUpdatePromise.then((()=>this.updateIssueView(e)))}async updateIssueView(e){let s=this.issueViews.get(e.aggregationKey());if(s){s.setIssue(e);const t=this.getIssueViewParent(e);s.parent===t||t instanceof UI.TreeOutline.TreeOutline&&s.parent===t.rootElement()||(s.parent?.removeChild(s),this.appendIssueViewToParent(s,t))}else{const t=e.getDescription();if(!t)return void console.warn("Could not find description for issue code:",e.code());const i=await IssuesManager.MarkdownIssueDescription.createIssueDescriptionFromMarkdown(t);s=new IssueView(e,i),this.issueViews.set(e.aggregationKey(),s);const n=this.getIssueViewParent(e);this.appendIssueViewToParent(s,n)}s.update(),this.updateCounts()}appendIssueViewToParent(e,s){s.appendChild(e,((e,s)=>e instanceof HiddenIssuesRow?1:s instanceof HiddenIssuesRow?-1:e instanceof IssueView&&s instanceof IssueView?e.getIssueTitle().localeCompare(s.getIssueTitle()):(console.error("The issues tree should only contain IssueView objects as direct children"),0)))}getIssueViewParent(e){const s=Root.Runtime.experiments.isEnabled("groupAndHideIssuesByKind");if(e.isHidden())return this.hiddenIssuesRow;if(s&&getGroupIssuesByKindSetting().get()){const s=e.getKind(),t=this.kindViews.get(s);if(t)return t;const i=new IssueKindView(s);return this.issuesTree.appendChild(i,((e,s)=>e instanceof IssueKindView&&s instanceof IssueKindView?issueKindViewSortPriority(e,s):0)),this.kindViews.set(s,i),i}if(getGroupIssuesByCategorySetting().get()){const s=e.getCategory(),t=this.categoryViews.get(s);if(t)return t;const i=new IssueCategoryView(s);return this.issuesTree.appendChild(i,((e,s)=>e instanceof IssueCategoryView&&s instanceof IssueCategoryView?e.getCategoryName().localeCompare(s.getCategoryName()):0)),this.categoryViews.set(s,i),i}return this.issuesTree}clearViews(e,s){for(const[t,i]of Array.from(e.entries()))s?.has(t)||(i.parent&&i.parent.removeChild(i),e.delete(t))}onFullUpdate(){this.fullUpdate(!1)}fullUpdate(e){if(this.clearViews(this.categoryViews,e?void 0:this.aggregator.aggregatedIssueCategories()),this.clearViews(this.kindViews,e?void 0:this.aggregator.aggregatedIssueKinds()),this.clearViews(this.issueViews,e?void 0:this.aggregator.aggregatedIssueCodes()),this.aggregator)for(const e of this.aggregator.aggregatedIssues())this.scheduleIssueViewUpdate(e);this.updateCounts()}updateIssueKindViewsCount(){for(const e of this.kindViews.values()){const s=this.issuesManager.numberOfIssues(e.getKind());e.update(s)}}updateCounts(){const e=Root.Runtime.experiments.isEnabled("groupAndHideIssuesByKind");this.showIssuesTreeOrNoIssuesDetectedMessage(this.issuesManager.numberOfIssues(),this.issuesManager.numberOfHiddenIssues()),e&&getGroupIssuesByKindSetting().get()&&this.updateIssueKindViewsCount()}showIssuesTreeOrNoIssuesDetectedMessage(e,s){if(e>0||s>0){this.hiddenIssuesRow.hidden=0===s,this.hiddenIssuesRow.update(s),this.issuesTree.element.hidden=!1,this.noIssuesMessageDiv.style.display="none";const e=this.issuesTree.firstChild();e&&(e.select(!0),this.setDefaultFocusedElement(e.listItemElement))}else{this.issuesTree.element.hidden=!0,this.showThirdPartyCheckbox&&this.setDefaultFocusedElement(this.showThirdPartyCheckbox.inputElement);const e=this.issuesManager.numberOfAllStoredIssues()>0;this.noIssuesMessageDiv.textContent=i18nString(e?UIStrings.onlyThirdpartyCookieIssues:UIStrings.noIssuesDetectedSoFar),this.noIssuesMessageDiv.style.display="flex"}}async reveal(e){await this.issueViewUpdatePromise;const s=this.aggregator.keyForIssue(e),t=this.issueViews.get(s),i=Root.Runtime.experiments.isEnabled("groupAndHideIssuesByKind");if(t){if(t.isForHiddenIssue()&&(this.hiddenIssuesRow.expand(),this.hiddenIssuesRow.reveal()),i&&getGroupIssuesByKindSetting().get()&&!t.isForHiddenIssue()){const e=this.kindViews.get(t.getIssueKind());e?.expand(),e?.reveal()}t.expand(),t.reveal(),t.select(!1,!0)}}wasShown(){super.wasShown(),this.issuesTree.registerCSSFiles([issuesTreeStyles]),this.registerCSSFiles([issuesPaneStyles])}}