import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";const UIStrings={canOnlyAuditHttphttpsPagesAnd:"Can only audit HTTP/HTTPS pages and `Chrome` extensions. Navigate to a different page to start an audit.",thereMayBeStoredDataAffectingSingular:"There may be stored data affecting loading performance in this location: {PH1}. Audit this page in an incognito window to prevent those resources from affecting your scores.",thereMayBeStoredDataAffectingLoadingPlural:"There may be stored data affecting loading performance in these locations: {PH1}. Audit this page in an incognito window to prevent those resources from affecting your scores.",multipleTabsAreBeingControlledBy:"Multiple tabs are being controlled by the same `service worker`. Close your other tabs on the same origin to audit this page.",atLeastOneCategoryMustBeSelected:"At least one category must be selected.",localStorage:"Local Storage",indexeddb:"IndexedDB",webSql:"Web SQL",performance:"Performance",howLongDoesThisAppTakeToShow:"How long does this app take to show content and become usable",progressiveWebApp:"Progressive Web App",doesThisPageMeetTheStandardOfA:"Does this page meet the standard of a Progressive Web App",bestPractices:"Best practices",doesThisPageFollowBestPractices:"Does this page follow best practices for modern web development",accessibility:"Accessibility",isThisPageUsableByPeopleWith:"Is this page usable by people with disabilities or impairments",seo:"SEO",isThisPageOptimizedForSearch:"Is this page optimized for search engine results ranking",publisherAds:"Publisher Ads",isThisPageOptimizedForAdSpeedAnd:"Is this page optimized for ad speed and quality",applyMobileEmulation:"Apply mobile emulation",applyMobileEmulationDuring:"Apply mobile emulation during auditing",mobile:"Mobile",desktop:"Desktop",simulatedThrottling:"Simulated throttling",simulateASlowerPageLoadBasedOn:"Simulate a slower page load, based on data from an initial unthrottled load. If disabled, the page is actually slowed with applied throttling.",clearStorage:"Clear storage",resetStorageLocalstorage:"Reset storage (`cache`, `service workers`, etc) before auditing. (Good for performance & `PWA` testing)"},str_=i18n.i18n.registerUIStrings("panels/lighthouse/LighthouseController.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class LighthouseController extends Common.ObjectWrapper.ObjectWrapper{manager;serviceWorkerListeners;inspectedURL;constructor(e){super(),e.registerStatusCallback((e=>this.dispatchEventToListeners(Events.AuditProgressChanged,{message:e})));for(const e of Presets)e.setting.addChangeListener(this.recomputePageAuditability.bind(this));for(const e of RuntimeSettings)e.setting.addChangeListener(this.recomputePageAuditability.bind(this));SDK.TargetManager.TargetManager.instance().observeModels(SDK.ServiceWorkerManager.ServiceWorkerManager,this),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.InspectedURLChanged,this.recomputePageAuditability,this)}modelAdded(e){this.manager||(this.manager=e,this.serviceWorkerListeners=[this.manager.addEventListener(SDK.ServiceWorkerManager.Events.RegistrationUpdated,this.recomputePageAuditability,this),this.manager.addEventListener(SDK.ServiceWorkerManager.Events.RegistrationDeleted,this.recomputePageAuditability,this)],this.recomputePageAuditability())}modelRemoved(e){this.manager===e&&(this.serviceWorkerListeners&&Common.EventTarget.removeEventListeners(this.serviceWorkerListeners),this.manager=null,this.recomputePageAuditability())}hasActiveServiceWorker(){if(!this.manager)return!1;const e=this.manager.target();if(!e)return!1;const t=Common.ParsedURL.ParsedURL.fromString(e.inspectedURL()),i=t&&t.securityOrigin();for(const e of this.manager.registrations().values())if(e.securityOrigin===i)for(const t of e.versions.values())if(t.controlledClients.length>1)return!0;return!1}hasAtLeastOneCategory(){return Presets.some((e=>e.setting.get()))}unauditablePageMessage(){if(!this.manager)return null;const e=this.manager.target(),t=e&&e.inspectedURL();return t&&!/^(http|chrome-extension)/.test(t)?i18nString(UIStrings.canOnlyAuditHttphttpsPagesAnd):null}async hasImportantResourcesNotCleared(){const e=RuntimeSettings.find((e=>"lighthouse.clear_storage"===e.setting.name));if(e&&!e.setting.get())return"";if(!this.manager)return"";const t=this.manager.target(),i=(await t.storageAgent().invoke_getUsageAndQuota({origin:t.inspectedURL()})).usageBreakdown.filter((e=>e.usage)).map((e=>STORAGE_TYPE_NAMES.get(e.storageType))).map((e=>e?e():void 0)).filter(Boolean);return 1===i.length?i18nString(UIStrings.thereMayBeStoredDataAffectingSingular,{PH1:String(i[0])}):i.length>1?i18nString(UIStrings.thereMayBeStoredDataAffectingLoadingPlural,{PH1:i.join(", ")}):""}async evaluateInspectedURL(){if(!this.manager)return"";const e=this.manager.target(),t=e.inspectedURL(),i=e.model(SDK.ResourceTreeModel.ResourceTreeModel),n=i&&await i.navigationHistory();if(!i||!n)return t;const{currentIndex:s,entries:a}=n;return a[s].url}getFlags(){const e={internalDisableDeviceScreenEmulation:!0};for(const t of RuntimeSettings)t.setFlags(e,t.setting.get());return e}getCategoryIDs(){const e=[];for(const t of Presets)t.setting.get()&&e.push(t.configID);return e}async getInspectedURL(e){return(e&&e.force||!this.inspectedURL)&&(this.inspectedURL=await this.evaluateInspectedURL()),this.inspectedURL}recomputePageAuditability(){const e=this.hasActiveServiceWorker(),t=this.hasAtLeastOneCategory(),i=this.unauditablePageMessage();let n="";e?n=i18nString(UIStrings.multipleTabsAreBeingControlledBy):t?i&&(n=i):n=i18nString(UIStrings.atLeastOneCategoryMustBeSelected),this.dispatchEventToListeners(Events.PageAuditabilityChanged,{helpText:n}),this.hasImportantResourcesNotCleared().then((e=>{this.dispatchEventToListeners(Events.PageWarningsChanged,{warning:e})}))}}const STORAGE_TYPE_NAMES=new Map([["local_storage",i18nLazyString(UIStrings.localStorage)],["indexeddb",i18nLazyString(UIStrings.indexeddb)],["websql",i18nLazyString(UIStrings.webSql)]]);export const Presets=[{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_perf",!0,Common.Settings.SettingStorageType.Synced),configID:"performance",title:i18nLazyString(UIStrings.performance),description:i18nLazyString(UIStrings.howLongDoesThisAppTakeToShow),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_pwa",!0,Common.Settings.SettingStorageType.Synced),configID:"pwa",title:i18nLazyString(UIStrings.progressiveWebApp),description:i18nLazyString(UIStrings.doesThisPageMeetTheStandardOfA),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_best_practices",!0,Common.Settings.SettingStorageType.Synced),configID:"best-practices",title:i18nLazyString(UIStrings.bestPractices),description:i18nLazyString(UIStrings.doesThisPageFollowBestPractices),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_a11y",!0,Common.Settings.SettingStorageType.Synced),configID:"accessibility",title:i18nLazyString(UIStrings.accessibility),description:i18nLazyString(UIStrings.isThisPageUsableByPeopleWith),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_seo",!0,Common.Settings.SettingStorageType.Synced),configID:"seo",title:i18nLazyString(UIStrings.seo),description:i18nLazyString(UIStrings.isThisPageOptimizedForSearch),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_pubads",!1,Common.Settings.SettingStorageType.Synced),plugin:!0,configID:"lighthouse-plugin-publisher-ads",title:i18nLazyString(UIStrings.publisherAds),description:i18nLazyString(UIStrings.isThisPageOptimizedForAdSpeedAnd)}];export const RuntimeSettings=[{setting:Common.Settings.Settings.instance().createSetting("lighthouse.device_type","mobile",Common.Settings.SettingStorageType.Synced),title:i18nLazyString(UIStrings.applyMobileEmulation),description:i18nLazyString(UIStrings.applyMobileEmulationDuring),setFlags:(e,t)=>{e.emulatedFormFactor=t},options:[{label:i18nLazyString(UIStrings.mobile),value:"mobile"},{label:i18nLazyString(UIStrings.desktop),value:"desktop"}],learnMore:void 0},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.throttling",!0,Common.Settings.SettingStorageType.Synced),title:i18nLazyString(UIStrings.simulatedThrottling),learnMore:"https://github.com/GoogleChrome/lighthouse/blob/master/docs/throttling.md#devtools-lighthouse-panel-throttling",description:i18nLazyString(UIStrings.simulateASlowerPageLoadBasedOn),setFlags:(e,t)=>{e.throttlingMethod=t?"simulate":"devtools"},options:void 0},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.clear_storage",!0,Common.Settings.SettingStorageType.Synced),title:i18nLazyString(UIStrings.clearStorage),description:i18nLazyString(UIStrings.resetStorageLocalstorage),setFlags:(e,t)=>{e.disableStorageReset=!t},options:void 0,learnMore:void 0}];export var Events;!function(e){e.PageAuditabilityChanged="PageAuditabilityChanged",e.PageWarningsChanged="PageWarningsChanged",e.AuditProgressChanged="AuditProgressChanged",e.RequestLighthouseStart="RequestLighthouseStart",e.RequestLighthouseCancel="RequestLighthouseCancel"}(Events||(Events={}));