import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as EmulationModel from"../../models/emulation/emulation.js";import*as UI from"../../ui/legacy/legacy.js";import*as Emulation from"../emulation/emulation.js";import{Events,LighthouseController}from"./LighthouseController.js";import lighthousePanelStyles from"./lighthousePanel.css.js";import{ProtocolService}from"./LighthouseProtocolService.js";import*as LighthouseReport from"../../third_party/lighthouse/report/report.js";import{LighthouseReportRenderer,LighthouseReportUIFeatures}from"./LighthouseReportRenderer.js";import{Item,ReportSelector}from"./LighthouseReportSelector.js";import{StartView}from"./LighthouseStartView.js";import{StatusView}from"./LighthouseStatusView.js";const UIStrings={dropLighthouseJsonHere:"Drop `Lighthouse` JSON here",performAnAudit:"Perform an audit…",clearAll:"Clear all",lighthouseSettings:"`Lighthouse` settings",printing:"Printing",thePrintPopupWindowIsOpenPlease:"The print popup window is open. Please close it to continue.",cancelling:"Cancelling"},str_=i18n.i18n.registerUIStrings("panels/lighthouse/LighthousePanel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let lighthousePanelInstace;export class LighthousePanel extends UI.Panel.Panel{protocolService;controller;startView;statusView;warningText;unauditableExplanation;cachedRenderedReports;dropTarget;auditResultsElement;clearButton;newButton;reportSelector;settingsPane;rightToolbar;showSettingsPaneSetting;stateBefore;isLHAttached;constructor(){super("lighthouse"),this.protocolService=new ProtocolService,this.controller=new LighthouseController(this.protocolService),this.startView=new StartView(this.controller),this.statusView=new StatusView(this.controller),this.warningText=null,this.unauditableExplanation=null,this.cachedRenderedReports=new Map,this.dropTarget=new UI.DropTarget.DropTarget(this.contentElement,[UI.DropTarget.Type.File],i18nString(UIStrings.dropLighthouseJsonHere),this.handleDrop.bind(this)),this.controller.addEventListener(Events.PageAuditabilityChanged,this.refreshStartAuditUI.bind(this)),this.controller.addEventListener(Events.PageWarningsChanged,this.refreshWarningsUI.bind(this)),this.controller.addEventListener(Events.AuditProgressChanged,this.refreshStatusUI.bind(this)),this.controller.addEventListener(Events.RequestLighthouseStart,(t=>{this.startLighthouse()})),this.controller.addEventListener(Events.RequestLighthouseCancel,(t=>{this.cancelLighthouse()})),this.renderToolbar(),this.auditResultsElement=this.contentElement.createChild("div","lighthouse-results-container"),this.renderStartView(),this.controller.recomputePageAuditability()}static instance(t={forceNew:null}){const{forceNew:e}=t;return lighthousePanelInstace&&!e||(lighthousePanelInstace=new LighthousePanel),lighthousePanelInstace}static getEvents(){return Events}refreshWarningsUI(t){this.isLHAttached||(this.warningText=t.data.warning,this.startView.setWarningText(t.data.warning))}refreshStartAuditUI(t){this.isLHAttached||(this.unauditableExplanation=t.data.helpText,this.startView.setUnauditableExplanation(t.data.helpText),this.startView.setStartButtonEnabled(!t.data.helpText))}refreshStatusUI(t){this.statusView.updateStatus(t.data.message)}refreshToolbarUI(){this.clearButton.setEnabled(this.reportSelector.hasItems())}clearAll(){this.reportSelector.clearAll(),this.renderStartView(),this.refreshToolbarUI()}renderToolbar(){const t=this.element.createChild("div","lighthouse-toolbar-container"),e=new UI.Toolbar.Toolbar("",t);this.newButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.performAnAudit),"largeicon-add"),e.appendToolbarItem(this.newButton),this.newButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.renderStartView.bind(this)),e.appendSeparator(),this.reportSelector=new ReportSelector((()=>this.renderStartView())),e.appendToolbarItem(this.reportSelector.comboBox()),this.clearButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearAll),"largeicon-clear"),e.appendToolbarItem(this.clearButton),this.clearButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.clearAll.bind(this)),this.settingsPane=new UI.Widget.HBox,this.settingsPane.show(this.contentElement),this.settingsPane.element.classList.add("lighthouse-settings-pane"),this.settingsPane.element.appendChild(this.startView.settingsToolbar().element),this.showSettingsPaneSetting=Common.Settings.Settings.instance().createSetting("lighthouseShowSettingsToolbar",!1,Common.Settings.SettingStorageType.Synced),this.rightToolbar=new UI.Toolbar.Toolbar("",t),this.rightToolbar.appendSeparator(),this.rightToolbar.appendToolbarItem(new UI.Toolbar.ToolbarSettingToggle(this.showSettingsPaneSetting,"largeicon-settings-gear",i18nString(UIStrings.lighthouseSettings))),this.showSettingsPaneSetting.addChangeListener(this.updateSettingsPaneVisibility.bind(this)),this.updateSettingsPaneVisibility(),this.refreshToolbarUI()}updateSettingsPaneVisibility(){this.settingsPane.element.classList.toggle("hidden",!this.showSettingsPaneSetting.get())}toggleSettingsDisplay(t){this.rightToolbar.element.classList.toggle("hidden",!t),this.settingsPane.element.classList.toggle("hidden",!t),this.updateSettingsPaneVisibility()}renderStartView(){this.auditResultsElement.removeChildren(),this.statusView.hide(),this.reportSelector.selectNewReport(),this.contentElement.classList.toggle("in-progress",!1),this.startView.show(this.contentElement),this.toggleSettingsDisplay(!0),this.startView.setUnauditableExplanation(this.unauditableExplanation),this.startView.setStartButtonEnabled(!this.unauditableExplanation),this.unauditableExplanation||this.startView.focusStartButton(),this.startView.setWarningText(this.warningText),this.newButton.setEnabled(!1),this.refreshToolbarUI(),this.setDefaultFocusedChild(this.startView)}renderStatusView(t){this.contentElement.classList.toggle("in-progress",!0),this.statusView.setInspectedURL(t),this.statusView.show(this.contentElement)}beforePrint(){this.statusView.show(this.contentElement),this.statusView.toggleCancelButton(!1),this.statusView.renderText(i18nString(UIStrings.printing),i18nString(UIStrings.thePrintPopupWindowIsOpenPlease))}afterPrint(){this.statusView.hide(),this.statusView.toggleCancelButton(!0)}renderReport(t,e){this.toggleSettingsDisplay(!1),this.contentElement.classList.toggle("in-progress",!1),this.startView.hideWidget(),this.statusView.hide(),this.auditResultsElement.removeChildren(),this.newButton.setEnabled(!0),this.refreshToolbarUI();const i=this.cachedRenderedReports.get(t);if(i)return void this.auditResultsElement.appendChild(i);const s=this.auditResultsElement.createChild("div","lh-vars lh-root lh-devtools"),n=new LighthouseReport.DOM(this.auditResultsElement.ownerDocument,s),o=new LighthouseReportRenderer(n).renderReport(t,s);this.waitForMainTargetLoad().then((()=>{LighthouseReportRenderer.linkifyNodeDetails(o),LighthouseReportRenderer.linkifySourceLocationDetails(o)})),LighthouseReportRenderer.handleDarkMode(o);const r=new LighthouseReportUIFeatures(n);r.setBeforePrint(this.beforePrint.bind(this)),r.setAfterPrint(this.afterPrint.bind(this)),LighthouseReportRenderer.addViewTraceButton(o,r,e),r.initFeatures(t),this.cachedRenderedReports.set(t,s)}async waitForMainTargetLoad(){const t=SDK.TargetManager.TargetManager.instance().mainTarget();if(!t)return;const e=t.model(SDK.ResourceTreeModel.ResourceTreeModel);e&&await e.once(SDK.ResourceTreeModel.Events.Load)}buildReportUI(t,e){if(null===t)return;const i=new Item(t,(()=>this.renderReport(t,e)),this.renderStartView.bind(this));this.reportSelector.prepend(i),this.refreshToolbarUI(),this.renderReport(t)}handleDrop(t){const e=t.items;if(!e.length)return;if("file"===e[0].kind){const t=e[0].getAsFile();if(!t)return;const i=new FileReader;i.onload=()=>this.loadedFromFile(i.result),i.readAsText(t)}}loadedFromFile(t){const e=JSON.parse(t);e.lighthouseVersion&&this.buildReportUI(e)}async startLighthouse(){Host.userMetrics.actionTaken(Host.UserMetrics.Action.LighthouseStarted);try{const t=await this.controller.getInspectedURL({force:!0}),e=this.controller.getCategoryIDs(),i=this.controller.getFlags();await this.setupEmulationAndProtocolConnection(),this.renderStatusView(t);const s=await this.protocolService.startLighthouse(t,e,i);if(s&&s.fatal){const t=new Error(s.message);throw t.stack=s.stack,t}if(!s)throw new Error("Auditing failed to produce a result");Host.userMetrics.actionTaken(Host.UserMetrics.Action.LighthouseFinished),await this.resetEmulationAndProtocolConnection(),this.buildReportUI(s.lhr,s.artifacts),this.newButton.element.focus()}catch(t){await this.resetEmulationAndProtocolConnection(),t instanceof Error&&this.statusView.renderBugReport(t)}}async cancelLighthouse(){this.statusView.updateStatus(i18nString(UIStrings.cancelling)),await this.resetEmulationAndProtocolConnection(),this.renderStartView()}async setupEmulationAndProtocolConnection(){const t=this.controller.getFlags(),e=EmulationModel.DeviceModeModel.DeviceModeModel.instance();if(this.stateBefore={emulation:{enabled:e.enabledSetting().get(),outlineEnabled:e.deviceOutlineSetting().get(),toolbarControlsEnabled:e.toolbarControlsEnabledSetting().get()},network:{conditions:SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()}},e.toolbarControlsEnabledSetting().set(!1),"emulatedFormFactor"in t&&"desktop"===t.emulatedFormFactor)e.enabledSetting().set(!1),e.emulate(EmulationModel.DeviceModeModel.Type.None,null,null);else if("mobile"===t.emulatedFormFactor){e.enabledSetting().set(!0),e.deviceOutlineSetting().set(!0);for(const t of EmulationModel.EmulatedDevices.EmulatedDevicesList.instance().standard())"Moto G4"===t.title&&e.emulate(EmulationModel.DeviceModeModel.Type.Device,t,t.modes[0],1)}await this.protocolService.attach(),this.isLHAttached=!0}async resetEmulationAndProtocolConnection(){if(!this.isLHAttached)return;if(this.isLHAttached=!1,await this.protocolService.detach(),this.stateBefore){const t=EmulationModel.DeviceModeModel.DeviceModeModel.instance();t.enabledSetting().set(this.stateBefore.emulation.enabled),t.deviceOutlineSetting().set(this.stateBefore.emulation.outlineEnabled),t.toolbarControlsEnabledSetting().set(this.stateBefore.emulation.toolbarControlsEnabled),SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(this.stateBefore.network.conditions),delete this.stateBefore}Emulation.InspectedPagePlaceholder.InspectedPagePlaceholder.instance().update(!0);const t=SDK.TargetManager.TargetManager.instance().mainTarget();if(!t)return;const e=t.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!e)return;const i=await this.controller.getInspectedURL();await e.navigate(i)}wasShown(){super.wasShown(),this.registerCSSFiles([lighthousePanelStyles])}}