import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Workspace from"../../models/workspace/workspace.js";import*as LighthouseReport from"../../third_party/lighthouse/report/report.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import*as ThemeSupport from"../../ui/legacy/theme_support/theme_support.js";import*as Timeline from"../timeline/timeline.js";const UIStrings={viewOriginalTrace:"View Original Trace",viewTrace:"View Trace",thePerformanceMetricsAboveAre:'The performance metrics above are simulated and won\'t match the timings found in this trace. Disable simulated throttling in "Lighthouse Settings" if you want the timings to match.'},str_=i18n.i18n.registerUIStrings("panels/lighthouse/LighthouseReportRenderer.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),MaxLengthForLinks=40;export class LighthouseReportRenderer extends LighthouseReport.ReportRenderer{constructor(e){super(e)}static addViewTraceButton(e,t,i){if(!i||!i.traces||!i.traces.defaultPass)return;const o="simulate"===i.settings.throttlingMethod;if(!e.querySelector(".lh-audit-group"))return;const r=i.traces.defaultPass,n=i18nString(o?UIStrings.viewOriginalTrace:UIStrings.viewTrace),s=t.addButton({text:n,onClick:async function(){Host.userMetrics.actionTaken(Host.UserMetrics.Action.LighthouseViewTrace),await UI.InspectorView.InspectorView.instance().showPanel("timeline"),Timeline.TimelinePanel.TimelinePanel.instance().loadFromEvents(r.traceEvents)}});s&&(s.classList.add("lh-button--trace"),o&&UI.Tooltip.Tooltip.install(s,i18nString(UIStrings.thePerformanceMetricsAboveAre)))}static async linkifyNodeDetails(e){const t=SDK.TargetManager.TargetManager.instance().mainTarget();if(!t)return;const i=t.model(SDK.DOMModel.DOMModel);if(i)for(const t of e.getElementsByClassName("lh-node")){const e=t,o=e.dataset;if(!o.path)continue;const r=await i.pushNodeByPathToFrontend(o.path);if(!r)continue;const n=i.nodeForId(r);if(!n)continue;const s=await Common.Linkifier.Linkifier.linkify(n,{tooltip:o.snippet,preventKeyboardFocus:void 0});UI.Tooltip.Tooltip.install(e,"");const a=e.querySelector(".lh-element-screenshot");e.textContent="",a&&e.append(a),e.appendChild(s)}}static async linkifySourceLocationDetails(e){for(const t of e.getElementsByClassName("lh-source-location")){const e=t,i=e.dataset;if(!i.sourceUrl||!i.sourceLine||!i.sourceColumn)continue;const o=i.sourceUrl,r=Number(i.sourceLine),n=Number(i.sourceColumn),s=await Components.Linkifier.Linkifier.linkifyURL(o,{lineNumber:r,columnNumber:n,showColumnNumber:!1,inlineFrameIndex:0,maxLength:40,bypassURLTrimming:void 0,className:void 0,preventClick:void 0,tabStop:void 0,text:void 0});UI.Tooltip.Tooltip.install(e,""),e.textContent="",e.appendChild(s)}}static handleDarkMode(e){"dark"===ThemeSupport.ThemeSupport.instance().themeName()&&e.classList.add("lh-dark")}}export class LighthouseReportUIFeatures extends LighthouseReport.ReportUIFeatures{beforePrint;afterPrint;constructor(e){super(e),this.beforePrint=null,this.afterPrint=null,this._topbar._print=this._print.bind(this)}setBeforePrint(e){this.beforePrint=e}setAfterPrint(e){this.afterPrint=e}getReportHtml(){return this.resetUIState(),Lighthouse.ReportGenerator.generateReportHtml(this.json)}async _saveFile(e){const t=`${new Common.ParsedURL.ParsedURL(this.json.finalUrl).domain().replace(/[^a-z0-9.-]+/gi,"_")}-${Platform.DateUtilities.toISO8601Compact(new Date(this.json.fetchTime))}${e.type.match("json")?".json":".html"}`,i=await e.text();Workspace.FileManager.FileManager.instance().save(t,i,!0)}async _print(){const e=this.getDocument().querySelector(".lh-root").cloneNode(!0),t=window.open("","_blank","channelmode=1,status=1,resizable=1");t&&(t.document.body.replaceWith(e),await LighthouseReportRenderer.linkifyNodeDetails(e),this.beforePrint&&this.beforePrint(),t.focus(),t.print(),t.close(),this.afterPrint&&this.afterPrint())}getDocument(){return this._dom.document()}resetUIState(){this._resetUIState()}}