import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as UI from"../../ui/legacy/legacy.js";import{MobileThrottlingSelector}from"./MobileThrottlingSelector.js";import{NetworkThrottlingSelector}from"./NetworkThrottlingSelector.js";import{ThrottlingPresets}from"./ThrottlingPresets.js";const UIStrings={sS:"{PH1}: {PH2}",add:"Add…",addS:"Add {PH1}",offline:"Offline",forceDisconnectedFromNetwork:"Force disconnected from network",throttling:"Throttling",cpuThrottlingIsEnabled:"CPU throttling is enabled",cpuThrottling:"CPU throttling",noThrottling:"No throttling",dSlowdown:"{PH1}× slowdown"},str_=i18n.i18n.registerUIStrings("panels/mobile_throttling/ThrottlingManager.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let throttlingManagerInstance,actionDelegateInstance;export class ThrottlingManager{cpuThrottlingControls;cpuThrottlingRates;customNetworkConditionsSetting;currentNetworkThrottlingConditionsSetting;lastNetworkThrottlingConditions;cpuThrottlingManager;constructor(){this.cpuThrottlingManager=SDK.CPUThrottlingManager.CPUThrottlingManager.instance(),this.cpuThrottlingControls=new Set,this.cpuThrottlingRates=ThrottlingPresets.cpuThrottlingPresets,this.customNetworkConditionsSetting=Common.Settings.Settings.instance().moduleSetting("customNetworkConditions"),this.currentNetworkThrottlingConditionsSetting=Common.Settings.Settings.instance().createSetting("preferredNetworkCondition",SDK.NetworkManager.NoThrottlingConditions),this.currentNetworkThrottlingConditionsSetting.setSerializer(new SDK.NetworkManager.ConditionsSerializer),SDK.NetworkManager.MultitargetNetworkManager.instance().addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,(()=>{this.lastNetworkThrottlingConditions=this.currentNetworkThrottlingConditionsSetting.get(),this.currentNetworkThrottlingConditionsSetting.set(SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions())})),this.isDirty()&&SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(this.currentNetworkThrottlingConditionsSetting.get())}static instance(t={forceNew:null}){const{forceNew:n}=t;return throttlingManagerInstance&&!n||(throttlingManagerInstance=new ThrottlingManager),throttlingManagerInstance}decorateSelectWithNetworkThrottling(t){let n=[];const e=new NetworkThrottlingSelector((function(e){t.removeChildren(),n=[];for(let o=0;o<e.length;++o){const i=e[o],r=t.createChild("optgroup");r.label=i.title;for(const t of i.items){const e="function"==typeof t.title?t.title():t.title,o=new Option(e,e);UI.ARIAUtils.setAccessibleName(o,i18nString(UIStrings.sS,{PH1:i.title,PH2:e})),r.appendChild(o),n.push(t)}if(o===e.length-1){const t=new Option(i18nString(UIStrings.add),i18nString(UIStrings.add));UI.ARIAUtils.setAccessibleName(t,i18nString(UIStrings.addS,{PH1:i.title})),r.appendChild(t),n.push(null)}}return n}),(function(n){t.selectedIndex!==n&&(t.selectedIndex=n)}),this.customNetworkConditionsSetting);return t.addEventListener("change",(function(){if(t.selectedIndex===t.options.length-1)e.revealAndUpdate();else{const o=n[t.selectedIndex];o&&e.optionSelected(o)}}),!1),e}createOfflineToolbarCheckbox(){const t=new UI.Toolbar.ToolbarCheckbox(i18nString(UIStrings.offline),i18nString(UIStrings.forceDisconnectedFromNetwork),function(){t.checked()?SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.OfflineConditions):SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(this.lastNetworkThrottlingConditions)}.bind(this));return SDK.NetworkManager.MultitargetNetworkManager.instance().addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,(function(){t.setChecked(SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()===SDK.NetworkManager.OfflineConditions)})),t.setChecked(SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()===SDK.NetworkManager.OfflineConditions),t}createMobileThrottlingButton(){const t=new UI.Toolbar.ToolbarMenuButton((function(t){for(let i=0;i<n.length;++i){const r=n[i];r&&(r.title===ThrottlingPresets.getCustomConditions().title&&r.description===ThrottlingPresets.getCustomConditions().description||t.defaultSection().appendCheckboxItem(r.title,o.optionSelected.bind(o,r),e===i))}}));t.setTitle(i18nString(UIStrings.throttling)),t.setGlyph(""),t.turnIntoSelect(),t.setDarkText();let n=[],e=-1;const o=new MobileThrottlingSelector((function(t){n=[];for(const e of t){for(const t of e.items)n.push(t);n.push(null)}return n}),(function(o){e=o;const i=n[o];i&&(t.setText(i.title),t.setTitle(i.description))}));return t}setCPUThrottlingRate(t){this.cpuThrottlingManager.setCPUThrottlingRate(t);let n=null;t!==SDK.CPUThrottlingManager.CPUThrottlingRates.NoThrottling&&(Host.userMetrics.actionTaken(Host.UserMetrics.Action.CpuThrottlingEnabled),n=UI.Icon.Icon.create("smallicon-warning"),UI.Tooltip.Tooltip.install(n,i18nString(UIStrings.cpuThrottlingIsEnabled)));const e=this.cpuThrottlingRates.indexOf(t);for(const t of this.cpuThrottlingControls)t.setSelectedIndex(e);UI.InspectorView.InspectorView.instance().setPanelIcon("timeline",n)}createCPUThrottlingSelector(){const t=new UI.Toolbar.ToolbarComboBox((t=>this.setCPUThrottlingRate(this.cpuThrottlingRates[t.target.selectedIndex])),i18nString(UIStrings.cpuThrottling));this.cpuThrottlingControls.add(t);const n=this.cpuThrottlingManager.cpuThrottlingRate();for(let e=0;e<this.cpuThrottlingRates.length;++e){const o=this.cpuThrottlingRates[e],i=1===o?i18nString(UIStrings.noThrottling):i18nString(UIStrings.dSlowdown,{PH1:o}),r=t.createOption(i);t.addOption(r),n===o&&t.setSelectedIndex(e)}return t}isDirty(){const t=SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions(),n=this.currentNetworkThrottlingConditionsSetting.get();return!SDK.NetworkManager.networkConditionsEqual(t,n)}}export class ActionDelegate{static instance(t={forceNew:null}){const{forceNew:n}=t;return actionDelegateInstance&&!n||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(t,n){return"network-conditions.network-online"===n?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.NoThrottlingConditions),!0):"network-conditions.network-low-end-mobile"===n?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.Slow3GConditions),!0):"network-conditions.network-mid-tier-mobile"===n?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.Fast3GConditions),!0):"network-conditions.network-offline"===n&&(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.OfflineConditions),!0)}}export function throttlingManager(){return ThrottlingManager.instance()}