import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as NetworkForward from"../../panels/network/forward/forward.js";import*as UI from"../../ui/legacy/legacy.js";import*as NetworkComponents from"./components/components.js";import{EventSourceMessagesView}from"./EventSourceMessagesView.js";import{RequestCookiesView}from"./RequestCookiesView.js";import{RequestHeadersView}from"./RequestHeadersView.js";import{RequestPayloadView}from"./RequestPayloadView.js";import{RequestInitiatorView}from"./RequestInitiatorView.js";import{RequestPreviewView}from"./RequestPreviewView.js";import{RequestResponseView}from"./RequestResponseView.js";import{RequestTimingView}from"./RequestTimingView.js";import{ResourceWebSocketFrameView}from"./ResourceWebSocketFrameView.js";const UIStrings={headers:"Headers",payload:"Payload",messages:"Messages",websocketMessages:"WebSocket messages",eventstream:"EventStream",preview:"Preview",responsePreview:"Response preview",signedexchangeError:"SignedExchange error",response:"Response",rawResponseData:"Raw response data",initiator:"Initiator",requestInitiatorCallStack:"Request initiator call stack",timing:"Timing",requestAndResponseTimeline:"Request and response timeline",trustTokens:"Trust Tokens",trustTokenOperationDetails:"Trust Token operation details",cookies:"Cookies",requestAndResponseCookies:"Request and response cookies"},str_=i18n.i18n.registerUIStrings("panels/network/NetworkItemView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class NetworkItemView extends UI.TabbedPane.TabbedPane{requestInternal;resourceViewTabSetting;headersView;payloadView;responseView;cookiesView;initialTab;constructor(e,s,t){if(super(),this.requestInternal=e,this.element.classList.add("network-item-view"),this.resourceViewTabSetting=Common.Settings.Settings.instance().createSetting("resourceViewTab",NetworkForward.UIRequestLocation.UIRequestTabs.Preview),this.headersView=new RequestHeadersView(e),this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Headers,i18nString(UIStrings.headers),this.headersView,i18nString(UIStrings.headers)),this.payloadView=null,this.maybeAppendPayloadPanel(),this.addEventListener(UI.TabbedPane.Events.TabSelected,this.tabSelected,this),e.resourceType()===Common.ResourceType.resourceTypes.WebSocket){const s=new ResourceWebSocketFrameView(e);this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.WsFrames,i18nString(UIStrings.messages),s,i18nString(UIStrings.websocketMessages))}else if(e.mimeType===SDK.NetworkRequest.MIME_TYPE.EVENTSTREAM)this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.EventSource,i18nString(UIStrings.eventstream),new EventSourceMessagesView(e));else{this.responseView=new RequestResponseView(e);const s=new RequestPreviewView(e);this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Preview,i18nString(UIStrings.preview),s,i18nString(UIStrings.responsePreview));const t=e.signedExchangeInfo();if(t&&t.errors&&t.errors.length){const e=UI.Icon.Icon.create("smallicon-error");UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.signedexchangeError)),this.setTabIcon(NetworkForward.UIRequestLocation.UIRequestTabs.Preview,e)}this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Response,i18nString(UIStrings.response),this.responseView,i18nString(UIStrings.rawResponseData))}this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Initiator,i18nString(UIStrings.initiator),new RequestInitiatorView(e),i18nString(UIStrings.requestInitiatorCallStack)),this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Timing,i18nString(UIStrings.timing),new RequestTimingView(e,s),i18nString(UIStrings.requestAndResponseTimeline)),e.trustTokenParams()&&this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.TrustTokens,i18nString(UIStrings.trustTokens),new NetworkComponents.RequestTrustTokensView.RequestTrustTokensView(e),i18nString(UIStrings.trustTokenOperationDetails)),this.cookiesView=null,this.initialTab=t||this.resourceViewTabSetting.get(),this.setAutoSelectFirstItemOnShow(!1)}wasShown(){super.wasShown(),this.requestInternal.addEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this.requestHeadersChanged,this),this.requestInternal.addEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this.maybeAppendCookiesPanel,this),this.requestInternal.addEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this.maybeShowErrorIconInTrustTokenTabHeader,this),this.maybeAppendCookiesPanel(),this.maybeShowErrorIconInTrustTokenTabHeader(),this.initialTab&&(this.selectTabInternal(this.initialTab),this.initialTab=void 0)}willHide(){this.requestInternal.removeEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this.requestHeadersChanged,this),this.requestInternal.removeEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this.maybeAppendCookiesPanel,this),this.requestInternal.removeEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this.maybeShowErrorIconInTrustTokenTabHeader,this)}async requestHeadersChanged(){this.maybeAppendCookiesPanel(),this.maybeAppendPayloadPanel()}maybeAppendCookiesPanel(){const e=this.requestInternal.hasRequestCookies()||this.requestInternal.responseCookies.length>0;console.assert(e||!this.cookiesView,"Cookies were introduced in headers and then removed!"),e&&!this.cookiesView&&(this.cookiesView=new RequestCookiesView(this.requestInternal),this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Cookies,i18nString(UIStrings.cookies),this.cookiesView,i18nString(UIStrings.requestAndResponseCookies)))}async maybeAppendPayloadPanel(){this.hasTab("payload")||(this.requestInternal.queryParameters||await this.requestInternal.requestFormData())&&(this.payloadView=new RequestPayloadView(this.requestInternal),this.appendTab(NetworkForward.UIRequestLocation.UIRequestTabs.Payload,i18nString(UIStrings.payload),this.payloadView,i18nString(UIStrings.payload),void 0,void 0,void 0,1))}maybeShowErrorIconInTrustTokenTabHeader(){const e=this.requestInternal.trustTokenOperationDoneEvent();e&&!NetworkComponents.RequestTrustTokensView.statusConsideredSuccess(e.status)&&this.setTabIcon(NetworkForward.UIRequestLocation.UIRequestTabs.TrustTokens,UI.Icon.Icon.create("smallicon-error"))}selectTabInternal(e){this.selectTab(e)||setTimeout((()=>{this.selectTab(e)||this.selectTab("headers")}),0)}tabSelected(e){e.data.isUserGesture&&this.resourceViewTabSetting.set(e.data.tabId)}request(){return this.requestInternal}async revealResponseBody(e){this.selectTabInternal(NetworkForward.UIRequestLocation.UIRequestTabs.Response),this.responseView&&"number"==typeof e&&await this.responseView.revealLine(e)}revealHeader(e,s){this.selectTabInternal(NetworkForward.UIRequestLocation.UIRequestTabs.Headers),this.headersView.revealHeader(e,s)}}