import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as DataGrid from"../../ui/legacy/components/data_grid/data_grid.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import{NetworkRequestNode}from"./NetworkDataGridNode.js";import{NetworkManageCustomHeadersView}from"./NetworkManageCustomHeadersView.js";import{NetworkWaterfallColumn}from"./NetworkWaterfallColumn.js";import{RequestInitiatorView}from"./RequestInitiatorView.js";const UIStrings={networkLog:"Network Log",waterfall:"Waterfall",responseHeaders:"Response Headers",manageHeaderColumns:"Manage Header Columns…",startTime:"Start Time",responseTime:"Response Time",endTime:"End Time",totalDuration:"Total Duration",latency:"Latency",name:"Name",path:"Path",url:"Url",method:"Method",status:"Status",text:"Text",protocol:"Protocol",scheme:"Scheme",domain:"Domain",remoteAddress:"Remote Address",type:"Type",initiator:"Initiator",initiatorAddressSpace:"Initiator Address Space",cookies:"Cookies",setCookies:"Set Cookies",size:"Size",content:"Content",time:"Time",priority:"Priority",connectionId:"Connection ID",remoteAddressSpace:"Remote Address Space"},str_=i18n.i18n.registerUIStrings("panels/network/NetworkLogViewColumns.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class NetworkLogViewColumns{networkLogView;persistantSettings;networkLogLargeRowsSetting;eventDividers;eventDividersShown;gridMode;columns;waterfallRequestsAreStale;waterfallScrollerWidthIsStale;popupLinkifier;calculatorsMap;lastWheelTime;dataGridInternal;splitWidget;waterfallColumn;activeScroller;dataGridScroller;waterfallScroller;waterfallScrollerContent;waterfallHeaderElement;waterfallColumnSortIcon;activeWaterfallSortId;popoverHelper;hasScrollerTouchStarted;scrollerTouchStartPos;constructor(t,e,i,r){this.networkLogView=t,this.persistantSettings=Common.Settings.Settings.instance().createSetting("networkLogColumns",{}),this.networkLogLargeRowsSetting=r,this.networkLogLargeRowsSetting.addChangeListener(this.updateRowsSize,this),this.eventDividers=new Map,this.eventDividersShown=!1,this.gridMode=!0,this.columns=[],this.waterfallRequestsAreStale=!1,this.waterfallScrollerWidthIsStale=!0,this.popupLinkifier=new Components.Linkifier.Linkifier,this.calculatorsMap=new Map,this.calculatorsMap.set(_calculatorTypes.Time,e),this.calculatorsMap.set(_calculatorTypes.Duration,i),this.lastWheelTime=0,this.setupDataGrid(),this.setupWaterfall()}static convertToDataGridDescriptor(t){const e=t.title instanceof Function?t.title():t.title;return{id:t.id,title:e,sortable:t.sortable,align:t.align,nonSelectable:t.nonSelectable,weight:t.weight,allowInSortByEvenWhenHidden:t.allowInSortByEvenWhenHidden}}wasShown(){this.updateRowsSize()}willHide(){this.popoverHelper&&this.popoverHelper.hidePopover()}reset(){this.popoverHelper&&this.popoverHelper.hidePopover(),this.eventDividers.clear()}setupDataGrid(){const t=_defaultColumns,e=_defaultColumnConfig;this.columns=[];for(const i of t){const t=Object.assign({},e,i);if(t.id=t.id,t.subtitle){const e=t.title instanceof Function?t.title():t.title,i=t.subtitle instanceof Function?t.subtitle():t.subtitle;t.titleDOMFragment=this.makeHeaderFragment(e,i)}this.columns.push(t)}this.loadCustomColumnsAndSettings(),this.popoverHelper=new UI.PopoverHelper.PopoverHelper(this.networkLogView.element,this.getPopoverRequest.bind(this)),this.popoverHelper.setHasPadding(!0),this.popoverHelper.setTimeout(300,300),this.dataGridInternal=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.networkLog),columns:this.columns.map(NetworkLogViewColumns.convertToDataGridDescriptor),editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this.dataGridInternal.element.addEventListener("mousedown",(t=>{!this.dataGridInternal.selectedNode&&t.button&&t.consume()}),!0),this.dataGridScroller=this.dataGridInternal.scrollContainer,this.updateColumns(),this.dataGridInternal.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this.sortHandler,this),this.dataGridInternal.setHeaderContextMenuCallback(this.innerHeaderContextMenu.bind(this)),this.activeWaterfallSortId=WaterfallSortIds.StartTime,this.dataGridInternal.markColumnAsSortedBy(_initialSortColumn,DataGrid.DataGrid.Order.Ascending),this.splitWidget=new UI.SplitWidget.SplitWidget(!0,!0,"networkPanelSplitViewWaterfall",200);const i=this.dataGridInternal.asWidget();i.setMinimumSize(150,0),this.splitWidget.setMainWidget(i)}setupWaterfall(){this.waterfallColumn=new NetworkWaterfallColumn(this.networkLogView.calculator()),this.waterfallColumn.element.addEventListener("contextmenu",function(t){const e=t,i=this.waterfallColumn.getNodeFromPoint(e.offsetX,e.offsetY);if(!i)return;const r=i.request();if(!r)return;const n=new UI.ContextMenu.ContextMenu(e);this.networkLogView.handleContextMenuForRequest(n,r),n.show()}.bind(this)),this.waterfallColumn.element.addEventListener("wheel",this.onMouseWheel.bind(this,!1),{passive:!0}),this.waterfallColumn.element.addEventListener("touchstart",this.onTouchStart.bind(this)),this.waterfallColumn.element.addEventListener("touchmove",this.onTouchMove.bind(this)),this.waterfallColumn.element.addEventListener("touchend",this.onTouchEnd.bind(this)),this.dataGridScroller.addEventListener("wheel",this.onMouseWheel.bind(this,!0),!0),this.dataGridScroller.addEventListener("touchstart",this.onTouchStart.bind(this)),this.dataGridScroller.addEventListener("touchmove",this.onTouchMove.bind(this)),this.dataGridScroller.addEventListener("touchend",this.onTouchEnd.bind(this)),this.waterfallScroller=this.waterfallColumn.contentElement.createChild("div","network-waterfall-v-scroll"),this.waterfallScrollerContent=this.waterfallScroller.createChild("div","network-waterfall-v-scroll-content"),this.dataGridInternal.addEventListener(DataGrid.DataGrid.Events.PaddingChanged,(()=>{this.waterfallScrollerWidthIsStale=!0,this.syncScrollers()})),this.dataGridInternal.addEventListener(DataGrid.ViewportDataGrid.Events.ViewportCalculated,this.redrawWaterfallColumn.bind(this)),this.createWaterfallHeader(),this.waterfallColumn.contentElement.classList.add("network-waterfall-view"),this.waterfallColumn.setMinimumSize(100,0),this.splitWidget.setSidebarWidget(this.waterfallColumn),this.switchViewMode(!1)}onMouseWheel(t,e){t&&e.consume(!0);const i=e,r=Date.now()-this.lastWheelTime<80;this.activeScroller.scrollBy({top:i.deltaY,behavior:r?"auto":"smooth"}),this.syncScrollers(),this.lastWheelTime=Date.now()}onTouchStart(t){const e=t;this.hasScrollerTouchStarted=!0,this.scrollerTouchStartPos=e.changedTouches[0].pageY}onTouchMove(t){if(!this.hasScrollerTouchStarted)return;const e=t.changedTouches[0].pageY,i=this.scrollerTouchStartPos-e;this.activeScroller.scrollBy({top:i,behavior:"auto"}),this.syncScrollers(),this.scrollerTouchStartPos=e}onTouchEnd(){this.hasScrollerTouchStarted=!1}syncScrollers(){this.waterfallColumn.isShowing()&&(this.waterfallScrollerContent.style.height=this.dataGridScroller.scrollHeight+"px",this.updateScrollerWidthIfNeeded(),this.dataGridScroller.scrollTop=this.waterfallScroller.scrollTop)}updateScrollerWidthIfNeeded(){this.waterfallScrollerWidthIsStale&&(this.waterfallScrollerWidthIsStale=!1,this.waterfallColumn.setRightPadding(this.waterfallScroller.offsetWidth-this.waterfallScrollerContent.offsetWidth))}redrawWaterfallColumn(){if(!this.waterfallRequestsAreStale)return this.updateScrollerWidthIfNeeded(),void this.waterfallColumn.update(this.activeScroller.scrollTop,this.eventDividersShown?this.eventDividers:void 0);this.syncScrollers();const t=this.networkLogView.flatNodesList();this.waterfallColumn.update(this.activeScroller.scrollTop,this.eventDividers,t)}createWaterfallHeader(){this.waterfallHeaderElement=this.waterfallColumn.contentElement.createChild("div","network-waterfall-header"),this.waterfallHeaderElement.addEventListener("click",function(){const t=DataGrid.DataGrid.Order,e="waterfall"===this.dataGridInternal.sortColumnId(),i=this.dataGridInternal.isSortOrderAscending(),r=e&&i?t.Descending:t.Ascending;this.dataGridInternal.markColumnAsSortedBy("waterfall",r),this.sortHandler()}.bind(this)),this.waterfallHeaderElement.addEventListener("contextmenu",(t=>this.innerHeaderContextMenu(new UI.ContextMenu.ContextMenu(t))));this.waterfallHeaderElement.createChild("div").textContent=i18nString(UIStrings.waterfall),this.waterfallColumnSortIcon=UI.Icon.Icon.create("","sort-order-icon"),this.waterfallHeaderElement.createChild("div","sort-order-icon-container").appendChild(this.waterfallColumnSortIcon)}setCalculator(t){this.waterfallColumn.setCalculator(t)}scheduleRefresh(){this.waterfallColumn.scheduleDraw()}updateRowsSize(){const t=Boolean(this.networkLogLargeRowsSetting.get());this.dataGridInternal.element.classList.toggle("small",!t),this.dataGridInternal.scheduleUpdate(),this.waterfallScrollerWidthIsStale=!0,this.waterfallColumn.setRowHeight(t?41:21),this.waterfallScroller.classList.toggle("small",!t),this.waterfallHeaderElement.classList.toggle("small",!t),window.requestAnimationFrame((()=>{this.waterfallColumn.setHeaderHeight(this.waterfallScroller.offsetTop),this.waterfallColumn.scheduleDraw()}))}show(t){this.splitWidget.show(t)}setHidden(t){UI.ARIAUtils.setHidden(this.splitWidget.element,t)}dataGrid(){return this.dataGridInternal}sortByCurrentColumn(){this.sortHandler()}sortHandler(){const t=this.dataGridInternal.sortColumnId();if(this.networkLogView.removeAllNodeHighlights(),this.waterfallRequestsAreStale=!0,"waterfall"===t){this.dataGridInternal.sortOrder()===DataGrid.DataGrid.Order.Ascending?this.waterfallColumnSortIcon.setIconType("smallicon-triangle-up"):this.waterfallColumnSortIcon.setIconType("smallicon-triangle-down");const t=NetworkRequestNode.RequestPropertyComparator.bind(null,this.activeWaterfallSortId);return this.dataGridInternal.sortNodes(t,!this.dataGridInternal.isSortOrderAscending()),void this.dataGridSortedForTest()}this.waterfallColumnSortIcon.setIconType("");const e=this.columns.find((e=>e.id===t));if(!e||!e.sortingFunction)return;const i=e.sortingFunction;i&&(this.dataGridInternal.sortNodes(i,!this.dataGridInternal.isSortOrderAscending()),this.dataGridSortedForTest())}dataGridSortedForTest(){}updateColumns(){if(!this.dataGridInternal)return;const t=new Set;if(this.gridMode)for(const e of this.columns)e.visible&&t.add(e.id);else{const e=this.columns.find((t=>"path"===t.hideableGroup&&t.visible));e?t.add(e.id):t.add("name")}this.dataGridInternal.setColumnsVisiblity(t)}switchViewMode(t){this.gridMode!==t&&(this.gridMode=t,t?(this.splitWidget.showBoth(),this.activeScroller=this.waterfallScroller,this.waterfallScroller.scrollTop=this.dataGridScroller.scrollTop,this.dataGridInternal.setScrollContainer(this.waterfallScroller)):(this.networkLogView.removeAllNodeHighlights(),this.splitWidget.hideSidebar(),this.activeScroller=this.dataGridScroller,this.dataGridInternal.setScrollContainer(this.dataGridScroller)),this.networkLogView.element.classList.toggle("brief-mode",!t),this.updateColumns(),this.updateRowsSize())}toggleColumnVisibility(t){this.loadCustomColumnsAndSettings(),t.visible=!t.visible,this.saveColumnsSettings(),this.updateColumns()}saveColumnsSettings(){const t={};for(const e of this.columns)t[e.id]={visible:e.visible,title:e.title};this.persistantSettings.set(t)}loadCustomColumnsAndSettings(){const t=this.persistantSettings.get(),e=Object.keys(t);for(const i of e){const e=t[i];let r=this.columns.find((t=>t.id===i));r||(r=this.addCustomHeader(e.title,i)||void 0),r&&r.hideable&&"boolean"==typeof e.visible&&(r.visible=Boolean(e.visible)),r&&"string"==typeof e.title&&(r.title=e.title)}}makeHeaderFragment(t,e){const i=document.createDocumentFragment();UI.UIUtils.createTextChild(i,t);const r=i.createChild("div","network-header-subtitle");return UI.UIUtils.createTextChild(r,e),i}innerHeaderContextMenu(t){const e=this.columns.filter((t=>t.hideable)),i=e.filter((t=>!t.isResponseHeader)),r=new Map,n=[];for(const t of i)if(t.hideableGroup){const e=t.hideableGroup;let i=r.get(e);i||(i=[],r.set(e,i)),i.push(t)}else n.push(t);for(const e of r.values()){const i=e.filter((t=>t.visible));for(const r of e){const e=1===i.length&&i[0]===r,n=r.title instanceof Function?r.title():r.title;t.headerSection().appendCheckboxItem(n,this.toggleColumnVisibility.bind(this,r),r.visible,e)}t.headerSection().appendSeparator()}for(const e of n){const i=e.title instanceof Function?e.title():e.title;t.headerSection().appendCheckboxItem(i,this.toggleColumnVisibility.bind(this,e),e.visible)}const o=t.footerSection().appendSubMenuItem(i18nString(UIStrings.responseHeaders)),s=e.filter((t=>t.isResponseHeader));for(const t of s){const e=t.title instanceof Function?t.title():t.title;o.defaultSection().appendCheckboxItem(e,this.toggleColumnVisibility.bind(this,t),t.visible)}o.footerSection().appendItem(i18nString(UIStrings.manageHeaderColumns),this.manageCustomHeaderDialog.bind(this));const a=WaterfallSortIds,l=t.footerSection().appendSubMenuItem(i18nString(UIStrings.waterfall));function d(t){let e=this.calculatorsMap.get(_calculatorTypes.Time);const i=WaterfallSortIds;t!==i.Duration&&t!==i.Latency||(e=this.calculatorsMap.get(_calculatorTypes.Duration)),this.networkLogView.setCalculator(e),this.activeWaterfallSortId=t,this.dataGridInternal.markColumnAsSortedBy("waterfall",DataGrid.DataGrid.Order.Ascending),this.sortHandler()}l.defaultSection().appendCheckboxItem(i18nString(UIStrings.startTime),d.bind(this,a.StartTime),this.activeWaterfallSortId===a.StartTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.responseTime),d.bind(this,a.ResponseTime),this.activeWaterfallSortId===a.ResponseTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.endTime),d.bind(this,a.EndTime),this.activeWaterfallSortId===a.EndTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.totalDuration),d.bind(this,a.Duration),this.activeWaterfallSortId===a.Duration),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.latency),d.bind(this,a.Latency),this.activeWaterfallSortId===a.Latency)}manageCustomHeaderDialog(){const t=[];for(const e of this.columns){const i=e.title instanceof Function?e.title():e.title;e.isResponseHeader&&t.push({title:i,editable:e.isCustomHeader})}const e=new NetworkManageCustomHeadersView(t,(t=>Boolean(this.addCustomHeader(t))),this.changeCustomHeader.bind(this),this.removeCustomHeader.bind(this)),i=new UI.Dialog.Dialog;e.show(i.contentElement),i.setSizeBehavior("MeasureContent"),i.show(this.networkLogView.element)}removeCustomHeader(t){t=t.toLowerCase();const e=this.columns.findIndex((e=>e.id===t));return-1!==e&&(this.columns.splice(e,1),this.dataGridInternal.removeColumn(t),this.saveColumnsSettings(),this.updateColumns(),!0)}addCustomHeader(t,e,i){e||(e=t.toLowerCase()),void 0===i&&(i=this.columns.length-1);const r=this.columns.find((t=>t.id===e));if(r)return null;const n=Object.assign({},_defaultColumnConfig,{id:e,title:t,isResponseHeader:!0,isCustomHeader:!0,visible:!0,sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,e)});return this.columns.splice(i,0,n),this.dataGridInternal&&this.dataGridInternal.addColumn(NetworkLogViewColumns.convertToDataGridDescriptor(n),i),this.saveColumnsSettings(),this.updateColumns(),n}changeCustomHeader(t,e,i){i||(i=e.toLowerCase()),t=t.toLowerCase();const r=this.columns.findIndex((e=>e.id===t)),n=this.columns[r],o=this.columns.find((t=>t.id===i));return!(!n||o&&t!==i)&&(this.removeCustomHeader(t),this.addCustomHeader(e,i,r),!0)}getPopoverRequest(t){if(!this.gridMode)return null;const e=this.networkLogView.hoveredNode();if(!e||!t.target)return null;const i=t.target.enclosingNodeOrSelfWithClass("network-script-initiated");if(!i)return null;const r=e.request();return r?{box:i.boxInWindow(),show:async t=>{this.popupLinkifier.setLiveLocationUpdateCallback((()=>{t.setSizeBehavior("MeasureContent")}));const e=RequestInitiatorView.createStackTracePreview(r,this.popupLinkifier,!1);return!!e&&(t.contentElement.appendChild(e.element),!0)},hide:this.popupLinkifier.reset.bind(this.popupLinkifier)}:null}addEventDividers(t,e){let i="transparent";switch(e){case"network-dcl-divider":i="#0867CB";break;case"network-load-divider":i="#B31412";break;default:return}const r=this.eventDividers.get(i)||[];this.eventDividers.set(i,r.concat(t)),this.networkLogView.scheduleRefresh()}hideEventDividers(){this.eventDividersShown=!0,this.redrawWaterfallColumn()}showEventDividers(){this.eventDividersShown=!1,this.redrawWaterfallColumn()}selectFilmStripFrame(t){this.eventDividers.set(_filmStripDividerColor,[t]),this.redrawWaterfallColumn()}clearFilmStripFrame(){this.eventDividers.delete(_filmStripDividerColor),this.redrawWaterfallColumn()}}export const _initialSortColumn="waterfall";export var _calculatorTypes;!function(t){t.Duration="Duration",t.Time="Time"}(_calculatorTypes||(_calculatorTypes={}));export const _defaultColumnConfig={subtitle:null,visible:!1,weight:6,sortable:!0,hideable:!0,hideableGroup:null,nonSelectable:!1,isResponseHeader:!1,isCustomHeader:!1,allowInSortByEvenWhenHidden:!1};const _temporaryDefaultColumns=[{id:"name",title:i18nLazyString(UIStrings.name),subtitle:i18nLazyString(UIStrings.path),visible:!0,weight:20,hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.NameComparator},{id:"path",title:i18nLazyString(UIStrings.path),hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"pathname")},{id:"url",title:i18nLazyString(UIStrings.url),hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.RequestURLComparator},{id:"method",title:i18nLazyString(UIStrings.method),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"requestMethod")},{id:"status",title:i18nLazyString(UIStrings.status),visible:!0,subtitle:i18nLazyString(UIStrings.text),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"statusCode")},{id:"protocol",title:i18nLazyString(UIStrings.protocol),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"protocol")},{id:"scheme",title:i18nLazyString(UIStrings.scheme),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"scheme")},{id:"domain",title:i18nLazyString(UIStrings.domain),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"domain")},{id:"remoteaddress",title:i18nLazyString(UIStrings.remoteAddress),weight:10,align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RemoteAddressComparator},{id:"remoteaddress-space",title:i18nLazyString(UIStrings.remoteAddressSpace),visible:!1,weight:10,sortingFunction:NetworkRequestNode.RemoteAddressSpaceComparator},{id:"type",title:i18nLazyString(UIStrings.type),visible:!0,sortingFunction:NetworkRequestNode.TypeComparator},{id:"initiator",title:i18nLazyString(UIStrings.initiator),visible:!0,weight:10,sortingFunction:NetworkRequestNode.InitiatorComparator},{id:"initiator-address-space",title:i18nLazyString(UIStrings.initiatorAddressSpace),visible:!1,weight:10,sortingFunction:NetworkRequestNode.InitiatorAddressSpaceComparator},{id:"cookies",title:i18nLazyString(UIStrings.cookies),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RequestCookiesCountComparator},{id:"setcookies",title:i18nLazyString(UIStrings.setCookies),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.ResponseCookiesCountComparator},{id:"size",title:i18nLazyString(UIStrings.size),visible:!0,subtitle:i18nLazyString(UIStrings.content),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.SizeComparator},{id:"time",title:i18nLazyString(UIStrings.time),visible:!0,subtitle:i18nLazyString(UIStrings.latency),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"duration")},{id:"priority",title:i18nLazyString(UIStrings.priority),sortingFunction:NetworkRequestNode.PriorityComparator},{id:"connectionid",title:i18nLazyString(UIStrings.connectionId),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"connectionId")},{id:"cache-control",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Cache-Control"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"cache-control")},{id:"connection",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Connection"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"connection")},{id:"content-encoding",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Content-Encoding"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"content-encoding")},{id:"content-length",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Content-Length"),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.ResponseHeaderNumberComparator.bind(null,"content-length")},{id:"etag",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("ETag"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"etag")},{id:"keep-alive",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Keep-Alive"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"keep-alive")},{id:"last-modified",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Last-Modified"),sortingFunction:NetworkRequestNode.ResponseHeaderDateComparator.bind(null,"last-modified")},{id:"server",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Server"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"server")},{id:"vary",isResponseHeader:!0,title:i18n.i18n.lockedLazyString("Vary"),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"vary")},{id:"waterfall",title:i18nLazyString(UIStrings.waterfall),visible:!1,hideable:!1,allowInSortByEvenWhenHidden:!0}],_defaultColumns=_temporaryDefaultColumns;export const _filmStripDividerColor="#fccc49";export var WaterfallSortIds;!function(t){t.StartTime="startTime",t.ResponseTime="responseReceivedTime",t.EndTime="endTime",t.Duration="duration",t.Latency="latency"}(WaterfallSortIds||(WaterfallSortIds={}));