const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (C) 2006, 2007, 2008 Apple Inc.  All rights reserved.\n * Copyright (C) 2009 Anthony Ricaud <rik@webkit.org>\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions\n * are met:\n *\n * 1.  Redistributions of source code must retain the above copyright\n *     notice, this list of conditions and the following disclaimer.\n * 2.  Redistributions in binary form must reproduce the above copyright\n *     notice, this list of conditions and the following disclaimer in the\n *     documentation and/or other materials provided with the distribution.\n * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of\n *     its contributors may be used to endorse or promote products derived\n *     from this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY\n * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY\n * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\n * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n:root {\n  --override-network-overview-total: #919191;\n  --override-network-overview-blocking: #858585;\n  --override-network-overview-connecting: #d68100;\n  --override-network-overview-service-worker: #d68100;\n  --override-network-overview-service-worker-respond-with: #00a3a3;\n  --override-network-overview-push: #0099e0;\n  --override-network-overview-proxy: #a1887f;\n  --override-network-overview-dns: #009688;\n  --override-network-overview-ssl: #b52dcd;\n  --override-network-overview-sending: #74979a;\n  --override-network-overview-waiting: #00a846;\n  --override-network-overview-receiving: #0299de;\n  --override-network-overview-queueing: #fff;\n  --network-grid-default-color: rgb(255 255 255 / 100%);\n  --network-grid-stripe-color: rgb(245 245 245 / 100%);\n  --network-grid-navigation-color: rgb(221 238 255 / 100%);\n  --network-grid-hovered-color: rgb(235 242 252 / 70%);\n  --network-grid-initiator-path-color: rgb(58 217 58 / 40%);\n  --network-grid-initiated-path-color: rgb(217 58 58 / 40%);\n  --network-grid-selected-color: #dadce0;\n  --network-grid-focus-selected-color: var(--legacy-selection-bg-color);\n  --network-grid-focus-selected-color-has-error: #fad2cf;\n  --network-grid-from-frame-color: rgb(224 247 250 / 40%);\n  --network-grid-is-product-color: rgb(255 252 225 / 60%);\n  --network-frame-divider-color: #fccc49;\n}\n\n.-theme-with-dark-background {\n  --network-grid-default-color: rgb(36 36 36 / 100%);\n  --network-grid-stripe-color: rgb(41 41 41 / 100%);\n  --network-grid-navigation-color: rgb(221 238 255 / 100%);\n  --network-grid-hovered-color: rgb(20 37 63 / 70%);\n  --network-grid-initiator-path-color: rgb(58 217 58 / 40%);\n  --network-grid-initiated-path-color: rgb(217 58 58 / 40%);\n  --network-grid-selected-color: #454545;\n  --network-grid-focus-selected-color: var(--legacy-selection-bg-color);\n  --network-grid-focus-selected-color-has-error: #482422;\n  --network-grid-from-frame-color: rgb(224 247 250 / 40%);\n  --network-grid-is-product-color: rgb(255 252 225 / 60%);\n}\n\n.network-details-view {\n  background: rgb(203 203 203); /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n}\n\n.network-details-view-tall-header {\n  border-top: 4px solid var(--color-background-elevation-1);\n}\n\n.network-item-view {\n  display: flex;\n  background: var(--color-background);\n}\n\n.network-item-preview-toolbar {\n  border-top: 1px solid var(--color-details-hairline);\n  background-color: var(--color-background-elevation-1);\n}\n\n.resource-timing-view {\n  display: block;\n  margin: 6px;\n  color: var(--color-text-primary);\n  overflow: auto;\n  background-color: var(--color-background);\n}\n\n.resource-timing-table {\n  width: 100% !important; /* stylelint-disable-line declaration-no-important */\n}\n\n#network-overview-panel {\n  flex: none;\n  position: relative;\n}\n\n#network-overview-container {\n  overflow: hidden;\n  flex: auto;\n  display: flex;\n  flex-direction: column;\n  position: relative;\n  border-bottom: 1px solid var(--color-details-hairline);\n}\n\n#network-overview-container canvas {\n  width: 100%;\n  height: 100%;\n}\n\n.resources-dividers-label-bar {\n  background-color: var(--color-background);\n}\n\n#network-overview-grid .resources-dividers-label-bar {\n  pointer-events: auto;\n}\n\n.network .network-overview {\n  flex: 0 0 60px;\n}\n\n.network-overview .resources-dividers-label-bar .resources-divider {\n  background-color: transparent;\n}\n\n.network-overview .resources-dividers {\n  z-index: 250;\n}\n\n.request-view.html iframe {\n  width: 100%;\n  height: 100%;\n  position: absolute;\n}\n\n.network-film-strip {\n  border-bottom: solid 1px var(--color-details-hairline);\n  flex: none !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.network-film-strip-placeholder {\n  flex-shrink: 0;\n}\n\n.network-tabbed-pane {\n  background-color: var(--color-background-elevation-1);\n}\n\n.network-settings-pane {\n  flex: none;\n  background-color: var(--color-background-elevation-1);\n}\n\n.network-settings-pane .toolbar {\n  flex: 1 1;\n}\n\n.network-toolbar-container {\n  display: flex;\n  flex: none;\n}\n\n.network-toolbar-container > :first-child {\n  flex: 1 1 auto;\n}\n\n.panel.network .toolbar {\n  background-color: var(--color-background-elevation-1);\n  border-bottom: var(--legacy-divider-border);\n}\n\n@media (forced-colors: active) {\n  .panel.network .toolbar {\n    background-color: canvas;\n  }\n}\n\n/*# sourceURL=networkPanel.css */\n');export default styles;