import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as UI from"../../ui/legacy/legacy.js";import*as ThemeSupport from"../../ui/legacy/theme_support/theme_support.js";import performanceMonitorStyles from"./performanceMonitor.css.js";const UIStrings={graphsDisplayingARealtimeViewOf:"Graphs displaying a real-time view of performance metrics",paused:"Paused",cpuUsage:"CPU usage",jsHeapSize:"JS heap size",domNodes:"DOM Nodes",jsEventListeners:"JS event listeners",documents:"Documents",documentFrames:"Document Frames",layoutsSec:"Layouts / sec",styleRecalcsSec:"Style recalcs / sec"},str_=i18n.i18n.registerUIStrings("panels/performance_monitor/PerformanceMonitor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let performanceMonitorImplInstance,numberFormatter,percentFormatter;export class PerformanceMonitorImpl extends UI.Widget.HBox{metricsBuffer;pixelsPerMs;pollIntervalMs;scaleHeight;graphHeight;gridColor;controlPane;canvas;animationId;width;height;model;startTimestamp;pollTimer;constructor(){super(!0),this.contentElement.classList.add("perfmon-pane"),this.metricsBuffer=[],this.pixelsPerMs=.01,this.pollIntervalMs=500,this.scaleHeight=16,this.graphHeight=90,this.gridColor=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.08)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),this.controlPane=new ControlPane(this.contentElement);const e=this.contentElement.createChild("div","perfmon-chart-container");this.canvas=e.createChild("canvas"),this.canvas.tabIndex=-1,UI.ARIAUtils.setAccessibleName(this.canvas,i18nString(UIStrings.graphsDisplayingARealtimeViewOf)),this.contentElement.createChild("div","perfmon-chart-suspend-overlay fill").createChild("div").textContent=i18nString(UIStrings.paused),this.controlPane.addEventListener("MetricChanged",this.recalcChartHeight,this),SDK.TargetManager.TargetManager.instance().observeModels(SDK.PerformanceMetricsModel.PerformanceMetricsModel,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return performanceMonitorImplInstance&&!t||(performanceMonitorImplInstance=new PerformanceMonitorImpl),performanceMonitorImplInstance}wasShown(){this.model&&(this.registerCSSFiles([performanceMonitorStyles]),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.SuspendStateChanged,this.suspendStateChanged,this),this.model.enable(),this.suspendStateChanged())}willHide(){this.model&&(SDK.TargetManager.TargetManager.instance().removeEventListener(SDK.TargetManager.Events.SuspendStateChanged,this.suspendStateChanged,this),this.stopPolling(),this.model.disable())}modelAdded(e){this.model||(this.model=e,this.isShowing()&&this.wasShown())}modelRemoved(e){this.model===e&&(this.isShowing()&&this.willHide(),this.model=null)}suspendStateChanged(){const e=SDK.TargetManager.TargetManager.instance().allTargetsSuspended();e?this.stopPolling():this.startPolling(),this.contentElement.classList.toggle("suspended",e)}startPolling(){this.startTimestamp=0,this.pollTimer=window.setInterval((()=>this.poll()),this.pollIntervalMs),this.onResize();const e=()=>{this.draw(),this.animationId=this.contentElement.window().requestAnimationFrame((()=>{e()}))};e()}stopPolling(){window.clearInterval(this.pollTimer),this.contentElement.window().cancelAnimationFrame(this.animationId),this.metricsBuffer=[]}async poll(){if(!this.model)return;const e=await this.model.requestMetrics(),t=e.timestamp,i=e.metrics;this.metricsBuffer.push({timestamp:t,metrics:i});const r=this.width/this.pixelsPerMs,o=Math.ceil(r/this.pollIntervalMs*2);this.metricsBuffer.length>2*o&&this.metricsBuffer.splice(0,this.metricsBuffer.length-o),this.controlPane.updateMetrics(i)}draw(){const e=this.canvas.getContext("2d");e.save(),e.scale(window.devicePixelRatio,window.devicePixelRatio),e.clearRect(0,0,this.width,this.height),e.save(),e.translate(0,this.scaleHeight);for(const t of this.controlPane.charts())this.controlPane.isActive(t.metrics[0].name)&&(this.drawChart(e,t,this.graphHeight),e.translate(0,this.graphHeight));e.restore(),this.drawHorizontalGrid(e),e.restore()}drawHorizontalGrid(e){const t=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.02)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);e.font="10px "+Host.Platform.fontFamily(),e.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);const i=Date.now()/1e3;for(let r=Math.ceil(i);;--r){const o=this.width-(1e3*(i-r)-this.pollIntervalMs)*this.pixelsPerMs;if(o<-50)break;e.beginPath(),e.moveTo(o,0),e.lineTo(o,this.height),r>=0&&r%10==0&&e.fillText(new Date(1e3*r).toLocaleTimeString(),o+4,12),e.strokeStyle=r%10?t:this.gridColor,e.stroke()}}drawChart(e,t,i){e.save(),e.rect(0,0,this.width,i),e.clip();const r=1.05*this.calcMax(t),o=t.stacked?new Map:null,s=[];for(let e=t.metrics.length-1;e>=0;--e){const n=t.metrics[e];s.push({path:this.buildMetricPath(t,n,i-8,r,e?o:null),color:n.color})}const n=Common.Color.Color.parse(UI.Utils.getThemeColorValue("--color-background"));if(n)for(const t of s.reverse()){const i=t.color;e.save();const r=Common.Color.Color.parse(i);r&&(e.fillStyle=n.blendWith(r.setAlpha(.2)).asString(null)||"",e.fill(t.path),e.strokeStyle=i,e.lineWidth=.5,e.stroke(t.path),e.restore())}e.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),e.font=`10px  ${Host.Platform.fontFamily()}`,e.fillText(t.title,8,10),this.drawVerticalGrid(e,i-8,r,t),e.restore()}calcMax(e){if(e.max)return e.max;const t=this.width,i=performance.now()-this.pollIntervalMs-t/this.pixelsPerMs;let r=-1/0;for(const t of e.metrics)for(let e=this.metricsBuffer.length-1;e>=0;--e){const o=this.metricsBuffer[e],s=o.metrics.get(t.name);if(void 0!==s&&(r=Math.max(r,s)),o.timestamp<i)break}if(!this.metricsBuffer.length)return 10;const o=Math.pow(10,Math.floor(Math.log10(r)));r=Math.ceil(r/o/2)*o*2;return e.currentMax=.2*r+.8*(e.currentMax||r),e.currentMax}drawVerticalGrid(e,t,i,r){let o=Math.pow(10,Math.floor(Math.log10(i)));const s=Math.floor(i/o);1!==s&&s%2==1&&(o*=2);let n=Math.floor(i/o)*o;const a=i,l=t-18;e.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),e.strokeStyle=this.gridColor,e.beginPath();for(let t=0;t<2;++t){const t=c(n),i=MetricIndicator.formatNumber(n,r);e.moveTo(0,t),e.lineTo(4,t),e.moveTo(e.measureText(i).width+12,t),e.lineTo(this.width,t),e.fillText(i,8,c(n)+3),n/=2}function c(e){return Math.round(t-l*e/a)+.5}e.stroke(),e.beginPath(),e.moveTo(0,t+.5),e.lineTo(this.width,t+.5),e.strokeStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.2)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),e.stroke()}buildMetricPath(e,t,i,r,o){const s=new Path2D,n=i-18;if(n<1)return s;const a=r,l=t.name,c=this.pixelsPerMs,h=performance.now()-this.pollIntervalMs-this.width/c,m=e.smooth;let p=0,d=0,g=0;this.metricsBuffer.length&&(p=(this.metricsBuffer[0].timestamp-h)*c,s.moveTo(p,u(0)),s.lineTo(this.width+5,u(0)),d=u(this.metricsBuffer[this.metricsBuffer.length-1].metrics.get(l)||0),g=this.width+5,s.lineTo(g,d));for(let e=this.metricsBuffer.length-1;e>=0;--e){const t=this.metricsBuffer[e],i=t.timestamp;let r=t.metrics.get(l)||0;o&&(r+=o.get(i)||0,r=Platform.NumberUtilities.clamp(r,0,1),o.set(i,r));const n=u(r);if(p=(i-h)*c,m){const e=(g+p)/2;s.bezierCurveTo(e,d,e,n,p,n)}else s.lineTo(p,d),s.lineTo(p,n);if(g=p,d=n,i<h)break}return s;function u(e){return Math.round(i-n*e/a)+.5}}onResize(){super.onResize(),this.width=this.canvas.offsetWidth,this.canvas.width=Math.round(this.width*window.devicePixelRatio),this.recalcChartHeight()}recalcChartHeight(){let e=this.scaleHeight;for(const t of this.controlPane.charts())this.controlPane.isActive(t.metrics[0].name)&&(e+=this.graphHeight);this.height=Math.ceil(e*window.devicePixelRatio),this.canvas.height=this.height,this.canvas.style.height=this.height/window.devicePixelRatio+"px"}}export class ControlPane extends Common.ObjectWrapper.ObjectWrapper{element;enabledChartsSetting;enabledCharts;chartsInfo;indicators;constructor(e){super(),this.element=e.createChild("div","perfmon-control-pane"),this.enabledChartsSetting=Common.Settings.Settings.instance().createSetting("perfmonActiveIndicators2",["TaskDuration","JSHeapTotalSize","Nodes"]),this.enabledCharts=new Set(this.enabledChartsSetting.get());const t={color:void 0,format:void 0,currentMax:void 0,max:void 0,smooth:void 0,stacked:void 0};this.chartsInfo=[{...t,title:i18nString(UIStrings.cpuUsage),metrics:[{name:"TaskDuration",color:"#999"},{name:"ScriptDuration",color:"orange"},{name:"LayoutDuration",color:"blueviolet"},{name:"RecalcStyleDuration",color:"violet"}],format:"Percent",smooth:!0,stacked:!0,color:"red",max:1,currentMax:void 0},{...t,title:i18nString(UIStrings.jsHeapSize),metrics:[{name:"JSHeapTotalSize",color:"#99f"},{name:"JSHeapUsedSize",color:"blue"}],format:"Bytes",color:"blue"},{...t,title:i18nString(UIStrings.domNodes),metrics:[{name:"Nodes",color:"green"}]},{...t,title:i18nString(UIStrings.jsEventListeners),metrics:[{name:"JSEventListeners",color:"yellowgreen"}]},{...t,title:i18nString(UIStrings.documents),metrics:[{name:"Documents",color:"darkblue"}]},{...t,title:i18nString(UIStrings.documentFrames),metrics:[{name:"Frames",color:"darkcyan"}]},{...t,title:i18nString(UIStrings.layoutsSec),metrics:[{name:"LayoutCount",color:"hotpink"}]},{...t,title:i18nString(UIStrings.styleRecalcsSec),metrics:[{name:"RecalcStyleCount",color:"deeppink"}]}];for(const e of this.chartsInfo){e.color&&(e.color=ThemeSupport.ThemeSupport.instance().patchColorText(e.color,ThemeSupport.ThemeSupport.ColorUsage.Foreground));for(const t of e.metrics)t.color=ThemeSupport.ThemeSupport.instance().patchColorText(t.color,ThemeSupport.ThemeSupport.ColorUsage.Foreground)}this.indicators=new Map;for(const e of this.chartsInfo){const t=e.metrics[0].name,i=this.enabledCharts.has(t),r=new MetricIndicator(this.element,e,i,this.onToggle.bind(this,t));this.indicators.set(t,r)}}onToggle(e,t){t?this.enabledCharts.add(e):this.enabledCharts.delete(e),this.enabledChartsSetting.set(Array.from(this.enabledCharts)),this.dispatchEventToListeners("MetricChanged")}charts(){return this.chartsInfo}isActive(e){return this.enabledCharts.has(e)}updateMetrics(e){for(const t of this.indicators.keys()){const i=e.get(t);if(void 0!==i){const e=this.indicators.get(t);e&&e.setValue(i)}}}}export class MetricIndicator{info;active;onToggle;element;swatchElement;valueElement;constructor(e,t,i,r){const o=t.color||t.metrics[0].color;this.info=t,this.active=i,this.onToggle=r,this.element=e.createChild("div","perfmon-indicator"),this.swatchElement=UI.Icon.Icon.create("smallicon-checkmark-square","perfmon-indicator-swatch"),this.swatchElement.style.backgroundColor=o,this.element.appendChild(this.swatchElement),this.element.createChild("div","perfmon-indicator-title").textContent=t.title,this.valueElement=this.element.createChild("div","perfmon-indicator-value"),this.valueElement.style.color=o,this.element.addEventListener("click",(()=>this.toggleIndicator())),this.element.addEventListener("keypress",(e=>this.handleKeypress(e))),this.element.classList.toggle("active",i),UI.ARIAUtils.markAsCheckbox(this.element),UI.ARIAUtils.setChecked(this.element,this.active),this.element.tabIndex=0}static formatNumber(e,t){switch(numberFormatter||(numberFormatter=new Intl.NumberFormat("en-US",{maximumFractionDigits:1}),percentFormatter=new Intl.NumberFormat("en-US",{maximumFractionDigits:1,style:"percent"})),t.format){case"Percent":return percentFormatter.format(e);case"Bytes":return Platform.NumberUtilities.bytesToString(e);default:return numberFormatter.format(e)}}setValue(e){this.valueElement.textContent=MetricIndicator.formatNumber(e,this.info)}toggleIndicator(){this.active=!this.active,this.element.classList.toggle("active",this.active),UI.ARIAUtils.setChecked(this.element,this.active),this.onToggle(this.active)}handleKeypress(e){const t=e;" "!==t.key&&"Enter"!==t.key||this.toggleIndicator()}}export const format=new Intl.NumberFormat("en-US",{maximumFractionDigits:1});