const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (C) 2006, 2007, 2008 Apple Inc.  All rights reserved.\n * Copyright (C) 2009 Anthony Ricaud <rik@webkit.org>\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions\n * are met:\n *\n * 1.  Redistributions of source code must retain the above copyright\n *     notice, this list of conditions and the following disclaimer.\n * 2.  Redistributions in binary form must reproduce the above copyright\n *     notice, this list of conditions and the following disclaimer in the\n *     documentation and/or other materials provided with the distribution.\n * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of\n *     its contributors may be used to endorse or promote products derived\n *     from this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY\n * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY\n * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\n * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n/* Profiler Style */\n\n#profile-views {\n  flex: auto;\n  position: relative;\n}\n\n.profile-view .data-grid table.data {\n  background: var(--color-background);\n}\n\n.profile-view .data-grid tr:not(.selected) .highlight {\n  background-color: var(--color-selection-highlight);\n}\n\n.profile-view .data-grid tr:hover td:not(.bottom-filler-td) {\n  background-color: var(--color-background-hover-overlay);\n}\n\n.profile-view .data-grid td.numeric-column {\n  text-align: right;\n}\n\n.profile-view .data-grid div.profile-multiple-values {\n  float: right;\n}\n\n.profile-view .data-grid span.percent-column {\n  color: var(--color-text-secondary);\n  width: 9ex;\n  display: inline-block;\n}\n\n.profile-view .data-grid tr.selected span {\n  color: inherit;\n}\n\n.profiles-toolbar {\n  background-color: var(--color-background-elevation-1);\n  border-bottom: 1px solid var(--color-details-hairline);\n  flex-shrink: 0;\n}\n\n.profiles-tree-sidebar {\n  flex: auto;\n  overflow: hidden;\n}\n\n.profiles-sidebar-tree-box {\n  overflow-y: auto;\n}\n\n.profile-view {\n  display: flex;\n  overflow: hidden;\n}\n\n.profile-view .data-grid {\n  border: none;\n  flex: auto;\n}\n\n.profile-view .data-grid th.self-column,\n.profile-view .data-grid th.total-column {\n  text-align: center;\n}\n\n.profile-node-file {\n  float: right;\n  color: var(--color-text-secondary);\n}\n\n.profile-warn-marker {\n  vertical-align: -1px;\n  margin-right: 2px;\n}\n\n.cpu-profile-flame-chart-overview-container {\n  overflow: hidden;\n  position: absolute;\n  top: 0;\n  width: 100%;\n  height: 80px;\n}\n\n#cpu-profile-flame-chart-overview-container {\n  border-bottom: 1px solid var(--color-details-hairline);\n  overflow: hidden;\n}\n\n.cpu-profile-flame-chart-overview-canvas {\n  position: absolute;\n  top: 20px;\n  left: 0;\n  right: 0;\n  bottom: 0;\n}\n\n#cpu-profile-flame-chart-overview-grid .resources-dividers-label-bar {\n  pointer-events: auto;\n}\n\n.cpu-profile-flame-chart-overview-pane {\n  flex: 0 0 80px !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.profile-text-view {\n  padding: 10px;\n  overflow: auto;\n  margin: 0;\n  user-select: text;\n  cursor: text;\n}\n\n@media (forced-colors: active) {\n  .profile-view .data-grid tr:hover td:not(.bottom-filler-td) {\n    background: Highlight;\n  }\n\n  .profile-view .data-grid table.data {\n    background: transparent;\n  }\n}\n\n/*# sourceURL=profilesPanel.css */\n');export default styles;