import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as ProtocolClient from"../../core/protocol_client/protocol_client.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as DataGrid from"../../ui/components/data_grid/data_grid.js";import*as IconButton from"../../ui/components/icon_button/icon_button.js";import*as SourceFrame from"../../ui/legacy/components/source_frame/source_frame.js";import*as UI from"../../ui/legacy/legacy.js";import*as LitHtml from"../../ui/lit-html/lit-html.js";import protocolMonitorStyles from"./protocolMonitor.css.js";const UIStrings={method:"Method",type:"Type",request:"Request",response:"Response",timestamp:"Timestamp",target:"Target",record:"Record",clearAll:"Clear all",filter:"Filter",documentation:"Documentation",sMs:"{PH1} ms",noMessageSelected:"No message selected",save:"Save",session:"Session",sendRawCDPCommand:"Send a raw `CDP` command"},str_=i18n.i18n.registerUIStrings("panels/protocol_monitor/ProtocolMonitor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),timestampRenderer=t=>LitHtml.html`${i18nString(UIStrings.sMs,{PH1:String(t)})}`;let protocolMonitorImplInstance;export class ProtocolMonitorImpl extends UI.Widget.VBox{started;startTime;dataGridRowForId;infoWidget;dataGridIntegrator;filterParser;suggestionBuilder;textFilterUI;messages=[];isRecording=!1;constructor(){super(!0),this.started=!1,this.startTime=0,this.dataGridRowForId=new Map;const t=new UI.Toolbar.Toolbar("protocol-monitor-toolbar",this.contentElement);this.contentElement.classList.add("protocol-monitor");const e=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.record),"largeicon-start-recording","largeicon-stop-recording");e.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{e.setToggled(!e.toggled()),this.setRecording(e.toggled())})),e.setToggleWithRedColor(!0),t.appendToolbarItem(e),e.setToggled(!0);const r=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearAll),"largeicon-clear");r.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this.messages=[],this.dataGridIntegrator.update({...this.dataGridIntegrator.data(),rows:[]}),this.infoWidget.render(null)})),t.appendToolbarItem(r);const o=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.save),"largeicon-download");o.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this.saveAsFile()})),t.appendToolbarItem(o);const i=new UI.SplitWidget.SplitWidget(!0,!0,"protocol-monitor-panel-split",250);i.show(this.contentElement),this.infoWidget=new InfoWidget;const n={columns:[{id:"type",title:i18nString(UIStrings.type),sortable:!0,widthWeighting:1,visible:!0,hideable:!0,styles:{"text-align":"center"}},{id:"method",title:i18nString(UIStrings.method),sortable:!1,widthWeighting:5,visible:!0,hideable:!1},{id:"request",title:i18nString(UIStrings.request),sortable:!1,widthWeighting:5,visible:!0,hideable:!0},{id:"response",title:i18nString(UIStrings.response),sortable:!1,widthWeighting:5,visible:!0,hideable:!0},{id:"timestamp",title:i18nString(UIStrings.timestamp),sortable:!0,widthWeighting:5,visible:!1,hideable:!0},{id:"target",title:i18nString(UIStrings.target),sortable:!0,widthWeighting:5,visible:!1,hideable:!0},{id:"session",title:i18nString(UIStrings.session),sortable:!0,widthWeighting:5,visible:!1,hideable:!0}],rows:[],contextMenus:{bodyRow:(t,e,r)=>{const o=DataGrid.DataGridUtils.getRowEntryForColumnId(r,"method"),i=DataGrid.DataGridUtils.getRowEntryForColumnId(r,"type");t.defaultSection().appendItem(i18nString(UIStrings.filter),(()=>{const t=DataGrid.DataGridUtils.getRowEntryForColumnId(r,"method");this.textFilterUI.setValue(`method:${t.value}`,!0)})),t.defaultSection().appendItem(i18nString(UIStrings.documentation),(()=>{if(!o.value)return;const[t,e]=String(o.value).split("."),r="sent"===i.value?"method":"event";Host.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab(`https://chromedevtools.github.io/devtools-protocol/tot/${t}#${r}-${e}`)}))}}};this.dataGridIntegrator=new DataGrid.DataGridControllerIntegrator.DataGridControllerIntegrator(n),this.dataGridIntegrator.dataGrid.addEventListener("cellfocused",(t=>{const e=t.data.row,r={request:DataGrid.DataGridUtils.getRowEntryForColumnId(e,"request"),response:DataGrid.DataGridUtils.getRowEntryForColumnId(e,"response"),type:DataGrid.DataGridUtils.getRowEntryForColumnId(e,"type").title};this.infoWidget.render(r)})),this.dataGridIntegrator.dataGrid.addEventListener("newuserfiltertext",(t=>{this.textFilterUI.setValue(t.data.filterText,!0)})),i.setMainWidget(this.dataGridIntegrator),i.setSidebarWidget(this.infoWidget);const s=["method","request","response","type","target","session"];this.filterParser=new TextUtils.TextUtils.FilterParser(s),this.suggestionBuilder=new UI.FilterSuggestionBuilder.FilterSuggestionBuilder(s),this.textFilterUI=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.filter),"",1,.2,"",this.suggestionBuilder.completions.bind(this.suggestionBuilder),!0),this.textFilterUI.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,(t=>{const e=t.data,r=this.filterParser.parse(e);this.dataGridIntegrator.update({...this.dataGridIntegrator.data(),filters:r})})),t.appendToolbarItem(this.textFilterUI);const a=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.sendRawCDPCommand),"",1,.2,"",void 0,!1);a.addEventListener(UI.Toolbar.ToolbarInput.Event.EnterPressed,(()=>{const t=a.value();let e=null;try{e=JSON.parse(t)}catch(t){}const r=e?e.command:t,o=e?e.parameters:null;ProtocolClient.InspectorBackend.test.sendRawMessage(r,o,(()=>{}))}));new UI.Toolbar.Toolbar("protocol-monitor-bottom-toolbar",this.contentElement).appendToolbarItem(a)}static instance(t={forceNew:null}){const{forceNew:e}=t;return protocolMonitorImplInstance&&!e||(protocolMonitorImplInstance=new ProtocolMonitorImpl),protocolMonitorImplInstance}wasShown(){this.started||(this.registerCSSFiles([protocolMonitorStyles]),this.started=!0,this.startTime=Date.now(),this.setRecording(!0))}setRecording(t){this.isRecording=t;const e=ProtocolClient.InspectorBackend.test;t?(e.onMessageSent=this.messageSent.bind(this),e.onMessageReceived=this.messageReceived.bind(this)):(e.onMessageSent=null,e.onMessageReceived=null)}targetToString(t){return t?t.decorateLabel(`${t.name()} ${t===SDK.TargetManager.TargetManager.instance().mainTarget()?"":t.id()}`):""}messageReceived(t,e){if(this.isRecording&&this.messages.push({...t,type:"recv",domain:"-"}),"id"in t&&t.id){const e=this.dataGridRowForId.get(t.id);if(!e)return;const r=this.dataGridIntegrator.data().rows.findIndex((t=>e===t)),o={...e,cells:e.cells.map((e=>"response"===e.columnId?{...e,value:JSON.stringify(t.result||t.error)}:e))},i=[...this.dataGridIntegrator.data().rows];return i[r]=o,this.dataGridRowForId.delete(t.id),void this.dataGridIntegrator.update({...this.dataGridIntegrator.data(),rows:i})}const r=e,o=new IconButton.Icon.Icon;o.data={iconName:"ic_response",color:"var(--color-text-disabled)",width:"16px",height:"16px"};const i={cells:[{columnId:"method",value:t.method},{columnId:"request",value:"",renderer:DataGrid.DataGridRenderers.codeBlockRenderer},{columnId:"response",value:JSON.stringify(t.params),renderer:DataGrid.DataGridRenderers.codeBlockRenderer},{columnId:"timestamp",value:Date.now()-this.startTime,renderer:timestampRenderer},{columnId:"type",value:o,title:"received"},{columnId:"target",value:this.targetToString(r)},{columnId:"session",value:t.sessionId||""}],hidden:!1};this.dataGridIntegrator.update({...this.dataGridIntegrator.data(),rows:this.dataGridIntegrator.data().rows.concat([i])})}messageSent(t,e){this.isRecording&&this.messages.push({...t,type:"send"});const r=e,o=new IconButton.Icon.Icon;o.data={iconName:"ic_request_response",color:"var(--color-primary)",width:"16px",height:"16px"};const i={styles:{"--override-data-grid-row-background-color":"var(--override-data-grid-sent-message-row-background-color)"},cells:[{columnId:"method",value:t.method},{columnId:"request",value:JSON.stringify(t.params),renderer:DataGrid.DataGridRenderers.codeBlockRenderer},{columnId:"response",value:"(pending)",renderer:DataGrid.DataGridRenderers.codeBlockRenderer},{columnId:"timestamp",value:Date.now()-this.startTime,renderer:timestampRenderer},{columnId:"type",value:o,title:"sent"},{columnId:"target",value:this.targetToString(r)},{columnId:"session",value:t.sessionId||""}],hidden:!1};this.dataGridRowForId.set(t.id,i),this.dataGridIntegrator.update({...this.dataGridIntegrator.data(),rows:this.dataGridIntegrator.data().rows.concat([i])})}async saveAsFile(){const t=new Date,e="ProtocolMonitor-"+Platform.DateUtilities.toISO8601Compact(t)+".json",r=new Bindings.FileUtils.FileOutputStream;await r.open(e)&&(r.write(JSON.stringify(this.messages,null,"  ")),r.close())}}export class InfoWidget extends UI.Widget.VBox{tabbedPane;constructor(){super(),this.tabbedPane=new UI.TabbedPane.TabbedPane,this.tabbedPane.appendTab("request",i18nString(UIStrings.request),new UI.Widget.Widget),this.tabbedPane.appendTab("response",i18nString(UIStrings.response),new UI.Widget.Widget),this.tabbedPane.show(this.contentElement),this.tabbedPane.selectTab("response"),this.render(null)}render(t){if(!t||!t.request||!t.response)return this.tabbedPane.changeTabView("request",new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noMessageSelected))),void this.tabbedPane.changeTabView("response",new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noMessageSelected)));const e=t&&t.type&&"sent"===t.type;this.tabbedPane.setTabEnabled("request",Boolean(e)),e||this.tabbedPane.selectTab("response");const r=JSON.parse(String(t.request.value)||"null");this.tabbedPane.changeTabView("request",SourceFrame.JSONView.JSONView.createViewSync(r));const o="(pending)"===t.response.value?null:JSON.parse(String(t.response.value)||"null");this.tabbedPane.changeTabView("response",SourceFrame.JSONView.JSONView.createViewSync(o))}}