import*as i18n from"../../core/i18n/i18n.js";import*as CodeMirror from"../../third_party/codemirror.next/codemirror.next.js";import*as TextEditor from"../../ui/components/text_editor/text_editor.js";import*as UI from"../../ui/legacy/legacy.js";import breakpointEditDialogStyles from"./breakpointEditDialog.css.js";const UIStrings={breakpointType:"Breakpoint type",breakpoint:"Breakpoint",conditionalBreakpoint:"Conditional breakpoint",logpoint:"Logpoint",expressionToCheckBeforePausingEg:"Expression to check before pausing, e.g. x > 5",pauseOnlyWhenTheConditionIsTrue:"Pause only when the condition is true",logMessageEgXIsX:"Log message, e.g. `'x is', x`",logAMessageToConsoleDoNotBreak:"Log a message to Console, do not break"},str_=i18n.i18n.registerUIStrings("panels/sources/BreakpointEditDialog.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class BreakpointEditDialog extends UI.Widget.Widget{onFinish;finished;editor;isLogpoint;typeSelector;placeholderCompartment;constructor(t,e,i,o){super(!0);const n=[CodeMirror.javascript.javascriptLanguage,TextEditor.Config.baseConfiguration(e||""),TextEditor.Config.closeBrackets,TextEditor.Config.autocompletion,CodeMirror.EditorView.lineWrapping,TextEditor.Config.showCompletionHint,TextEditor.JavaScript.completion(),TextEditor.JavaScript.argumentHints()];this.onFinish=o,this.finished=!1,this.element.tabIndex=-1;const r=LogpointPrefix,s=LogpointSuffix;this.isLogpoint=e.startsWith(r)&&e.endsWith(s),this.isLogpoint&&(e=e.substring(r.length,e.length-s.length)),this.isLogpoint=this.isLogpoint||i,this.element.classList.add("sources-edit-breakpoint-dialog");const a=new UI.Toolbar.Toolbar("source-frame-breakpoint-toolbar",this.contentElement);a.appendText(`Line ${t+1}:`),this.typeSelector=new UI.Toolbar.ToolbarComboBox(this.onTypeChanged.bind(this),i18nString(UIStrings.breakpointType)),this.typeSelector.createOption(i18nString(UIStrings.breakpoint),BreakpointType.Breakpoint);const p=this.typeSelector.createOption(i18nString(UIStrings.conditionalBreakpoint),BreakpointType.Conditional),d=this.typeSelector.createOption(i18nString(UIStrings.logpoint),BreakpointType.Logpoint);this.typeSelector.select(this.isLogpoint?d:p),a.appendToolbarItem(this.typeSelector);const l=e||"",g=t=>!!TextEditor.JavaScript.isExpressionComplete(t.state)&&(this.finishEditing(!0,this.editor.state.doc.toString()),!0),h=[{key:"Mod-Enter",run:g},{key:"Enter",run:g},{key:"Shift-Enter",run:CodeMirror.insertNewlineAndIndent},{key:"Escape",run:()=>(this.finishEditing(!1,""),!0)}];this.placeholderCompartment=new CodeMirror.Compartment;const c=this.contentElement.appendChild(document.createElement("div"));c.classList.add("condition-editor"),this.editor=new TextEditor.TextEditor.TextEditor(CodeMirror.EditorState.create({doc:l,selection:{anchor:0,head:l.length},extensions:[this.placeholderCompartment.of(this.getPlaceholder()),CodeMirror.keymap.of(h),n]})),c.appendChild(this.editor),this.updateTooltip(),this.element.addEventListener("blur",(t=>{(!t.relatedTarget||t.relatedTarget&&!t.relatedTarget.isSelfOrDescendant(this.element))&&this.finishEditing(!0,this.editor.state.doc.toString())}),!0)}focusEditor(){this.editor.editor.focus()}static conditionForLogpoint(t){return`${LogpointPrefix}${t}${LogpointSuffix}`}onTypeChanged(){this.breakpointType===BreakpointType.Breakpoint?this.finishEditing(!0,""):(this.editor.dispatch({effects:this.placeholderCompartment.reconfigure(this.getPlaceholder())}),this.updateTooltip())}get breakpointType(){const t=this.typeSelector.selectedOption();return t?t.value:null}getPlaceholder(){const t=this.breakpointType;return t===BreakpointType.Conditional?CodeMirror.placeholder(i18nString(UIStrings.expressionToCheckBeforePausingEg)):t===BreakpointType.Logpoint?CodeMirror.placeholder(i18nString(UIStrings.logMessageEgXIsX)):[]}updateTooltip(){const t=this.breakpointType;t===BreakpointType.Conditional?UI.Tooltip.Tooltip.install(this.typeSelector.element,i18nString(UIStrings.pauseOnlyWhenTheConditionIsTrue)):t===BreakpointType.Logpoint&&UI.Tooltip.Tooltip.install(this.typeSelector.element,i18nString(UIStrings.logAMessageToConsoleDoNotBreak))}finishEditing(t,e){this.finished||(this.finished=!0,this.editor.remove(),this.isLogpoint&&(e=BreakpointEditDialog.conditionForLogpoint(e)),this.onFinish({committed:t,condition:e}))}wasShown(){super.wasShown(),this.registerCSSFiles([breakpointEditDialogStyles])}}export const LogpointPrefix="/** DEVTOOLS_LOGPOINT */ console.log(";export const LogpointSuffix=")";export const BreakpointType={Breakpoint:"Breakpoint",Conditional:"Conditional",Logpoint:"Logpoint"};