import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Workspace from"../../models/workspace/workspace.js";import*as CodeMirror from"../../third_party/codemirror.next/codemirror.next.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import*as SourceFrame from"../../ui/legacy/components/source_frame/source_frame.js";import*as UI from"../../ui/legacy/legacy.js";import{AddSourceMapURLDialog}from"./AddSourceMapURLDialog.js";import{BreakpointEditDialog,LogpointPrefix}from"./BreakpointEditDialog.js";import{Plugin}from"./Plugin.js";import{ScriptFormatterEditorAction}from"./ScriptFormatterEditorAction.js";import{resolveExpression,resolveScopeInObject}from"./SourceMapNamesResolver.js";import{SourcesPanel}from"./SourcesPanel.js";import{getRegisteredEditorActions}from"./SourcesView.js";const UIStrings={thisScriptIsOnTheDebuggersIgnore:"This script is on the debugger's ignore list",removeFromIgnoreList:"Remove from ignore list",configure:"Configure",sourceMapFoundButIgnoredForFile:"Source map found, but ignored for file on ignore list.",addBreakpoint:"Add breakpoint",addConditionalBreakpoint:"Add conditional breakpoint…",addLogpoint:"Add logpoint…",neverPauseHere:"Never pause here",removeBreakpoint:"{n, plural, =1 {Remove breakpoint} other {Remove all breakpoints in line}}",editBreakpoint:"Edit breakpoint…",disableBreakpoint:"{n, plural, =1 {Disable breakpoint} other {Disable all breakpoints in line}}",enableBreakpoint:"{n, plural, =1 {Enable breakpoint} other {Enable all breakpoints in line}}",addSourceMap:"Add source map…",sourceMapDetected:"Source map detected.",prettyprintThisMinifiedFile:"Pretty-print this minified file?",prettyprint:"Pretty-print",prettyprintingWillFormatThisFile:"Pretty-printing will format this file in a new tab where you can continue debugging. You can also pretty-print this file by clicking the {PH1} button on the bottom status bar.",associatedFilesAreAvailable:"Associated files are available via file tree or {PH1}.",associatedFilesShouldBeAdded:"Associated files should be added to the file tree. You can debug these resolved source files as regular JavaScript files.",theDebuggerWillSkipStepping:"The debugger will skip stepping through this script, and will not stop on exceptions."},str_=i18n.i18n.registerUIStrings("panels/sources/DebuggerPlugin.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),MAX_POSSIBLE_BREAKPOINT_LINE=2500;export class DebuggerPlugin extends Plugin{transformer;editor=void 0;executionLocation=null;controlDown=!1;sourceMapInfobar=null;controlTimeout=void 0;scriptsPanel;breakpointManager;popoverHelper;scriptFileForDebuggerModel;breakpoints=[];continueToLocations=null;liveLocationPool;muted;initializedMuted;ignoreListInfobar;prettyPrintInfobar;scheduledBreakpointDecorationUpdates;refreshBreakpointsTimeout=void 0;constructor(e,t){super(e),this.transformer=t,this.scriptsPanel=SourcesPanel.instance(),this.breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance(),this.popoverHelper=new UI.PopoverHelper.PopoverHelper(this.scriptsPanel.element,this.getPopoverRequest.bind(this)),this.popoverHelper.setDisableOnClick(!0),this.popoverHelper.setTimeout(250,250),this.popoverHelper.setHasPadding(!0),this.breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this.breakpointChange,this),this.breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this.breakpointChange,this),this.uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.workingCopyChanged,this),this.uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.workingCopyCommitted,this),this.scriptFileForDebuggerModel=new Map,Common.Settings.Settings.instance().moduleSetting("skipStackFramesPattern").addChangeListener(this.showIgnoreListInfobarIfNeeded,this),Common.Settings.Settings.instance().moduleSetting("skipContentScripts").addChangeListener(this.showIgnoreListInfobarIfNeeded,this),UI.Context.Context.instance().addFlavorChangeListener(SDK.DebuggerModel.CallFrame,this.callFrameChanged,this),this.liveLocationPool=new Bindings.LiveLocation.LiveLocationPool,this.updateScriptFiles(),this.muted=this.uiSourceCode.isDirty(),this.initializedMuted=this.muted,this.ignoreListInfobar=null,this.showIgnoreListInfobarIfNeeded();for(const e of this.scriptFileForDebuggerModel.values())e.checkMapping();Root.Runtime.experiments.isEnabled("sourcesPrettyPrint")||(this.prettyPrintInfobar=null,this.detectMinified())}editorExtension(){const e=this.shortcutHandlers();return[CodeMirror.EditorView.updateListener.of((e=>this.onEditorUpdate(e))),CodeMirror.EditorView.domEventHandlers({keydown:t=>!!this.onKeyDown(t)||(e(t),t.defaultPrevented),keyup:e=>this.onKeyUp(e),mousemove:e=>this.onMouseMove(e),mousedown:e=>this.onMouseDown(e),focusout:e=>this.onBlur(e),wheel:e=>this.onWheel(e)}),CodeMirror.lineNumbers({domEventHandlers:{mousedown:(e,t,o)=>this.handleGutterClick(e.state.doc.lineAt(t.from),o)}}),infobarState,breakpointMarkers,CodeMirror.Prec.highest(executionLine.field),CodeMirror.Prec.lowest(continueToMarkers.field),markIfContinueTo,valueDecorations.field,CodeMirror.Prec.lowest(evalExpression.field),theme,this.uiSourceCode.project().type()===Workspace.Workspace.projectTypes.Debugger?CodeMirror.EditorView.editorAttributes.of({class:"source-frame-debugger-script"}):[]]}shortcutHandlers(){const e=e=>e.state.doc.lineAt(e.state.selection.main.head);return UI.ShortcutRegistry.ShortcutRegistry.instance().getShortcutListener({"debugger.toggle-breakpoint":async()=>!(this.muted||!this.editor)&&(await this.toggleBreakpoint(e(this.editor),!1),!0),"debugger.toggle-breakpoint-enabled":async()=>!(this.muted||!this.editor)&&(await this.toggleBreakpoint(e(this.editor),!0),!0),"debugger.breakpoint-input-window":async()=>{if(this.muted||!this.editor)return!1;const t=e(this.editor),o=this.breakpoints.find((e=>e.position>=t.from&&e.position<=t.to))?.breakpoint||null,i=!!o&&o.condition().includes(LogpointPrefix);return this.editBreakpointCondition(t,o,null,i),!0}})}editorInitialized(e){this.editor=e,computeNonBreakableLines(e.state,this.uiSourceCode).then((t=>{t.length&&e.dispatch({effects:SourceFrame.SourceFrame.addNonBreakableLines.of(t)})}),console.error),this.muted||this.refreshBreakpoints(),this.callFrameChanged()}static accepts(e){return e.contentType().hasScripts()}showIgnoreListInfobarIfNeeded(){const e=this.uiSourceCode;if(!e.contentType().hasScripts())return;const t=e.project().type();if(!Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedUISourceCode(e))return void this.hideIgnoreListInfobar();this.ignoreListInfobar&&this.ignoreListInfobar.dispose();const o=new UI.Infobar.Infobar(UI.Infobar.Type.Warning,i18nString(UIStrings.thisScriptIsOnTheDebuggersIgnore),[{text:i18nString(UIStrings.removeFromIgnoreList),highlight:!1,delegate:function(){Bindings.IgnoreListManager.IgnoreListManager.instance().unIgnoreListUISourceCode(e),t===Workspace.Workspace.projectTypes.ContentScripts&&Bindings.IgnoreListManager.IgnoreListManager.instance().unIgnoreListContentScripts()},dismiss:!0},{text:i18nString(UIStrings.configure),highlight:!1,delegate:UI.ViewManager.ViewManager.instance().showView.bind(UI.ViewManager.ViewManager.instance(),"blackbox"),dismiss:!1}]);this.ignoreListInfobar=o,o.setCloseCallback((()=>this.removeInfobar(this.ignoreListInfobar))),o.createDetailsRowMessage(i18nString(UIStrings.theDebuggerWillSkipStepping));const i=this.scriptFileForDebuggerModel.size?this.scriptFileForDebuggerModel.values().next().value:null;i&&i.hasSourceMapURL()&&o.createDetailsRowMessage(i18nString(UIStrings.sourceMapFoundButIgnoredForFile)),this.attachInfobar(this.ignoreListInfobar)}attachInfobar(e){this.editor&&this.editor.dispatch({effects:addInfobar.of(e)})}removeInfobar(e){this.editor&&e&&this.editor.dispatch({effects:removeInfobar.of(e)})}hideIgnoreListInfobar(){this.ignoreListInfobar&&(this.ignoreListInfobar.dispose(),this.ignoreListInfobar=null)}willHide(){this.popoverHelper.hidePopover()}populateLineGutterContextMenu(e,t){const o=new Workspace.UISourceCode.UILocation(this.uiSourceCode,t,0);if(this.scriptsPanel.appendUILocationItems(e,o),this.muted||!this.editor)return;const i=this.editor.state.doc.line(t+1),n=this.lineBreakpoints(i),r=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().supportsConditionalBreakpoints(this.uiSourceCode);if(n.length){const t=i18nString(UIStrings.removeBreakpoint,{n:n.length});e.debugSection().appendItem(t,(()=>n.forEach((e=>e.remove(!1))))),1===n.length&&r&&e.debugSection().appendItem(i18nString(UIStrings.editBreakpoint),this.editBreakpointCondition.bind(this,i,n[0],null,!1));if(n.some((e=>e.enabled()))){const t=i18nString(UIStrings.disableBreakpoint,{n:n.length});e.debugSection().appendItem(t,(()=>n.forEach((e=>e.setEnabled(!1)))))}if(n.some((e=>!e.enabled()))){const t=i18nString(UIStrings.enableBreakpoint,{n:n.length});e.debugSection().appendItem(t,(()=>n.forEach((e=>e.setEnabled(!0)))))}}else this.editor&&SourceFrame.SourceFrame.isBreakableLine(this.editor.state,i)&&(e.debugSection().appendItem(i18nString(UIStrings.addBreakpoint),this.createNewBreakpoint.bind(this,i,"",!0)),r&&(e.debugSection().appendItem(i18nString(UIStrings.addConditionalBreakpoint),this.editBreakpointCondition.bind(this,i,null,null,!1)),e.debugSection().appendItem(i18nString(UIStrings.addLogpoint),this.editBreakpointCondition.bind(this,i,null,null,!0)),e.debugSection().appendItem(i18nString(UIStrings.neverPauseHere),this.createNewBreakpoint.bind(this,i,"false",!0))))}populateTextAreaContextMenu(e){function t(e,t){t&&e.addSourceMapURL(t)}if(this.uiSourceCode.project().type()===Workspace.Workspace.projectTypes.Network&&Common.Settings.Settings.instance().moduleSetting("jsSourceMapsEnabled").get()&&!Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedUISourceCode(this.uiSourceCode)&&this.scriptFileForDebuggerModel.size){const o=this.scriptFileForDebuggerModel.values().next().value,i=i18nString(UIStrings.addSourceMap);e.debugSection().appendItem(i,function(e){new AddSourceMapURLDialog(t.bind(null,e)).show()}.bind(null,o))}}workingCopyChanged(){this.scriptFileForDebuggerModel.size||this.setMuted(this.uiSourceCode.isDirty())}workingCopyCommitted(){this.scriptsPanel.updateLastModificationTime(),this.scriptFileForDebuggerModel.size||this.setMuted(!1)}didMergeToVM(){this.consistentScripts()&&this.setMuted(!1)}didDivergeFromVM(){this.setMuted(!0)}setMuted(e){this.initializedMuted||e!==this.muted&&(this.muted=e,e?this.editor&&this.editor.dispatch({effects:muteBreakpoints.of(null)}):this.restoreBreakpointsAfterEditing())}consistentScripts(){for(const e of this.scriptFileForDebuggerModel.values())if(e.hasDivergedFromVM()||e.isMergingToVM())return!1;return!0}isIdentifier(e){return"VariableName"===e||"VariableDefinition"===e||"PropertyName"===e||"PropertyDefinition"===e}getPopoverRequest(e){if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e))return null;const t=UI.Context.Context.instance().flavor(SDK.Target.Target),o=t?t.model(SDK.DebuggerModel.DebuggerModel):null,{editor:i}=this;if(!o||!o.isPaused()||!i)return null;const n=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!n)return null;let r=i.editor.posAtCoords(e);if(!r)return null;const s=i.editor.coordsAtPos(r);if(!s||e.clientY<s.top||e.clientY>s.bottom||e.clientX<s.left-30||e.clientX>s.right+30)return null;e.clientX<s.left&&r>i.state.doc.lineAt(r).from&&(r-=1);const a=i.state.selection.main;let c;if(a.empty)if("application/wasm"===this.uiSourceCode.mimeType()){const e=CodeMirror.syntaxTree(i.state).resolveInner(r,1);if("Identifier"!==e.name)return null;const t=["block","loop","if","else","end","br","br_if","br_table"];for(let o=e.parent;o;o=o.parent)if("App"===o.name){const e=o.firstChild,n="Keyword"===e?.name&&i.state.sliceDoc(e.from,e.to);if(n&&t.includes(n))return null}c=e}else if(/^text\/(javascript|typescript|jsx)/.test(this.uiSourceCode.mimeType())){let e=CodeMirror.syntaxTree(i.state).resolveInner(r,1);if(e.firstChild)return null;for(;e&&"VariableDefinition"!==e.name&&"VariableName"!==e.name&&"MemberExpression"!==e.name&&("PropertyName"!==e.name||"PatternProperty"!==e.parent?.name||":"===e.nextSibling?.name)&&("PropertyDefinition"!==e.name||"Property"!==e.parent?.name||":"===e.nextSibling?.name);)e=e.parent;if(!e)return null;c=e}else{const e=CodeMirror.syntaxTree(i.state).resolveInner(r,1);if(e.to-e.from>50||/[^\w_\-$]/.test(i.state.sliceDoc(e.from,e.to)))return null;c=e}else{if(r<a.from||r>a.to)return null;c=a}const l=i.state.doc.lineAt(c.from);if(c.to>l.to)return null;const d=i.editor.coordsAtPos(c.from),u=i.editor.coordsAtPos(c.to);if(!d||!u)return null;const p=new AnchorBox(d.left,d.top-2,u.right-d.left,u.bottom-d.top),m=i.state.sliceDoc(c.from,c.to);let g=null;return{box:p,show:async e=>{const t=await async function(e,t){const o=await resolveExpression(n,t,e,l.number-1,c.from-l.from,c.to-l.from);return await n.evaluate({expression:o||t,objectGroup:"popover",includeCommandLineAPI:!1,silent:!0,returnByValue:!1,generatePreview:!1,throwOnSideEffect:void 0,timeout:void 0,disableBreaks:void 0,replMode:void 0,allowUnsafeEvalBlockedByCSP:void 0})}(this.uiSourceCode,m);if(!t||"error"in t||!t.object||"object"===t.object.type&&"error"===t.object.subtype)return!1;g=await ObjectUI.ObjectPopoverHelper.ObjectPopoverHelper.buildObjectPopover(t.object,e);const r=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!g||n!==r)return o.runtimeModel().releaseObjectGroup("popover"),g&&g.dispose(),!1;const s=CodeMirror.Decoration.set(evalExpressionMark.range(c.from,c.to));return i.dispatch({effects:evalExpression.update.of(s)}),!0},hide:()=>{g&&g.dispose(),o.runtimeModel().releaseObjectGroup("popover"),i.dispatch({effects:evalExpression.update.of(CodeMirror.Decoration.none)})}}}onEditorUpdate(e){if(!e.changes.empty)for(const t of this.breakpoints)t.position=e.changes.mapPos(t.position)}onWheel(e){this.executionLocation&&UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e)&&e.preventDefault()}onKeyDown(e){const t=UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e);return t||this.setControlDown(!1),e.key===Platform.KeyboardUtilities.ESCAPE_KEY&&this.popoverHelper.isPopoverVisible()?(this.popoverHelper.hidePopover(),e.consume(),!0):(t&&this.executionLocation&&this.setControlDown(!0),!1)}onMouseMove(e){this.executionLocation&&this.controlDown&&UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e)&&(this.continueToLocations||this.showContinueToLocations())}onMouseDown(e){if(!this.executionLocation||!UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlEquivalentKey(e))return;if(!this.continueToLocations||!this.editor)return;e.consume();const t=this.editor.editor.posAtCoords(e);if(null!==t)for(const{from:e,to:o,click:i}of this.continueToLocations)if(e<=t&&o>=t){i();break}}onBlur(e){this.setControlDown(!1)}onKeyUp(e){this.setControlDown(!1)}setControlDown(e){e!==this.controlDown&&(this.controlDown=e,clearTimeout(this.controlTimeout),this.controlTimeout=void 0,e&&this.executionLocation?this.controlTimeout=window.setTimeout((()=>{this.executionLocation&&this.controlDown&&this.showContinueToLocations()}),150):this.clearContinueToLocations())}editBreakpointCondition(e,t,o,i){const n=this.editor,r=t?t.condition():"",s=document.createElement("div"),a=new CodeMirror.Compartment,c=new BreakpointEditDialog(e.number-1,r,Boolean(i),(async i=>{c.detach(),n.dispatch({effects:a.reconfigure([])}),i.committed&&(t?t.setCondition(i.condition):o?await this.setBreakpoint(o.lineNumber,o.columnNumber,i.condition,!0):await this.createNewBreakpoint(e,i.condition,!0))}));n.dispatch({effects:CodeMirror.StateEffect.appendConfig.of(a.of(CodeMirror.EditorView.decorations.of(CodeMirror.Decoration.set([CodeMirror.Decoration.widget({block:!0,widget:new class extends CodeMirror.WidgetType{toDOM(){return s}},side:1}).range(e.from)]))))}),c.markAsExternallyManaged(),c.show(s),c.focusEditor()}computeExecutionDecorations(e,t,o){const{doc:i}=e;if(t>=i.lines)return CodeMirror.Decoration.none;const n=i.line(t+1),r=[executionLineDeco.range(n.from)],s=Math.min(n.to,n.from+o);let a=CodeMirror.syntaxTree(e).resolveInner(s,1);a.to===a.from-1&&/[(.]/.test(i.sliceString(a.from,a.to))&&(a=a.resolve(a.to,1));const c=Math.min(n.to,a.to);return c>s&&r.push(executionTokenDeco.range(s,c)),CodeMirror.Decoration.set(r)}async updateValueDecorations(){if(!this.editor)return;const e=this.executionLocation?await this.computeValueDecorations():null;(e||this.editor.state.field(valueDecorations.field).size)&&this.editor.dispatch({effects:valueDecorations.update.of(e||CodeMirror.Decoration.none)})}async computeValueDecorations(){if(!this.editor)return null;if(!Common.Settings.Settings.instance().moduleSetting("inlineVariableValues").get())return null;if(!UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext))return null;const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!e)return null;const t=e.localScope();if(!t||!e.functionLocation())return null;const{properties:o}=await resolveScopeInObject(t).getAllProperties(!1,!1);if(!o||!o.length||o.length>500)return null;const i=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.functionLocation()),n=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.location()),[r,s]=await Promise.all([i,n]);if(!r||!s||r.uiSourceCode.url()!==this.uiSourceCode.url()||s.uiSourceCode.url()!==this.uiSourceCode.url())return null;const a=this.transformer.uiLocationToEditorLocation(r.lineNumber,r.columnNumber),c=this.transformer.uiLocationToEditorLocation(s.lineNumber,s.columnNumber);if(a.lineNumber>=c.lineNumber||c.lineNumber-a.lineNumber>500||a.lineNumber<0||c.lineNumber>=this.editor.state.doc.lines)return null;const l=new Map(o.map((e=>[e.name,e.value]))),d=this.getVariablesByLine(this.editor.state,l,a,c);if(!d)return null;const u=[];for(const[e,t]of d){const o=d.get(e-1);let i=o?Array.from(t).filter((e=>!o.has(e))):Array.from(t);if(!i.length)continue;i.length>10&&(i=i.slice(0,10));const n=i.map((e=>[e,l.get(e)]));u.push(CodeMirror.Decoration.widget({widget:new ValueDecoration(n),side:1}).range(this.editor.state.doc.line(e+1).to))}return CodeMirror.Decoration.set(u,!0)}getVariablesByLine(e,t,o,i){const n=e.doc.line(o.lineNumber+1),r=Math.min(n.to,n.from+o.columnNumber),s=e.doc.line(i.lineNumber+1).from,a=CodeMirror.ensureSyntaxTree(e,s,100);if(!a)return null;const c=new Map;let l=n;return a.iterate({from:r,to:s,enter(o,i,n){const r="VariableName"===o.name&&e.sliceDoc(i,n);if(r&&t.has(r)){i>l.to&&(l=e.doc.lineAt(i));let t=c.get(l.number-1);t||(t=new Set,c.set(l.number-1,t)),t.add(r)}}}),c}async showContinueToLocations(){this.popoverHelper.hidePopover();if(!UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext)||!this.editor)return;const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!e)return;const t=e.functionLocation()||e.location(),o=e.debuggerModel,{state:i}=this.editor,n=await o.getPossibleBreakpoints(t,null,!0);this.continueToLocations=[];let r=-1;for(const e of n.reverse()){const t=this.transformer.uiLocationToEditorLocation(e.lineNumber,e.columnNumber);if(r===t.lineNumber&&"call"!==e.type||t.lineNumber>=i.doc.lines)continue;const o=i.doc.line(t.lineNumber+1),n=Math.min(o.to,o.from+t.columnNumber);let s=CodeMirror.syntaxTree(i).resolveInner(n,1);if(s.firstChild||s.from<o.from||s.to>o.to)continue;if("."===s.name){const e=s.resolve(s.to,1);if(e.firstChild||e.from<o.from||e.to>o.to)continue;s=e}const a=s.name,c="this"===a||"return"===a||"new"===a||"break"===a||"continue"===a;if(!c&&!this.isIdentifier(a))continue;this.continueToLocations.push({from:s.from,to:s.to,async:!1,click:()=>e.continueToLocation()}),"call"===e.type&&(r=t.lineNumber);const l=c?"":o.text.slice(s.from-o.from,s.to-o.from);let d=null;if("then"===l&&"MemberExpression"===s.parent?.name?d=s.parent.parent:"setTimeout"!==l&&"setInterval"!==l&&"postMessage"!==l||(d=s.parent),"new"===a){const e=s.parent?.getChild("Expression");e&&"VariableName"===e.name&&"Worker"===i.sliceDoc(e.from,e.to)&&(d=s.parent)}if(d&&("CallExpression"===d.name||"NewExpression"===d.name)&&"call"===e.type){const t=d.getChild("ArgList")?.firstChild?.nextSibling;let o;if("VariableName"===t?.name?o=t:"ArrowFunction"!==t?.name&&"FunctionExpression"!==t?.name||(o=t.firstChild,"async"===o?.name&&(o=o.nextSibling)),o){const t=this.executionLocation&&e.lineNumber===this.executionLocation.lineNumber&&e.columnNumber===this.executionLocation.columnNumber;this.continueToLocations.push({from:o.from,to:o.to,async:!0,click:()=>this.asyncStepIn(e,Boolean(t))})}}}const s=CodeMirror.Decoration.set(this.continueToLocations.map((e=>(e.async?asyncContinueToMark:continueToMark).range(e.from,e.to))),!0);this.editor.dispatch({effects:continueToMarkers.update.of(s)})}clearContinueToLocations(){this.editor&&this.editor.state.field(continueToMarkers.field).size&&this.editor.dispatch({effects:continueToMarkers.update.of(CodeMirror.Decoration.none)})}asyncStepIn(e,t){function o(){e.debuggerModel.scheduleStepIntoAsync()}t?o():e.continueToLocation(o)}fetchBreakpoints(){if(!this.editor)return[];const{editor:e}=this;return this.breakpointManager.breakpointLocationsForUISourceCode(this.uiSourceCode).map((({uiLocation:t,breakpoint:o})=>{const i=this.transformer.uiLocationToEditorLocation(t.lineNumber,t.columnNumber);return{position:e.toOffset(i),breakpoint:o}}))}lineBreakpoints(e){return this.breakpoints.filter((t=>t.position>=e.from&&t.position<=e.to)).map((e=>e.breakpoint))}async computeBreakpointDecoration(e,t){const o=[],i=[],n=new Map,r=new Map,s=[],a=new Set,c=(e,t,o)=>{let i=r.get(e);i||(i=[],r.set(e,i)),i.push({breakpoint:o,column:t})};for(const{position:o,breakpoint:i}of t){const t=e.doc.lineAt(o);let r=n.get(t.from);if(r||(r=[],n.set(t.from,r)),i.enabled()&&r.every((e=>!e.enabled()))){const e=this.transformer.editorLocationToUILocation(t.number-1,0),o=this.transformer.editorLocationToUILocation(t.number-1,Math.min(t.length,2500)),i=new TextUtils.TextRange.TextRange(e.lineNumber,e.columnNumber||0,o.lineNumber,o.columnNumber||0);s.push(this.breakpointManager.possibleBreakpoints(this.uiSourceCode,i).then((e=>l(t,e))))}r.push(i),i.enabled()&&(a.add(o),c(t.from,o-t.from,i))}for(const[e,t]of n){const o=t.sort(mostSpecificBreakpoint)[0];let n="cm-breakpoint";o.enabled()||(n+=" cm-breakpoint-disabled"),o.bound()||(n+=" cm-breakpoint-unbound"),o.condition().includes(LogpointPrefix)?n+=" cm-breakpoint-logpoint":o.condition()&&(n+=" cm-breakpoint-conditional"),i.push(new BreakpointGutterMarker(n).range(e))}const l=(e,t)=>{for(const o of t){const t=this.transformer.uiLocationToEditorLocation(o.lineNumber,o.columnNumber);if(t.lineNumber!==e.number-1)continue;const i=Math.min(e.to,e.from+t.columnNumber);a.has(i)||c(e.from,t.columnNumber,null)}};await Promise.all(s);for(const[e,t]of r)if(t.length>1)for(const{column:i,breakpoint:n}of t){const t=new BreakpointInlineMarker(n,this);o.push(CodeMirror.Decoration.widget({widget:t,side:-1}).range(e+i))}return{content:CodeMirror.Decoration.set(o,!0),gutter:CodeMirror.RangeSet.of(i,!0)}}restoreBreakpointsAfterEditing(){const{breakpoints:e}=this,t=this.editor;this.breakpoints=[];for(const{breakpoint:o,position:i}of e){const e=o.condition(),n=o.enabled();o.remove(!1);const r=t.toLineColumn(i),s=this.transformer.editorLocationToUILocation(r.lineNumber,r.columnNumber);this.setBreakpoint(s.lineNumber,s.columnNumber,e,n)}}async refreshBreakpoints(){if(this.editor){this.breakpoints=this.fetchBreakpoints();const e=this.breakpoints,t=await this.computeBreakpointDecoration(this.editor.state,e);this.breakpoints===e&&(t.gutter.size||this.editor.state.field(breakpointMarkers).gutter.size)&&this.editor.dispatch({effects:setBreakpointDeco.of(t)})}}breakpointChange(e){const{uiLocation:t}=e.data;if(t.uiSourceCode===this.uiSourceCode&&!this.muted){for(const e of this.scriptFileForDebuggerModel.values())if(e.isDivergingFromVM()||e.isMergingToVM())return;window.clearTimeout(this.refreshBreakpointsTimeout),this.refreshBreakpointsTimeout=window.setTimeout((()=>this.refreshBreakpoints()),50)}}onInlineBreakpointMarkerClick(e,t){if(e.consume(!0),t)e.shiftKey?t.setEnabled(!t.enabled()):t.remove(!1);else if(this.editor){const t=this.editor.editor.posAtDOM(e.target),o=this.editor.state.doc.lineAt(t),i=this.transformer.editorLocationToUILocation(o.number-1,t-o.from);this.setBreakpoint(i.lineNumber,i.columnNumber,"",!0)}}onInlineBreakpointMarkerContextMenu(e,t){e.consume(!0);const o=this.editor,i=o.editor.posAtDOM(e.target),n=o.state.doc.lineAt(i);if(!SourceFrame.SourceFrame.isBreakableLine(o.state,n)||!Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().supportsConditionalBreakpoints(this.uiSourceCode))return;const r=new UI.ContextMenu.ContextMenu(e);if(t)r.debugSection().appendItem(i18nString(UIStrings.editBreakpoint),this.editBreakpointCondition.bind(this,n,t,null,!1));else{const e=this.transformer.editorLocationToUILocation(n.number-1,i-n.from);r.debugSection().appendItem(i18nString(UIStrings.addConditionalBreakpoint),this.editBreakpointCondition.bind(this,n,null,e,!1)),r.debugSection().appendItem(i18nString(UIStrings.addLogpoint),this.editBreakpointCondition.bind(this,n,null,e,!0)),r.debugSection().appendItem(i18nString(UIStrings.neverPauseHere),this.setBreakpoint.bind(this,e.lineNumber,e.columnNumber,"false",!0))}r.show()}updateScriptFiles(){for(const e of SDK.TargetManager.TargetManager.instance().models(SDK.DebuggerModel.DebuggerModel)){Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().scriptFile(this.uiSourceCode,e)&&this.updateScriptFile(e)}}updateScriptFile(e){const t=this.scriptFileForDebuggerModel.get(e),o=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().scriptFile(this.uiSourceCode,e);this.scriptFileForDebuggerModel.delete(e),t&&(t.removeEventListener("DidMergeToVM",this.didMergeToVM,this),t.removeEventListener("DidDivergeFromVM",this.didDivergeFromVM,this),this.muted&&!this.uiSourceCode.isDirty()&&this.consistentScripts()&&this.setMuted(!1)),o&&(this.scriptFileForDebuggerModel.set(e,o),o.addEventListener("DidMergeToVM",this.didMergeToVM,this),o.addEventListener("DidDivergeFromVM",this.didDivergeFromVM,this),o.checkMapping(),o.hasSourceMapURL()&&this.showSourceMapInfobar())}showSourceMapInfobar(){this.sourceMapInfobar||(this.sourceMapInfobar=UI.Infobar.Infobar.create(UI.Infobar.Type.Info,i18nString(UIStrings.sourceMapDetected),[],Common.Settings.Settings.instance().createSetting("sourceMapInfobarDisabled",!1)),this.sourceMapInfobar&&(this.sourceMapInfobar.createDetailsRowMessage(i18nString(UIStrings.associatedFilesShouldBeAdded)),this.sourceMapInfobar.createDetailsRowMessage(i18nString(UIStrings.associatedFilesAreAvailable,{PH1:String(UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("quickOpen.show"))})),this.sourceMapInfobar.setCloseCallback((()=>{this.removeInfobar(this.sourceMapInfobar),this.sourceMapInfobar=null})),this.attachInfobar(this.sourceMapInfobar)))}async detectMinified(){const e=this.uiSourceCode.content();if(!e||!TextUtils.TextUtils.isMinified(e))return;const t=getRegisteredEditorActions();let o=null;for(const e of t)if(e instanceof ScriptFormatterEditorAction){if(!e.isCurrentUISourceCodeFormattable())return;o=e.toggleFormatScriptSource.bind(e);break}if(this.prettyPrintInfobar=UI.Infobar.Infobar.create(UI.Infobar.Type.Info,i18nString(UIStrings.prettyprintThisMinifiedFile),[{text:i18nString(UIStrings.prettyprint),delegate:o,highlight:!0,dismiss:!0}],Common.Settings.Settings.instance().createSetting("prettyPrintInfobarDisabled",!1)),!this.prettyPrintInfobar)return;this.prettyPrintInfobar.setCloseCallback((()=>{this.removeInfobar(this.prettyPrintInfobar),this.prettyPrintInfobar=null}));const i=new UI.Toolbar.Toolbar(""),n=new UI.Toolbar.ToolbarButton("","largeicon-pretty-print");i.appendToolbarItem(n),i.element.style.display="inline",i.element.style.verticalAlign="middle",i.element.style.marginBottom="3px",i.element.style.pointerEvents="none",i.element.tabIndex=-1;const r=this.prettyPrintInfobar.createDetailsRowMessage();r.appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.prettyprintingWillFormatThisFile,{PH1:i.element})),UI.ARIAUtils.markAsAlert(r),this.attachInfobar(this.prettyPrintInfobar)}handleGutterClick(e,t){return!(this.muted||0!==t.button||t.altKey||t.ctrlKey||t.metaKey)&&(this.toggleBreakpoint(e,t.shiftKey),!0)}async toggleBreakpoint(e,t){if(this.muted)return;const o=this.lineBreakpoints(e);if(!o.length)return void await this.createNewBreakpoint(e,"",!0);const i=o.some((e=>!e.enabled()));for(const e of o)t?e.setEnabled(i):e.remove(!1)}async createNewBreakpoint(e,t,o){if(!this.editor||!SourceFrame.SourceFrame.isBreakableLine(this.editor.state,e))return;Host.userMetrics.actionTaken(Host.UserMetrics.Action.ScriptsBreakpointSet);const i=this.transformer.editorLocationToUILocation(e.number-1);await this.setBreakpoint(i.lineNumber,i.columnNumber,t,o)}async setBreakpoint(e,t,o,i){Common.Settings.Settings.instance().moduleSetting("breakpointsActive").set(!0),await this.breakpointManager.setBreakpoint(this.uiSourceCode,e,t,o,i),this.breakpointWasSetForTest(e,t,o,i)}breakpointWasSetForTest(e,t,o,i){}async callFrameChanged(){this.liveLocationPool.disposeAll();const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);e?await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().createCallFrameLiveLocation(e.location(),(async e=>{const t=await e.uiLocation();t&&t.uiSourceCode.url()===this.uiSourceCode.url()?this.setExecutionLocation(t):this.setExecutionLocation(null)}),this.liveLocationPool):this.setExecutionLocation(null)}setExecutionLocation(e){if(this.executionLocation!==e&&this.editor)if(this.executionLocation=e,e){const t=this.transformer.uiLocationToEditorLocation(e.lineNumber,e.columnNumber),o=this.computeExecutionDecorations(this.editor.state,t.lineNumber,t.columnNumber);this.editor.dispatch({effects:executionLine.update.of(o)}),this.updateValueDecorations(),this.controlDown&&this.showContinueToLocations()}else this.editor.dispatch({effects:[executionLine.update.of(CodeMirror.Decoration.none),continueToMarkers.update.of(CodeMirror.Decoration.none),valueDecorations.update.of(CodeMirror.Decoration.none)]})}dispose(){this.hideIgnoreListInfobar(),this.sourceMapInfobar&&this.sourceMapInfobar.dispose(),this.prettyPrintInfobar&&this.prettyPrintInfobar.dispose();for(const e of this.scriptFileForDebuggerModel.values())e.removeEventListener("DidMergeToVM",this.didMergeToVM,this),e.removeEventListener("DidDivergeFromVM",this.didDivergeFromVM,this);this.scriptFileForDebuggerModel.clear(),this.popoverHelper.hidePopover(),this.popoverHelper.dispose(),this.breakpointManager.removeEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this.breakpointChange,this),this.breakpointManager.removeEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this.breakpointChange,this),this.uiSourceCode.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this.workingCopyChanged,this),this.uiSourceCode.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this.workingCopyCommitted,this),Common.Settings.Settings.instance().moduleSetting("skipStackFramesPattern").removeChangeListener(this.showIgnoreListInfobarIfNeeded,this),Common.Settings.Settings.instance().moduleSetting("skipContentScripts").removeChangeListener(this.showIgnoreListInfobarIfNeeded,this),super.dispose(),UI.Context.Context.instance().removeFlavorChangeListener(SDK.DebuggerModel.CallFrame,this.callFrameChanged,this),this.liveLocationPool.disposeAll()}}const addInfobar=CodeMirror.StateEffect.define(),removeInfobar=CodeMirror.StateEffect.define(),infobarState=CodeMirror.StateField.define({create:()=>[],update(e,t){for(const o of t.effects)o.is(addInfobar)?e=e.concat(o.value):o.is(removeInfobar)&&(e=e.filter((e=>e!==o.value)));return e},provide:e=>CodeMirror.showPanel.computeN([e],(t=>t.field(e).map((e=>()=>({dom:e.element})))))});async function computeNonBreakableLines(e,t){const o=[];if(Bindings.CompilerScriptMapping.CompilerScriptMapping.uiSourceCodeOrigin(t).length)for(let i=0;i<e.doc.lines;i++){Bindings.CompilerScriptMapping.CompilerScriptMapping.uiLineHasMapping(t,i)||o.push(e.doc.line(i+1).from)}else{const{pluginManager:i}=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance();if(!i)return[];const n=await i.getMappedLines(t);if(!n)return[];for(let t=0;t<e.doc.lines;t++)n.has(t)||o.push(e.doc.line(t+1).from)}return o}const setBreakpointDeco=CodeMirror.StateEffect.define(),muteBreakpoints=CodeMirror.StateEffect.define();function muteGutterMarkers(e,t){const o=[];return e.between(0,t.length,((e,t,i)=>{let n=i.elementClass;/cm-breakpoint-disabled/.test(n)||(n+=" cm-breakpoint-disabled"),o.push(new BreakpointGutterMarker(n).range(e))})),CodeMirror.RangeSet.of(o,!1)}const breakpointMarkers=CodeMirror.StateField.define({create:()=>({content:CodeMirror.RangeSet.empty,gutter:CodeMirror.RangeSet.empty}),update(e,t){t.changes.empty||(e={content:e.content.map(t.changes),gutter:e.gutter.map(t.changes)});for(const o of t.effects)o.is(setBreakpointDeco)?e=o.value:o.is(muteBreakpoints)&&(e={content:CodeMirror.RangeSet.empty,gutter:muteGutterMarkers(e.gutter,t.state.doc)});return e},provide:e=>[CodeMirror.EditorView.decorations.from(e,(e=>e.content)),CodeMirror.lineNumberMarkers.from(e,(e=>e.gutter))]});class BreakpointInlineMarker extends CodeMirror.WidgetType{breakpoint;parent;class;constructor(e,t){super(),this.breakpoint=e,this.parent=t,this.class="cm-inlineBreakpoint";const o=e?e.condition():"";o.includes(LogpointPrefix)?this.class+=" cm-inlineBreakpoint-logpoint":o&&(this.class+=" cm-inlineBreakpoint-conditional"),e?.enabled()||(this.class+=" cm-inlineBreakpoint-disabled")}eq(e){return e.class===this.class&&e.breakpoint===this.breakpoint}toDOM(){const e=document.createElement("span");return e.className=this.class,e.addEventListener("click",(e=>{this.parent.onInlineBreakpointMarkerClick(e,this.breakpoint),e.consume()})),e.addEventListener("contextmenu",(e=>{this.parent.onInlineBreakpointMarkerContextMenu(e,this.breakpoint),e.consume()})),e}ignoreEvent(){return!0}}class BreakpointGutterMarker extends CodeMirror.GutterMarker{elementClass;constructor(e){super(),this.elementClass=e}eq(e){return e.elementClass===this.elementClass}}function mostSpecificBreakpoint(e,t){return e.enabled()!==t.enabled()?e.enabled()?-1:1:e.bound()!==t.bound()?e.bound()?-1:1:Boolean(e.condition())!==Boolean(t.condition())?Boolean(e.condition())?-1:1:0}function defineStatefulDecoration(){const e=CodeMirror.StateEffect.define(),t=CodeMirror.StateField.define({create:()=>CodeMirror.Decoration.none,update:(t,o)=>o.effects.reduce(((t,o)=>o.is(e)?o.value:t),t.map(o.changes)),provide:e=>CodeMirror.EditorView.decorations.from(e)});return{update:e,field:t}}const executionLineDeco=CodeMirror.Decoration.line({attributes:{class:"cm-executionLine"}}),executionTokenDeco=CodeMirror.Decoration.mark({attributes:{class:"cm-executionToken"}}),executionLine=defineStatefulDecoration(),continueToMark=CodeMirror.Decoration.mark({class:"cm-continueToLocation"}),asyncContinueToMark=CodeMirror.Decoration.mark({class:"cm-continueToLocation cm-continueToLocation-async"}),continueToMarkers=defineStatefulDecoration(),noMarkers={},hasContinueMarkers={class:"cm-hasContinueMarkers"},markIfContinueTo=CodeMirror.EditorView.contentAttributes.compute([continueToMarkers.field],(e=>e.field(continueToMarkers.field).size?hasContinueMarkers:noMarkers));class ValueDecoration extends CodeMirror.WidgetType{pairs;constructor(e){super(),this.pairs=e}eq(e){return this.pairs.length===e.pairs.length&&this.pairs.every(((t,o)=>t[0]===e.pairs[o][0]&&t[1]===e.pairs[o][1]))}toDOM(){const e=new ObjectUI.RemoteObjectPreviewFormatter.RemoteObjectPreviewFormatter,t=document.createElement("div");t.classList.add("cm-variableValues");let o=!0;for(const[i,n]of this.pairs){o?o=!1:UI.UIUtils.createTextChild(t,", ");const r=t.createChild("span");UI.UIUtils.createTextChild(r,i+" = ");const s=n.preview?n.preview.properties.length:0,a=n.preview&&n.preview.entries?n.preview.entries.length:0;if(n.preview&&s+a<10)e.appendObjectPreview(r,n.preview,!1);else{const e=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.createPropertyValue(n,!1,!1);r.appendChild(e.element)}}return t}}const valueDecorations=defineStatefulDecoration(),evalExpressionMark=CodeMirror.Decoration.mark({class:"cm-evaluatedExpression"}),evalExpression=defineStatefulDecoration(),theme=CodeMirror.EditorView.baseTheme({".cm-lineNumbers .cm-gutterElement":{"&:hover, &.cm-breakpoint":{borderStyle:"solid",borderWidth:"1px 4px 1px 1px",marginRight:"-4px",paddingLeft:"8px",lineHeight:"calc(1.2em - 2px)",position:"relative"},"&:hover":{WebkitBorderImage:lineNumberArrow("#ebeced","#ebeced")},"&.cm-breakpoint":{color:"#fff",WebkitBorderImage:lineNumberArrow("#4285f4","#1a73e8")},"&.cm-breakpoint-conditional":{WebkitBorderImage:lineNumberArrow("#f29900","#e37400"),"&::before":{content:'"?"',position:"absolute",top:0,left:"1px"}},"&.cm-breakpoint-logpoint":{WebkitBorderImage:lineNumberArrow("#f439a0","#d01884"),"&::before":{content:'"‥"',position:"absolute",top:"-3px",left:"1px"}}},"&dark .cm-lineNumbers .cm-gutterElement":{"&:hover":{WebkitBorderImage:lineNumberArrow("#3c4043","#3c4043")},"&.cm-breakpoint":{WebkitBorderImage:lineNumberArrow("#5186EC","#1a73e8")},"&.cm-breakpoint-conditional":{WebkitBorderImage:lineNumberArrow("#e9a33a","#e37400")},"&.cm-breakpoint-logpoint":{WebkitBorderImage:lineNumberArrow("#E54D9B","#d01884")}},":host-context(.breakpoints-deactivated) & .cm-lineNumbers .cm-gutterElement.cm-breakpoint, .cm-lineNumbers .cm-gutterElement.cm-breakpoint-disabled":{color:"#1a73e8",WebkitBorderImage:lineNumberArrow("#d9e7fd","#1a73e8"),"&.cm-breakpoint-conditional":{color:"#e37400",WebkitBorderImage:lineNumberArrow("#fcebcc","#e37400")},"&.cm-breakpoint-logpoint":{color:"#d01884",WebkitBorderImage:lineNumberArrow("#fdd7ec","#f439a0")}},":host-context(.breakpoints-deactivated) &dark .cm-lineNumbers .cm-gutterElement.cm-breakpoint, &dark .cm-lineNumbers .cm-gutterElement.cm-breakpoint-disabled":{WebkitBorderImage:lineNumberArrow("#2a384e","#1a73e8"),"&.cm-breakpoint-conditional":{WebkitBorderImage:lineNumberArrow("#4d3c1d","#e37400")},"&.cm-breakpoint-logpoint":{WebkitBorderImage:lineNumberArrow("#4e283d","#f439a0")}},".cm-inlineBreakpoint":{cursor:"pointer",position:"relative",top:"1px",content:inlineBreakpointArrow("#4285F4","#1A73E8"),height:"10px","&.cm-inlineBreakpoint-conditional":{content:inlineConditionalBreakpointArrow("#F29900","#E37400")},"&.cm-inlineBreakpoint-logpoint":{content:inlineLogpointArrow("#F439A0","#D01884")}},"&dark .cm-inlineBreakpoint":{content:inlineBreakpointArrow("#5186EC","#1A73E8"),"&.cm-inlineBreakpoint-conditional":{content:inlineConditionalBreakpointArrow("#e9a33a","#E37400")},"&.cm-inlineBreakpoint-logpoint":{content:inlineLogpointArrow("#E54D9B","#D01884")}},":host-context(.breakpoints-deactivated) & .cm-inlineBreakpoint, .cm-inlineBreakpoint-disabled":{content:inlineBreakpointArrow("#4285F4","#1A73E8","0.2"),"&.cm-inlineBreakpoint-conditional":{content:inlineConditionalBreakpointArrow("#F9AB00","#E37400","0.2")},"&.cm-inlineBreakpoint-logpoint":{content:inlineLogpointArrow("#F439A0","#D01884","0.2")}},".cm-executionLine":{backgroundColor:"var(--color-execution-line-background)",outline:"1px solid var(--color-execution-line-outline)",".cm-hasContinueMarkers &":{backgroundColor:"transparent"},"&.cm-highlightedLine":{animation:"cm-fading-highlight-execution 2s 0s"}},".cm-executionToken":{backgroundColor:"var(--color-execution-token-background)"},"@keyframes cm-fading-highlight-execution":{from:{backgroundColor:"var(--color-highlighted-line)"},to:{backgroundColor:"var(--color-execution-line-background)"}},".cm-continueToLocation":{cursor:"pointer",backgroundColor:"var(--color-continue-to-location)","&:hover":{backgroundColor:"var(--color-continue-to-location-hover)",border:"1px solid var(--color-continue-to-location-hover-border)",margin:"0 -1px"},"&.cm-continueToLocation-async":{backgroundColor:"var(--color-continue-to-location-async)","&:hover":{backgroundColor:"var(--color-continue-to-location-async-hover)",border:"1px solid var(--color-continue-to-location-async-hover-border)",margin:"0 -1px"}}},".cm-evaluatedExpression":{backgroundColor:"var(--color-evaluated-expression)",border:"1px solid var(--color-evaluated-expression-border)",margin:"0 -1px"},".cm-variableValues":{display:"inline",whiteSpace:"nowrap",overflow:"hidden",textOverflow:"ellipsis",maxWidth:"1000px",opacity:"80%",backgroundColor:"var(--color-variable-values)",marginLeft:"10px",padding:"0 5px",userSelect:"text",".cm-executionLine &":{backgroundColor:"transparent",opacity:"50%"}}});function lineNumberArrow(e,t){return`url('data:image/svg+xml,<svg height="11" width="26" xmlns="http://www.w3.org/2000/svg"><path d="M22.8.5l2.7 5-2.7 5H.5V.5z" fill="${encodeURIComponent(e)}" stroke="${encodeURIComponent(t)}"/></svg>') 1 3 1 1`}function inlineBreakpointArrow(e,t,o="1"){return`url('data:image/svg+xml,<svg width="11" height="12" viewBox="0 0 11 12" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M0.5 0.5H5.80139C6.29382 0.5 6.7549 0.741701 7.03503 1.14669L10.392 6L7.03503 10.8533C6.7549 11.2583 6.29382 11.5 5.80139 11.5H0.5V0.5Z" fill="${encodeURIComponent(e)}" stroke="${encodeURIComponent(t)}" fill-opacity="${encodeURIComponent(o)}"/></svg>')`}function inlineConditionalBreakpointArrow(e,t,o="1"){return`url('data:image/svg+xml,<svg width="11" height="12" viewBox="0 0 11 12" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M0.5 0.5H5.80139C6.29382 0.5 6.75489 0.741701 7.03503 1.14669L10.392 6L7.03503 10.8533C6.75489 11.2583 6.29382 11.5 5.80138 11.5H0.5V0.5Z" fill="${encodeURIComponent(e)}" fill-opacity="${encodeURIComponent(o)}" stroke="${encodeURIComponent(t)}"/><path d="M3.51074 7.75635H4.68408V9H3.51074V7.75635ZM4.68408 7.23779H3.51074V6.56104C3.51074 6.271 3.55615 6.02344 3.64697 5.81836C3.73779 5.61328 3.90039 5.39648 4.13477 5.16797L4.53027 4.77686C4.71484 4.59814 4.83936 4.4502 4.90381 4.33301C4.97119 4.21582 5.00488 4.09424 5.00488 3.96826C5.00488 3.77197 4.9375 3.62402 4.80273 3.52441C4.66797 3.4248 4.46582 3.375 4.19629 3.375C3.9502 3.375 3.69238 3.42773 3.42285 3.5332C3.15625 3.63574 2.88232 3.78955 2.60107 3.99463V2.81689C2.88818 2.65283 3.17822 2.52979 3.47119 2.44775C3.76709 2.36279 4.06299 2.32031 4.35889 2.32031C4.95068 2.32031 5.41504 2.45801 5.75195 2.7334C6.08887 3.00879 6.25732 3.38818 6.25732 3.87158C6.25732 4.09424 6.20752 4.30225 6.10791 4.49561C6.0083 4.68604 5.8208 4.91602 5.54541 5.18555L5.15869 5.56348C4.95947 5.75684 4.83203 5.91504 4.77637 6.03809C4.7207 6.16113 4.69287 6.31201 4.69287 6.49072C4.69287 6.51709 4.69141 6.54785 4.68848 6.58301C4.68848 6.61816 4.68701 6.65625 4.68408 6.69727V7.23779Z" fill="white"/></svg>')`}function inlineLogpointArrow(e,t,o="1"){return`url('data:image/svg+xml,<svg width="11" height="12" viewBox="0 0 11 12" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M0.5 0.5H5.80139C6.29382 0.5 6.7549 0.741701 7.03503 1.14669L10.392 6L7.03503 10.8533C6.7549 11.2583 6.29382 11.5 5.80139 11.5H0.5V0.5Z" fill="${encodeURIComponent(e)}" stroke="${encodeURIComponent(t)}" fill-opacity="${encodeURIComponent(o)}"/><circle cx="3" cy="6" r="1" fill="white"/><circle cx="7" cy="6" r="1" fill="white"/></svg>')`}