import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Workspace from"../../models/workspace/workspace.js";import*as UI from"../../ui/legacy/legacy.js";import{LogpointPrefix}from"./BreakpointEditDialog.js";import javaScriptBreakpointsSidebarPaneStyles from"./javaScriptBreakpointsSidebarPane.css.js";const UIStrings={noBreakpoints:"No breakpoints",checked:"checked",unchecked:"unchecked",mixed:"mixed",sBreakpointHit:"{PH1} breakpoint hit",removeAllBreakpointsInLine:"Remove all breakpoints in line",removeBreakpoint:"Remove breakpoint",revealLocation:"Reveal location",deactivateBreakpoints:"Deactivate breakpoints",activateBreakpoints:"Activate breakpoints",enableAllBreakpoints:"Enable all breakpoints",enableBreakpointsInFile:"Enable breakpoints in file",disableAllBreakpoints:"Disable all breakpoints",disableBreakpointsInFile:"Disable breakpoints in file",removeAllBreakpoints:"Remove all breakpoints",removeOtherBreakpoints:"Remove other breakpoints"},str_=i18n.i18n.registerUIStrings("panels/sources/JavaScriptBreakpointsSidebarPane.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let javaScriptBreakpointsSidebarPaneInstance;export class JavaScriptBreakpointsSidebarPane extends UI.ThrottledWidget.ThrottledWidget{breakpointManager;breakpoints;list;emptyElement;constructor(){super(!0),this.breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance(),this.breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this.update,this),this.breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this.update,this),Common.Settings.Settings.instance().moduleSetting("breakpointsActive").addChangeListener(this.update,this),this.breakpoints=new UI.ListModel.ListModel,this.list=new UI.ListControl.ListControl(this.breakpoints,this,UI.ListControl.ListMode.NonViewport),UI.ARIAUtils.markAsList(this.list.element),this.contentElement.appendChild(this.list.element),this.emptyElement=this.contentElement.createChild("div","gray-info-message"),this.emptyElement.textContent=i18nString(UIStrings.noBreakpoints),this.emptyElement.tabIndex=-1,this.update()}static instance(){return javaScriptBreakpointsSidebarPaneInstance||(javaScriptBreakpointsSidebarPaneInstance=new JavaScriptBreakpointsSidebarPane),javaScriptBreakpointsSidebarPaneInstance}getBreakpointLocations(){const e=this.breakpointManager.allBreakpointLocations().filter((e=>e.uiLocation.uiSourceCode.project().type()!==Workspace.Workspace.projectTypes.Debugger));e.sort(((e,t)=>e.uiLocation.compareTo(t.uiLocation)));const t=[];let i=null,n=null;for(const o of e)(o.breakpoint!==i||n&&o.uiLocation.compareTo(n))&&(t.push(o),i=o.breakpoint,n=o.uiLocation);return t}hideList(){this.list.element.classList.add("hidden"),this.emptyElement.classList.remove("hidden")}ensureListShown(){this.list.element.classList.remove("hidden"),this.emptyElement.classList.add("hidden")}groupBreakpointLocationsById(e){const t=new Platform.MapUtilities.Multimap;for(const i of e){const e=i.uiLocation;t.set(e.id(),i)}const i=[];for(const e of t.keysArray()){const n=Array.from(t.get(e));n.length&&i.push(n)}return i}getLocationIdsByLineId(e){const t=new Platform.MapUtilities.Multimap;for(const i of e){const e=i.uiLocation;t.set(e.lineId(),e.id())}return t}async getSelectedUILocation(){const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.DebuggerPausedDetails);return e&&e.callFrames.length?await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.callFrames[0].location()):null}getContent(e){const t=new Map;return Promise.all(e.map((async([{uiLocation:{uiSourceCode:e}}])=>{if("application/wasm"===e.mimeType())return new TextUtils.Text.Text("");const{content:i}=await e.requestContent(),n=i||"";if(t.has(n))return t.get(n);const o=new TextUtils.Text.Text(n);return t.set(n,o),o})))}async doUpdate(){const e=this.hasFocus(),t=this.getBreakpointLocations();if(!t.length)return this.hideList(),this.setBreakpointItems([]),this.didUpdateForTest();this.ensureListShown();const i=this.groupBreakpointLocationsById(t),n=this.getLocationIdsByLineId(t),o=await this.getContent(i),s=await this.getSelectedUILocation(),a=[];for(let e=0;e<i.length;e++){const t=i[e],r=t[0].uiLocation,l=null!==s&&t.some((e=>e.uiLocation.id()===s.id())),c="application/wasm"!==r.uiSourceCode.mimeType()&&n.get(r.lineId()).size>1,p=o[e];a.push(new BreakpointItem(t,p,l,c))}return a.some((e=>e.isSelected))&&UI.ViewManager.ViewManager.instance().showView("sources.jsBreakpoints"),this.list.element.classList.toggle("breakpoints-list-deactivated",!Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get()),this.setBreakpointItems(a),e&&this.focus(),this.didUpdateForTest()}setBreakpointItems(e){if(this.breakpoints.length===e.length)for(let t=0;t<this.breakpoints.length;t++)this.breakpoints.at(t).isSimilar(e[t])||this.breakpoints.replace(t,e[t],!0);else this.breakpoints.replaceAll(e);!this.list.selectedItem()&&this.breakpoints.at(0)&&this.list.selectItem(this.breakpoints.at(0))}createElementForItem(e){const t=document.createElement("div");t.classList.add("breakpoint-entry"),UI.ARIAUtils.markAsListitem(t),t.tabIndex=this.list.selectedItem()===e?0:-1,t.addEventListener("contextmenu",this.breakpointContextMenu.bind(this),!0),t.addEventListener("click",this.revealLocation.bind(this,t),!1);const i=e.locations.some((e=>e.breakpoint.condition().includes(LogpointPrefix))),n=e.locations.some((e=>Boolean(e.breakpoint.condition()))),o=t.createChild("div","decoration-and-content");i?o.classList.add("logpoint"):n&&o.classList.add("breakpoint-conditional");const s=UI.UIUtils.CheckboxLabel.create(""),a=e.locations[0].uiLocation,r=e.locations.some((e=>e.breakpoint.enabled())),l=e.locations.some((e=>!e.breakpoint.enabled()));s.textElement.textContent=a.linkText()+(e.showColumn&&"number"==typeof a.columnNumber?":"+(a.columnNumber+1):""),s.checkboxElement.checked=r,s.checkboxElement.indeterminate=r&&l,s.checkboxElement.tabIndex=-1,s.addEventListener("click",this.breakpointCheckboxClicked.bind(this),!1),o.appendChild(s);let c=i18nString(r?UIStrings.checked:UIStrings.unchecked);r&&l&&(c=i18nString(UIStrings.mixed)),e.isSelected?(UI.ARIAUtils.setDescription(o,i18nString(UIStrings.sBreakpointHit,{PH1:c})),t.classList.add("breakpoint-hit"),this.setDefaultFocusedElement(t)):UI.ARIAUtils.setDescription(o,c),t.addEventListener("keydown",(e=>{" "===e.key&&(s.checkboxElement.click(),e.consume(!0))}));const p=o.createChild("div","source-text monospace"),d=a.lineNumber;if(e.text&&d<e.text.lineCount()){const t=e.text.lineAt(d),i=200;p.textContent=Platform.StringUtilities.trimEndWithMaxLength(t.substring(e.showColumn&&a.columnNumber||0),i)}return elementToBreakpointMap.set(t,e.locations),elementToUILocationMap.set(t,a),t}heightForItem(e){return 0}isItemSelectable(e){return!0}selectedItemChanged(e,t,i,n){i&&(i.tabIndex=-1),n&&(n.tabIndex=0,this.setDefaultFocusedElement(n),this.hasFocus()&&n.focus())}updateSelectedItemARIA(e,t){return!0}breakpointLocations(e){return e.target instanceof Element?this.breakpointLocationsForElement(e.target):[]}breakpointLocationsForElement(e){const t=e.enclosingNodeOrSelfWithClass("breakpoint-entry");return t&&elementToBreakpointMap.get(t)||[]}breakpointCheckboxClicked(e){const t=this.hasFocus(),i=this.breakpointLocations(e).map((e=>e.breakpoint)),n=e.target.checkboxElement.checked;for(const e of i){e.setEnabled(n);const t=this.breakpoints.find((t=>t.locations.some((t=>t.breakpoint===e))));t&&(this.list.selectItem(t),this.list.refreshItem(t))}t&&this.focus(),e.consume()}revealLocation(e){const t=this.breakpointLocationsForElement(e).map((e=>e.uiLocation));let i=null;for(const e of t)(!i||e.compareTo(i)<0)&&(i=e);i&&Common.Revealer.reveal(i)}breakpointContextMenu(e){const t=this.breakpointLocations(e).map((e=>e.breakpoint)),i=new UI.ContextMenu.ContextMenu(e),n=t.length>1?i18nString(UIStrings.removeAllBreakpointsInLine):i18nString(UIStrings.removeBreakpoint);i.defaultSection().appendItem(n,(()=>t.map((e=>e.remove(!1))))),e.target instanceof Element&&i.defaultSection().appendItem(i18nString(UIStrings.revealLocation),this.revealLocation.bind(this,e.target));const o=Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get(),s=i18nString(o?UIStrings.deactivateBreakpoints:UIStrings.activateBreakpoints);if(i.defaultSection().appendItem(s,(()=>Common.Settings.Settings.instance().moduleSetting("breakpointsActive").set(!o))),t.some((e=>!e.enabled()))){const t=i18nString(UIStrings.enableAllBreakpoints);if(i.defaultSection().appendItem(t,this.toggleAllBreakpoints.bind(this,!0)),e.target instanceof Element){const t=i18nString(UIStrings.enableBreakpointsInFile);i.defaultSection().appendItem(t,this.toggleAllBreakpointsInFile.bind(this,e.target,!0))}}if(t.some((e=>e.enabled()))){const t=i18nString(UIStrings.disableAllBreakpoints);if(i.defaultSection().appendItem(t,this.toggleAllBreakpoints.bind(this,!1)),e.target instanceof Element){const t=i18nString(UIStrings.disableBreakpointsInFile);i.defaultSection().appendItem(t,this.toggleAllBreakpointsInFile.bind(this,e.target,!1))}}const a=i18nString(UIStrings.removeAllBreakpoints);i.defaultSection().appendItem(a,this.removeAllBreakpoints.bind(this));const r=i18nString(UIStrings.removeOtherBreakpoints);i.defaultSection().appendItem(r,this.removeOtherBreakpoints.bind(this,new Set(t))),i.show()}toggleAllBreakpointsInFile(e,t){const i=this.getBreakpointLocations(),n=this.breakpointLocationsForElement(e);i.forEach((e=>{n.some((t=>t.breakpoint.url()===e.breakpoint.url()))&&e.breakpoint.setEnabled(t)}))}toggleAllBreakpoints(e){for(const t of this.breakpointManager.allBreakpointLocations())t.breakpoint.setEnabled(e)}removeAllBreakpoints(){for(const e of this.breakpointManager.allBreakpointLocations())e.breakpoint.remove(!1)}removeOtherBreakpoints(e){for(const t of this.breakpointManager.allBreakpointLocations())e.has(t.breakpoint)||t.breakpoint.remove(!1)}flavorChanged(e){this.update()}didUpdateForTest(){}wasShown(){super.wasShown(),this.registerCSSFiles([javaScriptBreakpointsSidebarPaneStyles])}}class BreakpointItem{locations;text;isSelected;showColumn;constructor(e,t,i,n){this.locations=e,this.text=t,this.isSelected=i,this.showColumn=n}isSimilar(e){return this.locations.length===e.locations.length&&this.locations.every(((t,i)=>t.uiLocation===e.locations[i].uiLocation))&&this.locations.every(((t,i)=>t.breakpoint===e.locations[i].breakpoint))&&(this.text===e.text||this.text&&e.text&&this.text.value()===e.text.value())&&this.isSelected===e.isSelected&&this.showColumn===e.showColumn}}const elementToUILocationMap=new WeakMap;export function retrieveLocationForElement(e){return elementToUILocationMap.get(e)}const elementToBreakpointMap=new WeakMap;