import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Persistence from"../../models/persistence/persistence.js";import*as Workspace from"../../models/workspace/workspace.js";import*as UI from"../../ui/legacy/legacy.js";import*as Snippets from"../snippets/snippets.js";import navigatorTreeStyles from"./navigatorTree.css.js";import navigatorViewStyles from"./navigatorView.css.js";import{SearchSourcesView}from"./SearchSourcesView.js";const UIStrings={searchInFolder:"Search in folder",searchInAllFiles:"Search in all files",noDomain:"(no domain)",areYouSureYouWantToExcludeThis:"Are you sure you want to exclude this folder?",areYouSureYouWantToDeleteThis:"Are you sure you want to delete this file?",rename:"Rename…",makeACopy:"Make a copy…",delete:"Delete",areYouSureYouWantToDeleteAll:"Are you sure you want to delete all overrides contained in this folder?",openFolder:"Open folder",newFile:"New file",excludeFolder:"Exclude folder",removeFolderFromWorkspace:"Remove folder from workspace",areYouSureYouWantToRemoveThis:"Are you sure you want to remove this folder?",deleteAllOverrides:"Delete all overrides",sFromSourceMap:"{PH1} (from source map)"},str_=i18n.i18n.registerUIStrings("panels/sources/NavigatorView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export const Types={Domain:"domain",File:"file",FileSystem:"fs",FileSystemFolder:"fs-folder",Frame:"frame",NetworkFolder:"nw-folder",Root:"root",SourceMapFolder:"sm-folder",Worker:"worker"};const TYPE_ORDERS=new Map([[Types.Root,1],[Types.Domain,10],[Types.FileSystemFolder,1],[Types.NetworkFolder,1],[Types.SourceMapFolder,2],[Types.File,10],[Types.Frame,70],[Types.Worker,90],[Types.FileSystem,100]]);export class NavigatorView extends UI.Widget.VBox{placeholder;scriptsTree;uiSourceCodeNodes;subfolderNodes;rootNode;frameNodes;navigatorGroupByFolderSetting;workspaceInternal;lastSelectedUISourceCode;groupByFrame;groupByDomain;groupByFolder;constructor(){super(!0),this.placeholder=null,this.scriptsTree=new UI.TreeOutline.TreeOutlineInShadow,this.scriptsTree.setComparator(NavigatorView.treeElementsCompare),this.scriptsTree.setFocusable(!1),this.contentElement.appendChild(this.scriptsTree.element),this.setDefaultFocusedElement(this.scriptsTree.element),this.uiSourceCodeNodes=new Platform.MapUtilities.Multimap,this.subfolderNodes=new Map,this.rootNode=new NavigatorRootTreeNode(this),this.rootNode.populate(),this.frameNodes=new Map,this.contentElement.addEventListener("contextmenu",this.handleContextMenu.bind(this),!1),UI.ShortcutRegistry.ShortcutRegistry.instance().addShortcutListener(this.contentElement,{"sources.rename":this.renameShortcut.bind(this)}),this.navigatorGroupByFolderSetting=Common.Settings.Settings.instance().moduleSetting("navigatorGroupByFolder"),this.navigatorGroupByFolderSetting.addChangeListener(this.groupingChanged.bind(this)),this.initGrouping(),Persistence.Persistence.PersistenceImpl.instance().addEventListener(Persistence.Persistence.Events.BindingCreated,this.onBindingChanged,this),Persistence.Persistence.PersistenceImpl.instance().addEventListener(Persistence.Persistence.Events.BindingRemoved,this.onBindingChanged,this),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.NameChanged,this.targetNameChanged,this),SDK.TargetManager.TargetManager.instance().observeTargets(this),this.resetWorkspace(Workspace.Workspace.WorkspaceImpl.instance()),this.workspaceInternal.uiSourceCodes().forEach(this.addUISourceCode.bind(this)),Bindings.NetworkProject.NetworkProjectManager.instance().addEventListener(Bindings.NetworkProject.Events.FrameAttributionAdded,this.frameAttributionAdded,this),Bindings.NetworkProject.NetworkProjectManager.instance().addEventListener(Bindings.NetworkProject.Events.FrameAttributionRemoved,this.frameAttributionRemoved,this)}static treeElementOrder(e){if(boostOrderForNode.has(e))return 0;const t=e;let r=TYPE_ORDERS.get(t.nodeType)||0;if(t.uiSourceCode){const e=t.uiSourceCode.contentType();e.isDocument()?r+=3:e.isScript()?r+=5:e.isStyleSheet()?r+=10:r+=15}return r}static appendSearchItem(e,t){let r=i18nString(UIStrings.searchInFolder);t&&t.trim()||(t="*",r=i18nString(UIStrings.searchInAllFiles)),e.viewSection().appendItem(r,(()=>{t&&SearchSourcesView.openSearch(`file:${t.trim()}`)}))}static treeElementsCompare(e,t){const r=NavigatorView.treeElementOrder(e),i=NavigatorView.treeElementOrder(t);return r>i?1:r<i?-1:Platform.StringUtilities.naturalOrderComparator(e.titleAsText(),t.titleAsText())}setPlaceholder(e){function t(){const t=this.scriptsTree.firstChild();t?e.hideWidget():e.showWidget(),this.scriptsTree.element.classList.toggle("hidden",!t)}console.assert(!this.placeholder,"A placeholder widget was already set"),this.placeholder=e,e.show(this.contentElement,this.contentElement.firstChild),t.call(this),this.scriptsTree.addEventListener(UI.TreeOutline.Events.ElementAttached,t.bind(this)),this.scriptsTree.addEventListener(UI.TreeOutline.Events.ElementsDetached,t.bind(this))}onBindingChanged(e){const t=e.data,r=this.uiSourceCodeNodes.get(t.network);for(const e of r)e.updateTitle();const i=this.uiSourceCodeNodes.get(t.fileSystem);for(const e of i)e.updateTitle();const s=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(t.fileSystem);let o="";for(let e=0;e<s.length-1;++e){o+=s[e];const r=this.folderNodeId(t.fileSystem.project(),null,null,t.fileSystem.origin(),o),i=this.subfolderNodes.get(r);i&&i.updateTitle(),o+="/"}const n=this.rootNode.child(t.fileSystem.project().id());n&&n.updateTitle()}focus(){this.scriptsTree.focus()}appendChild(e,t){this.scriptsTree.setFocusable(!0),e.appendChild(t)}removeChild(e,t){e.removeChild(t),0===this.scriptsTree.rootElement().childCount()&&this.scriptsTree.setFocusable(!1)}resetWorkspace(e){this.workspaceInternal&&(this.workspaceInternal.removeEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this.uiSourceCodeAddedCallback,this),this.workspaceInternal.removeEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this.uiSourceCodeRemovedCallback,this),this.workspaceInternal.removeEventListener(Workspace.Workspace.Events.ProjectAdded,this.projectAddedCallback,this),this.workspaceInternal.removeEventListener(Workspace.Workspace.Events.ProjectRemoved,this.projectRemovedCallback,this)),this.workspaceInternal=e,this.workspaceInternal.addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this.uiSourceCodeAddedCallback,this),this.workspaceInternal.addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this.uiSourceCodeRemovedCallback,this),this.workspaceInternal.addEventListener(Workspace.Workspace.Events.ProjectAdded,this.projectAddedCallback,this),this.workspaceInternal.addEventListener(Workspace.Workspace.Events.ProjectRemoved,this.projectRemovedCallback,this),this.workspaceInternal.projects().forEach(this.projectAdded.bind(this)),this.computeUniqueFileSystemProjectNames()}projectAddedCallback(e){const t=e.data;this.projectAdded(t),t.type()===Workspace.Workspace.projectTypes.FileSystem&&this.computeUniqueFileSystemProjectNames()}projectRemovedCallback(e){const t=e.data;this.removeProject(t),t.type()===Workspace.Workspace.projectTypes.FileSystem&&this.computeUniqueFileSystemProjectNames()}workspace(){return this.workspaceInternal}acceptProject(e){return!e.isServiceProject()}frameAttributionAdded(e){const{uiSourceCode:t}=e.data;if(!this.acceptsUISourceCode(t))return;const r=e.data.frame;this.addUISourceCodeNode(t,r)}frameAttributionRemoved(e){const{uiSourceCode:t}=e.data;if(!this.acceptsUISourceCode(t))return;const r=e.data.frame,i=Array.from(this.uiSourceCodeNodes.get(t)).find((e=>e.frame()===r));this.removeUISourceCodeNode(i)}acceptsUISourceCode(e){return this.acceptProject(e.project())}addUISourceCode(e){if(!this.acceptsUISourceCode(e))return;const t=Bindings.NetworkProject.NetworkProject.framesForUISourceCode(e);if(t.length)for(const r of t)this.addUISourceCodeNode(e,r);else this.addUISourceCodeNode(e,null);this.uiSourceCodeAdded(e)}addUISourceCodeNode(e,t){const r=e.contentType().isFromSourceMap();let i;i=e.project().type()===Workspace.Workspace.projectTypes.FileSystem?Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(e).slice(0,-1):Common.ParsedURL.ParsedURL.extractPath(e.url()).split("/").slice(1,-1);const s=e.project(),o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),n=this.folderNode(e,s,o,t,e.origin(),i,r),a=new NavigatorUISourceCodeTreeNode(this,e,t);n.appendChild(a),this.uiSourceCodeNodes.set(e,a),this.selectDefaultTreeNode()}uiSourceCodeAdded(e){}uiSourceCodeAddedCallback(e){const t=e.data;this.addUISourceCode(t)}uiSourceCodeRemovedCallback(e){const t=e.data;this.removeUISourceCode(t)}tryAddProject(e){this.projectAdded(e),e.uiSourceCodes().forEach(this.addUISourceCode.bind(this))}projectAdded(e){!this.acceptProject(e)||e.type()!==Workspace.Workspace.projectTypes.FileSystem||Snippets.ScriptSnippetFileSystem.isSnippetsProject(e)||this.rootNode.child(e.id())||(this.rootNode.appendChild(new NavigatorGroupTreeNode(this,e,e.id(),Types.FileSystem,e.displayName())),this.selectDefaultTreeNode())}selectDefaultTreeNode(){const e=this.rootNode.children();e.length&&!this.scriptsTree.selectedTreeElement&&e[0].treeNode().select(!0,!1)}computeUniqueFileSystemProjectNames(){const e=this.workspaceInternal.projectsForType(Workspace.Workspace.projectTypes.FileSystem);if(!e.length)return;const t=new Persistence.Persistence.PathEncoder,r=e.map((e=>{const r=e;return Platform.StringUtilities.reverse(t.encode(r.fileSystemPath()))})),i=new Common.Trie.Trie;for(const e of r)i.add(e);for(let s=0;s<e.length;++s){const o=r[s],n=e[s];i.remove(o);const a=i.longestPrefix(o,!1);i.add(o);const d=o.substring(0,a.length+1),l=t.decode(Platform.StringUtilities.reverse(d)),c=this.rootNode.child(n.id());c&&c.setTitle(l)}}removeProject(e){const t=e.uiSourceCodes();for(let e=0;e<t.length;++e)this.removeUISourceCode(t[e]);if(e.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const r=this.rootNode.child(e.id());r&&this.rootNode.removeChild(r)}folderNodeId(e,t,r,i,s){return(t?t.id():"")+":"+(e.type()===Workspace.Workspace.projectTypes.FileSystem?e.id():"")+":"+(this.groupByFrame&&r?r.id:"")+":"+i+":"+s}folderNode(e,t,r,i,s,o,n){if(Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(e))return this.rootNode;if(r&&!this.groupByFolder&&!n)return this.domainNode(e,t,r,i,s);const a=o.join("/"),d=this.folderNodeId(t,r,i,s,a);let l=this.subfolderNodes.get(d);if(l)return l;if(!o.length)return r?this.domainNode(e,t,r,i,s):this.rootNode.child(t.id());const c=this.folderNode(e,t,r,i,s,o.slice(0,-1),n);let h=n?Types.SourceMapFolder:Types.NetworkFolder;t.type()===Workspace.Workspace.projectTypes.FileSystem&&(h=Types.FileSystemFolder);const p=o[o.length-1];return l=new NavigatorFolderTreeNode(this,t,d,h,a,p),this.subfolderNodes.set(d,l),c.appendChild(l),l}domainNode(e,t,r,i,s){const o=this.frameNode(t,r,i);if(!this.groupByDomain)return o;let n=o.child(s);return n||(n=new NavigatorGroupTreeNode(this,t,s,Types.Domain,this.computeProjectDisplayName(r,s)),i&&s===Common.ParsedURL.ParsedURL.extractOrigin(i.url)&&boostOrderForNode.add(n.treeNode()),o.appendChild(n),n)}frameNode(e,t,r){if(!this.groupByFrame||!r)return this.targetNode(e,t);let i=this.frameNodes.get(r);if(i)return i;i=new NavigatorGroupTreeNode(this,e,t.id()+":"+r.id,Types.Frame,r.displayName()),i.setHoverCallback((function(e){if(e){const e=t.model(SDK.OverlayModel.OverlayModel);e&&r&&e.highlightFrame(r.id)}else SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()})),this.frameNodes.set(r,i);const s=r.parentFrame();return this.frameNode(e,s?s.resourceTreeModel().target():t,s).appendChild(i),s||(boostOrderForNode.add(i.treeNode()),i.treeNode().expand()),i}targetNode(e,t){if(t===SDK.TargetManager.TargetManager.instance().mainTarget())return this.rootNode;let r=this.rootNode.child("target:"+t.id());return r||(r=new NavigatorGroupTreeNode(this,e,"target:"+t.id(),t.type()===SDK.Target.Type.Frame?Types.Frame:Types.Worker,t.name()),this.rootNode.appendChild(r)),r}computeProjectDisplayName(e,t){const r=e.model(SDK.RuntimeModel.RuntimeModel),i=r?r.executionContexts():[];for(const e of i)if(e.name&&e.origin&&t.startsWith(e.origin))return e.name;if(!t)return i18nString(UIStrings.noDomain);const s=new Common.ParsedURL.ParsedURL(t);return(s.isValid?s.host+(s.port?":"+s.port:""):"")||t}revealUISourceCode(e,t){const r=this.uiSourceCodeNodes.get(e);if(0===r.size)return null;const i=r.values().next().value;return i?(this.scriptsTree.selectedTreeElement&&this.scriptsTree.selectedTreeElement.deselect(),this.lastSelectedUISourceCode=e,i.reveal(t),i):null}sourceSelected(e,t){this.lastSelectedUISourceCode=e,Common.Revealer.reveal(e,!t)}removeUISourceCode(e){const t=this.uiSourceCodeNodes.get(e);for(const e of t)this.removeUISourceCodeNode(e)}removeUISourceCodeNode(e){const t=e.uiSourceCode();this.uiSourceCodeNodes.delete(t,e);const r=t.project(),i=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(t),s=e.frame();let o=e.parent;if(!o)return;o.removeChild(e);let n=o;for(;n&&(o=n.parent,o&&n.isEmpty())&&(o!==this.rootNode||r.type()!==Workspace.Workspace.projectTypes.FileSystem)&&(n instanceof NavigatorGroupTreeNode||n instanceof NavigatorFolderTreeNode);){if(n.type===Types.Frame){this.discardFrame(s);break}const e=this.folderNodeId(r,i,s,t.origin(),n instanceof NavigatorFolderTreeNode&&n.folderPath||"");this.subfolderNodes.delete(e),o.removeChild(n),n=o}}reset(){for(const e of this.uiSourceCodeNodes.valuesArray())e.dispose();this.scriptsTree.removeChildren(),this.scriptsTree.setFocusable(!1),this.uiSourceCodeNodes.clear(),this.subfolderNodes.clear(),this.frameNodes.clear(),this.rootNode.reset(),this.resetWorkspace(Workspace.Workspace.WorkspaceImpl.instance())}handleContextMenu(e){}async renameShortcut(){const e=this.scriptsTree.selectedTreeElement,t=e&&e.node;return!!(t&&t.uiSourceCode()&&t.uiSourceCode().canRename())&&(this.rename(t,!1),!0)}handleContextMenuCreate(e,t,r){if(r){const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(r);e.pop(),t=e.join("/")}this.create(e,t,r)}handleContextMenuRename(e){this.rename(e,!1)}async handleContextMenuExclude(e,t){await UI.UIUtils.ConfirmDialog.show(i18nString(UIStrings.areYouSureYouWantToExcludeThis))&&(UI.UIUtils.startBatchUpdate(),e.excludeFolder(Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.completeURL(e,t)),UI.UIUtils.endBatchUpdate())}async handleContextMenuDelete(e){await UI.UIUtils.ConfirmDialog.show(i18nString(UIStrings.areYouSureYouWantToDeleteThis))&&e.project().deleteFile(e)}handleFileContextMenu(e,t){const r=t.uiSourceCode(),i=new UI.ContextMenu.ContextMenu(e);i.appendApplicableItems(r);const s=r.project();s.type()===Workspace.Workspace.projectTypes.FileSystem&&(i.editSection().appendItem(i18nString(UIStrings.rename),this.handleContextMenuRename.bind(this,t)),i.editSection().appendItem(i18nString(UIStrings.makeACopy),this.handleContextMenuCreate.bind(this,s,"",r)),i.editSection().appendItem(i18nString(UIStrings.delete),this.handleContextMenuDelete.bind(this,r))),i.show()}async handleDeleteOverrides(e){await UI.UIUtils.ConfirmDialog.show(i18nString(UIStrings.areYouSureYouWantToDeleteAll))&&this.handleDeleteOverridesHelper(e)}handleDeleteOverridesHelper(e){if(e.children().forEach((e=>{this.handleDeleteOverridesHelper(e)})),e instanceof NavigatorUISourceCodeTreeNode){Persistence.Persistence.PersistenceImpl.instance().binding(e.uiSourceCode())&&e.uiSourceCode().project().deleteFile(e.uiSourceCode())}}handleFolderContextMenu(e,t){const r=t.folderPath||"",i=t.project||null,s=new UI.ContextMenu.ContextMenu(e);if(NavigatorView.appendSearchItem(s,r),i){if(i.type()===Workspace.Workspace.projectTypes.FileSystem){const e=Common.ParsedURL.ParsedURL.capFilePrefix(Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.completeURL(i,r),Host.Platform.isWin());s.revealSection().appendItem(i18nString(UIStrings.openFolder),(()=>Host.InspectorFrontendHost.InspectorFrontendHostInstance.showItemInFolder(e))),i.canCreateFile()&&s.defaultSection().appendItem(i18nString(UIStrings.newFile),(()=>{this.handleContextMenuCreate(i,r,void 0)}))}i.canExcludeFolder(r)&&s.defaultSection().appendItem(i18nString(UIStrings.excludeFolder),this.handleContextMenuExclude.bind(this,i,r)),i.type()===Workspace.Workspace.projectTypes.FileSystem&&(s.defaultSection().appendAction("sources.add-folder-to-workspace",void 0,!0),t instanceof NavigatorGroupTreeNode&&s.defaultSection().appendItem(i18nString(UIStrings.removeFolderFromWorkspace),(async()=>{await UI.UIUtils.ConfirmDialog.show(i18nString(UIStrings.areYouSureYouWantToRemoveThis))&&i.remove()})),"overrides"===i.fileSystem().type()&&s.defaultSection().appendItem(i18nString(UIStrings.deleteAllOverrides),this.handleDeleteOverrides.bind(this,t))),s.show()}}rename(e,t){const r=e.uiSourceCode();e.rename(function(i){if(!t)return;i?e.treeElement&&e.treeElement.listItemElement.hasFocus()&&this.sourceSelected(r,!0):r.remove()}.bind(this))}async create(e,t,r){let i="";r&&(i=(await r.requestContent()).content||"");const s=await e.createFile(t,null,i);if(!s)return;this.sourceSelected(s,!1);const o=this.revealUISourceCode(s,!0);o&&this.rename(o,!0)}groupingChanged(){this.reset(),this.initGrouping(),this.workspaceInternal.uiSourceCodes().forEach(this.addUISourceCode.bind(this))}initGrouping(){this.groupByFrame=!0,this.groupByDomain=this.navigatorGroupByFolderSetting.get(),this.groupByFolder=this.groupByDomain}resetForTest(){this.reset(),this.workspaceInternal.uiSourceCodes().forEach(this.addUISourceCode.bind(this))}discardFrame(e){const t=this.frameNodes.get(e);if(t){t.parent&&t.parent.removeChild(t),this.frameNodes.delete(e);for(const t of e.childFrames)this.discardFrame(t)}}targetAdded(e){}targetRemoved(e){const t=this.rootNode.child("target:"+e.id());t&&this.rootNode.removeChild(t)}targetNameChanged(e){const t=e.data,r=this.rootNode.child("target:"+t.id());r&&r.setTitle(t.name())}wasShown(){super.wasShown(),this.scriptsTree.registerCSSFiles([navigatorTreeStyles]),this.registerCSSFiles([navigatorViewStyles])}}const boostOrderForNode=new WeakSet;export class NavigatorFolderTreeElement extends UI.TreeOutline.TreeElement{nodeType;navigatorView;hoverCallback;node;hovered;constructor(e,t,r,i){super("",!0),this.listItemElement.classList.add("navigator-"+t+"-tree-item","navigator-folder-tree-item"),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${r}, ${t}`),this.nodeType=t,this.title=r,this.tooltip=r,this.navigatorView=e,this.hoverCallback=i;let s="largeicon-navigator-folder";t===Types.Domain?s="largeicon-navigator-domain":t===Types.Frame?s="largeicon-navigator-frame":t===Types.Worker&&(s="largeicon-navigator-worker"),this.setLeadingIcons([UI.Icon.Icon.create(s,"icon")])}async onpopulate(){this.node.populate()}onattach(){this.collapse(),this.node.onattach(),this.listItemElement.addEventListener("contextmenu",this.handleContextMenuEvent.bind(this),!1),this.listItemElement.addEventListener("mousemove",this.mouseMove.bind(this),!1),this.listItemElement.addEventListener("mouseleave",this.mouseLeave.bind(this),!1)}setNode(e){this.node=e;const t=[];let r=e;for(;r&&!r.isRoot();)t.push(r.title),r=r.parent;t.reverse(),this.tooltip=t.join("/"),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${this.title}, ${this.nodeType}`)}handleContextMenuEvent(e){this.node&&(this.select(),this.navigatorView.handleFolderContextMenu(e,this.node))}mouseMove(e){!this.hovered&&this.hoverCallback&&(this.hovered=!0,this.hoverCallback(!0))}mouseLeave(e){this.hoverCallback&&(this.hovered=!1,this.hoverCallback(!1))}}export class NavigatorSourceTreeElement extends UI.TreeOutline.TreeElement{nodeType;node;navigatorView;uiSourceCodeInternal;constructor(e,t,r,i){super("",!1),this.nodeType=Types.File,this.node=i,this.title=r,this.listItemElement.classList.add("navigator-"+t.contentType().name()+"-tree-item","navigator-file-tree-item"),this.tooltip=t.url(),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${t.name()}, ${this.nodeType}`),Common.EventTarget.fireEvent("source-tree-file-added",t.fullDisplayName()),this.navigatorView=e,this.uiSourceCodeInternal=t,this.updateIcon()}updateIcon(){const e=Persistence.Persistence.PersistenceImpl.instance().binding(this.uiSourceCodeInternal);if(e){const t=document.createElement("span");t.classList.add("icon-stack");let r="largeicon-navigator-file-sync";Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(e.fileSystem)&&(r="largeicon-navigator-snippet");const i=UI.Icon.Icon.create(r,"icon"),s=UI.Icon.Icon.create("badge-navigator-file-sync","icon-badge");Persistence.NetworkPersistenceManager.NetworkPersistenceManager.instance().project()===e.fileSystem.project()&&(s.style.filter="hue-rotate(160deg)"),t.appendChild(i),t.appendChild(s),UI.Tooltip.Tooltip.install(t,Persistence.PersistenceUtils.PersistenceUtils.tooltipForUISourceCode(this.uiSourceCodeInternal)),this.setLeadingIcons([t])}else{let e="largeicon-navigator-file";Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(this.uiSourceCodeInternal)&&(e="largeicon-navigator-snippet");const t=UI.Icon.Icon.create(e,"icon");this.setLeadingIcons([t])}}get uiSourceCode(){return this.uiSourceCodeInternal}onattach(){this.listItemElement.draggable=!0,this.listItemElement.addEventListener("click",this.onclick.bind(this),!1),this.listItemElement.addEventListener("contextmenu",this.handleContextMenuEvent.bind(this),!1),this.listItemElement.addEventListener("dragstart",this.ondragstart.bind(this),!1)}shouldRenameOnMouseDown(){if(!this.uiSourceCodeInternal.canRename())return!1;if(!this.treeOutline)return!1;return this===this.treeOutline.selectedTreeElement&&this.treeOutline.element.hasFocus()&&!UI.UIUtils.isBeingEdited(this.treeOutline.element)}selectOnMouseDown(e){1===e.which&&this.shouldRenameOnMouseDown()?setTimeout(function(){this.shouldRenameOnMouseDown()&&this.navigatorView.rename(this.node,!1)}.bind(this),300):super.selectOnMouseDown(e)}ondragstart(e){e.dataTransfer&&(e.dataTransfer.setData("text/plain",this.uiSourceCodeInternal.url()),e.dataTransfer.effectAllowed="copy")}onspace(){return this.navigatorView.sourceSelected(this.uiSourceCode,!0),!0}onclick(e){this.navigatorView.sourceSelected(this.uiSourceCode,!1)}ondblclick(e){const t=1===e.button;return this.navigatorView.sourceSelected(this.uiSourceCode,!t),!1}onenter(){return this.navigatorView.sourceSelected(this.uiSourceCode,!0),!0}ondelete(){return!0}handleContextMenuEvent(e){this.select(),this.navigatorView.handleFileContextMenu(e,this.node)}}export class NavigatorTreeNode{id;navigatorView;type;childrenInternal;populated;isMerged;parent;title;constructor(e,t,r){this.id=t,this.navigatorView=e,this.type=r,this.childrenInternal=new Map,this.populated=!1,this.isMerged=!1}treeNode(){throw"Not implemented"}dispose(){}updateTitle(){}isRoot(){return!1}hasChildren(){return!0}onattach(){}setTitle(e){throw"Not implemented"}populate(){this.isPopulated()||(this.parent&&this.parent.populate(),this.populated=!0,this.wasPopulated())}wasPopulated(){const e=this.children();for(let t=0;t<e.length;++t)this.navigatorView.appendChild(this.treeNode(),e[t].treeNode())}didAddChild(e){this.isPopulated()&&this.navigatorView.appendChild(this.treeNode(),e.treeNode())}willRemoveChild(e){this.isPopulated()&&this.navigatorView.removeChild(this.treeNode(),e.treeNode())}isPopulated(){return this.populated}isEmpty(){return!this.childrenInternal.size}children(){return[...this.childrenInternal.values()]}child(e){return this.childrenInternal.get(e)||null}appendChild(e){this.childrenInternal.set(e.id,e),e.parent=this,this.didAddChild(e)}removeChild(e){this.willRemoveChild(e),this.childrenInternal.delete(e.id),e.parent=null,e.dispose()}reset(){this.childrenInternal.clear()}}export class NavigatorRootTreeNode extends NavigatorTreeNode{constructor(e){super(e,"",Types.Root)}isRoot(){return!0}treeNode(){return this.navigatorView.scriptsTree.rootElement()}}export class NavigatorUISourceCodeTreeNode extends NavigatorTreeNode{uiSourceCodeInternal;treeElement;eventListeners;frameInternal;constructor(e,t,r){super(e,t.project().id()+":"+t.url(),Types.File),this.uiSourceCodeInternal=t,this.treeElement=null,this.eventListeners=[],this.frameInternal=r}frame(){return this.frameInternal}uiSourceCode(){return this.uiSourceCodeInternal}treeNode(){if(this.treeElement)return this.treeElement;this.treeElement=new NavigatorSourceTreeElement(this.navigatorView,this.uiSourceCodeInternal,"",this),this.updateTitle();const e=this.updateTitle.bind(this,void 0);return this.eventListeners=[this.uiSourceCodeInternal.addEventListener(Workspace.UISourceCode.Events.TitleChanged,e),this.uiSourceCodeInternal.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,e),this.uiSourceCodeInternal.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,e)],this.treeElement}updateTitle(e){if(!this.treeElement)return;let t=this.uiSourceCodeInternal.displayName();!e&&this.uiSourceCodeInternal.isDirty()&&(t="*"+t),this.treeElement.title=t,this.treeElement.updateIcon();let r=this.uiSourceCodeInternal.url();this.uiSourceCodeInternal.contentType().isFromSourceMap()&&(r=i18nString(UIStrings.sFromSourceMap,{PH1:this.uiSourceCodeInternal.displayName()})),this.treeElement.tooltip=r}hasChildren(){return!1}dispose(){Common.EventTarget.removeEventListeners(this.eventListeners)}reveal(e){this.parent&&(this.parent.populate(),this.parent.treeNode().expand()),this.treeElement&&(this.treeElement.reveal(!0),e&&this.treeElement.select(!0))}rename(e){if(!this.treeElement)return;if(this.treeElement.listItemElement.focus(),!this.treeElement.treeOutline)return;const t=this.treeElement.treeOutline.element;function r(r){if(!r)return UI.UIUtils.markBeingEdited(t,!1),this.updateTitle(),void this.rename(e);if(this.treeElement){const{parent:e}=this.treeElement;e&&(e.removeChild(this.treeElement),e.appendChild(this.treeElement),this.treeElement.select())}i.call(this,!0)}function i(r){UI.UIUtils.markBeingEdited(t,!1),this.updateTitle(),e&&e(r)}UI.UIUtils.markBeingEdited(t,!0),this.updateTitle(!0),this.treeElement.startEditingTitle(new UI.InplaceEditor.Config(function(e,t,s){if(t!==s)return this.treeElement&&(this.treeElement.title=t),void this.uiSourceCodeInternal.rename(t).then(r.bind(this));i.call(this,!0)}.bind(this),i.bind(this,!1)))}}export class NavigatorFolderTreeNode extends NavigatorTreeNode{project;folderPath;title;treeElement;constructor(e,t,r,i,s,o){super(e,r,i),this.project=t,this.folderPath=s,this.title=o}treeNode(){return this.treeElement||(this.treeElement=this.createTreeElement(this.title,this),this.updateTitle()),this.treeElement}updateTitle(){if(!this.treeElement||!this.project||this.project.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.fileSystemPath(this.project.id())+"/"+this.folderPath,t=Persistence.Persistence.PersistenceImpl.instance().filePathHasBindings(e);this.treeElement.listItemElement.classList.toggle("has-mapped-files",t)}createTreeElement(e,t){if(this.project&&this.project.type()!==Workspace.Workspace.projectTypes.FileSystem)try{e=decodeURI(e)}catch(e){}const r=new NavigatorFolderTreeElement(this.navigatorView,this.type,e);return r.setNode(t),r}wasPopulated(){this.treeElement&&this.treeElement.node===this&&this.addChildrenRecursive()}addChildrenRecursive(){const e=this.children();for(let t=0;t<e.length;++t){const r=e[t];this.didAddChild(r),r instanceof NavigatorFolderTreeNode&&r.addChildrenRecursive()}}shouldMerge(e){return this.type!==Types.Domain&&e instanceof NavigatorFolderTreeNode}didAddChild(e){if(!this.treeElement)return;let t,r=this.children();if(1===r.length&&this.shouldMerge(e))return e.isMerged=!0,this.treeElement.title=this.treeElement.title+"/"+e.title,e.treeElement=this.treeElement,void this.treeElement.setNode(e);if(2===r.length&&(t=r[0]!==e?r[0]:r[1]),t&&t.isMerged){t.isMerged=!1;const e=[];e.push(this);let i=this;for(;i&&i.isMerged;)i=i.parent,i&&e.push(i);e.reverse();const s=e.map((e=>e.title)).join("/"),o=[];i=t;do{o.push(i),r=i.children(),i=1===r.length?r[0]:null}while(i&&i.isMerged);if(!this.isPopulated()){this.treeElement.title=s,this.treeElement.setNode(this);for(let e=0;e<o.length;++e)o[e].treeElement=null,o[e].isMerged=!1;return}const n=this.treeElement,a=this.createTreeElement(s,this);for(let t=0;t<e.length;++t)e[t].treeElement=a;n.parent&&this.navigatorView.appendChild(n.parent,a),n.setNode(o[o.length-1]),n.title=o.map((e=>e.title)).join("/"),n.parent&&this.navigatorView.removeChild(n.parent,n),this.navigatorView.appendChild(this.treeElement,n),n.expanded&&a.expand()}this.isPopulated()&&this.navigatorView.appendChild(this.treeElement,e.treeNode())}willRemoveChild(e){const t=e;!t.isMerged&&this.isPopulated()&&this.treeElement&&t.treeElement&&this.navigatorView.removeChild(this.treeElement,t.treeElement)}}export class NavigatorGroupTreeNode extends NavigatorTreeNode{project;title;hoverCallback;treeElement;constructor(e,t,r,i,s){super(e,r,i),this.project=t,this.title=s,this.populate()}setHoverCallback(e){this.hoverCallback=e}treeNode(){return this.treeElement||(this.treeElement=new NavigatorFolderTreeElement(this.navigatorView,this.type,this.title,this.hoverCallback),this.treeElement.setNode(this)),this.treeElement}onattach(){this.updateTitle()}updateTitle(){if(!this.treeElement||this.project.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.fileSystemPath(this.project.id()),t=this.treeElement.listItemElement.classList.contains("has-mapped-files"),r=Persistence.Persistence.PersistenceImpl.instance().filePathHasBindings(e);t!==r&&(this.treeElement.listItemElement.classList.toggle("has-mapped-files",r),this.treeElement.childrenListElement.hasFocus()||(r?this.treeElement.expand():this.treeElement.collapse()))}setTitle(e){this.title=e,this.treeElement&&(this.treeElement.title=this.title)}}