import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Formatter from"../../models/formatter/formatter.js";import*as TextUtils from"../../models/text_utils/text_utils.js";const scopeToCachedIdentifiersMap=new WeakMap,cachedMapByCallFrame=new WeakMap;export class Identifier{name;lineNumber;columnNumber;constructor(e,t,r){this.name=e,this.lineNumber=t,this.columnNumber=r}}export const scopeIdentifiers=async function(e){if("global"===e.type())return[];const t=e.startLocation(),r=e.endLocation();if(!t||!r)return[];const n=t.script();if(!n||!n.sourceMapURL||n!==r.script())return[];const{content:o}=await n.requestContent();if(!o)return[];const s=new TextUtils.Text.Text(o),i=new TextUtils.TextRange.TextRange(t.lineNumber,t.columnNumber,r.lineNumber,r.columnNumber),c=s.extract(i),a=s.toSourceRange(i).offset,u="function fui",l=await Formatter.FormatterWorkerPool.formatterWorkerPool().javaScriptIdentifiers(u+c),p=[],m=new TextUtils.TextCursor.TextCursor(s.lineEndings());for(const e of l){if(e.offset<u.length)continue;const t=a+e.offset-u.length;m.resetTo(t),p.push(new Identifier(e.name,m.lineNumber(),m.columnNumber()))}return p};export const resolveScopeChain=async function(e){if(!e)return null;const{pluginManager:t}=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance();if(t){const r=await t.resolveScopeChain(e);if(r)return r}return e.scopeChain()};export const resolveScope=async e=>{let t=scopeToCachedIdentifiersMap.get(e);return t||(t=(async()=>{const t=new Map,n=e.callFrame().script,o=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().sourceMapForScript(n);if(o){const s=new Map,i=[];for(const c of await scopeIdentifiers(e)){const e=o.findEntry(c.lineNumber,c.columnNumber);e&&e.name?t.set(c.name,e.name):i.push(r(n,o,c,s).then((e=>{e&&t.set(c.name,e)})))}await Promise.all(i).then(getScopeResolvedForTest())}return t})(),scopeToCachedIdentifiersMap.set(e,t)),await t;async function r(e,t,r,n){const o=t.findEntry(r.lineNumber,r.columnNumber),s=t.findEntry(r.lineNumber,r.columnNumber+r.name.length);if(!(o&&s&&o.sourceURL&&o.sourceURL===s.sourceURL&&o.sourceLineNumber&&o.sourceColumnNumber&&s.sourceLineNumber&&s.sourceColumnNumber))return null;const i=new TextUtils.TextRange.TextRange(o.sourceLineNumber,o.sourceColumnNumber,s.sourceLineNumber,s.sourceColumnNumber),c=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiSourceCodeForSourceMapSourceURL(e.debuggerModel,o.sourceURL,e.isContentScript());if(!c)return null;const{content:a}=await c.requestContent();if(!a)return null;let u=n.get(a);u||(u=new TextUtils.Text.Text(a),n.set(a,u));const l=u.extract(i).trim();return/[a-zA-Z0-9_$]+/.test(l)?l:null}};export const allVariablesInCallFrame=async e=>{const t=cachedMapByCallFrame.get(e);if(t)return t;const r=e.scopeChain(),n=await Promise.all(r.map(resolveScope)),o=new Map;for(const e of n)for(const[t,r]of e)r&&!o.has(r)&&o.set(r,t);return cachedMapByCallFrame.set(e,o),o};export const resolveExpression=async(e,t,r,n,o,s)=>{if("application/wasm"===r.mimeType())return`memories["${t}"] ?? locals["${t}"] ?? tables["${t}"] ?? functions["${t}"] ?? globals["${t}"]`;if(!r.contentType().isFromSourceMap())return"";const i=await allVariablesInCallFrame(e);if(i.has(t))return i.get(t);const c=(await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(r,n,o)).find((t=>t.debuggerModel===e.debuggerModel));if(!c)return"";const a=c.script();if(!a)return"";const u=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().sourceMapForScript(a);if(!u)return"";const{content:l}=await a.requestContent();if(!l)return"";const p=new TextUtils.Text.Text(l),m=u.reverseMapTextRange(r.url(),new TextUtils.TextRange.TextRange(n,o,n,s));if(!m)return"";const b=p.extract(m);return b?await Formatter.FormatterWorkerPool.formatterWorkerPool().evaluatableJavaScriptSubstring(b):""};export const resolveThisObject=async e=>{if(!e)return null;const t=e.scopeChain();if(0===t.length)return e.thisObject();const r=await resolveScope(t[0]),n=Platform.MapUtilities.inverse(r).get("this");if(!n||1!==n.size)return e.thisObject();const[o]=n.values(),s=await e.evaluate({expression:o,objectGroup:"backtrace",includeCommandLineAPI:!1,silent:!0,returnByValue:!1,generatePreview:!0});return"exceptionDetails"in s?!s.exceptionDetails&&s.object?s.object:e.thisObject():null};export const resolveScopeInObject=function(e){const t=e.startLocation(),r=e.endLocation(),n=t?t.script():null;return"global"!==e.type()&&n&&r&&n.sourceMapURL&&n===r.script()?new RemoteObject(e):e.object()};export class RemoteObject extends SDK.RemoteObject.RemoteObject{scope;object;constructor(e){super(),this.scope=e,this.object=e.object()}customPreview(){return this.object.customPreview()}get objectId(){return this.object.objectId}get type(){return this.object.type}get subtype(){return this.object.subtype}get value(){return this.object.value}get description(){return this.object.description}get hasChildren(){return this.object.hasChildren}get preview(){return this.object.preview}arrayLength(){return this.object.arrayLength()}getOwnProperties(e){return this.object.getOwnProperties(e)}async getAllProperties(e,t){const r=await this.object.getAllProperties(e,t),n=await resolveScope(this.scope),o=r.properties,s=r.internalProperties,i=[];if(o)for(let e=0;e<o.length;++e){const t=o[e],r=n.get(t.name)||o[e].name;t.value&&i.push(new SDK.RemoteObject.RemoteObjectProperty(r,t.value,t.enumerable,t.writable,t.isOwn,t.wasThrown,t.symbol,t.synthetic))}return{properties:i,internalProperties:s}}async setPropertyValue(e,t){const r=await resolveScope(this.scope);let n;n="string"==typeof e?e:e.value;let o=n;for(const e of r.keys())if(r.get(e)===n){o=e;break}return this.object.setPropertyValue(o,t)}async deleteProperty(e){return this.object.deleteProperty(e)}callFunction(e,t){return this.object.callFunction(e,t)}callFunctionJSON(e,t){return this.object.callFunctionJSON(e,t)}release(){this.object.release()}debuggerModel(){return this.object.debuggerModel()}runtimeModel(){return this.object.runtimeModel()}isNode(){return this.object.isNode()}}let _scopeResolvedForTest=function(){};export const getScopeResolvedForTest=()=>_scopeResolvedForTest;export const setScopeResolvedForTest=e=>{_scopeResolvedForTest=e};