import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Extensions from"../../models/extensions/extensions.js";import*as Workspace from"../../models/workspace/workspace.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import*as UI from"../../ui/legacy/legacy.js";import*as Snippets from"../snippets/snippets.js";import{CallStackSidebarPane}from"./CallStackSidebarPane.js";import{DebuggerPausedMessage}from"./DebuggerPausedMessage.js";import sourcesPanelStyles from"./sourcesPanel.css.js";import{ContentScriptsNavigatorView,FilesNavigatorView,NetworkNavigatorView,OverridesNavigatorView,SnippetsNavigatorView}from"./SourcesNavigator.js";import{Events,SourcesView}from"./SourcesView.js";import{ThreadsSidebarPane}from"./ThreadsSidebarPane.js";import{UISourceCodeFrame}from"./UISourceCodeFrame.js";const UIStrings={dropWorkspaceFolderHere:"Drop workspace folder here",moreOptions:"More options",showNavigator:"Show navigator",hideNavigator:"Hide navigator",showDebugger:"Show debugger",hideDebugger:"Hide debugger",groupByFolder:"Group by folder",pauseOnExceptions:"Pause on exceptions",dontPauseOnExceptions:"Don't pause on exceptions",resumeWithAllPausesBlockedForMs:"Resume with all pauses blocked for 500 ms",terminateCurrentJavascriptCall:"Terminate current JavaScript call",pauseOnCaughtExceptions:"Pause on caught exceptions",revealInSidebar:"Reveal in sidebar",continueToHere:"Continue to here",storeSAsGlobalVariable:"Store {PH1} as global variable",copyS:"Copy {PH1}",copyStringContents:"Copy string contents",copyStringAsJSLiteral:"Copy string as JavaScript literal",copyStringAsJSONLiteral:"Copy string as JSON literal",showFunctionDefinition:"Show function definition",openInSourcesPanel:"Open in Sources panel"},str_=i18n.i18n.registerUIStrings("panels/sources/SourcesPanel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),primitiveRemoteObjectTypes=new Set(["number","boolean","bigint","undefined"]);let sourcesPanelInstance,wrapperViewInstance,uILocationRevealerInstance,debuggerLocationRevealerInstance,uISourceCodeRevealerInstance,debuggerPausedDetailsRevealerInstance,revealingActionDelegateInstance,debuggingActionDelegateInstance;export class SourcesPanel extends UI.Panel.Panel{workspace;togglePauseAction;stepOverAction;stepIntoAction;stepOutAction;stepAction;toggleBreakpointsActiveAction;debugToolbar;debugToolbarDrawer;debuggerPausedMessage;splitWidget;editorView;navigatorTabbedLocation;sourcesViewInternal;toggleNavigatorSidebarButton;toggleDebuggerSidebarButton;threadsSidebarPane;watchSidebarPane;callstackPane;liveLocationPool;lastModificationTime;pausedInternal;switchToPausedTargetTimeout;ignoreExecutionLineEvents;executionLineLocation;pauseOnExceptionButton;sidebarPaneStack;tabbedLocationHeader;extensionSidebarPanesContainer;sidebarPaneView;constructor(){super("sources"),new UI.DropTarget.DropTarget(this.element,[UI.DropTarget.Type.Folder],i18nString(UIStrings.dropWorkspaceFolderHere),this.handleDrop.bind(this)),this.workspace=Workspace.Workspace.WorkspaceImpl.instance(),this.togglePauseAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.toggle-pause"),this.stepOverAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.step-over"),this.stepIntoAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.step-into"),this.stepOutAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.step-out"),this.stepAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.step"),this.toggleBreakpointsActiveAction=UI.ActionRegistry.ActionRegistry.instance().action("debugger.toggle-breakpoints-active"),this.debugToolbar=this.createDebugToolbar(),this.debugToolbarDrawer=this.createDebugToolbarDrawer(),this.debuggerPausedMessage=new DebuggerPausedMessage;this.splitWidget=new UI.SplitWidget.SplitWidget(!0,!0,"sourcesPanelSplitViewState",225),this.splitWidget.enableShowModeSaving(),this.splitWidget.show(this.element),globalThis.chii&&this.splitWidget.hideSidebar(!0);this.editorView=new UI.SplitWidget.SplitWidget(!0,!1,"sourcesPanelNavigatorSplitViewState",225),this.editorView.enableShowModeSaving(),this.splitWidget.setMainWidget(this.editorView),this.navigatorTabbedLocation=UI.ViewManager.ViewManager.instance().createTabbedLocation(this.revealNavigatorSidebar.bind(this),"navigator-view",!0);const e=this.navigatorTabbedLocation.tabbedPane();e.setMinimumSize(100,25),e.element.classList.add("navigator-tabbed-pane");const t=new UI.Toolbar.ToolbarMenuButton(this.populateNavigatorMenu.bind(this),!0);if(t.setTitle(i18nString(UIStrings.moreOptions)),e.rightToolbar().appendToolbarItem(t),UI.ViewManager.ViewManager.instance().hasViewsForLocation("run-view-sidebar")){const t=new UI.SplitWidget.SplitWidget(!1,!0,"sourcePanelNavigatorSidebarSplitViewState");t.setMainWidget(e);const n=UI.ViewManager.ViewManager.instance().createTabbedLocation(this.revealNavigatorSidebar.bind(this),"run-view-sidebar").tabbedPane();t.setSidebarWidget(n),t.installResizer(n.headerElement()),this.editorView.setSidebarWidget(t)}else this.editorView.setSidebarWidget(e);this.sourcesViewInternal=new SourcesView,this.sourcesViewInternal.addEventListener(Events.EditorSelected,this.editorSelected.bind(this)),this.toggleNavigatorSidebarButton=this.editorView.createShowHideSidebarButton(i18nString(UIStrings.showNavigator),i18nString(UIStrings.hideNavigator)),this.toggleDebuggerSidebarButton=this.splitWidget.createShowHideSidebarButton(i18nString(UIStrings.showDebugger),i18nString(UIStrings.hideDebugger)),this.editorView.setMainWidget(this.sourcesViewInternal),this.threadsSidebarPane=null,this.watchSidebarPane=UI.ViewManager.ViewManager.instance().view("sources.watch"),this.callstackPane=CallStackSidebarPane.instance(),Common.Settings.Settings.instance().moduleSetting("sidebarPosition").addChangeListener(this.updateSidebarPosition.bind(this)),this.updateSidebarPosition(),this.updateDebuggerButtonsAndStatus(),this.pauseOnExceptionEnabledChanged(),Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").addChangeListener(this.pauseOnExceptionEnabledChanged,this),this.liveLocationPool=new Bindings.LiveLocation.LiveLocationPool,this.setTarget(UI.Context.Context.instance().flavor(SDK.Target.Target)),Common.Settings.Settings.instance().moduleSetting("breakpointsActive").addChangeListener(this.breakpointsActiveStateChanged,this),UI.Context.Context.instance().addFlavorChangeListener(SDK.Target.Target,this.onCurrentTargetChanged,this),UI.Context.Context.instance().addFlavorChangeListener(SDK.DebuggerModel.CallFrame,this.callFrameChanged,this),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerWasEnabled,this.debuggerWasEnabled,this),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this.debuggerPaused,this),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerResumed,(e=>this.debuggerResumed(e.data))),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.GlobalObjectCleared,(e=>this.debuggerResumed(e.data))),Extensions.ExtensionServer.ExtensionServer.instance().addEventListener(Extensions.ExtensionServer.Events.SidebarPaneAdded,this.extensionSidebarPaneAdded,this),SDK.TargetManager.TargetManager.instance().observeTargets(this),this.lastModificationTime=window.performance.now()}static instance(e={forceNew:null}){const{forceNew:t}=e;return sourcesPanelInstance&&!t||(sourcesPanelInstance=new SourcesPanel),sourcesPanelInstance}static updateResizerAndSidebarButtons(e){e.sourcesViewInternal.leftToolbar().removeToolbarItems(),e.sourcesViewInternal.rightToolbar().removeToolbarItems(),e.sourcesViewInternal.bottomToolbar().removeToolbarItems();const t=WrapperView.isShowing()&&!UI.InspectorView.InspectorView.instance().isDrawerMinimized();e.splitWidget.isVertical()||t?e.splitWidget.uninstallResizer(e.sourcesViewInternal.toolbarContainerElement()):e.splitWidget.installResizer(e.sourcesViewInternal.toolbarContainerElement()),t||(e.sourcesViewInternal.leftToolbar().appendToolbarItem(e.toggleNavigatorSidebarButton),globalThis.chii||(e.splitWidget.isVertical()?e.sourcesViewInternal.rightToolbar().appendToolbarItem(e.toggleDebuggerSidebarButton):e.sourcesViewInternal.bottomToolbar().appendToolbarItem(e.toggleDebuggerSidebarButton)))}targetAdded(e){this.showThreadsIfNeeded()}targetRemoved(e){}showThreadsIfNeeded(){ThreadsSidebarPane.shouldBeShown()&&!this.threadsSidebarPane&&(this.threadsSidebarPane=UI.ViewManager.ViewManager.instance().view("sources.threads"),this.sidebarPaneStack&&this.threadsSidebarPane&&this.sidebarPaneStack.showView(this.threadsSidebarPane,this.splitWidget.isVertical()?this.watchSidebarPane:this.callstackPane))}setTarget(e){if(!e)return;const t=e.model(SDK.DebuggerModel.DebuggerModel);t&&(t.isPaused()?this.showDebuggerPausedDetails(t.debuggerPausedDetails()):(this.pausedInternal=!1,this.clearInterface(),this.toggleDebuggerSidebarButton.setEnabled(!0)))}onCurrentTargetChanged({data:e}){this.setTarget(e)}paused(){return this.pausedInternal||!1}wasShown(){UI.Context.Context.instance().setFlavor(SourcesPanel,this),this.registerCSSFiles([sourcesPanelStyles]),super.wasShown();const e=WrapperView.instance();e&&e.isShowing()&&(UI.InspectorView.InspectorView.instance().setDrawerMinimized(!0),SourcesPanel.updateResizerAndSidebarButtons(this)),this.editorView.setMainWidget(this.sourcesViewInternal)}willHide(){super.willHide(),UI.Context.Context.instance().setFlavor(SourcesPanel,null),WrapperView.isShowing()&&(WrapperView.instance().showViewInWrapper(),UI.InspectorView.InspectorView.instance().setDrawerMinimized(!1),SourcesPanel.updateResizerAndSidebarButtons(this))}resolveLocation(e){return"sources.sidebar-top"===e||"sources.sidebar-bottom"===e||"sources.sidebar-tabs"===e?this.sidebarPaneStack||null:this.navigatorTabbedLocation}ensureSourcesViewVisible(){return!!WrapperView.isShowing()||!!UI.InspectorView.InspectorView.instance().canSelectPanel("sources")&&(UI.ViewManager.ViewManager.instance().showView("sources"),!0)}onResize(){"auto"===Common.Settings.Settings.instance().moduleSetting("sidebarPosition").get()&&this.element.window().requestAnimationFrame(this.updateSidebarPosition.bind(this))}searchableView(){return this.sourcesViewInternal.searchableView()}debuggerPaused(e){const t=e.data,n=t.debuggerPausedDetails();!this.pausedInternal&&Common.Settings.Settings.instance().moduleSetting("autoFocusOnDebuggerPausedEnabled").get()&&this.setAsCurrentPanel(),UI.Context.Context.instance().flavor(SDK.Target.Target)===t.target()?this.showDebuggerPausedDetails(n):this.pausedInternal||UI.Context.Context.instance().setFlavor(SDK.Target.Target,t.target())}showDebuggerPausedDetails(e){this.pausedInternal=!0,this.updateDebuggerButtonsAndStatus(),UI.Context.Context.instance().setFlavor(SDK.DebuggerModel.DebuggerPausedDetails,e),this.toggleDebuggerSidebarButton.setEnabled(!1),this.revealDebuggerSidebar(),window.focus(),Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront()}debuggerResumed(e){const t=e.target();UI.Context.Context.instance().flavor(SDK.Target.Target)===t&&(this.pausedInternal=!1,this.clearInterface(),this.toggleDebuggerSidebarButton.setEnabled(!0),this.switchToPausedTargetTimeout=window.setTimeout(this.switchToPausedTarget.bind(this,e),500))}debuggerWasEnabled(e){const t=e.data;UI.Context.Context.instance().flavor(SDK.Target.Target)===t.target()&&this.updateDebuggerButtonsAndStatus()}get visibleView(){return this.sourcesViewInternal.visibleView()}showUISourceCode(e,t,n,i){if(i){const e=WrapperView.isShowing();if(!this.isShowing()&&!e)return}else this.showEditor();this.sourcesViewInternal.showSourceLocation(e,void 0===t?void 0:{lineNumber:t,columnNumber:n},i)}showEditor(){WrapperView.isShowing()||this.setAsCurrentPanel()}showUILocation(e,t){this.showUISourceCode(e.uiSourceCode,e.lineNumber,e.columnNumber,t)}revealInNavigator(e,t){for(const n of registeredNavigatorViews){const i=n.navigatorView(),a=n.viewId;a&&i.acceptProject(e.project())&&(i.revealUISourceCode(e,!0),t?this.navigatorTabbedLocation.tabbedPane().selectTab(a):UI.ViewManager.ViewManager.instance().showView(a))}}populateNavigatorMenu(e){const t=Common.Settings.Settings.instance().moduleSetting("navigatorGroupByFolder");e.appendItemsAtLocation("navigatorMenu"),e.viewSection().appendCheckboxItem(i18nString(UIStrings.groupByFolder),(()=>t.set(!t.get())),t.get())}setIgnoreExecutionLineEvents(e){this.ignoreExecutionLineEvents=e}updateLastModificationTime(){this.lastModificationTime=window.performance.now()}async executionLineChanged(e){const t=await e.uiLocation();t&&(window.performance.now()-this.lastModificationTime<lastModificationTimeout||this.sourcesViewInternal.showSourceLocation(t.uiSourceCode,t,void 0,!0))}lastModificationTimeoutPassedForTest(){lastModificationTimeout=Number.MIN_VALUE}updateLastModificationTimeForTest(){lastModificationTimeout=Number.MAX_VALUE}async callFrameChanged(){const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);e&&(this.executionLineLocation&&this.executionLineLocation.dispose(),this.executionLineLocation=await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().createCallFrameLiveLocation(e.location(),this.executionLineChanged.bind(this),this.liveLocationPool))}pauseOnExceptionEnabledChanged(){const e=Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").get(),t=this.pauseOnExceptionButton;t.setToggled(e),t.setTitle(i18nString(e?UIStrings.pauseOnExceptions:UIStrings.dontPauseOnExceptions)),this.debugToolbarDrawer.classList.toggle("expanded",e)}async updateDebuggerButtonsAndStatus(){const e=UI.Context.Context.instance().flavor(SDK.Target.Target),t=e?e.model(SDK.DebuggerModel.DebuggerModel):null;t?this.pausedInternal?(this.togglePauseAction.setToggled(!0),this.togglePauseAction.setEnabled(!0),this.stepOverAction.setEnabled(!0),this.stepIntoAction.setEnabled(!0),this.stepOutAction.setEnabled(!0),this.stepAction.setEnabled(!0)):(this.togglePauseAction.setToggled(!1),this.togglePauseAction.setEnabled(!t.isPausing()),this.stepOverAction.setEnabled(!1),this.stepIntoAction.setEnabled(!1),this.stepOutAction.setEnabled(!1),this.stepAction.setEnabled(!1)):(this.togglePauseAction.setEnabled(!1),this.stepOverAction.setEnabled(!1),this.stepIntoAction.setEnabled(!1),this.stepOutAction.setEnabled(!1),this.stepAction.setEnabled(!1));const n=t?t.debuggerPausedDetails():null;await this.debuggerPausedMessage.render(n,Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance(),Bindings.BreakpointManager.BreakpointManager.instance()),n&&this.updateDebuggerButtonsAndStatusForTest()}updateDebuggerButtonsAndStatusForTest(){}clearInterface(){this.updateDebuggerButtonsAndStatus(),UI.Context.Context.instance().setFlavor(SDK.DebuggerModel.DebuggerPausedDetails,null),this.switchToPausedTargetTimeout&&clearTimeout(this.switchToPausedTargetTimeout),this.liveLocationPool.disposeAll()}switchToPausedTarget(e){if(delete this.switchToPausedTargetTimeout,!this.pausedInternal&&!e.isPaused())for(const e of SDK.TargetManager.TargetManager.instance().models(SDK.DebuggerModel.DebuggerModel))if(e.isPaused()){UI.Context.Context.instance().setFlavor(SDK.Target.Target,e.target());break}}togglePauseOnExceptions(){Common.Settings.Settings.instance().moduleSetting("pauseOnExceptionEnabled").set(!this.pauseOnExceptionButton.toggled())}runSnippet(){const e=this.sourcesViewInternal.currentUISourceCode();e&&Snippets.ScriptSnippetFileSystem.evaluateScriptSnippet(e)}editorSelected(e){const t=e.data;this.editorView.mainWidget()&&Common.Settings.Settings.instance().moduleSetting("autoRevealInNavigator").get()&&this.revealInNavigator(t,!0)}togglePause(){const e=UI.Context.Context.instance().flavor(SDK.Target.Target);if(!e)return!0;const t=e.model(SDK.DebuggerModel.DebuggerModel);return!t||(this.pausedInternal?(this.pausedInternal=!1,t.resume()):t.pause(),this.clearInterface(),!0)}prepareToResume(){if(!this.pausedInternal)return null;this.pausedInternal=!1,this.clearInterface();const e=UI.Context.Context.instance().flavor(SDK.Target.Target);return e?e.model(SDK.DebuggerModel.DebuggerModel):null}longResume(){const e=this.prepareToResume();e&&(e.skipAllPausesUntilReloadOrTimeout(500),e.resume())}terminateExecution(){const e=this.prepareToResume();e&&(e.runtimeModel().terminateExecution(),e.resume())}stepOver(){const e=this.prepareToResume();return e&&e.stepOver(),!0}stepInto(){const e=this.prepareToResume();return e&&e.stepInto(),!0}stepIntoAsync(){const e=this.prepareToResume();return e&&e.scheduleStepIntoAsync(),!0}stepOut(){const e=this.prepareToResume();return e&&e.stepOut(),!0}async continueToLocation(e){const t=UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext);if(!t)return;const n=(await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(e.uiSourceCode,e.lineNumber,0)).find((e=>e.debuggerModel===t.debuggerModel));n&&this.prepareToResume()&&n.continueToLocation()}toggleBreakpointsActive(){Common.Settings.Settings.instance().moduleSetting("breakpointsActive").set(!Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get())}breakpointsActiveStateChanged(){const e=Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get();this.toggleBreakpointsActiveAction.setToggled(!e),this.sourcesViewInternal.toggleBreakpointsActiveState(e)}createDebugToolbar(){const e=new UI.Toolbar.Toolbar("scripts-debug-toolbar"),t=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.resumeWithAllPausesBlockedForMs),"largeicon-play");t.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.longResume,this);const n=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.terminateCurrentJavascriptCall),"largeicon-terminate-execution");return n.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.terminateExecution,this),e.appendToolbarItem(UI.Toolbar.Toolbar.createLongPressActionButton(this.togglePauseAction,[n,t],[])),e.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.stepOverAction)),e.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.stepIntoAction)),e.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.stepOutAction)),e.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.stepAction)),e.appendSeparator(),e.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.toggleBreakpointsActiveAction)),this.pauseOnExceptionButton=new UI.Toolbar.ToolbarToggle("","largeicon-pause-on-exceptions"),this.pauseOnExceptionButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.togglePauseOnExceptions,this),e.appendToolbarItem(this.pauseOnExceptionButton),e}createDebugToolbarDrawer(){const e=document.createElement("div");e.classList.add("scripts-debug-toolbar-drawer");const t=i18nString(UIStrings.pauseOnCaughtExceptions),n=Common.Settings.Settings.instance().moduleSetting("pauseOnCaughtException");return e.appendChild(UI.SettingsUI.createSettingCheckbox(t,n,!0)),e}appendApplicableItems(e,t,n){this.appendUISourceCodeItems(e,t,n),this.appendUISourceCodeFrameItems(e,t,n),this.appendUILocationItems(t,n),this.appendRemoteObjectItems(t,n),this.appendNetworkRequestItems(t,n)}appendUISourceCodeItems(e,t,n){if(!(n instanceof Workspace.UISourceCode.UISourceCode&&e.target))return;const i=n,a=e.target;i.project().isServiceProject()||a.isSelfOrDescendant(this.navigatorTabbedLocation.widget().element)||t.revealSection().appendItem(i18nString(UIStrings.revealInSidebar),this.handleContextMenuReveal.bind(this,i))}appendUISourceCodeFrameItems(e,t,n){n instanceof UISourceCodeFrame&&(n.uiSourceCode().contentType().isFromSourceMap()||n.textEditor.state.selection.main.empty||t.debugSection().appendAction("debugger.evaluate-selection"))}appendUILocationItems(e,t){if(!(t instanceof Workspace.UISourceCode.UILocation))return;const n=t,i=n.uiSourceCode;if(!Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().scriptsForUISourceCode(i).every((e=>e.isJavaScript())))return;if(i.contentType().hasScripts()){const t=UI.Context.Context.instance().flavor(SDK.Target.Target),a=t?t.model(SDK.DebuggerModel.DebuggerModel):null;a&&a.isPaused()&&e.debugSection().appendItem(i18nString(UIStrings.continueToHere),this.continueToLocation.bind(this,n)),this.callstackPane.appendIgnoreListURLContextMenuItems(e,i)}}handleContextMenuReveal(e){this.editorView.showBoth(),this.revealInNavigator(e)}appendRemoteObjectItems(e,t){if(!(t instanceof SDK.RemoteObject.RemoteObject))return;const n=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),i=t,a=UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext);const s="wasm"===i.type?i.subtype:"node"===i.subtype?"outerHTML":i.type;e.debugSection().appendItem(i18nString(UIStrings.storeSAsGlobalVariable,{PH1:String(s)}),(()=>SDK.ConsoleModel.ConsoleModel.instance().saveToTempVariable(a,i)));const o=e.clipboardSection(),r=Host.InspectorFrontendHost.InspectorFrontendHostInstance;if("string"===i.type)o.appendItem(i18nString(UIStrings.copyStringContents),(()=>{r.copyText(i.value)})),o.appendItem(i18nString(UIStrings.copyStringAsJSLiteral),(()=>{r.copyText(Platform.StringUtilities.formatAsJSLiteral(i.value))})),o.appendItem(i18nString(UIStrings.copyStringAsJSONLiteral),(()=>{r.copyText(JSON.stringify(i.value))}));else if(primitiveRemoteObjectTypes.has(i.type))o.appendItem(i18nString(UIStrings.copyS,{PH1:String(s)}),(()=>{r.copyText(i.description)}));else if("object"===i.type){const e=async()=>{const e=await i.callFunctionJSON(c,[{value:{subtype:i.subtype,indent:n}}]);r.copyText(e)};o.appendItem(i18nString(UIStrings.copyS,{PH1:String(s)}),e)}else"function"===i.type&&(globalThis.chii||e.debugSection().appendItem(i18nString(UIStrings.showFunctionDefinition),this.showFunctionDefinition.bind(this,i)));function c(e){const t=e.subtype,n=e.indent;if("node"===t)return this instanceof Element?this.outerHTML:void 0;if(t&&void 0===this)return String(t);try{return JSON.stringify(this,null,n)}catch(e){return String(this)}}}appendNetworkRequestItems(e,t){if(!(t instanceof SDK.NetworkRequest.NetworkRequest))return;const n=t,i=this.workspace.uiSourceCodeForURL(n.url());if(!i)return;const a=i18nString(UIStrings.openInSourcesPanel),s=this.showUILocation.bind(this,i.uiLocation(0,0));e.revealSection().appendItem(a,s)}showFunctionDefinition(e){e.debuggerModel().functionDetailsPromise(e).then(this.didGetFunctionDetails.bind(this))}async didGetFunctionDetails(e){if(!e||!e.location)return;const t=await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.location);t&&this.showUILocation(t)}revealNavigatorSidebar(){this.setAsCurrentPanel(),this.editorView.showBoth(!0)}revealDebuggerSidebar(){Common.Settings.Settings.instance().moduleSetting("autoFocusOnDebuggerPausedEnabled").get()&&(this.setAsCurrentPanel(),this.splitWidget.showBoth(!0))}updateSidebarPosition(){let e;const t=Common.Settings.Settings.instance().moduleSetting("sidebarPosition").get();if(e="right"!==t&&("bottom"===t||UI.InspectorView.InspectorView.instance().element.offsetWidth<680),this.sidebarPaneView&&e===!this.splitWidget.isVertical())return;if(this.sidebarPaneView&&this.sidebarPaneView.shouldHideOnDetach())return;this.sidebarPaneView&&this.sidebarPaneView.detach(),this.splitWidget.setVertical(!e),this.splitWidget.element.classList.toggle("sources-split-view-vertical",e),SourcesPanel.updateResizerAndSidebarButtons(this);const n=new UI.Widget.VBox;n.element.appendChild(this.debugToolbar.element),n.element.appendChild(this.debugToolbarDrawer),n.setMinimumAndPreferredSizes(minToolbarWidth,25,minToolbarWidth,100),this.sidebarPaneStack=UI.ViewManager.ViewManager.instance().createStackLocation(this.revealDebuggerSidebar.bind(this)),this.sidebarPaneStack.widget().element.classList.add("overflow-auto"),this.sidebarPaneStack.widget().show(n.element),this.sidebarPaneStack.widget().element.appendChild(this.debuggerPausedMessage.element()),this.sidebarPaneStack.appendApplicableItems("sources.sidebar-top"),this.threadsSidebarPane&&this.sidebarPaneStack.showView(this.threadsSidebarPane);const i=UI.ViewManager.ViewManager.instance().view("sources.jsBreakpoints"),a=UI.ViewManager.ViewManager.instance().view("sources.scopeChain");if(this.tabbedLocationHeader&&(this.splitWidget.uninstallResizer(this.tabbedLocationHeader),this.tabbedLocationHeader=null),e){const e=new UI.SplitWidget.SplitWidget(!0,!0,"sourcesPanelDebuggerSidebarSplitViewState",.5);e.setMainWidget(n),this.sidebarPaneStack.showView(i),this.sidebarPaneStack.showView(this.callstackPane);const t=UI.ViewManager.ViewManager.instance().createTabbedLocation(this.revealDebuggerSidebar.bind(this));e.setSidebarWidget(t.tabbedPane()),this.tabbedLocationHeader=t.tabbedPane().headerElement(),this.splitWidget.installResizer(this.tabbedLocationHeader),this.splitWidget.installResizer(this.debugToolbar.gripElementForResize()),t.appendView(a),t.appendView(this.watchSidebarPane),t.appendApplicableItems("sources.sidebar-tabs"),this.extensionSidebarPanesContainer=t,this.sidebarPaneView=e}else this.sidebarPaneStack.appendView(this.watchSidebarPane),this.sidebarPaneStack.showView(i),this.sidebarPaneStack.showView(a),this.sidebarPaneStack.showView(this.callstackPane),this.extensionSidebarPanesContainer=this.sidebarPaneStack,this.sidebarPaneView=n,this.splitWidget.uninstallResizer(this.debugToolbar.gripElementForResize());this.sidebarPaneStack.appendApplicableItems("sources.sidebar-bottom");const s=Extensions.ExtensionServer.ExtensionServer.instance().sidebarPanes();for(let e=0;e<s.length;++e)this.addExtensionSidebarPane(s[e]);this.splitWidget.setSidebarWidget(this.sidebarPaneView)}setAsCurrentPanel(){return UI.ViewManager.ViewManager.instance().showView("sources")}extensionSidebarPaneAdded(e){this.addExtensionSidebarPane(e.data)}addExtensionSidebarPane(e){e.panelName()===this.name&&this.extensionSidebarPanesContainer.appendView(e)}sourcesView(){return this.sourcesViewInternal}handleDrop(e){const t=e.items;if(!t.length)return;const n=t[0].webkitGetAsEntry();n&&n.isDirectory&&Host.InspectorFrontendHost.InspectorFrontendHostInstance.upgradeDraggedFileSystemPermissions(n.filesystem)}}export let lastModificationTimeout=200;export const minToolbarWidth=215;export class UILocationRevealer{static instance(e={forceNew:null}){const{forceNew:t}=e;return uILocationRevealerInstance&&!t||(uILocationRevealerInstance=new UILocationRevealer),uILocationRevealerInstance}reveal(e,t){return e instanceof Workspace.UISourceCode.UILocation?(SourcesPanel.instance().showUILocation(e,t),Promise.resolve()):Promise.reject(new Error("Internal error: not a ui location"))}}export class DebuggerLocationRevealer{static instance(e={forceNew:null}){const{forceNew:t}=e;return debuggerLocationRevealerInstance&&!t||(debuggerLocationRevealerInstance=new DebuggerLocationRevealer),debuggerLocationRevealerInstance}async reveal(e,t){if(!(e instanceof SDK.DebuggerModel.Location))throw new Error("Internal error: not a debugger location");const n=await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e);n&&SourcesPanel.instance().showUILocation(n,t)}}export class UISourceCodeRevealer{static instance(e={forceNew:null}){const{forceNew:t}=e;return uISourceCodeRevealerInstance&&!t||(uISourceCodeRevealerInstance=new UISourceCodeRevealer),uISourceCodeRevealerInstance}reveal(e,t){return e instanceof Workspace.UISourceCode.UISourceCode?(SourcesPanel.instance().showUISourceCode(e,void 0,void 0,t),Promise.resolve()):Promise.reject(new Error("Internal error: not a ui source code"))}}export class DebuggerPausedDetailsRevealer{static instance(e={forceNew:null}){const{forceNew:t}=e;return debuggerPausedDetailsRevealerInstance&&!t||(debuggerPausedDetailsRevealerInstance=new DebuggerPausedDetailsRevealer),debuggerPausedDetailsRevealerInstance}reveal(e){return Common.Settings.Settings.instance().moduleSetting("autoFocusOnDebuggerPausedEnabled").get()?SourcesPanel.instance().setAsCurrentPanel():Promise.resolve()}}export class RevealingActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return revealingActionDelegateInstance&&!t||(revealingActionDelegateInstance=new RevealingActionDelegate),revealingActionDelegateInstance}handleAction(e,t){const n=SourcesPanel.instance();if(!n.ensureSourcesViewVisible())return!1;if("debugger.toggle-pause"===t){return e.flavor(UI.ShortcutRegistry.ForwardedShortcut)&&!Common.Settings.Settings.instance().moduleSetting("disablePausedStateOverlay").get()||n.togglePause(),!0}return!1}}export class DebuggingActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return debuggingActionDelegateInstance&&!t||(debuggingActionDelegateInstance=new DebuggingActionDelegate),debuggingActionDelegateInstance}handleAction(e,t){const n=SourcesPanel.instance();switch(t){case"debugger.step-over":return n.stepOver(),!0;case"debugger.step-into":return n.stepIntoAsync(),!0;case"debugger.step":return n.stepInto(),!0;case"debugger.step-out":return n.stepOut(),!0;case"debugger.run-snippet":return n.runSnippet(),!0;case"debugger.toggle-breakpoints-active":return n.toggleBreakpointsActive(),!0;case"debugger.evaluate-selection":{const e=UI.Context.Context.instance().flavor(UISourceCodeFrame);if(e){const{state:t}=e.textEditor;let n=t.sliceDoc(t.selection.main.from,t.selection.main.to);const i=UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext);if(i){const e=SDK.ConsoleModel.ConsoleModel.instance().addCommandMessage(i,n);n=ObjectUI.JavaScriptREPL.JavaScriptREPL.wrapObjectLiteral(n),SDK.ConsoleModel.ConsoleModel.instance().evaluateCommandInConsole(i,e,n,!0)}}return!0}}return!1}}export class WrapperView extends UI.Widget.VBox{view;constructor(){super(),this.element.classList.add("sources-view-wrapper"),this.view=SourcesPanel.instance().sourcesView()}static instance(){return wrapperViewInstance||(wrapperViewInstance=new WrapperView),wrapperViewInstance}static isShowing(){return Boolean(wrapperViewInstance)&&wrapperViewInstance.isShowing()}wasShown(){SourcesPanel.instance().isShowing()?UI.InspectorView.InspectorView.instance().setDrawerMinimized(!0):this.showViewInWrapper(),SourcesPanel.updateResizerAndSidebarButtons(SourcesPanel.instance())}willHide(){UI.InspectorView.InspectorView.instance().setDrawerMinimized(!1),queueMicrotask((()=>{SourcesPanel.updateResizerAndSidebarButtons(SourcesPanel.instance())}))}showViewInWrapper(){this.view.show(this.element)}}const registeredNavigatorViews=[{viewId:"navigator-network",navigatorView:NetworkNavigatorView.instance,experiment:void 0},{viewId:"navigator-files",navigatorView:FilesNavigatorView.instance,experiment:void 0},{viewId:"navigator-snippets",navigatorView:SnippetsNavigatorView.instance,experiment:void 0},{viewId:"navigator-overrides",navigatorView:OverridesNavigatorView.instance,experiment:void 0},{viewId:"navigator-contentScripts",navigatorView:ContentScriptsNavigatorView.instance,experiment:void 0}];