const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (C) 2006, 2007, 2008 Apple Inc.  All rights reserved.\n * Copyright (C) 2009 Anthony Ricaud <rik@webkit.org>\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions\n * are met:\n *\n * 1.  Redistributions of source code must retain the above copyright\n *     notice, this list of conditions and the following disclaimer.\n * 2.  Redistributions in binary form must reproduce the above copyright\n *     notice, this list of conditions and the following disclaimer in the\n *     documentation and/or other materials provided with the distribution.\n * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of\n *     its contributors may be used to endorse or promote products derived\n *     from this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY\n * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY\n * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\n * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n:host {\n  overflow-y: auto;\n}\n\n.icon,\n.icon-badge {\n  margin: -3px -5px;\n}\n\n.icon-stack {\n  position: relative;\n  display: inline-flex;\n}\n\n.icon-stack > [is="ui-icon"]:not(:first-child) {\n  position: absolute;\n  left: 0;\n  top: 0;\n}\n\n.tree-outline {\n  --override-folder-tree-item-color: #555;\n  --override-file-tree-item-color: hsl(0deg 0% 50%);\n  --override-sm-folder-fs-tree-fs-folder-item-color: hsl(28deg 75% 50%);\n  --override-nw-folder-tree-item-color: hsl(210deg 82% 62%);\n  --override-script-snippet-tree-item-color: hsl(48deg 70% 50%);\n  --override-stylesheet-tree-item-color: hsl(256deg 50% 50%);\n  --override-image-font-tree-item-color: hsl(109deg 33% 50%);\n}\n\n.-theme-with-dark-background .tree-outline,\n:host-context(.-theme-with-dark-background) .tree-outline {\n  --override-folder-tree-item-color: rgb(170 170 170);\n  --override-file-tree-item-color: rgb(127 127 127);\n  --override-sm-folder-fs-tree-fs-folder-item-color: rgb(223 121 32);\n  --override-nw-folder-tree-item-color: rgb(17 96 176);\n  --override-script-snippet-tree-item-color: rgb(217 181 38);\n  --override-stylesheet-tree-item-color: rgb(98 64 191);\n  --override-image-font-tree-item-color: rgb(101 170 85);\n}\n\n.navigator-file-tree-item .icon {\n  background: var(--override-file-tree-item-color);\n}\n\n.navigator-fs-tree-item:not(.has-mapped-files):not(.selected) > :not(.selection),\n.navigator-fs-folder-tree-item:not(.has-mapped-files):not(.selected) > :not(.selection) {\n  filter: grayscale(50%);\n  opacity: 50%;\n}\n\n.tree-outline li {\n  min-height: 20px;\n}\n\n.tree-outline li:hover:not(.selected) .selection {\n  display: block;\n  background-color: var(--item-hover-color);\n}\n\n.navigator-folder-tree-item .icon {\n  background-color: var(--override-folder-tree-item-color);\n}\n\n.navigator-sm-folder-tree-item .icon,\n.navigator-fs-tree-item .icon,\n.navigator-fs-folder-tree-item .icon {\n  background: var(--override-sm-folder-fs-tree-fs-folder-item-color);\n}\n\n.navigator-nw-folder-tree-item .icon {\n  background: var(--override-nw-folder-tree-item-color);\n}\n\n.navigator-sm-script-tree-item .icon,\n.navigator-script-tree-item .icon,\n.navigator-snippet-tree-item .icon {\n  background: var(--override-script-snippet-tree-item-color);\n}\n\n.navigator-sm-stylesheet-tree-item .icon,\n.navigator-stylesheet-tree-item .icon {\n  background: var(--override-stylesheet-tree-item-color);\n}\n\n.navigator-image-tree-item .icon,\n.navigator-font-tree-item .icon {\n  background: var(--override-image-font-tree-item-color);\n}\n\n.navigator-sm-folder-tree-item .tree-element-title,\n.navigator-sm-script-tree-item .tree-element-title,\n.navigator-sm-stylesheet-tree-item .tree-element-title {\n  font-style: italic;\n}\n\n@media (forced-colors: active) {\n  .tree-outline li .leading-icons [is="ui-icon"].icon-mask {\n    background: ButtonText;\n  }\n\n  .tree-outline li:hover:not(.selected) .selection {\n    forced-color-adjust: none;\n    background-color: Highlight;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) li.parent:hover:not(.selected)::before,\n  .tree-outline:not(.hide-selection-when-blurred) li:hover:not(.selected) [is="ui-icon"].icon-mask {\n    background-color: HighlightText;\n  }\n\n  .tree-outline li:not(.selected):hover .tree-element-title {\n    forced-color-adjust: none;\n    color: HighlightText;\n  }\n}\n\n/*# sourceURL=navigatorTree.css */\n');export default styles;