import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Extensions from"../../models/extensions/extensions.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import{ExtensionTracingSession}from"./ExtensionTracingSession.js";import{PerformanceModel}from"./PerformanceModel.js";const UIStrings={cpuProfileForATargetIsNot:"CPU profile for a target is not available.",tracingNotSupported:"Performance trace recording not supported for this type of target"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineController.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineController{target;tracingManager;performanceModel;client;tracingModel;extensionSessions;extensionTraceProviders;tracingCompleteCallback;profiling;cpuProfiles;constructor(e,i){this.target=e,this.tracingManager=e.model(SDK.TracingManager.TracingManager),this.performanceModel=new PerformanceModel,this.performanceModel.setMainTarget(e),this.client=i;const t=new Bindings.TempFile.TempFileBackingStorage;this.tracingModel=new SDK.TracingModel.TracingModel(t),this.extensionSessions=[],SDK.TargetManager.TargetManager.instance().observeModels(SDK.CPUProfilerModel.CPUProfilerModel,this)}dispose(){SDK.TargetManager.TargetManager.instance().unobserveModels(SDK.CPUProfilerModel.CPUProfilerModel,this)}mainTarget(){return this.target}async startRecording(e,i){function t(e){return"disabled-by-default-"+e}this.extensionTraceProviders=Extensions.ExtensionServer.ExtensionServer.instance().traceProviders().slice();const r=["-*","devtools.timeline",t("devtools.timeline"),t("devtools.timeline.frame"),"v8.execute",t("v8.compile"),TimelineModel.TimelineModel.TimelineModelImpl.Category.Console,TimelineModel.TimelineModel.TimelineModelImpl.Category.UserTiming,TimelineModel.TimelineModel.TimelineModelImpl.Category.Loading];r.push(TimelineModel.TimelineModel.TimelineModelImpl.Category.LatencyInfo),Root.Runtime.experiments.isEnabled("timelineV8RuntimeCallStats")&&e.enableJSSampling&&r.push(t("v8.runtime_stats_sampling")),!Root.Runtime.Runtime.queryParam("timelineTracingJSProfileDisabled")&&e.enableJSSampling&&r.push(t("v8.cpu_profiler")),r.push(t("devtools.timeline.stack")),Root.Runtime.experiments.isEnabled("timelineInvalidationTracking")&&r.push(t("devtools.timeline.invalidationTracking")),e.capturePictures&&r.push(t("devtools.timeline.layers"),t("devtools.timeline.picture"),t("blink.graphics_context_annotations")),e.captureFilmStrip&&r.push(t("devtools.screenshot")),this.extensionSessions=i.map((e=>new ExtensionTracingSession(e,this.performanceModel))),this.extensionSessions.forEach((e=>e.start())),this.performanceModel.setRecordStartTime(Date.now());const o=await this.startRecordingWithCategories(r.join(","),e.enableJSSampling);return o.getError()&&(await this.waitForTracingToStop(!1),await SDK.TargetManager.TargetManager.instance().resumeAllTargets()),o}async stopRecording(){return this.tracingManager&&this.tracingManager.stop(),this.client.loadingStarted(),await this.waitForTracingToStop(!0),this.allSourcesFinished(),this.performanceModel}async waitForTracingToStop(e){const i=[];this.tracingManager&&e&&i.push(new Promise((e=>{this.tracingCompleteCallback=e}))),i.push(this.stopProfilingOnAllModels());const t=this.extensionSessions.map((e=>e.stop()));t.length&&i.push(Promise.race([Promise.all(t),new Promise((e=>setTimeout(e,5e3)))])),await Promise.all(i)}modelAdded(e){this.profiling&&e.startRecording()}modelRemoved(e){}async startProfilingOnAllModels(){this.profiling=!0;const e=SDK.TargetManager.TargetManager.instance().models(SDK.CPUProfilerModel.CPUProfilerModel);await Promise.all(e.map((e=>e.startRecording())))}addCpuProfile(e,i){i?(this.cpuProfiles||(this.cpuProfiles=new Map),this.cpuProfiles.set(e,i)):Common.Console.Console.instance().warn(i18nString(UIStrings.cpuProfileForATargetIsNot))}async stopProfilingOnAllModels(){const e=this.profiling?SDK.TargetManager.TargetManager.instance().models(SDK.CPUProfilerModel.CPUProfilerModel):[];this.profiling=!1;const i=[];for(const t of e){const e=t.target().id(),r=t.stopRecording().then(this.addCpuProfile.bind(this,e));i.push(r)}await Promise.all(i)}async startRecordingWithCategories(e,i){if(!this.tracingManager)throw new Error(UIStrings.tracingNotSupported);return await SDK.TargetManager.TargetManager.instance().suspendAllTargets("performance-timeline"),i&&Root.Runtime.Runtime.queryParam("timelineTracingJSProfileDisabled")&&await this.startProfilingOnAllModels(),this.tracingManager.start(this,e,"")}traceEventsCollected(e){this.tracingModel.addEvents(e)}tracingComplete(){this.tracingCompleteCallback&&(this.tracingCompleteCallback(void 0),this.tracingCompleteCallback=null)}allSourcesFinished(){this.client.processingStarted(),setTimeout((()=>this.finalizeTrace()),0)}async finalizeTrace(){this.injectCpuProfileEvents(),await SDK.TargetManager.TargetManager.instance().resumeAllTargets(),this.tracingModel.tracingComplete(),this.client.loadingComplete(this.tracingModel)}injectCpuProfileEvent(e,i,t){if(!t)return;const r={cat:SDK.TracingModel.DevToolsMetadataEventCategory,ph:SDK.TracingModel.Phase.Instant,ts:1e3*this.tracingModel.maximumRecordTime(),pid:e,tid:i,name:TimelineModel.TimelineModel.RecordType.CpuProfile,args:{data:{cpuProfile:t}}};this.tracingModel.addEvents([r])}buildTargetToProcessIdMap(){const e=TimelineModel.TimelineModel.TimelineModelImpl.DevToolsMetadataEvent,i=this.tracingModel.devToolsMetadataEvents(),t=i.find((i=>i.name===e.TracingStartedInBrowser));if(!t)return null;const r=new Platform.MapUtilities.Multimap,o=new Map,n=t.args.data.frames;for(const e of n)o.set(e.frame,e.processId);for(const t of i){const i=t.args.data;switch(t.name){case e.FrameCommittedInBrowser:i.processId?o.set(i.frame,i.processId):r.set(i.processPseudoId,i.frame);break;case e.ProcessReadyInBrowser:for(const e of r.get(i.processPseudoId)||[])o.set(e,i.processId)}}const s=n.find((e=>!e.parent)).processId,a=this.tracingModel.getProcessById(s);if(a){const e=SDK.TargetManager.TargetManager.instance().mainTarget();e&&o.set(e.id(),a.id())}return o}injectCpuProfileEvents(){if(!this.cpuProfiles)return;const e=TimelineModel.TimelineModel.TimelineModelImpl.DevToolsMetadataEvent,i=this.tracingModel.devToolsMetadataEvents(),t=this.buildTargetToProcessIdMap();if(t)for(const[e,i]of this.cpuProfiles){const r=t.get(e);if(!r)continue;const o=this.tracingModel.getProcessById(r),n=o&&o.threadByName(TimelineModel.TimelineModel.TimelineModelImpl.RendererMainThreadName);n&&this.injectCpuProfileEvent(r,n.id(),i)}else{const t=i.filter((i=>i.name===e.TracingStartedInPage)),r=t[t.length-1];if(r){const e=r.thread.process().id();if(this.tracingManager){const i=this.cpuProfiles.get(this.tracingManager.target().id());this.injectCpuProfileEvent(e,r.thread.id(),i)}}else{let e=0;for(const i of this.cpuProfiles){const t=SDK.TargetManager.TargetManager.instance().targetById(i[0]),r=t&&t.name();this.tracingModel.addEvents(TimelineModel.TimelineJSProfile.TimelineJSProfileProcessor.buildTraceProfileFromCpuProfile(i[1],++e,1===e,r))}}}const r=i.filter((i=>i.name===e.TracingSessionIdForWorker));for(const e of r){const i=e.args.data.workerId,t=this.cpuProfiles.get(i);this.injectCpuProfileEvent(e.thread.process().id(),e.args.data.workerThreadId,t)}this.cpuProfiles=null}tracingBufferUsage(e){this.client.recordingProgress(e)}eventsRetrievalProgress(e){this.client.loadingProgress(e)}}