import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import{EventsTimelineTreeView}from"./EventsTimelineTreeView.js";import{Events}from"./PerformanceModel.js";import{TimelineLayersView}from"./TimelineLayersView.js";import{TimelinePaintProfilerView}from"./TimelinePaintProfilerView.js";import{TimelineSelection}from"./TimelinePanel.js";import{BottomUpTimelineTreeView,CallTreeTimelineTreeView}from"./TimelineTreeView.js";import{TimelineDetailsContentHelper,TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={summary:"Summary",bottomup:"Bottom-Up",callTree:"Call Tree",eventLog:"Event Log",estimated:"estimated",totalBlockingTimeSmss:"Total blocking time: {PH1}ms{PH2}",learnMore:"Learn more",layers:"Layers",paintProfiler:"Paint Profiler",rangeSS:"Range:  {PH1} – {PH2}"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineDetailsView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineDetailsView extends UI.Widget.VBox{detailsLinkifier;tabbedPane;defaultDetailsWidget;defaultDetailsContentElement;rangeDetailViews;additionalMetricsToolbar;model;track;lazyPaintProfilerView;lazyLayersView;preferredTabId;selection;constructor(e){super(),this.element.classList.add("timeline-details"),this.detailsLinkifier=new Components.Linkifier.Linkifier,this.tabbedPane=new UI.TabbedPane.TabbedPane,this.tabbedPane.show(this.element),this.defaultDetailsWidget=new UI.Widget.VBox,this.defaultDetailsWidget.element.classList.add("timeline-details-view"),this.defaultDetailsContentElement=this.defaultDetailsWidget.element.createChild("div","timeline-details-view-body vbox"),this.appendTab(Tab.Details,i18nString(UIStrings.summary),this.defaultDetailsWidget),this.setPreferredTab(Tab.Details),this.rangeDetailViews=new Map;const i=new BottomUpTimelineTreeView;this.appendTab(Tab.BottomUp,i18nString(UIStrings.bottomup),i),this.rangeDetailViews.set(Tab.BottomUp,i);const t=new CallTreeTimelineTreeView;this.appendTab(Tab.CallTree,i18nString(UIStrings.callTree),t),this.rangeDetailViews.set(Tab.CallTree,t);const n=new EventsTimelineTreeView(e);this.appendTab(Tab.EventLog,i18nString(UIStrings.eventLog),n),this.rangeDetailViews.set(Tab.EventLog,n),this.additionalMetricsToolbar=new UI.Toolbar.Toolbar("timeline-additional-metrics"),this.element.appendChild(this.additionalMetricsToolbar.element),this.tabbedPane.addEventListener(UI.TabbedPane.Events.TabSelected,this.tabSelected,this)}setModel(e,i){this.model!==e&&(this.model&&this.model.removeEventListener(Events.WindowChanged,this.onWindowChanged,this),this.model=e,this.model&&this.model.addEventListener(Events.WindowChanged,this.onWindowChanged,this)),this.track=i,this.tabbedPane.closeTabs([Tab.PaintProfiler,Tab.LayerViewer],!1);for(const t of this.rangeDetailViews.values())t.setModel(e,i);if(this.lazyPaintProfilerView=null,this.lazyLayersView=null,this.setSelection(null),this.additionalMetricsToolbar.removeToolbarItems(),e&&e.timelineModel()){const{estimated:i,time:t}=e.timelineModel().totalBlockingTime(),n=i?` (${i18nString(UIStrings.estimated)})`:"",a=i18nString(UIStrings.totalBlockingTimeSmss,{PH1:t.toFixed(2),PH2:n}),s=document.createElement("span"),l=UI.XLink.XLink.create("https://web.dev/tbt/",i18nString(UIStrings.learnMore));l.style.marginRight="2px",s.appendChild(l),this.additionalMetricsToolbar.appendText(a),this.additionalMetricsToolbar.appendToolbarItem(new UI.Toolbar.ToolbarItem(s))}}setContent(e){const i=this.tabbedPane.otherTabs(Tab.Details);for(let e=0;e<i.length;++e)this.rangeDetailViews.has(i[e])||this.tabbedPane.closeTab(i[e]);this.defaultDetailsContentElement.removeChildren(),this.defaultDetailsContentElement.appendChild(e)}updateContents(){const e=this.rangeDetailViews.get(this.tabbedPane.selectedTabId||"");if(e){const i=this.model.window();e.updateContents(this.selection||TimelineSelection.fromRange(i.left,i.right))}}appendTab(e,i,t,n){this.tabbedPane.appendTab(e,i,t,void 0,void 0,n),this.preferredTabId!==this.tabbedPane.selectedTabId&&this.tabbedPane.selectTab(e)}headerElement(){return this.tabbedPane.headerElement()}setPreferredTab(e){this.preferredTabId=e}onWindowChanged(){this.selection||this.updateContentsFromWindow()}updateContentsFromWindow(){if(!this.model)return void this.setContent(UI.Fragment.html`<div/>`);const e=this.model.window();this.updateSelectedRangeStats(e.left,e.right),this.updateContents()}setSelection(e){if(this.detailsLinkifier.reset(),this.selection=e,this.selection){switch(this.selection.type()){case TimelineSelection.Type.TraceEvent:{const e=this.selection.object();TimelineUIUtils.buildTraceEventDetails(e,this.model.timelineModel(),this.detailsLinkifier,!0).then((i=>this.appendDetailsTabsForTraceEventAndShowDetails(e,i)));break}case TimelineSelection.Type.Frame:{const e=this.selection.object(),i=this.model.filmStripModelFrame(e);if(this.setContent(TimelineUIUtils.generateDetailsContentForFrame(e,i)),e.layerTree){const i=this.layersView();i.showLayerTree(e.layerTree),this.tabbedPane.hasTab(Tab.LayerViewer)||this.appendTab(Tab.LayerViewer,i18nString(UIStrings.layers),i)}break}case TimelineSelection.Type.NetworkRequest:{const e=this.selection.object();TimelineUIUtils.buildNetworkRequestDetails(e,this.model.timelineModel(),this.detailsLinkifier).then(this.setContent.bind(this));break}case TimelineSelection.Type.Range:this.updateSelectedRangeStats(this.selection.startTime(),this.selection.endTime())}this.updateContents()}else this.updateContentsFromWindow()}tabSelected(e){e.data.isUserGesture&&(this.setPreferredTab(e.data.tabId),this.updateContents())}layersView(){return this.lazyLayersView||(this.lazyLayersView=new TimelineLayersView(this.model.timelineModel(),this.showSnapshotInPaintProfiler.bind(this))),this.lazyLayersView}paintProfilerView(){return this.lazyPaintProfilerView||(this.lazyPaintProfilerView=new TimelinePaintProfilerView(this.model.frameModel())),this.lazyPaintProfilerView}showSnapshotInPaintProfiler(e){const i=this.paintProfilerView();i.setSnapshot(e),this.tabbedPane.hasTab(Tab.PaintProfiler)||this.appendTab(Tab.PaintProfiler,i18nString(UIStrings.paintProfiler),i,!0),this.tabbedPane.selectTab(Tab.PaintProfiler,!0)}appendDetailsTabsForTraceEventAndShowDetails(e,i){this.setContent(i),e.name!==TimelineModel.TimelineModel.RecordType.Paint&&e.name!==TimelineModel.TimelineModel.RecordType.RasterTask||this.showEventInPaintProfiler(e)}showEventInPaintProfiler(e){const i=SDK.TargetManager.TargetManager.instance().models(SDK.PaintProfiler.PaintProfilerModel)[0];if(!i)return;const t=this.paintProfilerView();t.setEvent(i,e)&&(this.tabbedPane.hasTab(Tab.PaintProfiler)||this.appendTab(Tab.PaintProfiler,i18nString(UIStrings.paintProfiler),t))}updateSelectedRangeStats(e,i){if(!this.model||!this.track)return;const t=TimelineUIUtils.statsForTimeRange(this.track.syncEvents(),e,i),n=e-this.model.timelineModel().minimumRecordTime(),a=i-this.model.timelineModel().minimumRecordTime(),s=new TimelineDetailsContentHelper(null,null);s.addSection(i18nString(UIStrings.rangeSS,{PH1:i18n.TimeUtilities.millisToString(n),PH2:i18n.TimeUtilities.millisToString(a)}));const l=TimelineUIUtils.generatePieChart(t);s.appendElementRow("",l),this.setContent(s.fragment)}}export var Tab;!function(e){e.Details="Details",e.EventLog="EventLog",e.CallTree="CallTree",e.BottomUp="BottomUp",e.PaintProfiler="PaintProfiler",e.LayerViewer="LayerViewer"}(Tab||(Tab={}));