import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as UI from"../../ui/legacy/legacy.js";import*as Coverage from"../coverage/coverage.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={net:"NET",cpu:"CPU",fps:"FPS",heap:"HEAP",sSDash:"{PH1} – {PH2}",coverage:"COVERAGE"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineEventOverview.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineEventOverview extends PerfUI.TimelineOverviewPane.TimelineOverviewBase{model;constructor(e,t){super(),this.element.id="timeline-overview-"+e,this.element.classList.add("overview-strip"),this.model=null,t&&(this.element.createChild("div","timeline-overview-strip-title").textContent=t)}setModel(e){this.model=e}renderBar(e,t,i,n,o){const s=e,r=t-e,l=this.context();l.fillStyle=o,l.fillRect(s,i,r,n)}}export class TimelineEventOverviewInput extends TimelineEventOverview{constructor(){super("input",null)}update(){if(super.update(),!this.model)return;const e=this.height(),t=TimelineUIUtils.eventDispatchDesciptors(),i=new Map;let n=-1;for(const e of t){for(const t of e.eventTypes)i.set(t,e);n=Math.max(n,e.priority)}const o=2*window.devicePixelRatio,s=this.model.timelineModel().minimumRecordTime(),r=this.model.timelineModel().maximumRecordTime()-s,l=this.width(),a=l/r;for(let t=0;t<=n;++t)for(const n of this.model.timelineModel().tracks())for(let r=0;r<n.events.length;++r){const m=n.events[r];if(m.name!==TimelineModel.TimelineModel.RecordType.EventDispatch)continue;const d=i.get(m.args.data.type);if(!d||d.priority!==t)continue;if(void 0===m.endTime)continue;const h=Platform.NumberUtilities.clamp(Math.floor((m.startTime-s)*a),0,l),c=Platform.NumberUtilities.clamp(Math.ceil((m.endTime-s)*a),0,l),u=Math.max(c-h,o);this.renderBar(h,h+u,0,e,d.color)}}}export class TimelineEventOverviewNetwork extends TimelineEventOverview{constructor(){super("network",i18nString(UIStrings.net))}update(){if(super.update(),!this.model)return;const e=this.model.timelineModel(),t=this.height()/2,i=e.minimumRecordTime(),n=e.maximumRecordTime()-i,o=this.width(),s=o/n,r=new Path2D,l=new Path2D,a=new Set(["VeryHigh","High","Medium"]);for(const n of e.networkRequests()){const e=a.has(n.priority)?r:l,m=Math.max(Math.floor((n.startTime-i)*s),0),d=Math.min(Math.ceil((n.endTime-i)*s+1),o);e.rect(m,0,d-m,t-1)}const m=this.context();m.save(),m.fillStyle="hsl(214, 60%, 60%)",m.fill(r),m.translate(0,t),m.fillStyle="hsl(214, 80%, 80%)",m.fill(l),m.restore()}}const categoryToIndex=new WeakMap;export class TimelineEventOverviewCPUActivity extends TimelineEventOverview{backgroundCanvas;constructor(){super("cpu-activity",i18nString(UIStrings.cpu)),this.backgroundCanvas=this.element.createChild("canvas","fill background")}resetCanvas(){super.resetCanvas(),this.backgroundCanvas.width=this.element.clientWidth*window.devicePixelRatio,this.backgroundCanvas.height=this.element.clientHeight*window.devicePixelRatio}update(){if(super.update(),!this.model)return;const e=this.model.timelineModel(),t=4*window.devicePixelRatio,i=this.width(),n=this.height(),o=n,s=e.minimumRecordTime(),r=e.maximumRecordTime()-s,l=t/(i/r),a=TimelineUIUtils.categories(),m=TimelineUIUtils.getTimelineMainEventCategories(),d=m.indexOf("other");console.assert(0===m.indexOf("idle"));for(let e=1;e<m.length;++e)categoryToIndex.set(a[m[e]],e);const h=this.backgroundCanvas.getContext("2d");if(!h)throw new Error("Could not find 2d canvas");for(const t of e.tracks())t.type===TimelineModel.TimelineModel.TrackType.MainThread&&t.forMainFrame?c(this.context(),t.events):c(h,t.events);function c(e,h){const c=new Quantizer(s,l,(function(e){let i=o;for(let o=1;o<m.length;++o){const s=(e[o]||0)/l*n;i-=s,f[o].bezierCurveTo(u,p[o],u,i,u+t/2,i),p[o]=i}u+=t}));let u=0;const v=[],f=[],p=[];for(let e=0;e<m.length;++e)f[e]=new Path2D,f[e].moveTo(0,n),p[e]=n;TimelineModel.TimelineModel.TimelineModelImpl.forEachEvent(h,(function(e){const t=v.length?v[v.length-1]:0;c.appendInterval(e.startTime,t),v.push(categoryToIndex.get(TimelineUIUtils.eventStyle(e).category)||d)}),(function(e){const t=v.pop();void 0!==e.endTime&&t&&c.appendInterval(e.endTime,t)})),c.appendInterval(s+r+l,0);for(let t=m.length-1;t>0;--t)f[t].lineTo(i,n),e.fillStyle=a[m[t]].color,e.fill(f[t])}!function(e){const t=4*window.devicePixelRatio;e.save(),e.lineWidth=t/Math.sqrt(8);for(let o=.5;o<i+n;o+=t)e.moveTo(o,0),e.lineTo(o-n,n);e.globalCompositeOperation="destination-out",e.stroke(),e.restore()}(h)}}export class TimelineEventOverviewResponsiveness extends TimelineEventOverview{constructor(){super("responsiveness",null)}update(){if(super.update(),!this.model)return;const e=this.height(),t=this.model.timelineModel().minimumRecordTime(),i=this.model.timelineModel().maximumRecordTime()-t,n=this.width()/i,o=this.model.frames(),s=this.context(),r=new Path2D,l=new Path2D;for(let e=0;e<o.length;++e){const t=o[e];t.hasWarnings()&&a(t.startTime,t.duration)}for(const e of this.model.timelineModel().tracks()){const t=e.events;for(let e=0;e<t.length;++e){if(!TimelineModel.TimelineModel.TimelineData.forEvent(t[e]).warning)continue;const i=t[e].duration;void 0!==i&&a(t[e].startTime,i)}}function a(i,o){const s=Math.round(n*(i-t)),a=Math.round(n*o);r.rect(s,0,a,e),l.moveTo(s+a,0),l.lineTo(s+a,e)}s.fillStyle="hsl(0, 80%, 90%)",s.strokeStyle="red",s.lineWidth=2*window.devicePixelRatio,s.fill(r),s.stroke(l)}}export class TimelineFilmStripOverview extends TimelineEventOverview{frameToImagePromise;lastFrame;lastElement;drawGeneration;emptyImage;imageWidth;constructor(){super("filmstrip",null),this.frameToImagePromise=new Map,this.lastFrame=null,this.lastElement=null,this.reset()}update(){super.update();const e=this.model?this.model.filmStripModel().frames():[];if(!e.length)return;const t=Symbol("drawGeneration");this.drawGeneration=t,this.imageByFrame(e[0]).then((e=>{if(this.drawGeneration!==t)return;if(!e||!e.naturalWidth||!e.naturalHeight)return;const i=this.height()-2*TimelineFilmStripOverview.Padding,n=Math.ceil(i*e.naturalWidth/e.naturalHeight),o=Math.min(200/e.naturalWidth,1);this.emptyImage=new Image(e.naturalWidth*o,e.naturalHeight*o),this.drawFrames(n,i)}))}async imageByFrame(e){let t=this.frameToImagePromise.get(e);if(!t){const i=await e.imageDataPromise();t=UI.UIUtils.loadImageFromData(i),this.frameToImagePromise.set(e,t)}return t}drawFrames(e,t){if(!e||!this.model)return;const i=this.model.filmStripModel();if(!i.frames().length)return;const n=TimelineFilmStripOverview.Padding,o=this.width(),s=i.zeroTime(),r=i.spanTime()/o,l=this.context(),a=this.drawGeneration;l.beginPath();for(let a=n;a<o;a+=e+2*n){const n=s+(a+e/2)*r,o=i.frameByTimestamp(n);o&&(l.rect(a-.5,.5,e+1,t+1),this.imageByFrame(o).then(m.bind(this,a)))}function m(i,n){this.drawGeneration===a&&n&&l.drawImage(n,i,1,e,t)}l.strokeStyle="#ddd",l.stroke()}async overviewInfoPromise(e){if(!this.model||!this.model.filmStripModel().frames().length)return null;const t=this.calculator();if(!t)return null;const i=t.positionToTime(e),n=this.model.filmStripModel().frameByTimestamp(i);if(n===this.lastFrame)return this.lastElement;const o=n?this.imageByFrame(n):Promise.resolve(this.emptyImage),s=await o,r=document.createElement("div");return r.classList.add("frame"),s&&r.createChild("div","thumbnail").appendChild(s),this.lastFrame=n,this.lastElement=r,r}reset(){this.lastFrame=null,this.lastElement=null,this.frameToImagePromise=new Map,this.imageWidth=0}static Padding=2}export class TimelineEventOverviewFrames extends TimelineEventOverview{constructor(){super("framerate",i18nString(UIStrings.fps))}update(){if(super.update(),!this.model)return;const e=this.model.frames();if(!e.length)return;const t=this.height(),i=Number(window.devicePixelRatio),n=t-2*i,o=this.model.timelineModel().minimumRecordTime(),s=this.model.timelineModel().maximumRecordTime()-o,r=this.width()/s,l=t-i,a=this.context(),m=l+10*window.devicePixelRatio;let d=0,h=m;const c=window.devicePixelRatio,u=1&c?.5:0,v=1.5*window.devicePixelRatio;a.beginPath(),a.moveTo(0,h);for(let t=0;t<e.length;++t){const i=e[t];d=Math.round((i.startTime-o)*r)+u,a.lineTo(d,h),a.lineTo(d,h+v),h=i.idle?m:Math.round(l-n*Math.min(16.666666666666668/i.duration,1))-u,a.lineTo(d,h+v),a.lineTo(d,h)}const f=e[e.length-1];f&&(d=Math.round((f.startTime+f.duration-o)*r)+u),a.lineTo(d,h),a.lineTo(d,m),a.fillStyle="hsl(110, 50%, 88%)",a.strokeStyle="hsl(110, 50%, 60%)",a.lineWidth=c,a.fill(),a.stroke()}}export class TimelineEventOverviewMemory extends TimelineEventOverview{heapSizeLabel;constructor(){super("memory",i18nString(UIStrings.heap)),this.heapSizeLabel=this.element.createChild("div","memory-graph-label")}resetHeapSizeLabels(){this.heapSizeLabel.textContent=""}update(){super.update();const e=window.devicePixelRatio;if(!this.model)return void this.resetHeapSizeLabels();const t=this.model.timelineModel().tracks().filter((e=>e.type===TimelineModel.TimelineModel.TrackType.MainThread&&e.forMainFrame)).map((e=>e.events)),i=3*e;let n=0,o=1e11;const s=this.model.timelineModel().minimumRecordTime(),r=this.model.timelineModel().maximumRecordTime();function l(e){return e.name===TimelineModel.TimelineModel.RecordType.UpdateCounters}for(let e=0;e<t.length;e++)t[e]=t[e].filter(l);function a(e){const t=e.args.data;t&&t.jsHeapSizeUsed&&(n=Math.max(n,t.jsHeapSizeUsed),o=Math.min(o,t.jsHeapSizeUsed))}for(let e=0;e<t.length;e++)t[e].forEach(a);o=Math.min(o,n);const m=this.width(),d=this.height()-i,h=m/(r-s),c=(d-1)/Math.max(n-o,1),u=new Array(m);function v(e){const t=e.args.data;if(!t||!t.jsHeapSizeUsed)return;const i=Math.round((e.startTime-s)*h),n=Math.round((t.jsHeapSizeUsed-o)*c);u[i]=Math.max(u[i]||0,n)}for(let e=0;e<t.length;e++)t[e].forEach(v);const f=this.context(),p=d+i+1;f.translate(.5,.5),f.beginPath(),f.moveTo(-1,p);let g=0,T=!0,w=0;for(let e=0;e<u.length;e++){if(void 0===u[e])continue;T&&(T=!1,g=u[e],f.lineTo(-1,d-g));const t=u[e];Math.abs(t-g)>2&&Math.abs(e-w)>1&&f.lineTo(e,d-g),g=t,f.lineTo(e,d-g),w=e}f.lineTo(m+1,d-g),f.lineTo(m+1,p),f.closePath(),f.fillStyle="hsla(220, 90%, 70%, 0.2)",f.fill(),f.lineWidth=1,f.strokeStyle="hsl(220, 90%, 70%)",f.stroke(),this.heapSizeLabel.textContent=i18nString(UIStrings.sSDash,{PH1:Platform.NumberUtilities.bytesToString(o),PH2:Platform.NumberUtilities.bytesToString(n)})}}export class Quantizer{lastTime;quantDuration;callback;counters;remainder;constructor(e,t,i){this.lastTime=e,this.quantDuration=t,this.callback=i,this.counters=[],this.remainder=t}appendInterval(e,t){let i=e-this.lastTime;if(i<=this.remainder)return this.counters[t]=(this.counters[t]||0)+i,this.remainder-=i,void(this.lastTime=e);for(this.counters[t]=(this.counters[t]||0)+this.remainder,this.callback(this.counters),i-=this.remainder;i>=this.quantDuration;){const e=[];e[t]=this.quantDuration,this.callback(e),i-=this.quantDuration}this.counters=[],this.counters[t]=i,this.lastTime=e,this.remainder=this.quantDuration-i}}export class TimelineEventOverviewCoverage extends TimelineEventOverview{heapSizeLabel;coverageModel;constructor(){super("coverage",i18nString(UIStrings.coverage)),this.heapSizeLabel=this.element.createChild("div","timeline-overview-coverage-label")}resetHeapSizeLabels(){this.heapSizeLabel.textContent=""}setModel(e){if(super.setModel(e),e){const t=e.mainTarget();t&&(this.coverageModel=t.model(Coverage.CoverageModel.CoverageModel))}}update(){super.update();const e=window.devicePixelRatio;if(!this.coverageModel)return;let t=0,i=0;const n=new Map,o=new Map;for(const e of this.coverageModel.entries())for(const s of e.entries()){t+=s.getSize();for(const[e,t]of s.usedByTimestamp()){i+=t;let r=o.get(e);void 0===r&&(r=new Set,o.set(e,r)),r.add(s);const l=n.get(e);void 0===l?n.set(e,t):n.set(e,l+t)}}const s=new Set,r=new Map;let l=0,a=0;const m=Array.from(o.entries()).sort(((e,t)=>e[0]-t[0]));for(const[e,t]of m){for(const e of t.values())s.has(e)||(s.add(e),l+=e.getSize());a+=n.get(e)||0,r.set(e,a/l)}const d=t?Math.round(100*i/t):0,h=3*e;if(!this.model)return;const c=this.model.timelineModel().minimumRecordTime()/1e3,u=this.model.timelineModel().maximumRecordTime()/1e3,v=this.width(),f=this.height()-h,p=v/(u-c),g=f-1;let T=0;const w=this.context(),M=f+h+1;w.translate(.5,.5),w.beginPath(),w.moveTo(-1,M),w.lineTo(-1,f-T);let S=null;for(const e of this.coverageModel.getCoverageUpdateTimes()){const t=r.get(e)||S;if(S=t,!t)continue;if(e>u)break;const i=(e-c)*p;T=t*g,w.lineTo(i,f-T)}const x="hsl(220, 90%, 70%)";w.lineTo(v+1,f-T),w.lineTo(v+1,M),w.closePath(),w.fillStyle="hsla(220, 90%, 70%, 0.2)",w.fill(),w.lineWidth=1,w.strokeStyle=x,w.stroke(),S=null;for(const e of this.coverageModel.getCoverageUpdateTimes()){const t=r.get(e)||S;if(S=t,!t)continue;w.beginPath();const i=(e-c)*p,n=f-t*g;w.arc(i,n,2,0,2*Math.PI,!1),w.closePath(),w.stroke(),w.fillStyle=r.has(e)?x:"hsl(0, 100%, 100%)",w.fill()}this.heapSizeLabel.textContent=`${d}% used`}}