import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as UI from"../../ui/legacy/legacy.js";import*as ThemeSupport from"../../ui/legacy/theme_support/theme_support.js";import timelineFlamechartPopoverStyles from"./timelineFlamechartPopover.css.js";import{FlameChartStyle,Selection,TimelineFlameChartMarker}from"./TimelineFlameChartView.js";import{TimelineSelection}from"./TimelinePanel.js";import{TimelineUIUtils,assignLayoutShiftsToClusters}from"./TimelineUIUtils.js";const UIStrings={onIgnoreList:"On ignore list",input:"Input",animation:"Animation",timings:"Timings",console:"Console",mainS:"Main — {PH1}",main:"Main",frameS:"Frame — {PH1}",subframe:"Subframe",raster:"Raster",rasterizerThreadS:"Rasterizer Thread {PH1}",gpu:"GPU",thread:"Thread",experience:"Experience",interactions:"Interactions",frames:"Frames",sSelfS:"{PH1} (self {PH2})",occurrencesS:"Occurrences: {PH1}",sFfps:"{PH1} ~ {PH2} fps",idleFrame:"Idle Frame",droppedFrame:"Dropped Frame",frame:"Frame",longFrame:"Long frame",threadS:"Thread {PH1}"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineFlameChartDataProvider.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineFlameChartDataProvider extends Common.ObjectWrapper.ObjectWrapper{font;timelineDataInternal;currentLevel;performanceModel;model;minimumBoundaryInternal;maximumBoundary;timeSpan;consoleColorGenerator;extensionColorGenerator;headerLevel1;headerLevel2;staticHeader;framesHeader;collapsibleTimingsHeader;timingsHeader;screenshotsHeader;interactionsHeaderLevel1;interactionsHeaderLevel2;experienceHeader;flowEventIndexById;entryData;entryTypeByLevel;markers;asyncColorByInteractionPhase;screenshotImageCache;extensionInfo;entryIndexToTitle;asyncColorByCategory;lastInitiatorEntry;entryParent;frameGroup;lastSelection;colorForEvent;constructor(){super(),this.reset(),this.font="11px "+Host.Platform.fontFamily(),this.timelineDataInternal=null,this.currentLevel=0,this.performanceModel=null,this.model=null,this.minimumBoundaryInternal=0,this.maximumBoundary=0,this.timeSpan=0,this.consoleColorGenerator=new Common.Color.Generator({min:30,max:55,count:void 0},{min:70,max:100,count:6},50,.7),this.extensionColorGenerator=new Common.Color.Generator({min:210,max:300,count:void 0},{min:70,max:100,count:6},70,.7),this.headerLevel1=this.buildGroupStyle({shareHeaderLine:!1}),this.headerLevel2=this.buildGroupStyle({padding:2,nestingLevel:1,collapsible:!1}),this.staticHeader=this.buildGroupStyle({collapsible:!1}),this.framesHeader=this.buildGroupStyle({useFirstLineForOverview:!0}),this.collapsibleTimingsHeader=this.buildGroupStyle({shareHeaderLine:!0,useFirstLineForOverview:!0,collapsible:!0}),this.timingsHeader=this.buildGroupStyle({shareHeaderLine:!0,useFirstLineForOverview:!0,collapsible:!1}),this.screenshotsHeader=this.buildGroupStyle({useFirstLineForOverview:!0,nestingLevel:1,collapsible:!1,itemsHeight:150}),this.interactionsHeaderLevel1=this.buildGroupStyle({useFirstLineForOverview:!0}),this.interactionsHeaderLevel2=this.buildGroupStyle({padding:2,nestingLevel:1}),this.experienceHeader=this.buildGroupStyle({collapsible:!1}),this.flowEventIndexById=new Map}buildGroupStyle(e){const t={padding:4,height:17,collapsible:!0,color:ThemeSupport.ThemeSupport.instance().patchColorText("#222",ThemeSupport.ThemeSupport.ColorUsage.Foreground),backgroundColor:ThemeSupport.ThemeSupport.instance().patchColorText("white",ThemeSupport.ThemeSupport.ColorUsage.Background),font:this.font,nestingLevel:0,shareHeaderLine:!0};return Object.assign(t,e)}setModel(e){this.reset(),this.performanceModel=e,this.model=e&&e.timelineModel()}groupTrack(e){return e.track||null}navStartTimes(){return this.model?this.model.navStartTimes():new Map}entryTitle(e){const t=EntryType,n=this.entryType(e);if(n===t.Event){const t=this.entryData[e];return t.phase===SDK.TracingModel.Phase.AsyncStepInto||t.phase===SDK.TracingModel.Phase.AsyncStepPast?t.name+":"+t.args.step:eventToDisallowRoot.get(t)?i18nString(UIStrings.onIgnoreList):this.performanceModel&&this.performanceModel.timelineModel().isMarkerEvent(t)?TimelineUIUtils.markerShortTitle(t):TimelineUIUtils.eventTitle(t)}if(n===t.ExtensionEvent){return this.entryData[e].name}if(n===t.Screenshot)return"";let i=this.entryIndexToTitle[e];return i||(i=`Unexpected entryIndex ${e}`,console.error(i)),i}textColor(e){const t=this.entryData[e];return t&&eventToDisallowRoot.get(t)?"#888":FlameChartStyle.textColor}entryFont(e){return this.font}reset(){this.currentLevel=0,this.timelineDataInternal=null,this.entryData=[],this.entryParent=[],this.entryTypeByLevel=[],this.entryIndexToTitle=[],this.markers=[],this.asyncColorByCategory=new Map,this.asyncColorByInteractionPhase=new Map,this.extensionInfo=[],this.screenshotImageCache=new Map}maxStackDepth(){return this.currentLevel}timelineData(){return this.timelineDataInternal?this.timelineDataInternal:(this.timelineDataInternal=new PerfUI.FlameChart.TimelineData([],[],[],[]),this.model?(this.flowEventIndexById.clear(),this.minimumBoundaryInternal=this.model.minimumRecordTime(),this.timeSpan=this.model.isEmpty()?1e3:this.model.maximumRecordTime()-this.minimumBoundaryInternal,this.currentLevel=0,this.model.isGenericTrace()?this.processGenericTrace():this.processInspectorTrace(),this.timelineDataInternal):this.timelineDataInternal)}processGenericTrace(){const e=this.buildGroupStyle({shareHeaderLine:!1}),t=this.buildGroupStyle({padding:2,nestingLevel:1,shareHeaderLine:!1}),n=EntryType.Event,i=new Platform.MapUtilities.Multimap;if(this.model){for(const e of this.model.tracks())null!==e.thread?i.set(e.thread.process(),e):console.error("Failed to process track");for(const r of i.keysArray()){if(i.size>1){const t=`${r.name()} ${r.id()}`;this.appendHeader(t,e,!1)}for(const e of i.get(r)){const i=this.appendSyncEvents(e,e.events,e.name,t,n,!0);!this.timelineDataInternal||this.timelineDataInternal.selectedGroup&&e.name!==TimelineModel.TimelineModel.TimelineModelImpl.BrowserMainThreadName||(this.timelineDataInternal.selectedGroup=i)}}}}processInspectorTrace(){this.appendFrames(),this.appendInteractionRecords();const e=EntryType.Event,t=e=>{switch(e.type){case TimelineModel.TimelineModel.TrackType.Input:return 0;case TimelineModel.TimelineModel.TrackType.Animation:return 1;case TimelineModel.TimelineModel.TrackType.Timings:return 2;case TimelineModel.TimelineModel.TrackType.Console:return 3;case TimelineModel.TimelineModel.TrackType.Experience:return 4;case TimelineModel.TimelineModel.TrackType.MainThread:return e.forMainFrame?5:6;case TimelineModel.TimelineModel.TrackType.Worker:return 7;case TimelineModel.TimelineModel.TrackType.Raster:return 8;case TimelineModel.TimelineModel.TrackType.GPU:return 9;case TimelineModel.TimelineModel.TrackType.Other:return 10;default:return-1}};if(!this.model)return;const n=this.model.tracks().slice();n.sort(((e,n)=>t(e)-t(n)));let i=0;for(const t of n)switch(t.type){case TimelineModel.TimelineModel.TrackType.Input:this.appendAsyncEventsGroup(t,i18nString(UIStrings.input),t.asyncEvents,this.interactionsHeaderLevel2,e,!1);break;case TimelineModel.TimelineModel.TrackType.Animation:this.appendAsyncEventsGroup(t,i18nString(UIStrings.animation),t.asyncEvents,this.interactionsHeaderLevel2,e,!1);break;case TimelineModel.TimelineModel.TrackType.Timings:{const n=t.asyncEvents.length>0?this.collapsibleTimingsHeader:this.timingsHeader;this.appendHeader(i18nString(UIStrings.timings),n,!0).track=t,this.appendPageMetrics(),this.copyPerfMarkEvents(t),this.appendSyncEvents(t,t.events,null,null,e,!0),this.appendAsyncEventsGroup(t,null,t.asyncEvents,null,e,!0);break}case TimelineModel.TimelineModel.TrackType.Console:this.appendAsyncEventsGroup(t,i18nString(UIStrings.console),t.asyncEvents,this.headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.MainThread:if(t.forMainFrame){const n=this.appendSyncEvents(t,t.events,t.url?i18nString(UIStrings.mainS,{PH1:t.url}):i18nString(UIStrings.main),this.headerLevel1,e,!0);n&&this.timelineDataInternal&&(this.timelineDataInternal.selectedGroup=n)}else this.appendSyncEvents(t,t.events,t.url?i18nString(UIStrings.frameS,{PH1:t.url}):i18nString(UIStrings.subframe),this.headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Worker:this.appendSyncEvents(t,t.events,t.name,this.headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Raster:i||this.appendHeader(i18nString(UIStrings.raster),this.headerLevel1,!1),++i,this.appendSyncEvents(t,t.events,i18nString(UIStrings.rasterizerThreadS,{PH1:i}),this.headerLevel2,e,!0);break;case TimelineModel.TimelineModel.TrackType.GPU:this.appendSyncEvents(t,t.events,i18nString(UIStrings.gpu),this.headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Other:this.appendSyncEvents(t,t.events,t.name||i18nString(UIStrings.thread),this.headerLevel1,e,!0),this.appendAsyncEventsGroup(t,t.name,t.asyncEvents,this.headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Experience:this.appendSyncEvents(t,t.events,i18nString(UIStrings.experience),this.experienceHeader,e,!0)}this.timelineDataInternal&&this.timelineDataInternal.selectedGroup&&(this.timelineDataInternal.selectedGroup.expanded=!0);for(let e=0;e<this.extensionInfo.length;e++)this.innerAppendExtensionEvents(e);this.markers.sort(((e,t)=>e.startTime()-t.startTime())),this.timelineDataInternal&&(this.timelineDataInternal.markers=this.markers),this.flowEventIndexById.clear()}minimumBoundary(){return this.minimumBoundaryInternal}totalTime(){return this.timeSpan}search(e,t,n){const i=[],r=EntryType;this.timelineData();for(let s=0;s<this.entryData.length;++s){if(this.entryType(s)!==r.Event)continue;const a=this.entryData[s];a.startTime>t||((a.endTime||a.startTime)<e||n.accept(a)&&i.push(s))}return i.sort(((e,t)=>SDK.TracingModel.Event.compareStartTime(this.entryData[e],this.entryData[t]))),i}appendSyncEvents(e,t,n,i,r,s){if(!t.length)return null;if(!this.performanceModel||!this.model)return null;const a=r===EntryType.ExtensionEvent,o=[],l=!a&&Root.Runtime.experiments.isEnabled("ignoreListJSFramesOnTimeline");let m=0,h=null;e&&e.type===TimelineModel.TimelineModel.TrackType.MainThread&&(h=this.appendHeader(n,i,s),h.track=e);for(let r=0;r<t.length;++r){const c=t[r];if(this.performanceModel){const t=this.performanceModel.timelineModel().isInteractiveTimeEvent(c),n=this.performanceModel.timelineModel().isLayoutShiftEvent(c),i=t||n;if(e&&e.type===TimelineModel.TimelineModel.TrackType.MainThread&&i)continue}if(this.performanceModel&&this.performanceModel.timelineModel().isLayoutShiftEvent(c))for(const e of this.performanceModel.frames()){void 0===c.endTime&&c.setEndTime(c.startTime);const t=c.startTime>=e.startTime,n=c.endTime&&c.endTime<=e.endTime;t&&n&&(c.startTime=e.startTime,c.setEndTime(e.endTime))}if(!a&&this.performanceModel.timelineModel().isMarkerEvent(c)&&this.markers.push(new TimelineFlameChartMarker(c.startTime,c.startTime-this.model.minimumRecordTime(),TimelineUIUtils.markerStyleForEvent(c))),!SDK.TracingModel.TracingModel.isFlowPhase(c.phase)){if(!c.endTime&&c.phase!==SDK.TracingModel.Phase.Instant)continue;if(SDK.TracingModel.TracingModel.isAsyncPhase(c.phase))continue;if(!a&&!this.performanceModel.isVisible(c))continue}for(;o.length&&o[o.length-1].endTime<=c.startTime;)o.pop();if(eventToDisallowRoot.set(c,!1),l&&this.isIgnoreListedEvent(c)){const e=o[o.length-1];if(e&&eventToDisallowRoot.get(e))continue;eventToDisallowRoot.set(c,!0)}!h&&n&&(h=this.appendHeader(n,i,s),s&&(h.track=e));const d=this.currentLevel+o.length,p=this.appendEvent(c,d);o.length&&(this.entryParent[p]=o[o.length-1]),!a&&this.performanceModel.timelineModel().isMarkerEvent(c)&&(this.timelineDataInternal.entryTotalTimes[this.entryData.length]=void 0),m=Math.max(m,o.length+1),c.endTime&&o.push(c)}return this.entryTypeByLevel.length=this.currentLevel+m,this.entryTypeByLevel.fill(r,this.currentLevel),this.currentLevel+=m,h}isIgnoreListedEvent(e){if(e.name!==TimelineModel.TimelineModel.RecordType.JSFrame)return!1;const t=e.args.data.url;return t&&this.isIgnoreListedURL(t)}isIgnoreListedURL(e){return Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedURL(e)}appendAsyncEventsGroup(e,t,n,i,r,s){if(!n.length)return null;const a=[];let o=null;for(let r=0;r<n.length;++r){const l=n[r];if(!this.performanceModel||!this.performanceModel.isVisible(l))continue;!o&&t&&(o=this.appendHeader(t,i,s),s&&(o.track=e));const m=l.startTime;let h;for(h=0;h<a.length&&a[h]>m;++h);this.appendAsyncEvent(l,this.currentLevel+h),a[h]=l.endTime}return this.entryTypeByLevel.length=this.currentLevel+a.length,this.entryTypeByLevel.fill(r,this.currentLevel),this.currentLevel+=a.length,o}appendInteractionRecords(){if(!this.performanceModel)return;const e=this.performanceModel.interactionRecords();if(e.length){this.appendHeader(i18nString(UIStrings.interactions),this.interactionsHeaderLevel1,!1);for(const t of e){const e=this.entryData.length;this.entryData.push(t.data),this.entryIndexToTitle[e]=t.data,this.timelineDataInternal&&(this.timelineDataInternal.entryLevels[e]=this.currentLevel,this.timelineDataInternal.entryTotalTimes[e]=t.end-t.begin,this.timelineDataInternal.entryStartTimes[e]=t.begin)}this.entryTypeByLevel[this.currentLevel++]=EntryType.InteractionRecord}}appendPageMetrics(){if(this.entryTypeByLevel[this.currentLevel]=EntryType.Event,!this.performanceModel||!this.model)return;const e=[],t=[],n=[],i=this.performanceModel.timelineModel();for(const r of this.model.tracks())for(const s of r.events)i.isLayoutShiftEvent(s)&&n.push(s),i.isMarkerEvent(s)&&(i.isLCPCandidateEvent(s)||i.isLCPInvalidateEvent(s)?t.push(s):e.push(s));if(t.length>0){const n=new Map;for(const e of t){const t=e.args.data.navigationId,i=n.get(t);(!i||i.args.data.candidateIndex<e.args.data.candidateIndex)&&n.set(t,e)}const r=Array.from(n.values()).filter((e=>i.isLCPCandidateEvent(e)));e.push(...r)}if(n.length&&assignLayoutShiftsToClusters(n),e.sort(SDK.TracingModel.Event.compareStartTime),this.timelineDataInternal){const t=this.timelineDataInternal.entryTotalTimes;for(const n of e)this.appendEvent(n,this.currentLevel),t[t.length-1]=Number.NaN}++this.currentLevel}copyPerfMarkEvents(e){if(this.entryTypeByLevel[this.currentLevel]=EntryType.Event,!this.performanceModel||!this.model||!e)return;const t=this.performanceModel.timelineModel(),n=["workerStart","redirectStart","redirectEnd","fetchStart","domainLookupStart","domainLookupEnd","connectStart","connectEnd","secureConnectionStart","requestStart","responseStart","responseEnd","navigationStart","unloadEventStart","unloadEventEnd","redirectStart","redirectEnd","fetchStart","domainLookupStart","domainLookupEnd","connectStart","connectEnd","secureConnectionStart","requestStart","responseStart","responseEnd","domLoading","domInteractive","domContentLoadedEventStart","domContentLoadedEventEnd","domComplete","loadEventStart","loadEventEnd"];for(const i of this.model.tracks())if(i.type===TimelineModel.TimelineModel.TrackType.MainThread)for(const r of i.events)if(t.isUserTimingEvent(r)){if(n.includes(r.name))continue;if(SDK.TracingModel.TracingModel.isAsyncPhase(r.phase))continue;r.setEndTime(r.startTime),e.events.push(r)}++this.currentLevel}appendFrames(){if(!this.performanceModel||!this.timelineDataInternal||!this.model)return;const e=this.performanceModel.filmStripModel().frames(),t=Boolean(e.length);this.framesHeader.collapsible=t,this.appendHeader(i18nString(UIStrings.frames),this.framesHeader,!1),this.frameGroup=this.timelineDataInternal.groups[this.timelineDataInternal.groups.length-1];const n=TimelineUIUtils.markerStyleForFrame();this.entryTypeByLevel[this.currentLevel]=EntryType.Frame;for(const e of this.performanceModel.frames())this.markers.push(new TimelineFlameChartMarker(e.startTime,e.startTime-this.model.minimumRecordTime(),n)),this.appendFrame(e);if(++this.currentLevel,!t)return;let i;this.appendHeader("",this.screenshotsHeader,!1),this.entryTypeByLevel[this.currentLevel]=EntryType.Screenshot;for(const t of e)this.entryData.push(t),this.timelineDataInternal.entryLevels.push(this.currentLevel),this.timelineDataInternal.entryStartTimes.push(t.timestamp),i&&this.timelineDataInternal.entryTotalTimes.push(t.timestamp-i),i=t.timestamp;e.length&&void 0!==i&&this.timelineDataInternal.entryTotalTimes.push(this.model.maximumRecordTime()-i),++this.currentLevel}entryType(e){return this.entryTypeByLevel[this.timelineDataInternal.entryLevels[e]]}prepareHighlightedEntryInfo(e){let t,n,i="",r="timeline-info-time";const s=this.entryType(e);if(s===EntryType.Event){const r=this.entryData[e],s=r.duration,a=r.selfTime,o=1e-6;if("number"==typeof s&&(i=Math.abs(s-a)>o&&a>o?i18nString(UIStrings.sSelfS,{PH1:i18n.TimeUtilities.millisToString(s,!0),PH2:i18n.TimeUtilities.millisToString(a,!0)}):i18n.TimeUtilities.millisToString(s,!0)),t=this.performanceModel&&this.performanceModel.timelineModel().isMarkerEvent(r)?TimelineUIUtils.eventTitle(r):this.entryTitle(e),n=TimelineUIUtils.eventWarning(r),this.model&&this.model.isLayoutShiftEvent(r)){i=i18nString(UIStrings.occurrencesS,{PH1:1})}if(this.model&&this.model.isParseHTMLEvent(r)){const e=r.args.beginData.startLine,n=r.args.endData&&r.args.endData.endLine;t+=` - ${Bindings.ResourceUtils.displayNameForURL(r.args.beginData.url)} [${-1!==n||n===e?`${e}...${n}`:e}]`}}else{if(s!==EntryType.Frame)return null;{const s=this.entryData[e];i=i18nString(UIStrings.sFfps,{PH1:i18n.TimeUtilities.preciseMillisToString(s.duration,1),PH2:(1e3/s.duration).toFixed(0)}),s.idle?t=i18nString(UIStrings.idleFrame):s.dropped?(t=i18nString(UIStrings.droppedFrame),r="timeline-info-warning"):t=i18nString(UIStrings.frame),s.hasWarnings()&&(n=document.createElement("span"),n.textContent=i18nString(UIStrings.longFrame))}}const a=document.createElement("div"),o=UI.Utils.createShadowRootWithCoreStyles(a,{cssFile:[timelineFlamechartPopoverStyles],delegatesFocus:void 0}).createChild("div","timeline-flamechart-popover");return o.createChild("span",r).textContent=i,o.createChild("span","timeline-info-title").textContent=t,n&&(n.classList.add("timeline-info-warning"),o.appendChild(n)),a}entryColor(e){function t(e,t,n){let i=e.get(t);if(i)return i;const r=Common.Color.Color.parse(n(t));if(!r)throw new Error("Could not parse color from entry");return i=r.setAlpha(.7).asString(Common.Color.Format.RGBA)||"",e.set(t,i),i}if(!this.performanceModel||!this.model)return"";const n=EntryType,i=this.entryType(e);if(i===n.Event){const n=this.entryData[e];if(this.model.isGenericTrace())return this.genericTraceEventColor(n);if(this.performanceModel.timelineModel().isMarkerEvent(n))return TimelineUIUtils.markerStyleForEvent(n).color;if(!SDK.TracingModel.TracingModel.isAsyncPhase(n.phase)&&this.colorForEvent)return this.colorForEvent(n);if(n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.Console)||n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.UserTiming))return this.consoleColorGenerator.colorForID(n.name);if(n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.LatencyInfo)){const e=TimelineModel.TimelineIRModel.TimelineIRModel.phaseForEvent(n)||TimelineModel.TimelineIRModel.Phases.Uncategorized;return t(this.asyncColorByInteractionPhase,e,TimelineUIUtils.interactionPhaseColor)}const i=TimelineUIUtils.eventStyle(n).category;return t(this.asyncColorByCategory,i,(()=>i.color))}if(i===n.Frame)return"white";if(i===n.InteractionRecord)return"transparent";if(i===n.ExtensionEvent){const t=this.entryData[e];return this.extensionColorGenerator.colorForID(t.name)}return""}genericTraceEventColor(e){const t=e.categoriesString||e.name;return t?`hsl(${Platform.StringUtilities.hashCode(t)%300+30}, 40%, 70%)`:"#ccc"}drawFrame(e,t,n,i,r,s,a){const o=this.entryData[e];i+=1,s-=2,t.fillStyle=o.idle?"white":o.dropped?"#f0b7b1":o.hasWarnings()?"#fad1d1":"#d7f0d1",t.fillRect(i,r,s,a);const l=i18n.TimeUtilities.preciseMillisToString(o.duration,1),m=t.measureText(l).width;m<=s&&(t.fillStyle=this.textColor(e),t.fillText(l,i+(s-m)/2,r+a-4))}async drawScreenshot(e,t,n,i,r,s){const a=this.entryData[e];if(!this.screenshotImageCache.has(a)){this.screenshotImageCache.set(a,null);const e=await a.imageDataPromise(),t=await UI.UIUtils.loadImageFromData(e);return this.screenshotImageCache.set(a,t),void this.dispatchEventToListeners(Events.DataChanged)}const o=this.screenshotImageCache.get(a);if(!o)return;const l=n+1,m=i+1,h=s-2,c=h/o.naturalHeight,d=Math.floor(o.naturalWidth*c);t.save(),t.beginPath(),t.rect(n,i,r,s),t.clip(),t.drawImage(o,l,m,d,h),t.strokeStyle="#ccc",t.strokeRect(l-.5,m-.5,Math.min(r-1,d+1),h),t.restore()}decorateEntry(e,t,n,i,r,s,a,o,l){const m=this.entryData[e],h=this.entryType(e),c=EntryType;if(h===c.Frame)return this.drawFrame(e,t,n,i,r,s,a),!0;if(h===c.Screenshot)return this.drawScreenshot(e,t,i,r,s,a),!0;if(h===c.InteractionRecord){const e=TimelineUIUtils.interactionPhaseColor(m);return t.fillStyle=e,t.fillRect(i,r,s-1,2),t.fillRect(i,r-3,2,3),t.fillRect(i+s-3,r-3,2,3),!1}if(h===c.Event){const e=m;if(e.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.LatencyInfo)){const n=TimelineModel.TimelineModel.TimelineData.forEvent(e).timeWaitingForMainThread;if(n){t.fillStyle="hsla(0, 70%, 60%, 1)";const e=Math.floor(o-i+n*l);t.fillRect(i,r+a-3,e,2)}}TimelineModel.TimelineModel.TimelineData.forEvent(e).warning&&function(e,n){const i=8;t.save(),t.beginPath(),t.rect(e,r,n,a),t.clip(),t.beginPath(),t.fillStyle="red",t.moveTo(e+n-i,r),t.lineTo(e+n,r),t.lineTo(e+n,r+i),t.fill(),t.restore()}(i,s-1.5)}return!1}forceDecoration(e){const t=EntryType,n=this.entryType(e);if(n===t.Frame)return!0;if(n===t.Screenshot)return!0;if(n===t.Event){const t=this.entryData[e];return Boolean(TimelineModel.TimelineModel.TimelineData.forEvent(t).warning)}return!1}appendExtensionEvents(e){this.extensionInfo.push(e),this.timelineDataInternal&&this.innerAppendExtensionEvents(this.extensionInfo.length-1)}innerAppendExtensionEvents(e){const t=this.extensionInfo[e],n=EntryType.ExtensionEvent,i=[...t.model.sortedProcesses().map((e=>e.sortedThreads()))].flat();if(!i.length)return;const r=!(1!==i.length||i[0].events().length&&i[0].asyncEvents().length);r||this.appendHeader(t.title,this.headerLevel1,!1);const s=r?this.headerLevel2:this.headerLevel1;let a=0;for(const e of i){const i=r?t.title:e.name()||i18nString(UIStrings.threadS,{PH1:++a});this.appendAsyncEventsGroup(null,i,e.asyncEvents(),s,n,!1),this.appendSyncEvents(null,e.events(),i,s,n,!1)}}appendHeader(e,t,n){const i={startLevel:this.currentLevel,name:e,style:t,selectable:n};return this.timelineDataInternal.groups.push(i),i}appendEvent(e,t){const n=this.entryData.length;this.entryData.push(e);const i=this.timelineDataInternal;return i.entryLevels[n]=t,i.entryTotalTimes[n]=e.duration||InstantEventVisibleDurationMs,i.entryStartTimes[n]=e.startTime,indexForEvent.set(e,n),n}appendAsyncEvent(e,t){if(SDK.TracingModel.TracingModel.isNestableAsyncPhase(e.phase))return void this.appendEvent(e,t);const n=e.steps,i=n.length>1&&n[1].phase===SDK.TracingModel.Phase.AsyncStepPast?1:0;for(let e=0;e<n.length-1;++e){const r=this.entryData.length;this.entryData.push(n[e+i]);const s=n[e].startTime,a=this.timelineDataInternal;a.entryLevels[r]=t,a.entryTotalTimes[r]=n[e+1].startTime-s,a.entryStartTimes[r]=s}}appendFrame(e){const t=this.entryData.length;this.entryData.push(e),this.entryIndexToTitle[t]=i18n.TimeUtilities.millisToString(e.duration,!0),this.timelineDataInternal&&(this.timelineDataInternal.entryLevels[t]=this.currentLevel,this.timelineDataInternal.entryTotalTimes[t]=e.duration,this.timelineDataInternal.entryStartTimes[t]=e.startTime)}createSelection(e){const t=this.entryType(e);let n=null;return t===EntryType.Event?n=TimelineSelection.fromTraceEvent(this.entryData[e]):t===EntryType.Frame&&(n=TimelineSelection.fromFrame(this.entryData[e])),n&&(this.lastSelection=new Selection(n,e)),n}formatValue(e,t){return i18n.TimeUtilities.preciseMillisToString(e,t)}canJumpToEntry(e){return!1}entryIndexForSelection(e){if(!e||e.type()===TimelineSelection.Type.Range)return-1;if(this.lastSelection&&this.lastSelection.timelineSelection.object()===e.object())return this.lastSelection.entryIndex;const t=this.entryData.indexOf(e.object());return-1!==t&&(this.lastSelection=new Selection(e,t)),t}buildFlowForInitiator(e){if(this.lastInitiatorEntry===e)return!1;this.lastInitiatorEntry=e;let t=this.eventByIndex(e);const n=this.timelineDataInternal;if(!n)return!1;for(n.flowStartTimes=[],n.flowStartLevels=[],n.flowEndTimes=[],n.flowEndLevels=[];t;){let e;for(;t&&(e=TimelineModel.TimelineModel.TimelineData.forEvent(t).initiator(),!e);t=this.eventParent(t));if(!e||!t)break;const i=indexForEvent.get(t),r=indexForEvent.get(e);n.flowStartTimes.push(e.endTime||e.startTime),n.flowStartLevels.push(n.entryLevels[r]),n.flowEndTimes.push(t.startTime),n.flowEndLevels.push(n.entryLevels[i]),t=e}return!0}eventParent(e){const t=indexForEvent.get(e);return void 0===t?null:this.entryParent[t]||null}eventByIndex(e){return e>=0&&this.entryType(e)===EntryType.Event?this.entryData[e]:null}setEventColorMapping(e){this.colorForEvent=e}}export const InstantEventVisibleDurationMs=.001;const eventToDisallowRoot=new WeakMap,indexForEvent=new WeakMap;export var Events;!function(e){e.DataChanged="DataChanged"}(Events||(Events={}));export var EntryType;!function(e){e.Frame="Frame",e.Event="Event",e.InteractionRecord="InteractionRecord",e.ExtensionEvent="ExtensionEvent",e.Screenshot="Screenshot"}(EntryType||(EntryType={}));