import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as UI from"../../ui/legacy/legacy.js";import{CountersGraph}from"./CountersGraph.js";import{Events as PerformanceModelEvents}from"./PerformanceModel.js";import{TimelineDetailsView}from"./TimelineDetailsView.js";import{TimelineRegExp}from"./TimelineFilters.js";import{Events as TimelineFlameChartDataProviderEvents,TimelineFlameChartDataProvider}from"./TimelineFlameChartDataProvider.js";import{TimelineFlameChartNetworkDataProvider}from"./TimelineFlameChartNetworkDataProvider.js";import{TimelineSelection}from"./TimelinePanel.js";import{AggregatedTimelineTreeView}from"./TimelineTreeView.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";import{WebVitalsIntegrator}from"./WebVitalsTimelineUtils.js";const UIStrings={sAtS:"{PH1} at {PH2}"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineFlameChartView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class MainSplitWidget extends UI.SplitWidget.SplitWidget{webVitals;model;constructor(e,t,i,s,a,r){super(e,t,i,s,a,r)}setWebVitals(e){this.webVitals=e,this.webVitals.setMinimumSize(0,120)}setWindowTimes(e,t,i){if(!this.webVitals)return;const s=e-(this.model?this.model.timelineModel().minimumRecordTime():0);this.webVitals.chartViewport.setWindowTimes(e,t,i),this.webVitals.webVitalsTimeline.data={startTime:s,duration:t-e,fcps:void 0,lcps:void 0,layoutShifts:void 0,longTasks:void 0,mainFrameNavigations:void 0,maxDuration:void 0}}setModelAndUpdateBoundaries(e){if(this.model=e,!this.webVitals||!e)return;const t=e.window().left,i=e.window().right,s=e.timelineModel(),a=s.tracks().reduce(((e,t)=>e.concat(t.events)),[]),r=e.timelineModel().minimumRecordTime(),n=e=>a.filter(e).map((e=>e.startTime-r)),l=a.filter((e=>s.isLCPCandidateEvent(e)||s.isLCPInvalidateEvent(e))),h=new Map;for(const e of l){const t=e.args.data.navigationId,i=h.get(t);(!i||i.args.data.candidateIndex<e.args.data.candidateIndex)&&h.set(t,e)}const o=Array.from(h.values()).filter((e=>s.isLCPCandidateEvent(e))),d=a.filter((e=>SDK.TracingModel.TracingModel.isCompletePhase(e.phase)&&s.isLongRunningTask(e))).map((e=>({start:e.startTime-r,duration:e.duration||0})));this.webVitals.chartViewport.setBoundaries(t,i-t),this.webVitals.chartViewport.setWindowTimes(t,i);const m=t-(this.model?this.model.timelineModel().minimumRecordTime():0);this.webVitals.webVitalsTimeline.data={startTime:m,duration:i-t,maxDuration:s.maximumRecordTime(),fcps:a.filter((e=>s.isFCPEvent(e))).map((e=>({timestamp:e.startTime-r,e:e}))),lcps:o.map((e=>e.startTime)).map((e=>({timestamp:e-r}))),layoutShifts:n((e=>s.isLayoutShiftEvent(e))).map((e=>({timestamp:e}))),longTasks:d,mainFrameNavigations:n((e=>s.isMainFrameNavigationStartEvent(e)))}}}export class TimelineFlameChartView extends UI.Widget.VBox{delegate;model;searchResults;eventListeners;showMemoryGraphSetting;showWebVitalsSetting;networkSplitWidget;mainDataProvider;mainFlameChart;networkFlameChartGroupExpansionSetting;networkDataProvider;networkFlameChart;networkPane;splitResizer;webVitals;mainSplitWidget;chartSplitWidget;countersView;detailsSplitWidget;detailsView;onMainEntrySelected;onNetworkEntrySelected;nextExtensionIndex;boundRefresh;selectedTrack;groupBySetting;searchableView;urlToColorCache;needsResizeToPreferredHeights;selectedSearchResult;searchRegex;constructor(e){super(),this.element.classList.add("timeline-flamechart"),this.delegate=e,this.model=null,this.eventListeners=[],this.showMemoryGraphSetting=Common.Settings.Settings.instance().createSetting("timelineShowMemory",!1),this.showWebVitalsSetting=Common.Settings.Settings.instance().createSetting("timelineWebVitals",!1),this.networkSplitWidget=new UI.SplitWidget.SplitWidget(!1,!1,"timelineFlamechartMainView",150),this.networkSplitWidget.sidebarElement().style.zIndex="120";const t=Common.Settings.Settings.instance().createSetting("timelineFlamechartMainViewGroupExpansion",{});this.mainDataProvider=new TimelineFlameChartDataProvider,this.mainDataProvider.addEventListener(TimelineFlameChartDataProviderEvents.DataChanged,(()=>this.mainFlameChart.scheduleUpdate())),this.mainFlameChart=new PerfUI.FlameChart.FlameChart(this.mainDataProvider,this,t),this.mainFlameChart.alwaysShowVerticalScroll(),this.mainFlameChart.enableRuler(!1),this.networkFlameChartGroupExpansionSetting=Common.Settings.Settings.instance().createSetting("timelineFlamechartNetworkViewGroupExpansion",{}),this.networkDataProvider=new TimelineFlameChartNetworkDataProvider,this.networkFlameChart=new PerfUI.FlameChart.FlameChart(this.networkDataProvider,this,this.networkFlameChartGroupExpansionSetting),this.networkFlameChart.alwaysShowVerticalScroll(),this.networkFlameChart.disableRangeSelection(),this.networkPane=new UI.Widget.VBox,this.networkPane.setMinimumSize(23,23),this.networkFlameChart.show(this.networkPane.element),this.splitResizer=this.networkPane.element.createChild("div","timeline-flamechart-resizer"),this.networkSplitWidget.hideDefaultResizer(!0),this.networkSplitWidget.installResizer(this.splitResizer),this.webVitals=new WebVitalsIntegrator(this),this.mainSplitWidget=new MainSplitWidget(!1,!1,"timelineFlamechartMainAndVitalsView",void 0,120),this.mainSplitWidget.setWebVitals(this.webVitals),this.mainSplitWidget.setMainWidget(this.mainFlameChart),this.mainSplitWidget.setSidebarWidget(this.webVitals),this.toggleWebVitalsLane(),this.networkSplitWidget.setMainWidget(this.mainSplitWidget),this.networkSplitWidget.setSidebarWidget(this.networkPane),this.chartSplitWidget=new UI.SplitWidget.SplitWidget(!1,!0,"timelineCountersSplitViewState"),this.countersView=new CountersGraph(this.delegate),this.chartSplitWidget.setMainWidget(this.networkSplitWidget),this.chartSplitWidget.setSidebarWidget(this.countersView),this.chartSplitWidget.hideDefaultResizer(),this.chartSplitWidget.installResizer(this.countersView.resizerElement()),this.updateCountersGraphToggle(),this.detailsSplitWidget=new UI.SplitWidget.SplitWidget(!1,!0,"timelinePanelDetailsSplitViewState"),this.detailsSplitWidget.element.classList.add("timeline-details-split"),this.detailsView=new TimelineDetailsView(e),this.detailsSplitWidget.installResizer(this.detailsView.headerElement()),this.detailsSplitWidget.setMainWidget(this.chartSplitWidget),this.detailsSplitWidget.setSidebarWidget(this.detailsView),this.detailsSplitWidget.show(this.element),this.onMainEntrySelected=this.onEntrySelected.bind(this,this.mainDataProvider),this.onNetworkEntrySelected=this.onEntrySelected.bind(this,this.networkDataProvider),this.mainFlameChart.addEventListener(PerfUI.FlameChart.Events.EntrySelected,this.onMainEntrySelected,this),this.mainFlameChart.addEventListener(PerfUI.FlameChart.Events.EntryInvoked,this.onMainEntrySelected,this),this.networkFlameChart.addEventListener(PerfUI.FlameChart.Events.EntrySelected,this.onNetworkEntrySelected,this),this.networkFlameChart.addEventListener(PerfUI.FlameChart.Events.EntryInvoked,this.onNetworkEntrySelected,this),this.mainFlameChart.addEventListener(PerfUI.FlameChart.Events.EntryHighlighted,this.onEntryHighlighted,this),this.nextExtensionIndex=0,this.boundRefresh=this.refresh.bind(this),this.selectedTrack=null,this.mainDataProvider.setEventColorMapping(TimelineUIUtils.eventColor),this.groupBySetting=Common.Settings.Settings.instance().createSetting("timelineTreeGroupBy",AggregatedTimelineTreeView.GroupBy.None),this.groupBySetting.addChangeListener(this.updateColorMapper,this),this.updateColorMapper()}toggleWebVitalsLane(){this.showWebVitalsSetting.get()?(this.mainSplitWidget.showBoth(),this.mainSplitWidget.setSidebarSize(120),this.mainSplitWidget.setResizable(!1),this.mainSplitWidget.hideDefaultResizer(!0)):this.mainSplitWidget.hideSidebar()}updateColorMapper(){this.urlToColorCache=new Map,this.model&&(this.mainDataProvider.setEventColorMapping(TimelineUIUtils.eventColor),this.mainFlameChart.update())}onWindowChanged(e){const{window:t,animate:i}=e.data;this.mainFlameChart.setWindowTimes(t.left,t.right,i),this.networkFlameChart.setWindowTimes(t.left,t.right,i),this.networkDataProvider.setWindowTimes(t.left,t.right),this.mainSplitWidget.setWindowTimes(t.left,t.right,Boolean(i)),this.updateSearchResults(!1,!1)}windowChanged(e,t,i){this.model&&this.model.setWindow({left:e,right:t},i)}updateRangeSelection(e,t){this.delegate.select(TimelineSelection.fromRange(e,t))}updateSelectedGroup(e,t){if(e!==this.mainFlameChart)return;const i=t?this.mainDataProvider.groupTrack(t):null;this.selectedTrack=i,this.updateTrack()}setModel(e){if(e!==this.model){if(Common.EventTarget.removeEventListeners(this.eventListeners),this.model=e,this.selectedTrack=null,this.mainDataProvider.setModel(this.model),this.networkDataProvider.setModel(this.model),this.model){this.eventListeners=[this.model.addEventListener(PerformanceModelEvents.WindowChanged,this.onWindowChanged,this),this.model.addEventListener(PerformanceModelEvents.ExtensionDataAdded,this.appendExtensionData,this)];const t=this.model.window();this.mainFlameChart.setWindowTimes(t.left,t.right),this.networkFlameChart.setWindowTimes(t.left,t.right),this.networkDataProvider.setWindowTimes(t.left,t.right),this.mainSplitWidget.setModelAndUpdateBoundaries(e),this.updateSearchResults(!1,!1)}this.updateColorMapper(),this.updateTrack(),this.nextExtensionIndex=0,this.appendExtensionData(),this.refresh()}}updateTrack(){this.countersView.setModel(this.model,this.selectedTrack),this.detailsView.setModel(this.model,this.selectedTrack)}refresh(){this.networkDataProvider.isEmpty()?(this.mainFlameChart.enableRuler(!0),this.networkSplitWidget.hideSidebar()):(this.mainFlameChart.enableRuler(!1),this.networkSplitWidget.showBoth(),this.resizeToPreferredHeights()),this.mainFlameChart.reset(),this.networkFlameChart.reset(),this.updateSearchResults(!1,!1)}appendExtensionData(){if(!this.model)return;const e=this.model.extensionInfo();for(;this.nextExtensionIndex<e.length;)this.mainDataProvider.appendExtensionEvents(e[this.nextExtensionIndex++]);this.mainFlameChart.scheduleUpdate()}onEntryHighlighted(e){SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight();const t=e.data,i=this.mainDataProvider.eventByIndex(t);if(!i)return;const s=this.model&&this.model.timelineModel().targetByEvent(i);if(!s)return;const a=TimelineModel.TimelineModel.TimelineData.forEvent(i).backendNodeIds;if(a)for(let e=0;e<a.length;++e)new SDK.DOMModel.DeferredDOMNode(s,a[e]).highlight()}highlightEvent(e){const t=e?this.mainDataProvider.entryIndexForSelection(TimelineSelection.fromTraceEvent(e)):-1;t>=0?this.mainFlameChart.highlightEntry(t):this.mainFlameChart.hideHighlight()}willHide(){this.networkFlameChartGroupExpansionSetting.removeChangeListener(this.resizeToPreferredHeights,this),this.showMemoryGraphSetting.removeChangeListener(this.updateCountersGraphToggle,this),Bindings.IgnoreListManager.IgnoreListManager.instance().removeChangeListener(this.boundRefresh)}wasShown(){this.networkFlameChartGroupExpansionSetting.addChangeListener(this.resizeToPreferredHeights,this),this.showMemoryGraphSetting.addChangeListener(this.updateCountersGraphToggle,this),Bindings.IgnoreListManager.IgnoreListManager.instance().addChangeListener(this.boundRefresh),this.needsResizeToPreferredHeights&&this.resizeToPreferredHeights(),this.mainFlameChart.scheduleUpdate(),this.networkFlameChart.scheduleUpdate()}updateCountersGraphToggle(){this.showMemoryGraphSetting.get()?this.chartSplitWidget.showBoth():this.chartSplitWidget.hideSidebar()}setSelection(e){let t=this.mainDataProvider.entryIndexForSelection(e);this.mainFlameChart.setSelectedEntry(t),t=this.networkDataProvider.entryIndexForSelection(e),this.networkFlameChart.setSelectedEntry(t),this.detailsView&&this.detailsView.setSelection(e)}onEntrySelected(e,t){const i=t.data;Root.Runtime.experiments.isEnabled("timelineEventInitiators")&&e===this.mainDataProvider&&this.mainDataProvider.buildFlowForInitiator(i)&&this.mainFlameChart.scheduleUpdate(),this.delegate.select(e.createSelection(i))}resizeToPreferredHeights(){this.isShowing()?(this.needsResizeToPreferredHeights=!1,this.networkPane.element.classList.toggle("timeline-network-resizer-disabled",!this.networkDataProvider.isExpanded()),this.networkSplitWidget.setSidebarSize(this.networkDataProvider.preferredHeight()+this.splitResizer.clientHeight+PerfUI.FlameChart.HeaderHeight+2)):this.needsResizeToPreferredHeights=!0}setSearchableView(e){this.searchableView=e}jumpToNextSearchResult(){if(!this.searchResults||!this.searchResults.length)return;const e=void 0!==this.selectedSearchResult?this.searchResults.indexOf(this.selectedSearchResult):-1;this.selectSearchResult(Platform.NumberUtilities.mod(e+1,this.searchResults.length))}jumpToPreviousSearchResult(){if(!this.searchResults||!this.searchResults.length)return;const e=void 0!==this.selectedSearchResult?this.searchResults.indexOf(this.selectedSearchResult):0;this.selectSearchResult(Platform.NumberUtilities.mod(e-1,this.searchResults.length))}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}selectSearchResult(e){this.searchableView.updateCurrentMatchIndex(e),this.searchResults&&(this.selectedSearchResult=this.searchResults[e],this.delegate.select(this.mainDataProvider.createSelection(this.selectedSearchResult)))}updateSearchResults(e,t){const i=this.selectedSearchResult;if(delete this.selectedSearchResult,this.searchResults=[],!this.searchRegex||!this.model)return;const s=new TimelineRegExp(this.searchRegex),a=this.model.window();if(this.searchResults=this.mainDataProvider.search(a.left,a.right,s),this.searchableView.updateSearchMatchesCount(this.searchResults.length),!e||!this.searchResults.length)return;let r=this.searchResults.indexOf(i);-1===r&&(r=t?this.searchResults.length-1:0),this.selectSearchResult(r)}searchCanceled(){void 0!==this.selectedSearchResult&&this.delegate.select(null),delete this.searchResults,delete this.selectedSearchResult,delete this.searchRegex}performSearch(e,t,i){this.searchRegex=e.toSearchRegex(),this.updateSearchResults(t,i)}}export class Selection{timelineSelection;entryIndex;constructor(e,t){this.timelineSelection=e,this.entryIndex=t}}export const FlameChartStyle={textColor:"#333"};export class TimelineFlameChartMarker{startTimeInternal;startOffset;style;constructor(e,t,i){this.startTimeInternal=e,this.startOffset=t,this.style=i}startTime(){return this.startTimeInternal}color(){return this.style.color}title(){if(this.style.lowPriority)return null;const e=i18n.TimeUtilities.millisToString(this.startOffset);return i18nString(UIStrings.sAtS,{PH1:this.style.title,PH2:e})}draw(e,t,i,s){this.style.lowPriority&&s<4||(e.save(),this.style.tall&&(e.strokeStyle=this.style.color,e.lineWidth=this.style.lineWidth,e.translate(this.style.lineWidth<1||1&this.style.lineWidth?.5:0,.5),e.beginPath(),e.moveTo(t,0),e.setLineDash(this.style.dashStyle),e.lineTo(t,e.canvas.height),e.stroke()),e.restore())}}export var ColorBy;!function(e){e.URL="URL"}(ColorBy||(ColorBy={}));