import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as TextUtils from"../../models/text_utils/text_utils.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";const UIStrings={malformedTimelineDataUnknownJson:"Malformed timeline data: Unknown JSON format",malformedTimelineInputWrongJson:"Malformed timeline input, wrong JSON brackets balance",malformedTimelineDataS:"Malformed timeline data: {PH1}",legacyTimelineFormatIsNot:"Legacy Timeline format is not supported.",malformedCpuProfileFormat:"Malformed CPU profile format"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelineLoader.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineLoader{client;backingStorage;tracingModel;canceledCallback;state;buffer;firstRawChunk;firstChunk;loadedBytes;totalSize;jsonTokenizer;constructor(e){this.client=e,this.backingStorage=new Bindings.TempFile.TempFileBackingStorage,this.tracingModel=new SDK.TracingModel.TracingModel(this.backingStorage),this.canceledCallback=null,this.state=State.Initial,this.buffer="",this.firstRawChunk=!0,this.firstChunk=!0,this.loadedBytes=0,this.jsonTokenizer=new TextUtils.TextUtils.BalancedJSONTokenizer(this.writeBalancedJSON.bind(this),!0)}static loadFromFile(e,t){const i=new TimelineLoader(t),n=new Bindings.FileUtils.ChunkedFileReader(e,TransferChunkLengthBytes);return i.canceledCallback=n.cancel.bind(n),i.totalSize=e.size,n.read(i).then((e=>{!e&&n.error()&&i.reportErrorAndCancelLoading(n.error().message)})),i}static loadFromEvents(e,t){const i=new TimelineLoader(t);return setTimeout((async()=>{t.loadingStarted();for(let n=0;n<e.length;n+=5e3){const r=e.slice(n,n+5e3);i.tracingModel.addEvents(r),t.loadingProgress((n+r.length)/e.length),await new Promise((e=>setTimeout(e)))}i.close()})),i}static loadFromURL(e,t){const i=new TimelineLoader(t);return Host.ResourceLoader.loadAsStream(e,null,i),i}cancel(){this.tracingModel=null,this.backingStorage.reset(),this.client&&(this.client.loadingComplete(null),this.client=null),this.canceledCallback&&this.canceledCallback()}async write(e){if(!this.client)return Promise.resolve();if(this.loadedBytes+=e.length,this.firstRawChunk)await this.client.loadingStarted(),await new Promise((e=>requestAnimationFrame((()=>requestAnimationFrame(e)))));else{let e;this.totalSize&&(e=this.loadedBytes/this.totalSize,e=e>1?e-Math.floor(e):e),await this.client.loadingProgress(e)}if(this.firstRawChunk=!1,this.state===State.Initial)if(e.startsWith('{"nodes":['))this.state=State.LoadingCPUProfileFormat;else if("{"===e[0])this.state=State.LookingForEvents;else{if("["!==e[0])return this.reportErrorAndCancelLoading(i18nString(UIStrings.malformedTimelineDataUnknownJson)),Promise.resolve();this.state=State.ReadingEvents}if(this.state===State.LoadingCPUProfileFormat)return this.buffer+=e,Promise.resolve();if(this.state===State.LookingForEvents){const t='"traceEvents":',i=this.buffer.length-t.length;this.buffer+=e;const n=this.buffer.indexOf(t,i);if(-1===n)return Promise.resolve();e=this.buffer.slice(n+t.length),this.state=State.ReadingEvents}return this.state!==State.ReadingEvents||this.jsonTokenizer.write(e)||(this.state=State.SkippingTail,this.firstChunk&&this.reportErrorAndCancelLoading(i18nString(UIStrings.malformedTimelineInputWrongJson))),Promise.resolve()}writeBalancedJSON(e){let t,i=e+"]";if(!this.firstChunk){const e=i.indexOf(",");-1!==e&&(i=i.slice(e+1)),i="["+i}try{t=JSON.parse(i)}catch(e){return void this.reportErrorAndCancelLoading(i18nString(UIStrings.malformedTimelineDataS,{PH1:e.toString()}))}if(this.firstChunk&&(this.firstChunk=!1,this.looksLikeAppVersion(t[0])))this.reportErrorAndCancelLoading(i18nString(UIStrings.legacyTimelineFormatIsNot));else try{this.tracingModel.addEvents(t)}catch(e){this.reportErrorAndCancelLoading(i18nString(UIStrings.malformedTimelineDataS,{PH1:e.toString()}))}}reportErrorAndCancelLoading(e){e&&Common.Console.Console.instance().error(e),this.cancel()}looksLikeAppVersion(e){return"string"==typeof e&&-1!==e.indexOf("Chrome")}async close(){this.client&&(this.client.processingStarted(),setTimeout((()=>this.finalizeTrace()),0))}finalizeTrace(){this.state===State.LoadingCPUProfileFormat&&(this.parseCPUProfileFormat(this.buffer),this.buffer=""),this.tracingModel.tracingComplete(),this.client.loadingComplete(this.tracingModel)}parseCPUProfileFormat(e){let t;try{const i=JSON.parse(e);t=TimelineModel.TimelineJSProfile.TimelineJSProfileProcessor.buildTraceProfileFromCpuProfile(i,1,!0)}catch(e){return void this.reportErrorAndCancelLoading(i18nString(UIStrings.malformedCpuProfileFormat))}this.tracingModel.addEvents(t)}}export const TransferChunkLengthBytes=5e6;export var State;!function(e){e.Initial="Initial",e.LookingForEvents="LookingForEvents",e.ReadingEvents="ReadingEvents",e.SkippingTail="SkippingTail",e.LoadingCPUProfileFormat="LoadingCPUProfileFormat"}(State||(State={}));