import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as Platform from"../../core/platform/platform.js";import*as Root from"../../core/root/root.js";import*as SDK from"../../core/sdk/sdk.js";import*as Bindings from"../../models/bindings/bindings.js";import*as Extensions from"../../models/extensions/extensions.js";import*as TimelineModel from"../../models/timeline_model/timeline_model.js";import*as PerfUI from"../../ui/legacy/components/perf_ui/perf_ui.js";import*as UI from"../../ui/legacy/legacy.js";import historyToolbarButtonStyles from"./historyToolbarButton.css.js";import timelinePanelStyles from"./timelinePanel.css.js";import timelineStatusDialogStyles from"./timelineStatusDialog.css.js";import*as MobileThrottling from"../mobile_throttling/mobile_throttling.js";import{Events,PerformanceModel}from"./PerformanceModel.js";import{TimelineController}from"./TimelineController.js";import{TimelineEventOverviewCoverage,TimelineEventOverviewCPUActivity,TimelineEventOverviewFrames,TimelineEventOverviewInput,TimelineEventOverviewMemory,TimelineEventOverviewNetwork,TimelineEventOverviewResponsiveness,TimelineFilmStripOverview}from"./TimelineEventOverview.js";import{TimelineFlameChartView}from"./TimelineFlameChartView.js";import{TimelineHistoryManager}from"./TimelineHistoryManager.js";import{TimelineLoader}from"./TimelineLoader.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";import{UIDevtoolsController}from"./UIDevtoolsController.js";import{UIDevtoolsUtils}from"./UIDevtoolsUtils.js";const UIStrings={dropTimelineFileOrUrlHere:"Drop timeline file or URL here",disableJavascriptSamples:"Disable JavaScript samples",enableAdvancedPaint:"Enable advanced paint instrumentation (slow)",screenshots:"Screenshots",coverage:"Coverage",memory:"Memory",webVitals:"Web Vitals",clear:"Clear",loadProfile:"Load profile…",saveProfile:"Save profile…",captureScreenshots:"Capture screenshots",showMemoryTimeline:"Show memory timeline",showWebVitals:"Show Web Vitals",recordCoverageWithPerformance:"Record coverage with performance trace",captureSettings:"Capture settings",disablesJavascriptSampling:"Disables JavaScript sampling, reduces overhead when running against mobile devices",capturesAdvancedPaint:"Captures advanced paint instrumentation, introduces significant performance overhead",network:"Network:",cpu:"CPU:",networkConditions:"Network conditions",failedToSaveTimelineSSS:"Failed to save timeline: {PH1} ({PH2}, {PH3})",CpuThrottlingIsEnabled:"- CPU throttling is enabled",NetworkThrottlingIsEnabled:"- Network throttling is enabled",SignificantOverheadDueToPaint:"- Significant overhead due to paint instrumentation",JavascriptSamplingIsDisabled:"- JavaScript sampling is disabled",stoppingTimeline:"Stopping timeline…",received:"Received",close:"Close",recordingFailed:"Recording failed",profiling:"Profiling…",bufferUsage:"Buffer usage",learnmore:"Learn more",wasd:"WASD",clickTheRecordButtonSOrHitSTo:"Click the record button {PH1} or hit {PH2} to start a new recording.",clickTheReloadButtonSOrHitSTo:"Click the reload button {PH1} or hit {PH2} to record the page load.",afterRecordingSelectAnAreaOf:"After recording, select an area of interest in the overview by dragging. Then, zoom and pan the timeline with the mousewheel or {PH1} keys. {PH2}",loadingProfile:"Loading profile…",processingProfile:"Processing profile…",initializingProfiler:"Initializing profiler…",status:"Status",time:"Time",description:"Description",stop:"Stop",ssec:"{PH1} sec"},str_=i18n.i18n.registerUIStrings("panels/timeline/TimelinePanel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let timelinePanelInstance,loadTimelineHandlerInstance,actionDelegateInstance;export class TimelinePanel extends UI.Panel.Panel{dropTarget;recordingOptionUIControls;state;recordingPageReload;millisecondsToRecordAfterLoadEvent;toggleRecordAction;recordReloadAction;historyManager;performanceModel;viewModeSetting;disableCaptureJSProfileSetting;captureLayersAndPicturesSetting;showScreenshotsSetting;startCoverage;showMemorySetting;showWebVitalsSetting;panelToolbar;panelRightToolbar;timelinePane;overviewPane;overviewControls;statusPaneContainer;flameChart;searchableViewInternal;showSettingsPaneButton;showSettingsPaneSetting;settingsPane;controller;clearButton;loadButton;saveButton;statusPane;landingPage;loader;showScreenshotsToolbarCheckbox;showMemoryToolbarCheckbox;showWebVitalsToolbarCheckbox;startCoverageCheckbox;networkThrottlingSelect;cpuThrottlingSelect;fileSelectorElement;selection;constructor(){super("timeline"),this.element.addEventListener("contextmenu",this.contextMenu.bind(this),!1),this.dropTarget=new UI.DropTarget.DropTarget(this.element,[UI.DropTarget.Type.File,UI.DropTarget.Type.URI],i18nString(UIStrings.dropTimelineFileOrUrlHere),this.handleDrop.bind(this)),this.recordingOptionUIControls=[],this.state=State.Idle,this.recordingPageReload=!1,this.millisecondsToRecordAfterLoadEvent=5e3,this.toggleRecordAction=UI.ActionRegistry.ActionRegistry.instance().action("timeline.toggle-recording"),this.recordReloadAction=UI.ActionRegistry.ActionRegistry.instance().action("timeline.record-reload"),this.historyManager=new TimelineHistoryManager,this.performanceModel=null,this.viewModeSetting=Common.Settings.Settings.instance().createSetting("timelineViewMode",ViewMode.FlameChart),this.disableCaptureJSProfileSetting=Common.Settings.Settings.instance().createSetting("timelineDisableJSSampling",!1),this.disableCaptureJSProfileSetting.setTitle(i18nString(UIStrings.disableJavascriptSamples)),this.captureLayersAndPicturesSetting=Common.Settings.Settings.instance().createSetting("timelineCaptureLayersAndPictures",!1),this.captureLayersAndPicturesSetting.setTitle(i18nString(UIStrings.enableAdvancedPaint)),this.showScreenshotsSetting=Common.Settings.Settings.instance().createSetting("timelineShowScreenshots",!0),this.showScreenshotsSetting.setTitle(i18nString(UIStrings.screenshots)),this.showScreenshotsSetting.addChangeListener(this.updateOverviewControls,this),this.startCoverage=Common.Settings.Settings.instance().createSetting("timelineStartCoverage",!1),this.startCoverage.setTitle(i18nString(UIStrings.coverage)),Root.Runtime.experiments.isEnabled("recordCoverageWithPerformanceTracing")||this.startCoverage.set(!1),this.showMemorySetting=Common.Settings.Settings.instance().createSetting("timelineShowMemory",!1),this.showMemorySetting.setTitle(i18nString(UIStrings.memory)),this.showMemorySetting.addChangeListener(this.onModeChanged,this),this.showWebVitalsSetting=Common.Settings.Settings.instance().createSetting("timelineWebVitals",!1),this.showWebVitalsSetting.setTitle(i18nString(UIStrings.webVitals)),this.showWebVitalsSetting.addChangeListener(this.onWebVitalsChanged,this);const e=this.element.createChild("div","timeline-toolbar-container");this.panelToolbar=new UI.Toolbar.Toolbar("timeline-main-toolbar",e),this.panelToolbar.makeWrappable(!0),this.panelRightToolbar=new UI.Toolbar.Toolbar("",e),this.createSettingsPane(),this.updateShowSettingsToolbarButton(),this.timelinePane=new UI.Widget.VBox,this.timelinePane.show(this.element);const t=this.timelinePane.element.createChild("div","hbox");t.id="timeline-overview-panel",this.overviewPane=new PerfUI.TimelineOverviewPane.TimelineOverviewPane("timeline"),this.overviewPane.addEventListener(PerfUI.TimelineOverviewPane.Events.WindowChanged,this.onOverviewWindowChanged.bind(this)),this.overviewPane.show(t),this.overviewControls=[],this.statusPaneContainer=this.timelinePane.element.createChild("div","status-pane-container fill"),this.createFileSelector(),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.ResourceTreeModel.ResourceTreeModel,SDK.ResourceTreeModel.Events.Load,this.loadEventFired,this),this.flameChart=new TimelineFlameChartView(this),this.searchableViewInternal=new UI.SearchableView.SearchableView(this.flameChart,null),this.searchableViewInternal.setMinimumSize(0,100),this.searchableViewInternal.element.classList.add("searchable-view"),this.searchableViewInternal.show(this.timelinePane.element),this.flameChart.show(this.searchableViewInternal.element),this.flameChart.setSearchableView(this.searchableViewInternal),this.searchableViewInternal.hideWidget(),this.onModeChanged(),this.onWebVitalsChanged(),this.populateToolbar(),this.showLandingPage(),this.updateTimelineControls(),Extensions.ExtensionServer.ExtensionServer.instance().addEventListener(Extensions.ExtensionServer.Events.TraceProviderAdded,this.appendExtensionsToToolbar,this),SDK.TargetManager.TargetManager.instance().addEventListener(SDK.TargetManager.Events.SuspendStateChanged,this.onSuspendStateChanged,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return timelinePanelInstance&&!t||(timelinePanelInstance=new TimelinePanel),timelinePanelInstance}searchableView(){return this.searchableViewInternal}wasShown(){super.wasShown(),UI.Context.Context.instance().setFlavor(TimelinePanel,this),this.registerCSSFiles([timelinePanelStyles]),Host.userMetrics.panelLoaded("timeline","DevTools.Launch.Timeline")}willHide(){UI.Context.Context.instance().setFlavor(TimelinePanel,null),this.historyManager.cancelIfShowing()}loadFromEvents(e){this.state===State.Idle&&(this.prepareToLoadTimeline(),this.loader=TimelineLoader.loadFromEvents(e,this))}onOverviewWindowChanged(e){if(!this.performanceModel)return;const t=e.data.startTime,i=e.data.endTime;this.performanceModel.setWindow({left:t,right:i},!0)}onModelWindowChanged(e){const t=e.data.window;this.overviewPane.setWindowTimes(t.left,t.right)}setState(e){this.state=e,this.updateTimelineControls()}createSettingCheckbox(e,t){const i=new UI.Toolbar.ToolbarSettingCheckbox(e,t);return this.recordingOptionUIControls.push(i),i}populateToolbar(){this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.toggleRecordAction)),this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButton(this.recordReloadAction)),this.clearButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clear),"largeicon-clear"),this.clearButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>this.onClearButton())),this.panelToolbar.appendToolbarItem(this.clearButton),this.loadButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.loadProfile),"largeicon-load"),this.loadButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{Host.userMetrics.actionTaken(Host.UserMetrics.Action.PerfPanelTraceImported),this.selectFileToLoad()})),this.saveButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.saveProfile),"largeicon-download"),this.saveButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(e=>{Host.userMetrics.actionTaken(Host.UserMetrics.Action.PerfPanelTraceExported),this.saveToFile()})),this.panelToolbar.appendSeparator(),this.panelToolbar.appendToolbarItem(this.loadButton),this.panelToolbar.appendToolbarItem(this.saveButton),this.panelToolbar.appendSeparator(),this.panelToolbar.appendToolbarItem(this.historyManager.button()),this.panelToolbar.registerCSSFiles([historyToolbarButtonStyles]),this.panelToolbar.appendSeparator(),this.panelToolbar.appendSeparator(),this.showScreenshotsToolbarCheckbox=this.createSettingCheckbox(this.showScreenshotsSetting,i18nString(UIStrings.captureScreenshots)),this.panelToolbar.appendToolbarItem(this.showScreenshotsToolbarCheckbox),this.showMemoryToolbarCheckbox=this.createSettingCheckbox(this.showMemorySetting,i18nString(UIStrings.showMemoryTimeline)),this.panelToolbar.appendToolbarItem(this.showMemoryToolbarCheckbox),this.showWebVitalsToolbarCheckbox=this.createSettingCheckbox(this.showWebVitalsSetting,i18nString(UIStrings.showWebVitals)),this.panelToolbar.appendToolbarItem(this.showWebVitalsToolbarCheckbox),Root.Runtime.experiments.isEnabled("recordCoverageWithPerformanceTracing")&&(this.startCoverageCheckbox=this.createSettingCheckbox(this.startCoverage,i18nString(UIStrings.recordCoverageWithPerformance)),this.panelToolbar.appendToolbarItem(this.startCoverageCheckbox)),this.panelToolbar.appendToolbarItem(UI.Toolbar.Toolbar.createActionButtonForId("components.collect-garbage")),this.panelRightToolbar.appendSeparator(),this.panelRightToolbar.appendToolbarItem(this.showSettingsPaneButton)}createSettingsPane(){this.showSettingsPaneSetting=Common.Settings.Settings.instance().createSetting("timelineShowSettingsToolbar",!1),this.showSettingsPaneButton=new UI.Toolbar.ToolbarSettingToggle(this.showSettingsPaneSetting,"largeicon-settings-gear",i18nString(UIStrings.captureSettings)),SDK.NetworkManager.MultitargetNetworkManager.instance().addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,this.updateShowSettingsToolbarButton,this),SDK.CPUThrottlingManager.CPUThrottlingManager.instance().addEventListener(SDK.CPUThrottlingManager.Events.RateChanged,this.updateShowSettingsToolbarButton,this),this.disableCaptureJSProfileSetting.addChangeListener(this.updateShowSettingsToolbarButton,this),this.captureLayersAndPicturesSetting.addChangeListener(this.updateShowSettingsToolbarButton,this),this.settingsPane=new UI.Widget.HBox,this.settingsPane.element.classList.add("timeline-settings-pane"),this.settingsPane.show(this.element);const e=new UI.Toolbar.Toolbar("",this.settingsPane.element);e.element.classList.add("flex-auto"),e.makeVertical(),e.appendToolbarItem(this.createSettingCheckbox(this.disableCaptureJSProfileSetting,i18nString(UIStrings.disablesJavascriptSampling))),e.appendToolbarItem(this.createSettingCheckbox(this.captureLayersAndPicturesSetting,i18nString(UIStrings.capturesAdvancedPaint)));const t=new UI.Widget.VBox;t.element.classList.add("flex-auto"),t.show(this.settingsPane.element);const i=new UI.Toolbar.Toolbar("",t.element);i.appendText(i18nString(UIStrings.network)),this.networkThrottlingSelect=this.createNetworkConditionsSelect(),i.appendToolbarItem(this.networkThrottlingSelect);const n=new UI.Toolbar.Toolbar("",t.element);n.appendText(i18nString(UIStrings.cpu)),this.cpuThrottlingSelect=MobileThrottling.ThrottlingManager.throttlingManager().createCPUThrottlingSelector(),n.appendToolbarItem(this.cpuThrottlingSelect),this.showSettingsPaneSetting.addChangeListener(this.updateSettingsPaneVisibility.bind(this)),this.updateSettingsPaneVisibility()}appendExtensionsToToolbar(e){const t=e.data,i=TimelinePanel.settingForTraceProvider(t),n=this.createSettingCheckbox(i,t.longDisplayName());this.panelToolbar.appendToolbarItem(n)}static settingForTraceProvider(e){let t=traceProviderToSetting.get(e);if(!t){const i=e.persistentIdentifier();t=Common.Settings.Settings.instance().createSetting(i,!1),t.setTitle(e.shortDisplayName()),traceProviderToSetting.set(e,t)}return t}createNetworkConditionsSelect(){const e=new UI.Toolbar.ToolbarComboBox(null,i18nString(UIStrings.networkConditions));return e.setMaxWidth(140),MobileThrottling.ThrottlingManager.throttlingManager().decorateSelectWithNetworkThrottling(e.selectElement()),e}prepareToLoadTimeline(){console.assert(this.state===State.Idle),this.setState(State.Loading),this.performanceModel&&(this.performanceModel.dispose(),this.performanceModel=null)}createFileSelector(){this.fileSelectorElement&&this.fileSelectorElement.remove(),this.fileSelectorElement=UI.UIUtils.createFileSelectorElement(this.loadFromFile.bind(this)),this.timelinePane.element.appendChild(this.fileSelectorElement)}contextMenu(e){const t=new UI.ContextMenu.ContextMenu(e);t.appendItemsAtLocation("timelineMenu"),t.show()}async saveToFile(){if(this.state!==State.Idle)return;const e=this.performanceModel;if(!e)return;const t=new Date,i="Profile-"+Platform.DateUtilities.toISO8601Compact(t)+".json",n=new Bindings.FileUtils.FileOutputStream;if(!await n.open(i))return;const s=await e.save(n);s&&Common.Console.Console.instance().error(i18nString(UIStrings.failedToSaveTimelineSSS,{PH1:s.message,PH2:s.name,PH3:s.code}))}async showHistory(){const e=await this.historyManager.showHistoryDropDown();e&&e!==this.performanceModel&&this.setModel(e)}navigateHistory(e){const t=this.historyManager.navigate(e);return t&&t!==this.performanceModel&&this.setModel(t),!0}selectFileToLoad(){this.fileSelectorElement&&this.fileSelectorElement.click()}loadFromFile(e){this.state===State.Idle&&(this.prepareToLoadTimeline(),this.loader=TimelineLoader.loadFromFile(e,this),this.createFileSelector())}loadFromURL(e){this.state===State.Idle&&(this.prepareToLoadTimeline(),this.loader=TimelineLoader.loadFromURL(e,this))}updateOverviewControls(){this.overviewControls=[],this.overviewControls.push(new TimelineEventOverviewResponsiveness),Root.Runtime.experiments.isEnabled("inputEventsOnTimelineOverview")&&this.overviewControls.push(new TimelineEventOverviewInput),this.overviewControls.push(new TimelineEventOverviewFrames),this.overviewControls.push(new TimelineEventOverviewCPUActivity),this.overviewControls.push(new TimelineEventOverviewNetwork),this.showScreenshotsSetting.get()&&this.performanceModel&&this.performanceModel.filmStripModel().frames().length&&this.overviewControls.push(new TimelineFilmStripOverview),this.showMemorySetting.get()&&this.overviewControls.push(new TimelineEventOverviewMemory),this.startCoverage.get()&&this.overviewControls.push(new TimelineEventOverviewCoverage);for(const e of this.overviewControls)e.setModel(this.performanceModel);this.overviewPane.setOverviewControls(this.overviewControls)}onModeChanged(){this.updateOverviewControls(),this.doResize(),this.select(null)}onWebVitalsChanged(){this.flameChart.toggleWebVitalsLane()}updateSettingsPaneVisibility(){this.showSettingsPaneSetting.get()?this.settingsPane.showWidget():this.settingsPane.hideWidget()}updateShowSettingsToolbarButton(){const e=[];if(1!==SDK.CPUThrottlingManager.CPUThrottlingManager.instance().cpuThrottlingRate()&&e.push(i18nString(UIStrings.CpuThrottlingIsEnabled)),SDK.NetworkManager.MultitargetNetworkManager.instance().isThrottling()&&e.push(i18nString(UIStrings.NetworkThrottlingIsEnabled)),this.captureLayersAndPicturesSetting.get()&&e.push(i18nString(UIStrings.SignificantOverheadDueToPaint)),this.disableCaptureJSProfileSetting.get()&&e.push(i18nString(UIStrings.JavascriptSamplingIsDisabled)),this.showSettingsPaneButton.setDefaultWithRedColor(e.length>0),this.showSettingsPaneButton.setToggleWithRedColor(e.length>0),e.length){const t=document.createElement("div");e.forEach((e=>{t.createChild("div").textContent=e})),this.showSettingsPaneButton.setTitle(t.textContent||"")}else this.showSettingsPaneButton.setTitle(i18nString(UIStrings.captureSettings))}setUIControlsEnabled(e){this.recordingOptionUIControls.forEach((t=>t.setEnabled(e)))}async getCoverageViewWidget(){const e=UI.ViewManager.ViewManager.instance().view("coverage");return await e.widget()}async startRecording(){console.assert(!this.statusPane,"Status pane is already opened."),this.setState(State.StartPending);const e={enableJSSampling:!this.disableCaptureJSProfileSetting.get(),capturePictures:this.captureLayersAndPicturesSetting.get(),captureFilmStrip:this.showScreenshotsSetting.get(),startCoverage:this.startCoverage.get()};e.startCoverage&&await UI.ViewManager.ViewManager.instance().showView("coverage").then((()=>this.getCoverageViewWidget())).then((e=>e.ensureRecordingStarted())),this.showRecordingStarted();const t=Extensions.ExtensionServer.ExtensionServer.instance().traceProviders().filter((e=>TimelinePanel.settingForTraceProvider(e).get())),i=SDK.TargetManager.TargetManager.instance().mainTarget();UIDevtoolsUtils.isUiDevTools()?this.controller=new UIDevtoolsController(i,this):this.controller=new TimelineController(i,this),this.setUIControlsEnabled(!1),this.hideLandingPage();try{const i=await this.controller.startRecording(e,t);if(i.getError())throw new Error(i.getError());this.recordingStarted()}catch(e){this.recordingFailed(e.message)}}async stopRecording(){if(this.statusPane&&(this.statusPane.finish(),this.statusPane.updateStatus(i18nString(UIStrings.stoppingTimeline)),this.statusPane.updateProgressBar(i18nString(UIStrings.received),0)),this.setState(State.StopPending),this.startCoverage.get()&&await UI.ViewManager.ViewManager.instance().showView("coverage").then((()=>this.getCoverageViewWidget())).then((e=>e.stopRecording())),this.controller){const e=await this.controller.stopRecording();this.performanceModel=e,this.setUIControlsEnabled(!0),this.controller.dispose(),this.controller=null}}recordingFailed(e){this.statusPane&&this.statusPane.hide(),this.statusPane=new StatusPane({description:e,buttonText:i18nString(UIStrings.close),buttonDisabled:!1,showProgress:void 0,showTimer:void 0},(()=>this.loadingComplete(null))),this.statusPane.showPane(this.statusPaneContainer),this.statusPane.updateStatus(i18nString(UIStrings.recordingFailed)),this.setState(State.RecordingFailed),this.performanceModel=null,this.setUIControlsEnabled(!0),this.controller&&(this.controller.dispose(),this.controller=null)}onSuspendStateChanged(){this.updateTimelineControls()}updateTimelineControls(){const e=State;this.toggleRecordAction.setToggled(this.state===e.Recording),this.toggleRecordAction.setEnabled(this.state===e.Recording||this.state===e.Idle),this.recordReloadAction.setEnabled(this.state===e.Idle),this.historyManager.setEnabled(this.state===e.Idle),this.clearButton.setEnabled(this.state===e.Idle),this.panelToolbar.setEnabled(this.state!==e.Loading),this.panelRightToolbar.setEnabled(this.state!==e.Loading),this.dropTarget.setEnabled(this.state===e.Idle),this.loadButton.setEnabled(this.state===e.Idle),this.saveButton.setEnabled(this.state===e.Idle&&Boolean(this.performanceModel))}toggleRecording(){this.state===State.Idle?(this.recordingPageReload=!1,this.startRecording(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.TimelineStarted)):this.state===State.Recording&&this.stopRecording()}recordReload(){this.state===State.Idle&&(this.recordingPageReload=!0,this.startRecording(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.TimelinePageReloadStarted))}onClearButton(){this.historyManager.clear(),this.clear()}clear(){this.showLandingPage(),this.reset()}reset(){PerfUI.LineLevelProfile.Performance.instance().reset(),this.setModel(null)}applyFilters(e){e.timelineModel().isGenericTrace()||Root.Runtime.experiments.isEnabled("timelineShowAllEvents")||e.setFilters([TimelineUIUtils.visibleEventsFilter()])}setModel(e){if(this.performanceModel&&this.performanceModel.removeEventListener(Events.WindowChanged,this.onModelWindowChanged,this),this.performanceModel=e,e?(this.searchableViewInternal.showWidget(),this.applyFilters(e)):this.searchableViewInternal.hideWidget(),this.flameChart.setModel(e),this.updateOverviewControls(),this.overviewPane.reset(),e&&this.performanceModel){this.performanceModel.addEventListener(Events.WindowChanged,this.onModelWindowChanged,this),this.overviewPane.setNavStartTimes(e.timelineModel().navStartTimes()),this.overviewPane.setBounds(e.timelineModel().minimumRecordTime(),e.timelineModel().maximumRecordTime()),PerfUI.LineLevelProfile.Performance.instance().reset();for(const t of e.timelineModel().cpuProfiles())PerfUI.LineLevelProfile.Performance.instance().appendCPUProfile(t);this.setMarkers(e.timelineModel()),this.flameChart.setSelection(null),this.overviewPane.setWindowTimes(e.window().left,e.window().right)}for(const t of this.overviewControls)t.setModel(e);this.flameChart&&this.flameChart.resizeToPreferredHeights(),this.updateTimelineControls()}recordingStarted(){if(this.recordingPageReload&&this.controller){const e=this.controller.mainTarget().model(SDK.ResourceTreeModel.ResourceTreeModel);e&&e.reloadPage()}this.reset(),this.setState(State.Recording),this.showRecordingStarted(),this.statusPane&&(this.statusPane.enableAndFocusButton(),this.statusPane.updateStatus(i18nString(UIStrings.profiling)),this.statusPane.updateProgressBar(i18nString(UIStrings.bufferUsage),0),this.statusPane.startTimer()),this.hideLandingPage()}recordingProgress(e){this.statusPane&&this.statusPane.updateProgressBar(i18nString(UIStrings.bufferUsage),100*e)}showLandingPage(){if(this.landingPage)return void this.landingPage.show(this.statusPaneContainer);function e(e,t){const i=document.createElement(e);return i.textContent=t,i}const t=UI.XLink.XLink.create("https://developer.chrome.com/docs/devtools/evaluate-performance/",i18nString(UIStrings.learnmore)),i=e("b",UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("timeline.toggle-recording")[0].title()),n=e("b",UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("timeline.record-reload")[0].title()),s=e("b",i18nString(UIStrings.wasd));this.landingPage=new UI.Widget.VBox,this.landingPage.contentElement.classList.add("timeline-landing-page","fill");const o=this.landingPage.contentElement.createChild("div"),r=UI.UIUtils.createInlineButton(UI.Toolbar.Toolbar.createActionButton(this.toggleRecordAction)),a=UI.UIUtils.createInlineButton(UI.Toolbar.Toolbar.createActionButtonForId("timeline.record-reload"));o.createChild("p").appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.clickTheRecordButtonSOrHitSTo,{PH1:r,PH2:i})),o.createChild("p").appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.clickTheReloadButtonSOrHitSTo,{PH1:a,PH2:n})),o.createChild("p").appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.afterRecordingSelectAnAreaOf,{PH1:s,PH2:t})),this.landingPage.show(this.statusPaneContainer)}hideLandingPage(){this.landingPage.detach()}loadingStarted(){this.hideLandingPage(),this.statusPane&&this.statusPane.hide(),this.statusPane=new StatusPane({showProgress:!0,showTimer:void 0,buttonDisabled:void 0,buttonText:void 0,description:void 0},(()=>this.cancelLoading())),this.statusPane.showPane(this.statusPaneContainer),this.statusPane.updateStatus(i18nString(UIStrings.loadingProfile)),this.loader||this.statusPane.finish(),this.loadingProgress(0)}loadingProgress(e){"number"==typeof e&&this.statusPane&&this.statusPane.updateProgressBar(i18nString(UIStrings.received),100*e)}processingStarted(){this.statusPane&&this.statusPane.updateStatus(i18nString(UIStrings.processingProfile))}loadingComplete(e){delete this.loader,this.setState(State.Idle),this.statusPane&&this.statusPane.hide(),this.statusPane=null,e?(this.performanceModel||(this.performanceModel=new PerformanceModel),this.performanceModel.setTracingModel(e),this.setModel(this.performanceModel),this.historyManager.addRecording(this.performanceModel),this.startCoverage.get()&&UI.ViewManager.ViewManager.instance().showView("coverage").then((()=>this.getCoverageViewWidget())).then((e=>e.processBacklog())).then((()=>this.updateOverviewControls()))):this.clear()}showRecordingStarted(){this.statusPane||(this.statusPane=new StatusPane({showTimer:!0,showProgress:!0,buttonDisabled:!0,description:void 0,buttonText:void 0},(()=>this.stopRecording())),this.statusPane.showPane(this.statusPaneContainer),this.statusPane.updateStatus(i18nString(UIStrings.initializingProfiler)))}cancelLoading(){this.loader&&this.loader.cancel()}setMarkers(e){const t=new Map,i=TimelineModel.TimelineModel.RecordType,n=e.minimumRecordTime();for(const s of e.timeMarkerEvents())s.name!==i.TimeStamp&&s.name!==i.ConsoleTime&&t.set(s.startTime,TimelineUIUtils.createEventDivider(s,n));for(const i of e.navStartTimes().values())t.set(i.startTime,TimelineUIUtils.createEventDivider(i,n));this.overviewPane.setMarkers(t)}async loadEventFired(e){if(this.state!==State.Recording||!this.recordingPageReload||!this.controller||this.controller.mainTarget()!==e.data.resourceTreeModel.target())return;const t=this.controller;await new Promise((e=>setTimeout(e,this.millisecondsToRecordAfterLoadEvent))),t===this.controller&&this.state===State.Recording&&this.stopRecording()}frameForSelection(e){switch(e.type()){case TimelineSelection.Type.Frame:return e.object();case TimelineSelection.Type.Range:return null;case TimelineSelection.Type.TraceEvent:return this.performanceModel?this.performanceModel.frameModel().getFramesWithinWindow(e.endTimeInternal,e.endTimeInternal)[0]:null;default:return console.assert(!1,"Should never be reached"),null}}jumpToFrame(e){const t=this.selection&&this.frameForSelection(this.selection);if(!t||!this.performanceModel)return;const i=this.performanceModel.frames();let n=i.indexOf(t);console.assert(n>=0,"Can't find current frame in the frame list"),n=Platform.NumberUtilities.clamp(n+e,0,i.length-1);const s=i[n];return this.revealTimeRange(s.startTime,s.endTime),this.select(TimelineSelection.fromFrame(s)),!0}select(e){this.selection=e,this.flameChart.setSelection(e)}selectEntryAtTime(e,t){if(e){for(let i=Platform.ArrayUtilities.upperBound(e,t,((e,t)=>e-t.startTime))-1;i>=0;--i){const n=e[i],s=n.endTime||n.startTime;if(SDK.TracingModel.TracingModel.isTopLevelEvent(n)&&s<t)break;if(this.performanceModel&&this.performanceModel.isVisible(n)&&s>=t)return void this.select(TimelineSelection.fromTraceEvent(n))}this.select(null)}}highlightEvent(e){this.flameChart.highlightEvent(e)}revealTimeRange(e,t){if(!this.performanceModel)return;const i=this.performanceModel.window();let n=0;i.right<t?n=t-i.right:i.left>e&&(n=e-i.left),this.performanceModel.setWindow({left:i.left+n,right:i.right+n},!0)}handleDrop(e){const t=e.items;if(!t.length)return;const i=t[0];if(Host.userMetrics.actionTaken(Host.UserMetrics.Action.PerfPanelTraceImported),"string"===i.kind){const t=e.getData("text/uri-list");new Common.ParsedURL.ParsedURL(t).isValid&&this.loadFromURL(t)}else if("file"===i.kind){const e=t[0].getAsFile();if(!e)return;this.loadFromFile(e)}}}export var State;!function(e){e.Idle="Idle",e.StartPending="StartPending",e.Recording="Recording",e.StopPending="StopPending",e.Loading="Loading",e.RecordingFailed="RecordingFailed"}(State||(State={}));export var ViewMode;!function(e){e.FlameChart="FlameChart",e.BottomUp="BottomUp",e.CallTree="CallTree",e.EventLog="EventLog"}(ViewMode||(ViewMode={}));export const rowHeight=18;export const headerHeight=20;export class TimelineSelection{typeInternal;startTimeInternal;endTimeInternal;objectInternal;constructor(e,t,i,n){this.typeInternal=e,this.startTimeInternal=t,this.endTimeInternal=i,this.objectInternal=n||null}static fromFrame(e){return new TimelineSelection(TimelineSelection.Type.Frame,e.startTime,e.endTime,e)}static fromNetworkRequest(e){return new TimelineSelection(TimelineSelection.Type.NetworkRequest,e.startTime,e.endTime||e.startTime,e)}static fromTraceEvent(e){return new TimelineSelection(TimelineSelection.Type.TraceEvent,e.startTime,e.endTime||e.startTime+1,e)}static fromRange(e,t){return new TimelineSelection(TimelineSelection.Type.Range,e,t)}type(){return this.typeInternal}object(){return this.objectInternal}startTime(){return this.startTimeInternal}endTime(){return this.endTimeInternal}}!function(e){let t;!function(e){e.Frame="Frame",e.NetworkRequest="NetworkRequest",e.TraceEvent="TraceEvent",e.Range="Range"}(t=e.Type||(e.Type={}))}(TimelineSelection||(TimelineSelection={}));export class StatusPane extends UI.Widget.VBox{status;time;progressLabel;progressBar;description;button;startTime;timeUpdateTimer;constructor(e,t){super(!0),this.contentElement.classList.add("timeline-status-dialog");const i=this.contentElement.createChild("div","status-dialog-line status");if(i.createChild("div","label").textContent=i18nString(UIStrings.status),this.status=i.createChild("div","content"),UI.ARIAUtils.markAsStatus(this.status),e.showTimer){const e=this.contentElement.createChild("div","status-dialog-line time");e.createChild("div","label").textContent=i18nString(UIStrings.time),this.time=e.createChild("div","content")}if(e.showProgress){const e=this.contentElement.createChild("div","status-dialog-line progress");this.progressLabel=e.createChild("div","label"),this.progressBar=e.createChild("div","indicator-container").createChild("div","indicator"),UI.ARIAUtils.markAsProgressBar(this.progressBar)}if("string"==typeof e.description){const t=this.contentElement.createChild("div","status-dialog-line description");t.createChild("div","label").textContent=i18nString(UIStrings.description),this.description=t.createChild("div","content"),this.description.innerText=e.description}const n=e.buttonText||i18nString(UIStrings.stop);this.button=UI.UIUtils.createTextButton(n,t,"",!0),this.button.disabled=!1==!e.buttonDisabled,this.contentElement.createChild("div","stop-button").appendChild(this.button)}finish(){this.stopTimer(),this.button.disabled=!0}hide(){this.element.parentNode.classList.remove("tinted"),this.arrangeDialog(this.element.parentNode),this.element.remove()}showPane(e){this.arrangeDialog(e),this.show(e),e.classList.add("tinted")}enableAndFocusButton(){this.button.disabled=!1,this.button.focus()}updateStatus(e){this.status.textContent=e}updateProgressBar(e,t){this.progressLabel.textContent=e,this.progressBar.style.width=t.toFixed(1)+"%",UI.ARIAUtils.setValueNow(this.progressBar,t),this.updateTimer()}startTimer(){this.startTime=Date.now(),this.timeUpdateTimer=window.setInterval(this.updateTimer.bind(this,!1),1e3),this.updateTimer()}stopTimer(){this.timeUpdateTimer&&(clearInterval(this.timeUpdateTimer),this.updateTimer(!0),delete this.timeUpdateTimer)}updateTimer(e){if(this.arrangeDialog(this.element.parentNode),!this.timeUpdateTimer)return;const t=(Date.now()-this.startTime)/1e3;this.time.textContent=i18nString(UIStrings.ssec,{PH1:t.toFixed(e?1:0)})}arrangeDialog(e){const t=e.clientWidth<325;this.element.classList.toggle("small-dialog",t),this.contentElement.classList.toggle("small-dialog",t)}wasShown(){super.wasShown(),this.registerCSSFiles([timelineStatusDialogStyles])}}export class LoadTimelineHandler{static instance(e={forceNew:null}){const{forceNew:t}=e;return loadTimelineHandlerInstance&&!t||(loadTimelineHandlerInstance=new LoadTimelineHandler),loadTimelineHandlerInstance}handleQueryParam(e){UI.ViewManager.ViewManager.instance().showView("timeline").then((()=>{TimelinePanel.instance().loadFromURL(window.decodeURIComponent(e))}))}}export class ActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return actionDelegateInstance&&!t||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(e,t){const i=UI.Context.Context.instance().flavor(TimelinePanel);switch(console.assert(i&&i instanceof TimelinePanel),t){case"timeline.toggle-recording":return i.toggleRecording(),!0;case"timeline.record-reload":return i.recordReload(),!0;case"timeline.save-to-file":return i.saveToFile(),!0;case"timeline.load-from-file":return i.selectFileToLoad(),!0;case"timeline.jump-to-previous-frame":return i.jumpToFrame(-1),!0;case"timeline.jump-to-next-frame":return i.jumpToFrame(1),!0;case"timeline.show-history":return i.showHistory(),!0;case"timeline.previous-recording":return i.navigateHistory(1),!0;case"timeline.next-recording":return i.navigateHistory(-1),!0}return!1}}const traceProviderToSetting=new WeakMap;