const styles=new CSSStyleSheet;styles.replaceSync("/*\n * Copyright 2021 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n* {\n  margin: 0;\n  padding: 0;\n  box-sizing: border-box;\n}\n\n/**\n* Reset default UA styles for focused elements.\n* The button styles below explicitly implement custom focus styles.\n*/\n*:focus,\n*:focus-visible,\n:host(:focus),\n:host(:focus-visible) {\n  outline: none;\n}\n\n:host {\n  display: inline-flex;\n  flex-direction: row;\n}\n\nbutton {\n  align-items: center;\n  border-radius: 4px;\n  display: inline-flex;\n  font-family: inherit;\n  font-size: 12px;\n  font-weight: 500;\n  height: 24px;\n  line-height: 14px;\n  padding: 5px 12px;\n  justify-content: center;\n  width: 100%;\n}\n\nbutton.small {\n  height: 18px;\n  border-radius: 2px;\n}\n\nbutton:focus-visible {\n  box-shadow: 0 0 0 2px var(--color-button-outline-focus);\n}\n\nbutton:hover {\n  cursor: pointer;\n}\n\nbutton.toolbar {\n  background: transparent;\n  border-radius: 2px;\n  border: none;\n  height: 24px;\n  width: 24px;\n  overflow: hidden;\n  padding: 0;\n  white-space: nowrap;\n}\n\nbutton.toolbar.small {\n  height: 18px;\n  width: 18px;\n}\n\nbutton.primary {\n  border: 1px solid var(--color-primary);\n  background: var(--color-primary);\n  color: var(--color-background);\n}\n\nbutton.primary:hover {\n  background: var(--color-button-primary-background-hovering);\n  border: 1px solid var(--color-button-primary-background-hovering);\n}\n\nbutton.primary.active,\nbutton.primary:active {\n  background: var(--color-button-primary-background-pressed);\n  border: 1px solid var(--color-button-primary-background-pressed);\n}\n\nbutton.primary:disabled,\nbutton.primary:disabled:hover {\n  border: 1px solid transparent;\n  background: var(--color-background-elevation-1);\n  color: var(--color-text-disabled);\n  cursor: not-allowed;\n}\n\nbutton.secondary {\n  border: 1px solid var(--color-details-hairline);\n  background: var(--color-background);\n  color: var(--color-primary);\n}\n\nbutton.secondary:hover {\n  background: var(--color-button-secondary-background-hovering);\n}\n\nbutton.secondary.active,\nbutton.secondary:active {\n  background: var(--color-button-secondary-background-pressed);\n  border: 1px solid var(--color-button-secondary-background-pressed);\n}\n\nbutton.secondary:focus-visible {\n  border: 1px solid var(--color-background);\n}\n\nbutton.secondary:disabled,\nbutton.secondary:disabled:hover {\n  border: 1px solid var(--color-background-elevation-1);\n  background: var(--color-background);\n  color: var(--color-text-disabled);\n  cursor: not-allowed;\n}\n\nbutton.secondary.active:focus-visible,\nbutton.secondary:active:focus-visible {\n  border: 1px solid var(--color-button-secondary-background-pressed);\n}\n\nbutton.toolbar:hover {\n  background-color: var(--color-button-secondary-background-hovering);\n}\n\nbutton.toolbar.active,\nbutton.toolbar:active {\n  background-color: var(--color-button-secondary-background-pressed);\n}\n\nbutton.toolbar:focus-visible {\n  background-color: var(--color-background-elevation-2);\n}\n\nbutton.toolbar:disabled,\nbutton.toolbar:disabled:hover {\n  border: 1px solid transparent;\n  background: var(--color-background);\n  color: var(--color-text-disabled);\n  cursor: not-allowed;\n}\n\nbutton.text-with-icon {\n  padding: 0 12px 0 4px;\n}\n\nbutton.small.text-with-icon {\n  padding: 0 9px 0 3px;\n}\n\nbutton.only-icon {\n  padding: 0;\n}\n\nbutton devtools-icon {\n  width: 19px;\n  height: 19px;\n}\n\nbutton.toolbar devtools-icon {\n  width: 24px;\n  height: 24px;\n\n  --icon-color: var(--color-text-primary);\n}\n\nbutton.primary devtools-icon {\n  --icon-color: var(--color-background);\n}\n\nbutton.secondary devtools-icon {\n  --icon-color: var(--color-primary);\n}\n\nbutton.small devtools-icon {\n  width: 14px;\n  height: 14px;\n}\n\nbutton.toolbar.small devtools-icon {\n  width: 18px;\n  height: 18px;\n}\n\nbutton.toolbar:disabled devtools-icon {\n  --icon-color: var(--color-text-disabled);\n}\n\nbutton.primary:disabled devtools-icon {\n  --icon-color: var(--color-text-disabled);\n}\n\nbutton.secondary:disabled devtools-icon {\n  --icon-color: var(--color-text-disabled);\n}\n\n.spinner-component.secondary {\n  border: 2px solid var(--color-primary);\n  border-right-color: transparent;\n}\n\n.spinner-component.disabled {\n  border: 2px solid var(--color-text-disabled);\n  border-right-color: transparent;\n}\n\n.spinner-component {\n  display: block;\n  width: 12px;\n  height: 12px;\n  border-radius: 6px;\n  border: 2px solid var(--color-background);\n  animation: spinner-animation 1s linear infinite;\n  border-right-color: transparent;\n  margin-right: 6px;\n}\n\n@keyframes spinner-animation {\n  from {\n    transform: rotate(0);\n  }\n\n  to {\n    transform: rotate(360deg);\n  }\n}\n\n/*# sourceURL=button.css */\n");export default styles;