const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2021 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n:host {\n  height: 100%;\n  display: block;\n  position: relative;\n}\n\n/* Ensure that vertically we don\'t overflow */\n.wrapping-container {\n  overflow-y: auto;\n  /* Use max-height instead of height to ensure that the\n    table does not use more space than necessary. */\n  height: 100%;\n}\n\n.wrapping-container::-webkit-scrollbar {\n  display: none;\n}\n\ntable {\n  border-spacing: 0;\n  width: 100%;\n  height: 100%;\n  /* To make sure that we properly hide overflowing text\n    when horizontal space is too narrow. */\n  table-layout: fixed;\n}\n\ntr {\n  outline: none;\n}\n\nthead tr {\n  height: 27px;\n}\n\ntbody tr {\n  background-color: var(--override-data-grid-row-background-color, --color-background);\n}\n\ntbody tr.selected {\n  background-color: var(--color-background-elevation-1);\n}\n\ntd,\nth {\n  padding: 1px 4px;\n  border-left: 1px solid var(--color-details-hairline);\n  color: var(--color-text-primary);\n  line-height: var(--table-row-height);\n  height: var(--table-row-height);\n  user-select: text;\n  /* Ensure that text properly cuts off if horizontal space is too narrow */\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  overflow: hidden;\n}\n\nth {\n  font-weight: normal;\n  text-align: left;\n  border-bottom: 1px solid var(--color-details-hairline);\n  position: sticky;\n  top: 0;\n  z-index: 2;\n  background-color: var(--color-background-elevation-1);\n}\n\ntd:focus,\nth:focus {\n  outline: var(--color-primary) auto 1px;\n}\n\n.cell-resize-handle {\n  top: 0;\n  height: 100%;\n  z-index: 3;\n  width: 20px;\n  cursor: col-resize;\n  position: absolute;\n}\n\n/* There is no divider before the first cell */\ntd.firstVisibleColumn,\nth.firstVisibleColumn {\n  border-left: none;\n}\n\n.hidden {\n  display: none;\n}\n\n.filler-row td {\n  /* By making the filler row cells 100% they take up any extra height,\n  * leaving the cells with content to be the regular height, and the\n  * final filler row to be as high as it needs to be to fill the empty\n  * space.\n  */\n  height: 100%;\n  pointer-events: none;\n  padding: 0;\n}\n\n.filler-row.empty-table td {\n  /* If the table is empty and we have no renderable rows, the filler row cell\n   * needs to have some form of padding to make it have some height, else it\n   * stays at a height of 0px and doesn\'t fill the table. With this padding set,\n   * it will then have some height & expand the row it\'s in to 100% high as\n   * desired. */\n  padding: 1px;\n}\n\n[aria-sort]:hover {\n  cursor: pointer;\n}\n\n[aria-sort="descending"]::after {\n  content: "";\n  width: 0;\n  border-left: 0.4em solid transparent;\n  border-right: 0.4em solid transparent;\n  border-top: 0.4em solid var(--color-text-secondary);\n  position: absolute;\n  right: 0.5em;\n  top: 0.85em;\n}\n\n[aria-sort="ascending"]::after {\n  content: "";\n  width: 0;\n  border-bottom: 0.4em solid var(--color-text-secondary);\n  border-left: 0.4em solid transparent;\n  border-right: 0.4em solid transparent;\n  position: absolute;\n  right: 0.5em;\n  top: 0.7em;\n}\n\n/*# sourceURL=dataGrid.css */\n');export default styles;