import*as LitHtml from"../../lit-html/lit-html.js";import*as ComponentHelpers from"../helpers/helpers.js";import{toHexString}from"./LinearMemoryInspectorUtils.js";import linearMemoryViewerStyles from"./linearMemoryViewer.css.js";const{render:render,html:html}=LitHtml;export class ByteSelectedEvent extends Event{static eventName="byteselected";data;constructor(e){super(ByteSelectedEvent.eventName),this.data=e}}export class ResizeEvent extends Event{static eventName="resize";data;constructor(e){super(ResizeEvent.eventName),this.data=e}}export class LinearMemoryViewer extends HTMLElement{static litTagName=LitHtml.literal`devtools-linear-memory-inspector-viewer`;static BYTE_GROUP_MARGIN=8;static BYTE_GROUP_SIZE=4;#e=this.attachShadow({mode:"open"});#t=new ResizeObserver((()=>this.resize()));#s=!1;#i=new Uint8Array;#r=0;#n=0;#o=1;#h=LinearMemoryViewer.BYTE_GROUP_SIZE;#d=!0;#a=void 0;set data(e){if(e.address<e.memoryOffset||e.address>e.memoryOffset+e.memory.length||e.address<0)throw new Error("Address is out of bounds.");if(e.memoryOffset<0)throw new Error("Memory offset has to be greater or equal to zero.");this.#i=e.memory,this.#r=e.address,this.#n=e.memoryOffset,this.#d=e.focus,this.update()}connectedCallback(){ComponentHelpers.SetCSSProperty.set(this,"--byte-group-margin",`${LinearMemoryViewer.BYTE_GROUP_MARGIN}px`),this.#e.adoptedStyleSheets=[linearMemoryViewerStyles]}disconnectedCallback(){this.#s=!1,this.#t.disconnect()}update(){this.updateDimensions(),this.render(),this.focusOnView(),this.engageResizeObserver()}focusOnView(){if(this.#d){const e=this.#e.querySelector(".view");e&&e.focus()}}resize(){this.update(),this.dispatchEvent(new ResizeEvent(this.#h*this.#o))}updateDimensions(){if(0===this.clientWidth||0===this.clientHeight||!this.shadowRoot)return this.#h=LinearMemoryViewer.BYTE_GROUP_SIZE,void(this.#o=1);const e=this.shadowRoot.querySelector(".byte-cell"),t=this.shadowRoot.querySelector(".text-cell"),s=this.shadowRoot.querySelector(".divider"),i=this.shadowRoot.querySelector(".row");if(!(e&&t&&s&&i))return this.#h=LinearMemoryViewer.BYTE_GROUP_SIZE,void(this.#o=1);const r=e.getBoundingClientRect().width,n=t.getBoundingClientRect().width,o=LinearMemoryViewer.BYTE_GROUP_SIZE*(r+n)+LinearMemoryViewer.BYTE_GROUP_MARGIN,h=s.getBoundingClientRect().width,d=this.clientWidth-1-(e.getBoundingClientRect().left-this.getBoundingClientRect().left)-h;if(d<o)return this.#h=LinearMemoryViewer.BYTE_GROUP_SIZE,void(this.#o=1);this.#h=Math.floor(d/o)*LinearMemoryViewer.BYTE_GROUP_SIZE,this.#o=Math.floor(this.clientHeight/i.clientHeight)}engageResizeObserver(){this.#t&&!this.#s&&(this.#t.observe(this),this.#s=!0)}render(){render(html`
      <div class="view" tabindex="0" @keydown=${this.onKeyDown}>
          ${this.renderView()}
      </div>
      `,this.#e,{host:this})}onKeyDown(e){const t=e;let s;"ArrowUp"===t.code?s=this.#r-this.#h:"ArrowDown"===t.code?s=this.#r+this.#h:"ArrowLeft"===t.code?s=this.#r-1:"ArrowRight"===t.code?s=this.#r+1:"PageUp"===t.code?s=this.#r-this.#h*this.#o:"PageDown"===t.code&&(s=this.#r+this.#h*this.#o),void 0!==s&&s!==this.#a&&(this.#a=s,this.dispatchEvent(new ByteSelectedEvent(s)))}renderView(){const e=[];for(let t=0;t<this.#o;++t)e.push(this.renderRow(t));return html`${e}`}renderRow(e){const{startIndex:t,endIndex:s}={startIndex:e*this.#h,endIndex:(e+1)*this.#h},i={address:!0,selected:Math.floor((this.#r-this.#n)/this.#h)===e};return html`
    <div class="row">
      <span class="${LitHtml.Directives.classMap(i)}">${toHexString({number:t+this.#n,pad:8,prefix:!1})}</span>
      <span class="divider"></span>
      ${this.renderByteValues(t,s)}
      <span class="divider"></span>
      ${this.renderCharacterValues(t,s)}
    </div>
    `}renderByteValues(e,t){const s=[];for(let i=e;i<t;++i){const t={cell:!0,"byte-cell":!0,"byte-group-margin":i!==e&&(i-e)%LinearMemoryViewer.BYTE_GROUP_SIZE==0,selected:i===this.#r-this.#n},r=i<this.#i.length,n=r?html`${toHexString({number:this.#i[i],pad:2,prefix:!1})}`:"",o=i+this.#n,h=r?this.onSelectedByte.bind(this,o):"";s.push(html`<span class="${LitHtml.Directives.classMap(t)}" @click=${h}>${n}</span>`)}return html`${s}`}renderCharacterValues(e,t){const s=[];for(let i=e;i<t;++i){const e={cell:!0,"text-cell":!0,selected:this.#r-this.#n===i},t=i<this.#i.length,r=t?html`${this.toAscii(this.#i[i])}`:"",n=t?this.onSelectedByte.bind(this,i+this.#n):"";s.push(html`<span class="${LitHtml.Directives.classMap(e)}" @click=${n}>${r}</span>`)}return html`${s}`}toAscii(e){return e>=20&&e<=127?String.fromCharCode(e):"."}onSelectedByte(e){this.dispatchEvent(new ByteSelectedEvent(e))}}ComponentHelpers.CustomElements.defineComponent("devtools-linear-memory-inspector-viewer",LinearMemoryViewer);