import*as Common from"../../core/common/common.js";import*as Host from"../../core/host/host.js";import*as i18n from"../../core/i18n/i18n.js";import*as ARIAUtils from"./ARIAUtils.js";import{Icon}from"./Icon.js";import{KeyboardShortcut,Modifiers}from"./KeyboardShortcut.js";import{bindCheckbox}from"./SettingsUI.js";import{Events,TextPrompt}from"./TextPrompt.js";import{ToolbarSettingToggle}from"./Toolbar.js";import{Tooltip}from"./Tooltip.js";import{CheckboxLabel,createTextChild}from"./UIUtils.js";import{HBox}from"./Widget.js";import filterStyles from"./filter.css.legacy.js";const UIStrings={filter:"Filter",egSmalldUrlacomb:"e.g. `/small[d]+/ url:a.com/b`",sclickToSelectMultipleTypes:"{PH1}Click to select multiple types",allStrings:"All",clearFilter:"Clear input"},str_=i18n.i18n.registerUIStrings("ui/legacy/FilterBar.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FilterBar extends(Common.ObjectWrapper.eventMixin(HBox)){enabled;stateSetting;filterButtonInternal;filters;alwaysShowFilters;showingWidget;constructor(t,e){super(),this.registerRequiredCSS(filterStyles),this.enabled=!0,this.element.classList.add("filter-bar"),this.stateSetting=Common.Settings.Settings.instance().createSetting("filterBar-"+t+"-toggled",Boolean(e)),this.filterButtonInternal=new ToolbarSettingToggle(this.stateSetting,"largeicon-filter",i18nString(UIStrings.filter)),this.filters=[],this.updateFilterBar(),this.stateSetting.addChangeListener(this.updateFilterBar.bind(this))}filterButton(){return this.filterButtonInternal}addFilter(t){this.filters.push(t),this.element.appendChild(t.element()),t.addEventListener("FilterChanged",this.filterChanged,this),this.updateFilterButton()}setEnabled(t){this.enabled=t,this.filterButtonInternal.setEnabled(t),this.updateFilterBar()}forceShowFilterBar(){this.alwaysShowFilters=!0,this.updateFilterBar()}showOnce(){this.stateSetting.set(!0)}filterChanged(){this.updateFilterButton(),this.dispatchEventToListeners("Changed")}wasShown(){super.wasShown(),this.updateFilterBar()}updateFilterBar(){this.parentWidget()&&!this.showingWidget&&(this.visible()?(this.showingWidget=!0,this.showWidget(),this.showingWidget=!1):this.hideWidget())}focus(){for(let t=0;t<this.filters.length;++t)if(this.filters[t]instanceof TextFilterUI){this.filters[t].focus();break}}updateFilterButton(){let t=!1;for(const e of this.filters)t=t||e.isActive();this.filterButtonInternal.setDefaultWithRedColor(t),this.filterButtonInternal.setToggleWithRedColor(t)}clear(){this.element.removeChildren(),this.filters=[],this.updateFilterButton()}setting(){return this.stateSetting}visible(){return this.alwaysShowFilters||this.stateSetting.get()&&this.enabled}}export class TextFilterUI extends Common.ObjectWrapper.ObjectWrapper{filterElement;filterInputElement;prompt;proxyElement;suggestionProvider;constructor(){super(),this.filterElement=document.createElement("div"),this.filterElement.className="filter-text-filter";const t=this.filterElement.createChild("div","filter-input-container");this.filterInputElement=t.createChild("span","filter-input-field"),this.prompt=new TextPrompt,this.prompt.initialize(this.completions.bind(this)," ",!0),this.proxyElement=this.prompt.attach(this.filterInputElement),Tooltip.install(this.proxyElement,i18nString(UIStrings.egSmalldUrlacomb)),this.prompt.setPlaceholder(i18nString(UIStrings.filter)),this.prompt.addEventListener(Events.TextChanged,this.valueChanged.bind(this)),this.suggestionProvider=null;const e=t.createChild("div","filter-input-clear-button");Tooltip.install(e,i18nString(UIStrings.clearFilter)),e.appendChild(Icon.create("mediumicon-gray-cross-active","filter-cancel-button")),e.addEventListener("click",(()=>{this.clear(),this.focus()})),this.updateEmptyStyles()}completions(t,e,i){return this.suggestionProvider?this.suggestionProvider(t,e,i):Promise.resolve([])}isActive(){return Boolean(this.prompt.text())}element(){return this.filterElement}value(){return this.prompt.textWithCurrentSuggestion()}setValue(t){this.prompt.setText(t),this.valueChanged()}focus(){this.filterInputElement.focus()}setSuggestionProvider(t){this.prompt.clearAutocomplete(),this.suggestionProvider=t}valueChanged(){this.dispatchEventToListeners("FilterChanged"),this.updateEmptyStyles()}updateEmptyStyles(){this.filterElement.classList.toggle("filter-text-empty",!this.prompt.text())}clear(){this.setValue("")}}export class NamedBitSetFilterUI extends Common.ObjectWrapper.ObjectWrapper{filtersElement;typeFilterElementTypeNames;allowedTypes;typeFilterElements;setting;constructor(t,e){super(),this.filtersElement=document.createElement("div"),this.filtersElement.classList.add("filter-bitset-filter"),ARIAUtils.markAsListBox(this.filtersElement),ARIAUtils.markAsMultiSelectable(this.filtersElement),Tooltip.install(this.filtersElement,i18nString(UIStrings.sclickToSelectMultipleTypes,{PH1:KeyboardShortcut.shortcutToString("",Modifiers.CtrlOrMeta)})),this.typeFilterElementTypeNames=new WeakMap,this.allowedTypes=new Set,this.typeFilterElements=[],this.addBit(NamedBitSetFilterUI.ALL_TYPES,i18nString(UIStrings.allStrings)),this.typeFilterElements[0].tabIndex=0,this.filtersElement.createChild("div","filter-bitset-filter-divider");for(let e=0;e<t.length;++e)this.addBit(t[e].name,t[e].label(),t[e].title);e?(this.setting=e,e.addChangeListener(this.settingChanged.bind(this)),this.settingChanged()):this.toggleTypeFilter(NamedBitSetFilterUI.ALL_TYPES,!1)}reset(){this.toggleTypeFilter(NamedBitSetFilterUI.ALL_TYPES,!1)}isActive(){return!this.allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES)}element(){return this.filtersElement}accept(t){return this.allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES)||this.allowedTypes.has(t)}settingChanged(){const t=this.setting.get();this.allowedTypes=new Set;for(const e of this.typeFilterElements){const i=this.typeFilterElementTypeNames.get(e);i&&t[i]&&this.allowedTypes.add(i)}this.update()}update(){(0===this.allowedTypes.size||this.allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES))&&(this.allowedTypes=new Set,this.allowedTypes.add(NamedBitSetFilterUI.ALL_TYPES));for(const t of this.typeFilterElements){const e=this.typeFilterElementTypeNames.get(t),i=this.allowedTypes.has(e||"");t.classList.toggle("selected",i),ARIAUtils.setSelected(t,i)}this.dispatchEventToListeners("FilterChanged")}addBit(t,e,i){const s=this.filtersElement.createChild("span",t);s.tabIndex=-1,this.typeFilterElementTypeNames.set(s,t),createTextChild(s,e),ARIAUtils.markAsOption(s),i&&(s.title=i),s.addEventListener("click",this.onTypeFilterClicked.bind(this),!1),s.addEventListener("keydown",this.onTypeFilterKeydown.bind(this),!1),this.typeFilterElements.push(s)}onTypeFilterClicked(t){const e=t;let i;if(i=Host.Platform.isMac()?e.metaKey&&!e.ctrlKey&&!e.altKey&&!e.shiftKey:e.ctrlKey&&!e.metaKey&&!e.altKey&&!e.shiftKey,e.target){const t=e.target,s=this.typeFilterElementTypeNames.get(t);this.toggleTypeFilter(s,i)}}onTypeFilterKeydown(t){const e=t,i=e.target;i&&("ArrowLeft"===e.key||"ArrowUp"===e.key?this.keyFocusNextBit(i,!0)&&e.consume(!0):"ArrowRight"===e.key||"ArrowDown"===e.key?this.keyFocusNextBit(i,!1)&&e.consume(!0):isEnterOrSpaceKey(e)&&this.onTypeFilterClicked(e))}keyFocusNextBit(t,e){const i=this.typeFilterElements.indexOf(t);if(-1===i)return!1;const s=e?i-1:i+1;if(s<0||s>=this.typeFilterElements.length)return!1;const l=this.typeFilterElements[s];return l.tabIndex=0,t.tabIndex=-1,l.focus(),!0}toggleTypeFilter(t,e){if(e&&t!==NamedBitSetFilterUI.ALL_TYPES?this.allowedTypes.delete(NamedBitSetFilterUI.ALL_TYPES):this.allowedTypes=new Set,this.allowedTypes.has(t)?this.allowedTypes.delete(t):this.allowedTypes.add(t),this.setting){const t={};for(const e of this.allowedTypes)t[e]=!0;this.setting.set(t)}else this.update()}static ALL_TYPES="all"}export class CheckboxFilterUI extends Common.ObjectWrapper.ObjectWrapper{filterElement;activeWhenChecked;label;checkboxElement;constructor(t,e,i,s){super(),this.filterElement=document.createElement("div"),this.filterElement.classList.add("filter-checkbox-filter"),this.activeWhenChecked=Boolean(i),this.label=CheckboxLabel.create(e),this.filterElement.appendChild(this.label),this.checkboxElement=this.label.checkboxElement,s?bindCheckbox(this.checkboxElement,s):this.checkboxElement.checked=!0,this.checkboxElement.addEventListener("change",this.fireUpdated.bind(this),!1)}isActive(){return this.activeWhenChecked===this.checkboxElement.checked}checked(){return this.checkboxElement.checked}setChecked(t){this.checkboxElement.checked=t}element(){return this.filterElement}labelElement(){return this.label}fireUpdated(){this.dispatchEventToListeners("FilterChanged")}setColor(t,e){this.label.backgroundColor=t,this.label.borderColor=e}}