import*as Common from"../../../../core/common/common.js";import*as Platform from"../../../../core/platform/platform.js";import*as UI from"../../legacy.js";import bezierEditorStyles from"./bezierEditor.css.js";import{BezierUI}from"./BezierUI.js";export class BezierEditor extends(Common.ObjectWrapper.eventMixin(UI.Widget.VBox)){bezierInternal;previewElement;previewOnion;outerContainer;selectedCategory;presetsContainer;presetUI;presetCategories;curveUI;curve;header;label;mouseDownPosition;controlPosition;selectedPoint;previewAnimation;constructor(e){super(!0),this.bezierInternal=e,this.contentElement.tabIndex=0,this.setDefaultFocusedElement(this.contentElement),this.previewElement=this.contentElement.createChild("div","bezier-preview-container"),this.previewElement.createChild("div","bezier-preview-animation"),this.previewElement.addEventListener("click",this.startPreviewAnimation.bind(this)),this.previewOnion=this.contentElement.createChild("div","bezier-preview-onion"),this.previewOnion.addEventListener("click",this.startPreviewAnimation.bind(this)),this.outerContainer=this.contentElement.createChild("div","bezier-container"),this.selectedCategory=null,this.presetsContainer=this.outerContainer.createChild("div","bezier-presets"),this.presetUI=new BezierUI(40,40,0,2,!1),this.presetCategories=[];for(let e=0;e<Presets.length;e++)this.presetCategories[e]=this.createCategory(Presets[e]),this.presetsContainer.appendChild(this.presetCategories[e].icon);this.curveUI=new BezierUI(150,250,50,7,!0),this.curve=UI.UIUtils.createSVGChild(this.outerContainer,"svg","bezier-curve"),UI.UIUtils.installDragHandle(this.curve,this.dragStart.bind(this),this.dragMove.bind(this),this.dragEnd.bind(this),"default"),this.header=this.contentElement.createChild("div","bezier-header");const t=this.createPresetModifyIcon(this.header,"bezier-preset-minus","M 12 6 L 8 10 L 12 14"),i=this.createPresetModifyIcon(this.header,"bezier-preset-plus","M 8 6 L 12 10 L 8 14");t.addEventListener("click",this.presetModifyClicked.bind(this,!1)),i.addEventListener("click",this.presetModifyClicked.bind(this,!0)),this.label=this.header.createChild("span","source-code bezier-display-value")}setBezier(e){e&&(this.bezierInternal=e,this.updateUI())}bezier(){return this.bezierInternal}wasShown(){this.registerCSSFiles([bezierEditorStyles]),this.unselectPresets();for(const e of this.presetCategories)for(let t=0;t<e.presets.length;t++)this.bezierInternal.asCSSText()===e.presets[t].value&&(e.presetIndex=t,this.presetCategorySelected(e));this.updateUI(),this.startPreviewAnimation()}onchange(){this.updateUI(),this.dispatchEventToListeners(Events.BezierChanged,this.bezierInternal.asCSSText())}updateUI(){const e=this.selectedCategory?this.selectedCategory.presets[this.selectedCategory.presetIndex].name:this.bezierInternal.asCSSText().replace(/\s(-\d\.\d)/g,"$1");this.label.textContent=e,this.curveUI.drawCurve(this.bezierInternal,this.curve),this.previewOnion.removeChildren()}dragStart(e){this.mouseDownPosition=new UI.Geometry.Point(e.x,e.y);const t=this.curveUI;this.controlPosition=new UI.Geometry.Point(Platform.NumberUtilities.clamp((e.offsetX-t.radius)/t.curveWidth(),0,1),(t.curveHeight()+t.marginTop+t.radius-e.offsetY)/t.curveHeight());const i=this.controlPosition.distanceTo(this.bezierInternal.controlPoints[0])<this.controlPosition.distanceTo(this.bezierInternal.controlPoints[1]);return this.selectedPoint=i?0:1,this.bezierInternal.controlPoints[this.selectedPoint]=this.controlPosition,this.unselectPresets(),this.onchange(),e.consume(!0),!0}updateControlPosition(e,t){if(void 0===this.mouseDownPosition||void 0===this.controlPosition||void 0===this.selectedPoint)return;const i=(e-this.mouseDownPosition.x)/this.curveUI.curveWidth(),s=(t-this.mouseDownPosition.y)/this.curveUI.curveHeight(),r=new UI.Geometry.Point(Platform.NumberUtilities.clamp(this.controlPosition.x+i,0,1),this.controlPosition.y-s);this.bezierInternal.controlPoints[this.selectedPoint]=r}dragMove(e){this.updateControlPosition(e.x,e.y),this.onchange()}dragEnd(e){this.updateControlPosition(e.x,e.y),this.onchange(),this.startPreviewAnimation()}createCategory(e){const t=document.createElement("div");t.classList.add("bezier-preset-category");const i=UI.UIUtils.createSVGChild(t,"svg","bezier-preset monospace"),s={presets:e,presetIndex:0,icon:t};return this.presetUI.drawCurve(UI.Geometry.CubicBezier.parse(s.presets[0].value),i),i.addEventListener("click",this.presetCategorySelected.bind(this,s)),s}createPresetModifyIcon(e,t,i){const s=UI.UIUtils.createSVGChild(e,"svg","bezier-preset-modify "+t);s.setAttribute("width","20"),s.setAttribute("height","20");return UI.UIUtils.createSVGChild(s,"path").setAttribute("d",i),s}unselectPresets(){for(const e of this.presetCategories)e.icon.classList.remove("bezier-preset-selected");this.selectedCategory=null,this.header.classList.remove("bezier-header-active")}presetCategorySelected(e,t){if(this.selectedCategory===e)return;this.unselectPresets(),this.header.classList.add("bezier-header-active"),this.selectedCategory=e,this.selectedCategory.icon.classList.add("bezier-preset-selected");const i=UI.Geometry.CubicBezier.parse(e.presets[e.presetIndex].value);i&&(this.setBezier(i),this.onchange(),this.startPreviewAnimation()),t&&t.consume(!0)}presetModifyClicked(e,t){if(null===this.selectedCategory)return;const i=this.selectedCategory.presets.length;this.selectedCategory.presetIndex=(this.selectedCategory.presetIndex+(e?1:-1)+i)%i;const s=UI.Geometry.CubicBezier.parse(this.selectedCategory.presets[this.selectedCategory.presetIndex].value);s&&(this.setBezier(s),this.onchange(),this.startPreviewAnimation())}startPreviewAnimation(){this.previewAnimation&&this.previewAnimation.cancel();const e=1600,t=[{offset:0,transform:"translateX(0px)",easing:this.bezierInternal.asCSSText(),opacity:1},{offset:.9,transform:"translateX(218px)",opacity:1},{offset:1,transform:"translateX(218px)",opacity:0}];this.previewAnimation=this.previewElement.animate(t,e),this.previewOnion.removeChildren();for(let t=0;t<=20;t++){const i=this.previewOnion.createChild("div","bezier-preview-animation").animate([{transform:"translateX(0px)",easing:this.bezierInternal.asCSSText()},{transform:"translateX(218px)"}],{duration:e,fill:"forwards"});i.pause(),i.currentTime=e*t/20}}}export var Events;!function(e){e.BezierChanged="BezierChanged"}(Events||(Events={}));export const Presets=[[{name:"ease-in-out",value:"ease-in-out"},{name:"In Out · Sine",value:"cubic-bezier(0.45, 0.05, 0.55, 0.95)"},{name:"In Out · Quadratic",value:"cubic-bezier(0.46, 0.03, 0.52, 0.96)"},{name:"In Out · Cubic",value:"cubic-bezier(0.65, 0.05, 0.36, 1)"},{name:"Fast Out, Slow In",value:"cubic-bezier(0.4, 0, 0.2, 1)"},{name:"In Out · Back",value:"cubic-bezier(0.68, -0.55, 0.27, 1.55)"}],[{name:"Fast Out, Linear In",value:"cubic-bezier(0.4, 0, 1, 1)"},{name:"ease-in",value:"ease-in"},{name:"In · Sine",value:"cubic-bezier(0.47, 0, 0.75, 0.72)"},{name:"In · Quadratic",value:"cubic-bezier(0.55, 0.09, 0.68, 0.53)"},{name:"In · Cubic",value:"cubic-bezier(0.55, 0.06, 0.68, 0.19)"},{name:"In · Back",value:"cubic-bezier(0.6, -0.28, 0.74, 0.05)"}],[{name:"ease-out",value:"ease-out"},{name:"Out · Sine",value:"cubic-bezier(0.39, 0.58, 0.57, 1)"},{name:"Out · Quadratic",value:"cubic-bezier(0.25, 0.46, 0.45, 0.94)"},{name:"Out · Cubic",value:"cubic-bezier(0.22, 0.61, 0.36, 1)"},{name:"Linear Out, Slow In",value:"cubic-bezier(0, 0, 0.2, 1)"},{name:"Out · Back",value:"cubic-bezier(0.18, 0.89, 0.32, 1.28)"}]];