import*as Common from"../../../../core/common/common.js";import*as Host from"../../../../core/host/host.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as Root from"../../../../core/root/root.js";import*as UI from"../../legacy.js";import*as ThemeSupport from"../../theme_support/theme_support.js";import{ChartViewport}from"./ChartViewport.js";import{TimelineGrid}from"./TimelineGrid.js";import flameChartStyles from"./flameChart.css.legacy.js";const UIStrings={flameChart:"Flame Chart",sHovered:"{PH1} hovered",sSelected:"{PH1} selected",sExpanded:"{PH1} expanded",sCollapsed:"{PH1} collapsed"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/perf_ui/FlameChart.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FlameChartDelegate{windowChanged(e,t,i){}updateRangeSelection(e,t){}updateSelectedGroup(e,t){}}export class FlameChart extends(Common.ObjectWrapper.eventMixin(UI.Widget.VBox)){groupExpansionSetting;groupExpansionState;flameChartDelegate;useWebGL;chartViewport;dataProvider;candyStripeCanvas;viewportElement;canvasGL;canvas;entryInfo;markerHighlighElement;highlightElement;selectedElement;rulerEnabled;rangeSelectionStart;rangeSelectionEnd;barHeight;textBaseline;textPadding;markerRadius;headerLeftPadding;arrowSide;expansionArrowIndent;headerLabelXPadding;headerLabelYPadding;highlightedMarkerIndex;highlightedEntryIndex;selectedEntryIndex;rawTimelineDataLength;textWidth;markerPositions;lastMouseOffsetX;selectedGroup;keyboardFocusedGroup;selectedGroupBackroundColor;selectedGroupBorderColor;offsetWidth;offsetHeight;dragStartX;dragStartY;lastMouseOffsetY;minimumBoundaryInternal;maxDragOffset;shaderProgram;vertexBuffer;colorBuffer;uScalingFactor;uShiftVector;aVertexPosition;aVertexColor;vertexCount;prevTimelineData;timelineLevels;visibleLevelOffsets;visibleLevels;groupOffsets;rawTimelineData;forceDecorationCache;entryColorsCache;visibleLevelHeights;totalTime;constructor(e,t,i){super(!0),this.registerRequiredCSS(flameChartStyles),this.contentElement.classList.add("flame-chart-main-pane"),this.groupExpansionSetting=i,this.groupExpansionState=i&&i.get()||{},this.flameChartDelegate=t,this.useWebGL=Root.Runtime.experiments.isEnabled("timelineWebGL"),this.chartViewport=new ChartViewport(this),this.chartViewport.show(this.contentElement),this.dataProvider=e,this.candyStripeCanvas=document.createElement("canvas"),this.createCandyStripePattern(),this.viewportElement=this.chartViewport.viewportElement,this.useWebGL&&(this.canvasGL=this.viewportElement.createChild("canvas","fill"),this.initWebGL()),this.canvas=this.viewportElement.createChild("canvas","fill"),this.canvas.tabIndex=0,UI.ARIAUtils.setAccessibleName(this.canvas,i18nString(UIStrings.flameChart)),UI.ARIAUtils.markAsTree(this.canvas),this.setDefaultFocusedElement(this.canvas),this.canvas.classList.add("flame-chart-canvas"),this.canvas.addEventListener("mousemove",this.onMouseMove.bind(this),!1),this.canvas.addEventListener("mouseout",this.onMouseOut.bind(this),!1),this.canvas.addEventListener("click",this.onClick.bind(this),!1),this.canvas.addEventListener("keydown",this.onKeyDown.bind(this),!1),this.entryInfo=this.viewportElement.createChild("div","flame-chart-entry-info"),this.markerHighlighElement=this.viewportElement.createChild("div","flame-chart-marker-highlight-element"),this.highlightElement=this.viewportElement.createChild("div","flame-chart-highlight-element"),this.selectedElement=this.viewportElement.createChild("div","flame-chart-selected-element"),this.canvas.addEventListener("focus",(()=>{this.dispatchEventToListeners(Events.CanvasFocused)}),!1),UI.UIUtils.installDragHandle(this.viewportElement,this.startDragging.bind(this),this.dragging.bind(this),this.endDragging.bind(this),null),this.rulerEnabled=!0,this.rangeSelectionStart=0,this.rangeSelectionEnd=0,this.barHeight=17,this.textBaseline=5,this.textPadding=5,this.markerRadius=6,this.chartViewport.setWindowTimes(e.minimumBoundary(),e.minimumBoundary()+e.totalTime()),this.headerLeftPadding=6,this.arrowSide=8,this.expansionArrowIndent=this.headerLeftPadding+this.arrowSide/2,this.headerLabelXPadding=3,this.headerLabelYPadding=2,this.highlightedMarkerIndex=-1,this.highlightedEntryIndex=-1,this.selectedEntryIndex=-1,this.rawTimelineDataLength=0,this.textWidth=new Map,this.markerPositions=new Map,this.lastMouseOffsetX=0,this.selectedGroup=-1,this.keyboardFocusedGroup=-1,this.selectedGroupBackroundColor=ThemeSupport.ThemeSupport.instance().patchColorText(Colors.SelectedGroupBackground,ThemeSupport.ThemeSupport.ColorUsage.Background),this.selectedGroupBorderColor=ThemeSupport.ThemeSupport.instance().patchColorText(Colors.SelectedGroupBorder,ThemeSupport.ThemeSupport.ColorUsage.Background)}willHide(){this.hideHighlight()}setBarHeight(e){this.barHeight=e}setTextBaseline(e){this.textBaseline=e}setTextPadding(e){this.textPadding=e}enableRuler(e){this.rulerEnabled=e}alwaysShowVerticalScroll(){this.chartViewport.alwaysShowVerticalScroll()}disableRangeSelection(){this.chartViewport.disableRangeSelection()}highlightEntry(e){this.highlightedEntryIndex!==e&&this.dataProvider.entryColor(e)&&(this.highlightedEntryIndex=e,this.updateElementPosition(this.highlightElement,this.highlightedEntryIndex),this.dispatchEventToListeners(Events.EntryHighlighted,e))}hideHighlight(){this.entryInfo.removeChildren(),this.highlightedEntryIndex=-1,this.updateElementPosition(this.highlightElement,this.highlightedEntryIndex),this.dispatchEventToListeners(Events.EntryHighlighted,-1)}createCandyStripePattern(){const e=17;this.candyStripeCanvas.width=e,this.candyStripeCanvas.height=e;const t=this.candyStripeCanvas.getContext("2d");if(t){t.translate(8.5,8.5),t.rotate(.25*Math.PI),t.translate(-8.5,-8.5),t.fillStyle="rgba(255, 0, 0, 0.4)";for(let e=-17;e<34;e+=3)t.fillRect(e,-17,1,51)}}resetCanvas(){const e=window.devicePixelRatio,t=Math.round(this.offsetWidth*e),i=Math.round(this.offsetHeight*e);this.canvas.width=t,this.canvas.height=i,this.canvas.style.width=t/e+"px",this.canvas.style.height=i/e+"px",this.useWebGL&&(this.canvasGL.width=t,this.canvasGL.height=i,this.canvasGL.style.width=t/e+"px",this.canvasGL.style.height=i/e+"px")}windowChanged(e,t,i){this.flameChartDelegate.windowChanged(e,t,i)}updateRangeSelection(e,t){this.flameChartDelegate.updateRangeSelection(e,t)}setSize(e,t){this.offsetWidth=e,this.offsetHeight=t}startDragging(e){return this.hideHighlight(),this.maxDragOffset=0,this.dragStartX=e.pageX,this.dragStartY=e.pageY,!0}dragging(e){const t=e.pageX-this.dragStartX,i=e.pageY-this.dragStartY;this.maxDragOffset=Math.max(this.maxDragOffset,Math.sqrt(t*t+i*i))}endDragging(e){this.updateHighlight()}timelineData(){if(!this.dataProvider)return null;const e=this.dataProvider.timelineData();return(e!==this.rawTimelineData||e&&e.entryStartTimes.length!==this.rawTimelineDataLength)&&this.processTimelineData(e),this.rawTimelineData||null}revealEntry(e){const t=this.timelineData();if(!t)return;const i=this.chartViewport.windowLeftTime(),s=this.chartViewport.windowRightTime(),r=t.entryStartTimes[e],n=t.entryTotalTimes[e],o=r+n;let a=Math.min(n,s-i);const l=t.entryLevels[e];this.chartViewport.setScrollOffset(this.levelToOffset(l),this.levelHeight(l));const h=(s-i)/this.offsetWidth;if(a=Math.max(a,30*h),i>o){const e=i-o+a;this.windowChanged(i-e,s-e,!0)}else if(s<r){const e=r-s+a;this.windowChanged(i+e,s+e,!0)}}setWindowTimes(e,t,i){this.chartViewport.setWindowTimes(e,t,i),this.updateHighlight()}onMouseMove(e){const t=e;if(this.lastMouseOffsetX=t.offsetX,this.lastMouseOffsetY=t.offsetY,this.enabled()&&!this.chartViewport.isDragging())return this.coordinatesToGroupIndex(t.offsetX,t.offsetY,!0)>=0?(this.hideHighlight(),void(this.viewportElement.style.cursor="pointer")):void this.updateHighlight()}updateHighlight(){const e=this.coordinatesToEntryIndex(this.lastMouseOffsetX,this.lastMouseOffsetY);if(-1!==e)this.chartViewport.isDragging()||(this.updatePopover(e),this.viewportElement.style.cursor=this.dataProvider.canJumpToEntry(e)?"pointer":"default",this.highlightEntry(e));else{this.hideHighlight();const e=this.coordinatesToGroupIndex(this.lastMouseOffsetX,this.lastMouseOffsetY,!1);e>=0&&this.rawTimelineData&&this.rawTimelineData.groups&&this.rawTimelineData.groups[e].selectable?this.viewportElement.style.cursor="pointer":this.viewportElement.style.cursor="default"}}onMouseOut(){this.lastMouseOffsetX=-1,this.lastMouseOffsetY=-1,this.hideHighlight()}updatePopover(e){if(e===this.highlightedEntryIndex)return void this.updatePopoverOffset();this.entryInfo.removeChildren();const t=this.dataProvider.prepareHighlightedEntryInfo(e);t&&(this.entryInfo.appendChild(t),this.updatePopoverOffset())}updatePopoverOffset(){const e=this.lastMouseOffsetX,t=this.lastMouseOffsetY,i=this.entryInfo.parentElement?this.entryInfo.parentElement.clientWidth:0,s=this.entryInfo.parentElement?this.entryInfo.parentElement.clientHeight:0,r=this.entryInfo.clientWidth,n=this.entryInfo.clientHeight;let o,a;for(let l=0;l<4;++l){const h=2&l?-10-r:10,d=1&l?-6-n:6;if(o=Platform.NumberUtilities.clamp(e+h,0,i-r),a=Platform.NumberUtilities.clamp(t+d,0,s-n),o>=e||e>=o+r||a>=t||t>=a+n)break}this.entryInfo.style.left=o+"px",this.entryInfo.style.top=a+"px"}onClick(e){const t=e;this.focus();if(this.maxDragOffset>5)return;this.selectGroup(this.coordinatesToGroupIndex(t.offsetX,t.offsetY,!1)),this.toggleGroupExpand(this.coordinatesToGroupIndex(t.offsetX,t.offsetY,!0));const i=this.timelineData();if(t.shiftKey&&-1!==this.highlightedEntryIndex&&i){const e=i.entryStartTimes[this.highlightedEntryIndex],t=e+i.entryTotalTimes[this.highlightedEntryIndex];this.chartViewport.setRangeSelection(e,t)}else this.chartViewport.onClick(t),this.dispatchEventToListeners(Events.EntryInvoked,this.highlightedEntryIndex)}selectGroup(e){if(e<0||this.selectedGroup===e)return;if(!this.rawTimelineData)return;const t=this.rawTimelineData.groups;if(!t)return;this.keyboardFocusedGroup=e,this.scrollGroupIntoView(e);const i=t[e].name;t[e].selectable?(this.selectedGroup=e,this.flameChartDelegate.updateSelectedGroup(this,t[e]),this.resetCanvas(),this.draw(),UI.ARIAUtils.alert(i18nString(UIStrings.sSelected,{PH1:i}))):(this.deselectAllGroups(),UI.ARIAUtils.alert(i18nString(UIStrings.sHovered,{PH1:i})))}deselectAllGroups(){this.selectedGroup=-1,this.flameChartDelegate.updateSelectedGroup(this,null),this.resetCanvas(),this.draw()}deselectAllEntries(){this.selectedEntryIndex=-1,this.resetCanvas(),this.draw()}isGroupFocused(e){return e===this.selectedGroup||e===this.keyboardFocusedGroup}scrollGroupIntoView(e){if(e<0)return;if(!this.rawTimelineData)return;const t=this.rawTimelineData.groups,i=this.groupOffsets;if(!i||!t)return;const s=i[e];let r=i[e+1];e===t.length-1&&(r+=t[e].style.padding);const n=0===e?0:s,o=Math.min(r-n,this.chartViewport.chartHeight());this.chartViewport.setScrollOffset(n,o)}toggleGroupExpand(e){e<0||!this.isGroupCollapsible(e)||this.rawTimelineData&&this.rawTimelineData.groups&&this.expandGroup(e,!this.rawTimelineData.groups[e].expanded)}expandGroup(e,t=!0,i=!1){if(e<0||!this.isGroupCollapsible(e))return;if(!this.rawTimelineData)return;const s=this.rawTimelineData.groups;if(!s)return;const r=s[e];if(r.expanded=t,this.groupExpansionState[r.name]=r.expanded,this.groupExpansionSetting&&this.groupExpansionSetting.set(this.groupExpansionState),this.updateLevelPositions(),this.updateHighlight(),!r.expanded){const t=this.timelineData();if(t){const i=t.entryLevels[this.selectedEntryIndex];this.selectedEntryIndex>=0&&i>=r.startLevel&&(e>=s.length-1||s[e+1].startLevel>i)&&(this.selectedEntryIndex=-1)}}if(this.updateHeight(),this.resetCanvas(),this.draw(),this.scrollGroupIntoView(e),!i){const t=s[e].name,i=r.expanded?i18nString(UIStrings.sExpanded,{PH1:t}):i18nString(UIStrings.sCollapsed,{PH1:t});UI.ARIAUtils.alert(i)}}onKeyDown(e){if(!UI.KeyboardShortcut.KeyboardShortcut.hasNoModifiers(e)||!this.timelineData())return;!this.handleSelectionNavigation(e)&&this.rawTimelineData&&this.rawTimelineData.groups&&this.handleKeyboardGroupNavigation(e)}bindCanvasEvent(e,t){this.canvas.addEventListener(e,t)}handleKeyboardGroupNavigation(e){const t=e;let i=!1,s=!1;"ArrowUp"===t.code?i=this.selectPreviousGroup():"ArrowDown"===t.code?i=this.selectNextGroup():"ArrowLeft"===t.code?this.keyboardFocusedGroup>=0&&(this.expandGroup(this.keyboardFocusedGroup,!1),i=!0):"ArrowRight"===t.code?this.keyboardFocusedGroup>=0&&(this.expandGroup(this.keyboardFocusedGroup,!0),this.selectFirstChild(),i=!0):"Enter"===t.key&&(s=this.selectFirstEntryInCurrentGroup(),i=s),i&&!s&&this.deselectAllEntries(),i&&t.consume(!0)}selectFirstEntryInCurrentGroup(){if(!this.rawTimelineData)return!1;const e=this.rawTimelineData.groups;if(this.keyboardFocusedGroup<0||!e)return!1;const t=e[this.keyboardFocusedGroup].startLevel;if(t<0)return!1;if(this.keyboardFocusedGroup<e.length-1&&e[this.keyboardFocusedGroup+1].startLevel===t)return!1;if(!this.timelineLevels)return!1;const i=this.timelineLevels[t][0];return this.expandGroup(this.keyboardFocusedGroup,!0),this.setSelectedEntry(i),!0}selectPreviousGroup(){if(this.keyboardFocusedGroup<=0)return!1;const e=this.getGroupIndexToSelect(-1);return this.selectGroup(e),!0}selectNextGroup(){if(!this.rawTimelineData||!this.rawTimelineData.groups)return!1;if(this.keyboardFocusedGroup>=this.rawTimelineData.groups.length-1)return!1;const e=this.getGroupIndexToSelect(1);return this.selectGroup(e),!0}getGroupIndexToSelect(e){if(!this.rawTimelineData||!this.rawTimelineData.groups)throw new Error("No raw timeline data");const t=this.rawTimelineData.groups;let i,s,r=this.keyboardFocusedGroup;do{r+=e,i=this.rawTimelineData.groups[r].name,s=-1!==this.keyboardFocusedGroup&&t[r].style.nestingLevel>t[this.keyboardFocusedGroup].style.nestingLevel}while(r>0&&r<t.length-1&&(!i||s));return r}selectFirstChild(){if(!this.rawTimelineData||!this.rawTimelineData.groups)return;const e=this.rawTimelineData.groups;if(this.keyboardFocusedGroup<0||this.keyboardFocusedGroup>=e.length-1)return;const t=this.keyboardFocusedGroup+1;e[t].style.nestingLevel>e[this.keyboardFocusedGroup].style.nestingLevel&&this.selectGroup(t)}handleSelectionNavigation(e){if(-1===this.selectedEntryIndex)return!1;const t=this.timelineData();if(!t)return!1;function i(e,i){if(!t)throw new Error("No timeline data");const s=t.entryStartTimes[e],r=t.entryStartTimes[i],n=s+t.entryTotalTimes[e];return s<r+t.entryTotalTimes[i]&&r<n}const s=e,r=UI.KeyboardShortcut.Keys;if(s.keyCode===r.Left.code||s.keyCode===r.Right.code){const i=t.entryLevels[this.selectedEntryIndex],n=this.timelineLevels?this.timelineLevels[i]:[];let o=Platform.ArrayUtilities.lowerBound(n,this.selectedEntryIndex,((e,t)=>e-t));return o+=s.keyCode===r.Left.code?-1:1,e.consume(!0),o>=0&&o<n.length&&this.dispatchEventToListeners(Events.EntrySelected,n[o]),!0}if(s.keyCode===r.Up.code||s.keyCode===r.Down.code){let e=t.entryLevels[this.selectedEntryIndex];if(e+=s.keyCode===r.Up.code?-1:1,e<0||this.timelineLevels&&e>=this.timelineLevels.length)return this.deselectAllEntries(),s.consume(!0),!0;const n=t.entryStartTimes[this.selectedEntryIndex]+t.entryTotalTimes[this.selectedEntryIndex]/2,o=this.timelineLevels?this.timelineLevels[e]:[];let a=Platform.ArrayUtilities.upperBound(o,n,(function(e,i){if(!t)throw new Error("No timeline data");return e-t.entryStartTimes[i]}))-1;return!i(this.selectedEntryIndex,o[a])&&(++a,a>=o.length||!i(this.selectedEntryIndex,o[a]))?"ArrowDown"!==s.code&&(this.deselectAllEntries(),s.consume(!0),!0):(s.consume(!0),this.dispatchEventToListeners(Events.EntrySelected,o[a]),!0)}return"Enter"===e.key&&(e.consume(!0),this.dispatchEventToListeners(Events.EntryInvoked,this.selectedEntryIndex),!0)}coordinatesToEntryIndex(e,t){if(e<0||t<0)return-1;const i=this.timelineData();if(!i)return-1;if(t+=this.chartViewport.scrollOffset(),!this.visibleLevelOffsets)throw new Error("No visible level offsets");const s=Platform.ArrayUtilities.upperBound(this.visibleLevelOffsets,t,Platform.ArrayUtilities.DEFAULT_COMPARATOR)-1;if(s<0||this.visibleLevels&&!this.visibleLevels[s])return-1;if(t-this.visibleLevelOffsets[s]>this.levelHeight(s))return-1;for(const[t,r]of this.markerPositions)if(i.entryLevels[t]===s&&r.x<=e&&e<r.x+r.width)return t;const r=i.entryStartTimes,n=this.timelineLevels?this.timelineLevels[s]:[];if(!n||!n.length)return-1;const o=this.chartViewport.pixelToTime(e),a=Math.max(Platform.ArrayUtilities.upperBound(n,o,((e,t)=>e-r[t]))-1,0);function l(t){if(void 0===t)return!1;if(!i)return!1;const s=r[t],n=i.entryTotalTimes[t],o=this.chartViewport.timeToPosition(s),a=this.chartViewport.timeToPosition(s+n);return o-3<e&&e<a+3}let h=n[a];return l.call(this,h)?h:(h=n[a+1],l.call(this,h)?h:-1)}coordinatesToGroupIndex(e,t,i){if(!this.rawTimelineData||!this.rawTimelineData.groups||!this.groupOffsets)return-1;if(e<0||t<0)return-1;t+=this.chartViewport.scrollOffset();const s=this.rawTimelineData.groups||[],r=Platform.ArrayUtilities.upperBound(this.groupOffsets,t,Platform.ArrayUtilities.DEFAULT_COMPARATOR)-1;if(r<0||r>=s.length)return-1;const n=i?s[r].style.height:this.groupOffsets[r+1]-this.groupOffsets[r];if(t-this.groupOffsets[r]>=n)return-1;if(!i)return r;const o=this.canvas.getContext("2d");o.save(),o.font=s[r].style.font;const a=this.headerLeftPadding+this.labelWidthForGroup(o,s[r]);return o.restore(),e>a?-1:r}markerIndexAtPosition(e){const t=this.timelineData();if(!t)return-1;const i=t.markers;if(!i)return-1;const s=this.chartViewport.pixelToTime(e),r=this.chartViewport.pixelToTime(e-4),n=this.chartViewport.pixelToTime(e+4);let o=-1,a=1/0;for(let e=this.markerIndexBeforeTime(r);e<i.length&&i[e].startTime()<n;e++){const t=Math.abs(i[e].startTime()-s);t<a&&(o=e,a=t)}return o}markerIndexBeforeTime(e){const t=this.timelineData();if(!t)throw new Error("No timeline data");if(!t.markers)throw new Error("No timeline markers");return Platform.ArrayUtilities.lowerBound(t.markers,e,((e,t)=>e-t.startTime()))}draw(){const e=this.timelineData();if(!e)return;const t=this.visibleLevelOffsets?this.visibleLevelOffsets:new Uint32Array,i=this.offsetWidth,s=this.offsetHeight,r=this.canvas.getContext("2d");r.save();const n=window.devicePixelRatio,o=this.chartViewport.scrollOffset();r.scale(n,n),r.fillStyle="rgba(0, 0, 0, 0)",r.fillRect(0,0,i,s),r.translate(0,-o);const a="11px "+Host.Platform.fontFamily();r.font=a;const l=r.createPattern(this.candyStripeCanvas,"repeat"),h=e.entryTotalTimes,d=e.entryStartTimes,c=e.entryLevels,u=this.chartViewport.timeToPixel(),p=[],f=[],m=this.textPadding,g=2*m+UI.UIUtils.measureTextWidth(r,"…"),v=this.chartViewport.pixelToTimeOffset(g),y=Math.max(Platform.ArrayUtilities.upperBound(t,o,Platform.ArrayUtilities.DEFAULT_COMPARATOR)-1,0);this.markerPositions.clear();let w=-1;if("groups"in e&&Array.isArray(e.groups)){const t=e.groups.find((e=>!!e.track&&"CrRendererMain"===e.track.name));t&&(w=t.startLevel)}const T=new Map;for(let e=y;e<this.dataProvider.maxStackDepth()&&!(this.levelToOffset(e)>o+s);++e){if(!this.visibleLevels||!this.visibleLevels[e])continue;if(!this.timelineLevels)continue;const t=this.timelineLevels[e];let i=1/0;for(let e=Platform.ArrayUtilities.lowerBound(t,this.chartViewport.windowRightTime(),((e,t)=>e-d[t]))-1;e>=0;--e){const s=t[e],r=h[s];if(isNaN(r)){f.push(s);continue}(r>=v||this.forceDecorationCache&&this.forceDecorationCache[s])&&p.push(s);const n=d[s];if(n+r<=this.chartViewport.windowLeftTime())break;if(this.useWebGL)continue;const o=this.timeToPositionClipped(n);if(!(o>=i)&&(i=o,this.entryColorsCache)){const e=this.entryColorsCache[s];let t=T.get(e);t||(t={indexes:[]},T.set(e,t)),t.indexes.push(s)}}}if(this.useWebGL)this.drawGL();else{r.save(),this.forEachGroupInViewport(((e,t,s,n,o)=>{this.isGroupFocused(t)&&(r.fillStyle=this.selectedGroupBackroundColor,r.fillRect(0,e,i,o-s.style.padding))})),r.restore();for(const[e,{indexes:t}]of T){r.beginPath();for(let e=0;e<t.length;++e){const i=t[e],s=h[i];if(isNaN(s))continue;const n=d[i],o=this.timeToPositionClipped(n),a=c[i],l=this.levelHeight(a),u=this.levelToOffset(a),p=this.timeToPositionClipped(n+s),f=Math.max(p-o,1);r.rect(o,u,f-.4,l-1)}r.fillStyle=e,r.fill(),r.beginPath();for(let e=0;e<t.length;++e){const i=t[e],s=h[i];if(!(c[i]===w))continue;if(isNaN(s)||s<50)continue;const n=d[i],o=this.timeToPositionClipped(n+50),a=c[i],l=this.levelHeight(a),u=this.levelToOffset(a),p=this.timeToPositionClipped(n+s),f=Math.max(p-o,1);r.rect(o,u,f-.4,l-1)}l&&(r.fillStyle=l,r.fill())}}r.textBaseline="alphabetic",r.beginPath();let x=-1,E=-1/0;for(let e=f.length-1;e>=0;--e){const t=f[e],i=this.dataProvider.entryTitle(t);if(!i)continue;const s=d[t],n=c[t];x!==n&&(E=-1/0);const o=Math.max(this.chartViewport.timeToPosition(s),E),a=this.levelToOffset(n),l=this.levelHeight(n),h=4,u=Math.ceil(UI.UIUtils.measureTextWidth(r,i))+2*h;E=o+u+1,x=n,this.markerPositions.set(t,{x:o,width:u}),r.fillStyle=this.dataProvider.entryColor(t),r.fillRect(o,a,u,l-1),r.fillStyle="white",r.fillText(i,o+h,a+l-this.textBaseline)}r.strokeStyle="rgba(0, 0, 0, 0.2)",r.stroke();for(let e=0;e<p.length;++e){const t=p[e],s=d[t],n=this.timeToPositionClipped(s),o=Math.min(this.timeToPositionClipped(s+h[t]),i)+1-n,l=c[t],f=this.levelToOffset(l);let g=this.dataProvider.entryTitle(t);g&&g.length&&(r.font=this.dataProvider.entryFont(t)||a,g=UI.UIUtils.trimTextMiddle(r,g,o-2*m));const v=this.chartViewport.timeToPosition(s),y=this.levelHeight(l);this.dataProvider.decorateEntry(t,r,g,n,f,o,y,v,u)||g&&g.length&&(r.fillStyle=this.dataProvider.textColor(t),r.fillText(g,n+m,f+y-this.textBaseline))}r.restore(),this.drawGroupHeaders(i,s),this.drawFlowEvents(r,i,s),this.drawMarkers();const S=TimelineGrid.calculateGridOffsets(this),L=Array.from(this.dataProvider.navStartTimes().values());let P=0;const C=e=>{if(0===L.length)return this.formatValue(e,S.precision);L.length>P+1&&e>L[P+1].startTime&&P++;const t=L[P];return t&&(e-=t.startTime-this.zeroTime()),this.formatValue(e,S.precision)};TimelineGrid.drawCanvasGrid(r,S),this.rulerEnabled&&TimelineGrid.drawCanvasHeaders(r,S,C,3,HeaderHeight),this.updateElementPosition(this.highlightElement,this.highlightedEntryIndex),this.updateElementPosition(this.selectedElement,this.selectedEntryIndex),this.updateMarkerHighlight()}initWebGL(){const e=this.canvasGL.getContext("webgl");if(!e)return console.error("Failed to obtain WebGL context."),void(this.useWebGL=!1);function t(e,t,i){const s=e.createShader(t);return s?(e.shaderSource(s,i),e.compileShader(s),e.getShaderParameter(s,e.COMPILE_STATUS)?s:(console.error("Shader compile error: "+e.getShaderInfoLog(s)),e.deleteShader(s),null)):null}const i=t(e,e.VERTEX_SHADER,"\n  attribute vec2 aVertexPosition;\n  attribute float aVertexColor;\n\n  uniform vec2 uScalingFactor;\n  uniform vec2 uShiftVector;\n\n  varying mediump vec2 vPalettePosition;\n\n  void main() {\n  vec2 shiftedPosition = aVertexPosition - uShiftVector;\n  gl_Position = vec4(shiftedPosition * uScalingFactor + vec2(-1.0, 1.0), 0.0, 1.0);\n  vPalettePosition = vec2(aVertexColor, 0.5);\n  }"),s=t(e,e.FRAGMENT_SHADER,"\n  varying mediump vec2 vPalettePosition;\n  uniform sampler2D uSampler;\n\n  void main() {\n  gl_FragColor = texture2D(uSampler, vPalettePosition);\n  }"),r=e.createProgram();if(!r||!i||!s)return;if(e.attachShader(r,i),e.attachShader(r,s),e.linkProgram(r),!e.getProgramParameter(r,e.LINK_STATUS))throw this.shaderProgram=null,new Error("Unable to initialize the shader program: "+e.getProgramInfoLog(r));this.shaderProgram=r,e.useProgram(r),this.vertexBuffer=e.createBuffer(),this.colorBuffer=e.createBuffer(),this.uScalingFactor=e.getUniformLocation(r,"uScalingFactor"),this.uShiftVector=e.getUniformLocation(r,"uShiftVector");const n=e.getUniformLocation(r,"uSampler");e.uniform1i(n,0),this.aVertexPosition=e.getAttribLocation(this.shaderProgram,"aVertexPosition"),this.aVertexColor=e.getAttribLocation(this.shaderProgram,"aVertexColor"),e.enableVertexAttribArray(this.aVertexPosition),e.enableVertexAttribArray(this.aVertexColor)}setupGLGeometry(){const e=this.canvasGL.getContext("webgl");if(!e)return;const t=this.timelineData();if(!t)return;const i=t.entryTotalTimes,s=t.entryStartTimes,r=t.entryLevels,n=new Float32Array(6*i.length*2);let o=new Uint8Array(6*i.length),a=0;const l=new Map,h=[],d=this.visibleLevels||[],c=this.rawTimelineData||{groups:[]},u=new Array(d.length),p=c.groups||[];this.forEachGroup(((e,t,i)=>{if(i.style.useFirstLineForOverview||!this.isGroupCollapsible(t)||i.expanded)return;let s=t+1;for(;s<p.length&&p[s].style.nestingLevel>i.style.nestingLevel;)++s;const r=s<p.length?p[s].startLevel:this.dataProvider.maxStackDepth();for(let t=i.startLevel;t<r;++t)u[t]=e}));for(let e=0;e<i.length;++e){const t=r[e],c=u[t];if(!d[t]&&!c)continue;if(!this.entryColorsCache)continue;const p=this.entryColorsCache[e];if(!p)continue;let f=l.get(p);if(void 0===f){const e=Common.Color.Color.parse(p);if(e){const t=e.canonicalRGBA();t[3]=Math.round(255*t[3]),f=h.length/4,h.push(...t),256===f&&(o=new Uint8Array(o))}f&&l.set(p,f)}for(let e=0;e<6;++e)f&&(o[a+e]=f);const m=2*a,g=s[e]-this.minimumBoundaryInternal,v=g+i[e],y=c||this.levelToOffset(t),w=y+this.levelHeight(t)-1;n[m+0]=g,n[m+1]=y,n[m+2]=v,n[m+3]=y,n[m+4]=g,n[m+5]=w,n[m+6]=g,n[m+7]=w,n[m+8]=v,n[m+9]=y,n[m+10]=v,n[m+11]=w,a+=6}this.vertexCount=a;const f=e.createTexture();e.bindTexture(e.TEXTURE_2D,f),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.activeTexture(e.TEXTURE0);const m=h.length/4,g=m>=256,v=g?Math.min(65536,e.getParameter(e.MAX_TEXTURE_SIZE)):256;console.assert(m<=v,"Too many colors");const y=g?e.UNSIGNED_SHORT:e.UNSIGNED_BYTE;if(g){const e=65536/v;for(let t=0;t<a;++t)o[t]*=e}const w=new Uint8Array(4*v);w.set(h),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,v,1,0,e.RGBA,e.UNSIGNED_BYTE,w),this.vertexBuffer&&this.aVertexPosition&&(e.bindBuffer(e.ARRAY_BUFFER,this.vertexBuffer),e.bufferData(e.ARRAY_BUFFER,n,e.STATIC_DRAW),e.vertexAttribPointer(this.aVertexPosition,2,e.FLOAT,!1,0,0)),this.colorBuffer&&this.aVertexColor&&(e.bindBuffer(e.ARRAY_BUFFER,this.colorBuffer),e.bufferData(e.ARRAY_BUFFER,o,e.STATIC_DRAW),e.vertexAttribPointer(this.aVertexColor,1,y,!0,0,0))}drawGL(){const e=this.canvasGL.getContext("webgl");if(!e)return;const t=this.timelineData();if(!t)return;if(this.prevTimelineData&&t.entryTotalTimes===this.prevTimelineData.entryTotalTimes||(this.prevTimelineData=t,this.setupGLGeometry()),e.viewport(0,0,this.canvasGL.width,this.canvasGL.height),!this.vertexCount)return;const i=[2/this.boundarySpan(),-2*window.devicePixelRatio/this.canvasGL.height],s=[this.minimumBoundary()-this.zeroTime(),this.chartViewport.scrollOffset()];this.uScalingFactor&&e.uniform2fv(this.uScalingFactor,i),this.uShiftVector&&e.uniform2fv(this.uShiftVector,s),e.drawArrays(e.TRIANGLES,0,this.vertexCount)}drawGroupHeaders(e,t){const i=this.canvas.getContext("2d"),s=this.chartViewport.scrollOffset(),r=window.devicePixelRatio;if(!this.rawTimelineData)return;const n=this.rawTimelineData.groups||[];if(!n.length)return;const o=this.groupOffsets;if(null==o)return;const a=o[o.length-1],l=ThemeSupport.ThemeSupport.ColorUsage;i.save(),i.scale(r,r),i.translate(0,-s);const h="11px "+Host.Platform.fontFamily();function d(t){i.moveTo(0,t),i.lineTo(e,t)}function c(e,t,s){const r=this.arrowSide*Math.sqrt(3)/2,n=Math.round(r/2);i.save(),i.translate(e,t),i.rotate(s?Math.PI/2:0),i.moveTo(-n,-this.arrowSide/2),i.lineTo(-n,this.arrowSide/2),i.lineTo(r-n,0),i.restore()}i.font=h,i.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("#fff",l.Background),this.forEachGroupInViewport(((t,s,r)=>{const n=r.style.padding;n<5||i.fillRect(0,t-n+2,e,n-4)})),n.length&&a<s+t&&i.fillRect(0,a+2,e,s+t-a),i.strokeStyle=ThemeSupport.ThemeSupport.instance().patchColorText("#eee",l.Background),i.beginPath(),this.forEachGroupInViewport(((e,t,i,s)=>{s||i.style.padding<4||d(e-2.5)})),d(a+1.5),i.stroke(),this.forEachGroupInViewport(((t,s,r)=>{if(r.style.useFirstLineForOverview)return;if(!this.isGroupCollapsible(s)||r.expanded)return void(!r.style.shareHeaderLine&&this.isGroupFocused(s)&&(i.fillStyle=r.style.backgroundColor,i.fillRect(0,t,e,r.style.height)));if(this.useWebGL)return;let o=s+1;for(;o<n.length&&n[o].style.nestingLevel>r.style.nestingLevel;)o++;const a=o<n.length?n[o].startLevel:this.dataProvider.maxStackDepth();this.drawCollapsedOverviewForGroup(r,t,a)})),i.save(),this.forEachGroupInViewport(((e,t,s)=>{if(i.font=s.style.font,this.isGroupCollapsible(t)&&!s.expanded||s.style.shareHeaderLine){const r=this.labelWidthForGroup(i,s)+2;if(this.isGroupFocused(t))i.fillStyle=this.selectedGroupBackroundColor;else{const e=Common.Color.Color.parse(s.style.backgroundColor);e&&(i.fillStyle=e.setAlpha(.8).asString(null))}i.fillRect(this.headerLeftPadding-this.headerLabelXPadding,e+this.headerLabelYPadding,r,s.style.height-2*this.headerLabelYPadding)}i.fillStyle=s.style.color,i.fillText(s.name,Math.floor(this.expansionArrowIndent*(s.style.nestingLevel+1)+this.arrowSide),e+s.style.height-this.textBaseline)})),i.restore(),i.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("#6e6e6e",l.Foreground),i.beginPath(),this.forEachGroupInViewport(((e,t,i)=>{this.isGroupCollapsible(t)&&c.call(this,this.expansionArrowIndent*(i.style.nestingLevel+1),e+i.style.height-this.textBaseline-this.arrowSide/2,Boolean(i.expanded))})),i.fill(),i.strokeStyle=ThemeSupport.ThemeSupport.instance().patchColorText("#ddd",l.Background),i.beginPath(),i.stroke(),this.forEachGroupInViewport(((e,t,s,r,n)=>{if(this.isGroupFocused(t)){const t=2,r=10;i.fillStyle=this.selectedGroupBorderColor,i.fillRect(0,e-t,t,n-s.style.padding+2*t),i.fillRect(0,e-t,r,t),i.fillRect(0,e+n-s.style.padding,r,t)}})),i.restore()}forEachGroup(e){if(!this.rawTimelineData)return;const t=this.rawTimelineData.groups||[];if(!t.length)return;const i=this.groupOffsets;if(!i)return;const s=[{nestingLevel:-1,visible:!0}];for(let r=0;r<t.length;++r){const n=i[r],o=t[r];let a=!0,l=s[s.length-1];for(;l&&l.nestingLevel>=o.style.nestingLevel;)s.pop(),a=!1,l=s[s.length-1];l=s[s.length-1];const h=!!l&&l.visible,d=h&&(!this.isGroupCollapsible(r)||o.expanded);s.push({nestingLevel:o.style.nestingLevel,visible:Boolean(d)});const c=r===t.length-1?i[r+1]+o.style.padding:i[r+1];h&&e(n,r,o,a,c-n)}}forEachGroupInViewport(e){const t=this.chartViewport.scrollOffset();this.forEachGroup(((i,s,r,n,o)=>{i-r.style.padding>t+this.offsetHeight||i+o<t||e(i,s,r,n,o)}))}labelWidthForGroup(e,t){return UI.UIUtils.measureTextWidth(e,t.name)+this.expansionArrowIndent*(t.style.nestingLevel+1)+2*this.headerLabelXPadding}drawCollapsedOverviewForGroup(e,t,i){const s=new Common.SegmentedRange.SegmentedRange((function(e,t){return e.data===t.data&&e.end+.4>t.end?e:null})),r=this.chartViewport.windowLeftTime(),n=this.chartViewport.windowRightTime(),o=this.canvas.getContext("2d"),a=e.style.height;if(!this.rawTimelineData)return;const l=this.rawTimelineData.entryStartTimes,h=this.rawTimelineData.entryTotalTimes,d=this.chartViewport.timeToPixel();for(let c=e.startLevel;c<i;++c){const i=this.timelineLevels?this.timelineLevels[c]:[];let u=1/0;for(let c=Platform.ArrayUtilities.lowerBound(i,n,((e,t)=>e-l[t]))-1;c>=0;--c){const n=i[c],p=l[n],f=this.timeToPositionClipped(p),m=p+h[n];if(isNaN(m)||f>=u)continue;if(m<=r)break;u=f;const g=this.entryColorsCache?this.entryColorsCache[n]:"",v=this.timeToPositionClipped(m);if(e.style.useDecoratorsForOverview&&this.dataProvider.forceDecoration(n)){const e=this.chartViewport.timeToPosition(p),i=v-f;o.beginPath(),o.fillStyle=g,o.fillRect(f,t,i,a-1),this.dataProvider.decorateEntry(n,o,"",f,t,i,a,e,d)}else s.append(new Common.SegmentedRange.Segment(f,v,g))}}const c=s.segments().slice().sort(((e,t)=>e.data.localeCompare(t.data)));let u;o.beginPath();for(let e=0;e<c.length;++e){const i=c[e];u!==c[e].data&&(o.fill(),o.beginPath(),u=c[e].data,o.fillStyle=u),o.rect(i.begin,t,i.end-i.begin,a)}o.fill()}drawFlowEvents(e,t,i){e.save();const s=window.devicePixelRatio,r=this.chartViewport.scrollOffset();e.scale(s,s),e.translate(0,-r),e.fillStyle="#7f5050",e.strokeStyle="#7f5050";const n=this.timelineData();if(!n)return;const o=Platform.ArrayUtilities.lowerBound(n.flowStartTimes,this.chartViewport.windowRightTime(),Platform.ArrayUtilities.DEFAULT_COMPARATOR);e.lineWidth=.5;for(let t=0;t<o;++t){if(!n.flowEndTimes[t]||n.flowEndTimes[t]<this.chartViewport.windowLeftTime())continue;const i=this.chartViewport.timeToPosition(n.flowStartTimes[t]),s=this.chartViewport.timeToPosition(n.flowEndTimes[t]),r=n.flowStartLevels[t],o=n.flowEndLevels[t],a=this.levelToOffset(r)+this.levelHeight(r)/2,l=this.levelToOffset(o)+this.levelHeight(o)/2,h=Math.min((s-i)/4,40),d=(l-a)/10,c=30,u=n.flowEndTimes[t]-n.flowStartTimes[t]<1?a:c+Math.max(0,a+d*(t%c)),p=[];p.push({x:i,y:a}),p.push({x:i+6,y:a}),p.push({x:i+h+12,y:a}),p.push({x:i+h,y:u}),p.push({x:i+2*h,y:u}),p.push({x:s-2*h,y:u}),p.push({x:s-h,y:u}),p.push({x:s-h-12,y:l}),p.push({x:s-6,y:l}),e.beginPath(),e.moveTo(p[0].x,p[0].y),e.lineTo(p[1].x,p[1].y),e.bezierCurveTo(p[2].x,p[2].y,p[3].x,p[3].y,p[4].x,p[4].y),e.lineTo(p[5].x,p[5].y),e.bezierCurveTo(p[6].x,p[6].y,p[7].x,p[7].y,p[8].x,p[8].y),e.stroke(),e.beginPath(),e.arc(i,a,2,-Math.PI/2,Math.PI/2,!1),e.fill(),e.beginPath(),e.moveTo(s,l),e.lineTo(s-6,l-3),e.lineTo(s-6,l+3),e.fill()}e.restore()}drawMarkers(){const e=this.timelineData();if(!e)return;const t=e.markers,i=this.markerIndexBeforeTime(this.minimumBoundary()),s=this.maximumBoundary(),r=this.chartViewport.timeToPixel(),n=this.canvas.getContext("2d");n.save();const o=window.devicePixelRatio;n.scale(o,o),n.translate(0,3);const a=HeaderHeight-1;for(let e=i;e<t.length;e++){const i=t[e].startTime();if(i>s)break;t[e].draw(n,this.chartViewport.timeToPosition(i),a,r)}n.restore()}updateMarkerHighlight(){const e=this.markerHighlighElement;e.parentElement&&e.remove();const t=this.highlightedMarkerIndex;if(-1===t)return;const i=this.timelineData();if(!i)return;const s=i.markers[t],r=this.timeToPositionClipped(s.startTime());UI.Tooltip.Tooltip.install(e,s.title()||"");const n=e.style;n.left=r+"px",n.backgroundColor=s.color(),this.viewportElement.appendChild(e)}processTimelineData(e){if(!e)return this.timelineLevels=null,this.visibleLevelOffsets=null,this.visibleLevels=null,this.groupOffsets=null,this.rawTimelineData=null,this.forceDecorationCache=null,this.entryColorsCache=null,this.rawTimelineDataLength=0,this.selectedGroup=-1,this.keyboardFocusedGroup=-1,void this.flameChartDelegate.updateSelectedGroup(this,null);this.rawTimelineData=e,this.rawTimelineDataLength=e.entryStartTimes.length,this.forceDecorationCache=new Int8Array(this.rawTimelineDataLength),this.entryColorsCache=new Array(this.rawTimelineDataLength);for(let e=0;e<this.rawTimelineDataLength;++e)this.forceDecorationCache[e]=this.dataProvider.forceDecoration(e)?1:0,this.entryColorsCache[e]=this.dataProvider.entryColor(e);const t=new Uint32Array(this.dataProvider.maxStackDepth()+1);for(let i=0;i<e.entryLevels.length;++i)++t[e.entryLevels[i]];const i=new Array(t.length);for(let e=0;e<i.length;++e)i[e]=new Uint32Array(t[e]),t[e]=0;for(let s=0;s<e.entryLevels.length;++s){const r=e.entryLevels[s];i[r][t[r]++]=s}this.timelineLevels=i;const s=this.rawTimelineData.groups||[];for(let e=0;e<s.length;++e){const t=this.groupExpansionState[s[e].name];void 0!==t&&(s[e].expanded=t)}this.updateLevelPositions(),this.updateHeight(),this.selectedGroup=e.selectedGroup?s.indexOf(e.selectedGroup):-1,this.keyboardFocusedGroup=this.selectedGroup,this.flameChartDelegate.updateSelectedGroup(this,e.selectedGroup)}updateLevelPositions(){const e=this.dataProvider.maxStackDepth(),t=this.rawTimelineData&&this.rawTimelineData.groups||[];this.visibleLevelOffsets=new Uint32Array(e+1),this.visibleLevelHeights=new Uint32Array(e),this.visibleLevels=new Uint16Array(e),this.groupOffsets=new Uint32Array(t.length+1);let i=-1,s=this.rulerEnabled?HeaderHeight+2:2,r=!0;const n=[{nestingLevel:-1,visible:!0}],o=Math.max(e,t.length?t[t.length-1].startLevel+1:0);let a;for(a=0;a<o;++a){let o,l=!0;for(;i<t.length-1&&a===t[i+1].startLevel;){++i,o=t[i].style;let e=!0,a=n[n.length-1];for(;a&&a.nestingLevel>=o.nestingLevel;)n.pop(),e=!1,a=n[n.length-1];const h=!(i>=0&&this.isGroupCollapsible(i))||t[i].expanded;a=n[n.length-1],l=!!a&&a.visible,r=Boolean(h)&&l,n.push({nestingLevel:o.nestingLevel,visible:r}),l&&(s+=e?0:o.padding),this.groupOffsets[i]=s,l&&!o.shareHeaderLine&&(s+=o.height)}if(a>=e)continue;const h=i>=0&&a===t[i].startLevel,d=l&&(r||h&&t[i].style.useFirstLineForOverview);let c;if(i>=0){const e=t[i],s=e.style;c=h&&!s.shareHeaderLine||s.collapsible&&!e.expanded?s.height:s.itemsHeight||this.barHeight}else c=this.barHeight;this.visibleLevels[a]=d?1:0,this.visibleLevelOffsets[a]=s,this.visibleLevelHeights[a]=c,(d||l&&o&&o.shareHeaderLine&&h)&&(s+=this.visibleLevelHeights[a])}i>=0&&(this.groupOffsets[i+1]=s),this.visibleLevelOffsets[a]=s,this.useWebGL&&this.setupGLGeometry()}isGroupCollapsible(e){if(!this.rawTimelineData)return;const t=this.rawTimelineData.groups||[],i=t[e].style;if(!i.shareHeaderLine||!i.collapsible)return Boolean(i.collapsible);const s=e+1>=t.length;if(!s&&t[e+1].style.nestingLevel>i.nestingLevel)return!0;return(s?this.dataProvider.maxStackDepth():t[e+1].startLevel)!==t[e].startLevel+1||i.height!==i.itemsHeight}setSelectedEntry(e){this.selectedEntryIndex!==e&&(-1!==e&&this.chartViewport.hideRangeSelection(),this.selectedEntryIndex=e,this.revealEntry(e),this.updateElementPosition(this.selectedElement,this.selectedEntryIndex))}updateElementPosition(e,t){if(e.classList.add("hidden"),-1===t)return;const i=this.timelineData();if(!i)return;const s=i.entryStartTimes[t],r=i.entryTotalTimes[t];let n=0,o=0,a=!0;if(Number.isNaN(r)){const e=this.markerPositions.get(t);e?(n=e.x,o=e.width):a=!1}else n=this.chartViewport.timeToPosition(s),o=r*this.chartViewport.timeToPixel();if(n+o<=0||n>=this.offsetWidth)return;const l=n+o/2;o=Math.max(o,2),n=l-o/2;const h=i.entryLevels[t],d=this.levelToOffset(h)-this.chartViewport.scrollOffset(),c=this.levelHeight(h),u=e.style;u.left=n+"px",u.top=d+"px",u.width=o+"px",u.height=c-1+"px",e.classList.toggle("hidden",!a),this.viewportElement.appendChild(e)}timeToPositionClipped(e){return Platform.NumberUtilities.clamp(this.chartViewport.timeToPosition(e),0,this.offsetWidth)}levelToOffset(e){if(!this.visibleLevelOffsets)throw new Error("No visible level offsets");return this.visibleLevelOffsets[e]}levelHeight(e){if(!this.visibleLevelHeights)throw new Error("No visible level heights");return this.visibleLevelHeights[e]}updateBoundaries(){this.totalTime=this.dataProvider.totalTime(),this.minimumBoundaryInternal=this.dataProvider.minimumBoundary(),this.chartViewport.setBoundaries(this.minimumBoundaryInternal,this.totalTime)}updateHeight(){const e=this.levelToOffset(this.dataProvider.maxStackDepth())+2;this.chartViewport.setContentHeight(e)}onResize(){this.scheduleUpdate()}update(){this.timelineData()&&(this.resetCanvas(),this.updateHeight(),this.updateBoundaries(),this.draw(),this.chartViewport.isDragging()||this.updateHighlight())}reset(){this.chartViewport.reset(),this.rawTimelineData=null,this.rawTimelineDataLength=0,this.highlightedMarkerIndex=-1,this.highlightedEntryIndex=-1,this.selectedEntryIndex=-1,this.textWidth=new Map,this.chartViewport.scheduleUpdate()}scheduleUpdate(){this.chartViewport.scheduleUpdate()}enabled(){return 0!==this.rawTimelineDataLength}computePosition(e){return this.chartViewport.timeToPosition(e)}formatValue(e,t){return this.dataProvider.formatValue(e-this.zeroTime(),t)}maximumBoundary(){return this.chartViewport.windowRightTime()}minimumBoundary(){return this.chartViewport.windowLeftTime()}zeroTime(){return this.dataProvider.minimumBoundary()}boundarySpan(){return this.maximumBoundary()-this.minimumBoundary()}}export const HeaderHeight=15;export const MinimalTimeWindowMs=.5;export class TimelineData{entryLevels;entryTotalTimes;entryStartTimes;groups;markers;flowStartTimes;flowStartLevels;flowEndTimes;flowEndLevels;selectedGroup;constructor(e,t,i,s){this.entryLevels=e,this.entryTotalTimes=t,this.entryStartTimes=i,this.groups=s||[],this.markers=[],this.flowStartTimes=[],this.flowStartLevels=[],this.flowEndTimes=[],this.flowEndLevels=[],this.selectedGroup=null}}export var Events;!function(e){e.CanvasFocused="CanvasFocused",e.EntryInvoked="EntryInvoked",e.EntrySelected="EntrySelected",e.EntryHighlighted="EntryHighlighted"}(Events||(Events={}));export const Colors={SelectedGroupBackground:"hsl(215, 85%, 98%)",SelectedGroupBorder:"hsl(216, 68%, 54%)"};