import*as Common from"../../../../core/common/common.js";import*as Host from"../../../../core/host/host.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as Diff from"../../../../third_party/diff/diff.js";import*as UI from"../../legacy.js";import{FilteredListWidget,Provider,registerProvider}from"./FilteredListWidget.js";import{QuickOpenImpl}from"./QuickOpen.js";const UIStrings={oneOrMoreSettingsHaveChanged:"One or more settings have changed which requires a reload to take effect.",noCommandsFound:"No commands found",run:"Run",command:"Command"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/quick_open/CommandMenu.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let commandMenuInstance,commandMenuProviderInstance,showActionDelegateInstance;export class CommandMenu{commandsInternal;constructor(){this.commandsInternal=[],this.loadCommands()}static instance(e={forceNew:null}){const{forceNew:t}=e;return commandMenuInstance&&!t||(commandMenuInstance=new CommandMenu),commandMenuInstance}static createCommand(e){const{category:t,keys:n,title:o,shortcut:r,executeHandler:a,availableHandler:i,userActionCode:s}=e;let c=a;if(s){const e=s;c=()=>{Host.userMetrics.actionTaken(e),a()}}if("Show Issues"===o){const e=c;c=()=>{Host.userMetrics.issuesPanelOpenedFrom(Host.UserMetrics.IssueOpener.CommandMenu),e()}}return new Command(t,o,n,r,c,i)}static createSettingCommand(e,t,n){const o=e.category();if(!o)throw new Error(`Creating '${t}' setting command failed. Setting has no category.`);const r=e.tags()||"",a=Boolean(e.reloadRequired());return CommandMenu.createCommand({category:Common.Settings.getLocalizedSettingsCategory(o),keys:r,title:t,shortcut:"",executeHandler:()=>{e.set(n),a&&UI.InspectorView.InspectorView.instance().displayReloadRequiredWarning(i18nString(UIStrings.oneOrMoreSettingsHaveChanged))},availableHandler:function(){return e.get()!==n},userActionCode:void 0})}static createActionCommand(e){const{action:t,userActionCode:n}=e,o=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction(t.id())||"";return CommandMenu.createCommand({category:t.category(),keys:t.tags()||"",title:t.title()||"",shortcut:o,executeHandler:t.execute.bind(t),userActionCode:n,availableHandler:void 0})}static createRevealViewCommand(e){const{title:t,tags:n,category:o,userActionCode:r,id:a}=e;return CommandMenu.createCommand({category:o,keys:n,title:t,shortcut:"",executeHandler:UI.ViewManager.ViewManager.instance().showView.bind(UI.ViewManager.ViewManager.instance(),a,!0),userActionCode:r,availableHandler:void 0})}loadCommands(){const e=new Map;for(const{category:t,name:n}of UI.ViewManager.getRegisteredLocationResolvers())t&&n&&e.set(n,t);const t=UI.ViewManager.getRegisteredViewExtensions();for(const n of t){const t=n.location(),o=t&&e.get(t);if(!o)continue;const r={title:n.commandPrompt(),tags:n.tags()||"",category:o,userActionCode:void 0,id:n.viewId()};this.commandsInternal.push(CommandMenu.createRevealViewCommand(r))}const n=Common.Settings.getRegisteredSettings();for(const e of n){const t=e.options;if(t&&e.category)for(const n of t){const t=Common.Settings.Settings.instance().moduleSetting(e.settingName);this.commandsInternal.push(CommandMenu.createSettingCommand(t,n.title(),n.value))}}}commands(){return this.commandsInternal}}export class CommandMenuProvider extends Provider{commands;constructor(){super(),this.commands=[]}static instance(e={forceNew:null}){const{forceNew:t}=e;return commandMenuProviderInstance&&!t||(commandMenuProviderInstance=new CommandMenuProvider),commandMenuProviderInstance}attach(){const e=CommandMenu.instance().commands(),t=UI.ActionRegistry.ActionRegistry.instance().availableActions();for(const e of t){if(!e.category())continue;const t={action:e,userActionCode:void 0};this.commands.push(CommandMenu.createActionCommand(t))}for(const t of e)t.available()&&this.commands.push(t);this.commands=this.commands.sort((function(e,t){const n=Platform.StringUtilities.compare(e.category(),t.category());return n||Platform.StringUtilities.compare(e.title(),t.title())}))}detach(){this.commands=[]}itemCount(){return this.commands.length}itemKeyAt(e){return this.commands[e].key()}itemScoreAt(e,t){const n=this.commands[e];let o=Diff.Diff.DiffWrapper.characterScore(t.toLowerCase(),n.title().toLowerCase());return n.category().startsWith("Panel")?o+=2:n.category().startsWith("Drawer")&&(o+=1),o}renderItem(e,t,n,o){const r=this.commands[e];n.removeChildren(),UI.UIUtils.createTextChild(n,r.title()),FilteredListWidget.highlightRanges(n,t,!0),o.textContent=r.shortcut();const a=n.parentElement?.parentElement?.createChild("span","tag");if(!a)return;const i=Platform.StringUtilities.hashCode(r.category())%MaterialPaletteColors.length;a.style.backgroundColor=MaterialPaletteColors[i],a.style.color="var(--color-background)",a.textContent=r.category()}selectItem(e,t){null!==e&&(this.commands[e].execute(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.SelectCommandFromCommandMenu))}notFoundText(){return i18nString(UIStrings.noCommandsFound)}}export const MaterialPaletteColors=["#F44336","#E91E63","#9C27B0","#673AB7","#3F51B5","#03A9F4","#00BCD4","#009688","#4CAF50","#8BC34A","#CDDC39","#FFC107","#FF9800","#FF5722","#795548","#9E9E9E","#607D8B"];export class Command{categoryInternal;titleInternal;keyInternal;shortcutInternal;executeHandler;availableHandler;constructor(e,t,n,o,r,a){this.categoryInternal=e,this.titleInternal=t,this.keyInternal=e+"\0"+t+"\0"+n,this.shortcutInternal=o,this.executeHandler=r,this.availableHandler=a}category(){return this.categoryInternal}title(){return this.titleInternal}key(){return this.keyInternal}shortcut(){return this.shortcutInternal}available(){return!this.availableHandler||this.availableHandler()}execute(){this.executeHandler()}}export class ShowActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return showActionDelegateInstance&&!t||(showActionDelegateInstance=new ShowActionDelegate),showActionDelegateInstance}handleAction(e,t){return Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront(),QuickOpenImpl.show(">"),!0}}registerProvider({prefix:">",iconName:"ic_command_run_command",provider:()=>Promise.resolve(CommandMenuProvider.instance()),titlePrefix:()=>i18nString(UIStrings.run),titleSuggestion:()=>i18nString(UIStrings.command)});