import*as Common from"../../../../core/common/common.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as Formatter from"../../../../models/formatter/formatter.js";import*as TextUtils from"../../../../models/text_utils/text_utils.js";import*as CodeMirror from"../../../../third_party/codemirror.next/codemirror.next.js";import*as CodeHighlighter from"../../../components/code_highlighter/code_highlighter.js";import*as TextEditor from"../../../components/text_editor/text_editor.js";import*as UI from"../../legacy.js";const UIStrings={source:"Source",prettyPrint:"Pretty print",loading:"Loading…",dSelectionRegions:"{PH1} selection regions",bytecodePositionXs:"Bytecode position `0x`{PH1}",lineSColumnS:"Line {PH1}, Column {PH2}",dCharactersSelected:"{PH1} characters selected",dLinesDCharactersSelected:"{PH1} lines, {PH2} characters selected"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/source_frame/SourceFrame.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SourceFrameImpl extends(Common.ObjectWrapper.eventMixin(UI.View.SimpleView)){options;lazyContent;prettyInternal;rawContent;formattedContentPromise;formattedMap;prettyToggle;shouldAutoPrettyPrint;progressToolbarItem;textEditorInternal;prettyBaseDoc=null;baseDoc;displayedSelection=null;searchConfig;delayedFindSearchMatches;currentSearchResultIndex;searchResults;searchRegex;loadError;muteChangeEventsForSetContent;sourcePosition;searchableView;editable;positionToReveal;lineToScrollTo;selectionToSet;loadedInternal;contentRequested;wasmDisassemblyInternal;contentSet;constructor(e,t={}){super(i18nString(UIStrings.source)),this.options=t,this.lazyContent=e,this.prettyInternal=!1,this.rawContent=null,this.formattedContentPromise=null,this.formattedMap=null,this.prettyToggle=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.prettyPrint),"largeicon-pretty-print"),this.prettyToggle.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this.setPretty(!this.prettyToggle.toggled())})),this.shouldAutoPrettyPrint=!1,this.prettyToggle.setVisible(!1),this.progressToolbarItem=new UI.Toolbar.ToolbarItem(document.createElement("div")),this.textEditorInternal=new TextEditor.TextEditor.TextEditor(this.placeholderEditorState("")),this.textEditorInternal.style.flexGrow="1",this.element.appendChild(this.textEditorInternal),this.element.addEventListener("keydown",(e=>{e.defaultPrevented&&e.stopPropagation()})),this.baseDoc=this.textEditorInternal.state.doc,this.searchConfig=null,this.delayedFindSearchMatches=null,this.currentSearchResultIndex=-1,this.searchResults=[],this.searchRegex=null,this.loadError=!1,this.muteChangeEventsForSetContent=!1,this.sourcePosition=new UI.Toolbar.ToolbarText,this.searchableView=null,this.editable=!1,this.positionToReveal=null,this.lineToScrollTo=null,this.selectionToSet=null,this.loadedInternal=!1,this.contentRequested=!1,this.wasmDisassemblyInternal=null,this.contentSet=!1}placeholderEditorState(e){return CodeMirror.EditorState.create({doc:e,extensions:[CodeMirror.EditorState.readOnly.of(!0),!1!==this.options.lineNumbers?CodeMirror.lineNumbers():[],TextEditor.Config.theme()]})}editorConfiguration(e){return[CodeMirror.EditorView.updateListener.of((e=>this.dispatchEventToListeners("EditorUpdate",e))),TextEditor.Config.baseConfiguration(e),TextEditor.Config.closeBrackets,TextEditor.Config.sourcesAutocompletion.instance(),TextEditor.Config.showWhitespace.instance(),TextEditor.Config.allowScrollPastEof.instance(),TextEditor.Config.codeFolding.instance(),TextEditor.Config.autoDetectIndent.instance(),CodeMirror.EditorView.theme({"&.cm-editor":{height:"100%"},".cm-scroller":{overflow:"auto"},".cm-lineNumbers .cm-gutterElement.cm-nonBreakableLine":{color:"var(--color-non-breakable-line)"},".cm-searchMatch":{border:"1px solid var(--color-search-match-border)",borderRadius:"3px",margin:"0 -1px","&.cm-searchMatch-selected":{borderRadius:"1px",backgroundColor:"var(--color-selected-search-match-background)",borderColor:"var(--color-selected-search-match-background)","&, & *":{color:"var(--color-selected-search-match) !important"}}},":host-context(.pretty-printed) & .cm-lineNumbers .cm-gutterElement":{color:"var(--legacy-accent-color)"}}),CodeMirror.EditorView.domEventHandlers({focus:()=>this.onFocus(),blur:()=>this.onBlur(),scroll:()=>this.dispatchEventToListeners("EditorScroll"),contextmenu:e=>this.onContextMenu(e)}),CodeMirror.lineNumbers({domEventHandlers:{contextmenu:(e,t,r)=>this.onLineGutterContextMenu(t.from,r)}}),CodeMirror.EditorView.updateListener.of((e=>{(e.selectionSet||e.docChanged)&&this.updateSourcePosition(),e.docChanged&&this.onTextChanged()})),activeSearchState,CodeMirror.Prec.lowest(searchHighlighter),config.language.of([]),this.wasmDisassemblyInternal?markNonBreakableLines(this.wasmDisassemblyInternal):nonBreakableLines,this.options.lineWrapping?CodeMirror.EditorView.lineWrapping:[],!1!==this.options.lineNumbers?CodeMirror.lineNumbers():[]]}onBlur(){}onFocus(){this.resetCurrentSearchResultIndex()}get wasmDisassembly(){return this.wasmDisassemblyInternal}editorLocationToUILocation(e,t){return this.wasmDisassemblyInternal?(t=this.wasmDisassemblyInternal.lineNumberToBytecodeOffset(e),e=0):this.prettyInternal&&([e,t]=this.prettyToRawLocation(e,t)),{lineNumber:e,columnNumber:t}}uiLocationToEditorLocation(e,t=0){return this.wasmDisassemblyInternal?(e=this.wasmDisassemblyInternal.bytecodeOffsetToLineNumber(t),t=0):this.prettyInternal&&([e,t]=this.rawToPrettyLocation(e,t)),{lineNumber:e,columnNumber:t}}setCanPrettyPrint(e,t){this.shouldAutoPrettyPrint=e&&Boolean(t),this.prettyToggle.setVisible(e)}setEditable(e){this.editable=e,this.loaded&&e!==!this.textEditor.state.readOnly&&this.textEditor.dispatch({effects:config.editable.reconfigure(CodeMirror.EditorState.readOnly.of(!e))})}async setPretty(e){this.prettyInternal=e,this.prettyToggle.setEnabled(!1);const t=this.loaded,{textEditor:r}=this,o=r.state.selection.main,i=r.toLineColumn(o.from),s=r.toLineColumn(o.to);let n;if(this.prettyInternal){const e=await this.requestFormattedContent();this.formattedMap=e.formattedMapping,await this.setContent(e.formattedContent),this.prettyBaseDoc=r.state.doc;const t=this.rawToPrettyLocation(i.lineNumber,i.columnNumber),o=this.rawToPrettyLocation(s.lineNumber,s.columnNumber);n=r.createSelection({lineNumber:t[0],columnNumber:t[1]},{lineNumber:o[0],columnNumber:o[1]})}else{await this.setContent(this.rawContent||""),this.baseDoc=r.state.doc;const e=this.prettyToRawLocation(i.lineNumber,i.columnNumber),t=this.prettyToRawLocation(s.lineNumber,s.columnNumber);n=r.createSelection({lineNumber:e[0],columnNumber:e[1]},{lineNumber:t[0],columnNumber:t[1]})}t&&r.revealPosition(n,!1),this.prettyToggle.setEnabled(!0),this.updatePrettyPrintState()}getLineNumberFormatter(){if(!1===this.options.lineNumbers)return[];let e=null;if(this.wasmDisassemblyInternal){const t=this.wasmDisassemblyInternal,r=t.lineNumberToBytecodeOffset(t.lineNumbers-1).toString(16).length+1;e=e=>`0x${t.lineNumberToBytecodeOffset(Math.min(t.lineNumbers,e)-1).toString(16).padStart(r,"0")}`}else this.prettyInternal&&(e=e=>{const t=this.prettyToRawLocation(e-1,0)[0]+1;return 1===e||t!==this.prettyToRawLocation(e-2,0)[0]+1?String(t):"-"});return e?CodeMirror.lineNumbers({formatNumber:e}):[]}updateLineNumberFormatter(){this.textEditor.dispatch({effects:config.lineNumbers.reconfigure(this.getLineNumberFormatter())})}updatePrettyPrintState(){this.prettyToggle.setToggled(this.prettyInternal),this.textEditorInternal.classList.toggle("pretty-printed",this.prettyInternal),this.updateLineNumberFormatter()}prettyToRawLocation(e,t=0){return this.formattedMap?this.formattedMap.formattedToOriginal(e,t):[e,t]}rawToPrettyLocation(e,t){return this.formattedMap?this.formattedMap.originalToFormatted(e,t):[e,t]}hasLoadError(){return this.loadError}wasShown(){this.ensureContentLoaded(),this.wasShownOrLoaded()}willHide(){super.willHide(),this.clearPositionToReveal()}async toolbarItems(){return[this.prettyToggle,this.sourcePosition,this.progressToolbarItem]}get loaded(){return this.loadedInternal}get textEditor(){return this.textEditorInternal}get pretty(){return this.prettyInternal}get contentType(){return this.loadError?"":this.getContentType()}getContentType(){return""}async ensureContentLoaded(){if(!this.contentRequested){this.contentRequested=!0;const e=new UI.ProgressIndicator.ProgressIndicator;e.setTitle(i18nString(UIStrings.loading)),e.setTotalWork(100),this.progressToolbarItem.element.appendChild(e.element);const t=await this.lazyContent();let r,o;if(null===t.content?(r=t.error,this.rawContent=t.error):(o=t.content,this.rawContent=t.isEncoded?window.atob(t.content):t.content),e.setWorked(1),!r&&"application/wasm"===this.contentType){const t=Common.Worker.WorkerWrapper.fromURL(new URL("../../../../entrypoints/wasmparser_worker/wasmparser_worker-entrypoint.js",import.meta.url)),i=new Promise(((r,o)=>{t.onmessage=({data:t})=>{if("event"in t){if("progress"===t.event)e.setWorked(t.params.percentage)}else if("method"in t&&"disassemble"===t.method)"error"in t?o(t.error):"result"in t&&r(t.result)},t.onerror=o}));t.postMessage({method:"disassemble",params:{content:o}});try{const{source:e,offsets:r,functionBodyOffsets:s}=await i;this.rawContent=o=e,this.wasmDisassemblyInternal=new Common.WasmDisassembly.WasmDisassembly(r,s)}catch(e){this.rawContent=o=r=e.message}finally{t.terminate()}}e.setWorked(100),e.done(),this.formattedContentPromise=null,this.formattedMap=null,this.prettyToggle.setEnabled(!0),r?(this.loadError=!0,this.textEditor.editor.setState(this.placeholderEditorState(r)),this.prettyToggle.setEnabled(!1)):this.shouldAutoPrettyPrint&&TextUtils.TextUtils.isMinified(o)?await this.setPretty(!0):await this.setContent(this.rawContent||""),this.contentSet=!0}}requestFormattedContent(){return this.formattedContentPromise||(this.formattedContentPromise=Formatter.ScriptFormatter.formatScriptContent(this.contentType,this.rawContent||"")),this.formattedContentPromise}revealPosition(e,t){this.lineToScrollTo=null,this.selectionToSet=null;let r=0,o=0;if("number"==typeof e){const{doc:t}=this.textEditor.state;if(e>t.length)r=t.lines-1;else if(e>=0){const i=t.lineAt(e);r=i.number-1,o=e-i.from}}else r=e.lineNumber,o=e.columnNumber??0;this.positionToReveal={line:r,column:o,shouldHighlight:t},this.innerRevealPositionIfNeeded()}innerRevealPositionIfNeeded(){if(!this.positionToReveal)return;if(!this.loaded||!this.isShowing())return;const e=this.uiLocationToEditorLocation(this.positionToReveal.line,this.positionToReveal.column),{textEditor:t}=this;t.revealPosition(t.createSelection(e),this.positionToReveal.shouldHighlight),this.positionToReveal=null}clearPositionToReveal(){this.positionToReveal=null}scrollToLine(e){this.clearPositionToReveal(),this.lineToScrollTo=e,this.innerScrollToLineIfNeeded()}innerScrollToLineIfNeeded(){if(null!==this.lineToScrollTo&&this.loaded&&this.isShowing()){const{textEditor:e}=this,t=e.toOffset({lineNumber:this.lineToScrollTo,columnNumber:0});e.dispatch({effects:CodeMirror.EditorView.scrollTo.of(CodeMirror.EditorSelection.cursor(t))}),this.lineToScrollTo=null}}setSelection(e){this.selectionToSet=e,this.innerSetSelectionIfNeeded()}innerSetSelectionIfNeeded(){const e=this.selectionToSet;if(e&&this.loaded&&this.isShowing()){const{textEditor:t}=this;t.dispatch({selection:t.createSelection({lineNumber:e.startLine,columnNumber:e.startColumn},{lineNumber:e.endLine,columnNumber:e.endColumn})}),this.selectionToSet=null}}wasShownOrLoaded(){this.innerRevealPositionIfNeeded(),this.innerSetSelectionIfNeeded(),this.innerScrollToLineIfNeeded()}onTextChanged(){const e=this.pretty;this.prettyInternal=Boolean(this.prettyBaseDoc&&this.textEditor.state.doc.eq(this.prettyBaseDoc)),this.prettyInternal!==e&&this.updatePrettyPrintState(),this.prettyToggle.setEnabled(this.isClean()),this.searchConfig&&this.searchableView&&this.performSearch(this.searchConfig,!1,!1)}isClean(){return this.textEditor.state.doc.eq(this.baseDoc)||null!==this.prettyBaseDoc&&this.textEditor.state.doc.eq(this.prettyBaseDoc)}contentCommitted(){this.baseDoc=this.textEditorInternal.state.doc,this.prettyBaseDoc=null,this.rawContent=this.textEditor.state.doc.toString(),this.formattedMap=null,this.formattedContentPromise=null,this.prettyInternal&&(this.prettyInternal=!1,this.updatePrettyPrintState()),this.prettyToggle.setEnabled(!0)}simplifyMimeType(e,t){return t?t.indexOf("typescript")>=0?"text/typescript-jsx":t.indexOf("javascript")>=0||t.indexOf("jscript")>=0||t.indexOf("ecmascript")>=0?"text/jsx":"text/x-php"===t&&e.match(/\<\?.*\?\>/g)?"application/x-httpd-php":"application/wasm"===t?"text/webassembly":t:""}async getLanguageSupport(e){const t=this.simplifyMimeType(e,this.contentType)||"",r=await CodeHighlighter.CodeHighlighter.languageFromMIME(t);return r?"text/jsx"===t?[r,CodeMirror.javascript.javascriptLanguage.data.of({autocomplete:CodeMirror.completeAnyWord})]:r:[]}async updateLanguageMode(e){const t=await this.getLanguageSupport(e);this.textEditor.dispatch({effects:config.language.reconfigure(t)})}async setContent(e){this.muteChangeEventsForSetContent=!0;const{textEditor:t}=this,r=this.loadedInternal,o=t.editor.scrollDOM.scrollTop;this.loadedInternal=!0;const i=await this.getLanguageSupport(e),s=CodeMirror.EditorState.create({doc:e,extensions:[this.editorConfiguration(e),i,config.lineNumbers.of(this.getLineNumberFormatter()),config.editable.of(this.editable?[]:CodeMirror.EditorState.readOnly.of(!0))]});this.baseDoc=s.doc,t.editor.setState(s),r&&(t.editor.scrollDOM.scrollTop=o),this.wasShownOrLoaded(),this.delayedFindSearchMatches&&(this.delayedFindSearchMatches(),this.delayedFindSearchMatches=null),this.muteChangeEventsForSetContent=!1}setSearchableView(e){this.searchableView=e}doFindSearchMatches(e,t,r){this.currentSearchResultIndex=-1,this.searchRegex=e.toSearchRegex(!0),this.searchResults=this.collectRegexMatches(this.searchRegex),this.searchableView&&this.searchableView.updateSearchMatchesCount(this.searchResults.length);const o=this.textEditor;this.searchResults.length?t&&r?this.jumpToPreviousSearchResult():t?this.jumpToNextSearchResult():o.dispatch({effects:setActiveSearch.of(new ActiveSearch(this.searchRegex,null))}):o.state.field(activeSearchState)&&o.dispatch({effects:setActiveSearch.of(null)})}performSearch(e,t,r){this.searchableView&&this.searchableView.updateSearchMatchesCount(0),this.resetSearch(),this.searchConfig=e,this.loaded?this.doFindSearchMatches(e,t,Boolean(r)):this.delayedFindSearchMatches=this.doFindSearchMatches.bind(this,e,t,Boolean(r)),this.ensureContentLoaded()}resetCurrentSearchResultIndex(){if(!this.searchResults.length)return;this.currentSearchResultIndex=-1,this.searchableView&&this.searchableView.updateCurrentMatchIndex(this.currentSearchResultIndex);const e=this.textEditor,t=e.state.field(activeSearchState);t&&t.currentRange&&e.dispatch({effects:setActiveSearch.of(new ActiveSearch(t.regexp,null))})}resetSearch(){this.searchConfig=null,this.delayedFindSearchMatches=null,this.currentSearchResultIndex=-1,this.searchResults=[],this.searchRegex=null}searchCanceled(){const e=-1!==this.currentSearchResultIndex?this.searchResults[this.currentSearchResultIndex]:null;if(this.resetSearch(),!this.loaded)return;this.textEditor.dispatch({effects:setActiveSearch.of(null),selection:e?{anchor:e.from,head:e.to}:void 0,scrollIntoView:!0,userEvent:"select.search.cancel"})}jumpToLastSearchResult(){this.jumpToSearchResult(this.searchResults.length-1)}searchResultIndexForCurrentSelection(){return Platform.ArrayUtilities.lowerBound(this.searchResults,this.textEditor.state.selection.main,((e,t)=>e.to-t.to))}jumpToNextSearchResult(){const e=this.searchResultIndexForCurrentSelection(),t=-1===this.currentSearchResultIndex?e:e+1;this.jumpToSearchResult(t)}jumpToPreviousSearchResult(){const e=this.searchResultIndexForCurrentSelection();this.jumpToSearchResult(e-1)}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}jumpToSearchResult(e){if(!this.loaded||!this.searchResults.length)return;this.currentSearchResultIndex=(e+this.searchResults.length)%this.searchResults.length,this.searchableView&&this.searchableView.updateCurrentMatchIndex(this.currentSearchResultIndex);const t=this.textEditor,r=this.searchResults[this.currentSearchResultIndex];t.dispatch({effects:setActiveSearch.of(new ActiveSearch(this.searchRegex,r)),selection:{anchor:r.from,head:r.to},scrollIntoView:!0,userEvent:"select.search"})}replaceSelectionWith(e,t){const r=this.searchResults[this.currentSearchResultIndex];if(!r)return;const o=this.searchRegex.__fromRegExpQuery?r.insertPlaceholders(t):t,i=this.textEditor,s=i.state.changes({from:r.from,to:r.to,insert:o});i.dispatch({changes:s,selection:{anchor:s.mapPos(i.state.selection.main.to,1)},userEvent:"input.replace"})}replaceAllWith(e,t){this.resetCurrentSearchResultIndex();const r=e.toSearchRegex(!0),o=this.collectRegexMatches(r);if(!o.length)return;const i=r.__fromRegExpQuery,s=o.map((e=>({from:e.from,to:e.to,insert:i?e.insertPlaceholders(t):t})));this.textEditor.dispatch({changes:s,scrollIntoView:!0,userEvent:"input.replace.all"})}collectRegexMatches(e){const t=[];let r=0;for(const o of this.textEditor.state.doc.iterLines()){for(e.lastIndex=0;;){const i=e.exec(o);if(!i)break;if(i[0].length){const e=r+i.index;t.push(new SearchMatch(e,e+i[0].length,i))}}r+=o.length+1}return t}canEditSource(){return this.editable}updateSourcePosition(){const{textEditor:e}=this,{state:t}=e,{selection:r}=t;if(this.displayedSelection?.eq(r))return;if(this.displayedSelection=r,r.ranges.length>1)return void this.sourcePosition.setText(i18nString(UIStrings.dSelectionRegions,{PH1:r.ranges.length}));const{main:o}=t.selection;if(o.empty){const{lineNumber:t,columnNumber:r}=e.toLineColumn(o.head),i=this.prettyToRawLocation(t,r);if(this.wasmDisassemblyInternal){const e=this.wasmDisassemblyInternal,t=e.lineNumberToBytecodeOffset(e.lineNumbers-1).toString(16).length,r=e.lineNumberToBytecodeOffset(i[0]);this.sourcePosition.setText(i18nString(UIStrings.bytecodePositionXs,{PH1:r.toString(16).padStart(t,"0")}))}else this.sourcePosition.setText(i18nString(UIStrings.lineSColumnS,{PH1:i[0]+1,PH2:i[1]+1}))}else{const e=t.doc.lineAt(o.from),r=t.doc.lineAt(o.to);e.number===r.number?this.sourcePosition.setText(i18nString(UIStrings.dCharactersSelected,{PH1:o.to-o.from})):this.sourcePosition.setText(i18nString(UIStrings.dLinesDCharactersSelected,{PH1:r.number-e.number+1,PH2:o.to-o.from}))}}onContextMenu(e){e.consume(!0);const t=new UI.ContextMenu.ContextMenu(e),{state:r}=this.textEditor,o=r.selection.main.from,i=r.doc.lineAt(o);return this.populateTextAreaContextMenu(t,i.number-1,o-i.from),t.appendApplicableItems(this),t.show(),!0}populateTextAreaContextMenu(e,t,r){}onLineGutterContextMenu(e,t){t.consume(!0);const r=new UI.ContextMenu.ContextMenu(t),o=this.textEditor.state.doc.lineAt(e).number-1;return this.populateLineGutterContextMenu(r,o),r.appendApplicableItems(this),r.show(),!0}populateLineGutterContextMenu(e,t){}focus(){this.textEditor.focus()}}class SearchMatch{from;to;match;constructor(e,t,r){this.from=e,this.to=t,this.match=r}insertPlaceholders(e){return e.replace(/\$(\$|&|\d+|<[^>]+>)/g,((e,t)=>"$"===t?"$":"&"===t?this.match[0]:"<"===t[0]?this.match.groups&&this.match.groups[t.slice(1,t.length-1)]||"":this.match[Number.parseInt(t,10)]||""))}}export var DecoratorType;!function(e){e.PERFORMANCE="performance",e.MEMORY="memory",e.COVERAGE="coverage"}(DecoratorType||(DecoratorType={}));const config={editable:new CodeMirror.Compartment,language:new CodeMirror.Compartment,lineNumbers:new CodeMirror.Compartment};class ActiveSearch{regexp;currentRange;constructor(e,t){this.regexp=e,this.currentRange=t}map(e){return e.empty||!this.currentRange?this:new ActiveSearch(this.regexp,{from:e.mapPos(this.currentRange.from),to:e.mapPos(this.currentRange.to)})}static eq(e,t){return Boolean(e===t||e&&t&&e.currentRange?.from===t.currentRange?.from&&e.currentRange?.to===t.currentRange?.to&&e.regexp.source===t.regexp.source&&e.regexp.flags===t.regexp.flags)}}const setActiveSearch=CodeMirror.StateEffect.define({map:(e,t)=>e&&e.map(t)}),activeSearchState=CodeMirror.StateField.define({create:()=>null,update:(e,t)=>t.effects.reduce(((e,t)=>t.is(setActiveSearch)?t.value:e),e&&e.map(t.changes))}),searchMatchDeco=CodeMirror.Decoration.mark({class:"cm-searchMatch"}),currentSearchMatchDeco=CodeMirror.Decoration.mark({class:"cm-searchMatch cm-searchMatch-selected"}),searchHighlighter=CodeMirror.ViewPlugin.fromClass(class{decorations;constructor(e){this.decorations=this.computeDecorations(e)}update(e){const t=e.state.field(activeSearchState);(!ActiveSearch.eq(t,e.startState.field(activeSearchState))||t&&(e.viewportChanged||e.docChanged))&&(this.decorations=this.computeDecorations(e.view))}computeDecorations(e){const t=e.state.field(activeSearchState);if(!t)return CodeMirror.Decoration.none;const r=new CodeMirror.RangeSetBuilder,{doc:o}=e.state;for(const{from:i,to:s}of e.visibleRanges){let e=i;for(const n of o.iterLines(o.lineAt(i).number,o.lineAt(s).number+1)){for(t.regexp.lastIndex=0;;){const o=t.regexp.exec(n);if(!o)break;const i=e+o.index,s=i+o[0].length,a=t.currentRange&&t.currentRange.from===i&&t.currentRange.to===s;r.add(i,s,a?currentSearchMatchDeco:searchMatchDeco)}e+=n.length+1}}return r.finish()}},{decorations:e=>e.decorations}),nonBreakableLineMark=new class extends CodeMirror.GutterMarker{elementClass="cm-nonBreakableLine"};export const addNonBreakableLines=CodeMirror.StateEffect.define();const nonBreakableLines=CodeMirror.StateField.define({create:()=>CodeMirror.RangeSet.empty,update:(e,t)=>t.effects.reduce(((e,t)=>t.is(addNonBreakableLines)?e.update({add:t.value.map((e=>nonBreakableLineMark.range(e)))}):e),e.map(t.changes)),provide:e=>CodeMirror.lineNumberMarkers.from(e)});export function isBreakableLine(e,t){const r=e.field(nonBreakableLines);if(!r.size)return!0;let o=!1;return r.between(t.from,t.from,(()=>{o=!0})),!o}function markNonBreakableLines(e){return nonBreakableLines.init((t=>{const r=[];for(const o of e.nonBreakableLineNumbers())o<t.doc.lines&&r.push(nonBreakableLineMark.range(t.doc.line(o+1).from));return CodeMirror.RangeSet.of(r)}))}