export default{cssContent:'/*\n * Copyright (C) 2013 Google Inc. All rights reserved.\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions are\n * met:\n *\n *     * Redistributions of source code must retain the above copyright\n * notice, this list of conditions and the following disclaimer.\n *     * Redistributions in binary form must reproduce the above\n * copyright notice, this list of conditions and the following disclaimer\n * in the documentation and/or other materials provided with the\n * distribution.\n *     * Neither the name of Google Inc. nor the names of its\n * contributors may be used to endorse or promote products derived from\n * this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n.filter-bar {\n  background-color: var(--color-background-elevation-1);\n  flex: none;\n  flex-wrap: wrap;\n  align-items: center;\n  border-bottom: var(--legacy-divider-border);\n}\n\n.filter-text-filter {\n  display: inline-flex;\n  margin-left: 1px;\n  margin-right: 2px;\n  min-width: 40px;\n  max-width: 200px;\n  height: 24px;\n  align-items: center;\n}\n\n.filter-bitset-filter {\n  padding: 2px;\n  display: inline-flex;\n  overflow: hidden;\n  height: 24px;\n  position: relative;\n  margin: 0;\n}\n\n.filter-bitset-filter span {\n  color: var(--color-text-primary);\n  display: inline-block;\n  flex: none;\n  margin: auto 2px;\n  padding: 3px;\n  background: transparent;\n  border-radius: 6px;\n  overflow: hidden;\n  cursor: pointer;\n}\n\n.filter-bitset-filter span:focus-visible {\n  outline: -webkit-focus-ring-color auto 5px;\n}\n\n.filter-bitset-filter-divider {\n  background-color: var(--color-details-hairline);\n  height: 16px;\n  width: 1px;\n  margin: auto 2px;\n  display: inline-block;\n}\n\n.filter-bitset-filter span:hover {\n  background: var(--color-background-elevation-2);\n}\n\n.filter-bitset-filter span.selected,\n.filter-bitset-filter span:active {\n  background: var(--color-background-highlight);\n}\n\n.filter-checkbox-filter {\n  padding-left: 4px;\n  padding-right: 2px;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  display: inline-flex;\n  vertical-align: middle;\n  height: 24px;\n  position: relative;\n}\n\n.filter-checkbox-filter > [is="dt-checkbox"] {\n  display: flex;\n  margin: auto 0;\n}\n\n.filter-input-field {\n  padding-left: 3px;\n  width: 163px;\n  height: 18px;\n  line-height: 20px;\n  display: inline-block;\n  overflow: hidden;\n  white-space: nowrap;\n  cursor: auto;\n}\n\n.filter-input-container {\n  margin: 0 3px;\n  display: flex;\n  background: var(--color-background);\n  width: 163px;\n}\n\n.filter-input-container:hover {\n  box-shadow: var(--legacy-focus-ring-inactive-shadow);\n}\n\n.filter-input-container:focus-within,\n.filter-text-filter:not(.filter-text-empty) .filter-input-container {\n  box-shadow: var(--legacy-focus-ring-active-shadow);\n}\n\n.filter-input-clear-button {\n  opacity: 70%;\n  height: 16px;\n  margin-top: 1px;\n  cursor: pointer;\n}\n\n.filter-cancel-button {\n  display: block;\n}\n\n.filter-text-empty .filter-input-clear-button {\n  display: none;\n}\n\n.filter-input-clear-button:hover {\n  opacity: 99%;\n}\n\n@media (forced-colors: active) {\n  .filter-bitset-filter span:hover,\n  .filter-bitset-filter span.selected,\n  .filter-bitset-filter span:active {\n    forced-color-adjust: none;\n    background: Highlight;\n    color: HighlightText;\n  }\n\n  .filter-input-container {\n    forced-color-adjust: none;\n    background: ButtonFace;\n    box-shadow: var(--legacy-focus-ring-inactive-shadow);\n    color: fieldtext;\n  }\n\n  .filter-input-container:hover,\n  .filter-input-container:focus-within,\n  .filter-text-filter:not(.filter-text-empty) .filter-input-container {\n    box-shadow: var(--legacy-focus-ring-active-shadow);\n  }\n}\n'};