const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n* {\n  box-sizing: border-box;\n  /* This is required for correct sizing of flex items because we rely\n     * on an old version of the flexbox spec. */\n\n  min-width: 0;\n  min-height: 0;\n}\n\n:root {\n  height: 100%;\n  overflow: hidden;\n  /**\n   * NOTE: please don\'t add to these colours!\n   * We are migrating to a new set of theme colors (see below for details) and over time these colors will be deprecated / removed.\n   * Chat to jacktfranklin@ or petermueller@ if you have questions.\n   * https://crbug.com/1122511\n   */\n  --legacy-accent-color: #1a73e8;\n  --legacy-accent-fg-color: #1a73e8;\n  --legacy-accent-color-hover: #3b86e8;\n  --legacy-accent-fg-color-hover: #1567d3;\n  --legacy-active-control-bg-color: #5a5a5a;\n  --legacy-focus-bg-color: hsl(214deg 40% 92%);\n  --legacy-focus-ring-inactive-shadow-color: #e0e0e0;\n  --legacy-input-validation-error: #db1600;\n  --legacy-toolbar-hover-bg-color: #eaeaea;\n  --legacy-selection-fg-color: #fff;\n  --legacy-selection-bg-color: var(--legacy-accent-color);\n  --legacy-selection-inactive-fg-color: #5a5a5a;\n  --legacy-selection-inactive-bg-color: #dadada;\n  --legacy-tab-selected-fg-color: #333;\n  --legacy-divider-border: 1px solid var(--color-details-hairline);\n  --legacy-focus-ring-inactive-shadow: 0 0 0 1px var(--legacy-focus-ring-inactive-shadow-color);\n  --legacy-focus-ring-active-shadow: 0 0 0 1px var(--legacy-accent-color);\n  --legacy-item-selection-bg-color: #cfe8fc;\n  --legacy-item-selection-inactive-bg-color: #e0e0e0;\n  --item-hover-color: rgb(56 121 217 / 10%);\n  --monospace-font-size: 10px;\n  --monospace-font-family: monospace;\n  --source-code-font-size: 11px;\n  --source-code-font-family: monospace;\n  --override-force-white-icons-background: #fafafa;\n}\n\n.-theme-with-dark-background {\n  /**\n   * Inherit the native form control colors when using a dark theme.\n   * Override them using CSS variables if needed.\n   */\n  color-scheme: dark;\n  /**\n   * NOTE: please don\'t add to these colours!\n   * We are migrating to a new set of theme colors (see below for details) and over time these colors will be deprecated / removed.\n   * Chat to jacktfranklin@ or petermueller@ if you have questions.\n   * https://crbug.com/1122511\n   */\n  --legacy-accent-color: #0e639c;\n  --legacy-accent-fg-color: #ccc;\n  --legacy-accent-fg-color-hover: #fff;\n  --legacy-accent-color-hover: rgb(17 119 187);\n  --legacy-active-control-bg-color: #cdcdcd;\n  --legacy-focus-bg-color: hsl(214deg 19% 27%);\n  --legacy-focus-ring-inactive-shadow-color: #5a5a5a;\n  --legacy-toolbar-hover-bg-color: #202020;\n  --legacy-selection-fg-color: #cdcdcd;\n  --legacy-selection-inactive-fg-color: #cdcdcd;\n  --legacy-selection-inactive-bg-color: hsl(0deg 0% 28%);\n  --legacy-tab-selected-fg-color: #eaeaea;\n  --legacy-focus-ring-inactive-shadow: 0 0 0 1px var(--legacy-focus-ring-inactive-shadow-color);\n  --legacy-item-selection-bg-color: hsl(207deg 88% 22%);\n  --legacy-item-selection-inactive-bg-color: #454545;\n}\n\nbody {\n  height: 100%;\n  width: 100%;\n  position: relative;\n  overflow: hidden;\n  margin: 0;\n  cursor: default;\n  font-family: ".SFNSDisplay-Regular", "Helvetica Neue", "Lucida Grande", sans-serif;\n  font-size: 12px;\n  tab-size: 4;\n  user-select: none;\n  color: var(--color-text-primary);\n  background: var(--color-background);\n}\n\n/* Default fonts */\n.platform-linux {\n  font-family: Roboto, Ubuntu, Arial, sans-serif;\n}\n\n.platform-mac {\n  font-family: ".SFNSDisplay-Regular", "Helvetica Neue", "Lucida Grande", sans-serif;\n}\n\n.platform-mac,\n.platform-linux {\n  --override-text-color: rgb(48 57 66);\n\n  color: var(--override-text-color);\n}\n\n.platform-windows {\n  font-family: "Segoe UI", Tahoma, sans-serif;\n}\n\n:focus {\n  outline-width: 0;\n}\n\n/* Monospace font per platform configuration */\n.platform-mac,\n:host-context(.platform-mac) {\n  --monospace-font-size: 11px;\n  --monospace-font-family: menlo, monospace;\n  --source-code-font-size: 11px;\n  --source-code-font-family: menlo, monospace;\n}\n\n.platform-windows,\n:host-context(.platform-windows) {\n  --monospace-font-size: 12px;\n  --monospace-font-family: consolas, lucida console, courier new, monospace;\n  --source-code-font-size: 12px;\n  --source-code-font-family: consolas, lucida console, courier new, monospace;\n}\n\n.platform-linux,\n:host-context(.platform-linux) {\n  --monospace-font-size: 11px;\n  --monospace-font-family: dejavu sans mono, monospace;\n  --source-code-font-size: 11px;\n  --source-code-font-family: dejavu sans mono, monospace;\n}\n\n.-theme-with-dark-background .platform-linux,\n.-theme-with-dark-background .platform-mac,\n:host-context(.-theme-with-dark-background) .platform-linux,\n:host-context(.-theme-with-dark-background) .platform-mac {\n  --override-text-color: rgb(189 198 207);\n}\n\n.monospace {\n  font-family: var(--monospace-font-family);\n  font-size: var(--monospace-font-size) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.source-code {\n  font-family: var(--source-code-font-family);\n  font-size: var(--source-code-font-size) !important; /* stylelint-disable-line declaration-no-important */\n  white-space: pre-wrap;\n}\n\nimg {\n  -webkit-user-drag: none;\n}\n\niframe,\na img {\n  border: none;\n}\n\n.fill {\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n}\n\niframe.fill {\n  width: 100%;\n  height: 100%;\n}\n\n.widget {\n  position: relative;\n  flex: auto;\n  contain: style;\n}\n\n.hbox {\n  display: flex;\n  flex-direction: row !important; /* stylelint-disable-line declaration-no-important */\n  position: relative;\n}\n\n.vbox {\n  display: flex;\n  flex-direction: column !important; /* stylelint-disable-line declaration-no-important */\n  position: relative;\n}\n\n.view-container > .toolbar {\n  border-bottom: 1px solid var(--color-details-hairline);\n}\n\n.flex-auto {\n  flex: auto;\n}\n\n.flex-none {\n  flex: none;\n}\n\n.flex-centered {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n.overflow-auto {\n  overflow: auto;\n  background-color: var(--color-background);\n}\n\niframe.widget {\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  left: 0;\n  right: 0;\n  top: 0;\n  bottom: 0;\n}\n\n.hidden {\n  display: none !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.highlighted-search-result {\n  --override-highlighted-search-result-background-color: rgb(255 255 0 / 80%);\n\n  border-radius: 1px;\n  background-color: var(--override-highlighted-search-result-background-color);\n  outline: 1px solid var(--override-highlighted-search-result-background-color);\n}\n\n.-theme-with-dark-background .highlighted-search-result,\n:host-context(.-theme-with-dark-background) .highlighted-search-result {\n  --override-highlighted-search-result-background-color: hsl(133deg 100% 30%);\n\n  color: #333;\n}\n\n.link {\n  cursor: pointer;\n  text-decoration: underline;\n  color: var(--color-link);\n}\n\nbutton,\ninput,\nselect {\n  /* Form elements do not automatically inherit font style from ancestors. */\n  font-family: inherit;\n  font-size: inherit;\n}\n\nselect option,\nselect optgroup,\ninput {\n  background-color: var(--color-background);\n}\n\ninput {\n  color: inherit;\n}\n\ninput::placeholder {\n  --override-input-placeholder-color: rgb(0 0 0 / 54%);\n\n  color: var(--override-input-placeholder-color);\n}\n\n.-theme-with-dark-background input::placeholder,\n:host-context(.-theme-with-dark-background) input::placeholder {\n  --override-input-placeholder-color: rgb(230 230 230 / 54%);\n}\n\n:host-context(.-theme-with-dark-background) input[type="checkbox"]:not(.-theme-preserve) {\n  accent-color: var(--color-checkbox-accent-color);\n}\n\n.harmony-input:not([type]),\n.harmony-input[type="number"],\n.harmony-input[type="text"] {\n  padding: 3px 6px;\n  height: 24px;\n  border: none;\n  box-shadow: var(--legacy-focus-ring-inactive-shadow);\n}\n\n.harmony-input:not([type]).error-input,\n.harmony-input[type="number"].error-input,\n.harmony-input[type="text"].error-input,\n.harmony-input:not([type]):invalid,\n.harmony-input[type="number"]:invalid,\n.harmony-input[type="text"]:invalid {\n  box-shadow: 0 0 0 1px var(--color-red);\n}\n\n.harmony-input:not([type]):not(.error-input):not(:invalid):hover,\n.harmony-input[type="number"]:not(.error-input):not(:invalid):hover,\n.harmony-input[type="text"]:not(.error-input):not(:invalid):hover {\n  box-shadow: var(--legacy-focus-ring-inactive-shadow);\n}\n\n.harmony-input:not([type]):not(.error-input):not(:invalid):focus,\n.harmony-input[type="number"]:not(.error-input):not(:invalid):focus,\n.harmony-input[type="text"]:not(.error-input):not(:invalid):focus {\n  box-shadow: var(--legacy-focus-ring-active-shadow);\n}\n\n.highlighted-search-result.current-search-result {\n  /* Note: this value is used in light & dark mode */\n  --override-current-search-result-background-color: rgb(255 127 0 / 80%);\n\n  border-radius: 1px;\n  padding: 1px;\n  margin: -1px;\n  background-color: var(--override-current-search-result-background-color);\n}\n\n.dimmed {\n  opacity: 60%;\n}\n\n.editing {\n  box-shadow: var(--drop-shadow);\n  background-color: var(--color-background);\n  text-overflow: clip !important; /* stylelint-disable-line declaration-no-important */\n  padding-left: 2px;\n  margin-left: -2px;\n  padding-right: 2px;\n  margin-right: -2px;\n  margin-bottom: -1px;\n  padding-bottom: 1px;\n  opacity: 100% !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.editing,\n.editing * {\n  color: var(--color-text-primary) !important; /* stylelint-disable-line declaration-no-important */\n  text-decoration: none !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.chrome-select {\n  --override-chrome-select-border-color: rgb(0 0 0 / 20%);\n\n  appearance: none;\n  user-select: none;\n  border: 1px solid var(--override-chrome-select-border-color);\n  border-radius: 2px;\n  color: var(--color-text-primary);\n  font: inherit;\n  margin: 0;\n  outline: none;\n  padding-right: 20px;\n  padding-left: 6px;\n  background-image: var(--image-file-chromeSelect);\n  background-color: var(--color-background-elevation-0);\n  background-position: right center;\n  background-repeat: no-repeat;\n  min-height: 24px;\n  min-width: 80px;\n  background-size: 15px;\n}\n\n.chrome-select:disabled {\n  opacity: 38%;\n}\n\n.-theme-with-dark-background .chrome-select,\n:host-context(.-theme-with-dark-background) .chrome-select {\n  --override-chrome-select-border-color: rgb(230 230 230 / 20%);\n\n  background-image: var(--image-file-chromeSelectDark);\n}\n\n.chrome-select:enabled:active,\n.chrome-select:enabled:focus,\n.chrome-select:enabled:hover {\n  --override-select-box-shadow: 0 0 0 2px var(--color-button-outline-focus);\n\n  background-color: var(--color-background-elevation-1);\n  box-shadow: var(--override-select-box-shadow);\n}\n\n.chrome-select:enabled:active {\n  background-color: var(--color-background-elevation-2);\n}\n\n.chrome-select:enabled:focus {\n  border-color: transparent;\n}\n\n.-theme-with-dark-background .chrome-select:enabled:active,\n.-theme-with-dark-background .chrome-select:enabled:focus,\n.-theme-with-dark-background .chrome-select:enabled:hover,\n:host-context(.-theme-with-dark-background) .chrome-select:enabled:active,\n:host-context(.-theme-with-dark-background) .chrome-select:enabled:focus,\n:host-context(.-theme-with-dark-background) .chrome-select:enabled:hover {\n  --override-select-box-shadow: 0 0 0 2px var(--color-button-outline-focus);\n}\n\n.chrome-select-label {\n  margin: 0 22px;\n  flex: none;\n}\n\n.chrome-select-label p p {\n  margin-top: 0;\n  color: var(--color-text-secondary);\n}\n\n/* This class is used outside of the settings screen in the "Renderer" and\n   "Sensors" panel. As such we need to override their style globally */\n.settings-select {\n  margin: 0;\n}\n\n.chrome-select optgroup,\n.chrome-select option {\n  background-color: var(--color-background-elevation-1);\n  color: var(--color-text-primary);\n}\n\n.gray-info-message {\n  text-align: center;\n  font-style: italic;\n  padding: 6px;\n  color: var(--color-text-secondary);\n  white-space: nowrap;\n}\n\nspan[is="dt-icon-label"] {\n  flex: none;\n}\n\n.full-widget-dimmed-banner a {\n  color: inherit;\n}\n\n.full-widget-dimmed-banner {\n  color: var(--color-text-secondary);\n  background-color: var(--color-background);\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  text-align: center;\n  padding: 20px;\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  font-size: 13px;\n  overflow: auto;\n  z-index: 500;\n}\n\n[is="ui-icon"] {\n  display: inline-block;\n  flex-shrink: 0;\n}\n\n.-theme-with-dark-background [is="ui-icon"].icon-invert,\n:host-context(.-theme-with-dark-background) [is="ui-icon"].icon-invert {\n  filter: invert(80%) hue-rotate(180deg);\n}\n\n[is="ui-icon"].icon-mask {\n  --override-icon-mask-background-color: rgb(110 110 110);\n\n  background-color: var(--override-icon-mask-background-color);\n  -webkit-mask-position: var(--spritesheet-position);\n}\n\n.-theme-with-dark-background [is="ui-icon"].icon-mask,\n:host-context(.-theme-with-dark-background) [is="ui-icon"].icon-mask {\n  --override-icon-mask-background-color: rgb(145 145 145);\n}\n\n[is="ui-icon"]:not(.icon-mask) {\n  background-position: var(--spritesheet-position);\n}\n\n.spritesheet-smallicons:not(.icon-mask) {\n  background-image: var(--image-file-smallIcons);\n}\n\n.spritesheet-smallicons.icon-mask {\n  -webkit-mask-image: var(--image-file-smallIcons);\n}\n\n.spritesheet-largeicons:not(.icon-mask) {\n  background-image: var(--image-file-largeIcons);\n}\n\n.spritesheet-largeicons.icon-mask {\n  -webkit-mask-image: var(--image-file-largeIcons);\n}\n\n.spritesheet-mediumicons:not(.icon-mask) {\n  background-image: var(--image-file-mediumIcons);\n}\n\n.spritesheet-mediumicons.icon-mask {\n  -webkit-mask-image: var(--image-file-mediumIcons);\n}\n\n.spritesheet-arrowicons {\n  background-image: var(--image-file-popoverArrows);\n}\n\n.force-white-icons [is="ui-icon"].spritesheet-smallicons,\n:host-context(.force-white-icons) [is="ui-icon"].spritesheet-smallicons,\n[is="ui-icon"].force-white-icons.spritesheet-smallicons,\n.-theme-preserve {\n  -webkit-mask-image: var(--image-file-smallIcons);\n  -webkit-mask-position: var(--spritesheet-position);\n  background: var(--override-force-white-icons-background) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.force-white-icons [is="ui-icon"].spritesheet-largeicons,\n:host-context(.force-white-icons) [is="ui-icon"].spritesheet-largeicons,\n[is="ui-icon"].force-white-icons.spritesheet-largeicons,\n.-theme-preserve {\n  -webkit-mask-image: var(--image-file-largeIcons);\n  -webkit-mask-position: var(--spritesheet-position);\n  background: var(--override-force-white-icons-background) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.force-white-icons [is="ui-icon"].spritesheet-mediumicons,\n:host-context(.force-white-icons) [is="ui-icon"].spritesheet-mediumicons,\n[is="ui-icon"].force-white-icons.spritesheet-mediumicons,\n.-theme-preserve {\n  -webkit-mask-image: var(--image-file-mediumIcons);\n  -webkit-mask-position: var(--spritesheet-position);\n  background: var(--override-force-white-icons-background) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.expandable-inline-button {\n  background-color: var(--color-background-elevation-2);\n  color: var(--color-text-primary);\n  cursor: pointer;\n  border-radius: 3px;\n}\n\n.undisplayable-text,\n.expandable-inline-button {\n  padding: 1px 3px;\n  margin: 0 2px;\n  font-size: 11px;\n  font-family: sans-serif;\n  white-space: nowrap;\n  display: inline-block;\n}\n\n.undisplayable-text::after,\n.expandable-inline-button::after {\n  content: attr(data-text);\n}\n\n.undisplayable-text {\n  color: var(--color-text-disabled);\n  font-style: italic;\n}\n\n.expandable-inline-button:hover,\n.expandable-inline-button:focus-visible {\n  background-color: var(--color-background-elevation-1);\n}\n\n.expandable-inline-button:focus-visible {\n  background-color: var(--color-background-elevation-1);\n}\n\n::selection {\n  --override-selection-background-color: rgb(141 199 248 / 60%);\n\n  background-color: var(--override-selection-background-color);\n}\n\n.-theme-with-dark-background *::selection,\n:host-context(.-theme-with-dark-background) *::selection {\n  background-color: rgb(93 93 93 / 60%);\n}\n\n.reload-warning {\n  align-self: center;\n  margin-left: 10px;\n}\n\nbutton.link {\n  border: none;\n  background: none;\n  padding: 3px;\n}\n\nbutton.link:focus-visible {\n  --override-link-focus-background-color: rgb(0 0 0 / 8%);\n\n  background-color: var(--override-link-focus-background-color);\n  border-radius: 2px;\n}\n\n.-theme-with-dark-background button.link:focus-visible,\n:host-context(.-theme-with-dark-background) button.link:focus-visible {\n  --override-link-focus-background-color: rgb(230 230 230 / 8%);\n}\n\n/* See ARIAUtils.js */\n[data-aria-utils-animation-hack] {\n  animation: ANIMATION-HACK 0s;\n}\n\n@keyframes ANIMATION-HACK {\n  /* empty keyframe to trigger the animation hack above */\n}\n\n@media (forced-colors: active) {\n  .dimmed,\n  .chrome-select:disabled {\n    opacity: 100%;\n  }\n\n  [is="ui-icon"].icon-mask,\n  .force-white-icons [is="ui-icon"].spritesheet-smallicons,\n  :host-context(.force-white-icons) [is="ui-icon"].spritesheet-smallicons,\n  [is="ui-icon"].force-white-icons.spritesheet-smallicons,\n  .force-white-icons [is="ui-icon"].spritesheet-largeicons,\n  :host-context(.force-white-icons) [is="ui-icon"].spritesheet-largeicons,\n  [is="ui-icon"].force-white-icons.spritesheet-largeicons,\n  .force-white-icons [is="ui-icon"].spritesheet-mediumicons,\n  :host-context(.force-white-icons) [is="ui-icon"].spritesheet-mediumicons,\n  [is="ui-icon"].force-white-icons.spritesheet-mediumicons,\n  .-theme-preserve {\n    forced-color-adjust: none;\n    background-color: ButtonText;\n  }\n\n  .harmony-input:not([type]),\n  .harmony-input[type="number"],\n  .harmony-input[type="text"] {\n    border: 1px solid ButtonText;\n  }\n\n  .harmony-input:not([type]):focus,\n  .harmony-input[type="number"]:focus,\n  .harmony-input[type="text"]:focus {\n    border: 1px solid Highlight;\n  }\n}\n/* search input with customized styling */\ninput.custom-search-input::-webkit-search-cancel-button {\n  appearance: none;\n  cursor: pointer;\n  width: 16px;\n  height: 15px;\n  margin-right: 0;\n  background-position: -32px 32px;\n  background-image: var(--image-file-mediumIcons);\n}\n/* loading spinner */\n.spinner::before {\n  display: block;\n  width: var(--dimension, 24px);\n  height: var(--dimension, 24px);\n  border: var(--override-spinner-size, 3px) solid var(--override-spinner-color, var(--color-text-secondary));\n  border-radius: 12px;\n  clip: rect(0, var(--clip-size, 15px), var(--clip-size, 15px), 0);\n  content: "";\n  position: absolute;\n  animation: spinner-animation 1s linear infinite;\n  box-sizing: border-box;\n}\n\n@keyframes spinner-animation {\n  from { transform: rotate(0); }\n  to { transform: rotate(360deg); }\n}\n/** Adorner */\n.adorner-container {\n  display: inline-block;\n}\n\n.adorner-container.hidden {\n  display: none;\n}\n\n.adorner-container devtools-adorner {\n  margin-left: 3px;\n}\n\n:host-context(.-theme-with-dark-background) devtools-adorner {\n  --override-adorner-background-color: rgb(var(--color-syntax-2-rgb) / 15%);\n  --override-adorner-border-color: rgb(var(--color-syntax-2-rgb) / 50%);\n  --override-adorner-focus-border-color: var(--color-syntax-2);\n  --override-adorner-active-background-color: var(--color-syntax-8);\n}\n\n/* General panel styles */\n.panel {\n  display: flex;\n  overflow: hidden;\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  z-index: 0;\n  background-color: var(--color-background);\n}\n\n.panel-sidebar {\n  overflow-x: hidden;\n  background-color: var(--color-background-elevation-1);\n}\n\niframe.extension {\n  flex: auto;\n  width: 100%;\n  height: 100%;\n}\n\niframe.panel.extension {\n  display: block;\n  height: 100%;\n}\n\n@media (forced-colors: active) {\n  :root {\n    --legacy-accent-color: Highlight;\n    --legacy-focus-ring-inactive-shadow-color: ButtonText;\n  }\n}\n\n/*# sourceURL=inspectorCommon.css */\n');export default styles;