export default{cssContent:"/*\n * Copyright 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.list {\n  flex: auto 0 1;\n  overflow-y: auto;\n  border: 1px solid var(--color-details-hairline);\n  flex-direction: column;\n\n  --override-background-list-item-color: hsl(0deg 0% 96%);\n}\n\n.-theme-with-dark-background .list,\n:host-context(.-theme-with-dark-background) .list {\n  --override-background-list-item-color: hsl(0deg 0% 16%);\n}\n\n.list-separator {\n  background: var(--color-background-elevation-1);\n  height: 1px;\n}\n\n.list-item {\n  flex: none;\n  min-height: 30px;\n  display: flex;\n  align-items: center;\n  position: relative;\n  overflow: hidden;\n}\n\n.list-item:focus-within,\n.list-item:hover {\n  background: var(--override-background-list-item-color);\n}\n\n.list-widget-input-validation-error {\n  color: var(--legacy-input-validation-error);\n  margin: 0 5px;\n}\n\n.controls-container {\n  display: flex;\n  flex-direction: row;\n  justify-content: flex-end;\n  align-items: stretch;\n  pointer-events: none;\n}\n\n.controls-gradient {\n  flex: 0 1 50px;\n}\n\n.list-item:focus-within .controls-gradient,\n.list-item:hover .controls-gradient {\n  background-image: linear-gradient(90deg, transparent, var(--override-background-list-item-color));\n}\n\n.controls-buttons {\n  flex: none;\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  pointer-events: auto;\n  visibility: hidden;\n}\n\n.list-item:focus-within .controls-buttons,\n.list-item:hover .controls-buttons {\n  background-color: var(--override-background-list-item-color);\n  visibility: visible;\n}\n\n.editor-container {\n  display: flex;\n  flex-direction: column;\n  align-items: stretch;\n  flex: none;\n  background: var(--color-background-elevation-2);\n  overflow: hidden;\n}\n\n.editor-content {\n  flex: auto;\n  display: flex;\n  flex-direction: column;\n  align-items: stretch;\n}\n\n.editor-buttons {\n  flex: none;\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  justify-content: flex-start;\n  padding: 5px;\n}\n\n.editor-buttons > button {\n  flex: none;\n  margin-right: 10px;\n}\n\n.editor-content input {\n  margin-right: 10px;\n}\n\n.editor-content input.error-input {\n  background-color: var(--color-background);\n}\n\n.text-prompt-container {\n  padding: 3px 6px;\n  height: 24px;\n  border: none;\n  box-shadow: var(--legacy-focus-ring-inactive-shadow);\n  border-radius: 2px;\n  width: 100%;\n  background-color: var(--color-background);\n}\n\n.text-prompt-container:focus {\n  box-shadow: var(--legacy-focus-ring-active-shadow);\n}\n\n.text-prompt-container .text-prompt {\n  width: 100%;\n}\n\n@media (forced-colors: active) {\n  .list-item:focus-within .controls-buttons,\n  .list-item:hover .controls-buttons {\n    background-color: canvas;\n  }\n\n  .list-item:focus-within,\n  .list-item:hover {\n    forced-color-adjust: none;\n    background: Highlight;\n  }\n\n  .list-item:focus-within *,\n  .list-item:hover * {\n    color: HighlightText;\n  }\n\n  .list-item:focus-within .controls-gradient,\n  .list-item:hover .controls-gradient {\n    background-image: unset;\n  }\n}\n"};