export default{cssContent:"/*\n * Copyright (c) 2014 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.soft-context-menu {\n  --override-context-menu-seperator-color: var(--color-details-hairline);\n  --override-context-menu-hover-text-color: rgb(255 255 255);\n\n  overflow-y: auto;\n  min-width: 160px !important; /* stylelint-disable-line declaration-no-important */\n  /* NOTE: Keep padding in sync with padding adjustment in SoftContextMenu.js */\n  padding: 4px 0;\n  border: 1px solid var(--color-details-hairline);\n  background-color: var(--color-background);\n  box-shadow: var(--drop-shadow);\n}\n\n:host-context(.-theme-with-dark-background) .soft-context-menu {\n  border: none;\n}\n\n:host:host-context(.platform-mac):host-context(html:not(.-theme-with-dark-background)) .soft-context-menu {\n  --override-mac-specific-border-color: rgb(196 196 196 / 90%);\n  --override-mac-specific-border-top-color: rgb(196 196 196 / 50%);\n  --override-mac-specific-background-color: rgb(240 240 240);\n  --override-mac-specific-box-shadow: 0 5px 10px rgb(0 0 0 25%);\n  --override-context-menu-seperator-color: rgb(222 222 222);\n\n  border: 1px solid var(--override-mac-specific-border-color);\n  border-top: 1px solid var(--override-mac-specific-border-top-color);\n  border-radius: 4px;\n  background-color: var(--override-mac-specific-background-color);\n  box-shadow: var(--override-mac-specific-box-shadow);\n}\n\n.soft-context-menu-item {\n  display: flex;\n  width: 100%;\n  font-size: 12px;\n  padding: 3px 7px 3px 8px;\n  margin: 0 13px 0 0;\n  white-space: nowrap;\n  align-items: center;\n}\n\n.soft-context-menu-item devtools-icon {\n  --icon-color: var(--color-text-secondary);\n\n  pointer-events: none;\n}\n\n.soft-context-menu-disabled {\n  color: var(--color-text-disabled);\n  pointer-events: none;\n}\n\n.soft-context-menu-separator {\n  height: 10px;\n  margin: 0 1px;\n}\n\n.soft-context-menu-separator > .separator-line {\n  margin: 0;\n  height: 5px;\n  border-bottom: 1px solid var(--override-context-menu-seperator-color);\n  pointer-events: none;\n}\n\n.soft-context-menu-item-mouse-over {\n  background-color: var(--color-primary);\n  color: var(--override-context-menu-hover-text-color);\n}\n\n.soft-context-menu-item-mouse-over devtools-icon {\n  --icon-color: var(--override-context-menu-hover-text-color);\n}\n\n.-theme-with-dark-background .soft-context-menu-item-mouse-over,\n:host-context(.-theme-with-dark-background) .soft-context-menu-item-mouse-over {\n  --override-dark-mode-focus-color: #1a73e8;\n\n  background-color: var(--override-dark-mode-focus-color);\n}\n\n:host:host-context(.platform-mac):host-context(html:not(.-theme-with-dark-background)) .soft-context-menu-item-mouse-over {\n  --override-mac-specific-dark-background: linear-gradient(to right, hsl(214deg 81% 60%), hsl(214deg 100% 56%));\n\n  background-image: var(--override-mac-specific-dark-background);\n}\n\n:host:host-context(.platform-mac):host-context(html:not(.-theme-with-dark-background)) .separator-line {\n  border-width: 2px;\n}\n\n.soft-context-menu-item-submenu-arrow {\n  pointer-events: none;\n  font-size: 11px;\n  text-align: right;\n  align-self: center;\n  margin-left: auto;\n}\n\n.soft-context-menu-item-mouse-over .soft-context-menu-item-checkmark {\n  color: var(--legacy-selection-fg-color);\n}\n\n.soft-context-menu-custom-item {\n  display: inline-flex;\n  justify-content: center;\n  align-items: center;\n  flex: auto;\n}\n\n.soft-context-menu-shortcut {\n  color: var(--color-text-secondary);\n  pointer-events: none;\n  flex: 1 1 auto;\n  text-align: right;\n  padding-left: 10px;\n}\n\n.soft-context-menu-item-mouse-over .soft-context-menu-shortcut {\n  color: inherit;\n}\n\n.checkmark {\n  opacity: 70%;\n  pointer-events: none;\n  margin: auto 5px auto 0;\n}\n\n.soft-context-menu-item-mouse-over .checkmark {\n  opacity: 100%;\n  filter: none;\n}\n\n:host-context(.-theme-with-dark-background) .checkmark {\n  filter: invert(80%);\n}\n\n@media (forced-colors: active) {\n  .soft-context-menu-item {\n    color: canvastext;\n  }\n\n  .soft-context-menu-item-mouse-over {\n    background-color: Highlight;\n    color: HighlightText;\n    forced-color-adjust: none;\n  }\n\n  .soft-context-menu-shortcut {\n    color: ButtonText;\n  }\n\n  .soft-context-menu-item-mouse-over .soft-context-menu-shortcut {\n    color: HighlightText;\n  }\n\n  .soft-context-menu:focus-visible {\n    forced-color-adjust: none;\n    background: canvas;\n    border-color: Highlight;\n  }\n\n  .soft-context-menu-separator > .separator-line {\n    border-bottom-color: ButtonText;\n  }\n\n  .checkmark {\n    opacity: 100%;\n  }\n\n  .spritesheet-smallicons:not(.icon-mask) {\n    filter: invert(100%);\n  }\n\n  .soft-context-menu-item-mouse-over .spritesheet-smallicons:not(.icon-mask) {\n    filter: invert(0);\n  }\n}\n"};