export default{cssContent:'/*\n * Copyright (C) 2011 Google Inc. All rights reserved.\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions are\n * met:\n *\n *     * Redistributions of source code must retain the above copyright\n * notice, this list of conditions and the following disclaimer.\n *     * Redistributions in binary form must reproduce the above\n * copyright notice, this list of conditions and the following disclaimer\n * in the documentation and/or other materials provided with the\n * distribution.\n *     * Neither the name of Google Inc. nor the names of its\n * contributors may be used to endorse or promote products derived from\n * this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n:host {\n  display: flex;\n  flex: auto;\n}\n\n.suggest-box {\n  flex: auto;\n  background-color: var(--color-background);\n  pointer-events: auto;\n  margin-left: -3px;\n  box-shadow: var(--drop-shadow);\n  overflow-x: hidden;\n}\n\n.suggest-box-content-item {\n  padding: 1px 0 1px 1px;\n  margin: 0;\n  border: 1px solid transparent;\n  white-space: nowrap;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n}\n\n.suggest-box-content-item.secondary {\n  background-color: var(--color-background-elevation-1);\n  justify-content: normal;\n}\n\n.suggestion-title {\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n.suggestion-title span {\n  white-space: pre;\n}\n\n.suggestion-subtitle {\n  flex: auto;\n  text-align: right;\n  color: var(--color-text-secondary);\n  margin-right: 3px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n.suggestion-icon {\n  user-select: none;\n  align-self: center;\n  flex-shrink: 0;\n}\n\n.suggest-box-content-item devtools-icon {\n  --icon-color: #000;\n\n  margin-right: 1px;\n}\n\n.suggest-box-content-item .query {\n  font-weight: bold;\n}\n\n.suggest-box-content-item .spacer {\n  display: inline-block;\n  width: 20px;\n}\n\n.suggest-box-content-item.selected {\n  background-color: var(--legacy-selection-bg-color);\n}\n\n.suggest-box-content-item.selected devtools-icon {\n  --icon-color: #fff;\n}\n\n.suggest-box-content-item.selected > span {\n  color: var(--legacy-selection-fg-color);\n}\n\n.suggest-box-content-item:hover:not(.selected) {\n  background-color: var(--item-hover-color);\n}\n\n:host-context(.-theme-with-dark-background) .suggest-box-content-item devtools-icon {\n  --icon-color: #fff;\n}\n\n:host-context(.-theme-with-dark-background) .suggest-box-content-item.selected devtools-icon {\n  --icon-color: #fff;\n}\n\n@media (forced-colors: active) {\n  .suggest-box-content-item.selected {\n    forced-color-adjust: none;\n    background-color: Highlight;\n  }\n\n  .suggest-box-content-item.selected > span {\n    color: HighlightText;\n  }\n}\n'};