export default{cssContent:'/*\n * Copyright 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n:host {\n  flex: 1 1 auto;\n  padding: 2px 0 0;\n}\n\n.tree-outline-disclosure:not(.tree-outline-disclosure-hide-overflow) {\n  min-width: 100%;\n  display: inline-block;\n}\n\n.tree-outline {\n  padding: 0 0 4px 4px;\n  margin: 0;\n  z-index: 0;\n  position: relative;\n}\n\n.tree-outline:focus-visible {\n  box-shadow: 0 0 0 2px var(--legacy-accent-color) inset;\n}\n\n.tree-outline li .selection {\n  display: none;\n  z-index: -1;\n  margin-left: -10000px;\n}\n\n.tree-outline:not(.hide-selection-when-blurred) li.selected {\n  color: var(--legacy-selection-inactive-fg-color);\n}\n\n.tree-outline:not(.hide-selection-when-blurred) li.selected .selection {\n  display: block;\n  background-color: var(--legacy-selection-inactive-bg-color);\n}\n\n.tree-outline:not(.hide-selection-when-blurred) li.elements-drag-over .selection {\n  display: block;\n  margin-top: -2px;\n  border-top: 2px solid;\n  border-top-color: var(--legacy-selection-bg-color);\n}\n\n.tree-outline:not(.hide-selection-when-blurred) li.hovered:not(.selected) .selection {\n  display: block;\n  left: 3px;\n  right: 3px;\n  background-color: var(--item-hover-color);\n  border-radius: 5px;\n}\n\n.tree-outline:not(.hide-selection-when-blurred) li.in-clipboard .highlight {\n  outline: 1px dotted var(--color-background-highlight);\n}\n\nol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus .selection {\n  background-color: var(--legacy-selection-bg-color);\n}\n\nol.tree-outline:not(.hide-selection-when-blurred) li.parent.selected:focus::before {\n  background-color: var(--legacy-selection-fg-color);\n}\n\nol.tree-outline,\n.tree-outline ol {\n  list-style-type: none;\n}\n\n.tree-outline ol {\n  padding-left: 12px;\n}\n\n.tree-outline li {\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  position: relative;\n  display: flex;\n  align-items: center;\n  min-height: 16px;\n}\n\nol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus {\n  color: var(--legacy-selection-fg-color);\n}\n\nol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus * {\n  color: inherit;\n}\n\n.tree-outline li .icons-container {\n  align-self: center;\n  display: flex;\n  align-items: center;\n}\n\n.tree-outline li .leading-icons {\n  margin-right: 4px;\n}\n\n.tree-outline li .trailing-icons {\n  margin-left: 4px;\n}\n\n.tree-outline li::before {\n  user-select: none;\n  -webkit-mask-image: var(--image-file-treeoutlineTriangles);\n  -webkit-mask-size: 32px 24px;\n  -webkit-mask-position: 0 0;\n  background-color: var(--color-text-secondary);\n  content: "\\A0\\A0";\n  text-shadow: none;\n  margin-right: -2px;\n  height: 12px;\n  width: 13px;\n}\n\n.tree-outline li:not(.parent)::before {\n  background-color: transparent;\n}\n\n.tree-outline li.parent.expanded::before {\n  -webkit-mask-position: -16px 0;\n}\n\n.tree-outline ol.children {\n  display: none;\n}\n\n.tree-outline ol.children.expanded {\n  display: block;\n}\n\n.tree-outline.tree-outline-dense li {\n  margin-top: 1px;\n  min-height: 12px;\n}\n\n.tree-outline.tree-outline-dense li.parent {\n  margin-top: 0;\n}\n\n.tree-outline.tree-outline-dense li.parent::before {\n  top: 0;\n}\n\n.tree-outline.tree-outline-dense ol {\n  padding-left: 10px;\n}\n\n.tree-outline.hide-selection-when-blurred .selected:focus-visible {\n  background: var(--legacy-focus-bg-color);\n  border-radius: 2px;\n}\n\n.tree-outline-disclosure:not(.tree-outline-disclosure-hide-overflow) .tree-outline.hide-selection-when-blurred .selected:focus-visible {\n  width: fit-content;\n  padding-right: 3px;\n}\n\n@media (forced-colors: active) {\n  .tree-outline-disclosure li.parent::before,\n  .tree-outline:not(.hide-selection-when-blurred) li.parent:not(.selected)::before,\n  .tree-outline li [is="ui-icon"].icon-mask {\n    forced-color-adjust: none;\n    background-color: ButtonText;\n  }\n\n  .tree-outline-disclosure li.parent:hover:not(.selected)::before,\n  .tree-outline:not(.hide-selection-when-blurred) li.parent:hover:not(.selected)::before {\n    background-color: ButtonText;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) li.selected .selection {\n    forced-color-adjust: none;\n    background-color: ButtonText;\n  }\n\n  ol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus .selection,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible {\n    forced-color-adjust: none;\n    background-color: Highlight;\n  }\n\n  ol.tree-outline:not(.hide-selection-when-blurred) li.parent.selected::before,\n  ol.tree-outline:not(.hide-selection-when-blurred) li.parent.selected:focus::before,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible::before {\n    background-color: HighlightText;\n  }\n\n  .tree-outline li:not(.parent)::before,\n  .tree-outline li:not(.parent):hover::before,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible:not(.parent)::before {\n    forced-color-adjust: none;\n    background-color: transparent;\n  }\n\n  .tree-outline li.selected [is="ui-icon"].icon-mask,\n  .tree-outline li.selected:focus [is="ui-icon"]:not(.icon-mask) {\n    background-color: HighlightText !important; /* stylelint-disable-line declaration-no-important */\n  }\n\n  ol.tree-outline:not(.hide-selection-when-blurred) li.selected,\n  .tree-outline:not(.hide-selection-when-blurred) li.selected .tree-element-title,\n  .tree-outline:not(.hide-selection-when-blurred) li.selected:focus,\n  .tree-outline:not(.hide-selection-when-blurred) li:focus-visible .tree-element-title,\n  .tree-outline:not(.hide-selection-when-blurred) li.selected:focus .tree-element-title,\n  .tree-outline:not(.hide-selection-when-blurred) li.selected span,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible span {\n    forced-color-adjust: none;\n    color: HighlightText;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) li.selected:focus-visible devtools-adorner,\n  .tree-outline.hide-selection-when-blurred li.selected:focus-visible devtools-adorner {\n    --override-adorner-background-color: Highlight;\n    --override-adorner-border-color: HighlightText;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) devtools-icon,\n  .tree-outline.hide-selection-when-blurred devtools-icon {\n    --icon-color: ButtonText;\n  }\n\n  .tree-outline:not(.hide-selection-when-blurred) .selected devtools-icon,\n  .tree-outline.hide-selection-when-blurred .selected:focus-visible devtools-icon {\n    --icon-color: HighlightText;\n  }\n}\n'};